/**
 * @file
 * @author jinguangguo
 * @date 11/07/2020 2:08 PM
 */

var picsMap = {};   // 缓存

var FRAGMENT_MOMENT = {
    filters: {
        fixed2: function (value) {
            var v = value || 0;
            return Number(v).toFixed(2);
        },
        formatTime: function (value) {
            return moment.utc(value).local().format('YYYY-MM-DD HH:mm');
            // console.log("lan is: " + lan);
            // 按照系统语言切换显示的时间语言
            if (lan === 'zh') {
                moment.locale('zh-cn');
            } else if (lan === 'es') {
                moment.locale('es');
            }
            var today = moment();
            var time = moment.utc(value).local().format('YYYY-MM-DD HH:mm');
            var time2 = moment.utc(value).local().format('M-D');
            var diff = today.diff(time, 'days');
            // console.log("diff is: " + diff);
            var result;
            if (diff === 0) {
                return moment(time).fromNow();
            } else {
                return time2;
            }
            return time;

        },
        // formatTimeNew: function (value) {
        //     moment().calendar(null, {
        //       sameDay: function (now) {
        //         if (this.isBefore(now)) {
        //           return '[Will Happen Today]';
        //         } else {
        //           return '[Happened Today]';
        //         }
        //         /* ... */
        //       }
        //     });
        // },
        formatDuration: function (value) {
            if (value) {
                var arrs = value.split(':');
                if (arrs[0] === '00') {
                    arrs = arrs.slice(1);
                }
                return arrs.join(':');
            } else {
                return value;
            }
        },
        filterContent: function (value) {
            if (value && value.length > 40) {
                return value.slice(0, 40) + '...';
            } else {
                return value
            }
        },
        getDistance: function (info) {
            var lng1 = localStorage.getItem('lon');
            var lat1 = localStorage.getItem('lat');
            if(!lng1){
                return
            }
            var lat2 = info.latitude;
            var lng2 = info.longitude;

            var radLat1 = lat1 * Math.PI / 180.0;
            var radLat2 = lat2 * Math.PI / 180.0;
            var a = radLat1 - radLat2;
            var b = lng1 * Math.PI / 180.0 - lng2 * Math.PI / 180.0;
            var s = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(a / 2), 2) + Math.cos(radLat1) * Math.cos(radLat2) * Math.pow(Math.sin(b / 2), 2)));
            s = s * 6378.137;
            s = Math.round(s * 10000) / 10000;
            // console.log(s);
            var duration;
            if(s > 1){
                duration = Math.round(s) + " " + MSG.general.kMeters;
            }else if(s < 1 && s > 0.1){
                duration = MSG.general.whitKMeters1;
            }else if(s < 0.1){
                duration = MSG.general.meters100;
            }
            return duration
        }

    },
    data: function () {
        var token = api.getPrefs({
            sync: true,
            key: 'accessToken'
        });
        var winWidth = api.winWidth;
        var w66 = winWidth * 2 / 3;
        return {
            token: token,
            bottomLoading: false,
            imageShow: false,
            repostContent: '',
            scrollTop: 0,
            isScrolling: false,  // 判断当前页面是否是在滚动中
            picStyle: {
                minWidth: w66,
                minHeight: getPhoneLoadingHeight(),
                maxHeight: winWidth
            },
            currentMoment: {    // 当前操作的瞬间
                index: null,
                detail: null,
            },
            tweebaaId: localStorage.getItem('tweebaaId'),
            feedType: localStorage.getItem('feedType') || 'auto'    // full, auto 图片显示模式
        }
    },
    mounted: function () {
        this._initDom();
    },
    methods: {
        _initDom: function () {
            var that = this;

            //写入字体大小
            var fontSize = localStorage.getItem('chatFontSize');
            if (fontSize) {
                var style = '<style> .moment-content, .translation-text\{font-size: ' + getRightPxFromFontSize(fontSize) + 'px !important; line-height: 1.3 !important;\}</style>';
                $('head').append(style);
            }

            // 解决页面滚动过程中，突然停住不小心打开图片
            var t1 = 0;
            var t2 = 0;
            var timer = null; // 定时器

            // scroll监听
            $(document).scroll(function () {
                that.isScrolling = true;
                clearTimeout(timer);
                timer = setTimeout(isScrollEnd, 500);
                t1 = document.documentElement.scrollTop || document.body.scrollTop;
            });

            function isScrollEnd() {
                t2 = document.documentElement.scrollTop || document.body.scrollTop;
                // console.log('t2 ===== ' + t2);
                if (t2 === t1) {
                    // console.log('滚动结束了');
                    that.isScrolling = false;
                }
            }
        },
        _initSwipper: function () {
            setTimeout(function () {
                var $containers = $('.swiper-container');
                $containers.each(function () {
                    var $this = $(this);
                    if (!$this.data('hasRender')) {
                        var pageElem = $this.find('.swiper-pagination')[0];
                        new Swiper(this, {
                            direction: 'horizontal',
                            loop: false,
                            initialSlide: 0,
                            pagination: {
                                el: pageElem
                            },
                            lazy: {
                                loadPrevNext: true,
                            }
                        });
                        $this.data('hasRender', true);
                    }
                });
            });
        },
        _imgLoad: function (url, callback, moment) {
            var that = this;
            var img = new Image();
            img.src = url;
            if (img.complete) {
                // console.log('complete url: ' + url);
                callback(img.width, img.height);
                picsMap[url] = {
                    width: img.width,
                    height: img.height
                };
            } else {
                img.onload = function () {
                    // console.warn('onload url: ' + url);
                    callback(img.width, img.height);
                    picsMap[url] = {
                        width: img.width,
                        height: img.height
                    };
                    img.onload = null;
                };
            }
        },

        _setMomentOfPic: function (pic, moment) {
            var that = this;
            var path = pic.mediaFileUrl || pic.D;
            var picObj = picsMap[path];
            if (picObj) {
                picCallback(picObj.width, picObj.height);
            } else {
                this._imgLoad(path, function (width, height) {
                    picCallback(width, height);
                });
            }

            function picCallback(w, h) {
                var radio = w / h;
                moment.picRadio = radio;
                if (radio >= PIC_SCALE.MUCH_LONG.radio) {
                    moment.picClazz = PIC_SCALE.MUCH_LONG.clazz;
                } else if (1 < radio && radio <= PIC_SCALE.MUCH_LONG.radio) {
                    moment.picClazz = PIC_SCALE.SO_LONG.clazz;
                } else if (radio === 1) {
                    moment.picClazz = PIC_SCALE.NORMAL.clazz;
                } else if (PIC_SCALE.MUCH_HIGH.radio <= radio && radio < 1) {
                    moment.picClazz = PIC_SCALE.SO_HIGH.clazz;
                } else if (radio < PIC_SCALE.MUCH_HIGH.radio) {
                    moment.picClazz = PIC_SCALE.MUCH_HIGH.clazz;
                }
            }
        },
        _setMomentOfVideo: function (video, moment) {
            var path = video.thumbnailUrl;
            var picObj = picsMap[path];
            if (picObj) {
                videoCallback(picObj.width, picObj.height);
            } else {
                this._imgLoad(path, function (width, height) {
                    videoCallback(width, height);
                }, moment);
            }

            function videoCallback(w, h) {
                var radio = w / h;
                if (radio >= VIDEO_SCALE.MUCH_LONG.radio) {
                    moment.videoClazz = VIDEO_SCALE.MUCH_LONG.clazz;
                } else {
                    moment.videoClazz = VIDEO_SCALE.NORMAL.clazz;
                }
            }
        },
        _initMomentsData: function (list) {
            var item;
            // if (this.page === 'tycoonplaceEdit') {
            //     console.log(JSON.stringify(list));
            // }
            // console.log('this.page: ' + this.page);
            if (list.length > 0) {
                for (var i = 0, len = list.length; i < len; i++) {

                    item = list[i];
                    // item.owner = {};
                    item.store = '';
                    item.picClazz = '';
                    item.videoClazz = '';
                    item.picRadio = '';

                    if (this.page === 'momentDetail') {
                        item.content = this.formatLink(item.content);
                    }

                    if (item.pictures.length === 1) {
                        this._setMomentOfPic(item.pictures[0], item);
                    }
                    if (item.videos.length > 0) {
                        this._setMomentOfVideo(item.videos[0], item);
                    }
                    if (item.rePost) {
                        var originPost = item.rePost;
                        if (originPost.pictures.length === 1) {
                            this._setMomentOfPic(originPost.pictures[0], originPost);
                        }
                        if (originPost.videos.length > 0) {
                            this._setMomentOfVideo(originPost.videos[0], originPost);
                        }
                    }
                }
            }
        },
        switchFeedType: function (type) {
            var that = this;
            this.feedType = type;
            localStorage.setItem('feedType', type);

            if (type === 'full') {
                setTimeout(function () {
                    that._initSwipper();
                });
            }
        },
        showID: function () {
            var random = api.loadSecureValue({
                sync: true,
                key: 'random'
            });
            return (localStorage.getItem('userId') * random).toString(32);
        },
        showImages: function ($event, Index, moment, repost) {
            var that = this;
            // console.log('Open Image ...');
            if (this.isScrolling === true) {
                // console.log('!mage will not open !');
                return;
            }
            this.imageShow = true;

            var picUrls = [];
            if (repost) {
                for (var i = 0, len = moment.rePost.pictures.length; i < len; i++) {
                    picUrls.push(moment.rePost.pictures[i].mediaFileUrl);
                }
            } else {
                for (var i = 0, len = moment.pictures.length; i < len; i++) {
                    picUrls.push(moment.pictures[i].mediaFileUrl);
                }
            }

            var UIPhotoViewer = api.require('UIPhotoViewer');
            UIPhotoViewer.open({
                images: picUrls,
                placeholderImg: 'widget://image/lost_images.jpg',
                bgColor: '#000',
                activeIndex: Index,
                zoomEnabled: true,
                gestureClose: true
            }, function (Ret, err) {
                if (Ret.eventType === 'click') {
                    UIPhotoViewer.close();
                    that.imageShow = false;
                } else if (Ret.eventType === 'longPress') {
                    // 如果用户未登录
                    if (!that.token) {
                        api.toast({
                            msg: MSG.general.reLogin,
                            duration: 2000,
                            location: 'middle'
                        });
                        setTimeout(function () {
                            openLogin();
                        }, 2000);
                        return;
                    }
                    actionSheet([
                        {
                            text: MSG.general.save,
                            callback: function () {
                                api.download({
                                    url: picUrls[Ret.index],
                                    report: true,
                                    cache: true,
                                    allowResume: true
                                }, function (ret, err) {
                                    if (ret.state === 1) {
                                        var Url = ret.savePath;
                                        var BASE_WIN_WIDTH = 540;
                                        var IMAGE_WIDTH = 137;
                                        var IMAGE_HEIGHT = 30;
                                        var ONE_TEXT_WIDTH = 10;
                                        var PADDING_BOTTOM = 20;
                                        var WATER_TEXT = MSG.profile.myID + (lan === 'zh' ? '：' : ': ') + that.tweebaaId;

                                        var textLenPx = jmz(WATER_TEXT) * ONE_TEXT_WIDTH + (api.systemType === 'ios' ? 20 : 20);

                                        var pictureWatermark = api.require('pictureWatermark');
                                        pictureWatermark.clearCache();
                                        pictureWatermark.getPictureSize({
                                            path: Url
                                        }, function (ret, err) {
                                            if (ret) {
                                                console.log('图片尺寸：' + JSON.stringify(ret));

                                                // 计算系数
                                                var c = ret.w / BASE_WIN_WIDTH;
                                                console.log('计算系数：' + c);

                                                var imgRect = {
                                                    x: ret.w - getActualPx(PADDING_BOTTOM + IMAGE_WIDTH - 4),
                                                    // y: ret.h - getActualPx(40),
                                                    y: ret.h - getActualPx(72),
                                                    w: getActualPx(IMAGE_WIDTH),
                                                    h: getActualPx(IMAGE_HEIGHT)
                                                };
                                                console.log('图片矩阵：' + JSON.stringify(imgRect));

                                                pictureWatermark.mark({
                                                    watermark: {
                                                        rect: imgRect,
                                                        image: 'widget://image//logo-white-new.png',
                                                        textAttribute: {
                                                            point: {
                                                                x: ret.w - getActualPx(textLenPx + PADDING_BOTTOM),
                                                                y: ret.h - getActualPx(PADDING_BOTTOM + 20),
                                                                // y: ret.h,
                                                            },
                                                            textSize: getActualPx(20),
                                                            textColor: '#fff'
                                                        },
                                                        text: WATER_TEXT
                                                    },
                                                }, function (ret, err) {
                                                    if (ret.status) {
                                                        api.saveMediaToAlbum({
                                                            path: ret.path,
                                                            groupName: "Tweebaa"
                                                        }, function (ret, err) {
                                                            if (ret && ret.status) {
                                                                alert(MSG.tips.saved);
                                                            }
                                                        });
                                                    }
                                                });

                                                function getActualPx(w) {
                                                    if (c > 1) {
                                                        return w;
                                                    } else {
                                                        return Math.round(w * c * 0.9);
                                                    }
                                                }
                                            }
                                        });


                                    }
                                });
                            }
                        }
                    ]);
                }
            });
            if (this.page === 'home') {
                api.sendEvent({
                    name: 'analytics',
                    extra: {
                        AnalyticsItemTypeId: 1,
                        AnalyticsActionTypeId: 1,
                        PostId: moment.Id,
                        CountryCode: localStorage.getItem('countryCode') || 'CN',
                        StaySeconds: Math.floor(Math.random() * 10 + 2)
                    }
                });
            }
        },
        openTycoonPlace: function (index, repost, $event) {
            $event && $event.stopPropagation();
            // 滚动时，阻止不小心打开个人空间
            if (this.isScrolling === true) {
                return;
            }
            if (repost) {
                openUserTycoonPlace(this.momentsData[index].rePost.owner.id, this.momentsData[index].rePost.owner.storeName, this.momentsData[index].rePost.owner.thumbnailAvatarUrl);
            } else {
                openUserTycoonPlace(this.momentsData[index].owner.id, this.momentsData[index].owner.storeName, this.momentsData[index].owner.thumbnailAvatarUrl);
            }
        },
        openMyTycoonPlace: function () {
            openTycoonPlace();
        },
        openMomentDetail: function (momentId, momentGuid, userId, type, index) {
            // console.log('Open Moment Detail ...');

            if (this.isScrolling === true) {
                // console.log('Moment will not open !');
                return;
            }
            // console.log('open moment detail !');
            var url = 'widget://html/users/moment-detail.html';
            openTabLayout('shareMoment', '', url, {
                momentId: momentId,
                momentGuid: momentGuid,
                userId: userId,
                useServer: 'cn',
                type: type,
                postIndex: index,
                from: 'home',
                detailData: this.momentsData[index]
            });
            // openWindows('shareMoment',url,{
            //     prodId:momentId,
            //     momentGuid:momentGuid,
            //     userId:userId,
            //     useServer:'cn',
            //     type:type,
            //     postIndex:index,
            //     from:'home',
            // });

        },
        /**
         * @override
         * @param moment
         * @param index
         */
        toggleMore: function (moment, index) {

        },
        /**
         * @override
         */
        hideMore: function () {

        },
        showTranslation: function (index) {
            if (this.isScrolling === true) {
                return;
            }
            var that = this;
            var moment = that.momentsData[index];
            translate(moment.content, function (result) {
                moment.store = result;
            });
        },
        originalText: function (index) {
            if (this.isScrolling === true) {
                return;
            }
            this.momentsData[index].store = null;
            // this.momentsData[index].FeaturedPicture = null;
        },
        videoImageLoaded: function (img, videoUrl, guid) {
            var that = this;
            var video = videoUrl.split('/playlist.m3u8')[0];
            api.imageCache({
                url: img
            }, function (ret, err) {
                //console.log(ret.url +' @@@')
            });

            var kv = api.require('snKVStorage');
            var hasVideoList = kv.has({
                key: 'videoList'
            });
            if (!hasVideoList) {
                var savevideoList = kv.setArray({
                    key: 'videoList',
                    value: []
                });
            }
            var VideoList = kv.getArray({
                key: 'videoList'
            });

            if (api.connectionType === 'wifi') {
                if (VideoList.indexOf(guid) === -1) {
                    api.download({
                        url: video,
                        savePath: "fs://videos/" + guid + ".mp4",
                        cache: true,
                        allowResume: true
                    }, function (ret, err) {
                        if (ret.state === 1) {
                            //console.log(JSON.stringify(ret));
                            that.saveVideoCache(guid);
                        } else {
                            //console.log(JSON.stringify(err))
                        }
                    });
                }

            }

        },
        saveVideoCache: function (guid) {
            var kv = api.require('snKVStorage');
            var VideoList = kv.getArray({
                key: 'videoList'
            });
            if (VideoList.indexOf(guid) === -1) {
                var videos = VideoList;
                videos.push(guid);
                var savevideoList = kv.setArray({
                    key: 'videoList',
                    value: videos
                });
                // console.log(JSON.stringify(savevideoList));
            }
        },
        openVideo: function (url, img, momentId, DurationSeconds, guid, moment) {
            // console.log('Open Video ...');
            if (this.isScrolling === true) {
                // console.log('Video will not open !');
                return;
            }
            // console.log('open Video !');
            var URL = url;
            //var isCache = false;
            //var that = this;
            var kv = api.require('snKVStorage');
            var hasVideoList = kv.has({
                key: 'videoList'
            });
            var VideoList = kv.getArray({
                key: 'videoList'
            });
            if (hasVideoList && VideoList.indexOf(guid) !== -1) {
                URL = "fs://videos/" + guid + '.mp4';
                //isCache = true;
                //that.openPlayerPage(URL,img,isCache);
            }

            if (this.page === 'home') {
                api.sendEvent({
                    name: 'analytics',
                    extra: {
                        AnalyticsItemTypeId: 1,
                        AnalyticsActionTypeId: 1,
                        PostId: momentId,
                        CountryCode: localStorage.getItem('countryCode') || 'CN',
                        StaySeconds: DurationSeconds
                    }
                });
            }
            // playVideo(URL,this.page);
            /*         openTabLayout('single-video','','widget://html/videos/single-video.html', {
                         url: URL,
                         page: this.page
                     });*/
            openTabLayout('videos', '', 'widget://html/videos/video-container.html',
                {
                    data: {
                        userInfo: {
                            "userId": moment.owner.id,
                            "userGuid": moment.owner.customerGuid,
                            "storeName": moment.owner.storeName,
                            "thumbnail": moment.owner.thumbnailAvatarUrl,
                            "followed": moment.favorited,
                            "userName": moment.owner.userName,
                        },
                        postInfo: {
                            "liked": moment.liked,
                            "likeCount": moment.likedCount,
                            "id": moment.blogPostId,
                            "content": moment.content,
                            "videoThumbnail": img,
                            "videoUrl": URL,
                            'guid': moment.momentGuid,
                        }
                    }
                }, true)
/*            api.openFrame({
                name: 'videos',
                url: 'widget://html/videos/video.html',
                pageParam: {
                    data: {
                        userInfo: {
                            "userId": moment.owner.id,
                            "userGuid": moment.owner.customerGuid,
                            "storeName": moment.owner.storeName,
                            "thumbnail": moment.owner.thumbnailAvatarUrl,
                            "followed": moment.favorited,
                            "userName": moment.owner.userName,
                        },
                        postInfo: {
                            "liked": moment.liked,
                            "likeCount": moment.likedCount,
                            "id": moment.blogPostId,
                            "content": moment.content,
                            "videoThumbnail": img,
                            "videoUrl": URL,
                            'guid': moment.momentGuid,
                        }
                    }
                }
            });*/
            /*api.openFrame({
                name: 'single-video',
                url: 'widget://html/videos/single-video.html',
                pageParam: {
                    url: URL,
                    page: this.page,
                    thumb: img,
                }
            });*/

        },
        // openPlayerPage:function(url,pic,isCache){
        //     //console.log(url);
        //     playVideo(url);
        //
        //     // api.openWin({
        //     //     name: 'videoPlayer',
        //     //     url: 'widget://html/frame/video-player.html',
        //     //     bounces:false,
        //     //     bgColor:'#000000',
        //     //     hideHomeIndicator:true,
        //     //     slidBackEnabled:false,
        //     //     animation:{
        //     //         type:"none",
        //     //     },
        //     //     pageParam: {
        //     //         url: url,
        //     //         pic: pic,
        //     //         isCache:isCache
        //     //     }
        //     // });
        // },
        openProdDetail: function (index) {
            var that = this;

            if (that.momentsData[index].rePost) {
                var userInfo = {
                    "ThumbnailAvatarUrl": that.momentsData[index].rePost.owner.thumbnailAvatarUrl,
                    "AvatarUrl": that.momentsData[index].rePost.owner.thumbnailAvatarUrl,
                    "UserName": that.momentsData[index].rePost.owner.userName,
                    "CustomerGuid": that.momentsData[index].rePost.owner.userGuid,
                    "StoreName": that.momentsData[index].rePost.owner.storeName,
                    "Id": that.momentsData[index].rePost.owner.id
                };
                openTabLayout('productDetail', '', 'widget://html/products/product-detail.html', {
                    prodId: that.momentsData[index].rePost.momentProduct.productId,
                    userInfo: JSON.stringify(userInfo)
                });
            } else {
                openTabLayout('productDetail', '', 'widget://html/products/product-detail.html', {
                    prodId: that.momentsData[index].momentProduct.productId,
                    userInfo: JSON.stringify(that.momentsData[index].owner),
                    useServer: that.momentsData[index].owner.registerCountryCode || 'CN',
                });
            }

        },
        openLink: function (link, title) {
            openBrowser(this, link, title);
        },
        likeBtn: function (moment) {
            var that = this;
            var token = api.getPrefs({
                sync: true,
                key: 'accessToken'
            });
            if (!token) {
                openLogin();
                return;
            }
            if (moment.liked === false) {
                like(moment.blogPostId, function () {
                    moment.liked = true;
                    moment.likedCount++;
                });
            } else {
                disLike(moment.blogPostId, function () {
                    moment.liked = false;
                    moment.likedCount--;
                });
            }
        },
        favoriteBtn: function (moment) {
            if (moment.favorited === false) {
                favorite(moment.blogPostId, function () {
                    moment.favorited = true;
                    moment.favoritedCount++;
                });
            } else {
                disFavorite(moment.blogPostId, function () {
                    moment.favorited = false;
                    moment.favoritedCount--;
                });
            }
        },
        hideShareRepost: function () {
            $('.select-repost').removeClass('show');
        },
        hideInputRepost: function () {
            $('.input-repost').removeClass('show');
            $("html,body").css({
                "position": "static",   //去除相对于窗口的定位
            });
            $(window).scrollTop(this.scrollTop);     //恢复浏览器原来的滚动距离
        },
        inputRepost: function () {
            $('.input-repost').addClass('show');
            $('.select-repost').removeClass('show');
            this.scrollTop = $(window).scrollTop();
            $("html,body").css({
                "position": "fixed",
                "top": -this.scrollTop
            });
        },
        repost: function () {
            var that = this;
            var content = this.repostContent;

            if (!content) {
                api.toast({
                    msg: MSG.tips.pleaseSaySomething,
                    duration: 2000,
                    location: 'middle'
                });
                //window.location.reload();
                return
            } else {
                this.hideInputRepost();
            }

            loading('show');
            var index = this.currentMoment.index;
            var id;
            if (this.momentsData[index].rePost) {
                id = this.momentsData[index].rePost.postId;
            } else {
                id = this.momentsData[index].blogPostId;
            }
            var TZ = Intl.DateTimeFormat().resolvedOptions().timeZone;
            var LT = moment().format('YYYY-MM-DDThh:mm:ss');
            var paramStr = {
                "Content": content,
                "ShowOnHomePage": true,
                "RepostId": id,
                "tz": TZ,   // timezone 时区 字符
                "tl": LT, // timelocal  APP本地时间
            };
            var url = getBaseUrl() + "/api/v2/moments/add?userId=" + localStorage.getItem('userId');
            getAxois(url, "POST", paramStr).then(function (response) {
                loading('hide');
                //console.log(JSON.stringify(response));
                api.toast({
                    msg: MSG.tips.alreadyRepost,
                    duration: 2000,
                    location: 'middle'
                });
                // setTimeout(function () {
                //     location.reload();
                // },1000);
                if (that.page !== 'home') {
                    api.sendEvent({
                        name: 'reloadHome'
                    });
                }
                that.repostContent = '';
                postNotify(that.currentMoment.detail.owner.UserName, MSG_TYPE_OTHER, {
                    Type: 'repost',
                    AvatarUrl: localStorage.getItem('thumbnail'),
                    StoreName: localStorage.getItem('storename'),
                    UserId: localStorage.getItem('userId'),
                    PostId: response.data.Id,
                    PostGuid: response.data.Guid,
                });
                showTiV(true);
            }).catch(function (error) {
                loading('hide');
                api.toast({
                    msg: MSG.tips.canNotRepost,
                    duration: 2000,
                    location: 'middle'
                });
            });
        },
        toRepostPage: function () {
            var index = this.currentMoment.index;
            openTabLayout('addMoment', MSG.general.repost, 'widget://html/users/add-moment.html', {
                repostInfo: this.momentsData[index]
            });
        },
        toRepostChatPage: function () {
            var index = this.currentMoment.index;
            var id = this.momentsData[index].blogPostId;
            var username = this.momentsData[index].owner.userName;
            var userPortrait = this.momentsData[index].owner.thumbnailAvatarUrl;
            var postGuid = this.momentsData[index].momentGuid;
            var name = this.momentsData[index].owner.storeName.replace(REG_SHARE_FILTER, " ");
            var Content;
            if (!this.currentMoment.detail.rePost) {
                name = name.replace(/&nbsp;/g, " ");
                Content = this.momentsData[index].content ? this.momentsData[index].content.replace(REG_SHARE_FILTER, "") : "推易吧";
                if (Content && Content.length > 40) {
                    Content = Content.slice(0, 40) + '...';
                }
            } else {
                name = '@' + name + MSG.moment.shareRepostTitle;
                Content = MSG.moment.shareRepostContent;
            }
            var thumbnail;
            if (this.momentsData[index].pictures[0]) {
                thumbnail = this.momentsData[index].pictures[0].thumbnailUrl;
            } else if (this.currentMoment.detail.videos.length > 0) {
                thumbnail = this.currentMoment.detail.videos[0].thumbnailUrl;
            } else {
                thumbnail = this.momentsData[index].owner.thumbnailAvatarUrl;
            }
            openShareToChats({
                title: name,
                description: Content,
                imageUrl: thumbnail,
                extra: {
                    textType: 'moment',
                    momentId: id,
                    momentGuid: postGuid,
                    storeName: this.momentsData[index].owner.storeName,
                    userName: username,
                    userPortrait: userPortrait,
                    userId: this.momentsData[index].owner.id
                }
            });
        },
        shareAndRepost: function (index) {
            var that = this;
            var token = api.getPrefs({
                sync: true,
                key: 'accessToken'
            });
            if (token) {
                this.currentMoment.index = index;
                this.currentMoment.detail = this.momentsData[index];
                // $('.select-repost').addClass('show');

                actionSheet([
                    {
                        text: MSG.general.shareto,
                        callback: function () {
                            that.openShareBar();
                        }
                    },
                    {
                        text: MSG.general.repostChat,
                        callback: function () {
                            that.toRepostChatPage();
                        }
                    },
                    // {
                    //     text: MSG.general.fastRepost,
                    //     callback: function () {
                    //         that.inputRepost();
                    //     }
                    // },
                    {
                        text: MSG.general.repost,
                        callback: function () {
                            that.toRepostPage();
                        }
                    }
                ]);

            } else {
                openLogin();
            }
        },
        openShareBar: function () {
            this.hideShareRepost();
            var that = this;
            var index = this.currentMoment.index;
            var id = this.momentsData[index].blogPostId;
            var ShareUrl = shareH5Host + '/html/post.html?postid=' + id + "&shareid=" + localStorage.getItem('userName');
            var username = this.momentsData[index].owner.userName;
            var thumbnail = this.momentsData[index].owner.thumbnailAvatarUrl;
            var postGuid = this.momentsData[index].momentGuid;
            var name = this.momentsData[index].owner.storeName.replace(REG_SHARE_FILTER, " ");
            var Content;
            if (!this.currentMoment.detail.rePost) {
                name = name.replace(/&nbsp;/g, " ");
                Content = this.momentsData[index].content ? this.momentsData[index].content.replace(REG_SHARE_FILTER, "") : "推易吧";
                if (Content && Content.length > 40) {
                    Content = Content.slice(0, 40) + '...';
                }
            } else {
                name = '@' + name + MSG.moment.shareRepostTitle;
                Content = MSG.moment.shareRepostContent;
            }

            OpenShareBox(ShareUrl, name, Content, username, id, 'post', thumbnail, postGuid);

            if (localStorage.getItem('userGuid')) {
                setTimeout(function () {
                    AddTivNew('share_post_outside', {
                        postOwnerId: that.momentsData[index].owner.id
                    });
                }, 3000);
            }
        },
        formatLink: function (text) {
            if (text) {
                return text.replace(REG_LINK, "<a href='javascript:;' data-url='$1$2' onclick='openBrowser(this)'>$1$2</a>");
            }
        },
        openRewardPage: function (index) {
            // 滚动时，阻止不小心打开打赏
            if (this.isScrolling === true) {
                return;
            }

            var moment = this.momentsData[index];
            this.currentMoment.index = index;
            this.currentMoment.detail = moment;

            if (moment.owner.id === +this.myID) {
                api.toast({
                    msg: this.message.home.tipRewardSelf,
                    duration: 2000,
                    location: 'middle'
                });
                return;
            }

            var that = this;
            if (this.token) {
                api.removeEventListener({
                    name: 'dialogRewardSuccess'
                });
                api.addEventListener({
                    name: 'dialogRewardSuccess'
                }, function (ret) {
                    var rewardValue = ret.value.rewardValue;
                    console.log('rewardValue: ' + rewardValue);
                    api.toast({
                        msg: that.message.home.rewardSuccess,
                        duration: 2000,
                        location: 'middle'
                    });
                    api.sendEvent({
                        name: 'workplaceReload',
                        extra: {
                            type: 'tweebuck',
                        }
                    });
                    postNotify(that.currentMoment.detail.owner.userName, MSG_TYPE_REWARD, {
                        AvatarUrl: localStorage.getItem('thumbnail'),
                        StoreName: localStorage.getItem('storename'),
                        UserId: localStorage.getItem('userId'),
                        PostId: that.currentMoment.detail.blogPostId,
                        PostGuid: that.currentMoment.detail.momentGuid,
                        Reward: rewardValue
                    });
                });

                api.openFrame({
                    name: 'dialog-reward',
                    url: 'widget://html/dialog/dialog-reward.html',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    pageParam: {
                        PostId: that.momentsData[index].blogPostId,
                        PostGuid: that.momentsData[index].momentGuid,
                        Owner: that.momentsData[index].owner.id,
                        UserName: that.momentsData[index].owner.userName,
                        Avatar: that.momentsData[index].owner.thumbnailAvatarUrl,
                    },
                    bounces: false,
                    bgColor: 'rgba(0,0,0,0)',
                    fixedOn: 'ui_layout'
                });
            } else {
                openLogin();
            }
        },
    }
};
