var step1Html = api.readFile({
    sync: true,
    path: 'widget://html/tweelog/modules/step1/step1.html'
})
MSG = JSON.parse(api.readFile({
    sync: true,
    path: 'widget://res/i18n/'+ lan +'.json'
}));
var typeList = [];
try{
    typeList = JSON.parse(localStorage.getItem('tweelogType'));
}catch (err){

}
var step1 = Vue.component('step1', {
    template: step1Html,
    props: {
        tweelogdata: {
            default: function(){return {}},
            type: Object
        }
    },
    data: function(){
        return {
            description: '',
            lookingMember: false,
            message: MSG,
            name: '',
            introduction: '',
            tags: [],
            tweelogType: '',
            members: [
                {
                    avatarUrl: localStorage.getItem('thumbnail'),
                    userId: +localStorage.getItem('userId'),
                    userGuid: localStorage.getItem('userGuid'),
                    nickname: localStorage.getItem('storename'),
                    tweebaaId: localStorage.getItem('userName'),
                    role: 'CREATOR',
                    title: MSG.tweeLog.memberCreator
                }
            ],
            avatarUrl: '../../image/tweelog/default.png'
        }
    },
    created: function(){
        if (Object.keys(this.tweelogdata).length){
            this.avatarUrl = this.tweelogdata.avatarUrl || '../../image/tweelog/default.png';
            this.name = this.tweelogdata.name || '';
            this.introduction = this.tweelogdata.introduction || '';
            if (this.tweelogdata.tags){
                this.tags = this.tweelogdata.tags.map(function(item){
                    return item.tagName
                });
            }
            if (this.tweelogdata.tweelogType){
                if (!typeList || !typeList.length){
                    getTweeLogType().then(function(list){
                        typeList = list;
                        this.sloveType(typeList);
                    }).bind(this);
                }else {
                    this.sloveType(typeList);
                }
            }

            if (this.tweelogdata.members){
                this.members = this.tweelogdata.members
            }

            this.lookingMember = this.tweelogdata.lookingMember || '';
            this.description = this.tweelogdata.description || '';
        }
        api.addEventListener({
            name:'selectTweeLogType'
        }, function(ret, err){
            this.tweelogType = ret.value.type
        }.bind(this));
        api.addEventListener({
            name: 'tweelogtags'
        }, function (ret, err){
            this.tags = ret.value.tags;
        }.bind(this))
        api.addEventListener({
            name: 'select-tweelog-avatar'
        }, function (ret, err){
            this.avatarUrl = ret.value.data.thumbnail;
        }.bind(this))
        api.addEventListener({
            name: 'tweelogSelectMembers'
        }, function (ret, err){
            this.members = ret.value.members;
        }.bind(this))
    },
    computed: {
        descLen: function(){
            return this.introduction.length;
        },
        hiringDescLen: function (){
            return this.description.length;
        }
    },
    methods: {
        sloveType: function(typeList){
            typeList.forEach(function(item){
                if (item.code === this.tweelogdata.tweelogType){
                    this.tweelogType = item;
                }
            }.bind(this));
        },
        checkData: function(){
            const promise = new Promise(function(resolve, reject) {
                var errorMessage = '';
                if (this.avatarUrl === '../../image/tweelog/default.png'){
                    errorMessage = MSG.tweeLog.avatarError;
                }else if (!this.name){
                    errorMessage = MSG.tweeLog.namePlaceholder;
                }else if (!this.introduction){
                    errorMessage = MSG.tweeLog.descPlaceholder;
                }else if (!Object.keys(this.tweelogType).length){
                    errorMessage = MSG.tweeLog.typePlaceholder;
                }else if (!this.tags.length){
                    errorMessage = MSG.tweeLog.tagsPlaceholder;
                }else if (this.tweelogdata.type === 'COLLAB' && this.members.length < 2){
                    errorMessage = MSG.tweeLog.memberError;
                }else if (this.tweelogdata.type === 'COLLAB' &&this.lookingMember && !this.description){
                    errorMessage = MSG.tweeLog.hiringPlaceholder;
                }
                if (errorMessage){
                    api.toast({
                        msg: errorMessage,
                        duration: 2000,
                        location: 'middle'
                    });
                }else {
                    var data = {
                        tags: this.tags.map(function(item){ return {tagName:item}}),
                        avatarUrl: this.avatarUrl,
                        introduction: this.introduction,
                        name: this.name,
                        tweelogType: this.tweelogType.code,
                        members: this.members
                    };
                    if (this.tweelogdata.type === 'COLLAB'){
                        data.lookingMember = this.lookingMember
                        if (this.lookingMember){
                            data.description = this.description;
                        }
                    }
                    loading('show');
                    apiTweelog.post('/api/v1/tweelog/sensitive', {
                        text: this.name + this.introduction + this.description
                    }).then(function(res){
                        loading('hide');
                        if (!Number(res.code)){
                            resolve(data);
                        }else {
                            api.toast({
                                msg: res.message,
                                duration: 2000,
                                location: 'middle'
                            });
                        }
                    });
                }
            }.bind(this))
            return promise
        },
        changeAvatar: function(){
            changeTweelogPortrait({
                avatarUrl: this.avatarUrl
            });
        },
        changeMembers: function(){
            const list = this.members.length ? this.members : [
                {
                    avatarUrl: localStorage.getItem('thumbnail'),
                    userId: +localStorage.getItem('userId'),
                    userGuid: localStorage.getItem('userGuid'),
                    nickname: localStorage.getItem('storename'),
                    tweebaaId: localStorage.getItem('userName'),
                    role: 'CREATOR',
                    title: this.message.tweeLog.memberCreator
                }
            ]
            api.openFrame({
                name: 'tweelogSelectMembers',
                url: 'widget://html/tweelog/modules/step1/selectMembers.html',
                bgColor:'rgba(0, 0, 0, 0.4)',
                rect: {
                    x: 0,
                    y: 0,
                    w: 'auto',
                    h: 'auto'
                },
                animation:{
                    type:"movein",
                    subType:"from_bottom",
                    duration:300
                },
                pageParam: {
                    members: list
                }
            });
        },
        changeTags: function(){
            api.openFrame({
                name: 'tweeLogTags',
                url: 'widget://html/tweelog/modules/step1/tweelog-tags.html',
                bgColor:'rgba(0, 0, 0, 0.4)',
                rect: {
                    x: 0,
                    y: 0,
                    w: 'auto',
                    h: 'auto'
                },
                animation:{
                    type:"movein",
                    subType:"from_bottom",
                    duration:300
                },
                pageParam: {
                    tags: this.tags
                }
            });
        },
        goType: function(){
            api.openFrame({
                name: 'selectTweeLogType',
                url: 'widget://html/tweelog/modules/step1/selectType.html',
                bgColor:'rgba(0, 0, 0, 0.4)',
                rect: {
                    x: 0,
                    y: 0,
                    w: 'auto',
                    h: 'auto'
                },
                animation:{
                    type:"movein",
                    subType:"from_bottom",
                    duration:300
                },
                pageParam: {
                    type: this.tweelogType
                }
            });
        }
    }
})
