//读取文字信息
MSG = JSON.parse(api.readFile({
    sync: true,
    path: 'widget://res/i18n/' + lan + '.json'
}));

var step3Html = api.readFile({
    sync: true,
    path: 'widget://html/tweelog/modules/step3/step3.html'
});

var step3 = Vue.component('step3', {
    template: step3Html,
    props: {
        tweelogdata: {
            default: function(){return {}},
            type: Object
        }
    },
    created: function() {
        // this.selectProduct();
        // this.selectMoment();

        if (this.tweelogdata.moments) {
            this.moments = this.tweelogdata.moments;
        }
        if (this.tweelogdata.products) {
            this.products = this.tweelogdata.products;
        }
        if (this.tweelogdata.story) {
            this.story = this.tweelogdata.story;
        }

        api.addEventListener({
            name: 'tweelogSelectMoment'
        }, function(ret, err){
            this.moments = ret.value.list
        }.bind(this));

        api.addEventListener({
            name: 'tweelogSelectProduct'
        }, function(ret, err){
            this.products = ret.value.list
        }.bind(this));

        api.addEventListener({
            name: 'tweelogInputStory'
        }, function(ret, err){
            this.story = ret.value.content
        }.bind(this));
    },
    data: function() {
        return {
            message: MSG,
            moments: [],
            products: [],
            story: ''
        }
    },
    methods: {
        checkData(){
            const promise = new Promise((resolve, reject) => {
                var data = {
                    moments: this.moments,
                    products: this.products,
                    story: this.story
                };
                if (this.story) {
                    loading('show');
                    apiTweelog.post('/api/v1/tweelog/sensitive', {
                        text: this.story
                    }).then(function(res){
                        loading('hide');
                        if (!Number(res.code)){
                            resolve(data);
                        }else {
                            api.toast({
                                msg: res.message,
                                duration: 2000,
                                location: 'middle'
                            });
                        }
                    });
                } else {
                    resolve(data);
                }
            });
            return promise
        },
        selectProduct: function () {
            api.openFrame({
                name: 'step3Product',
                url: 'widget://html/tweelog/modules/step3/product-page.html',
                bgColor: 'rgba(0, 0, 0, 0.4)',
                rect: {
                    x: 0,
                    y: 0,
                    w: 'auto',
                    h: 'auto'
                },
                animation: {
                    type: "movein",
                    subType: "from_bottom",
                    duration: 300
                },
                pageParam: {
                    products: this.products
                }
            });
        },
        selectMoment: function () {
            api.openFrame({
                name: 'step3Moment',
                url: 'widget://html/tweelog/modules/step3/moment-page.html',
                bgColor: 'rgba(0, 0, 0, 0.4)',
                rect: {
                    x: 0,
                    y: 0,
                    w: 'auto',
                    h: 'auto'
                },
                animation: {
                    type: "movein",
                    subType: "from_bottom",
                    duration: 300
                },
                pageParam: {
                    moments: this.moments
                }
            });
        },
        selectStory: function () {
            api.openFrame({
                name: 'step3Story',
                url: 'widget://html/tweelog/modules/step3/story-page.html',
                bgColor: 'rgba(0, 0, 0, 0.4)',
                rect: {
                    x: 0,
                    y: 0,
                    w: 'auto',
                    h: 'auto'
                },
                animation: {
                    type: "movein",
                    subType: "from_bottom",
                    duration: 300
                },
                pageParam: {
                    type: ''
                }
            });
        }
    }
});
