//读取文字信息
MSG = JSON.parse(api.readFile({
    sync: true,
    path: 'widget://res/i18n/' + lan + '.json'
}));

var step4Html = api.readFile({
    sync: true,
    path: 'widget://html/tweelog/modules/step4/step4.html'
});

var UIAlbumBrowser = api.require('UIAlbumBrowser');

var step4 = Vue.component('step4', {
    template: step4Html,
    props: {
        tweelogdata: {
            default: function () {
                return {}
            },
            type: Object
        }
    },
    mounted: function () {
        // var $body = $('body');
        // window.Sortable = {
        //     create: function () {
        //     }
        // };
        // $body.append('<script type="text/javascript" src="../../script/phone/get-photo.js"></script>');
        // $body.append('<script type="text/javascript" src="../../script/access/sortable.min.js"></script>');
        // 拖动图片
        // Sortable.create($('#uploadImgBox')[0],
        //     {
        //         animation: 150,
        //         onEnd: function (e) {
        //             console.log(222);
        //             console.log(e.target);
        //         },
        //         ignore: 'a',
        //         ghostClass: '.img-li',
        //         handle: '.drag-box'
        //     });

        api.addEventListener({
            name: 'changeTweeLogShowcases'
        }, function(ret, err){
            this.showcases = ret.value.list
        }.bind(this));
    },
    created: function () {
        var that = this;
        this.openPPFrame();
        showcaseService.setUploadedCallback(function (fileList) {
            that.showcases = fileList;
            that.tweelogdata.showcases = fileList;
        });
    },
    destroyed: function() {
        api.sendEvent({
            name: 'closePPFrame'
        });
    },
    data: function () {
        return {
            MSG: MSG,
            myName: localStorage.getItem('storename'),
            myThumbnail: localStorage.getItem('thumbnail'),

            backgroundUrl: this.tweelogdata.backgroundUrl,
            showcases: this.tweelogdata.showcases || [],

            totalScore: '',
            score: '',
            showAccount: '',
        }
    },
    methods: {
        openMedia:function (type,url,thumb) {
            var that = this;
            if(type === 'VIDEO' ){
                playVideo(url,'',thumb);
            }else{
                var Index = that.pics.indexOf(url);
                var UIPhotoViewer = api.require('UIPhotoViewer');
                UIPhotoViewer.open({
                    images: that.pics,
                    placeholderImg: 'widget://image/lost_images.jpg',
                    bgColor: '#000',
                    activeIndex: Index,
                    zoomEnabled: true,
                    gestureClose: true
                }, function (Ret, err) {
                    if (Ret.eventType === 'click') {
                        UIPhotoViewer.close();
                    }
                });
            }
        },
        changeShowcases: function() {
            api.openFrame({
                name: 'changeTweeLogShowcases',
                url: 'widget://html/tweelog/frame/change-showcase.html',
                bgColor:'rgba(0, 0, 0, 0.4)',
                rect: {
                    x: 0,
                    y: 0,
                    w: 'auto',
                    h: 'auto'
                },
                animation:{
                    type:"movein",
                    subType:"from_bottom",
                    duration:300
                },
                pageParam: {
                    tweelogdata: this.tweelogdata
                }
            });
        },
        uploadShowcase: function() {
            showcaseService.open();
        },
        openPPFrame:function () {
            api.openFrame({
                name: 'postPord',
                url: 'frame/post-product.html',
                bgColor:'rgba(0, 0, 0, 0)',
                rect: {
                    x: 0,
                    y: api.winHeight-60,
                    w: 'auto',
                    h: 'auto'
                },
                pageParam: {
                    moments: this.tweelogdata.moments,
                    products: this.tweelogdata.products
                }
            });
        },
        checkData() {
            const promise = new Promise((resolve, reject) => {
                var data = {
                    backgroundUrl: this.backgroundUrl,
                    showcases: this.showcases
                };
                resolve(data);
            })
            return promise
        },
        /**
         * 更改背景
         */
        changeBg: function () {
            var that = this;
            var type;
            actionSheet([
                {
                    text: MSG.general.takePicture,
                    callback: function () {
                        type = 'camera';
                        start();
                    }
                },
                {
                    text: MSG.general.library,
                    callback: function () {
                        type = 'library';
                        start();
                    }
                }
            ]);

            function start() {

                api.getPicture({
                    sourceType: type,
                    encodingType: 'jpg',
                    mediaValue: 'pic',
                    destinationType: 'url',
                    allowEdit: false,
                    quality: 70,
                    targetWidth: 640,
                    saveToPhotoAlbum: false
                }, function (ret, err) {

                    if (ret) {
                        loading('show');

                        setTimeout(function () {
                            console.log("[" + api.deviceName + "]" + JSON.stringify(ret));

                            apiMedia.upload("/upload/images", ret.data).done(function (response) {
                                //console.log("[" + api.deviceName + "]" + JSON.stringify(response));
                                loading('hide');

                                var data = response.data[0];
                                var imgURL = data.raw;

                                // console.log("[" + api.deviceName + "]" + JSON.stringify(response));

                                api.toast({
                                    msg: MSG.tips.backgroundChanged,
                                    duration: 2000,
                                    location: 'middle'
                                });

                                that.backgroundUrl = imgURL;

                            });
                        }, 200);
                    } else {
                        loading('hide');
                        console.log(JSON.stringify(err));
                    }
                });
            }

        },
        openLocation:function () {
            openTabLayout("location",MSG.tweeLog.locationTitle,"widget://html/tweelog/frame/show-location.html",{
                lon:this.detail.longitude,
                lat:this.detail.latitude,
                address:this.detail.address,
            })
        },
        showMediaAccount:function (index) {
            this.showAccount = index;
        },
        toEdit: function() {
            openTabLayout('createTweeLogLocal', MSG.tweeLog.edit, 'widget://html/tweelog/editTweeLogLocal.html');
        }
    }
});
