
apiready = function () {
    backListener();
    api.addEventListener({
        name:'swiperight'
    }, function(ret, err){
        back();
    });

    api.setNavBarAttr({
        rightButtons: [{
            text: lan === "zh" ? "注册" : "Sign Up",
            color: '#1651F0',
            fontSize: '15'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if(ret.type ==='right'){
            openSignup();
        }else{
            back();
        }
    });

    api.setWinAttr({
        name: 'login',
        bounces: false
    });

    api.addEventListener({
        name: 'selectedCallCode'
    }, function(ret, err) {
        loginPage.selectCode = ret.value.num;
    });

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    var loginPage = new Vue({
        el: '#loginPage',
        mounted: function () {
            var that =this;
            //国家号码
            var countryCode = localStorage.getItem('countryCode');
            for (var l= 0; l<callingCode.length;l++){
                if(countryCode === callingCode[l].code){
                    selectedCallingCode = callingCode[l].number;
                    // $('#selectCode').text(callingCode[l].show);
                    that.selectCode = callingCode[l].number
                }
            }

            if(api.systemType ==='android'){
                var oHeight = $(document).height(); //浏览器当前的高度
                $(window).resize(function(){
                    if ($(document).height() < oHeight) {
                        $(".login-signup-links").hide();
                    } else {
                        $(".login-signup-links").show();
                    }
                });
            }

        },
        data: {
            selectCode:86,
            phoneNumber:'',
            password:"",
            inputType:'password',
            message:MSG,
            isRequesting: false,
            isSuccess: false
        },
        computed:{
            unclickable:function () {
                return this.phoneNumber.length<8 || this.password.length < 6;
            },
            clickable:function () {
                return this.phoneNumber.length>=8 && this.password.length >= 6;
            }
        },
        methods:{
            changeInputType:function () {
                if(this.inputType === 'password'){
                    this.inputType = "text"
                }else{
                    this.inputType = 'password'
                }
            },
            loginFunction:function () {
                // 1. 手机号
                if (!this.phoneNumber) {
                    api.toast({
                        msg: MSG.tips.phoneEmpty,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }
                if (this.phoneNumber.length < 8) {
                    api.toast({
                        msg: MSG.tips.phoneNumberTooShort,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }
                if (this.phoneNumber.length > 11) {
                    api.toast({
                        msg: MSG.tips.phoneNumberTooLong,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }

                // 2. 登录密码
                if (!this.password) {
                    api.toast({
                        msg: MSG.tips.passwordEmpty,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }

                var that = this;

                var paramStr = {
                    "countryCallingCode": this.selectCode,
                    "phoneNumber": this.phoneNumber,
                    "password": this.password
                };
                this.isRequesting = true;
                apiUserCenter.post("/api/v1/uas/login", paramStr).done(function (rep) {
                    if (rep.code === 0) {
                        that.isSuccess = true;
                        var userinfo = rep.data.user;
                        var user = {
                            "UserID":userinfo.id,
                            "UserGuid":userinfo.userGuid,
                            "UserName":userinfo.userName,
                            // "Email":null,
                            "UserStoreName":userinfo.storeName,
                            "tweebaaId": userinfo.tweebaaId
                        };
                        if (user.UserID) {

                            var kv = api.require('snKVStorage');
                            var result = kv.setObject({
                                key: 'baseInfo',
                                value: user
                            });
                            // NEW
                            kv.setBool({
                                key: 'isLoggedIn',
                                value: true
                            });

                            api.setPrefs({
                                key: 'accessToken',
                                value: rep.data.token
                            });

                            api.setPrefs({
                                key: 'refreshToken',
                                value: rep.data.refreshToken
                            });

                            api.setPrefs({
                                key: 'tokenExpiration',
                                value: rep.data.expiration
                            });

                            saveLocalStorage(user, rep.data.token, rep.data.refreshToken, rep.data.expiration);
                        } else {
                            back();
                        }
                    } else {
                        that.isRequesting = false;
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    loading('hide');
                    that.isRequesting = false;
                    api.toast({
                        msg:MSG.tips.systemError,
                        duration: 2000,
                        location: 'middle'
                    });
                });

            },
            skipToHome: function () {
                back();
            },
            openForgotPassword: function () {
                openTabLayout('forgotPassword', MSG.loginRegister.resetPassword , 'forgot-password.html');
            }
        }
    });

};

function selectCodeBtn() {
    openTabLayout('selectCodePage','','select-code-page.html');
}

//保存信息到localStorage
function saveLocalStorage(obj, token, refreshToken, tokenExpiration) {
    localStorage.setItem('access_token', token);
    localStorage.setItem('refresh_token', refreshToken);
    localStorage.setItem('token_expiration', tokenExpiration);
    localStorage.setItem('userName', obj.UserName);
    localStorage.setItem('userId', obj.UserID);
    localStorage.setItem('storename', obj.UserStoreName);
    localStorage.setItem('registerCountryCode', "CN");
    localStorage.setItem('userGuid', obj.UserGuid);
    localStorage.setItem('tweebaaId', obj.tweebaaId);
    // 标志App引导已经显示

    api.setPrefs({
        key: guideService.GUIDE_APP_BOOT.key,
        value: 1
    });
    setTimeout(function () {
        api.sendEvent({
            name: 'loginInit'
        });
    },1000);
    setTimeout(function () {
        login();
    }, 1500);
}

// 登陆
function login() {
    loading('hide');
    api.closeWin({
        name:'signup'
    });
    api.closeWin({
        name:'login'
    });
}

function openForgotPassword() {
    openTabLayout('forgotPassword', MSG.loginRegister.resetPassword , 'forgot-password.html');
}

function help() {
    api.openApp({
        iosUrl: "https://chatlink.mstatik.com/widget/standalone.html?eid=358588bc8aa91aa74000dc92b7e3e45c",
        androidPkg: 'android.intent.action.VIEW',
        mimeType: 'text/html',
        uri: "https://chatlink.mstatik.com/widget/standalone.html?eid=358588bc8aa91aa74000dc92b7e3e45c",
    });
}
