
var Code,key,t,countryCode;
var selectedCallingCode = 86;

apiready = function () {
    var SHA256 = api.require('HmacSHA256');

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if(ret.type ==='left'){
            back();
        }
    });

    api.setWinAttr({
        name: 'forgotPassword',
        bounces: false
    });

    api.addEventListener({
        name: 'selectedCallCode'
    }, function(ret, err) {
        selectedCallingCode = ret.value.num;
        signupPage.selectCode = ret.value.num
    });

    api.addEventListener({
        name: 'scanInviteCode'
    }, function(ret, err) {
        signupPage.inviteCode = ret.value.inviteCode;
    });

    Code = api.loadSecureValue({
        sync: true,
        key: 'yunpankey_slider'
    });

    key = api.loadSecureValue({
        sync: true,
        key: 'publickey'
    });

    console.info("[" + api.deviceName + "] [yunpankey] " + Code);
    console.info("[" + api.deviceName + "] [publickey] " + key);

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    var signupPage = new Vue({
        el: '#signupPage',
        mounted: function () {
            var that =this;
            //国家号码

            countryCode = localStorage.getItem('countryCode');
            for (var l= 0; l<callingCode.length;l++){
                if(countryCode === callingCode[l].code){
                    selectedCallingCode = callingCode[l].number;
                    // $('#selectCode').text(callingCode[l].show);
                    that.selectCode = callingCode[l].number
                }
            }

            var clipBoard = api.require('clipBoard');
            clipBoard.get(function(ret, err) {
                var isCode = ret.value.toLowerCase().indexOf("tw");
                if (isCode === 0 && (10 < ret.value.length && ret.value.length < 23)) {
                    that.inviteCode = ret.value;
                    localStorage.setItem('copyInviteCode',ret.value);
                }
            });

            this.initYP();

        },
        created: function() {
            var that = this;
            // DeviceId加密
            SHA256.HmacSHA({
                secret: key,
                content: api.deviceId
            }, function(ret) {
                if (ret) {
                    that.deviceIdHash = ret.HMAC;
                }
            });
        },
        data: {
            selectCode:86,
            phoneNumber:'',
            verifyCode:"",
            verifyToken:'',
            verifyAuthenticate:'',
            password:"",
            inviteCode:localStorage.getItem('copyInviteCode') || '',
            countdown: VERIFY_COUNT_SECONDS,
            isCounting: false,
            inputType: 'password',
            isRequesting: false,
            isSuccess: false,
            deviceIdHash: '',
            message: MSG
        },
        methods:{
            resetYP: function() {
                // this.verifyToken = '';
                // this.verifyAuthenticate = '';
                this.initYP();
            },
            initYP: function() {
                var that = this;
                new YpRiddler({
                    expired: 10,
                    mode: 'dialog',
                    winWidth: api.winWidth * 0.9,
                    lang: lan === 'zh' ?"zh-cn":"en",
                    // langPack: LANG_OTHER, // 你可以通过该参数自定义语言包, 其优先级高于lang
                    container: document.getElementById('cbox'),
                    appId: Code,
                    version: 'v1',
                    onError: function (param) {
                        if (!param.code) {
                            console.error('错误请求');
                        }
                        else if (parseInt(param.code / 100) == 5) {
                            // 服务不可用时，开发者可采取替代方案
                            console.error('验证服务暂不可用');
                        }
                        else if (param.code == 429) {
                            console.warn('请求过于频繁，请稍后再试');
                        }
                        else if (param.code == 403) {
                            console.warn('请求受限，请稍后再试');
                        }
                        else if (param.code == 400) {
                            console.warn('非法请求，请检查参数');
                        }
                        // 异常回调
                        console.error('验证服务异常:' + param.code)
                        api.toast({
                            msg: '验证服务异常:' + param.code,
                            duration: 2000,
                            location: 'middle'
                        });
                    },
                    onSuccess: function (validInfo, close, useDefaultSuccess) {
                        // 成功回调
                        // alert('验证通过! token=' + validInfo.token + ', authenticate=' + validInfo.authenticate)
                        // 验证成功默认样式
                        that.verifyAuthenticate = validInfo.authenticate;
                        that.verifyToken = validInfo.token;
                        useDefaultSuccess(true);
                        close();

                        setTimeout(function () {
                            that.sendCode();
                        }, 200);
                    },
                    onFail: function (code, msg, retry) {
                        // 失败回调
                        // alert('出错啦：' + msg + ' code: ' + code);
                        retry()
                    },
                    beforeStart: function (next) {
                        //console.log('验证马上开始')
                        next()
                    }
                })
            },
            changeInputType:function () {
                if(this.inputType === 'password'){
                    this.inputType = "text"
                }else{
                    this.inputType = 'password'
                }
            },
            getVerifyCode: function(){
                if (!this.phoneNumber) {
                    api.toast({
                        msg: MSG.tips.phoneEmpty,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }
                if (this.phoneNumber.length < 8) {
                    api.toast({
                        msg: MSG.tips.phoneNumberTooShort,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }
                if (this.phoneNumber.length > 11) {
                    api.toast({
                        msg: MSG.tips.phoneNumberTooLong,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }
                $('.yp-riddler-button').trigger('click');
            },
            sendCode: function () {

                if (!this.verifyToken) {
                    return;
                }

                var phone = this.phoneNumber;

                var that = this;
                loading('show');
                if (phone) {
                    var paramStr = {
                        "authenticate": that.verifyAuthenticate,
                        "cellphone": phone,
                        "countryCode": that.selectCode,
                        "token": that.verifyToken,
                        "lang": lan = lan ==="es"?'en':lan
                    };
                    apiUserCenter.post("/api/v1/uas/smsv2", paramStr).done(function (rep) {
                        loading('hide');
                        if (rep.code === 0) {
                            that.isCounting = true;
                            that.startCountDown();
                        } else {
                            api.toast({
                                msg: rep.message + " (4000)",
                                duration: 2000,
                                location: 'middle'
                            });
                            that.resetYP();
                        }
                    }).fail(function (err) {
                        loading('hide');
                        api.toast({
                            msg:MSG.tips.systemError + " (5000)",
                            duration: 2000,
                            location: 'middle'
                        });
                    });

                }
            },
            /**
             * 计数验证码
             */
            startCountDown: function () {
                var that = this;
                if (this.countdown === 0) {
                    //$(This).removeAttribute("disabled");
                    this.countdown = 60;
                    this.isCounting = false;
                    this.resetYP();
                    clearTimeout(t);
                } else {
                    t = setTimeout(function () {
                        that.countdown--;
                        that.startCountDown();
                    }, 1000);
                }
            },
            /**
             * 注册
             */
            singUp: function () {
                // 1. 手机号
                if (!this.phoneNumber) {
                    api.toast({
                        msg: MSG.tips.phoneEmpty,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }
                if (this.phoneNumber.length < 8) {
                    api.toast({
                        msg: MSG.tips.phoneNumberTooShort,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }
                if (this.phoneNumber.length > 11) {
                    api.toast({
                        msg: MSG.tips.phoneNumberTooLong,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }

                // 2. 验证码
                if (!this.verifyCode) {
                    api.toast({
                        msg: MSG.tips.verifyCodeEmpty,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }
                if (this.verifyCode.length !== 6) {
                    api.toast({
                        msg: MSG.tips.verifyCodeIncorrect,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }

                // 登录密码
                if (!this.password) {
                    api.toast({
                        msg: MSG.tips.passwordEmpty,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }
                if (REG_PATTERN_PASSWORD.test(this.password) === false) {
                    api.toast({
                        msg: MSG.tips.password6,
                        duration: 2000,
                        location: 'top'
                    });
                    return;
                }

                var that = this;

                var userName  = 'tw' + Date.parse(new Date());

                var paramStr = {
                    "verifyCode": that.verifyCode,
                    "userName": userName,
                    "storeName": userName,
                    "password": that.password,
                    "countryCallingCode": selectedCallingCode,
                    "phoneNumber": that.phoneNumber,
                    "registerCountryCode": "CN",
                    "inviter": that.inviteCode,
                    "deviceId": api.deviceId,
                    "signature": that.deviceIdHash,
                    "timezone": Intl.DateTimeFormat().resolvedOptions().timeZone
                };

                console.log(JSON.stringify(paramStr));
                loading('show');
                this.isRequesting = true;
                apiUserCenter.post("/api/v1/uas/register", paramStr).done(function (rep) {
                    loading('hide');
                    if (rep.code === 0) {
                        that.isSuccess = true;
                        that.loginFunction();
                    } else {
                        that.isRequesting = false;
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    loading('hide');
                    that.isRequesting = false;
                    api.toast({
                        msg:MSG.tips.systemError + " (5000)",
                        duration: 2000,
                        location: 'middle'
                    });
                });

            },
            loginFunction:function () {
                var that = this;
                loading('show');
                var paramStr = {
                    "countryCallingCode":selectedCallingCode,
                    "phoneNumber":that.phoneNumber,
                    "password":that.password
                };

                apiUserCenter.post("/api/v1/uas/login", paramStr).done(function (rep) {
                    loading('hide');
                    //console.log(JSON.stringify(rep));
                    if (rep.code === 0) {
                        loading('hide');
                        var userinfo = rep.data.user;
                        var user = {
                            "UserID":userinfo.id,
                            "UserGuid":userinfo.userGuid,
                            "UserName":userinfo.userName,
                            // "Email":null,
                            "UserStoreName":userinfo.storeName,
                            "tweebaaId": userinfo.tweebaaId
                        };
                        if (user.UserID) {

                            var kv = api.require('snKVStorage');
                            var result = kv.setObject({
                                key: 'baseInfo',
                                value: user
                            });
                            // NEW
                            kv.setBool({
                                key: 'isLoggedIn',
                                value: true
                            });

                            api.setPrefs({
                                key: 'accessToken',
                                value: rep.data.token
                            });

                            api.setPrefs({
                                key: 'refreshToken',
                                value: rep.data.refreshToken
                            });

                            api.setPrefs({
                                key: 'tokenExpiration',
                                value: rep.data.expiration
                            });

                            if (that.inviteCode) {
                                postNotify(that.inviteCode, MSG_TYPE_OTHER, {
                                    Type: 'accepted',
                                    UserId: user.UserID,
                                    AvatarUrl: IMAGE_DEFAULT_AVATAR,
                                    StoreName: user.UserStoreName
                                });
                            }

                            saveLocalStorage(user, rep.data.token, rep.data.refreshToken, rep.data.expiration);
                        } else {
                            back();
                        }
                    } else {
                        that.submit = false;
                        api.toast({
                            msg: rep.message + " (6000)",
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    loading('hide');
                    that.submit = false;
                    api.toast({
                        msg:MSG.tips.systemError + " (5000)",
                        duration: 2000,
                        location: 'middle'
                    });
                });

            },
            skipToHome: function () {
                api.closeWin({
                    name: 'login'
                });
                back();
            }
        }
    });

};

function selectCodeBtn() {
    openTabLayout('selectCodePage','','select-code-page.html');
}

function tips(key,text) {
    openTabLayout("tweebaaProfitTips",'','widget://html/access/tips.html',{
        key:key,
        text:text
    })
}


function showTerms() {
    var title;
    if (lan === 'zh') {
        title = '推易吧用户服务协议'
    } else {
        title = 'Tweebaa End User Services Agreement'
    }
    openTabLayout('serviceNote',title,'widget://html/access/term.html')
}


function filterStr(str) {
    var pattern = new RegExp("[`/~@#$^&=|{}':;, \\[\\]<>￥…‘；：”“。，、？+]");
    var specialStr = "";
    for (var i = 0; i < str.length; i++) {
        specialStr += str.substr(i, 1).replace(pattern, '');
    }
    return specialStr;
}

//保存信息到localStorage
function saveLocalStorage(obj, token, refreshToken, tokenExpiration) {
    localStorage.setItem('access_token', token);
    localStorage.setItem('refresh_token', refreshToken);
    localStorage.setItem('token_expiration', tokenExpiration);
    localStorage.setItem('userName', obj.UserName);
    localStorage.setItem('userId', obj.UserID);
    localStorage.setItem('storename', obj.UserStoreName);
    localStorage.setItem('registerCountryCode', "CN");
    localStorage.setItem('userGuid', obj.UserGuid);
    localStorage.setItem('tweebaaId', obj.tweebaaId);

    // 标志App引导已经显示
    api.setPrefs({
        key: guideService.GUIDE_APP_BOOT.key,
        value: 1
    });

    setTimeout(function () {
        api.sendEvent({
            name: 'loginInit'
        });
    },500);
    api.closeWin({
        name:'login'
    });
    setTimeout(function () {
        loading('hide');
        api.closeWin({
            name:'signup'
        });
    }, 1000);

}

function help() {
    api.openApp({
        iosUrl: "https://chatlink.mstatik.com/widget/standalone.html?eid=358588bc8aa91aa74000dc92b7e3e45c",
        androidPkg: 'android.intent.action.VIEW',
        mimeType: 'text/html',
        uri: "https://chatlink.mstatik.com/widget/standalone.html?eid=358588bc8aa91aa74000dc92b7e3e45c",
    });
}
