
apiready = function () {
    backListener();
    api.setNavBarAttr({
        shadow:'#fff',
    });

    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    var analytics = new Vue({
        el: '#analytics',
        mounted: function () {
            var that = this;
            this.getBlockData();
            this.getCompar();
            this.attractionTopFollower();
        },
        data: {
            tag:'attraction',
            ADate:30,
            postLikeOrView:'Views',
            blockData:{
                'attraction':'',
                'post':'',
                'products':'',
                'profile':'',
            },
            comparison:{
                'attraction':{
                    'd7':'',
                    'd30':'',
                    'd90':''
                },
                'post':{
                    'd7':'',
                    'd30':'',
                    'd90':''
                },
                'products':{
                    'd7':'',
                    'd30':'',
                    'd90':''
                },
                'profile':{
                    'd7':'',
                    'd30':'',
                    'd90':''
                },
            },
            viewLikeData:{
                'post':{
                    'd7':'',
                    'd30':'',
                    'd90':''
                },
                'products':{
                    'd7':'',
                    'd30':'',
                    'd90':''
                },
                'profile':{
                    'd7':'',
                    'd30':'',
                    'd90':''
                },
            },
            topFollower:'',
            topPost:'',
            myID:localStorage.getItem('userId'),
            msg: MSG.analytics
        },
        filters: {
            ifNull:function (value) {
                if(!value){
                    return 0 ;
                }else{
                    return value;
                }
            },
        },
        watch:{
            tag:function () {
                if(this.tag === 'post'){

                }
            }
        },
        methods: {
            openWarn: function(title) {
                dialog({
                    title: MSG.analytics[title],
                    content: MSG.analytics[title + 'Desc'],
                    primaryText: MSG.tips.gotit,
                    asideText: '',
                    onWarning: function() {
                    },
                    onPrimary: function () {

                    }
                });
            },
            changeTag:function (type) {
                var that = this;
                that.tag = type;
                that.getBlockData();
                that.getCompar();
                if(type ==='post' ||type ==='products'){
                    that.getViewLikeData();
                }
            },
            changeDate:function(d){
                var that = this;
                that.ADate = d;
                that.getCompar();
                if(that.tag !== 'attraction'){
                    that.getViewLikeData();
                }
            },
            changePostViewLike:function(btn){
                var that = this;
                that.postLikeOrView = btn;
                that.DrawViewLikeChart();
            },
            getBlockData:function () {
                var that = this;
                if(that.blockData[that.tag]){
                    return false;
                }
                var type ='';
                switch (that.tag) {
                    case 'attraction':
                        type ='attraction';
                        break;
                    case 'post':
                        type ='post';
                        break;
                    case 'products':
                        type ='pro';
                        break;
                    case 'profile':
                        type ='ty';
                        break;
                }
                var url = getBaseUrl() + "api/dashboard/v1/"+ type +"/" + that.myID;
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(that.tag));
                    if(response.data.Code === 0){
                        that.blockData[that.tag] = response.data.Data;
                    }

                    //console.log(JSON.stringify(that.blockData[that.tag]));
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');

                });
            },
            getCompar:function () {
                var that = this;
                if(that.comparison[that.tag]['d'+that.ADate]){
                    setTimeout(function () {
                        that.DrawComparChart();
                        if(that.tag ==='profile'){
                            that.DrawViewLikeChart();
                        }
                    });
                    return false;
                }
                var type ='';
                switch (that.tag) {
                    case 'attraction':
                        type ='attraction/rates/';
                        break;
                    case 'post':
                        type ='post/';
                        break;
                    case 'products':
                        type ='pro/';
                        break;
                    case 'profile':
                        type ='ty/';
                        break;
                }
                loading('show');
                var url = getBaseUrl() + "api/dashboard/v1/" + type + that.myID+'/'+that.ADate;
                getAxois(url, "GET", {}).then(function (response) {
                    loading('hide');
                    // console.log(JSON.stringify(response)+"@@@");
                    if(response.data.Code === 0){
                        that.comparison[that.tag]['d'+that.ADate] = response.data.Data;
                    }
                    if(that.tag ==='profile'){
                        that.viewLikeData[that.tag]['d'+that.ADate] = response.data.Data;
                    }
                     //console.log(JSON.stringify(that.comparison)+"###");
                    setTimeout(function () {
                        that.DrawComparChart();
                        if(that.tag ==='profile'){
                            that.DrawViewLikeChart();
                        }
                    },300)
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            DrawComparChart:function () {
                var that = this;
                var chartData,YValue,ID,Color,legend;
                switch (that.tag) {
                    case 'attraction':
                        chartData = that.comparison.attraction['d'+that.ADate].Rates;
                        YValue = 'Rate';
                        ID = 'attractionCompar';
                        Color = '#43abff';
                        legend = [{
                            name: that.msg.attractionValue,
                            marker: 'circle',
                            fill: '#518DFE'
                        },{
                            name: that.msg.average +' ' + that.comparison.attraction['d'+that.ADate].Average,
                            marker: 'circle',
                            fill: '#fff'
                        }];
                        break;
                    case 'post':
                        chartData = that.comparison.post['d'+that.ADate];
                        YValue = 'AvgStaySeconds';
                        ID = 'postCompar';
                        Color = '#ef8d1d';
                        legend = [{
                            name: that.msg.averageViews +' ' + that.msg.seconds,
                            marker: 'circle',
                            fill: '#ef8d1d'
                        }];
                        break;
                    case 'products':
                        chartData = that.comparison.products['d'+that.ADate];
                        YValue = 'Sales';
                        ID = 'productsCompar';
                        Color = '#d278e5';
                        legend = [{
                            name: that.msg.conversionRate,
                            marker: 'circle',
                            fill: '#d278e5'
                        }];
                        break;
                    case 'profile':
                        chartData = that.comparison.profile['d'+that.ADate];
                        YValue = 'Views';
                        ID = 'profileCompar';
                        Color = '#4416c0';
                        legend = [{
                            name: that.msg.views,
                            marker: 'circle',
                            fill: '#4416c0'
                        }];
                        break;
                }
                var chart = new F2.Chart({
                    id: ID,
                    pixelRatio: window.devicePixelRatio
                });

                chart.source(chartData);
                chart.scale('date', {
                    type: 'timeCat',
                    mask:"MM-DD",
                    tickCount: 3
                });
                chart.scale(YValue, {
                    tickCount: 5,
                    // alias:$.i18n.prop('attraction-value')
                });
                chart.tooltip({
                    custom: true,
                    showXTip: true,
                    showYTip: true,
                    snap: true,
                    crosshairsType: 'xy',
                    crosshairsStyle: {
                        lineDash: [2]
                    }
                });
                chart.legend({
                    custom: true,
                    itemWidth: null,
                    items: legend
                });
                chart.line().position('date*'+ YValue + '').color(Color).shape('smooth');
                if(that.ADate !==90){
                    chart.point().position('date*'+ YValue + '').color(Color).shape('smooth').style({
                        stroke: '#fff',
                        lineWidth: 1
                    });
                }

                chart.render();

            },
            getViewLikeData:function(){
                var that = this;
                var type = '';
                if(that.viewLikeData[that.tag]['d'+that.ADate]){
                    setTimeout(function () {
                        that.DrawViewLikeChart();
                    });
                    return false;
                }
                switch (that.tag) {
                    case 'post':
                        type ='post/likes/';
                        break;
                    case 'products':
                        type ='pro/views/';
                        break;
                    case 'profile':
                        type ='ty/';
                        break;
                }

                var url = getBaseUrl() + "api/dashboard/v1/" + type + that.myID+'/'+that.ADate;
                getAxois(url, "GET", {}).then(function (response) {
                    loading('hide');
                     //console.log(JSON.stringify(response)+"@@@");
                    if(response.data.Code === 0){
                        that.viewLikeData[that.tag]['d'+that.ADate] = response.data.Data;
                    }
                    //console.log(JSON.stringify(that.viewLikeData)+"###");
                    setTimeout(function () {
                        that.DrawViewLikeChart();
                    },300)
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });

            },
            DrawViewLikeChart:function () {
                var that = this;
                var chartData,YValue,ID,Color,legend;
                switch (that.tag) {
                    case 'post':
                        chartData = that.viewLikeData.post['d'+that.ADate];
                        YValue = that.postLikeOrView;
                        ID = 'postViewLike';
                        Color = 'l(0) 0:#7ddd8f 0.5:#3fae54 1:#15dbbc';
                        legend = [{
                            name: that.postLikeOrView ==='Views'? MSG.general.viewTimes+' ' + that.msg.times:that.msg.like +' ' + that.msg.times,
                            marker: 'circle',
                            fill: '#15dbbc'
                        }];
                        break;
                    case 'products':
                        chartData = that.viewLikeData.products['d'+that.ADate];
                        YValue = 'Views';
                        ID = 'productsViewLike';
                        Color = 'l(0) 0:#db8815 0.5:#ddc116 1:#dd9216';
                        legend = [{
                            name: that.msg.views,
                            marker: 'circle',
                            fill: '#dd9216'
                        }];
                        break;
                    case 'profile':
                        chartData = that.comparison.profile['d'+that.ADate];
                        YValue = 'Ave';
                        ID = 'profileViewLike';
                        Color = 'l(0) 0:#F2C587 0.5:#ED7973 1:#c6331f';
                        legend = [{
                            name: that.msg.averageViews +' '+ that.msg.seconds,
                            marker: 'circle',
                            fill: '#c6331f'
                        }];
                        break;
                }
                var chart = new F2.Chart({
                    id: ID,
                    pixelRatio: window.devicePixelRatio
                });

                chart.source(chartData);
                chart.scale('date', {
                    type: 'timeCat',
                    mask:"MM-DD",
                    tickCount: 3
                });
                chart.scale(YValue, {
                    tickCount: 5,
                    // alias:$.i18n.prop('attraction-value')
                });
                chart.tooltip({
                    custom: true,
                    showXTip: true,
                    showYTip: true,
                    snap: true,
                    crosshairsType: 'xy',
                    crosshairsStyle: {
                        lineDash: [2]
                    }
                });
                chart.legend({
                    custom: true,
                    itemWidth: null,
                    items: legend
                });
                chart.line().position('date*'+ YValue + '').color(Color);
                chart.area().position('date*'+ YValue + '').color(Color);
                if(that.ADate !==90) {
                    chart.point().position('date*' + YValue + '').color(Color).style({
                        stroke: '#fff',
                        lineWidth: 1
                    });
                }
                chart.render();

            },
            attractionTopFollower:function () {
                var that = this;
                var url = getBaseUrl() + "api/dashboard/v1/attractiontop/"+ that.myID;
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(response)+"@@@");
                    that.topFollower = response.data.Data
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            openProfile: function (index) {
                openUserTycoonPlace(this.topFollower[index].FollowerId,this.topFollower[index].Name,this.topFollower[index].Url);
            },
            getTopPost:function () {
                var that = this;
                var url = getBaseUrl() + "api/dashboard/v1/post/top5/"+ that.myID;
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(response)+"@@@");
                    that.topPost = response.data.Data
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            }
        }
    });
};
