
var addressForm,selectedCounty,selectedProvince;
apiready = function () {
    backListener();

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));
    $('[data-replace-text]').each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.general[k]);
    });

    api.setNavBarAttr({
        rightButtons: [{
            text: MSG.general.done,
            color: '#4578F3',
            fontSize: '15'
        }]
    });
    api.addEventListener({
        name: 'navitembtn'
    }, function (ret, err) {
        if (ret.type === 'right') {
            addressForm.saveAddress();
        } else {
            back();
        }
    });


    api.setWinAttr({
        bounces: false,
        slidBackEnabled:true,
    });

    api.addEventListener({
        name: 'selectedCounty'
    }, function(ret, err) {
        selectedCounty = ret.value.county;
        $('#country').text(selectedCounty.Name);
        if(selectedCounty.Name){
            for(i=0;i<callingCode.length;i++){
                if(callingCode[i].code === selectedCounty.TwoLetterIsoCode){
                    if(addressForm.addressData.phoneNum.indexOf("+") !== -1){
                        addressForm.addressData.phoneNum = callingCode[i].show + ' ' +  addressForm.addressData.phoneNum.split(' ')[1]
                    }else if(!addressForm.addressData.phoneNum){
                        addressForm.addressData.phoneNum = callingCode[i].show + ' '
                    }else{
                        addressForm.addressData.phoneNum = callingCode[i].show + ' ' +  addressForm.addressData.phoneNum
                    }

                }
            }
        }

    });

    api.addEventListener({
        name: 'selectedProvince'
    }, function(ret, err) {
        if(ret.value.provinces.Id !=null){
            selectedProvince = ret.value.provinces;
        }
        $('#province').text(ret.value.provinces.Name);
    });

    addressForm = new Vue({
        el: '#addressForm',
        mounted: function () {
            this.getCounty();
            if(api.pageParam.addressData.CountryId){
                selectedCounty = api.pageParam.addressData.Country;
                $('#country').text(selectedCounty.Name);
            }
            if(api.pageParam.addressData.ProvinceId){
                selectedProvince = api.pageParam.addressData.Province;
                $('#province').text(selectedProvince.Name);
            }
        },
        data: {
            addressData: {
                "name":api.pageParam.addressData.FirstName || '',
                "email":api.pageParam.addressData.Email || '',
                "city":api.pageParam.addressData.City || '',
                "address":api.pageParam.addressData.Address1 || '',
                "phoneNum":api.pageParam.addressData.PhoneNumber || '',
                "postalCode":api.pageParam.addressData.PostalCode || '',
                "isPrimaryShipping":api.pageParam.addressData.IsPrimaryShipping || false,
            },
            addressId:api.pageParam.addressData.Id,
            defaultAddress:null,
            countyList:'',
            message:MSG.address
        },
        methods:{
            getCounty:function () {
                loading('show');
                var that = this;
                var url = getBaseUrl() + "api/countries?lang="+ lan;
                getAxois(url, "GET", {}).then(function (response) {
                    loading('hide');
                    //console.log(JSON.stringify(response.data));
                    that.countyList = response.data;
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                    //messages($.i18n.prop('systemError'), 'error', 'top', 3);
                });
            },
            toCountyPage:function () {
                if(this.countyList){
                    openTabLayout("selectCounty","","widget://html/business/select-county.html",{
                        countries:this.countyList
                    });
                }
            },
            toProvincePage:function () {
                var that = this;
                if(selectedCounty){
                    openTabLayout("selectCounty","","widget://html/business/select-province.html",{
                        selectedCounty:selectedCounty
                    });
                }else{
                    api.toast({
                        msg: that.message.noCounty,
                        duration: 2000,
                        location: 'middle'
                    });
                }
            },
            saveAddress:function () {
                var that = this;
                if(!that.addressData.name){
                    api.toast({
                        msg: that.message.noName,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }else if(!selectedCounty){
                    api.toast({
                        msg: that.message.noCounty,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }else if(!that.addressData.address){
                    api.toast({
                        msg: that.message.noAddress,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }else if(!that.addressData.phoneNum){
                    api.toast({
                        msg: that.message.noPhoneNum,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }
                var paramStr = {
                    "FirstName": that.addressData.name,
                    "LastName": '',
                    "Email": that.addressData.email,
                    "Company": null,
                    "CountryId": selectedCounty.Id,
                    "ProvinceId": selectedProvince?selectedProvince.Id:null,
                    "City": that.addressData.city,
                    "Address1": that.addressData.address,
                    "Address2": null,
                    "PostalCode": that.addressData.postalCode,
                    "PhoneNumber": that.addressData.phoneNum,
                    "FaxNumber": null,
                    "CustomAttributes": "",
                    "CompanyUrl": null,
                    "IsPrimaryBilling":false,
                    "IsPrimaryShipping":that.addressData.isPrimaryShipping
                };
                var url,method;
                if(that.addressId){
                    url = getBaseUrl() + "api/users/"+ localStorage.getItem('userId') +"/addresses/" +that.addressId;
                    method = "PUT";
                }else{
                    url = getBaseUrl() + "api/users/"+ localStorage.getItem('userId') +"/addresses";
                    method = "POST";
                }
                loading("show");
                getAxois(url, method, paramStr).then(function (response) {
                    //console.log(JSON.stringify(response.data));
                    loading('hide');
                    if (response.status === 200) {
                        api.toast({
                            msg: that.message.success,
                            duration: 2000,
                            location: 'middle'
                        });
                        api.sendEvent({
                            name: 'reloadAddressList'
                        });
                        // api.sendEvent({
                        //     name: 'analytics',
                        //     extra: {
                        //         AnalyticsItemTypeId: 2,
                        //         AnalyticsActionTypeId:1,
                        //         ProductId: prodId,
                        //         CountryCode: localStorage.getItem('countryCode'),
                        //         StaySeconds: time
                        //     }
                        // });
                        setTimeout(function () {
                            back();
                        }, 2000);
                    } else {
                        api.toast({
                            msg: response.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                    //messages($.i18n.prop('systemError'), 'error', 'top', 3);
                });

            },
            deleteAddress:function () {
                var that = this;

                //默认地址不可以删除
                if (api.pageParam.addressData.IsPrimaryShipping === true) {
                    api.toast({
                        msg: that.message.defaultNotDel,
                        duration: 2000,
                        location: 'middle'
                    });
                    return;
                }

                confirmBox(MSG.tips.wantDelete, MSG.general.cancel, MSG.general.ok,'error');
                $('.dialog-box').find('button').on('click',function (e) {
                    var index = $(this).attr('id');
                    $('.dialog-box').remove();
                    if (index === 'btn-2') {
                        var userId =  localStorage.getItem('userId');
                        var url = getBaseUrl() + "api/users/"+ userId +"/addresses/" + that.addressId;
                        loading("show");
                        getAxois(url, "DELETE", {}).then(function (response) {
                            console.log(JSON.stringify(response.data));
                            if (response.status === 200) {
                                loading('hide');
                                api.toast({
                                    msg: MSG.tips.success,
                                    duration: 2000,
                                    location: 'middle'
                                });
                                api.execScript({
                                    name: 'address',
                                    script: "addressList.getAddressList()"
                                });
                                setTimeout(function () {
                                    back()
                                }, 2000);
                            } else {
                                if (response.data.$id === '1') {
                                    messages(that.message.canNotDelete, 'error', 'top', 3);
                                }
                            }
                        }).catch(function (error) {
                            loading('hide');
                            console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                            //messages($.i18n.prop('systemError'), 'error', 'top', 3);
                            if (error.response.data.$id === '1') {
                                messages(that.message.canNotDelete, 'error', 'top', 3);
                            }
                        });

                    }
                });
            }
        }
    });
}
