apiready = function () {
    api.setWinAttr({
        bounces: false
    });

    $('.addShopping-bar').height((api.safeArea.bottom + 60) + 'px');

    api.addEventListener({
        name: 'reloadShoppingPage'
    }, function (ret, err) {
        location.reload();
    });
    api.addEventListener({
        name: 'updateCart'
    }, function (ret, err) {
        cart.getShoppingCartList();
    });
    api.addEventListener({
        name: 'changeDefaultAddress'
    }, function (ret, err) {
        cart.getDefaultAddress(ret.value.index);
    });

    //下拉刷新
    var pullDownRefresh = lan ==='zh'?'下拉刷新':'Pull down to refresh';
    var refreshing = lan ==='zh'?'刷新中...':'Refreshing...';
    var releaseRefresh = lan ==='zh'?'放开开始刷新':'Release refresh';
    api.setRefreshHeaderInfo({
        bgColor: '#fff',
        textColor: '#000',
        textDown: pullDownRefresh,
        textLoading: refreshing,
        showTime:false,
        textUp: releaseRefresh
    }, function(ret, err) {
        $('#placeHolderLoad').show();
        cart.getShoppingCartList();
    });

    var cart = new Vue({
        el: '#cart',
        mounted: function () {
            this.getShoppingCartList();
            this.getDefaultAddress();
         },
        data: {
            listData: [],
            defaultCurrency: localStorage.getItem('primaryCurrencyCode'),
            shoppingCartInfo:[],
            defaultAddress:null,
            allAddress:[],
            checked: false,
            checkedList: [],
            checkedArr: []
        },
        filters: {
            fixed2:function (value) {
                return Number(value).toFixed(2);
            },
        },
        watch: {
            "checkedList": function() {
                this.checked = this.checkedList.length === this.checkedArr.length;
            }
        },
        methods:{
            getDefaultAddress:function(index){
                var that = this;
                var userId =  localStorage.getItem('userId');
                var url = getBaseUrl() + "api/users/"+ userId +"/addresses";
                getAxois(url,"GET",{}).then(function (response) {
                    //console.log(JSON.stringify(response.data));
                    that.allAddress = response.data;
                    var d = response.data;
                    if(index || index == 0){
                        that.defaultAddress = d[index];
                    }else{
                        for(i=0; i< d.length; i++){
                            if(d[i].IsPrimaryShipping){
                                that.defaultAddress = d[i];
                                break;
                            }
                        }
                    }
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                    // messages($.i18n.prop('systemError'), 'error', 'top', 3);
                });
            },
            getShoppingCartList:function () {

                var that = this;
                var userGuid =  localStorage.getItem('userGuid');
                var url = getBaseUrl() + "/api/v2/shopping-cart/items?buyerGuid=" + userGuid;
                that.listData =[];
                getAxois(url,"GET",{}).then(function (response) {
                    $('#placeHolderLoad').hide();
                    //console.log(JSON.stringify(response.data));
                    api.refreshHeaderLoadDone();
                    that.listData = response.data;
                    if(that.listData.length ===0){
                        $('#noData').removeClass('d-none');
                    }
                    setTimeout(function () {
                        var len = that.listData.length;
                        for(l=0;l<len;l++){
                            var Lenght = that.listData[l].length;
                            for(u=0;u<Lenght;u++){
                                that.checkedArr.push({"StoreId":that.listData[l][u].StoreId,"ProductId":that.listData[l][u].Product.Id,"Quantity":that.listData[l][u].Quantity});
                            }
                        }
                    });

                }).catch(function (error) {

                    console.log(JSON.stringify(error));
                   // messages($.i18n.prop('systemError'), 'error', 'top', 3);
                });
            },
            openPlace:function(Id,StoreName,AvatarUrl){
                openUserTycoonPlace(Id,StoreName,AvatarUrl);
            },
            changeAllChecked: function() {
                if (this.checked) {
                    this.checkedList = this.checkedArr;
                } else {
                    this.checkedList = []
                }
                // console.log("checkedList "+ JSON.stringify(this.checkedList));
                // console.log("checkedArr "+ JSON.stringify(this.checkedArr));
            },
            delProduct:function(itemId){
                var that = this;
                confirmBox($.i18n.prop('wantDeleteProduct'), $.i18n.prop('cancel'), $.i18n.prop('sure'),'error');
                $('.dialog-box').find('button').on('click',function (e) {
                    var index = $(this).attr('id');
                    $('.dialog-box').remove();
                    if (index === 'btn-2') {
                        loading('show');
                        var userId =  localStorage.getItem('userId');
                        var url = getBaseUrl() + "api/users/"+ userId +"/shopping-cart/items/" + itemId;
                        getAxois(url,"DELETE",{}).then(function (response) {
                            loading('hide');
                            //console.log(JSON.stringify(response));
                            that.getShoppingCartList();
                        }).catch(function (error) {
                            loading('hide');
                            that.getShoppingCartList();
                            console.log(JSON.stringify(error));
                        });
                    }
                });

            },
            changeCurrency:function (currencyCode,price,index) {
                var url = getBaseUrl() + "/api/exchange/get-rate?from="+ currencyCode +"&to="+ localStorage.getItem('primaryCurrencyCode');
                // console.log(JSON.stringify(url));
                var that = this;
                getAxois(url, "GET", {}).then(function (response) {
                    that.listData[index].Product.DisplayOrder =  (price * response.data).toFixed(2);
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                    //messages($.i18n.prop('systemError'), 'error', 'top', 3);
                });
            },
            ctrlQuantity:function (index,i,type) {
                if(type ==='add' && this.listData[index][i].Product.ProductType !==2){
                    this.listData[index][i].Quantity ++;
                }else{
                    if(this.listData[index][i].Quantity >= 2){
                        this.listData[index][i].Quantity --;
                    }
                }
                this.unsetCheckbox(index,i);
            },
            inputQuantity:function(index,i){
                this.unsetCheckbox(index,i);
            },
            unsetCheckbox:function(index,i){
                var that = this;
                var prdId = this.listData[index][i].Product.Id;
                console.log('prdId '+prdId);
                for(i=0;i<this.checkedList.length;i++){
                    console.log(this.checkedList[i].ProductId);
                    if(this.checkedList[i].ProductId === prdId){
                        this.checkedList.splice(i,1);
                    }
                }
                that.checkedArr =[];
                var len = that.listData.length;
                for(l=0;l<len;l++){
                    var Lenght = that.listData[l].length;
                    for(u=0;u<Lenght;u++){
                        that.checkedArr.push({"StoreId":that.listData[l][u].StoreId,"ProductId":that.listData[l][u].Product.Id,"Quantity":that.listData[l][u].Quantity});
                    }
                }

            },
            openAddress:function(){
                if(this.defaultAddress){
                    openWindows('addressList','widget://html/business/address-list.html');
                }else{
                    openWindows('addAddress','widget://html/business/add-address.html', {
                        addressData: {}
                    });
                }
            },
            checkOut:function () {
                if(this.checkedList.length===0){
                    api.toast({
                        msg: $.i18n.prop('pleaseSelectProducts'),
                        duration: 2000,
                        location: 'bottom'
                    });
                    return false;
                }
                var userId =  localStorage.getItem('userId');
                var addressId = this.defaultAddress ? this.defaultAddress.Id: null;
                var that = this;
                var url = getBaseUrl() + "/api/v2/shopping-cart/review";
                var paramStr = {
                    "buyerId": userId,
                    "CurrencyCode":localStorage.getItem('primaryCurrencyCode'),
                    "ShippingAddress": { "AddressId" : addressId },
                    "ShoppingCartItems": this.checkedList,
                };
                //console.log(JSON.stringify(paramStr));
                loading('show');
                $('.ui-loading').removeClass('invisible');
                getAxois(url, "PUT", paramStr).then(function (response) {
                    loading('hide');
                    //console.log(JSON.stringify(response));
                    $('.ui-loading').addClass('invisible');
                    var address = that.defaultAddress ? JSON.stringify(that.defaultAddress) : null;
                    api.openWin({
                        name: 'checkoutPage',
                        url: 'checkout.html',
                        bounces:false,
                        pageParam:{
                            addressInfo: address,
                            checkoutInfo: JSON.stringify(response.data),
                            checkedList:that.checkedList
                        }
                    });
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error) + ' review API 报错');
                    //messages($.i18n.prop('systemError'), 'error', 'top', 3);
                });
            }
        }
    });
};



function closePage() {
    api.sendEvent({
        name: 'productDetailReload',
    });
    api.closeWin({
        name: 'shoppingCart',
    });
}
