apiready = function () {
    var currentpage = 0;
    backListener();
    api.setNavBarAttr({
        rightButtons: [{
            iconPath: 'widget://image/me-help.png',
            color: '#000000',
            fontSize: '16'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if(ret.type ==='right'){
            customerService();
        } else {
            back();
        }
    });

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 0
        }
    }, function (ret, err) {
        currentpage++;
        myPurchases.getPurchases();
    });

    api.addEventListener({
        name: 'reloadPurchaseList'
    }, function(ret, err) {
        currentpage = 0;
        myPurchases.getPurchases();
    });

    var pullDownRefresh = lan === 'zh' ? '下拉刷新' : 'Pull down to refresh';
    var refreshing = lan === 'zh' ? '刷新中...' : 'Refreshing...';
    var releaseRefresh = lan === 'zh' ? '放开开始刷新' : 'Release refresh';
    api.setRefreshHeaderInfo({
        loadingImg:'widget://image/refresh-logo.png',
        bgColor: '#fff',
        textColor: '#000',
        textDown: pullDownRefresh,
        textLoading: refreshing,
        showTime: false,
        textUp: releaseRefresh
    }, function (ret, err) {
        //结束下拉刷新状态
        api.refreshHeaderLoadDone();
        currentpage = 0;
        // myPurchases.purchasesData = [];
        $('#placeHolderLoad').show();
        myPurchases.getPurchases();
    });

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    api.addEventListener({
        name: 'dialogRemarkSuccess'
    }, function (ret, err) {
        myPurchases.$forceUpdate();
    });

    var myPurchases = new Vue({
        el: '#myPurchases',
        mounted: function () {
            this.getPurchases();
        },
        data: {
            currentType:'all',
            purchasesData: [],
            noPurchases:'',
            loading:true,
            message: MSG.payment,
            MSG:MSG
        },
        filters: {
            filterTime: filterTime,
            filterOrderStatus: filterOrderStatus,
            filterShippingStatus: filterShippingStatus
        },
        methods: {
            changeType:function(type){
                this.currentType = type;
                this.purchasesData = [];
                currentpage = 0;
                this.getPurchases();
            },
            getPurchases:function () {
                var that = this;
                var customerId = localStorage.getItem('userId');
                var currentPage = currentpage || 0;
                var url = getBaseUrl() + "api/v3/buyerorders?BuyerId="+ customerId +"&currentpage="+ currentPage +"&itemsperpage=8&orderStatus=" +this.currentType;
                loading('show');
                that.loading = true;
                getAxois(url,"GET",{}).then(function (response) {
                    //console.log(JSON.stringify(response));
                    that.loading = false;
                    loading('hide');
                    if(response.data.length!== 0){
                        if (currentPage === 0) {
                            that.purchasesData = response.data;
                            // console.log(JSON.stringify(response.data));
                        } else {
                            that.purchasesData = that.purchasesData.concat(response.data);
                        }
                        //console.log(JSON.stringify(that.purchasesData))
                    }else{
                        that.noPurchases = MSG.tips.noPurchases;
                    }
                }).catch(function (error) {
                    that.loading = false;
                    loading('hide');
                    console.log(JSON.stringify(error));
                    //messages($.i18n.prop('systemError'), 'error', 'top', 3);
                });
            },
            openDetail: function (orderId) {
                openTabLayout('purchaseDetail',this.message.orderDetail,'widget://html/business/purchase-detail.html',{
                    orderId:orderId,
                });
            },
            repay:function (id,guid) {
                openWindows('payment','widget://html/business/payment.html',{
                    orders:[{OrderId:id}],
                });
            },
            deleteOrder:function(orderId,orderGuid){
                confirmBox(MSG.tips.wantDelete, MSG.general.cancel, MSG.general.ok,'error'); //'Do you want delete this moment?'
                $('.dialog-box').find('button').on('click',function (e) {
                    var index = $(this).attr('id');
                    $('.dialog-box').remove();
                    if (index === 'btn-2') {
                        loading('show');
                        var url = getBaseUrl() + "api/orders/" + orderId + "/cancel";
                        getAxois(url,"DELETE",{}).then(function (response) {
                            loading('hide');
                            $('li#'+orderGuid).fadeOut();
                        }).catch(function (error) {
                            loading('hide');
                            console.log(JSON.stringify(error));
                            //messages($.i18n.prop('systemError'), 'error', 'top', 3);
                        });
                    }
                });
            },
            cancelOrder:function(orderId,Index){
                var that = this;
                confirmBox(MSG.tips.wantCancel, MSG.general.cancel, MSG.general.ok,'error'); //'Do you want delete this moment?'
                $('.dialog-box').find('button').on('click',function (e) {
                    var index = $(this).attr('id');
                    $('.dialog-box').remove();
                    if (index === 'btn-2') {
                        var paramStr = {
                            "orderId": orderId,
                            "orderStatus": "cancelled",
                        };
                        var url = getBaseUrl() + "/api/v2/orders/order-status";
                        that.purchasesData[Index].OrderStatus ="Cancelled";
                        loading('show');
                        getAxois(url,"PUT",paramStr).then(function (response) {
                            loading('hide');
                        }).catch(function (error) {
                            loading('hide');
                            console.log(JSON.stringify(error));
                            //messages($.i18n.prop('systemError'), 'error', 'top', 3);
                        });
                    }
                });
            },
            openPlace:function(index, $event){
                $event.stopPropagation();
                var Id,StoreName,AvatarUrl;
                var Item = this.purchasesData[index];
                if(Item.Seller){
                    Id = Item.Seller.Id;
                    StoreName = Item.Seller.Name;
                    AvatarUrl = Item.Seller.ThumbnailAvatarUrl;
                }else{
                    Id = Item.Items[0].Owner.Id;
                    StoreName = Item.Items[0].Owner.Name;
                    AvatarUrl = Item.Items[0].Owner.ThumbnailAvatarUrl;
                }
                openUserTycoonPlace(Id,StoreName,AvatarUrl);
            },
            copyNumber:function (Number) {
                var that = this;
                var clipBoard = api.require('clipBoard');
                clipBoard.set({
                    value: Number
                }, function (ret, err) {
                    if (ret) {
                        api.toast({
                            msg: that.message.copied,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            }
        }
    });
};

function customerService(){
    MQCustomerSerivce();
}
