var PaymentCurrency,Price,orders,orderGuid;
apiready = function () {
    orders = api.pageParam.orders;
    console.log(JSON.stringify(orders) + ' orders ');

    $('.addShopping-bar').height((api.safeArea.bottom + 60) + 'px');

    setPayment();
    $('input[name="paymentMethod"]:checked').val();
    $('input[name="paymentMethod"]').on('change',function () {
        if($(this).val() ==='payPal'){
            $('#selectCurrencyBox').removeClass('d-none');
            setPayment();
        }else{
            $('#selectCurrencyBox').addClass('d-none');
            setPayment();
        }
    });
    $('input[name="paymentCurrency"]').on('change',function () {
        setPayment();
    });
    function setPayment() {
        var code  = $('input[name="paymentMethod"]:checked').val() === 'payPal' ? $('input[name="paymentCurrency"]:checked').val() :'CNY';
        var paramStr = {
            "Orders" : orders,
            "CurrencyCode" : code
        };
        var url = getBaseUrl() + "api/v2/orders/payment-prices";
        loading('show');
        getAxois(url, "PUT", paramStr).then(function (response) {
            loading('hide');
            //console.log(JSON.stringify(response) + ' payment API ');
            var p = response.data;
            PaymentCurrency = p.CurrencyCode;
            Price = p.Total;

            $('#Price').html("<span>"+ p.CurrencyCode +"</span> <span>"+ Price.toFixed(2) +"</span>");

        }).catch(function (error) {
            loading('hide');
            console.log(JSON.stringify(error) + ' payment API 报错');
            //messages($.i18n.prop('systemError'), 'error', 'top', 3);
        });
    }

};
function payOrder() {
    var paymentMethod = $('input[name="paymentMethod"]:checked').val();
    switch (paymentMethod) {
        case "alipay":
            alipay();
            break;
        case "wechat":
            weixinPay();
            break;
        case "payPal":
            payPal();
            break;
    }

}

//支付宝付款
function alipay() {
    loading('show');
    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });
    var paramStr = {
        "Orders": orders,
        "Amount": Price.toFixed(2),
        "CurrencyCode": "CNY"
    };
    var url = getBaseUrl() + "api/v2/voics/payments/alipay?mode=prod";//  mode 参数 （dev/prod)
    var method = "PUT";
    // console.log(JSON.stringify(paramStr));
    $.when(postApi(url, method, paramStr, token, null)).done(function (data) {
        // console.log(JSON.stringify(data));
        loading('hide');
        if(data.response){
            var aliPayPlus = api.require('aliPayPlus');
            aliPayPlus.payOrder({
                orderInfo:data.response
            }, function(ret, err) {
                console.log(JSON.stringify(ret));
                if(ret.code == "9000"){
                    changeOrderStatus(ret,"alipay","CNY");
                }else{
                    paymentResult(ret,orders,"alipay",Price,"CNY");
                }
            });
        }
    });

}


//微信支付
function weixinPay() {
    loading('show');
    var paramStr = {
        "Amount": Price.toFixed(2),
        "CurrencyCode": "CNY",
        "Orders":orders,
        "TradeType": "APP"
    };
    // console.log(JSON.stringify(paramStr));
    var url = getNodeApiUrl() + "pay/wechat";
    getNodeAxois(url, "POST", paramStr).then(function (response) {
        loading('hide');
        // console.log(JSON.stringify(response.data));
        var data = response.data.wxpay;
        var wxPay = api.require('wxPay');
        wxPay.payOrder({
            apiKey: data.appid,
            orderId: data.prepay_id,
            mchId: data.mch_id,
            nonceStr: data.nonce_str,
            timeStamp: data.timestamp,
            sign: data.sign
        }, function(ret, err) {
            if (ret.status) {
                changeOrderStatus(ret,"wechatpay","CNY");  //
            } else {
                paymentResult(ret,orders,"wechatpay",Price,"CNY");
            }
        });
    }).catch(function (error) {
        loading('hide');
        console.log(JSON.stringify(error) + '微信支付报错');
        //messages($.i18n.prop('systemError'), 'error', 'top', 3);
    });
}


//payPal付款
function payPal() {
    var paypal = api.require('paypal');
    var orderNumber ='';
    for(i=0;i<orders.length;i++){
        orderNumber = orderNumber + orders[i].OrderNumber +' ';
    }
    paypal.pay({
        currency: PaymentCurrency,
        price: Price.toFixed(2),
        description: $.i18n.prop("orderNumber") + " " + orderNumber,
        mode: 'production' //production or sandbox
    }, function(ret) {
        if(ret.state === "success"){
            changeOrderStatus(ret,"paypal",PaymentCurrency);
        }else{
            paymentResult(ret,orders,"paypal",Price,PaymentCurrency);
        }

    });

}

function changeOrderStatus(ret,paymentMethod,CurrencyCode) {

    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });
    var paramStr = {
        "PaymentMethod" : paymentMethod,
        "Amount" :Price.toFixed(2),
        "CurrencyCode" : CurrencyCode,
        "Data":null,
        "Orders":orders
    };
    console.log(JSON.stringify(paramStr));
    var url = getBaseUrl() + "/api/v2/orders/verify";
    var method = "PUT";
    var contentType = "application/json";
    $.when(postApi(url, method, paramStr, token, contentType)).done(function (data) {
         console.log(JSON.stringify(data));
         paymentResult(ret,orders,paymentMethod,Price,"CNY");
    });
}

function paymentResult(paymentResult,orders,paymentMethod,Price,PaymentCurrency) {
    api.openWin({
        name: 'paymentResult',
        url: 'payment-result.html',
        bounces:false,
        animation:{
            type:"movein",
            subType:"from_right"
        },
        pageParam: {
            orders:orders,
            paymentResult:paymentResult,
            paymentMethod:paymentMethod,
            price:Price,
            paymentCurrency:PaymentCurrency
        }
    });
}
