apiready = function () {
    var downloadManager = api.require('downloadManager');
    // downloadManager.remove({
    //     ids: [
    //         '4',
    //         '10',
    //         '9'
    //     ]
    // }, function(ret, err) {
    //     if (ret) {
    //         alert(JSON.stringify(ret));
    //     } else {
    //         alert(JSON.stringify(err));
    //     }
    // });
    backListener();
    api.setNavBarAttr({
        rightButtons: [{
            iconPath: 'widget://image/me-help.png',
            color: '#000000',
            fontSize: '16'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function (ret, err) {
        if (ret.type === 'right') {
            MQCustomerSerivce();
        } else {
            back();
        }
    });
    api.addEventListener({
        name: 'reloadPurchaseDetail'
    }, function (ret, err) {
        purchaseDetail.getPurchaseDetail();
    });
    api.setWinAttr({
        bounces: false,
    });

    api.addEventListener({
        name: 'updateOrderAssess'
    }, function (){
        purchaseDetail.getAssess();
    });

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/' + lan + '.json'
    }));

    $('[data-replace-text]').each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.general[k]);
    });

    api.addEventListener({
        name: 'dialogRemarkSuccess'
    }, function (ret, err) {
        purchaseDetail.$forceUpdate();
    });

    var purchaseDetail = new Vue({
        el: '#purchaseDetail',
        mounted: function () {
            this.getPurchaseDetail();
            this.getAssess();
        },
        data: {
            isLoading: true,
            productType: 1,     // 1. 实体产品
            repData: {},
            AddressInfo: null,
            ShippingInfo: [],
            listData: [],
            orderNumber: '',
            orderDate: '',
            orderTime: '',
            OrderStatus: '',
            PaymentStatus: '',
            userInfo: [],
            sellerName: '',
            sellerThumbnail: '',
            Status: '',
            assessInfo: null,
            orderId: api.pageParam.orderId,
            message: MSG.payment,
            commonLocale: MSG.assess,
            picUrls: [],
            Comment: false,
            preSaleStatus:'',
        },
        filters: {
            filterSubString: filterSubString,
            fixed2: function (value) {
                return Number(value).toFixed(2);
            },
            returnStatus: function (value) {
                switch (value) {
                    case "Approved for refund":
                        return MSG.general.approved;
                    case "Rejected":
                        return MSG.general.rejected;
                    case "Complete":
                        return MSG.payment.transactionComplete;
                    case "Cancelled":
                        return MSG.payment.transactionCancelled;
                }
            },
            filterOrderStatus: filterOrderStatus,
            filterShippingStatus: filterShippingStatus
        },
        methods: {
            playPicture: function(innerIndex, pictures) {
                var pics = [];
                $.map(pictures, function (item, index) {
                    pics.push(item.DownloadUrl);
                });
                var UIPhotoViewer = api.require('UIPhotoViewer');
                UIPhotoViewer.open({
                    images: pics,
                    placeholderImg: 'widget://image/lost_images.jpg',
                    bgColor: '#000',
                    activeIndex: innerIndex,
                    zoomEnabled: true,
                    gestureClose: true
                }, function(Ret, err) {
                    if (Ret.eventType === 'click' ) {
                        UIPhotoViewer.close();
                    }
                });
            },
            playVideo: function(url) {
                playVideo(url);
            },
            getAssess: function (){
                apiAssess.get("/v1/api/evaluate/" + api.pageParam.orderId).done(function (rep) {
                    if (rep.code === 0) {
                        this.assessInfo = rep.data;
                    } else if (rep.code === -1) {

                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }.bind(this));
            },
            goCommon: function(id, disabled) {
                var title = this.commonLocale.addCommon;
                if (disabled){
                    title = this.commonLocale.myAssessTitle;
                }
                openTabLayout('addCommon', title, 'widget://html/products/add-assess.html', {
                    orderId: id,
                    disabled: disabled,
                    seller: this.repData.Seller,
                    assessInfo: this.assessInfo
                });
            },
            openProdDetail: function (item) {
                var prodId = item.Product.Id;
                var param = {
                    prodId: prodId,
                    userInfo: JSON.stringify(this.userInfo),
                    countryCode: this.userInfo.RegisterCountryCode,
                    tweebaaTag: ''
                };
                openTabLayout('productDetail', '', 'widget://html/products/product-detail.html', param);
            },
            getPurchaseDetail: function () {
                var that = this;
                var url = getBaseUrl() + 'api/v3/orderdetail?OrderId=' + that.orderId;
                this.isLoading = true;
                getAxois(url, "GET", '').then(function (response) {
                    that.isLoading = false;
                    that.repData = response.data;
                    //console.log(JSON.stringify(response.data.Seller.Name));
                    that.AddressInfo = response.data.ShippingAddress;
                    that.ShippingInfo = response.data.ShippingInfo;
                    that.orderNumber = response.data.CustomOrderNumber;
                    that.orderDate = moment.utc(response.data.CreatedOnUtc).local().format('YYYY-MM-DD');
                    that.orderTime = moment.utc(response.data.CreatedOnUtc).local().format('HH:mm:ss');
                    that.listData = response.data.Items;
                    that.productType = that.listData[0].Product.ProductType;
                    that.userInfo = response.data.Items[0].Owner;
                    if (userRemarkService.has(response.data.Seller.Id) === true) {
                        that.sellerName = response.data.Seller.Name + ' (' + userRemarkService.get(response.data.Seller.Id, response.data.Seller.Name) + ')';
                    } else {
                        that.sellerName = response.data.Seller.Name;
                    }
                    that.sellerThumbnail = response.data.Seller.ThumbnailAvatarUrl;
                    that.OrderStatus = response.data.OrderStatus;
                    that.PaymentStatus = response.data.PaymentStatus;
                    that.preSaleStatus = that.listData[0].Product.PreSaleInfo ? that.listData[0].Product.PreSaleInfo.StatusCode :'';
                    if (response.data.Comment){
                        this.getAssess();
                    }

                    // 判断是否有申诉，如果有，把退款原因提取出来
                    if (that.repData.AppealInfo && that.repData.AppealInfo.AppealComment) {
                        var comment = that.repData.AppealInfo.AppealComment;
                        var indexDivide = comment.indexOf(']');
                        that.repData.AppealInfo.Reasons = comment.substring(1, indexDivide);
                        that.repData.AppealInfo.Desc = comment.substring(indexDivide + 1);
                        that._initPics();
                    }

                    //console.log(JSON.stringify(response.data));
                }).catch(function (error) {
                    that.isLoading = false;
                    console.log(JSON.stringify(error) + ' review API 报错');
                    //messages($.i18n.prop('systemError'), 'error', 'top', 3);
                });
            },
            cancelOrder:function(){
                var that = this;
                // 二次确认
                confirmBox(MSG.payment.tipCancel, MSG.general.cancel, MSG.general.ok);
                $('.dialog-box').find('button').on('click',function (e) {
                    var index = $(this).attr('id');
                    //console.log(index);
                    $('.dialog-box').remove();
                    if (index === 'btn-2') {
                        var url = getBaseUrl() + 'api/v1/presale';
                        var param = {
                            "OrderId":that.repData.Id,
                            "OrderGuid":that.repData.OrderGuid,
                            "BuyerId":localStorage.getItem("userId"),
                            "Buyerguid":localStorage.getItem("userGuid"),
                            "ProductId":that.repData.Items[0].Product.Id,
                            "ProductGuid":that.repData.Items[0].Product.ProductGuid
                        };
                        getAxois(url, "PUT", param).then(function (response) {
                            console.log(JSON.stringify(response));
                            if(response.data.Code){
                                back()
                            }
                        }).catch(function (error) {
                            that.isLoading = false;
                            console.log(JSON.stringify(error) + ' review API 报错');

                        });
                    }
                });
            },
            checkShippingStatus: function () {
                var param = {
                    shippingInfo: this.ShippingInfo,
                    addressInfo: this.AddressInfo
                };
                openTabLayout('tracking', '', 'widget://html/business/show-tracking.html', param);
            },
            openDetail: function (prodId, productSource) {
                var tweebaaTag = productSource === 1 ? 'tweebaa-tag' : '';
                var param = {
                    prodId: prodId,
                    userInfo: JSON.stringify(this.userInfo),
                    countryCode: this.userInfo.RegisterCountryCode,
                    tweebaaTag: tweebaaTag
                };
                //console.log(param);
                openTabLayout('productDetail', '', 'widget://html/products/product-detail.html', param);
            },
            customerService: function () {
                MQCustomerSerivce();
            },
            openDigitalDownload: function () {
                var that = this;
                var url = that.listData[0].Download.DownloadUrl;
                //console.log(url);
                var fileType;
                var prod = this.repData.Items[0].Product;
                var prodName = prod.Name;
                var prodId = prod.Id;
                var pic = prod.FeaturedPicture.ThumbnailUrl;
                if (url) {
                    var videos = ['mp4', 'mpg', 'mov', 'wmv', 'm3u8'];
                    var pics = ['jpg', 'jpeg', 'raw', 'png', 'bmp'];
                    var audios = ['amr', 'wav', 'mp3', 'm4a'];
                    var text = ['txt', 'doc', 'docx', 'xlsx', 'xls', 'pdf'];
                    var links = ['com', 'cn', 'io', 'pro'];

                    var key = url.lastIndexOf(".");
                    var xName = (url.substr(key + 1)).toLowerCase();

                    if (videos.indexOf(xName) !== -1) {
                        fileType = 'video'
                    } else if (pics.indexOf(xName) !== -1) {
                        fileType = 'image'
                    } else if (audios.indexOf(xName) !== -1) {
                        fileType = 'audios'
                    } else if (text.indexOf(xName) !== -1) {
                        fileType = 'text';
                    } else {
                        fileType = 'other'
                    }
                }

                if (fileType === 'audios') {

                    downloadManager.query({}, function (ret, err) {
                        if (ret) {
                            var hasDownload, downloadData;
                            console.log(JSON.stringify(ret));
                            if (!ret.data) {
                                downloadData = [];
                            } else {
                                downloadData = ret.data;
                            }

                            for (var i = 0; i < downloadData.length; i++) {
                                if (downloadData[i].title.split('##')[1] == prodId) {
                                    hasDownload = downloadData[i];
                                    break;
                                }
                            }

                            setTimeout(function () {
                                if (hasDownload) {
                                    openDigitalProd(hasDownload.savePath, fileType, prodName, prodId, pic);
                                } else {
                                    dialog({
                                        title: '',
                                        content: MSG.tips.needDownload,
                                        primaryText: MSG.general.download,
                                        asideText: '',
                                        onClose: "show",
                                        onWarning: function () {
                                        },
                                        onPrimary: function () {
                                            downloadProdManager(url, prodName, prodId, xName, pic, fileType, true);
                                        }
                                    });

                                }
                            })
                        }
                    });
                } else if (fileType === 'video') {
                    url = url.split('/playlist.m3u8')[0];
                    openDigitalProd(url, fileType, prodName, prodId, pic);
                } else if (fileType === 'text') {
                    if (xName === 'pdf') {
                        openDigitalProd(url, 'pdf', prodName, prodId, pic);
                    } else {
                        openDigitalProd(url, 'other', prodName, prodId, pic, xName);
                    }
                } else if (fileType === 'image') {
                    openDigitalProd(url, fileType, prodName, prodId, pic);
                } else {
                    api.openApp({
                        iosUrl: url,
                        androidPkg: 'android.intent.action.VIEW',
                        mimeType: 'text/html',
                        uri: url
                    });
                }

            },
            openPlace: function ($event) {
                $event.stopPropagation();
                var seller = this.repData.Seller;
                openUserTycoonPlace(seller.Id, seller.Name, seller.ThumbnailAvatarUrl);
            },
            copyNumber: function (Number, type) {
                var that = this;
                var clipBoard = api.require('clipBoard');
                clipBoard.set({
                    value: Number
                }, function (ret, err) {
                    if (ret) {
                        api.toast({
                            msg: type === 'orderNum' ? that.message.orderNumberCopied : that.message.trackingNumberCopied,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            },
            copyDigitalDownloadLink: function () {
                var that = this;
                var clipBoard = api.require('clipBoard');
                clipBoard.set({
                    value: that.listData[0].Download.DownloadUrl
                }, function (ret, err) {
                    if (ret) {
                        api.toast({
                            msg: MSG.tips.copied,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            },
            openReturn: function (index, prodId) {
                var that = this;
                var d = this.listData[index];
                api.openWin({
                    name: 'returnExchange',
                    url: 'return-exchange.html',
                    pageParam: {
                        orderId: that.orderId,
                        prodId: prodId,
                        orderNumber: that.orderNumber,
                        d: JSON.stringify(d),
                    }
                });
            },
            /**
             * 确定收货
             */
            confirmReceived: function (sellerUserName) {
                var that = this;
                confirmBox(that.message.confirmReceivedTip, MSG.general.cancel, MSG.general.ok);
                $('.dialog-box').find('button').on('click', function (e) {
                    var index = $(this).attr('id');
                    $('.dialog-box').remove();
                    if (index === 'btn-2') {
                        loading('show');
                        var CustomerId = localStorage.getItem('userId');
                        var url = getBaseUrl() + "api/v3/order/settlement?CustomerId=" + CustomerId + "&OrderId=" + that.orderId;
                        getAxois(url, "POST", {}).then(function (response) {
                            loading('hide');
                            if (response.data.Code === 0) {
                                api.toast({
                                    msg: MSG.tips.success,
                                    duration: 2000,
                                    location: 'middle'
                                });
                                that.getPurchaseDetail();
                                api.sendEvent({
                                    name: 'reloadPurchaseList'
                                });
                                // 通知卖家收到货物
                                postNotify(sellerUserName, MSG_TYPE_ORDER, {
                                    Type: 'orderConfirmed',
                                    AvatarUrl: localStorage.getItem('thumbnail'),
                                    StoreName: localStorage.getItem('storename'),
                                    UserId: localStorage.getItem('userId'),
                                    OrderId: api.pageParam.orderId,
                                });
                            }
                        }).catch(function (error) {
                            loading('hide');
                            console.log(JSON.stringify(error));
                            messages(MSG.tips.systemError, 'error', 'top', 3);
                        });
                    }
                });
            },
            /**
             * 联系卖家
             */
            chatToOwner: function () {
                var owner = this.repData.Seller;
                var userId = owner.UserName + '@new';
                openChatPage({
                    targetId: userId,
                    userId: owner.Id,
                    userName: owner.Name,
                    userPortrait: owner.ThumbnailAvatarUrl,
                    conversationType: 'PRIVATE',
                    isTop: false
                });
            },
            /**
             * 申请修改地址
             * @param OrderId
             */
            openUpdateAddress: function (OrderId) {
                var CustomerId = localStorage.getItem('userId');
                var CustomerGuid = localStorage.getItem('userGuid');
                openTabLayout('updateOrderAddress', this.message.updateAddress, 'widget://html/products/order-update-address.html', {
                    OrderId: OrderId,
                    CustomerId: CustomerId,
                    CustomerGuid: CustomerGuid
                });
            },
            /**
             * 申请退款
             * @param OrderId
             * @param SellerUserName
             */
            openRefund: function (OrderId, SellerUserName) {
                var CustomerId = localStorage.getItem('userId');
                var CustomerGuid = localStorage.getItem('userGuid');
                openTabLayout('updateOrderAddress', this.message.refund, 'widget://html/products/order-enter-refund.html', {
                    OrderId: OrderId,
                    CustomerId: CustomerId,
                    CustomerGuid: CustomerGuid,
                    UserName: SellerUserName
                });
            },
            /**
             * 取消申请
             * @param orderId
             * @param appealId
             * @param sellerUserName
             */
            cancelApply: function (orderId, appealId, sellerUserName) {
                var that = this;
                // 二次确认
                confirmBox(this.message.cancelConfirm, MSG.general.cancel, MSG.general.ok);
                $('.dialog-box').find('button').on('click', function (e) {
                    var index = $(this).attr('id');
                    $('.dialog-box').remove();
                    if (index === 'btn-2') {
                        loading('show');
                        var CustomerId = localStorage.getItem('userId');
                        var CustomerGuid = localStorage.getItem('userGuid');
                        var url = getBaseUrl() + "api/v1/appeal/cancel";
                        getAxois(url, "POST", {
                            AppealId: appealId,
                            CustomerId: CustomerId,
                            CustomerGuid: CustomerGuid,
                            OrderId: orderId,
                            AppealReasonCode: 'AppealCancel'
                        }).then(function (response) {
                            loading('hide');
                            if (response.data.Code === 0) {
                                api.toast({
                                    msg: MSG.tips.success,
                                    duration: 2000,
                                    location: 'middle'
                                });
                                that.getPurchaseDetail();
                                api.sendEvent({
                                    name: 'reloadPurchaseList'
                                });
                                // 通知买家退货申请取消
                                postNotify(sellerUserName, MSG_TYPE_ORDER, {
                                    Type: 'orderApplyRefundCancel',
                                    AvatarUrl: localStorage.getItem('thumbnail'),
                                    StoreName: localStorage.getItem('storename'),
                                    OrderId: api.pageParam.orderId,
                                    UserId: localStorage.getItem('userId'),
                                });
                            } else {
                                api.toast({
                                    msg: response.data.ExceptionMessage,
                                    duration: 2000,
                                    location: 'middle'
                                });
                            }
                        }).catch(function (error) {
                            loading('hide');
                            console.log(JSON.stringify(error));
                            messages(MSG.tips.systemError, 'error', 'top', 3);
                        });
                    }
                });
            },
            /**
             * 查看物流单号
             * @param orderId
             * @param shippingInfo
             */
            openTracking: function (orderId, shippingInfo) {
                openTabLayout('orderReadTracking', this.message.viewTracking, 'widget://html/products/order-read-tracking.html', {
                    orderId: orderId,
                    shippingInfo: shippingInfo
                });
            },
            /**
             * 查看修改地址
             * @param comment
             */
            openViewAddress: function (comment) {
                openTabLayout('orderViewAddress', this.message.viewAddress, 'widget://html/products/order-view-address.html', {
                    comment: comment
                });
            },
            openRefundView: function (AppealInfo) {
                openTabLayout('orderViewRefund', this.message.refund, 'widget://html/products/order-view-refund.html', {
                    listData: this.listData,
                    AppealInfo: AppealInfo
                });
            },
            _initPics: function () {
                var appealPictures = this.repData.AppealInfo.AppealPictures;
                if (appealPictures) {
                    var picUrls = [];
                    for (var i = 0, len = appealPictures.length; i < len; i++) {
                        picUrls.push(appealPictures[i].DownloadUrl);
                    }
                    this.picUrls = picUrls;
                }
            }

        }
    });

};

