
apiready = function () {
    var orderId = api.pageParam.orderId;
    var prodId = api.pageParam.prodId;
    var orderNumber = api.pageParam.orderNumber;
    var d = JSON.parse(api.pageParam.d);

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    $('.payment [data-replace-text]').each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.payment[k]);
    });

    $('.general [data-replace-text]').each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.general[k]);
    });

    autosize(document.querySelectorAll('textarea'));
    $('#fullDescription').on('input', function () {
        var len = $(this).val().length;
        $('.text-count').attr('data-count', len);
    });

    var myReturn = new Vue({
        el: '#myReturn',
        data: {
            returnData:[],
            purchasesData:[],
            returnType:[],
            returnReason:[],
            service:'',
            reason:'',
            Quantity:'',
            orderNumber:orderNumber,
            Data:d,
        },
        mounted: function () {
             this.getService();
             this.getReason();
        },
        filters: {
            replaceQuotation: function (value) {
                if (value) {
                    return value.replace(/"/g, "");
                }
            },
            fixed2: function (value) {
                return Number(value).toFixed(2);
            },
            formatTime: function (value) {
                return moment.utc(value).local().format('YYYY-MM-DD HH:mm');
            },
            setStatus: function (value) {
                switch (value) {
                    case "Processing":
                        return MSG.payment.transactionProcessing;

                    case "Pending":
                        return MSG.payment.transactionPending;

                    case "Complete":
                        return MSG.payment.transactionComplete;

                    case "Cancelled":
                        return MSG.payment.transactionCancelled;
                }
            },
        },
        methods: {
            getService:function(){
                var that = this;
                var url = getBaseUrl() + "api/return/types?lang=" +lan;
                loading('show');
                getAxois(url, "GET", {}).then(function (response)  {
                    if (response.data.length !== 0) {
                        that.returnType = response.data;
                    }
                    loading('hide');
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            getReason:function(){
                var that = this;
                var url = getBaseUrl() + "api/return/reasons?lang=" +lan;
                loading('show');
                getAxois(url, "GET", {}).then(function (response)  {
                    if (response.data.length !== 0) {
                        that.returnReason = response.data;
                    }
                    loading('hide');
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            getPic:function(){
                actionSheet([
                    {
                        text: MSG.general.takePicture,
                        callback: function () {
                            useCamera();
                        }
                    },
                    {
                        text: MSG.general.library,
                        callback: function () {
                            selectImagesFromAlbum();
                        }
                    }
                ]);
            },
            createReturn:function(){
                var that = this;
                var userId = localStorage.getItem('userId');
                var Quantity = Number($("#Quantity").val());
                var remark =$("#returnDescription").val();
                var url = getBaseUrl() + "api/return/users/" +userId+ "/create-return";
                var LanguageId;
                if (lan === "en"){
                    LanguageId = 1;
                }else{
                    LanguageId = 2;
                }
                var paramStr = {
                    "OrderId": orderId,
                    "ProductId": prodId,
                    "Quantity": Quantity,
                    "VideoUrl": '',
                    "TypeCode": that.service,
                    "Description": remark,
                    "ReasonId": that.reason,
                    "Pictures": picArray,
                    "LanguageId":LanguageId
                };

                loading('show');
                getAxois(url, "POST", paramStr).then(function (response) {
                    loading('hide');
                    if(response.status === 200){
                        setTimeout(function () {
                            back();
                        },2000);

                        api.toast({
                            msg: MSG.tips.returnSuccess,
                            duration: 2000,
                            location: 'middle'
                        });

                    }
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
        }
    });

};

