apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    api.setNavBarAttr({
        rightButtons: [{
            text: MSG.tiv.whatIsTiv,
            color:'#4578F3',
            fontSize:'12'
        }]
    });

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 300
        }
    }, function (ret, err) {
        if(!TivStatement.isLoading && TivStatement.hasTouchBottom === false){
            TivStatement.getTIVStatement();
        }
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if(ret.type ==='right'){
            var text = lan ==="zh" ? "什么是TiV？" : "What is TiV?";
            MQCustomerSerivce(text);
        }else{
            back();
        }
    });
    api.sendEvent({
        name: 'workplaceReload',
        extra: {
            type: 'tiv',
        }
    });
    var TivStatement = new Vue({
        el: '#TivStatement',
        mounted: function () {
            this.getTiv();
            this.getTIVStatement();
            // this.getTivSum();
        },
        data: {
            isLoading: true,
            hasTouchBottom: false,
            listData: [],
            CompletedTotal:'',
            PendingTotal:'--',
            CancelledTotal:'--',
            nextPageId: null,
            // collectPage:false,
            // tweebucks:0,
            // collectedTweebucks:0,
            userId :localStorage.getItem('userId'),
            showToDate:moment().format('YYYY-MM-DD'),
            fromDate:moment().subtract(30, 'days').format('YYYY-MM-DD'),
            toDate:moment().utc().format('YYYY-MM-DD'),
            message:MSG.tiv
        },
        filters: {
            formatTime:function (value) {
                return moment(+value).local().format('MM-DD HH:mm:ss');
            },
            fixed:function (value) {
                if (value) {
                    value = value + '';
                    if (value.indexOf('.') >= 0) {
                        var arrs = value.split('.');
                        var len = arrs[1].length;
                        if (len > 3) {
                            return Number(value).toFixed(len);
                        }
                    }
                    return Number(value).toFixed(4);
                }
            },
        },
        methods:{
            getTiv:function () {
                var that = this;

                apiTiv.get("/api/v1/tiv", {}).done(function (rep) {
                    if (rep.code === 0) {
                        that.CompletedTotal = rep.data.completedTiv;
                    } else {
                        api.toast({
                            msg: rep.responseText,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    console.error("[" + api.deviceName + "] getNotifyUnreads: " + JSON.stringify(err));
                });
            },
            getTIVStatement:function(){
                var that = this;
                loading('show');
                this.isLoading = true;

                var param = {
                    startedAtUtc: moment(that.fromDate).utc().format('YYYY-MM-DD'),
                    endedAtUtc: moment(that.toDate).format('YYYY-MM-DD'),
                    id: this.nextPageId,
                    pageSize: DEFAULT_PAGE_SIZE
                };
                apiTiv.get("/api/v1/tiv/logs", param).done(function (rep) {
                    if (rep.code === 0) {
                        loading('hide');
                        that.isLoading = false;
                        var data = rep.data.data;
                        if (data.content.length !== 0) {
                            that.listData = that.listData.concat(data.content);
                            that.nextPageId = data.nextPageId;
                            if (data.hasNext === false) {
                                that.hasTouchBottom = true;
                            }
                        } else {
                            that.hasTouchBottom = true;
                        }
                    } else {
                        loading('hide');
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    console.error("[" + api.deviceName + "] getNotifyUnreads: " + JSON.stringify(err));
                });
            },
            /**
             * 获取累计可转化的T豆
             */
            // getTivSum:function(){
            //     var that = this;
            //     var url = getBaseUrl() + "api/v1/tiv2tweebucksum?UserId="+ this.userId;
            //     getAxois(url,"GET",{}).then(function (response) {
            //         //console.log(JSON.stringify(response));
            //         loading('hide');
            //         that.tweebucks = response.data.Data.TweebuckPending;
            //     }).catch(function (error) {
            //         loading('hide');
            //         console.log(JSON.stringify(error));
            //     });
            // },
            // collectTweebucks: function(){
            //     var that = this;
            //     if(this.tweebucks >= 0.1){
            //         loading('show');
            //         var url = getBaseUrl() + "api/v1/tiv2tweebucks?UserId="+ this.userId;
            //         getAxois(url,"POST",{}).then(function (response) {
            //             //console.log(JSON.stringify(response));
            //             loading('hide');
            //             that.collectPage = true;
            //             that.collectedTweebucks = that.tweebucks;
            //             that.tweebucks = 0;
            //         }).catch(function (error) {
            //             loading('hide');
            //             console.log(JSON.stringify(error));
            //         });
            //     }else{
            //         api.toast({
            //             msg: that.message.notEnough,
            //             duration: 2000,
            //             location: 'middle'
            //         });
            //     }
            // },
            // closeCollectPage:function($event){
            //     if($event){
            //         $event.stopPropagation();
            //         this.collectPage = false;
            //     }
            // },
            // openTweebucks:function($event){
            //     openTabLayout('tweebuck',this.message.Tweebank,'widget://html/tweebucks/tweebuck.html');
            // },
            openDatePicker:function(type){
                var that =this;
                var maxD,minD;
                if(type ==='from'){
                    maxD = moment(that.toDate).subtract(1, 'days').format('YYYY-MM-DD');
                    minD = moment(that.toDate).subtract(1, 'year').format('YYYY-MM-DD');
                }else{
                    maxD = moment().format('YYYY-MM-DD');
                    minD = moment(that.fromDate).add(1, 'days').format('YYYY-MM-DD');
                }
                api.openPicker({
                    type: 'date',
                    date: type ==='from'? that.fromDate:that.toDate,
                    maxDate:maxD,
                    minDate:minD,
                    title: ''
                }, function(ret, err) {
                    if (ret) {
                        var m = ret.month<10 ?'0'+ret.month:ret.month;
                        var d = ret.day<10 ?'0'+ret.day:ret.day;
                        var t = ret.year +'-'+ m +'-'+d;
                        if(type === 'from'){
                            if(moment(t).isBefore(moment(that.toDate))){
                                that.fromDate = t;
                                that.getTIVStatement();
                            }
                        }else{
                            if(moment(t).isSame(moment())|| moment(t).isBefore(moment())){
                                that.toDate = t;
                                that.getTIVStatement();
                            }
                        }

                    }
                });
            },
            opemSummary:function(){
                openTabLayout('tiv-summary',this.message.summary,'widget://html/business/tiv-summary.html')
            },
            openTivInfo:function () {
                openTabLayout('productUploadVideoPage','','widget://html/access/faq-detail.html',{
                    id:10001
                })
            }
        }
    });

};
