var TEST_CN_OLD_HOST = 'http://47.101.219.248';
var TEST_COM_NEW_HOST = 'https://manage.tweebaa-stg.com';

var SERVER_HOSTS = {
    dev: false,
    BASE: {
        PROD: 'http://njuser2.tweebaa.cn/',
        // PROD: 'https://api.tweebaa.cn/',
        TEST: 'http://api-dev.tycoonplace.com/'
    },
    SHARE_H5: {
        TEST: 'http://47.101.219.248:30003',
        TEST_COM: 'http://47.101.219.248:30003',
        PROD: 'https://tweebaa.com/space'
    },
    MEDIA_UPLOAD: {
        PROD_CN: 'https://upload.tweebaa.cn',
        PROD_COM: 'https://media.tweebaa.com',
        TEST: 'http://upload.tweebaa.cn:8125'
    },
    USER_CENTER: {
        TEST: TEST_CN_OLD_HOST + ':8101',
        TEST_COM: TEST_COM_NEW_HOST + '/user-api',
        // PROD: 'http://47.100.58.9:8101',
        PROD: 'https://user.tweebaa.cn',
    },
    TASK: {
        TEST: TEST_CN_OLD_HOST + ':8100',
        TEST_COM: TEST_COM_NEW_HOST+ '/task-api',
        // PROD: 'http://47.100.58.9:8100',
        PROD: 'https://manage.tweebaa.cn/task-api'
    },
    SUGGEST: {
        TEST: TEST_CN_OLD_HOST + ':8120',
        TEST_COM: TEST_COM_NEW_HOST+ '/suggest-api',
        // PROD: 'http://106.15.126.244:8120',
        PROD: 'https://manage.tweebaa.cn/suggest-api'
    },
    NOTIFICATION: {
        TEST: TEST_CN_OLD_HOST + ':8122',
        TEST_COM: TEST_COM_NEW_HOST+ '/notification-api',
        // PROD: 'http://106.15.126.244:8122',
        PROD: 'https://manage.tweebaa.cn/notification-api',
        // SOCKET: 'ws://47.101.219.248:8122'
        SOCKET_TEST: 'ws://47.101.219.248:8122',
        SOCKET_TEST_COM: 'wss://manage.tweebaa-stg.com/socket',
        SOCKET_PROD: 'wss://manage.tweebaa.cn/socket'
    },
    TIV: {
        TEST: TEST_CN_OLD_HOST + ':8130',
        TEST_COM: TEST_COM_NEW_HOST+ '/tiv-api',
        // PROD: '',
        PROD: 'https://manage.tweebaa.cn/tiv-api'
    },
    TRACKING: {
        TEST: TEST_CN_OLD_HOST + ':8127',
        TEST_COM: TEST_COM_NEW_HOST+ '/tracking-api',
        // PROD: '',
        PROD: 'https://manage.tweebaa.cn/tracking-api'
    },
    ASSESS: {
        TEST: TEST_CN_OLD_HOST + ':10005',
        TEST_COM: TEST_COM_NEW_HOST+ '/assess-api',
        PROD: 'https://manage.tweebaa.cn/assess-api',
    },
    PRESALE: {
        TEST: TEST_CN_OLD_HOST + ':10007',
        TEST_COM: TEST_COM_NEW_HOST+ '/presale-api',
        PROD: 'https://manage.tweebaa.cn/presale-api',
    },
    MOMENT: {
        TEST: TEST_CN_OLD_HOST + ':8131',
        TEST_COM: TEST_COM_NEW_HOST+ '/moment-api',
        // http://106.14.38.208:8131
        PROD: 'https://manage.tweebaa.cn/moment-api',
    },
    RECOMMEND: {
        TEST: TEST_CN_OLD_HOST + ':10017',
        TEST_COM: TEST_CN_OLD_HOST+ ':10017',
        // http://106.14.38.208:8131
        PROD: 'https://manage.tweebaa.cn/recommend-api',
    },
    FREE: {
        TEST: TEST_CN_OLD_HOST + ':8132',
        TEST_COM: TEST_COM_NEW_HOST+ '/free-api',
        PROD: 'https://manage.tweebaa.cn/free-api',
    },
    TWEELOG: {
        TEST: TEST_CN_OLD_HOST + ':10012',
        TEST_COM: TEST_CN_OLD_HOST + ':10012',
        // TEST_COM: TEST_COM_NEW_HOST+ '/tweelog-api',
        // PROD: 'http://106.14.38.208:10012'
       PROD: 'https://manage.tweebaa.cn/tweelog-api',
    },
};

var VIDEO_MAX_SIZE = 209715200; // 视频最大上传200MB

var REM_BASE_FONTSIZE = 62.5;
var REM_ANDROID_FONTSIZE = 62.5;  // 安卓缩小系数

var HEADER_HEIGHT = 48;     // 顶部导航的高度

var VERIFY_COUNT_SECONDS = 60;  // 验证码计数

var DEFAULT_PAGE_SIZE = 10;  // 默认一页20条记录

var TWEELOG_PAGE_SIZE = 50; // 黄页项目默认分页数

var CONNECTION_TYPE = ['WIFI', '2G', '3G', '4G', '5G'];

// 账户密码正确性
var REG_PATTERN_PASSWORD = /^(?=.*\d)(?=.*[a-zA-Z])[\da-zA-Z~!@#\$%\^&\*\(\)_+]{6,20}$/;

// 微信分享内容过滤
var REG_SHARE_FILTER = /[↵\r\n<>&"';￥%…*（）!@#$^().。,，]|[\uE000-\uF8FF]|\uD83C[\uDF00-\uDFFF]|\uD83D[\uDC00-\uDDFF]/g;

// 链接地址格式化
var REG_LINK = /(http:\/\/|https:\/\/)((\w|=|\?|\.|\/|&|-)+)/gi;

// 用户头像默认地址
var IMAGE_DEFAULT_AVATAR = 'https://tweebaafiles.oss-accelerate.aliyuncs.com/tweebaa/default-avatar.png';

// 群聊头像
var IMAGE_GROUP_AVATAR = 'https://tweebaafiles.oss-accelerate.aliyuncs.com/tweebaa/group-avatar.jpg';

// 各个通知类型常亮
var MSG_TYPE_INVITEACCEPTED = 'InviteAccepted';
var MSG_TYPE_FOLLOW = 'Follow';
var MSG_TYPE_LIKE = 'Like';
var MSG_TYPE_COMMENT = 'Comment';
var MSG_TYPE_COMMENT_REPLY = 'Comment';
var MSG_TYPE_REWARD = 'Reward';
var MSG_TYPE_ORDER = 'Order';
var MSG_TYPE_TWEELOG = 'Tweelog';
var MSG_TYPE_OTHER = 'Other';

var PIC_SCALE = {
    NORMAL: {
        clazz: 'normal'
    },
    SO_LONG: {
        radio: 1,
        clazz: 'so-long'    // 包含1，满屏展示
    },
    MUCH_LONG: {
        radio: 2,
        clazz: 'much-long'  // 满屏，展示图片最左侧
    },
    SO_HIGH: {
        radio: 1,
        clazz: 'so-high'    // 66%宽屏展示
    },
    MUCH_HIGH: {
        radio: 0.5,
        clazz: 'much-high'  // 满屏，展示图片最顶部
    }
};

var VIDEO_SCALE = {
    NORMAL: {
        clazz: 'normal'
    },
    MUCH_LONG: {
        radio: 1,
        clazz: 'much-long'
    }
};

// FIX
var WS_TIV_DIALOG_TYPE = {
    VOTE_PRODUCT: {
        // stayPage: false
    }
};

var CHAT_STATUS = {
    TIME: 'TIME',

    /*
     * 接收方，无人应答
     * 发起方："对方无应答"
     * 接收方："对方已取消"
     */
    NO_ANSWER: 'NO_ANSWER',
    /*
     * 发起方主动挂断
     * 发起方："已取消"
     * 接收方："对方已取消"
     */
    HANG_UP_SENDER: 'HANG_UP_SENDER',

    /*
     * 接受方主动挂断
     * 发起方："对方已拒绝"
     * 接收方："已拒绝"
     */
    HANG_UP_RECEIVER: 'HANG_UP_RECEIVER',


    /**
     * 发起方：聊天结束
     * 接收方：对方已挂断，通话结束
     */
    HANG_UP_AFTER: 'HANG_UP_AFTER',

    // 群聊：创建群聊
    GROUP_CREATE: 'GROUP_CREATE',

    // 群聊：邀请
    GROUP_INVITE: 'GROUP_INVITE',

    // 群聊：移除
    GROUP_REMOVE: 'GROUP_REMOVE',

    // 群聊：修改群昵称
    GROUP_CHANGE_NAME: 'GROUP_CHANGE_NAME',

    // 群聊：修改群昵称
    GROUP_CHANGE_PORTRAIT: 'GROUP_CHANGE_PORTRAIT',

    // 群聊：解散群聊
    GROUP_CHANGE_DISSOLVE: 'GROUP_CHANGE_DISSOLVE',

    // 群聊：群成员退出群聊
    GROUP_CHANGE_QUIT: 'GROUP_CHANGE_QUIT',

    // 群聊通话：发起了通话
    GROUP_CALL_BEGIN: 'GROUP_CALL_BEGIN',

    // 群聊通话：通话结束
    GROUP_CALL_END: 'GROUP_CALL_END'

};

var CHAT_MAX_MEMBERS = 12;

var EMO_DATA = [
    {"name": "E00001", "text": "[Earnie笑]"},
    {"name": "E00002", "text": "[Earnie尴尬]"},
    {"name": "E00003", "text": "[Earnie心心眼]"},
    {"name": "E00004", "text": "[Earnie哦]"},
    {"name": "E00005", "text": "[Earnie墨镜]"},
    {"name": "E00006", "text": "[Earnie哭]"},
    {"name": "E00007", "text": "[Earnie害羞]"},
    {"name": "E00008", "text": "[Earnie住口]"},
    {"name": "E00009", "text": "[Earnie困]"},
    {"name": "E00010", "text": "[Earnie挤眼]"},
    {"name": "E00011", "text": "[Earnie生气]"},
    {"name": "E00012", "text": "[Earnie愤怒]"},
    {"name": "E00013", "text": "[Earnie鬼脸]"},
    {"name": "E00014", "text": "[Earnie龇牙]"},
    {"name": "E00015", "text": "[Earnie惊讶]"},
    {"name": "E00016", "text": "[Earnie不开心]"},
    {"name": "E00017", "text": "[Earnie惊异]"},
    {"name": "E00018", "text": "[Earnie尴尬]"},
    {"name": "E00019", "text": "[Earnie狂怒]"},
    {"name": "E00020", "text": "[Earnie呕吐]"},
    {"name": "Expression_1", "text": "[微笑]"},
    {"name": "Expression_1", "text": "[微笑]"},
    {"name": "Expression_2", "text": "[撇嘴]"},
    {"name": "Expression_3", "text": "[色]"},
    {"name": "Expression_4", "text": "[发呆]"},
    {"name": "Expression_5", "text": "[得意]"},
    {"name": "Expression_6", "text": "[流泪]"},
    {"name": "Expression_7", "text": "[害羞]"},
    {"name": "Expression_8", "text": "[闭嘴]"},
    {"name": "Expression_9", "text": "[睡]"},
    {"name": "Expression_10", "text": "[大哭]"},
    {"name": "Expression_11", "text": "[尴尬]"},
    {"name": "Expression_12", "text": "[发怒]"},
    {"name": "Expression_13", "text": "[调皮]"},
    {"name": "Expression_14", "text": "[呲牙]"},
    {"name": "Expression_15", "text": "[惊讶]"},
    {"name": "Expression_16", "text": "[难过]"},
    {"name": "Expression_17", "text": "[酷]"},
    {"name": "Expression_18", "text": "[冷汗]"},
    {"name": "Expression_19", "text": "[抓狂]"},
    {"name": "Expression_20", "text": "[吐]"},
    {"name": "Expression_21", "text": "[偷笑]"},
    {"name": "Expression_22", "text": "[愉快]"},
    {"name": "Expression_23", "text": "[白眼]"},
    {"name": "Expression_24", "text": "[傲慢]"},
    {"name": "Expression_25", "text": "[饥饿]"},
    {"name": "Expression_26", "text": "[困]"},
    {"name": "Expression_27", "text": "[恐惧]"},
    {"name": "Expression_28", "text": "[流汗]"},
    {"name": "Expression_29", "text": "[憨笑]"},
    {"name": "Expression_30", "text": "[悠闲]"},
    {"name": "Expression_31", "text": "[奋斗]"},
    {"name": "Expression_32", "text": "[咒骂]"},
    {"name": "Expression_33", "text": "[疑问]"},
    {"name": "Expression_34", "text": "[嘘]"},
    {"name": "Expression_35", "text": "[晕]"},
    {"name": "Expression_36", "text": "[疯了]"},
    {"name": "Expression_37", "text": "[衰]"},
    {"name": "Expression_38", "text": "[骷髅]"},
    {"name": "Expression_39", "text": "[敲打]"},
    {"name": "Expression_40", "text": "[再见]"},
    {"name": "Expression_41", "text": "[擦汗]"},
    {"name": "Expression_42", "text": "[抠鼻]"},
    {"name": "Expression_43", "text": "[鼓掌]"},
    {"name": "Expression_44", "text": "[糗大了]"},
    {"name": "Expression_45", "text": "[坏笑]"},
    {"name": "Expression_46", "text": "[左哼哼]"},
    {"name": "Expression_47", "text": "[右哼哼]"},
    {"name": "Expression_48", "text": "[哈欠]"},
    {"name": "Expression_49", "text": "[鄙视]"},
    {"name": "Expression_50", "text": "[委屈]"},
    {"name": "Expression_51", "text": "[快哭了]"},
    {"name": "Expression_52", "text": "[阴险]"},
    {"name": "Expression_53", "text": "[亲亲]"},
    {"name": "Expression_54", "text": "[吓]"},
    {"name": "Expression_55", "text": "[可怜]"},
    {"name": "Expression_56", "text": "[菜刀]"},
    {"name": "Expression_57", "text": "[西瓜]"},
    {"name": "Expression_58", "text": "[啤酒]"},
    {"name": "Expression_59", "text": "[篮球]"},
    {"name": "Expression_60", "text": "[乒乓]"},
    {"name": "Expression_61", "text": "[咖啡]"},
    {"name": "Expression_62", "text": "[饭]"},
    {"name": "Expression_63", "text": "[猪头]"},
    {"name": "Expression_64", "text": "[玫瑰]"},
    {"name": "Expression_65", "text": "[凋谢]"},
    {"name": "Expression_66", "text": "[嘴唇]"},
    {"name": "Expression_67", "text": "[爱心]"},
    {"name": "Expression_68", "text": "[心碎]"},
    {"name": "Expression_69", "text": "[蛋糕]"},
    {"name": "Expression_70", "text": "[闪电]"},
    {"name": "Expression_71", "text": "[炸弹]"},
    {"name": "Expression_72", "text": "[刀]"},
    {"name": "Expression_73", "text": "[足球]"},
    {"name": "Expression_74", "text": "[瓢虫]"},
    {"name": "Expression_75", "text": "[便便]"},
    {"name": "Expression_76", "text": "[月亮]"},
    {"name": "Expression_77", "text": "[太阳]"},
    {"name": "Expression_78", "text": "[礼物]"},
    {"name": "Expression_79", "text": "[拥抱]"},
    {"name": "Expression_80", "text": "[强]"},
    {"name": "Expression_81", "text": "[弱]"},
    {"name": "Expression_82", "text": "[握手]"},
    {"name": "Expression_83", "text": "[胜利]"},
    {"name": "Expression_84", "text": "[抱拳]"},
    {"name": "Expression_85", "text": "[勾引]"},
    {"name": "Expression_86", "text": "[拳头]"},
    {"name": "Expression_87", "text": "[差劲]"},
    {"name": "Expression_88", "text": "[爱你]"},
    {"name": "Expression_89", "text": "[NO]"},
    {"name": "Expression_90", "text": "[OK]"},
    {"name": "Expression_91", "text": "[爱情]"},
    {"name": "Expression_92", "text": "[飞吻]"},
    {"name": "Expression_93", "text": "[跳跳]"},
    {"name": "Expression_94", "text": "[发抖]"},
    {"name": "Expression_95", "text": "[怄火]"},
    {"name": "Expression_96", "text": "[转圈]"},
    {"name": "Expression_97", "text": "[磕头]"},
    {"name": "Expression_98", "text": "[回头]"},
    {"name": "Expression_99", "text": "[跳绳]"},
    {"name": "Expression_100", "text": "[投降]"},
    {"name": "Expression_101", "text": "[激动]"},
    {"name": "Expression_102", "text": "[街舞]"},
    {"name": "Expression_103", "text": "[献吻]"},
    {"name": "Expression_104", "text": "[左太极]"},
    {"name": "Expression_105", "text": "[右太极]"}
];


var POST_TAGS = [
    {
        "Id":'',
        "zh":"最新",
        "en":"Latest"
    },
    {
        "Id":4096,
        "zh":"推易吧",
        "en":"Tweebaa"
    },
    {
        "Id":4194304,
        "zh":"活动专区",
        "en":"EVENT",
        "new": true
    },
    {
        "Id":8192,
        "zh":"用户心声",
        "en":"The Story of User"
    },
    {
        "Id":1,
        "zh":"旅行",
        "en":"Travel"
    },
    {
        "Id":2,
        "zh":"艺术",
        "en":"Art"
    },
    {
        "Id":4,
        "zh":"交友",
        "en":"Society"
    },
    {
        "Id":8,
        "zh":"音乐",
        "en":"Music"
    },
    {
        "Id":16,
        "zh":"美食",
        "en":"Food"
    },
    {
        "Id":32,
        "zh":"时尚",
        "en":"Fashion"
    },
    {
        "Id":64,
        "zh":"游戏",
        "en":"Game"
    },
    {
        "Id":128,
        "zh":"运动",
        "en":"Sport"
    },
    {
        "Id":256,
        "zh":"生活",
        "en":"Lifestyle"
    },
    {
        "Id":512,
        "zh":"心情",
        "en":"Emotion"
    },
    {
        "Id":1024,
        "zh":"科技",
        "en":"Technology"
    },
    {
        "Id":16384,
        "zh":"财经",
        "en":"Finance"
    },
    {
        "Id":32768,
        "zh":"娱乐",
        "en":"Entertainment"
    },
    {
        "Id":65536,
        "zh":"亲子",
        "en":"Family"
    },
    {
        "Id":131072,
        "zh":"励志",
        "en":"Inspiration"
    },
    {
        "Id":262144,
        "zh":"文化",
        "en":"Culture"
    },
    {
        "Id": 524288,
        "zh": "风景",
        "en": "Scenery"
    },
    {
        "Id": 1048576,
        "zh": "宠物",
        "en": "Pets"
    }
];


