
apiready = function () {
    var activityId = api.pageParam.activityId;

    api.setWinAttr({
        bounces: false
    });

    api.setNavBarAttr({
        rightButtons: [{
            iconPath: 'widget://image/share.jpg',
            color:'#a1a1a1',
            fontSize:'18'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if(ret.type ==='right'){
            activityDetail.openShareBar();
        }else{
            back();
        }
    });

    api.addEventListener({
        name: 'keyback'
    }, function(ret, err) {
        if(activityDetail.imageShow){
            var UIPhotoViewer = api.require('UIPhotoViewer');
            UIPhotoViewer.close();
            activityDetail.imageShow = false;
        }else{
            back();
        }
    });
    var activityDetail = new Vue({
        el: '#activityDetail',
        mounted: function () {
            this.getActivityDetail();
            var that = this;
            var url ='../../res/country.json';
            setTimeout(function () {
                $.getJSON(url, function( data ) {
                    //console.log(JSON.stringify(data));
                    that.countryList = data;
                });
            },500);

        },
        data: {
            activityData: '',
            participants:[],
            myID: localStorage.getItem('userId'),
            nowTime:moment(),
            userCount:'',
            images:[],
            countryList:[],
            countryName:'',
            translateTitle:'',
            translateContent:'',
            isTranslate:false,
            imageShow:false,
            message:{
                "zh":{
                    "createGroup":"建立群聊",
                },
                "en":{
                    "createGroup":"Create Group",
                }
            }
        },
        filters: {
            formatTime: function (value) {
                if(value){
                    return moment.utc(value).local().format('YYYY-MM-DD HH:mm');
                }else{
                    return lan ==="zh"?"不限":"Unlimited";
                }
            },
        },
        methods:{
            getActivityDetail: function () {
                var that = this;
                var url = getBaseUrl() + "api/charity/voics-activity/" + activityId +"?viewerId=" + this.myID;
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(response));
                    that.activityData = response.data.Data;
                    that.participants = response.data.Users;
                    that.userCount = response.data.UserCount;

                    var lang = lan === 'zh'?'cnName':'enName';
                    for(i=0;i<that.countryList.length;i++){
                        if(response.data.Data.CountryCode === that.countryList[i].code){
                            that.countryName = that.countryList[i][lang];
                        }
                    }

                    setTimeout(function () {
                        initialize();
                    },500);
                    var pics = response.data.Data.pictures;
                    for(i=0;i< pics.length;i++){
                        that.images.push(pics[i].PictureUrl);
                    }
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            showTranslation:function(){
                var that = this;
                if(that.translateContent){
                    that.isTranslate = true;
                    return;
                }
                loading('show');
                var url = getBaseUrl() + '/api/v2/translation';
                var paramStr = {
                    "q":  that.activityData.Name +'##'+ that.activityData.Description,
                    "LanguageCode": lan,
                };
                getAxois(url, "POST", paramStr).then(function (response) {
                    loading('hide');
                    //console.log(JSON.stringify(response.data.TranslatedText) + '$$$');
                    that.translateTitle = response.data.TranslatedText.split("##")[0];
                    that.translateContent = response.data.TranslatedText.split("##")[1];
                    that.isTranslate = true;
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error) + '@!@!@!@!@!@!@!@');
                    //messages($.i18n.prop('systemError'), 'error', 'top', 3);
                });
            },
            originalText:function(){
                this.isTranslate = false;
            },
            showOnMap:function(){
                var that = this;
                if(!that.activityData.Long || !that.activityData.Lat){
                    api.toast({
                        msg: $.i18n.prop('notOnMap'),
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }
                var systemType = api.systemType;
                if (systemType === 'android') {
                    var resultList = api.hasPermission({
                        list: ['location']
                    });
                    if (!resultList[0].granted) {
                        api.requestPermission({
                            list: [resultList[0].name],
                            code: 1
                        }, function (ret, err) {
                            if (ret.list[0].granted) {
                                openWindows("mapSelector",'widget://html/discovery/map-selector.html',{
                                    type:'get',
                                    lon:that.activityData.Long,
                                    lat:that.activityData.Lat
                                });
                            }
                        });
                    }else{
                        openWindows("mapSelector",'widget://html/discovery/map-selector.html',{
                            type:'get',
                            lon:that.activityData.Long,
                            lat:that.activityData.Lat
                        });
                    }

                }else{
                    openWindows("mapSelector",'widget://html/discovery/map-selector.html',{
                        type:'get',
                        lon:that.activityData.Long,
                        lat:that.activityData.Lat
                    });
                }
            },
            moreParticipants:function(){
                openWindows('participantsList','widget://html/activity/participants-list.html',{
                    activityId:activityId
                })
            },
            createGroup:function(){
                var that =this;
                openTabLayout('createActivityGroup',that.message[lan].createGroup,'widget://html/discovery/create-activity-group.html',{
                    users:that.participants
                })
            },
            openTycoonPlace: function (userId,StoreName,AvatarUrl) {
                openUserTycoonPlace(userId,StoreName,AvatarUrl);
            },
            showImages:function(Index){
                var that = this;
                that.imageShow = true;
                var UIPhotoViewer = api.require('UIPhotoViewer');
                UIPhotoViewer.open({
                    images: that.images,
                    placeholderImg: 'widget://image/lost_images.jpg',
                    bgColor: '#000',
                    activeIndex:Index,
                    zoomEnabled:true,
                    gestureClose:true
                }, function(Ret, err) {
                    if (Ret.eventType === 'click' ) {
                        UIPhotoViewer.close();
                        that.imageShow = false;
                    } else if(Ret.eventType === 'longPress'){
                        api.actionSheet({
                            cancelTitle: $.i18n.prop('cancel'),
                            buttons: [$.i18n.prop('saveImage')]
                        }, function(ret, err) {
                            var index = ret.buttonIndex;
                            if(index === 1){
                                api.download({
                                    url: that.images[Ret.index],
                                    report: true,
                                    cache: true,
                                    allowResume: true
                                }, function (ret, err) {
                                    if (ret.state === 1) {
                                        var Url= ret.savePath;
                                        api.saveMediaToAlbum({
                                            path: Url,
                                            groupName:"Tweebaa"
                                        }, function(ret, err) {
                                            if (ret && ret.status) {
                                                alert($.i18n.prop('imgSaved'));
                                            }
                                        });

                                    }
                                });
                            }

                        });

                    }
                });
            },
            openShareBar:function(){
                var ShareUrl = shareH5Host + '/html/activity.html?id='+ activityId+"&shareid="+localStorage.getItem('userName');
                var name = $.i18n.prop('tweebaa');
                var title = this.activityData.Name.replace(REG_SHARE_FILTER," ");
                new OpenShareBox(ShareUrl,name,title,'','','activity','',activityId);
            },
            joinActivity:function () {
                var that = this;
                var url = getBaseUrl() + "api/charity/users/"+ this.myID +"/join/voics-activity/" + activityId;
                if(that.activityData.RegistrationEndTimeUtc && that.nowTime > moment(that.activityData.RegistrationEndTimeUtc)){
                    api.toast({
                        msg: $.i18n.prop('registrationTimePassed'),
                        duration: 2000,
                        location: 'bottom'
                    });
                    return false;
                }

                if(that.userCount >= that.activityData.ParticipantLimit){
                    api.toast({
                        msg:  $.i18n.prop('NumberFull'),
                        duration: 2000,
                        location: 'bottom'
                    });
                    return false;
                }
                getAxois(url, "POST", {}).then(function (response) {
                    api.toast({
                        msg: $.i18n.prop('registerSuccessful'),
                        duration: 2000,
                        location: 'bottom'
                    });
                    setTimeout(function () {
                        back();
                    },2500)
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
        }
    });
};

//初始化图片显示
function initialize() {
    var mySwiper = new Swiper('.swiper-container', {
        direction: 'horizontal',
        loop: false,
        initialSlide: 0,
        pagination: {
            el: '.swiper-pagination',
            type: 'bullets'
        }
    });
    var winWidth = api.winWidth;
    $('#proDetailPhoto').height(winWidth);

}
