apiready = function () {
    var page = 0;
    var Category ='';

    backListener();

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 500
        }
    }, function (ret, err) {
        if(!activityList.bottomLoading && activityList.haveData && !activityList.isLoading){
            page++;
            activityList.getActivityList();
        }
    });

    var kv = api.require('snKVStorage');
    var hasActivityList = kv.has({
        key: 'activityList'
    });
    var ACTUVIYYLIST = kv.getArray({
        key: 'activityList'
    });

    var activityList = new Vue({
        el: '#activityList',
        mounted: function () {
            this.getActivityList();
        },
        data: {
            activityList: hasActivityList ? ACTUVIYYLIST : [],
            newsList: [],
            myID: localStorage.getItem('userId'),
            cityId: '',
            TotalCount:'',
            isLoading:false,
            bottomLoading:false,
            haveData:true,
            message:{
                "zh":{
                    "update":"努力更新中...",
                    "participant":"人",
                },
                "en":{
                    "update":"Updating...",
                    "participant":"Participant",
                }
            }
        },
        filters: {
            formatTime: function (value) {
                if(value){
                    return moment.utc(value).local().format('MM.DD');
                }else{
                    return lan ==="zh"?"不限":"Unlimited";
                }
            },
            activityType:function (value) {
                return $.i18n.prop(''+ value.toLowerCase() +'');
            }
        },
        methods: {

            getActivityList: function (Q) {

                var that = this;
                if(that.isLoading){
                    return false;
                }
                var q = Q || '';
                var paramStr = "?q=" + q + "&type=" + Category +"&currentpage="+ page+ "&itemsperpage=12" ;
                var url = getBaseUrl() + "api/charity/v1/activities" + paramStr;
                if(page===0){
                    $('#updateTips').show();
                }else{
                    that.bottomLoading = true;
                }
                //api.refreshHeaderLoadDone();
                that.isLoading = true;
                getAxois(url, "GET", {}).then(function (response) {
                    $('#updateTips').hide();
                    that.bottomLoading = false;
                    that.isLoading = false;
                    if(page === 0){
                        that.activityList = response.data.Data.List;
                        var activityListDatas = kv.setArray({
                            key: 'activityList',
                            value: that.activityList
                        });
                    }else{
                        if (response.data.Data.List.length !== 0) {
                            that.activityList = that.activityList.concat(response.data.Data.List);
                        }else{
                            that.haveData = false;
                        }
                    }

                    //that.noData = response.data.Data.length === 0 && page === 0;
                }).catch(function (error) {
                    $('#placeHolderLoad').hide();
                    console.log(JSON.stringify(error));
                });
            },
            openActivityDetail: function (id, title) {
                openTabLayout('activityDetail', title, 'widget://html/discovery/activity-detail.html', {
                    activityId: id
                });
            },
            createActive: function () {
                if (!Boolean(localStorage.getItem('OrgVerified') === 'true')) {
                    confirmBox($.i18n.prop('completeOrganization'), $.i18n.prop('cancel'), $.i18n.prop('sure'), 'error');
                    $('.dialog-box').find('button').on('click', function (e) {
                        $('.dialog-box').remove();
                        var index = $(this).attr('id');
                        if (index === 'btn-2') {
                            openTabLayout('verification', $.i18n.prop('orgernizationVerification'), 'widget://html/discovery/verified-org.html');
                        }
                    });

                } else {
                    openTabLayout('addActivity', $.i18n.prop('postActivity'), 'widget://html/discovery/add-activity.html');
                }
            },
        }
    });
};
