
apiready = function () {
    api.setWinAttr({
        bounces: false
    });
    backListener();
    api.addEventListener({
        name: 'selectedMap'
    }, function (ret, err) {
        addActivity.lon = ret.value.lon;
        addActivity.lat = ret.value.lat;
    });
    var Pictures = [];
    var today = moment().format('YYYY-MM-DDTHH:mm:ss');
    // var activeAay2 = moment().add(1, 'days').format('YYYY-MM-DDTHH:mm:ss');

    var imgW = $('#width').width();
    $('#uploadImgBox .img-li').height(imgW);

    var addActivity = new Vue({
        el: '#addActivity',
        mounted: function () {
            var that = this;
            var url ='../../res/country.json';
            //console.log(url);
            $.getJSON(url, function( data ) {
                //console.log(JSON.stringify(data));
                that.countryList = data;
                that.country = localStorage.getItem('countryCode');
            });
        },
        data: {
            activeStartTime:today,
            activeEndTime:today,
            activeUnlimited:false,
            signStartTime:today,
            signEndTime:today,
            signUnlimited:false,
            selectedAddressInfo:[],
            selectedAddress:'',
            activityType:'EVENTS',
            activityTypeOption:[
                { text: $.i18n.prop('events'), value: 'EVENTS' },
                { text: $.i18n.prop('consulting'), value: 'CONSULTING' },
                { text: $.i18n.prop('crowdfunding'), value: 'CROWDFUNDING' },
                { text: $.i18n.prop('seminars'), value: 'SEMINARS' },
                { text: $.i18n.prop('recruitment'), value: 'RECRUITMENT' },
                { text: $.i18n.prop('charity'), value: 'CHARITY' },
                { text: $.i18n.prop('volunteering'), value: 'VOLUNTEERING' }
            ],
            title:'',
            number:'',
            fullDescription:'',
            addressDetail:'',
            provincePostalCode:'',
            cityPostalCode:'',
            districtPostalCode: '',
            lon:'',
            lat:'',
            country:localStorage.getItem('countryCode'),
            countryList:'',
            lang:lan==='zh'?'cnName':'enName',
            uploading:false,
            message:{
                "zh":{
                    "title":"标题",
                    "inputTitle":"输入标题",
                    "participation":"活动人数",
                    "inputParticipation":"输入活动人数",

                },
                "en":{
                    "title":"Title",
                    "inputTitle":"Input title",
                    "participation":"Participants",
                    "inputParticipation":"Number of Participants",
                }
            }
        },
        watch:{
            activeStartTime:function (val) {
                if( val < today){
                    this.activeStartTime = today;
                }else if(this.activeEndTime < this.activeStartTime){
                    this.activeEndTime = this.activeStartTime;
                }
            },
            activeEndTime:function (val) {
                if( val < this.activeStartTime){
                    this.activeEndTime = this.activeStartTime;
                }
                if(this.signStartTime > this.activeEndTime){
                    this.signEndTime = this.signStartTime = this.activeEndTime;
                }
            },
            signStartTime:function (val) {
                if( val < today){
                    this.signStartTime = today;
                }else if(this.signEndTime < this.signStartTime){
                    this.signEndTime = this.signStartTime;
                }
                if(this.signStartTime > this.activeEndTime){
                    this.signEndTime = this.signStartTime = this.activeEndTime;
                }
            },
            signEndTime:function (val) {
                if( val < this.signStartTime){
                    this.signEndTime = this.signStartTime;
                }
            }
        },
        methods:{
            changeActiveUnlimited:function () {
                if(this.activeUnlimited){
                    this.activeStartTime = '';
                    this.activeEndTime = ''
                }else{
                    this.activeStartTime = today;
                    this.activeEndTime = today
                }
            },
            changeSignUnlimited:function () {
                if(this.signUnlimited){
                    this.signStartTime = '';
                    this.signEndTime = '';
                }else{
                    this.signStartTime = today;
                    this.signEndTime = today
                }
            },
            markOnMap:function(){

                var systemType = api.systemType;
                if (systemType === 'android') {
                    var resultList = api.hasPermission({
                        list: ['location']
                    });
                    if (!resultList[0].granted) {
                        api.requestPermission({
                            list: [resultList[0].name],
                            code: 1
                        }, function (ret, err) {
                            if (ret.list[0].granted) {
                                openWindows("mapSelector",'widget://html/discovery/map-selector.html',{
                                    type:'set'
                                });
                            }
                        });
                    }else{
                        openWindows("mapSelector",'widget://html/discovery/map-selector.html',{
                            type:'set'
                        });
                    }

                }else{
                    openWindows("mapSelector",'widget://html/discovery/map-selector.html',{
                        type:'set'
                    });
                }
            },
            saveActivity:function () {
                var that = this;
                if(that.uploading){
                    return false;
                }
                var userId = localStorage.getItem('userId');
                if(!this.title){
                    messages($.i18n.prop('enterTitle'), 'error', 'top', 3);
                    return false;
                }else if(!this.addressDetail){
                    messages($.i18n.prop('enterAddressDetail'), 'error', 'top', 3);
                    return false;
                }
                if(imgUploading){
                    api.toast({
                        msg: $.i18n.prop('uploadDataTips'),
                        duration: 2000,
                        location: 'middle'
                    });
                    setTimeout(function () {
                        that.saveActivity();
                    },2000)
                }else{
                    $("#uploadImgBox").find('img').each(function (index) {
                        var pic = $(this).data('picture');
                        pic.DisplayOrder = index;
                        Pictures.push(pic);
                    });
                    var paramStr = {
                        "Name": that.title,
                        "RegistrationStartTimeUtc": that.signStartTime ? moment(that.signStartTime).utc() : null,
                        "RegistrationEndTimeUtc": that.signEndTime ? moment(that.signEndTime).utc() : null,
                        "LaunchStartTimeUtc": that.activeStartTime ? moment(that.activeStartTime).utc() : null,
                        "LaunchEndTimeUtc": that.activeEndTime ? moment(that.activeEndTime).utc(): null,
                        "DurationRecorded": false,
                        "ParticipantLimit": Number(that.number) || null,
                        "Description": that.fullDescription,
                        "TypeCode": that.activityType,
                        "Pictures": Pictures,
                        "CountryCode": that.country,
                        "Address": that.addressDetail,
                        "Lat": that.lat,
                        "Long": that.lon
                    };
                    var url = getBaseUrl() + "api/v2/charity/users/"+ userId +"/create/voics-activity";
                    //console.log(JSON.stringify(paramStr));
                    that.uploading = true;
                    saving('show');
                    getAxois(url,"POST",paramStr).then(function (response) {
                        //console.log(JSON.stringify(response));
                        api.sendEvent({
                            name: 'myActivityListReload',
                        });
                        saving('hide');
                        setTimeout(function () {
                            back()
                        },500)
                    }).catch(function (error) {
                        saving('hide');
                        console.log(JSON.stringify(error) + '@!@!@!@!@!@!@!@');
                    });
                }

            }
        }

    });
};
