var discovery;
apiready = function () {
    api.addEventListener({
        name:'discoveryReload'
    }, function(ret, err){
        location.reload();
    });

    api.addEventListener({
        name: 'resetEvaluationList',
    }, function (ret, err) {
        discovery.evaluationList[ret.value.index].Evaluated = true;
        discovery.evaluationList[ret.value.index].CurrentVotes ++;
    });

    var pullDownRefresh = lan === 'zh' ? '下拉刷新' : 'Pull down to refresh';
    var refreshing = lan === 'zh' ? '刷新中...' : 'Refreshing...';
    var releaseRefresh = lan === 'zh' ? '放开开始刷新' : 'Release refresh';
    api.setRefreshHeaderInfo({
        loadingImg:'widget://image/refresh-logo.png',
        bgColor: '#fff',
        textColor: '#000',
        textDown: pullDownRefresh,//'Pull down to refresh'
        textLoading: refreshing, //'Refreshing...'
        showTime: false,
        textUp: releaseRefresh //'Release refresh'
    }, function (ret, err) {
        api.refreshHeaderLoadDone();

        loading('show');

        switch (discovery.currentTag) {
            case 'evaluation':
                discovery.evaluationData.page = 0;
                discovery.getEvaluationList();
                break;
            case 'activity':
                discovery.activityData.page = 0;
                discovery.getActivityList();
                break;
            case 'tweeLog':
                discovery.orgData.page = 0;
                discovery.getOrgList();
                break;
        }

    });

    // 下拉滚动刷新
    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 300
        }
    }, function (ret, err) {

        switch (discovery.currentTag) {
            case 'evaluation':
                if (discovery.evaluationData.bottomLoading === false
                    && discovery.evaluationData.haveData === true
                    && discovery.evaluationData.isLoading === false){
                    discovery.evaluationData.page++;
                    discovery.getEvaluationList();
                }
                break;
            case 'activity':
                if (discovery.activityData.bottomLoading === false
                    && discovery.activityData.haveData === true
                    && discovery.activityData.isLoading === false){
                    discovery.activityData.page++;
                    discovery.getActivityList();
                }
                break;
            case 'tweeLog':
                if (discovery.orgData.bottomLoading === false
                    && discovery.orgData.haveData === true
                    && discovery.orgData.isLoading === false){
                    discovery.orgData.page++;
                    discovery.getOrgList();
                }
                break;
        }

    });

    var kv = api.require('snKVStorage');

    // 评审列表
    var hasEvaluationList = kv.has({
        key: 'evaluationList'
    });
    var EVALUATIONLIST = kv.getArray({
        key: 'evaluationList'
    });

    // 活动列表
    var hasActivityList = kv.has({
        key: 'activityList'
    });
    var ACTUVIYYLIST = kv.getArray({
        key: 'activityList'
    });


    var PAGE_SIZE_FOR_MAP = 40;
    //大众评审
    var EVALUATION_LIST_MAP = {
        '25': {
            Id: 25
        },
        '20': {
            Id: 20
        },
        '19': {
            Id: 19
        },
        '38': {
            Id: 38
        },
        '42': {
            Id: 42
        }
    };
    // 活动中心
    var ACTIVITY_LIST_MAP = {
        '68': {
            Id: 68
        },
        '67': {
            Id: 67
        },
        '66': {
            Id: 66
        },
        '79': {
            Id: 65
        },
        '64': {
            Id: 64
        }
    };

    discovery = new Vue({
        el: '#discovery',
        created: function () {
            var that  = this;
            var token = api.getPrefs({
                sync: true,
                key: 'accessToken'
            }) || localStorage.getItem('access_token');
            if(token){
                // that.getEvaluationList();
                that.getActivityList();
                that.getOrgList();
            }
        },
        data: {
            currentTag: 'activity',

            activityList: [],
            evaluationList:[],
            orgList:[],

            activityData: {
                page: 0,
                pageSize: 12,
                bottomLoading: false,
                haveData: true,
                isLoading: false
            },
            evaluationData: {
                page: 0,
                pageSize: 50,
                bottomLoading: false,
                haveData: true,
                isLoading: false,
            },
            orgData: {
                page: 0,
                pageSize: 24,
                bottomLoading: false,
                haveData: true,
                isLoading: false
            },

            banner: '../../image/banners/discovery-activity-'+ lan +'.jpg',
            myID: localStorage.getItem('userId'),
            TotalCount:'',
            tasks:$.i18n.prop('tasks'),
            tweeLog:$.i18n.prop('tweeLog'),
            evaluation:$.i18n.prop('evaluation'),
            isInTweeLog:localStorage.getItem('OrgVerified'),
            tasksList:[
                // {
                //     "title":$.i18n.prop('inviteFriendsRegister'),
                //     "text":$.i18n.prop('tripleTivBonus')
                // },
                {
                    "title":$.i18n.prop('likeFavoritePosts'),
                    "text":$.i18n.prop('increaseTiV')
                },
                {
                    "title":$.i18n.prop('sharePostsWithFriends'),
                    "text":$.i18n.prop('expandNetworkReward')
                },
                {
                    "title":$.i18n.prop('showcaseUniqueU'),
                    "text":$.i18n.prop('monetizeYourTiV')
                },
                {
                    "title":$.i18n.prop('shareMomentsLife'),
                    "text":$.i18n.prop('rewardYourselfTiV')
                },
                {
                    "title":$.i18n.prop('beautifyYourself'),
                    "text":$.i18n.prop('moreFollowersMoreTiV')
                },
            ],
            message:{
                "zh":{
                    "tweebucks":"T豆",
                    "evaluated":"已评审",
                    "joined":"已参与",
                    "evaluation":"大众评审",
                    "participant":"人",
                    "addProduct":"发布产品",
                },
                "en":{
                    "tweebucks":"Tweebucks",
                    "evaluated":"Evaluated",
                    "joined":"Joined",
                    "evaluation":"Evaluation",
                    "participant":"Participant",
                    "addProduct":"Add Product",
                }
            }
        },
        filters: {
            fixed2: function (value) {
                var v = value || 0;
                return Number(v).toFixed(2);
            },
            formatTime: function (value) {
                if(value){
                    return moment.utc(value).local().format('MM.DD');
                }else{
                    return lan ==="zh"?"不限":"Unlimited";
                }

            },
            activityType:function (value) {
                return $.i18n.prop(''+ value.toLowerCase() +'');
            },
            /**
             * @return {string}
             */
            ParticipantValue:function (value) {
                if(!value){
                    return lan ==="zh"?"不限人数":"Unlimited Participant";
                }else{
                    return value
                }
            }
        },
        methods: {
            switchTag:function (type) {
                this.currentTag = type;
                switch (type) {
                    case "activity":
                        this.banner = '../../image/banners/discovery-activity-'+ lan +'.jpg';
                        break;
                    case "tweeLog":
                        this.banner = '../../image/banners/discovery-tweeLog-'+ lan +'.jpg';
                        break;
                    // case "evaluation":
                    //     this.banner = '../../image/banners/discovery-evaluation-'+ lan +'.jpg';
                    //     break;
                }
            },
            addBtn:function(){
                var that = this;
                switch (that.currentTag) {
                    case "activity":
                        that.addActivity();
                        break;
                    case "tweeLog":
                        that.addTweeLog();
                        break;
                    case "evaluation":
                        that.addEvaluation();
                        break;
                }
            },
            openTips:function(){
                // var that  =  this;
                // var type = this.currentTag;
                // var Id;
                // switch (type) {
                //     case "evaluation":
                //         Id = 16004;
                //         break;
                // }
                openTabLayout("faqDetail",'','widget://html/access/faq-detail.html',{
                    id:16004
                })
            },
            _getNewListByMap: function(listMap, baseList) {
                var resultsTop = [];
                var resultsBottom = [];
                var item;
                for (var i = 0, len = baseList.length; i < len; i++) {
                    item = baseList[i];
                    if (listMap[item.Id]) {
                        resultsTop.push(item);
                    } else {
                        resultsBottom.push(item);
                    }
                }
                return resultsTop.concat(resultsBottom);
            },
            getActivityList: function () {
                var that = this;
                if (this.activityData.isLoading) {
                    return false;
                }
                var paramStr = "?q=&type=" + "&currentpage="+ this.activityData.page+ "&itemsperpage=" + this.activityData.pageSize;
                var url = getBaseUrl() + "api/charity/v1/activities" + paramStr;

                if (this.activityData.page === 0) {

                } else {
                    this.activityData.bottomLoading = true;
                }

                this.activityData.isLoading = true;
                getAxois(url, "GET", {}).then(function (response) {
                    that.activityData.isLoading = false;
                    that.activityData.bottomLoading = false;
                    var list = response.data.Data.List;
                    if (that.activityData.page === 0) {
                        loading('hide');
                        that.activityList = that._getNewListByMap(ACTIVITY_LIST_MAP, list);
                        kv.setArray({
                            key: 'activityList',
                            value: that.activityList
                        });
                    }else{
                        if (list.length !== 0) {
                            that.activityList = that.activityList.concat(list);
                        } else {
                            that.activityData.haveData = false;
                        }
                    }
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            openActivityDetail: function (id, title) {
                openTabLayout('activityDetail', title, 'widget://html/discovery/activity-detail.html', {
                    activityId: id
                });
            },

            goTasks:function (index) {
                switch (index+1) {
                    case 0:
                        openTabLayout("invite",$.i18n.prop('inviteFriend'),'widget://html/access/invite.html');
                        break;
                    case 1:
                        api.execScript({
                            name: 'root',
                            script: 'switchToIndex(0,"home");'
                        });
                        break;
                    case 2:
                        api.execScript({
                            name: 'root',
                            script: 'switchToIndex(0,"home");'
                        });
                        break;
                    case 3:
                        var name = this.message[lan].addProduct;
                        openTabLayout('addProduct', name, 'widget://html/products/add-products.html');
                        break;
                    case 4:
                        openWindows('addMoment','widget://html/users/add-moment.html');
                        break;
                    case 5:
                        openTabLayout("myProfile",$.i18n.prop('editProfile'),'widget://html/users/my-profile.html');
                        break;
                }

            },
            getOrgList:function () {
                var that = this;
                if (this.orgData.isLoading) {
                    return false;
                }

                var url = getBaseUrl() + "api/voics/organizations/verified?currentpage="+ this.orgData.page +"&itemsperpage=" + this.orgData.pageSize;

                if (this.orgData.page === 0) {

                } else {
                    this.orgData.bottomLoading = true;
                }

                this.orgData.isLoading = true;
                getAxois(url, "GET", {}).then(function (response) {
                    that.orgData.isLoading = false;
                    that.orgData.bottomLoading = false;
                    if (that.orgData.page === 0) {
                        loading('hide');
                        that.orgList = response.data;
                    }else{
                        if (response.data.length !== 0) {
                            that.orgList = that.orgList.concat(response.data);
                        } else {
                            that.orgData.haveData = false;
                        }
                    }
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            openTycoonplace:function(index){
                openUserTycoonPlace(this.orgList[index].User.Id,this.orgList[index].User.StoreName,this.orgList[index].User.AvatarUrl);
            },
            openDetial:function (index) {
                var that =this;
                openTabLayout('org-detail',$.i18n.prop('tweeLog'),'widget://html/discovery/org-detail.html',{
                    userId: JSON.stringify(that.orgList[index].User.Id)
                })
            },
            moreActivity:function () {
                openTabLayout("activity",$.i18n.prop('activity'),'widget://html/discovery/activity-list.html');
            },
            moreTweelog:function () {
                openTabLayout("tweeLog",$.i18n.prop('tweeLog'),'widget://html/discovery/org-list.html');
            },
            addActivity:function () {
                openTabLayout('addActivity',$.i18n.prop('postActivity'),'widget://html/discovery/add-activity.html');
            },
            addTweeLog:function () {
                openTabLayout("addTweeLog",'','widget://html/discovery/verified-org.html');
            },
            addEvaluation:function () {
                openTabLayout('suggestProduct', $.i18n.prop('New-Suggestion'), 'widget://html/products/suggest-product.html');
            },
            getEvaluationList: function (Q) {
                var that = this;
                if (this.evaluationData.isLoading) {
                    return false;
                }
                var url = getBaseUrl() + "api/suggest-products?currentpage="
                        + this.evaluationData.page + "&itemsperpage="
                        + this.evaluationData.pageSize + "&viewerId=" + that.myID;

                if (this.evaluationData.page === 0) {

                } else {
                    this.evaluationData.bottomLoading = true;
                }

                this.evaluationData.isLoading = true;
                getAxois(url, "GET", {}).then(function (response) {
                    that.evaluationData.isLoading = false;
                    that.evaluationData.bottomLoading = false;
                    if (that.evaluationData.page === 0) {
                        loading('hide');
                        var list = response.data;
                        that.evaluationList = that._getNewListByMap(EVALUATION_LIST_MAP, list);
                        kv.setArray({
                            key: 'evaluationList',
                            value: that.evaluationList
                        });
                    }else{
                        if (response.data.length !== 0) {
                            that.evaluationList = that.evaluationList.concat(response.data);
                        } else {
                            that.evaluationData.haveData = false;
                        }
                    }
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            openEvaluationDetail: function (index) {
                var title = this.message[lan].evaluation;
                var id = this.evaluationList[index].Id;
                openTabLayout('evaluationDetail', title, 'widget://html/discovery/evaluation-detail.html', {
                    evaluationId: id,
                    index :index
                });
            },
            allEvaluation:function () {
                api.openTabLayout({
                    name: "evaluationList",
                    url: 'widget://html/discovery/evaluation-list.html',
                    title: $.i18n.prop('evaluation'),
                    shadow:'#f0f0f0',
                    hideNavigationBar:false,
                    navigationBar: {
                        background: '#fff',
                        color: '#6b6b6b',
                        leftButtons:  [ {
                            iconPath: 'widget://image/back2.png'
                        }],
                    },
                    bounces: true,
                    scrollToTop:true,
                    slidBackEnabled:true,
                    allowEdit:true,
                    pageParam:{}
                });
            }
        }
    });

};

function refreshPage() {
    location.reload();
}
