
// autosize(document.querySelectorAll('textarea'));

apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    backListener();

    api.setWinAttr({
        bounces: false
    });

    api.addEventListener({
        name: 'keyback'
    }, function(ret, err) {
        if(evaluationDetail.imageShow){
            var UIPhotoViewer = api.require('UIPhotoViewer');
            UIPhotoViewer.close();
            evaluationDetail.imageShow = false;
        }else{
            back();
        }
    });

    api.setNavBarAttr({
        rightButtons: [{
            text: MSG.evaluation.submit,
            color: '#7497f5',
            fontSize: '14',
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if (ret.type === 'right') {
            evaluationDetail.submitEvaluation();
        } else {
            back();
        }
    });

    var appleCheck = api.getGlobalData({
        key: 'appleCheck'
    });

    var evaluationDetail = new Vue({
        el: '#evaluationDetail',
        mounted: function () {
            // this.getEvaluationDetail();
        },
        created: function() {
            this.evaluationId = api.pageParam.evaluationId;
            this.productData = api.pageParam.productData;
        },
        data: {
            appleCheck: appleCheck,
            evaluationId: '',
            productData: '',
            myID: localStorage.getItem('userId'),
            images:[],
            translateTitle:'',
            translateContent:'',
            isTranslate:false,
            switchImg:true,
            sending:false,
            imageShow:false,
            questionMap: {
                selected1:
                    {
                        "question" : MSG.evaluation.q1,
                        "answer" : ""
                    },
                selected0:
                    {
                        "question" : MSG.evaluation.q0,
                        "answer" : ""
                    },
                selected2:
                    {
                        "question" : MSG.evaluation.q2,
                        "answer" : ""
                    },
                selected3:
                    {
                        "question" : MSG.evaluation.q3,
                        "answer" : ""
                    },
                selected4:
                    {
                        "question" : MSG.evaluation.q4,
                        "answer" : ""
                    }
            },
            textIdea: {
                "question" : MSG.evaluation.q5,
                "answer" : ""
            },
            inputText:"",
            canSubmit: false,
            message: MSG
        },
        filters: {
            formatTime:function (value) {
                return moment.utc(value).local().format('YYYY-MM-DD HH:mm');
            },
        },
        watch: {
            questionMap: {
                handler: function(newVal, oldVal) {
                    var result = true;
                    $.map(newVal, function (item) {
                        if (item.answer === '') {
                            result = false;
                        }
                    });
                    if (result === true) {
                        this.canSubmit = true;
                        api.setNavBarAttr({
                            rightButtons: [{
                                text: MSG.evaluation.submit,
                                color: '#4578F3',
                                fontSize: '15',
                            }]
                        });
                    }
                },
                deep: true
            },
        },
        methods: {
            getLangKey: function() {
                return lan === 'zh' ? 'zh_CN' : 'en_US';
            },
            switchImgVideo: function (type) {
                this.switchImg = type === 'img';
                initialize();
            },
            getEvaluationDetail: function () {
                var that = this;
                var url = getBaseUrl() + "api/suggest-products/detail?SuggestProductId=" + this.evaluationId +"&LanguageCode="+ lan +"&viewerId=" + this.myID;
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(response));
                    that.evaluationData = response.data;

                    setTimeout(function () {
                        initialize();
                    },500);
                    var pics = response.data.Pictures;
                    for(i=0;i< pics.length;i++){
                        that.images.push(pics[i].PictureUrl);
                    }
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            showTranslate:function(){
                var that = this;
                if(that.translateContent){
                    that.isTranslate = true;
                    return;
                }
                loading('show');
                var url = getBaseUrl() + '/api/v2/translation';
                var paramStr = {
                    "q":  that.evaluationData.Name +'##'+ that.evaluationData.Description,
                    "LanguageCode": lan,
                };
                getAxois(url, "POST", paramStr).then(function (response) {
                    loading('hide');
                    //console.log(JSON.stringify(response.data.TranslatedText) + '$$$');
                    that.translateTitle = response.data.TranslatedText.split("##")[0];
                    that.translateContent = response.data.TranslatedText.split("##")[1];
                    that.isTranslate = true;
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error) + '@!@!@!@!@!@!@!@');
                });
            },
            originalText:function(){
                this.isTranslate = false;
            },
            submitEvaluation: function(){
                var that = this;
                if (that.sending) {
                    return;
                }

                if (that.canSubmit === false) {
                    return;
                }

                var params = {
                    productSuggestionId: this.evaluationId,
                    answers: [
                        that.questionMap.selected1,
                        that.questionMap.selected0,
                        that.questionMap.selected2,
                        that.questionMap.selected3,
                        that.questionMap.selected4,
                        that.textIdea
                    ]
                };

                this.sending = true;
                apiSuggest.post("/api-product/suggest/evaluate", params, {
                    timeZone: 'Asia/Beijing',
                    userGuid: localStorage.getItem('userGuid')
                }).done(function (rep) {
                    that.sending = false;
                    //loading('hide');
                    console.log(JSON.stringify(rep));
                    if (rep.code === 0) {
                        //loading('hide');
                        api.toast({
                            msg: that.message.evaluation.evaluated,
                            duration: 2000,
                            location: 'middle'
                        });
                        api.sendEvent({
                            name: 'refreshEvaluationVoted',
                            extra: {
                                evaluationId: api.pageParam.evaluationId,
                            }
                        });

                        api.sendEvent({
                            name: 'evaluationVoted'
                        });

                        api.sendEvent({
                            name: 'mySuggestProductsListReload'
                        });

                        showTiV(false);

                    } else {
                        loading('hide');
                        api.toast({
                            msg: (rep.responseJSON && rep.responseJSON.message) || MSG.tips.systemError,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });


                // var url = getBaseUrl() + 'api/suggest-products/evaluate';
                // var paramStr = {
                //     "SuggestProductId":  evaluationId,
                //     "LanguageCode": lan,
                //     "EvaluatorId":that.myID,
                //     "EvaluationAnswers":[that.selected1,that.selected2,that.selected3,that.selected4,{"QuestionId": 5,"Answers" : [that.inputText]}]
                // };
                // that.sending = true;
                // loading('show');
                // //console.log(JSON.stringify(paramStr));
                // getAxois(url, "POST", paramStr).then(function (response) {
                //     //console.log(JSON.stringify(response));
                //     loading('hide');
                //     api.toast({
                //         msg: that.message.evaluated,
                //         duration: 2000,
                //         location: 'middle'
                //     });
                //     api.sendEvent({
                //         name: 'resetEvaluationList',
                //         extra: {
                //             index:api.pageParam.index,
                //         }
                //     });
                //     setTimeout(function () {
                //         back();
                //     },2000)
                // }).catch(function (error) {
                //     loading('hide');
                //     console.log(JSON.stringify(error) + '@!@!@!@!@!@!@!@');
                // });
            },
            showImages:function(Index){
                var that = this;
                that.imageShow = true;
                var UIPhotoViewer = api.require('UIPhotoViewer');
                UIPhotoViewer.open({
                    images: that.images,
                    placeholderImg: 'widget://image/lost_images.jpg',
                    bgColor: '#000',
                    activeIndex:Index,
                    zoomEnabled:true,
                    gestureClose:true
                }, function(Ret, err) {
                    if (Ret.eventType === 'click' ) {
                        UIPhotoViewer.close();
                        that.imageShow = false;
                    } else if(Ret.eventType === 'longPress'){
                        api.actionSheet({
                            cancelTitle: MSG.general.cancel,
                            buttons: [MSG.general.save]
                        }, function(ret, err) {
                            var index = ret.buttonIndex;
                            if(index === 1){
                                api.download({
                                    url: that.images[Ret.index],
                                    report: true,
                                    cache: true,
                                    allowResume: true
                                }, function (ret, err) {
                                    if (ret.state === 1) {
                                        var Url= ret.savePath;
                                        api.saveMediaToAlbum({
                                            path: Url,
                                            groupName:"Tweebaa"
                                        }, function(ret, err) {
                                            if (ret && ret.status) {
                                                alert(MSG.tips.saved);
                                            }
                                        });

                                    }
                                });
                            }

                        });

                    }
                });
            },
            openTycoonOfEvaluation: function ($event, userId, username, avatarUrl) {
                $event.stopPropagation();
                openUserTycoonPlace(userId, username, avatarUrl, 'tproducts-list');
            }

        }
    });
};

//初始化图片显示
function initialize() {
    var mySwiper = new Swiper('.swiper-container', {
        direction: 'horizontal',
        loop: false,
        initialSlide: 0,
        pagination: {
            el: '.swiper-pagination',
            type: 'bullets'
        }
    });
    var winWidth = api.winWidth;
    $('#proDetailPhoto').height(winWidth);

}

