apiready = function () {
    var page = 0;

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    backListener();

    api.addEventListener({
        name: 'resetEvaluationList',
    }, function (ret, err) {
        if(evaluationList.evaluationList[ret.value.index]){
            evaluationList.evaluationList[ret.value.index].Evaluated = true;
            evaluationList.evaluationList[ret.value.index].CurrentVotes ++;
        }
    });

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 500
        }
    }, function (ret, err) {
        if(!evaluationList.bottomLoading && evaluationList.haveData && !evaluationList.isLoading){
            page++;
            evaluationList.getEvaluationList();
        }
    });

    var kv = api.require('snKVStorage');
    var hasEvaluationList = kv.has({
        key: 'evaluationList'
    });
    var EVALUATIONLIST = kv.getArray({
        key: 'evaluationList'
    });


    var evaluationList = new Vue({
        el: '#evaluationList',
        mounted: function () {
            this.getEvaluationList();
        },
        data: {
            evaluationList: hasEvaluationList ? EVALUATIONLIST : [],
            myID: localStorage.getItem('userId'),
            TotalCount:'',
            bottomLoading:false,
            isLoading:false,
            haveData:true,
            message:MSG.evaluation
        },
        filters: {
            formatTime: function (value) {
                return moment.utc(value).local().format('YYYY.MM.DD');
            },
        },
        methods: {

            getEvaluationList: function () {

                var that = this;
                if(that.isLoading){
                    return false;
                }
                var url = getBaseUrl() + "api/suggest-products?currentpage="+ page+ "&itemsperpage=20&viewerId=" + that.myID;
                if(page===0){
                    $('#updateTips').show();
                }else{
                    that.bottomLoading = true;
                }
                //api.refreshHeaderLoadDone();
                that.isLoading = true;
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(response));
                    $('#updateTips').hide();
                    that.bottomLoading = false;
                    that.isLoading = false;
                    if(page === 0){
                        that.evaluationList = response.data;
                        var evaluationListDatas = kv.setArray({
                            key: 'evaluationList',
                            value: that.evaluationList
                        });
                    }else{
                        if (response.data.length !== 0) {
                            that.evaluationList = that.evaluationList.concat(response.data);
                        }else{
                            that.haveData = false;
                        }
                    }


                }).catch(function (error) {
                    $('#placeHolderLoad').hide();
                    console.log(JSON.stringify(error));
                });
            },
            openEvaluationDetail: function (index) {
                var title = this.message.evaluation;
                var id = this.evaluationList[index].Id;
                openTabLayout('evaluationDetail', title, 'widget://html/discovery/evaluation-detail.html', {
                    evaluationId: id,
                    index :index
                });
            },
        }
    });
};
