var tProductDetail;
apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    api.setNavBarAttr({
        rightButtons: [{
            iconPath: 'widget://image/share0.png',
            color: '#a1a1a1',
            fontSize: '18'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        //console.log(JSON.stringify(ret));
        if (ret.type ==='right') {
            suggestProduct.preShare();
        } else {
            back();
        }
    });

    api.setWinAttr({
        bounces: false
    });

    api.addEventListener({
        name: 'evaluationVoted'
    }, function(ret, err) {
        suggestProduct.evaluationData.voted = true;
    });

    api.addEventListener({
        name: 'dialogRemarkSuccess'
    }, function (ret, err) {
        suggestProduct.$forceUpdate();
    });

    var appleCheck = api.getGlobalData({
        key: 'appleCheck'
    });

    var suggestProduct = new Vue({
        el: '#suggestProduct',
        data: function () {
            return {
                appleCheck: appleCheck,
                myUserName: localStorage.getItem('userName'),
                switchImg: true,
                isTranslate: false,
                userId: localStorage.getItem('userId'),
                suggestId: api.pageParam.evaluationId,
                evaluationData: api.pageParam.evaluationData,
                productData: {
                    i18nProductName: {
                        zh_CN: '',
                        en_US: ''
                    },
                    i18nProductDescription: {
                        zh_CN: '',
                        en_US: '',
                        translationText: ''
                    },
                    i18nTycoonComment: {
                        zh_CN: '',
                        en_US: '',
                        translationText: ''
                    },
                    i18nProductPitch: {
                        zh_CN: '',
                        en_US: '',
                        translationText: ''
                    },
                    productVideoInfos: [

                    ]
                },
                pics: [],
                videoUrl: null,
                message: MSG
            };
        },
        filters: {

        },
        watch: {

        },
        mounted: function () {
            //this._initSwiper();
        },
        created: function() {
            this.getSuggestDetail();
        },
        methods: {
            _initSwiper: function() {
                setTimeout(function () {
                    initialize();
                }, 100);
            },
            getFormatted: function(nameObj) {
                if (lan === 'zh') {
                    if (nameObj['zh_CN']) {
                        return nameObj['zh_CN'];
                    } else {
                        return nameObj['en_US'];
                    }
                } else {
                    if (nameObj['en_US']) {
                        return nameObj['en_US'];
                    } else {
                        return nameObj['zh_CN'];
                    }
                }
            },
            getLangKey: function() {
                return lan === 'zh' ? 'zh_CN' : 'en_US';
            },
            getSuggestDetail: function() {
                var that = this;
                apiSuggest.get("/api-product/suggest/details", {
                    id: this.suggestId
                }).done(function (rep) {
                    loading('hide');
                    that.isLoading = false;
                    if (rep.code === 0) {
                        var product = rep.data;

                        product.i18nProductDescription.translationText = '';
                        product.i18nTycoonComment.translationText = '';
                        product.i18nProductPitch.translationText = '';

                        var categoryIds = product.productCategories;
                        product.categoryNames = getCategoryNameByIds(categoryIds, lan);

                        var Pics = product.productImageLinks;
                        for (i = 0; i < Pics.length; i++) {
                            that.pics.push(Pics[i].pictureUrl);
                        }

                        if (product.productVideoInfos.length > 0) {
                            that.videoUrl = product.productVideoInfos[0].downloadUrl;
                        }

                        that.productData = product;
                        that._initSwiper();
                    } else {
                        api.toast({
                            msg: rep.responseJSON.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    console.error(JSON.stringify(err));
                });

                function setImageHtml(productImageLinks) {
                    $.map(productImageLinks, function (item, index) {
                        var picData =  {
                            "MediaType": "Picture",
                            "FileName": "testimage.png",
                            "MediaFileUrl": item.pictureUrl,
                            "DownloadUrl": item.pictureUrl,
                            "ThumbnailUrl" : item.thumbnailUrl
                        };
                        $('#uploadImgBox').prepend(
                            getPhotoItem(index, liWith, item.pictureUrl, false)
                        );
                        $("#p" + index).data("picture", picData);
                    });
                }
            },
            toTycoonplace: function() {
                var that = this;
                openUserTycoonPlace(that.productData.userId, that.productData.nickname, that.productData.avatarUrl);
            },
            switchImgVideo:function (type) {
                this.switchImg = type === 'img';
                setTimeout(function () {
                    initialize();
                }, 100);
            },
            openPicture:function(index){
                var that = this;
                console.log(index);
                var UIPhotoViewer = api.require('UIPhotoViewer');
                UIPhotoViewer.open({
                    images: that.pics,
                    placeholderImg: 'widget://image/lost_images.jpg',
                    bgColor: '#000',
                    activeIndex:index,
                    zoomEnabled:true,
                    gestureClose:true
                }, function(Ret, err) {
                    if (Ret.eventType === 'click' ) {
                        UIPhotoViewer.close();
                    }
                });
            },
            showTranslation:function(key){
                var that = this;
                if (that.productData[key].translationText) {
                    that.isTranslate = true;
                    return;
                }
                loading('show');
                var url = getBaseUrl() + '/api/v2/translation';
                var paramStr1 = {
                    "q": that.productData[key][this.getLangKey()],
                    "LanguageCode": lan,
                };
                getAxois(url, "POST", paramStr1).then(function (response) {
                    that.productData[key].translationText = response.data.TranslatedText;
                    loading('hide');
                    that.isTranslate = true;
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@!@!@!@!@!@!@!@');
                });
            },
            preShare: function() {
                var that = this;
                actionSheet([
                    {
                        text: MSG.general.shareto,
                        callback: function () {
                            that.openShareBar();
                        }
                    },
                    {
                        text: MSG.general.repostChat,
                        callback: function () {
                            that.toRepostChatPage();
                        }
                    }
                ]);
            },
            toRepostChatPage: function() {
                var productTitle = this.getFormatted(this.productData.i18nProductName);
                var content = productTitle.replace(REG_SHARE_FILTER, " ");
                if (content && content.length > 50) {
                    content = content.slice(0,50) + '...';
                }
                var title = MSG.suggestion.shareTitle;
                var thumbnail = this.productData.productImageLinks && this.productData.productImageLinks[0]
                        && this.productData.productImageLinks[0].pictureUrl;
                openShareToChats({
                    title: title,
                    description: content,
                    imageUrl: thumbnail,
                    extra: {
                        textType: 'evaluation',
                        evaluationId: api.pageParam.evaluationId,
                        evaluationData: api.pageParam.evaluationData,
                        userId: that.productData.userId,
                        userPortrait: this.productData.avatarUrl,
                        storeName: this.productData.nickname
                    }
                });
            },
            openShareBar: function() {
                var productTitle = this.getFormatted(this.productData.i18nProductName);
                var content = productTitle.replace(REG_SHARE_FILTER, " ");
                if (content && content.length > 50) {
                    content = content.slice(0,50) + '...';
                }

                var title = MSG.suggestion.shareTitle;
                var ShareUrl = 'https://tweebaa.cn/space/html/evaluation.html?evaluationId=' + this.suggestId
                    + "&shareid=" + localStorage.getItem('userName');

                new OpenShareBox(ShareUrl, title, content, this.productData.userName, '', 'evaluation', this.productData.avatarUrl);
            },
            openEvaluationVote: function ($event) {
                $event.stopPropagation();
                var title = this.message.tProduct.evaluation;
                var id = this.productData.id;
                openTabLayout('evaluationDetail', title, 'widget://html/discovery/evaluation-detail.html', {
                    evaluationId: id,
                    productData: this.productData
                });
            },
            openReason: function () {
                openTabLayout('evaluationReject', MSG.evaluation.reasonTitle, 'widget://html/discovery/evaluation-reject.html', {
                    reason: this.productData.reason
                });
            },
            openDigitalProduct:function(){
                var that= this;
                var url = that.productData.productLink;
                // console.log(url);
                var fileType;
                if(url){
                    var videos = ['mp4','mpg','mov','wmv','m3u8'];
                    var pics = ['jpg','jpeg','raw','png','bmp'];
                    var audios =['amr','wav','mp3','m4a'];
                    var text =['txt','doc','docx','xlsx','xls','pdf'];
                    var links = ['com', 'cn', 'io', 'pro'];

                    var key = url.lastIndexOf(".");
                    var xName = (url.substr(key+1)).toLowerCase();

                    if (videos.indexOf(xName) !== -1) {
                        fileType = 'video'
                    } else if (pics.indexOf(xName) !== -1) {
                        fileType = 'image'
                    } else if (audios.indexOf(xName) !== -1) {
                        fileType = 'audios'
                    } else if (text.indexOf(xName) !== -1) {
                        fileType= 'text';
                    }else {
                        fileType = 'other'
                    }
                }
                if(fileType ==='image'){
                    that.imageShow = true;
                    var UIPhotoViewer = api.require('UIPhotoViewer');
                    UIPhotoViewer.open({
                        images: [url],
                        placeholderImg: 'widget://images/lost-img.jpg',
                        bgColor: '#000',
                        zoomEnabled:true,
                        gestureClose:true
                    },function (Ret,err) {
                        if (Ret.eventType === 'click' ) {
                            UIPhotoViewer.close();
                        } else if(Ret.eventType === 'longPress'){
                            api.actionSheet({
                                cancelTitle: MSG.general.cancel,
                                buttons: [MSG.general.save]
                            }, function(ret, err) {
                                var index = ret.buttonIndex;
                                if(index === 1){
                                    api.download({
                                        url: url,
                                        report: true,
                                        cache: true,
                                        allowResume: true
                                    }, function (ret, err) {
                                        if (ret.state === 1) {
                                            var Url= ret.savePath;
                                            api.saveMediaToAlbum({
                                                path: Url,
                                                groupName:"Tweebaa"
                                            }, function(ret, err) {
                                                if (ret && ret.status) {
                                                    alert(MSG.tips.saved);
                                                }
                                            });

                                        }
                                    });
                                }

                            });

                        }
                    });
                }else if(fileType ==='video'){
                    playVideo(url);
                }
                else if( fileType ==='audios'){

                    loading('show');
                    api.download({
                        url: url,
                        report: true,
                        cache: true,
                        allowResume: true,
                        savePath:'fs://downloadPord'+ Date.parse(new Date()) +'.' + xName,
                    }, function(ret, err) {
                        if (ret.state == 1) {
                            loading('hide');
                            openTabLayout('audioPlayer','', 'widget://html/business/audio-player.html',{
                                url:ret.savePath,
                                title:that.productData.Name,
                                pic:that.productData.FeaturedPicture.ThumbnailUrl,
                                owner:that.productData.Owner.StoreName
                            });
                        }
                    });

                }
                else if(fileType === 'text'){

                    if(xName === 'pdf'){
                        openTabLayout('pdfReader','','widget://html/business/pdfreader.html',{
                            file:url
                        })
                    }else {
                        loading('show');
                        api.download({
                            url: url,
                            report: true,
                            cache: true,
                            allowResume: true,
                            savePath:'fs://downloadPord'+ Date.parse(new Date()) +'.' + xName,
                        }, function(ret, err) {
                            if (ret.state == 1) {
                                loading('hide');
                                alert(MSG.tips.fileTips1 +'"' + xName +'"'+ MSG.tips.fileTips2);
                                var docInteraction = api.require('docInteraction');
                                docInteraction.open({
                                    path: ret.savePath
                                }, function(ret, err) {

                                });

                            }
                        });
                    }



                } else if (fileType === 'link') {
                    api.openApp({
                        iosUrl: url,
                        androidPkg: 'android.intent.action.VIEW',
                        mimeType: 'text/html',
                        uri: url
                    });
                } else {

                    alert(MSG.tips.fileTips1 +'"' + xName +'"'+ MSG.tips.fileTips2);
                    api.openApp({
                        iosUrl: url,
                        androidPkg: 'android.intent.action.VIEW',
                        mimeType: 'text/html',
                        uri: url
                    });
                }

            },
        }
    });

};

function initialize() {
    var mySwiper = new Swiper('#proDetailPhoto', {
        direction: 'horizontal',
        loop: false,
        initialSlide: 0,
        pagination: {
            el: '.swiper-pagination',
            type: 'fraction'
        }
    });
    var winWidth = api.winWidth;
    $('#proDetailPhoto').height(winWidth);
    $('.videoDisplay').height(winWidth - 36);
}
