apiready = function(){
    var map = api.require('bMap');
    var mapView = new Vue({
        el: '#mapView',
        mounted: function () {
            this.openMapFunction();
            var msg = lan ==='zh'?'正在将活动区域由中国扩建至世界范围，敬请期待':'We are expanding the activities area from China to the entire world! Stay tuned.';
            alert(msg);
        },
        data: {
            listBtn:'list1',
            activityList:[],
            listData:[],
            organizationsList:[],
            volunteersList:[],
            currentCity:'北京',
            cityId:''
        },
        methods: {
            changeList:function(index){
                this.listBtn = index;
                var that = this;
                switch (index) {
                    case 'list1':
                        that.getListInCity('activities');
                        break;
                    case 'list2':
                        that.getListInCity('organizations');
                        break;
                    case 'list3':
                        that.getListInCity('volunteers');
                        break;
                }
            },
            getListInCity:function(type){
                var that = this;
                var url = getBaseUrl() + "api/voics/city/"+ type +"?districtName="+ that.currentCity;
                //console.log(url);
                getAxois(url,"GET",{}).then(function (response) {
                    console.log(JSON.stringify(response.data));
                    that.listData = [];
                    var preData;
                    var d = response.data;
                    for(i=0;i< d.length;i++){
                        preData = {
                            lat:d[i].Lat,
                            lon:d[i].Long,
                            title:d[i].Name,
                            subtitle:d[i].Address,
                            customID: i.toString()
                        };
                        that.listData.push(preData);
                    }
                    // setTimeout(function () {
                    //     if(that.listData.length>0){
                    //         map.removeCluster();
                    //         map.addCluster({
                    //             styles: {
                    //                 size: {
                    //                     w: 22,
                    //                     h: 22
                    //                 },
                    //                 corner: 11,
                    //                 bg: {
                    //                     point:'',
                    //                     grade:[1,5,10],
                    //                     bgs:['#ea5d6b','#ea5d6b','#ea5d6b'],
                    //                     numberColors:['#fff','#fff','#fff']
                    //                 }
                    //             },
                    //             data:that.listData
                    //         });
                    //     }
                    //
                    // });
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            openMapFunction:function () {
                var that = this;
                console.log('aa');
                //var systemType = api.systemType;

                // if (systemType === 'ios') {
                //     map.initMapSDK(function (ret) {
                //         if (ret.status) {
                //
                //         }
                //     });
                // }

                map.getLocation({
                    accuracy: '10m',
                    autoStop: true,
                    filter: 1
                }, function(ret, err) {
                    if (ret.status) {
                        map.setCenter({
                            coords: {
                                lon: ret.lon,
                                lat: ret.lat,
                            },
                            animation: false
                        });
                        // map.getNameFromCoords({
                        //     lon: ret.lon,
                        //     lat: ret.lat,
                        // }, function(ret, err) {
                        //     console.log(JSON.stringify(err));
                        //     console.log(JSON.stringify(ret));
                        //     if (ret.status) {
                        //         console.log(JSON.stringify(ret));
                        //         that.currentCity = ret.city.substr(0,ret.city.length-1);
                        //         //console.log(that.currentCity);
                        //         //that.getListInCity('activities');
                        //
                        //     }
                        // });
                    }
                });

                map.open({
                    rect: {
                        x: 0,
                        y: 45,
                        w: api.winWidth,
                        h: api.winHeight - 45
                    },
                    center: {
                        lon: 116.4021310000,
                        lat: 39.9994480000
                    },
                    zoomLevel: 11,
                    showUserLocation: true,
                    fixed: true
                }, function(ret,err) {
                    console.log(JSON.stringify(ret));
                    console.log(JSON.stringify(err));
                });

            },
        }
    });


};

function back() {
    api.closeWin();
}
