
apiready = function () {
    var type = api.pageParam.type;
    var page = 0;
    var paramStr;
    if(type === "post"){
        api.setNavBarAttr({
            rightButtons: [{
                text: $.i18n.prop('postActivity'),
                color:'#3eb2c6',
                fontSize:'14'
            }]
        });
    }

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if(ret.type ==='right'){
            myActivityList.createActive();
        }else{
            back();
        }
    });

    api.addEventListener({
        name: 'myActivityListReload'
    }, function (ret, err) {
        page = 0;
        $('#nolist').remove();
        myActivityList.activityList =[];
        myActivityList.getActivityList();
    });

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 300
        }
    }, function (ret, err) {
        page++;
        myActivityList.getActivityList();
    });

    var myActivityList = new Vue({
        el: '#myActivityList',
        mounted: function () {
            this.getActivityList();
        },
        data: {
            activityList:[],
            myID: localStorage.getItem('userId'),
            Type: api.pageParam.type,
            currentIndex:'',
            currentActivityId:'',
        },
        filters: {
            formatTime:function (value) {
                return moment.utc(value).local().format('YYYY.MM.DD');
            },
        },
        methods: {
            getActivityList:function () {
                var that = this;
                var userId = localStorage.getItem('userId');
                if(type === "post"){
                    paramStr = "?createdBy="+ userId +"&itemsperpage=24&currentpage="+page;
                }else{
                    paramStr = "?joinBy="+ userId +"&itemsperpage=24&currentpage="+page;
                }
                var url = getBaseUrl() + "api/charity/voics-activities" + paramStr;
                if(page === 0){
                    loading('show');
                }
                getAxois(url,"GET",{}).then(function (response) {
                    loading('hide');
                    //console.log(JSON.stringify(response));
                    if (response.data.Data.length !== 0) {
                        that.activityList = that.activityList.concat(response.data.Data);
                    }else if(response.data.Data.length === 0 && page ===0 ){
                        var template = '    <div class="text-center" id="nolist" style="margin-top: 10rem">\n' +
                            '        <span class="text-light-gray text-title">'+ $.i18n.prop("noActivity")+'</span>\n' +
                            '    </div>';
                        $('body').append(template);
                    }
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error));
                });
            },
            openActivityDetail: function (id,title) {
                openTabLayout('activityDetail',title,'widget://html/discovery/activity-detail.html',{
                    activityId:id
                });
            },
            openListMenu:function(index){
                var that = this;
                this.currentActivityId = this.activityList[index].Id;
                $('#activityListMenu').addClass('show').on('click',function (e) {
                    var tar  = e.target.id;
                    if(tar ==='activityListMenu'){
                        that.closeActivityListMenu();
                    }
                });
            },
            closeActivityListMenu:function(){
                $('#activityListMenu').removeClass('show');
            },
            disJoinActivity:function(){
                this.closeActivityListMenu();
                var that = this;
                var url = getBaseUrl() + "api/charity/users/"+ that.myID +"/disjoin/voics-activity/" + that.currentActivityId;
                loading('show');
                //console.log(url);
                getAxois(url,"PUT",{}).then(function (response) {
                    loading('hide');
                    //console.log(JSON.stringify(response));
                    $('#'+that.currentActivityId).remove();
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error));
                });
            },
            deleteActivity:function(){
                this.closeActivityListMenu();
                var that = this;
                confirmBox($.i18n.prop('wantDeleteActivity'), $.i18n.prop('cancel'), $.i18n.prop('sure'),'error');
                $('.dialog-box').find('button').on('click',function (e) {
                    $('.dialog-box').remove();
                    var index = $(this).attr('id');
                    if (index === 'btn-2') {
                        var url = getBaseUrl() + "api/charity/delete/voics-activity/" + that.currentActivityId;
                        loading('show');
                        //console.log(url);
                        getAxois(url,"DELETE",{}).then(function (response) {
                            loading('hide');
                            //console.log(JSON.stringify(response));
                            $('#'+that.currentActivityId).remove();
                            api.sendEvent({
                                name: 'discoveryReload'
                            });
                        }).catch(function (error) {
                            loading('hide');
                            console.log(JSON.stringify(error));
                        });
                    }
                });


            },
            createActive:function(){
                openTabLayout('addActivity',$.i18n.prop('postActivity'),'widget://html/discovery/add-activity.html');
            },

        }
    });
};
