apiready = function () {
    backListener();

    api.setWinAttr({
        bounces: false
    });

    var systemType = api.systemType;
    if (systemType === 'android') {
        //检测用户权限
        var resultList = api.hasPermission({
            list: ['location']
        });
        //console.log(JSON.stringify(resultList));
        if (!resultList[0].granted) {
            api.requestPermission({
                list: [resultList[0].name],
                code: 1
            }, function (ret, err) {
                //alert(JSON.stringify(ret));
                if (!ret.list[0].granted) {
                    back();
                }

            });
        }

    }

    api.addEventListener({
        name: 'selectedMap'
    }, function (ret, err) {
        //console.log(ret.value.streetName);
        verifiedName.addressDetail = ret.value.streetName + ret.value.streetNumber;
        verifiedName.lon = ret.value.lon;
        verifiedName.lat = ret.value.lat;
    });

    var today = moment().format('YYYY-MM-DD HH:mm:ss');
    var verifiedName = new Vue({
        el: '#verifiedName',
        mounted: function () {
            //this.getLocation();
            if(Boolean(localStorage.getItem('IDVerified') === 'true')){
                this.getVerified();
                $('#saveBtn').remove();
            }
        },
        data: {
            userId: localStorage.getItem('userId'),
            nationality:'汉族',
            nationalityOption:[{"id":"01","name":"汉族"},{"id":"02","name":"蒙古族"},{"id":"03","name":"回族"},
                {"id":"04","name":"藏族"},{"id":"05","name":"维吾尔族"},{"id":"06","name":"苗族"},
                {"id":"07","name":"彝族"},{"id":"08","name":"壮族"},{"id":"09","name":"布依族"},
                {"id":"10","name":"朝鲜族"},{"id":"11","name":"满族"},{"id":"12","name":"侗族"},
                {"id":"13","name":"瑶族"},{"id":"14","name":"白族"},{"id":"15","name":"土家族"},
                {"id":"16","name":"哈尼族"},{"id":"17","name":"哈萨克族"},{"id":"18","name":"傣族"},
                {"id":"19","name":"黎族"},{"id":"20","name":"傈僳族"},{"id":"21","name":"佤族"},
                {"id":"22","name":"畲族"},{"id":"23","name":"高山族"},{"id":"24","name":"拉祜族"},
                {"id":"25","name":"水族"},{"id":"26","name":"东乡族"},{"id":"27","name":"纳西族"},
                {"id":"28","name":"景颇族"},{"id":"29","name":"柯尔克孜族"},{"id":"30","name":"土族"},
                {"id":"31","name":"达斡尔族"},{"id":"32","name":"仫佬族"},{"id":"33","name":"羌族"},
                {"id":"34","name":"布朗族"},{"id":"35","name":"撒拉族"},{"id":"36","name":"毛难族"},
                {"id":"37","name":"仡佬族"},{"id":"38","name":"锡伯族"},{"id":"39","name":"阿昌族"},
                {"id":"40","name":"普米族"},{"id":"41","name":"塔吉克族"},{"id":"42","name":"怒族"},
                {"id":"43","name":"乌孜别克族"},{"id":"44","name":"俄罗斯族"},{"id":"45","name":"鄂温克族"},
                {"id":"46","name":"崩龙族"},{"id":"47","name":"保安族"},{"id":"48","name":"裕固族"},
                {"id":"49","name":"京族"},{"id":"50","name":"塔塔尔族"},{"id":"51","name":"独龙族"},
                {"id":"52","name":"鄂伦春族"},{"id":"53","name":"赫哲族"},{"id":"54","name":"门巴族"},
                {"id":"55","name":"珞巴族"},{"id":"56","name":"基诺族"}],
            education:'小学',
            educationOption:[{"id":"01", "name":"小学"},{"id":"02", "name":"初中"},{"id":"03", "name":"高中"},{"id":"04", "name":"专科"},
                {"id":"05", "name":"本科"},{"id":"06", "name":"研究生"}],
            political:'群众',
            politicalOption:[{"id":"01", "name":"群众"},{"id":"02", "name":"团员"},{"id":"03", "name":"党员"},{"id":"04", "name":"民主党派"}],
            gender:'M',
            genderSelect:[{"id":"01", "key":"男"},{"id":"02", "key":"女"}],
            idType:'身份证',
            idTypes:[{"id":"01", "key":"身份证"},{"id":"02", "key":"护照"}],
            phone:'',
            email:'',
            birthday:'1949-10-01',
            followType:[],
            name:'',
            idNumber:'',
            selectedAddressInfo:[],
            selectedAddress:'',
            addressDetail:'',
            provincePostalCode:'',
            cityPostalCode:'',
            districtPostalCode: '',
            lon:'',
            lat:'',
            agree:true
        },
        methods:{
            getVerified:function () {
                var that = this;
                var url = getNodeApiUrl() + "users/ver-person/" + this.userId;
                loading('show');
                //console.log(url);
                getNodeAxois(url, "GET", {}).then(function (response) {
                    loading('hide');
                    //console.log(JSON.stringify(response));
                    var d = response.data;
                    that.activityType = d.UserType;
                    that.name = d.FullName;
                    that.idNumber = d.IdNumber;
                    that.nationality = d.Nationality;
                    that.phone = d.Phone;
                    that.education = d.Education;
                    that.genderSelect = d.Gender;
                    that.email = d.Email;
                    that.idType = d.IdType;
                    that.political = d.Political;
                    that.followType = d.FollowType.split(',');
                    that.addressDetail = d.Address;
                    that.selectedAddress = d.ProvinceName + ' ' + d.CityName + ' ' + d.DistrictName;
                    that.organizer = d.Organizer;
                    that.companyName = d.CompanyName;
                    that.organizerType = Number(d.OrganizerType);
                    that.creditCode = d.CreditCode;

                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '#######################');
                    // messages($.i18n.prop('systemError'), 'error', 'top', 3);
                    loading('hide');
                });
            },

            selectBirthday:function(){
                var that =  this;
                var UIDatePicker = api.require('UIDatePicker');
                UIDatePicker.open({
                    type: 'date',
                    rowHeight:40,
                    maxDate:today,
                    date:'1949-10-01 10:10:10',
                    minDate:'1920-01-01 12:30:08',
                    title: '出生日期',
                    styles: {
                        bg: '#fff',
                        headerViewBackgroundColor:'#f0f0f0',
                        lineBackgroundColor: '#fff',
                        item:{
                            normal: '#a1a1a1',
                            normalFont: 14,
                            selected: '#6b6b6b',
                            selectedFont: 17,
                            cancelBtn:{
                                cancelButtonTextColor: '#6b6b6b',
                                cancelButtonText: '取消' ,
                                cancelButtonFont:17
                            },
                            confirmBtn:{
                                confirmButtonTextColor: '#6b6b6b',
                                confirmButtonText: '确定' ,
                                confirmButtonFont:17
                            },
                        }
                    },
                }, function(ret, err) {
                    if (ret) {
                        var m = ret.month >9 ?ret.month : '0'+ret.month;
                        var d = ret.day >9 ?ret.day : '0'+ret.day;
                        that.birthday = ret.year+'-'+ m+'-'+ d;
                    } else {
                        //alert(JSON.stringify(err));
                    }
                });
            },
            submitVerify:function(){
                var that = this;

                if(this.checkInfo()){
                    saving('show');
                    var map = api.require('bMap');
                    map.getCoordsFromName({
                        city: that.selectedAddress,
                        address: that.addressDetail
                    }, function(ret, err) {
                        console.log(ret.lon);
                        var paramStr = {
                            "UserType": 11,
                            "CountryId": "21",
                            "FullName": that.name,
                            "Gender": that.gender,
                            "IdType":that.idType,
                            "IdNumber": Number(that.idNumber),
                            "Birthday":that.birthday,
                            "Nationality": that.nationality,
                            "Phone": that.phone,
                            "ProvinceId": Number(that.provincePostalCode),
                            "CityId": Number(that.cityPostalCode),
                            "DistrictId": Number(that.districtPostalCode),
                            "Address": that.addressDetail,
                            "Education": that.education,
                            "Occupation": '',
                            "FollowType": that.followType,
                            "Email":that.email,
                            "Political":that.political,
                            "Long":ret.lon,
                            "Lat":ret.lat,
                        };
                        var url = getNodeApiUrl() + "users/ver-person/" + that.userId;
                        console.log(JSON.stringify(url));
                        getNodeAxois(url, "POST", paramStr).then(function (response) {
                            saving('hide');
                            localStorage.setItem('IDVerified','true');
                            back();
                        }).catch(function (error) {
                            console.log(JSON.stringify(error) + '#######################');
                            saving('hide');
                        });
                    });

                }
            },
            checkInfo:function(){
                var that =this;
                if(!that.name){
                    messages("请填写姓名", 'error', 'top', 2);
                    return false;
                }else if(!that.idNumber){
                    messages("请填写证件号", 'error', 'top', 2);
                    return false;
                }else if(that.idType ==='身份证' && !that.testId(that.idNumber)){
                    messages("请填写正确身份证号码", 'error', 'top', 2);
                    return false;
                }else if(!that.phone){
                    messages("请填写正确联系电话", 'error', 'top', 2);
                    return false;
                }else if(!that.cityPostalCode){
                    messages("请选择所在区域", 'error', 'top', 2);
                    return false;
                }else if(!that.addressDetail){
                    messages("请填写详细地址", 'error', 'top', 2);
                    return false;
                }else if(!that.agree){
                    messages("需同意阳光实则服务须知", 'error', 'top', 2);
                    return false;
                }else{
                    return true;
                }
            },
            testId:function(id){
                var format = /^(([1][1-5])|([2][1-3])|([3][1-7])|([4][1-6])|([5][0-4])|([6][1-5])|([7][1])|([8][1-2]))\d{4}(([1][9]\d{2})|([2]\d{3}))(([0][1-9])|([1][0-2]))(([0][1-9])|([1-2][0-9])|([3][0-1]))\d{3}[0-9xX]$/;
                if(!format.test(id)){
                    return false;
                }
                var year = id.substr(6,4),
                    month = id.substr(10,2),
                    date = id.substr(12,2),
                    time = Date.parse(month+'-'+date+'-'+year),
                    now_time = Date.parse(new Date()),
                    dates = (new Date(year,month,0)).getDate();
                if(time>now_time||date>dates){
                    return false;
                }
                var c = [7,9,10,5,8,4,2,1,6,3,7,9,10,5,8,4,2];
                var b = ['1','0','X','9','8','7','6','5','4','3','2'];
                var id_array = id.split("");
                var sum = 0;
                for(var k=0;k<17;k++){
                    sum+=parseInt(id_array[k])*parseInt(c[k]);
                }
                return id_array[17].toUpperCase() === b[sum % 11].toUpperCase();

            },
            openDoc:function(){
                openTabLayout('serviceNote','阳光使者服务须知','widget://html/activity/service-note.html')
            },
            addressSelector:function(){
                var that = this;
                var UIActionSelector = api.require('UIActionSelector');
                UIActionSelector.open({
                    datas: 'widget://res/city-v2.json',
                    layout: {
                        row: 5,
                        col: 3,
                        height: 30,
                        size: 12,
                        sizeActive: 14,
                        rowSpacing: 5,
                        colSpacing: 10,
                        maskBg: 'rgba(0,0,0,0.2)',
                        bg: '#fff',
                        color: '#6b6b6b',
                        colorActive: '#3eb2c6',
                        colorSelected: '#3eb2c6'
                    },
                    animation: true,
                    cancel: {
                        text: '取消',
                        size: 12,
                        w: 90,
                        h: 35,
                        bg: '#fff',
                        bgActive: '#ccc',
                        color: '#6b6b6b',
                        colorActive: '#fff'
                    },
                    ok: {
                        text: '确定',
                        size: 12,
                        w: 90,
                        h: 35,
                        bg: '#fff',
                        bgActive: '#ccc',
                        color: '#6b6b6b',
                        colorActive: '#fff'
                    },
                    title: {
                        text: '请选择',
                        size: 12,
                        h: 44,
                        bg: '#f0f0f0',
                        color: '#6b6b6b'
                    },
                }, function(ret, err) {
                    if (ret.eventType === 'ok') {
                        if(ret.selectedInfo[0].id !== 7050){
                            that.selectedAddress = ret.level1+' '+ret.level2+' '+ret.level3;
                            that.provincePostalCode = ret.selectedInfo[0].id;
                            that.cityPostalCode = ret.selectedInfo[1].id;
                            that.districtPostalCode = ret.selectedInfo[2].id;
                        }

                    }
                });
            },

        }

    });
};
