apiready = function () {
    backListener();

    api.setWinAttr({
        bounces: false
    });

    api.addEventListener({
        name: 'selectedMap'
    }, function (ret, err) {
        verifiedName.lon = ret.value.lon;
        verifiedName.lat = ret.value.lat;
    });

    var systemType = api.systemType;
    if (systemType === 'android') {
        //检测用户权限
        var resultList = api.hasPermission({
            list: ['location']
        });
        //console.log(JSON.stringify(resultList));
        if (!resultList[0].granted) {
            api.requestPermission({
                list: [resultList[0].name],
                code: 1
            }, function (ret, err) {
                //alert(JSON.stringify(ret));
                if (!ret.list[0].granted) {
                    back();
                }

            });
        }

    }

    api.addEventListener({
        name: 'selectedMap'
    }, function (ret, err) {
        //console.log(ret.value.streetName);
        verifiedName.lon = ret.value.lon;
        verifiedName.lat = ret.value.lat;
    });

    var verifiedName = new Vue({
        el: '#verifiedName',
        mounted: function () {
            var that = this;
            if(Boolean(localStorage.getItem('VerifiedOrg') === 'true')){
                this.getVerified();
                $('#saveBtn').remove();
            }
            var url ='../../res/country.json';
            //console.log(url);
            $.getJSON(url, function( data ) {
                //console.log(JSON.stringify(data));
                that.countryList = data;
                that.country = localStorage.getItem('countryCode');
            });
        },
        data: {
            userId: localStorage.getItem('userId'),
            creditCode:'',
            companyName:'',
            phone:'',
            email:'',
            contactName:'',
            followType:[],
            country:localStorage.getItem('countryCode'),
            countryList:'',
            selectedAddressInfo:[],
            selectedAddress:'',
            addressDetail:'',
            description:'',
            lon:'',
            lat:'',
            lang:lan==='zh'?'cnName':'enName'
        },

        methods:{
            getVerified:function () {
                var  url;
                var that = this;
                url = getNodeApiUrl() + "users/ver-org/" + this.userId;
                loading('show');
                getNodeAxois(url, "GET", {}).then(function (response) {
                    loading('hide');
                    var d = response.data;
                    that.name = d.FullName;
                    // that.idNumber = d.IdNumber;
                    // that.nationality = d.Nationality;
                    that.phone = d.Phone;
                    that.email = d.Email;
                    that.addressDetail = d.Address;
                    that.companyName = d.CompanyName;
                    // that.creditCode = d.CreditCode;
                    that.contactName = d.ContactName;
                    that.country = d.Country;
                    that.description = d.Description;
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '#######################');
                    // messages($.i18n.prop('systemError'), 'error', 'top', 3);
                    loading('hide');
                });
            },
            markOnMap:function(){
                var systemType = api.systemType;
                if (systemType === 'android') {
                    var resultList = api.hasPermission({
                        list: ['location']
                    });
                    if (!resultList[0].granted) {
                        api.requestPermission({
                            list: [resultList[0].name],
                            code: 1
                        }, function (ret, err) {
                            if (ret.list[0].granted) {
                                openWindows("mapSelector",'widget://html/discovery/map-selector.html',{
                                    type:'set'
                                });
                            }
                        });
                    }else{
                        openWindows("mapSelector",'widget://html/discovery/map-selector.html',{
                            type:'set'
                        });
                    }

                }else{
                    openWindows("mapSelector",'widget://html/discovery/map-selector.html',{
                        type:'set'
                    });
                }
            },
            submitVerify:function(){
                var that = this;
                if(this.checkInfo()){

                    var paramStr = {
                        "UserType": 13,
                        "CompanyName":that.companyName,
                        "ContactName":that.contactName,
                        "Phone": that.phone,
                        "Address": that.addressDetail,
                        // "CreditCode":that.creditCode,
                        "Email":that.email,
                        "Long":that.lon,
                        "Lat":that.lat,
                        "VerifyCountryCode":that.country,
                        "Description":that.description
                    };
                    var url = getNodeApiUrl() + "users/ver-org/" + that.userId;
                    //console.log(JSON.stringify(paramStr));
                    saving('show');
                    getNodeAxois(url, "POST", paramStr).then(function (response) {
                        //console.log(JSON.stringify(response));
                        saving('hide');
                        api.toast({
                            msg: MSG.general.success,
                            duration: 2000,
                            location: 'middle'
                        });
                    }).catch(function (error) {
                        console.log(JSON.stringify(error) + '#######################');
                        saving('hide');
                    });
                }
            },
            checkInfo:function(){
                var that =this;
                if(!that.companyName){
                    messages("请填写名称", 'error', 'top', 2);
                    return false;
                }else if(!that.contactName){
                    messages("请填写正确联系人", 'error', 'top', 2);
                    return false;
                }else if(!that.phone){
                    messages("请填写正确联系电话", 'error', 'top', 2);
                    return false;
                }else if(!that.addressDetail){
                    messages("请选输入细地址", 'error', 'top', 2);
                    return false;
                }else{
                    return true;
                }
            },
            toDownloadPage:function(){
                api.openApp({
                    androidPkg: 'android.intent.action.VIEW',
                    mimeType: 'text/html',
                    uri: shareH5Host + '/html/download.html',
                    iosUrl:shareH5Host + '/html/download.html'
                });
            },

        }

    });
};
