
apiready = function () {
    if(api.systemType ==='android'){
        api.setTabLayoutAttr({
            hideNavigationBar: true
        });
    }
    backListener();

    api.setWinAttr({
        bounces: false,
        slidBackEnabled:true,
        hideHomeIndicator:true,
    });

    var volunteerDetail = new Vue({
        el: '#volunteerDetail',
        data: {
            volunteerData:JSON.parse(api.pageParam.data),
            Verified:Boolean(localStorage.getItem('OrgVerified') === 'true'),
            followTypes: JSON.parse(api.pageParam.data).FollowType.split(','),
        },
        filters: {
            showGender:function (value) {
                if(value === 'M'){
                    return "男";
                }else{
                    return "女";
                }
            },
            hideInfo:function (value) {
                if(Boolean(localStorage.getItem('OrgVerified') === 'true')){
                    return value;
                }else{
                    return "组织认证后可见";
                }
            },
            showFollowType:function (value) {
                var name;
                switch (value) {
                    case '1':
                        name = "扶贫济困";
                        break;
                    case '2':
                        name = "社区服务";
                        break;
                    case '3':
                        name = "关爱服务";
                        break;
                    case '4':
                        name = "文化教育";
                        break;
                    case '5':
                        name = "医疗卫生";
                        break;
                    case '6':
                        name = "法律维权";
                        break;
                    case '7':
                        name = "绿色环保";
                        break;
                    case '8':
                        name = "应急救援";
                        break;
                    case '9':
                        name = "交通旅游";
                        break;
                    case '10':
                        name = "文明礼仪";
                        break;
                    case '11':
                        name = "消防宣传";
                        break;
                    case '12':
                        name = "赛会服务";
                        break;
                    case '13':
                        name = "网络文明";
                        break;
                    case '14':
                        name = "国际服务";
                        break;
                    case '15':
                        name = "其他";
                        break;
                }
                return name;
            }
        },
        methods: {
            openTycoonPlace:function () {
                openUserTycoonPlace(this.volunteerData.User.Id, this.volunteerData.User.StoreName, this.volunteerData.User.AvatarUrl);
            },
            addressDetailFunction:function(){
                var that = this;
                if(that.Verified){
                    return that.volunteerData.Province.Name +' '+that.volunteerData.City.Name+' '+ that.volunteerData.District.Name+'区 '+that.volunteerData.Address;
                }else{
                    return  "组织认证后可见";
                }
            },
            phoneCall:function () {
                var that = this;
                if(that.Verified){
                    api.call({
                        type: 'tel_prompt',
                        number: that.volunteerData.Phone
                    });
                }else{
                    api.toast({
                        msg: '组织认证后可拨打电话',
                        duration: 2000,
                        location: 'bottom'
                    });
                }
            },
            openPortrait:function(){
                var UIPhotoViewer = api.require('UIPhotoViewer');
                var that = this;
                UIPhotoViewer.open({
                    images: [that.volunteerData.User.AvatarUrl],
                    bgColor: '#000',
                    zoomEnabled:true,
                    gestureClose:true
                }, function(ret, err) {
                    if (ret.eventType === 'click' ) {
                        UIPhotoViewer.close();
                    } else if(ret.eventType === 'longPress'){
                        api.actionSheet({
                            cancelTitle: $.i18n.prop('cancel'),
                            buttons: [$.i18n.prop('saveImage')]
                        }, function(ret, err) {
                            console.log(JSON.stringify(ret));
                            var index = ret.buttonIndex;
                            if(index === 1){
                                loading('show');
                                api.download({
                                    url: that.avatarUrl,
                                    report: true,
                                    cache: true,
                                    allowResume: true
                                }, function (ret, err) {
                                    if (ret.state === 1) {
                                        var Url= ret.savePath;
                                        loading('hide');
                                        api.saveMediaToAlbum({
                                            path: Url,
                                            groupName:"Tweebaa"
                                        }, function(ret, err) {
                                            if (ret && ret.status) {
                                                alert($.i18n.prop('imgSaved'));

                                            }
                                        });

                                    }
                                });
                            }

                        });

                    }
                });

            },
        }
    });

};
