/**
 * @file
 * @author jinguangguo
 * @date 10/06/2020 12:36 PM
 */

var editor = {
    _opt: {
        placeholder: '请输入文章正文内容',
        insertImageId: 'editorInsert',
        validHtml: ["<br/>"],
        content: '', // 初始化内容
        test: false
    },
    $element: null,
    $insertImg: null,
    $input: null,

    _initDom: function(element) {
        this.$element = $(element);
        this.element = element;
        var styles = {
            "-webkit-user-select": "text",
            "user-select": "text",
            "overflow-y": "auto",
            "text-break": "break-all",
            "outline": "none",
            "cursor": "text"
        };
        this.$element.css(styles).attr("contenteditable", true);
        this.$element.attr("contenteditable", true);

        // if (api.systemType === 'android') {
            var insertImgText = lan === 'zh' ? '插入图片' : 'Insert Image';
            this.$insertImg  = $('<div class="editor-insert ui-border-t" id="editorInsert">\n' +
                '                    <i class="icon iconfont icon-tupian1"></i>\n' +
                '                    <span class="text">' + insertImgText + '</span>\n' +
                '                </div>');

            this.$element.after(this.$insertImg);
        // }

    },
    _bind: function() {
        var that = this;
        // if (api.systemType === 'android') {
            //插入图片
            this.$insertImg.click(function () {
                that._selectImagesFromAlbum();
            });
        // }

        that.$element.on('input click', function() {
            setTimeout(function() {
                var selection = window.getSelection ? window.getSelection() : document.selection;
                that.range = selection.createRange ? selection.createRange() : selection.getRangeAt(0);
                // var cursorPos = that.element.selectionStart;
                // console.log('cursorPos: ' + cursorPos);
            }, 10);
            return false;
        });

        // this.$element.on('change', function () {
        //     console.log($(this).html());
        // });
        // this.pasteHandler();
    },
    initEditor: function (element, options) {
        this._opt = $.extend(this._opt, options);
        this._initDom(element);

        if (this._opt.content) {
            this._setValue(this._opt.content);
        }
        this._placeholderHandler();
        this._bind();
    },
    _selectImagesFromAlbum: function () {
        var that = this;
        var UIAlbumBrowser = api.require('UIAlbumBrowser');
        UIAlbumBrowser.open({
            max: 9,
            isOpenPreview:true,
            classify:true,
            type:'image',
            alertTitle: lan ==="zh"?"最多能选9张图片":"More then 9 pictures",
            alertBtnTitle:"OK",
            styles: {
                bg: '#FFFFFF',
                cameraImg: 'widget://res/cameraImg.png',
                mark: {
                    icon: '',
                    position: 'bottom_left',
                    size: 20
                },
                nav: {
                    bg: '#252525',
                    cancelColor: '#fff',
                    cancelSize: 16,
                    nextStepColor: '#fff',
                    nextStepSize: 16,
                    cancelText: lan === 'zh'?'取消':'Cancel',
                    finishText: 'OK',
                },
                bottomTabBar: {
                    bg: 'rgba(0,0,0,0.6)',
                    unPreviewTitleColor:'rgba(0,0,0,0.25)',
                    previewTitleColor: '#fff',
                    previewTitle:lan === 'zh'?'预览':'Preview',
                    previewTitleSize: 15,
                }
            },
        }, function (ret) {
            if (ret.eventType === 'confirm') {
                //UIAlbumBrowser.closePicker();

                var path = ret.list;

                var len = path.length;
                if (api.systemType.toLowerCase() === "ios") {
                    //console.log(JSON.stringify(path));
                    for (i = 0; i < len; i++) {
                        UIAlbumBrowser.transPath({
                            quality: 'highest',
                            scale: 1, //
                            path: path[i].path
                        }, function (ret, err) {
                            that._setImagesNew(ret.path);
                        });
                    }
                } else {
                    for (J = 0; J < len; J++) {
                        that._setImagesNew(path[J].path);
                    }
                }

            }
        });
    },
    _setImagesNew: function(path) {
        loading('show');
        var that = this;
        var savePath = api.fsDir;
        var specialStr = path.substring(path.lastIndexOf('/') + 1).split(".")[0];
        var imageFilter = api.require('imageFilter');
        var pattern = new RegExp("[`/~@#$^&=|{}':;, \\[\\]<>￥…‘；：”“。，、？+]");
        var picName = "";
        for (var i = 0; i < specialStr.length; i++) {
            picName += specialStr.substr(i, 1).replace(pattern, '');
        }
        imageFilter.getAttr({
            path: path
        },function( ret, err ){
            if( ret.status ){

                var originWidth = ret.width;
                var originHeight = ret.height;

                var S = 1;
                if(originWidth > 3000){
                    S = 0.35;
                } else if(originWidth >= 1000 ){
                    S = 0.5;
                }else{
                    S = 0.8;
                }

                var Q = 1;
                if (ret.size > 204800) {
                    Q = 0.6;
                } else if (ret.size >= 102400) {
                    Q = 0.8;
                } else {
                    Q = 1;
                }

                imageFilter.compress({
                    img: path,
                    quality: Q,
                    scale:S,
                    // size:{
                    //     w:targetWidth,
                    //     h:targetHeight
                    // },
                    save:{
                        album: false,
                        imgPath: savePath + '/tweebaaCache/',
                        imgName: picName + '.jpg',
                    }
                },function( ret, err ){
                    if( ret.status ){

                        // imageFilter.getAttr({
                        //     path: savePath + '/tweebaaCache/' + picName + '.jpg'
                        // },function( ret, err ){
                        //     if( ret.status ){
                        //         alert( JSON.stringify( ret ) );
                        //     }else{
                        //         alert( JSON.stringify( err ) );
                        //     }
                        // });

                        var imgPath = savePath + '/tweebaaCache/' + picName + '.jpg';


                        if (that._opt.test === true) {
                            var src = 'https://tweebaafiles.oss-accelerate.aliyuncs.com/upload/images/2020-10-13/1d09b9a0-0613-45c9-b926-3d157f95b100.jpg';
                            var img = '<img src="' + src + '" style="max-width:100%;" />';
                            that._insertImage(img);
                            loading('hide');
                        } else {
                            that._uploadImagesNew(imgPath);
                        }

                    }else{
                        alert( JSON.stringify( err ) );
                    }
                });

            }else{
                //alert( JSON.stringify( err ) );
            }

        });
    },
    _insertImage: function (src) {
        var that = this;
        this.$element.focus();
        // var selection = window.getSelection ? window.getSelection() : document.selection;
        var selection;

        if (window.getSelection) {
            selection = window.getSelection();
        } else {
            selection = document.selection;
        }
        var range;
        if (this.range) {
            range = this.range;
            this.range = null;
        } else {
            if (selection.createRange) {
                range = selection.createRange();
            } else {
                range = selection.getRangeAt(0);
            }
        }
        if (!window.getSelection) {
            range.pasteHTML(src);
            range.collapse(false);
            range.select();
        } else {
            // 安卓
            // 设置为非折叠（即光标起点和结束点重叠在一起）
            range.collapse(false);
            // 创建图片节点
            var hasR = range.createContextualFragment(src);

            // 清理<br>
            var hasLastChild = hasR.lastChild;
            while (hasLastChild && hasLastChild.nodeName.toLowerCase() == "br"
                    && hasLastChild.previousSibling && hasLastChild.previousSibling.nodeName.toLowerCase() == "br") {
                var e = hasLastChild;
                hasLastChild = hasLastChild.previousSibling;
                hasR.removeChild(e);
            }

            range.insertNode(range.createContextualFragment("<br/>"));
            range.insertNode(hasR);
            // range.insertNode(range.createContextualFragment("<br/>"));
            if (hasLastChild) {
                range.setEndAfter(hasLastChild);
                range.setStartAfter(hasLastChild);
            }
            selection.removeAllRanges();
            selection.addRange(range);

            // setTimeout(function () {
            //     that.$element.focus();
            //     // console.log(JSON.stringify($img.offset()));
            //     var $lastImg = that.$element.find('img').last();
            //     console.log(JSON.stringify($lastImg.offset()));
            //     setTimeout(function () {
            //         $('body').animate({ scrollTop: $lastImg.offset().top }, 'normal');
            //     }, 100)
            // }, 500);
        }

        // console.log('===============' + this.$element.html());
    },
    _uploadImagesNew: function(filepath) {
        var that = this;
        apiMedia.upload("/upload/images", filepath).done(function (response) {
            //console.log("[" + api.deviceName + "]" + JSON.stringify(response));

            loading('hide');

            var data = response.data[0];

            var imgURL = data.raw;
            var ThumbnailUrl = data.thumbnail;

            var pic = {
                "MediaType": "Picture",
                "FileName": "testimage.png",
                "MediaFileUrl": imgURL,
                "DownloadUrl": imgURL,
                "ThumbnailUrl": ThumbnailUrl
            };

            var img = '<img src="' + pic.DownloadUrl + '">';
            that._insertImage(img);
        });
    },
    _getValue: function () {
        return this.$element.html();
    },
    _setValue: function (str) {
        this.$element.html(str);
        if (this._opt.onInput) {
            this._opt.onInput(str);
        }
    },
    _placeholderHandler: function () {
        var _this = this;
        var imgReg = /<img\s*([\w]+=(\"|\')([^\"\']*)(\"|\')\s*)*\/?>/;
        var $dom = $('<div class="placeholder">' + _this._opt.placeholder + '</div>');

        if (!$.trim(this.$element.text()) && !imgReg.test(this.$element.html())) {
            this.$element.after($dom);
        }

        this.$element.on('focus', function () {
            // 隐藏
            $dom.hide();
        }).on('blur', function () {
            // 显示
            if (!$.trim($(this).text()) && !imgReg.test($(this).html())) {
                $dom.show();
            }
        });

        $dom.on('click', function () {
            _this.$element.focus();
        });

    },
    /**
     * FIXME
     * 这里的粘贴监听暂时不好使，待深度调研
     */
    pasteHandler: function () {
        var _this = this;
        this.$element.on("paste", function (e) {
            console.log(123);
            console.log(e.clipboardData.items);
            var content = $(this).html();
            console.log(content);
            valiHTML = _this._opt.validHtml;
            content = content.replace(/_moz_dirty=""/gi, "")
                .replace(/\[/g, "[[-")
                .replace(/\]/g, "-]]")
                .replace(/<\/ ?tr[^>]*>/gi, "[br]")
                .replace(/<\/ ?td[^>]*>/gi, "&nbsp;&nbsp;")
                .replace(/<(ul|dl|ol)[^>]*>/gi, "[br]")
                .replace(/<(li|dd)[^>]*>/gi, "[br]")
                .replace(/<p [^>]*>/gi, "[br]")
                .replace(new RegExp("<(/?(?:" + valiHTML.join("|") + ")[^>]*)>", "gi"), "[$1]")
                .replace(new RegExp('<span([^>]*class="?at"?[^>]*)>', "gi"), "[span$1]").replace(/<[^>]*>/g, "")
                .replace(/\[\[\-/g, "[").replace(/\-\]\]/g, "]")
                .replace(new RegExp("\\[(/?(?:" + valiHTML.join("|") + "|img|span)[^\\]]*)\\]", "gi"), "<$1>");
            content = content.replace(/\r?\n/gi, "<br>");
            $(this).html(content);
        });
        // this.$element.bind('input propertychange', function (e) {
        //     console.log(123);
        //     var clipBoard = api.require('clipBoard');
        //     clipBoard.get(function(ret, err) {
        //         var value = ret.value;
        //         _this._setValue(value);
        //     });
        // });
    },
};

$.fn.extend({
    editor: function (opts) {
        var element = this;
        editor.initEditor(element, opts);
    }
});
