
apiready = function () {
    //进入页面统计点
    var td = api.require('talkingData');
    td.onPageStart({pageName:'通知中心'});

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    var kv = api.require('snKVStorage');

    api.setNavBarAttr({
        rightButtons: [{
            text: '•••',
            color: '#4d4d4d',
            fontSize: '16'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if (ret.type === 'right') {
            actionSheet([
                {
                    text: MSG.notif['allRead'],
                    callback: function () {
                        NotifyCategory.readAll('All');
                    }
                },
                {
                    text: MSG.notif['deleteAll'],
                    callback: function () {
                        NotifyCategory.removeAll('All');
                    }
                }
            ]);
        } else {
            back('通知中心');
        }
    });

    //下拉刷新
    api.setRefreshHeaderInfo({
        loadingImg:'widget://image/refresh-logo.png',
        bgColor: '#fff',
        textColor: '#000',
        textDown: MSG.tips.pullDownRefresh,
        textLoading: MSG.tips.refreshing,
        showTime: false,
        textUp:  MSG.tips.releaseRefresh
    }, function (ret, err) {
        api.refreshHeaderLoadDone();
        NotifyCategory._initNotify();
    });

    api.addEventListener({
        name: 'ReloadNotifyCategory',
    }, function (ret, err) {
        NotifyCategory._initNotify();
    });

    api.addEventListener({
        name: 'dialogRemarkSuccess'
    }, function (ret, err) {
        NotifyCategory.$forceUpdate();
    });

    var NotifyCategory = new Vue({
        el: '#notifyCategory',
        mounted: function () {

        },
        created: function() {
            var that = this;
            if (localStorage.getItem('access_token')) {
                this._initNotify();
            }
        },
        data: {
            Follow: {
                unreadCount: 0,
                latest: null
            },
            Comment: {
                unreadCount: 0,
                latest: null
            },
            Reward: {
                unreadCount: 0,
                latest: null
            },
            Order: {
                unreadCount: 0,
                latest: null
            },
            Tweelog: {
                unreadCount: 0,
                latest: null
            },
            Other: {
                unreadCount: 0,
                latest: null
            },
            message: MSG,
            isLoggedIn: kv.getBool({key: 'isLoggedIn'}),
            muteUnreadCount: 0
        },
        filters: {
            formatTime:function (value) {
                return moment.utc(value).local().format('MM-DD HH:mm')
            }
        },
        methods:{
            _initNotify: function() {
                this._fetchData();
            },
            _fetchData: function() {
                var that = this;
                var userName = localStorage.getItem('userName');
                loading('show');
                apiNotify.get("/notification/" + userName + "/summary", {}).done(function (rep) {
                    loading('hide');
                    if (rep.code === 0) {
                        var list = rep.data;
                        if (list.length > 0) {
                            $.map(list, function (item, index) {
                                that[item.type].unreadCount = item.unreadCount;
                                if (item.latest) {
                                    item.latest.contentObj = JSON.parse(item.latest.content);
                                    if (!item.latest.contentObj.Type) {
                                        item.latest.contentObj.Type = item.latest.contentObj.type;
                                    }
                                }
                                that[item.type].latest = item.latest;
                            });
                        }
                    } else {
                        api.toast({
                            msg: rep.responseJSON.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    console.error(JSON.stringify(err));
                });
            },
            openNotifyPage: function(event, params) {
                var pageTitle = params.pageTitie;
                var type = params.type;
                openTabLayout('notifyList', pageTitle, '../../html/users/notify-list.html', {
                    type: type
                });
            },
            showNotifyBtns: function(event, params) {
                var type = params.type;
                var tar = event.target;
                var that = this;
                var list = that[type].list;

                $(tar).closest('.notify').addClass('pressDown');

                actionSheet([
                    {
                        text: MSG.notif['allRead'],
                        callback: function () {
                            that.readAll(type);
                            that._initNotify();
                        }
                    },
                    {
                        text: MSG.notif['deleteAll'],
                        callback: function () {
                            that.removeAll(type);
                            that._initNotify();
                        }
                    }
                ], function () {
                    $('.notify-list').find('.notify').removeClass('pressDown');
                });

            },
            readAll: function(type) {
                var that = this;
                loading('show');
                apiNotify.edit("/notification/all", {
                    type: type,
                    action: 'READ',
                    username: localStorage.getItem('userName')
                }).done(function (rep) {
                    loading('hide');
                    if (rep.code === 0) {
                        that._fetchData();
                        api.toast({
                            msg: MSG.general.success,
                            duration: 2000,
                            location: 'middle'
                        });
                        api.sendEvent({
                            name: 'workplaceReload',
                            extra: {
                                type: 'notify'
                            }
                        });
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    api.toast({
                        msg: MSG.tips.systemError,
                        duration: 2000,
                        location: 'middle'
                    });
                });
            },
            removeAll: function(type) {
                var that = this;
                loading('show');
                apiNotify.edit("/notification/all", {
                    type: type,
                    action: 'DELETE',
                    username: localStorage.getItem('userName')
                }).done(function (rep) {
                    loading('hide');
                    if (rep.code === 0) {
                        that._fetchData();
                        api.toast({
                            msg: MSG.general.success,
                            duration: 2000,
                            location: 'middle'
                        });
                        api.sendEvent({
                            name: 'workplaceReload',
                            extra: {
                                type: 'notify'
                            }
                        });
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    api.toast({
                        msg: MSG.tips.systemError,
                        duration: 2000,
                        location: 'middle'
                    });
                });
            }
        }
    });

};
