
function iniNotif() {
    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });
    if (!token) return;

    var userName = localStorage.getItem('userName');

    if (userName) {
        if (isConnected()) {
            setupNotifClient_Mock(userName, token);
        }

        api.addEventListener({name: 'online'}, function (ret, err) {
            setupNotifClient_Mock(userName, token);
        });

        api.addEventListener({name: 'offline'}, function (ret, err) {
            api.toast('No network connection!');
        });
    }

}

function setupNotifClient_Mock(user, token) {

    if (!isConnected()) {
        return;
    }

    connectByNewStomp();
    // connectByOldStomp();

    // 对应文档
    // https://stomp-js.github.io/guide/stompjs/using-stompjs-v5.html
    function connectByNewStomp() {
        var socketUrl;
        if (SERVER_HOSTS.dev === true) {
            if (localStorage.getItem('server') === 'cn') {
                socketUrl = SERVER_HOSTS.NOTIFICATION.SOCKET_TEST;
            } else {
                socketUrl = SERVER_HOSTS.NOTIFICATION.SOCKET_TEST_COM;
            }
        } else {
            socketUrl = SERVER_HOSTS.NOTIFICATION.SOCKET_PROD;
        }
        const client = new StompJs.Client({
            brokerURL: socketUrl + '/ws/websocket',
            connectHeaders: {
                token: token,
                username: user
            },
            debug: function (str) {
                console.log(str);
            },
            reconnectDelay: 5000,
            heartbeatIncoming: 4000,
            heartbeatOutgoing: 4000,
        });

        client.onConnect = function (frame) {
            // Do something, all subscribes must be done is this callback
            // This is needed because this will be executed after a (re)connect
            console.log("[" + api.deviceName + "] ws connect ---------------------------------------------");
            console.log("[" + api.deviceName + "] ws connect " + JSON.stringify(frame));
            console.log("[" + api.deviceName + "] ws connect ---------------------------------------------");

            // 通知中心
            client.subscribe('/user/queue/messages', function (message) {
                console.log("[" + api.deviceName + "] 消息监听开始...");
                console.log("[" + api.deviceName + "]" + JSON.stringify(message));

                api.sendEvent({
                    name: 'workplaceReload',
                    extra: {
                        type: 'notify'
                    }
                });

                api.sendEvent({
                    name: 'ReloadNotifyCategory'
                });

                var notify = JSON.parse(message.body);
                // 插入到详情列表中
                api.sendEvent({
                    name: 'insertNotify',
                    extra: {
                        notify: notify
                    }
                });
            });

            // TiV奖励
            client.subscribe('/user/queue/rewards', function (message) {
                // console.log(new Date());
                // console.log("[" + api.deviceName + "] 消息监听开始...");
                // console.log("[" + api.deviceName + "]" + JSON.stringify(message));

                // var binaryBody = message._binaryBody;
                // var results = [];
                // $.map(binaryBody, function (item, key) {
                //     results.push(item);
                // });
                // var str = String.fromCharCode.apply(String, results);
                // console.log("[" + api.deviceName + "]" + JSON.stringify(str));

                var notify = JSON.parse(message.body);
                console.log("[" + api.deviceName + "]" + JSON.stringify(notify));

                if (notify.show === true) {
                    api.sendEvent({
                        name: 'showTiV',
                        extra: {
                            notify: notify
                        }
                    });
                }

            });

            // 系统通知
            client.subscribe('/topic/announcements', function (message) {
                var announcement = JSON.parse(message.body);
                console.log("[" + api.deviceName + "]" + JSON.stringify(announcement));

                announcementUtil.saveLocalAnnouncement(announcement);
                api.sendEvent({
                    name: 'insertNewAnnouncement',
                    extra: {
                        announcement: announcement
                    }
                });
            });

        };

        client.onStompError = function (frame) {
            // Will be invoked in case of error encountered at Broker
            // Bad login/passcode typically will cause an error
            // Complaint brokers will set `message` header with a brief message. Body may contain details.
            // Compliant brokers will terminate the connection after any error
            console.log('Broker reported error: ' + frame.headers['message']);
            console.log('Additional details: ' + frame.body);
        };

        client.activate();
    }

    // function connectByApiCloud() {
        // var ws = api.require('webSocket');
        //
        // ws.addEventListener(function (ret, err) {
        //
        //     if (err) {
        //         console.warn("[" + api.deviceName + "] err ..." + JSON.stringify(err));
        //     }
        //
        //     console.log("[" + api.deviceName + "] ret ..." + JSON.stringify(ret));
        //
        //     console.log("[" + api.deviceName + "] status ..." + ret.status);
        //
        //     switch (ret.evenType) {
        //         case 'Connected':
        //             console.log("[" + api.deviceName + "] Connected ...");
        //             break;
        //         case 'ReturnData':
        //             console.log("[" + api.deviceName + "] ReturnData ...");
        //             console.log("[" + api.deviceName + "] data ..." + JSON.stringify(ret.data));
        //             break;
        //         case 'Closed':
        //             console.log("[" + api.deviceName + "] Closed ...");
        //             break;
        //         case 'reConnect':
        //             console.log("[" + api.deviceName + "] reConnect ...");
        //             break;
        //     }
        //
        // });
        //
        // ws.open({
        //     url: 'ws://notification.tweebaa.cn:8122' + '/ws'
        // }, function(ret, err) {
        //     console.log("[" + api.deviceName + "] open ..." + JSON.stringify(ret));
        // });
    // }

    function connectByOldStomp() {
        var tycoonSocket = {};

        var socket = new SockJS(SERVER_HOSTS.NOTIFICATION.PROD + '/ws');
        tycoonSocket = Stomp.over(socket);
        tycoonSocket.heartbeat.outgoing = 10000;
        tycoonSocket.heartbeat.incoming = 10000;
        tycoonSocket.reconnect_delay = 5000;
        tycoonSocket.connect({
            token: token,
            username: user
        }, function (frame) {
            console.log("[" + api.deviceName + "] ws connect ---------------------------------------------");
            console.log("[" + api.deviceName + "] ws connect " + JSON.stringify(frame));
            console.log("[" + api.deviceName + "] ws connect ---------------------------------------------");
            tycoonSocket.subscribe('/user/queue/messages', function (message) {
                console.log("[" + api.deviceName + "] 消息监听开始...");
                console.log("[" + api.deviceName + "]" + JSON.stringify(message));

                api.sendEvent({
                    name: 'workplaceReload',
                    extra: {
                        type: 'notify'
                    }
                });

                api.sendEvent({
                    name: 'ReloadNotifyCategory'
                });

                var notify = JSON.parse(message.body);
                // 插入到详情列表中
                api.sendEvent({
                    name: 'insertNotify',
                    extra: {
                        notify: notify
                    }
                });
            });
        });
    }



}

function errorHandle(error) {
    if (error) {
        log(error);
    }
}

function isConnected(){
    // return false;
    return CONNECTION_TYPE.indexOf(api.connectionType.toUpperCase()) > -1;
}


