
apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    api.setWinAttr({bounces: false});

    api.setNavBarAttr({
        rightButtons: [{
            text: '•••',
            color: '#4d4d4d',
            fontSize: '16'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if (ret.type === 'right') {
            actionSheet([
                {
                    text: MSG.notif['allRead'],
                    callback: function () {
                        notifyList.readAll();
                    }
                },
                {
                    text: MSG.notif['deleteAll'],
                    callback: function () {
                        notifyList.removeAll();
                    }
                }
            ]);
        } else {
            api.closeWin();
        }
    });

    //下拉刷新
    api.setRefreshHeaderInfo({
        loadingImg:'widget://image/refresh-logo.png',
        bgColor: '#fff',
        textColor: '#000',
        textDown: MSG.tips.pullDownRefresh,
        textLoading: MSG.tips.refreshing,
        showTime: false,
        textUp:  MSG.tips.releaseRefresh
    }, function (ret, err) {
        api.refreshHeaderLoadDone();
        notifyList.reset();
        notifyList.fetchData();
    });

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 500
        }
    }, function (ret, err) {
        if (notifyList.total > notifyList.list.length && !notifyList.bottomLoading && !notifyList.isLoading) {
            notifyList.condition.page++;
            notifyList.fetchData();
        }
    });

    api.addEventListener({
        name: 'insertNotify'
    }, function(ret, err) {
        var notify = ret.value.notify;
        if (notify.type === notifyList.type) {
            notify.contentObj = JSON.parse(notify.content);
            notifyList.list.unshift(notify);
        }
    });

    api.addEventListener({
        name: 'dialogRemarkSuccess'
    }, function (ret, err) {
        notifyList.$forceUpdate();
    });

    var notifyList = new Vue({
        el: '#notifyList',
        created: function() {
            this._init();
        },
        data: {
            type: api.pageParam.type,   // other, liked, comments
            list: [],
            myID: localStorage.getItem('userId') || '',
            condition: {
                page: 1,
                size: 10,
                username: localStorage.getItem('userName'),
                type: api.pageParam.type
            },
            bottomLoading: false,
            isLoading: false,
            total: 0,
            message:MSG
        },
        filters: {
            i18n:function (value) {
                return MSG.notif[value];
            },
            formatTime:function (value) {
                return moment.utc(value).local().format('YYYY-MM-DD HH:mm');
            }
        },
        methods: {
            _init: function() {
                this.fetchData();
            },
            reset: function() {
                this.condition.page = 1;
                this.list = [];
            },
            openChatPage:function (item) {
                var chatId = item.username + '@new';
                var userId = item.contentObj.UserId;
                var userName = item.contentObj.StoreName;
                var userAvatar = item.contentObj.AvatarUrl;

                chatTo(chatId, userId, userName, userAvatar, 'PRIVATE', false);

                //进入聊天页面
                function chatTo(targetId, userId, username, userPortrait, conversationType, isTop) {
                    openChatPage({
                        targetId: targetId,
                        userId: userId,
                        userName: username,
                        userPortrait: userPortrait,
                        conversationType: conversationType,
                        isTop: isTop
                    });
                }

            },

            /**
             * 获取关注列表
             */
            getFollowList: function () {
                var that = this;
                var userId = this.myID;
                var url = getBaseUrl() + "/api/users/"+ userId +"/followees?viewerId=" +this.myID ;
                getAxois(url, "GET", {}).then(function (response) {
                    if(response.data.length !== 0){
                        var persons = response.data;
                        var personMap = {};
                        var item;
                        for (var i = 0, len = persons.length; i < len; i++) {
                            item = persons[i];
                            personMap[item.Id] = item;
                        }
                        var itemJ;
                        for (var j = 0, lenJ = that.list.length; j < lenJ; j++) {
                            itemJ = that.list[j];
                            if (personMap[itemJ.UserId]) {
                                itemJ.Followed = true;
                            } else {
                                itemJ.Followed = false;
                            }
                        }
                    }else{

                    }
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },

            fetchData: function() {
                var that = this;
                var param = $.extend({}, this.condition);
                if (this.condition.page === 1) {
                    loading('show');
                } else {
                    that.bottomLoading = true
                }
                that.isLoading = true;
                apiNotify.get("/notification", param).done(function (rep) {
                    that.bottomLoading = false;
                    that.isLoading = false;
                    loading('hide');
                    if (rep.code === 0) {
                        that.total = rep.data.total;
                        var list = rep.data.records;
                        if (list.length > 0) {
                            var result = [];
                            $.map(list, function (item, index) {
                                try {
                                    item.contentObj = JSON.parse(item.content);
                                    if (!item.contentObj.Type) {
                                        item.contentObj.Type = item.contentObj.type;
                                    }
                                    result.push(item);
                                } catch (e) {

                                }
                            });
                            that.list = that.list.concat(result);
                        }
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    console.error(JSON.stringify(err));
                });
            },

            /**
             * 设置全部已读
             */
            readAll: function() {
                var that = this;
                loading('show');
                apiNotify.edit("/notification/all", {
                    type: this.type,
                    action: 'READ',
                    username: this.condition.username
                }).done(function (rep) {
                    loading('hide');
                    if (rep.code === 0) {
                        $.map(that.list, function (item) {
                            item.hasRead = true;
                        });
                        api.toast({
                            msg: MSG.general.success,
                            duration: 2000,
                            location: 'middle'
                        });
                        api.sendEvent({
                            name: 'workplaceReload',
                            extra: {
                                type: 'notify'
                            }
                        });
                        api.sendEvent({
                            name: 'ReloadNotifyCategory'
                        });
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    api.toast({
                        msg: MSG.tips.systemError,
                        duration: 2000,
                        location: 'middle'
                    });
                });
            },
            /**
             * 设置全部删除
             */
            removeAll: function() {
                var that = this;
                loading('show');
                apiNotify.edit("/notification/all", {
                    type: this.type,
                    action: 'DELETE',
                    username: this.condition.username
                }).done(function (rep) {
                    loading('hide');
                    if (rep.code === 0) {
                        that.reset();
                        api.toast({
                            msg: MSG.general.success,
                            duration: 2000,
                            location: 'middle'
                        });
                        api.sendEvent({
                            name: 'workplaceReload',
                            extra: {
                                type: 'notify'
                            }
                        });
                        api.sendEvent({
                            name: 'ReloadNotifyCategory'
                        });
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    api.toast({
                        msg: MSG.tips.systemError,
                        duration: 2000,
                        location: 'middle'
                    });
                });
            },
            openTycoonPlace: function (contentObj) {
                openUserTycoonPlace(contentObj.UserId, contentObj.StoreName, contentObj.AvatarUrl, 'notifs');
            },
            openDetail: function(item) {
                var contentObj = item.contentObj;
                switch (item.type) {
                    case MSG_TYPE_COMMENT:
                        openTabLayout('shareMoment', '', 'widget://html/users/moment-detail.html', {
                            prodId: contentObj.PostId,
                            userId: this.myID,
                            momentGuid: contentObj.PostGuid,
                            useServer: 'cn',
                            type: 'comments',
                            isView: true
                        });
                        break;
                    case MSG_TYPE_FOLLOW:
                        this.openTycoonPlace(contentObj);
                        break;
                    case MSG_TYPE_REWARD:
                        openTabLayout('shareMoment', '', 'widget://html/users/moment-detail.html', {
                            prodId: contentObj.PostId,
                            userId: this.myID,
                            momentGuid: contentObj.PostGuid,
                            useServer: 'cn',
                            type: 'comments',
                            isView: true
                        });
                        break;
                    case MSG_TYPE_TWEELOG:
                        switch (contentObj.type) {
                            case 'tweelogApply':
                                openTabLayout('myTweelog', MSG.tweeLog.myTweelog, 'widget://html/tweelog/myTweeLog.html', {
                                    category: 'pending'
                                });
                                break;
                            case 'tweelogApproved':
                                openTabLayout('myTweelog', MSG.tweeLog.myTweelog, 'widget://html/tweelog/myTweeLog.html', {
                                    category: 'joined'
                                });
                                break;
                            case 'tweelogReject':
                                openTabLayout('tweeLogDetail', '', 'widget://html/tweelog/tweeLog-detail.html',{
                                    tweelogInfo: {
                                        tweelogId: contentObj.tweelogId,
                                        name: contentObj.tweelogName,
                                        owner: {
                                            userId: contentObj.UserId
                                        }
                                    }
                                },true);
                                break;
                        }
                        break;
                    default:
                        switch (contentObj.Type) {
                            case 'accepted':
                                this.openTycoonPlace(contentObj);
                                break;
                            case 'repost':
                                openTabLayout('shareMoment', '', 'widget://html/users/moment-detail.html', {
                                    prodId: contentObj.PostId,
                                    userId: this.myID,
                                    momentGuid: contentObj.PostGuid,
                                    useServer: 'cn',
                                    type: 'comments',
                                    isView: true
                                });
                                break;
                        }

                }
            },
            setRead: function(item) {
                var that = this;
                apiNotify.edit("/notification/one", {
                    action: 'READ',
                    id: item.id
                }).done(function (rep) {
                    loading('hide');
                    that.isLoading = false;
                    if (rep.code === 0) {
                        item.hasRead = true;
                        api.sendEvent({
                            name: 'workplaceReload',
                            extra: {
                                type: 'notify'
                            }
                        });
                        api.sendEvent({
                            name: 'ReloadNotifyCategory'
                        });
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    console.error(JSON.stringify(err));
                });
            },
            /*
            orderSelled: 买家下单，卖家收到：您有一笔售出订单
            卖家发货，买家收到：您购买的产品已经发货
            卖家取消订单，买家收到：您的订单已被卖家取消
            买家取消订单，卖家收到：您的订单已经取消
             */
            openOrderDetail:function (item) {
                var contentObj = item.contentObj;
                switch (contentObj.Type) {
                    // 您有一笔售出订单
                    case 'orderSelled':
                        openTabLayout("orderDetail", MSG.payment.orderDetail, 'widget://html/products/order-detail.html',{
                            orderId: contentObj.OrderId
                        });
                        break;

                    case 'orderProxyed':
                        openTabLayout("orderDetail", MSG.payment.orderDetail, 'widget://html/products/order-detail.html',{
                            orderId: contentObj.OrderId
                        });
                        break;

                    // 您购买的产品已经发货
                    case 'orderShipped':
                        openTabLayout("orderDetail", MSG.payment.orderDetail, 'widget://html/business/purchase-detail.html',{
                            orderId: contentObj.OrderId
                        });
                        break;

                    // 您的订单已被卖家取消
                    case 'orderCancelledByOwner':
                        openTabLayout("orderDetail", MSG.payment.orderDetail, 'widget://html/business/purchase-detail.html',{
                            orderId: contentObj.OrderId
                        });
                        break;

                    // 您的订单已被买家取消
                    case 'orderCancelled':
                        openTabLayout("orderDetail", MSG.payment.orderDetail, 'widget://html/products/order-detail.html',{
                            orderId: contentObj.OrderId
                        });
                        break;

                    // 您的订单已确认收货
                    case 'orderConfirmed':
                        openTabLayout("orderDetail", MSG.payment.orderDetail, 'widget://html/products/order-detail.html',{
                            orderId: contentObj.OrderId
                        });
                        break;

                    // 您有一个退货申请
                    case 'orderApplyRefund':
                        openTabLayout("orderDetail", MSG.payment.orderDetail, 'widget://html/products/order-detail.html',{
                            orderId: contentObj.OrderId
                        });
                        break;

                    // 退货申请已被买家取消
                    case 'orderApplyRefundCancel':
                        openTabLayout("orderDetail", MSG.payment.orderDetail, 'widget://html/products/order-detail.html',{
                            orderId: contentObj.OrderId
                        });
                        break;

                    // 收到评价
                    case 'orderAssess':
                        openTabLayout("orderDetail", MSG.payment.orderDetail, 'widget://html/products/order-detail.html',{
                            orderId: contentObj.OrderId,
                            prodId: contentObj.productId
                        });
                        // openTabLayout('product-assess-list', MSG.assess.title, 'widget://html/products/product-assess-list.html', {
                        //     prodId: contentObj.productId,
                        // });
                        break;

                    // 预售审核成功，活动成功/失败
                    case 'orderPresaleApproved':
                    case 'orderPresaleOwnerSuccess':
                    case 'orderPresaleOwnerFail':
                        openTabLayout('productDetail', '', 'widget://html/products/product-detail.html', {
                            prodId: contentObj.productId,
                            userInfo: JSON.stringify({
                                Id: this.myID,
                                UserName: localStorage.getItem('userName'),
                                StoreName: localStorage.getItem('storename'),
                                ThumbnailAvatarUrl: localStorage.getItem('thumbnail'),
                                AvatarUrl: localStorage.getItem('thumbnail'),
                                CustomerGuid: localStorage.getItem('userGuid'),
                            }),
                            countryCode: 'CN',
                            tweebaaTag: 'tweebaa-tag'
                        });
                        break;

                    // 预售审核拒绝
                    case 'orderPresaleReject':
                        openTabLayout('presaleDetail', MSG.suggestion.presaleDetail, 'widget://html/products/presale-detail.html', {
                            presaleId: contentObj.presaleId
                        });
                        break;

                    // 买家：您参与的预售已成功/失败
                    case 'orderPresalBuyerSuccess':
                    case 'orderPresalBuyerFail':
                        openTabLayout('productDetail', '', 'widget://html/products/product-detail.html', {
                            prodId: contentObj.productId,
                            countryCode: 'CN',
                            tweebaaTag: 'tweebaa-tag'
                        });
                        break;
                    default:

                }
            },
        }
    });

};

