
apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    var kv = api.require('snKVStorage');

    api.addEventListener({
        name: 'insertNewAnnouncement'
    }, function (ret, err) {
        console.log("[" + api.deviceName + "]" + '【insertNewAnnouncement】：' + JSON.stringify(ret.value.announcement));
        var announcement = ret.value.announcement;
        announcement.titleObj = JSON.parse(announcement.title);
        announcement.contentObj = JSON.parse(announcement.content);
        conversationList.announcementList.unshift(announcement);
        conversationList.announcementsUnread = announcementUtil.getUnreadAnnouncementsNumber();
        conversationList.notifyGlobalUnread();
    });

    api.addEventListener({
        name: 'refreshAnnouncements'
    }, function (ret, err) {
        // console.log("[" + api.deviceName + "]" + '【conversationListReload】：');
        conversationList.announcementsUnread = announcementUtil.getUnreadAnnouncementsNumber();
        conversationList.getAnnouncements();
        conversationList.notifyGlobalUnread();
    });

    api.addEventListener({
        name: 'conversationListReload'
    }, function (ret, err) {
        // console.log("[" + api.deviceName + "]" + '【conversationListReload】：');
        conversationList.getConversationList();
    });

    api.addEventListener({
        name:'workplaceReload'
    }, function(ret, err){
        location.reload();
    });

    api.addEventListener({
        name: 'updateMyChatId'
    }, function (ret, err) {
        // console.log(1111111);
        // console.log(JSON.stringify(ret));
        conversationList.myChatId = ret.value.chatId;
    });

    // 监听：消息撤回
    api.addEventListener({
        name: 'recallMessageInListPage'
    }, function(ret, err) {
        var messageId = ret.value.messageId;
        conversationList.getConversationList();
    });

    var rong = api.require('rongCloud2');

    //下拉刷新
    // if (api.systemType === 'ios') {
        api.setRefreshHeaderInfo({
            loadingImg:'widget://image/refresh-logo.png',
            bgColor: '#fff',
            textColor: '#000',
            textDown: MSG.tips.pullDownRefresh,
            textLoading: MSG.tips.refreshing,
            showTime: false,
            textUp:  MSG.tips.releaseRefresh
        }, function (ret, err) {
            api.refreshHeaderLoadDone();
            if (conversationList.isLoggedIn) {
                loading('show');
                conversationList.getConversationList();
            }
        });
    // }

    api.addEventListener({
        name: 'dialogRemarkSuccess'
    }, function (ret, err) {
        conversationList.$forceUpdate();
    });

    var conversationList = new Vue({
        el: '#conversationList',
        mounted: function () {

        },
        created: function() {
            if (localStorage.getItem('chatID')) {
                this.myChatId = localStorage.getItem('chatID');
                this.getConversationList();
            }
            this.getAnnouncements();
        },
        data: {
            myChatId: '',
            conversationData: [],
            message: MSG,
            isLoggedIn: kv.getBool({key: 'isLoggedIn'}),
            muteUnreadCount: 0,
            muteLen: 0,
            conversationLen: 0,
            announcementList: [],
            announcementsUnread: announcementUtil.getUnreadAnnouncementsNumber()
        },
        filters: {
            formatTime:function (value) {
                return moment.utc(value).local().format('MM-DD HH:mm')
            },
            transEmo:function(emoMsg){
                var emoPath, transMsg;
                var reg = /\[(.*?)\]/gm;
                transMsg = emoMsg.replace(reg, function (match) {
                    for (var i = 0, len = EMO_DATA.length; i < len; i++) {
                        if (EMO_DATA[i].text === match) {
                            emoPath = '../../image/emotion/' + EMO_DATA[i].name + '.png';
                            return "<img width='20' height='20' src='" + emoPath + "' />"
                        }
                    }
                    return match;
                });
                return transMsg;
            },
            formatInviteText: function (text) {
                var symbol = lan === 'zh' ? '、' : ',';
                var arr = text.split(',');
                var inviter = arr[0];
                var members = arr[1].split(' ');
                var membersText = '';
                if (members.length > 3) {
                    var tempArr = members.slice(0, 3);
                    membersText = tempArr.join(symbol) + '...';
                } else {
                    membersText = members.join(symbol);
                }
                return inviter + ' ' + MSG.chat.invite + ' ' + membersText + MSG.chat.joinGroup;
            },
            formatRemoveText: function (text) {
                var symbol = lan === 'zh' ? '、' : ',';
                var arr = text.split(',');
                var inviter = arr[0];
                var members = arr[1].split(' ');
                var membersText = '';
                if (members.length > 3) {
                    var tempArr = members.slice(0, 3);
                    membersText = tempArr.join(symbol) + '...';
                } else {
                    membersText = members.join(symbol);
                }
                return inviter + ' ' + MSG.chat.by + ' ' + membersText + MSG.chat.removeGroup;
            },
            formatChangeGroupName: function (text) {
                var arr = text.split(',');
                var username = arr[0];
                var newGroupName = arr[1];
                return username + MSG.chat.groupNameChange + newGroupName;
            }
        },
        methods:{
            getAnnouncements: function() {
                var that = this;
                apiNotify.get("/announcements", {
                    page: 1,
                    size: 1
                }).done(function (rep) {
                    if (rep.code === 0) {
                        var list = rep.data.records;
                        $.map(list, function (item, index) {
                            item.titleObj = JSON.parse(item.title);
                            item.contentObj = JSON.parse(item.content);
                        });
                        that.announcementList = list;
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    console.error("[" + api.deviceName + "] getNotifyUnreads: " + JSON.stringify(err));
                });
            },
            notifyGlobalUnread: function() {
                api.execScript({
                    name: 'root',
                    script: 'ChatFunction.getUnreadCount(' + this.muteUnreadCount + ', ' + this.announcementsUnread + ');'
                });
            },
            getMuteStatus: function(item) {
                var that = this;
                rong.getConversationNotificationStatus({
                    conversationType: item.conversationType,
                    targetId: item.targetId
                }, function(ret, err) {
                    // console.log("[" + api.deviceName + "]" + "getConversationNotificationStatus: " + JSON.stringify(ret));
                    if (ret.status === 'success') {
                        item.notificationStatus = ret.result.notificationStatus;
                        if (item.notificationStatus === 'DO_NOT_DISTURB') {
                            that.muteUnreadCount = that.muteUnreadCount + item.unreadMessageCount;
                        }
                    }
                    that.muteLen++;
                    if (that.muteLen >= that.conversationLen) {
                        // console.log("[" + api.deviceName + "]" + "begin notify unreads ...");
                        that.notifyGlobalUnread();
                    }
                });
            },
            getConversationList:function () {
                var that = this;

                that.muteUnreadCount = 0;
                that.muteLen = 0;

                rong.getConversationList(function(ret, err) {
                    // console.log("会话列表:" + ret.status);
                    // console.log("[" + api.deviceName + "]" + "会话列表:" + ret.status);
                    // console.log("会话列表:" +JSON.stringify(ret));
                    loading('hide');
                    if(ret.status ==='success'){
                        var list = ret.result;
                        var len = list.length;

                        that.conversationLen = len;

                        // console.warn("[" + api.deviceName + "]" + JSON.stringify(ret.result));

                        var results = [];
                        var item;
                        for (var i = 0; i < len; i++) {
                            item = list[i];
                            if (item.sentStatus === 'SENDING') {
                                continue;
                            }

                            // 免打扰
                            item.notificationStatus = 'NOTIFY';     // DO_NOT_DISTURB
                            that.getMuteStatus(item);

                            // @功能兼容性
                            // hasUnreadMentioned这个属性仅仅在ios采用
                            // console.warn("[" + api.deviceName + "]" + item.hasUnreadMentioned);
                            if (item.hasUnreadMentioned === undefined) {
                                // mentionedCount这个属性在安卓采用
                                if (item.mentionedCount > 0) {
                                    item.hasUnreadMentioned = true;
                                } else {
                                    item.hasUnreadMentioned = false;
                                }
                            }
                            if (item.hasUnreadMentioned) {
                                console.warn("[" + api.deviceName + "]" + '------------------------------------Mentionsed');
                            }

                            if (item.objectName === 'RC:RcNtf') {
                                item.extraObj = {};
                                $.extend(item.latestMessage, {
                                    type: '',
                                    receiveName: '',
                                    receivePortrait: '',
                                    sendName: '',
                                    sendPortrait: ''
                                });
                                (function (item) {
                                    rong.getLatestMessages({
                                        conversationType: item.conversationType,
                                        targetId: item.targetId,
                                        count: 10
                                    }, function(ret, err) {
                                        if (ret.status === 'success') {
                                            var firstItem = ret.result[0];
                                            var extra = firstItem.extra;
                                            if (extra) {
                                                $.extend(item.latestMessage, ret.result[0], JSON.parse(firstItem.extra));
                                            } else {
                                                // 遍历
                                                var innerItem;
                                                for (var j = 0, len = ret.result.length; j < len; j++) {
                                                    innerItem = ret.result[j];
                                                    if (innerItem.content && innerItem.content.extra) {
                                                        $.extend(item, innerItem);
                                                        item.latestMessage = innerItem.content;
                                                        item.extraObj = JSON.parse(item.latestMessage.extra);
                                                        break;
                                                    }
                                                }
                                            }
                                        }
                                        // api.alert({ msg: JSON.stringify(ret.result) });
                                    })
                                })(item);
                                results.push(item);
                            } else if (item.latestMessage.extra) {
                                try {
                                    item.extraObj = JSON.parse(item.latestMessage.extra);
                                    results.push(item);
                                } catch (e) {
                                    console.error(item.latestMessage.extra);
                                }
                            }

                        }
                        that.conversationData = results;

                        // setTimeout(function () {
                        //     that.notifyGlobalUnread();
                        // }, 1000);
                        // that.openChatPage(0);
                    }
                });

            },
            showAvatar:function(index,group){
                var that = this;
                var data = this.conversationData[index].latestMessage.extra;
                if(data){
                    var avatar = JSON.parse(data);
                    if(group){
                        return avatar.receivePortrait;
                    }else{
                        return that.conversationData[index].senderUserId === this.myChatId ? avatar.receivePortrait : avatar.sendPortrait;
                    }
                }
            },
            showName:function(index,group){
                var that = this;
                var data = this.conversationData[index].latestMessage.extra;
                if(data){
                    var extraObj = JSON.parse(data);
                    if(group === 'group'){
                        return extraObj.receiveName;
                    }else if(group ==='sendName'){
                        return userRemarkService.get(extraObj.sendUserId, extraObj.sendName);
                    }else{
                        if (that.conversationData[index].senderUserId === this.myChatId) {
                            return userRemarkService.get(extraObj.receiveUserId, extraObj.receiveName);
                        } else {
                            return userRemarkService.get(extraObj.sendUserId, extraObj.sendName);
                        }
                    }
                }else{
                    rong.setMessageReceivedStatus({
                        messageId: that.conversationData[index].latestMessageId,
                        receivedStatus: 'READ'
                    }, function(ret, err) {
                    });
                    // rong.deleteMessages({
                    //     messageIds: [that.conversationData[index].latestMessageId]
                    // }, function(ret, err) {
                    //     that.getConversationList();
                    // })
                }
            },
            openSystemPage: function() {
                openChatPage({
                    conversationType: 'SYSTEM'
                });
            },
            showSysButton:function (event, params) {
                var tar = event.target;

                $(tar).closest('li').addClass('pressDown');

                actionSheet([
                    {
                        text: MSG.chat.clearUnread,
                        callback: function () {
                            // TODO
                        }
                    }
                ], function () {
                    $('#conversationList').find('li').removeClass('pressDown');
                });
            },
            openChatPage:function (event, params) {
                var index = params.index;
                var data = this.conversationData[index];
                var userId,userName,userAvatar,chatId;
                // console.log(JSON.stringify(data));
                if (!data.latestMessage.extra) {
                    return;
                }
                var userInfo = JSON.parse(data.latestMessage.extra);

                if(data.conversationType === 'PRIVATE'){
                    if(data.senderUserId === this.myChatId){
                        userId = userInfo.receiveUserId;
                        userName = userInfo.receiveName;
                        userAvatar = userInfo.receivePortrait;
                        chatId = data.targetId;
                    }else{
                        userId = userInfo.sendUserId;
                        userName = userInfo.sendName;
                        userAvatar = userInfo.sendPortrait;
                        chatId = data.senderUserId;
                    }
                }else{
                    userName = userInfo.receiveName;
                    userAvatar = userInfo.receivePortrait;
                    chatId = data.targetId
                }

                openChatPage({
                    targetId: chatId,
                    userId: userId,
                    userName: userName,
                    userPortrait: userAvatar,
                    conversationType: data.conversationType,
                    isTop: data.isTop,
                    notificationStatus: data.notificationStatus
                });

                // openWindows('chatPage', 'widget://html/chat/chat.html',{
                //     userId: chatId,
                //     userName: userName,
                //     userPortrait: userAvatar,
                //     conversationType: data.conversationType,
                //     isTop: data.isTop
                // });
            },
            showListButton:function (event, params) {
                var tar = event.target;
                var index = params.index;
                var that = this;

                $(tar).closest('li').addClass('pressDown');

                var data = that.conversationData[index];
                var chatId;
                //console.log(JSON.stringify(data));
                if(data.conversationType ==='PRIVATE'){
                    chatId = data.targetId;
                    // chatId = data.senderUserId === myChatId ? data.targetId : data.senderUserId;
                }else if(data.conversationType ==='GROUP'){
                    chatId = data.targetId;
                }
                var top = data.isTop ? MSG.chat.removeStickyTop : MSG.chat.stickyTop;

                var buttons = [
                    {
                        text: MSG.chat.clearUnread,
                        callback: function () {
                            that.clearUnreadStatus(chatId, data.conversationType, data);
                        }
                    },
                    {
                        text: top,
                        callback: function () {
                            that.stickyTop(chatId,data.conversationType,data.isTop);
                        }
                    },
                    {
                        text: MSG.chat.removeConversation,
                        callback: function () {
                            that.removeConversation(chatId, data.conversationType);
                        }
                    }
                ];
                actionSheet(buttons, function () {
                    $('#conversationList').find('li').removeClass('pressDown');
                });
            },
            removeConversation:function (chatId,type) {
                var that = this;
                //console.log(chatId);
                rong.removeConversation({
                    conversationType: type,
                    targetId: chatId
                }, function (ret, err) {
                    //console.log(JSON.stringify(ret));
                    that.getConversationList();
                })
            },
            stickyTop:function (chatId,type,isTop) {
                var that = this;
                rong.setConversationToTop({
                    conversationType: type,
                    targetId: chatId,
                    isTop: !isTop
                }, function(ret, err) {
                    //console.log( ret.status);
                    that.getConversationList();
                })
            },
            /**
             * 全部设为已读
             * @param chatId
             * @param type
             * @param conversation
             */
            clearUnreadStatus: function(chatId, type, conversation) {
                var that = this;
                rong.clearMessagesUnreadStatus({
                    conversationType: type,
                    targetId: chatId
                }, function(ret, err) {
                    if (ret.status === 'success') {
                        conversation.unreadMessageCount = 0;
                        that.notifyGlobalUnread();
                    } else {
                        console.warn(JSON.stringify(ret));
                    }
                });
            }
        }
    });

};

function menuTag(type) {
    switch (type) {
        case 'followings':
            openTabLayout('followList', MSG.general[type], 'widget://html/users/follow-list.html', {
                type: 'follow',
                from: 'conversation'
            });
            break;
        case 'createGroup':
            openTabLayout('setGroup',MSG.chat.createGroup,'widget://html/chat/set-group.html', {
                type: 'create'
            });
            break;
        case 'joinedGroup':
            openTabLayout('joinedGroup',MSG.chat.joinedGroup,'widget://html/chat/joined-group.html');
            break;
    }
    $('.conversation-menu,#Mask').addClass('d-none');
}

function refreshPage() {
    location.reload();
}
