
var chatSetting;

apiready = function () {
    backListener();

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));
    $('[data-replace-text]').each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.chat[k]);
    });

    var rong = api.require('rongCloud2');

    api.addEventListener({
        name: 'changeGroupMembers'
    }, function(ret, err) {
        chatSetting.groupInfo.Members = ret.value.members;
        chatSetting.inputKeys = '';
        chatSetting.filterKeys();
    });

    api.addEventListener({
        name: 'chatSettingChangeGroupName'
    }, function(ret, err) {
        chatSetting.groupInfo.Name = ret.value.groupName;
    });

    api.addEventListener({
        name: 'chatSettingChangeGroupPortrait'
    }, function(ret, err) {
        chatSetting.groupInfo.GroupPortrait = ret.value.groupAvatar;
    });

    api.addEventListener({
        name: 'reloadAdminList'
    }, function (ret, err) {
        chatSetting.getGroupAdministrator();
    });

    api.addEventListener({
        name: 'reloadGroupNotice'
    }, function (ret, err) {
        chatSetting.getGroupNotice();
    });

    chatSetting = new Vue({
        el: '#chatSetting',
        mounted: function () {
            if (api.pageParam.conversationType ==='GROUP') {

                var groupInfo = api.pageParam.groupInfo;
                this.groupInfo.GroupId = groupInfo.GroupId;
                this.groupInfo.Name = groupInfo.Name;
                this.groupInfo.CreatorId = groupInfo.CreatorId;
                this.groupInfo.Members = groupInfo.Members;
                this.groupInfo.GroupPortrait = api.pageParam.userPortrait;

                this.getConversation();
                this.getGroupAdministrator();
                this.getGroupNotice();

                var members = groupInfo.Members;
                if (members.length >= 15) {
                    this.showMore = true;
                    this.currentMembers = members.slice(0, 14);
                } else {
                    this.currentMembers = members.slice();
                }
            }else{
                this.chatName = this.getChatName();
                this.getBlacklistStatus();
            }
        },
        data: {
            hasViewAll: false,
            showMore: false,
            currentMembers: [],
            inputKeys: '',
            muteNotifications: api.pageParam.isSilence,
            stickyTop: api.pageParam.isTop,
            targetId: api.pageParam.targetId, //群ID 或单聊的 chatId
            userId: api.pageParam.userId,
            conversationType: api.pageParam.conversationType,
            chatName: api.pageParam.userName, //聊天的用户名 群聊的群名称
            chatPortrait: api.pageParam.userPortrait,
            groupInfo: {
                GroupId: '',
                Name: '',
                CreatorId: '',
                Members: [],
                GroupPortrait: ''
            },
            groupAdministrators:'',
            isGroupAdministrator:false,
            administratorsIDs:[],
            groupNotice:'',
            myChatId : localStorage.getItem('chatID'),
            addBlacklist:false,
            message:MSG
        },
        methods: {
            getChatName: function() {
                if (this.conversationType === 'PRIVATE') {
                    return userRemarkService.get(api.pageParam.userId, api.pageParam.userName);
                } else {
                    return api.pageParam.userName;
                }
            },
            setRemark: function() {
                var that = this;
                userRemarkService.open({
                    userId: this.userId,
                    avatarUrl: this.chatPortrait,
                }, function (name) {
                    that.chatName = name;
                });
            },
            filterKeys: function() {
                var value = this.inputKeys.toLowerCase();
                var members = this.groupInfo.Members;

                if (value) {
                    var results = [];
                    $.map(members, function (item, index) {
                        var name = item.StoreNames.toLowerCase();
                        if (name.indexOf(value) >= 0) {
                            results.push(item);
                        }
                    });
                    this.currentMembers = results;
                    if (members.length >= 15) {
                        this.showMore = false;
                    }
                } else {
                    if (members.length >= 15) {
                        if (this.hasViewAll === false) {
                            this.currentMembers = members.slice(0, 14);
                        } else {
                            this.currentMembers = members.slice();
                        }
                        this.showMore = true;
                    } else {
                        this.currentMembers = members.slice();
                    }
                }

            },
            viewAll: function() {
                this.hasViewAll = true;
                this.currentMembers = this.groupInfo.Members;
            },
            getConversation: function() {
                var that = this;
                rong.getConversation({
                    conversationType: this.conversationType,
                    targetId: this.targetId
                }, function(ret, err) {
                    if (ret.status === 'success') {
                        that.stickyTop = ret.result.isTop;
                    }
                })
            },
            getBlacklistStatus:function(){
                var that = this;
                rong.getBlacklistStatus({
                    userId: this.targetId
                }, function(ret, err) {
                    // console.log(JSON.stringify(ret.result));
                    that.addBlacklist = ret.result !== 1;
                });
            },
            pushNotification:function(titleKey){
                openTabLayout("notificationTpis",MSG.notificationTips[titleKey],"widget://html/chat/notification-tips.html")
            },
            getGroupInfo: function () {
                var that = this;
                var url = getBaseUrl() + "api/im/v1/imgroup/" + that.targetId + "?currentpage=0&itemsperpage=10";
                getAxois(url, "GET", {}).then(function (response) {
                    loading('hide');
                    var groupInfo = response.data;
                    this.groupInfo.GroupId = groupInfo.GroupId;
                    this.groupInfo.Name = groupInfo.Name;
                    this.groupInfo.CreatorId = groupInfo.CreatorId;
                    this.groupInfo.Members = groupInfo.Members;
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            changeGroupName: function () {
                var that = this;
                openTabLayout('changeGroupName', MSG.chat.changeGroupName, 'widget://html/chat/change-group-name.html', {
                    GroupId: that.groupInfo.GroupId,
                    CreatorId: that.groupInfo.CreatorId,
                    Name: that.groupInfo.Name
                });
            },
            changeGroupAvatar:function(){
                var that = this;
                openChangePortrait({
                    GroupId: that.groupInfo.GroupId,
                    CreatorId: that.groupInfo.CreatorId,
                    Name: that.groupInfo.Name,
                    GroupPortrait: api.pageParam.userPortrait
                });
            },
            addBlacklistBtn:function(){
                var that = this;

                if (that.addBlacklist) {
                    rong.addToBlacklist({
                        userId: api.pageParam.targetId
                    }, function(ret, err) {
                        // console.log({ msg: ret.status });
                    });
                } else {
                    rong.removeFromBlacklist({
                        userId: api.pageParam.targetId
                    }, function(ret, err) {
                        // console.log({ msg: ret.status });
                    });
                }
            },
            getGroupNotice:function(){
                var that =this;
                var url = getBaseUrl() + "api/im/v1/imgrouplastnotice/" + this.groupInfo.GroupId;
                getAxois(url, "GET", {}).then(function (response) {
                    console.log(JSON.stringify(response.data));
                    if(response.data.Code === 0 && response.data.Data){
                        that.groupNotice = response.data.Data;
                    }else{
                        that.groupNotice = {}
                    }
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error));
                });
            },
            setGroupNotice:function(){
                var that =this;
                var isAdmin = this.groupInfo.CreatorId === this.myChatId || this.isGroupAdministrator;
                if(this.groupNotice){
                    openTabLayout('setGroupNotice', MSG.chat.groupNotice, 'widget://html/chat/group-notice.html', {
                        isAdmin: isAdmin,
                        groupNotice:that.groupNotice,
                        groupId:that.groupInfo.GroupId,
                    });
                }
            },
            getGroupAdministrator:function(){
                var that =this;
                var url = getBaseUrl() + "api/im/v1/imgroupmanager/" + this.groupInfo.GroupId;
                loading('show');
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(response.data));
                    loading('hide');
                    if(response.data.Code === 0 ){
                        that.groupAdministrators = response.data.Data;
                        if(that.groupAdministrators.length >0){
                            that.administratorsIDs = [];
                            for(i=0; i< that.groupAdministrators.length; i++){
                                that.administratorsIDs.push(that.groupAdministrators[i].MemberId);
                                if(that.groupAdministrators[i].MemberId === that.myChatId){
                                    that.isGroupAdministrator = true;
                                }
                            }
                        }
                    }

                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error));
                });
            },
            setGroupAdministrator:function(){
                var that =this;
                if(this.groupAdministrators){
                    openTabLayout('setGroupAdministrator', MSG.chat.groupAdministrator, 'widget://html/chat/group-administrator.html', {
                        type: 'createFromOne',
                        groupId:that.groupInfo.GroupId,
                        administrators: that.groupAdministrators,
                        members:that.groupInfo.Members,
                        administratorsIDs:that.administratorsIDs,
                        groupCreatorId:that.groupInfo.CreatorId
                    });
                }
            },
            quitGroup:function(){
                var that =this;
                confirmBox(MSG.chat.wantQuitGroup, MSG.general.cancel, MSG.general.ok,'error');
                $('.dialog-box').find('button').on('click',function (e) {
                    var index = $(this).attr('id');
                    //console.log(index);
                    $('.dialog-box').remove();
                    if (index === 'btn-2') {
                        loading('show');

                        var msg = localStorage.getItem('storename');
                        // api.sendEvent({
                        //     name: 'groupChatQuit',
                        //     extra: {
                        //         msg: msg
                        //     }
                        // });

                        var URL = getBaseUrl() + "/api/im/v1/imgroupuser";
                        var params = {
                            "GroupId": that.groupInfo.GroupId,
                            "UserIds": [that.myChatId]
                        };
                        setTimeout(function () {
                            getAxois(URL, "DELETE", params).then(function (response) {
                                //console.log(JSON.stringify(response.data));
                                var rong = api.require('rongCloud2');

                                rong.removeConversation({
                                    conversationType: that.conversationType,
                                    targetId: that.targetId
                                }, function(ret, err) {
                                    //console.log(JSON.stringify(ret));

                                    loading('hide');

                                    closeChatPage();

                                    api.toast({
                                        msg: MSG.general.success,
                                        duration: 2000,
                                        location: 'middle'
                                    });

                                    setTimeout(function () {
                                        rong.clearMessages({
                                            conversationType: that.conversationType,
                                            targetId: that.targetId
                                        }, function (ret, err) {
                                            back();
                                        });
                                    }, 2000);

                                });

                            }).catch(function (error) {
                                loading('hide');
                                console.log(JSON.stringify(error));
                            });
                        }, 500);
                    }
                });
            },
            /**
             * 解散群聊
             */
            dissolveGroup:function(){
                var that = this;
                confirmBox(MSG.chat.wantDissolveGroup, MSG.general.cancel, MSG.general.ok,'error');
                $('.dialog-box').find('button').on('click',function (e) {
                    var index = $(this).attr('id');
                    //console.log(index);
                    $('.dialog-box').remove();
                    if (index === 'btn-2') {
                        loading('show');

                        var msg = localStorage.getItem('storename');
                        api.sendEvent({
                            name: 'groupChatDissolve',
                            extra: {
                                msg: msg
                            }
                        });

                        var URL = getBaseUrl() + "api/im/v1/imgroup";
                        var params = {
                            "GroupId": that.groupInfo.GroupId,
                            "UserId": that.myChatId
                        };
                        setTimeout(function () {
                            getAxois(URL,"DELETE",params).then(function (response) {
                                //console.log(JSON.stringify(response.data));
                                var rong = api.require('rongCloud2');

                                rong.removeConversation({
                                    conversationType: 'GROUP',
                                    targetId: that.targetId
                                }, function(ret, err) {
                                    //console.log(JSON.stringify(ret));

                                    loading('hide');

                                    closeChatPage();

                                    api.toast({
                                        msg: MSG.general.success,
                                        duration: 2000,
                                        location: 'middle'
                                    });

                                    setTimeout(function () {
                                        rong.clearMessages({
                                            conversationType: that.conversationType,
                                            targetId: that.targetId
                                        }, function (ret, err) {
                                            back();
                                        });
                                    }, 2000);

                                });



                            }).catch(function (error) {
                                loading('hide');
                                console.log(JSON.stringify(error));
                            });
                        }, 500);

                    }
                });
            },
            setMember:function(type){
                var that = this;
                if (this.conversationType === 'PRIVATE') {
                    openTabLayout('setGroup', MSG.chat.createGroup, 'widget://html/chat/set-group.html', {
                        type: 'createFromOne',
                        members: [
                            {
                                StoreNames: api.pageParam.userName,
                                Thumbnail: api.pageParam.userPortrait,
                                UserId: api.pageParam.targetId,
                                CustomerId: api.pageParam.userId
                            }
                        ],
                    });
                } else {
                    var title = type ==='add' ? MSG.chat.groupCreateTitle : MSG.chat.removeFromGroup;
                    openTabLayout('createGroup', title, 'widget://html/chat/set-group.html',{
                        "members": that.groupInfo.Members,
                        "groupId": that.groupInfo.GroupId,
                        "name": that.groupInfo.Name,
                        "type": type,
                        "creatorId": that.groupInfo.CreatorId
                    });
                }
            },
            goToPlace:function(user){
                openUserTycoonPlace(user.CustomerId,user.chatName,user.Thumbnail);
            },
            openPlace:function(){
                openUserTycoonPlace(api.pageParam.userId, api.pageParam.userName, this.chatPortrait);
            },
            changeStickyTop: function () {
                var that = this;
                rong.setConversationToTop({
                    conversationType: that.conversationType,
                    targetId: that.targetId,
                    isTop: that.stickyTop
                }, function (ret, err) {
                    if (ret.status === 'success') {
                        api.sendEvent({
                            name: 'conversationListReload'
                        });
                    }
                });
            },
            changeNotification: function () {
                var that = this;
                var notificationStatus = this.muteNotifications ?  'DO_NOT_DISTURB' : 'NOTIFY';
                rong.setConversationNotificationStatus({
                    conversationType: that.conversationType,
                    targetId: that.targetId,
                    notificationStatus: notificationStatus
                }, function (ret, err) {
                    if (ret.status === 'success') {
                        api.sendEvent({
                            name: 'updateChatTitle',
                            extra: {
                                notificationStatus: notificationStatus
                            }
                        });
                        api.sendEvent({
                            name: 'conversationListReload'
                        });
                    }
                })
            },
            clearHistory: function () {
                var that = this;
                actionSheet([
                    {
                        color: 'red',
                        text: MSG.chat.clearHistory,
                        callback: function () {
                            that.confirmClearHistory();
                        }
                    }
                ])
            },
            confirmClearHistory:function () {
                var that = this;
                api.sendEvent({
                    name: 'cleanMessage'
                });
                // rong.removeConversation({
                //     conversationType: that.conversationType,
                //     targetId: that.targetId
                // }, function (ret, err) {
                //
                // });
                setTimeout(function () {
                    rong.clearMessages({
                        conversationType: that.conversationType,
                        targetId: that.targetId
                    }, function (ret, err) {
                        // rong.sendCommandMessage({
                        //     conversationType: that.conversationType,
                        //     targetId: that.targetId,
                        //     name: 'ClearMessage',
                        //     data: {}
                        // }, function (ret, err) {
                        //     if (ret.status === 'success') {
                        //         back();
                        //     }
                        // });
                    });
                }, 100);
            }
        }
    });

};
