var chatPage;

var FIRST_PAGE_SIZE = 20;
var HISTORY_PAGE_SIZE = 50;
var OFFSET_REQURE_HISTORY = 0; // 距离指定高度，触发历史聊天记录
var REQUEST_TIME = 1000; // ms, 指定这个时间内，不允许再次提交历史记录请求

var RECALL_TIMEOUT = 120;

var ONE_HOUR_MINITIME = 60 * 60 * 1000; // 1小时对应的毫秒
var TIME_ACROSS_NUM = 8;   // 超过10条消息，呈现一条时间

var UIChatBox;

var MSG;

apiready = function () {
    if (api.appVersion.split('.')[0] !== '00') {
        Sentry.init({
            dsn: 'http://500ff18f59c74c2f9909d24a984a225b@testing.tweebaa.cn:9000/5',
            integrations: [
                new Sentry.Integrations.BrowserTracing(),
            ],

            tracesSampleRate: 1.0,
        });
    }
    //进入页面统计点
    var td = api.require('talkingData');
    td.onPageStart({pageName: '聊天页面'});
    backListener('聊天页面');

    // var phoneInfoMore = api.require('phoneInfoMore');

    // phoneInfoMore.getBaseInfo(function(ret, err) {
    //     console.log(JSON.stringify(phoneInfoMore));
    //     if(ret){
    //         console.log(ret.ipMac);
    //     }
    // });

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/' + lan + '.json'
    }));

    var UIAlbumBrowser = api.require('UIAlbumBrowser');

    UIChatBox = api.require('UIChatBox');

    // 打开聊天框
    if (api.pageParam.conversationType !== 'SYSTEM') {
        fnOpen(api.pageParam.conversationType);
    }

    $('.tweebucks-message [data-replace-text]').each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.tweebucks[k]);
    });
    $('.chat [data-replace-text]').each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.chat[k]);
    });


    var systemType = api.systemType;

    //展示白名单操作方法

    if (!checkPermission('notification')) {
        startTip();
    } else {
        var chatSettingTip = api.getPrefs({
            sync: true,
            key: 'chatSettingTip'
        });

        // console.log("[" + api.deviceName + "]" + chatSettingTip)

        if (!chatSettingTip) {
            startTip();
            api.setPrefs({
                key: 'chatSettingTip',
                value: 'show'
            });
        }
    }

    function startTip() {
        var tips = systemType === 'android' ? MSG.notificationTips.tipsTitle : MSG.notificationTips.tipsTitleIos;
        dialog({
            title: MSG.notificationTips.pTitle,
            content: tips,
            primaryText: MSG.notificationTips.checkDetail,
            asideText: '',
            onClose: "show",
            onWarning: function () {
            },
            onPrimary: function () {
                openTabLayout("notificationTpis", MSG.notificationTips.notificationSet, "widget://html/chat/notification-tips.html")
            }
        });
    }

    api.setKeepScreenOn({
        keepOn: true
    });

    // 监听：新消息写入
    api.addEventListener({
        name: 'showMessageInPage'
    }, function (ret, err) {
        // console.log("[" + api.deviceName + "]" + '[showMessageInPage] ' + JSON.stringify(ret.value));
        if (JSON.parse(ret.value.message).targetId === api.pageParam.targetId) {
            chatPage.getChatMessage(ret.value.message);
        }
    });

    // 监听：群聊：加入群聊
    api.addEventListener({
        name: 'groupChatCreate'
    }, function (ret, err) {
        // chatPage.sendMessages(ret.value.msg, undefined, undefined, CHAT_STATUS.GROUP_CREATE, false);
        chatPage.sendMessages(ret.value.msg + MSG.chat.joinGroup, undefined, undefined, 'groupChat', false);
    });
    // 加入群聊成员
    api.addEventListener({
        name: 'groupChatInvite'
    }, function (ret, err) {
        chatPage.sendMessages(chatPage.$options.filters.formatInviteText(ret.value.msg), undefined, undefined, 'groupChat', false);

        chatPage.getUserDetail();
    });
    // 移除群聊成员
    api.addEventListener({
        name: 'groupChatRemove'
    }, function (ret, err) {
        chatPage.sendMessages(chatPage.$options.filters.formatRemoveText(ret.value.msg), undefined, undefined, 'groupChat', false);
        chatPage.getUserDetail();
    });
    // 修改群名称
    api.addEventListener({
        name: 'groupChatChangeName'
    }, function (ret, err) {
        chatPage.sendMessages(chatPage.$options.filters.formatChangeGroupName(ret.value.msg), ret.value.groupName, undefined, 'groupChat', false);
        chatPage.getUserDetail();
    });
    // 修改群头像
    api.addEventListener({
        name: 'groupChatChangePortrait'
    }, function (ret, err) {
        chatPage.sendMessages(ret.value.msg + MSG.chat.changePortrait, undefined, ret.value.groupAvatar, 'groupChat', false);
        chatPage.getUserDetail();
    });
    // 解散群聊
    api.addEventListener({
        name: 'groupChatDissolve'
    }, function (ret, err) {
        chatPage.sendMessages(MSG.chat.groupDissolvedPrefix + ret.value.msg + MSG.chat.groupDissolvedSuffx, undefined, undefined, 'groupChat', false);
    });
    // 退出群聊
    api.addEventListener({
        name: 'groupChatQuit'
    }, function (ret, err) {
        chatPage.sendMessages(ret.value.msg + MSG.chat.groupQuited, undefined, undefined, 'groupChat', false);
    });

    // 群聊：@功能
    api.addEventListener({
        name: 'inputMentionedUser'
    }, function (ret, err) {
        var user = ret.value.user;
        chatPage.inputMentionUser(user);
    });

    api.addEventListener({
        name: 'inputMentionedAll'
    }, function (ret, err) {
        chatPage.inputMentionAll();
    });

    // 监听：群聊：发起通话
    api.addEventListener({
        name: 'vGroupCallBegin'
    }, function (ret, err) {
        chatPage.sendMessages(ret.value.msg, undefined, undefined, CHAT_STATUS.GROUP_CALL_BEGIN, false);
    });

    // 监听：群聊：通话结束
    api.addEventListener({
        name: 'vGroupCallEnd'
    }, function (ret, err) {
        chatPage.sendMessages(ret.value.msg, undefined, undefined, CHAT_STATUS.GROUP_CALL_END, false);
    });

    // 监听：消息撤回
    api.addEventListener({
        name: 'recallMessageInChatPage'
    }, function (ret, err) {
        var messageId = ret.value.messageId;
        var $targetChat = $('#chatId' + messageId);
        if ($targetChat[0]) {
            $targetChat.html("<div class='small text-center text-light-gray'>" + MSG.chat.messageRecalled + "</div>");
        }
    });

    // api.addEventListener({
    //     name: 'swiperight'
    // }, function(ret, err) {
    //     chatPage.closePage();
    // });

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 500            //设置距离底部多少距离时触发，默认值为0，数字类型
        }
    }, function (ret, err) {
        if (!homePage.bottomLoading && !homePage.isLoading) {
            mPages++;
            homePage.getAllMoments();
        }
    });

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 0
        }
    }, function (ret, err) {

    });

    localStorage.setItem('openChatPage', 'open'); //设置一个标记来识别 聊天窗口是否打开 closePage时清除这个localStorage
    var rong = api.require('rongCloud2');

    // 针对发起方和接收方两个不同角色，发送不同的消息回执
    // 1. 无人接听
    // 发起方：对方五应答；接收方：对方已取消
    api.addEventListener({
        name: 'noBodyReceive'
    }, function (ret, err) {
        chatPage.sendMessages(ret.value.msg, undefined, undefined, ret.value.type, false);
    });


    // 2. 发起方主动停止呼叫
    // 发起方：已取消；接收方：对方已取消
    api.addEventListener({
        name: 'hangupBefore'
    }, function (ret, err) {
        chatPage.sendMessages(ret.value.msg, undefined, undefined, ret.value.type, false);
    });

    api.addEventListener({
        name: 'hangupAfter'
    }, function (ret, err) {
        console.log("[" + api.deviceName + "]" + 'chat: hangupAfter');
        chatPage.sendMessages(ret.value.msg + ' ' + ret.value.duration, undefined, undefined, ret.value.type, false);
    });

    api.addEventListener({
        name: 'callingIsBusy'
    }, function (ret, err) {
        console.log("[" + api.deviceName + "]" + 'chat: callingIsBusy');
        clearTimeout(chatPage.callingTimeId);
        closeVCallPage();
        api.toast({
            msg: MSG.chat.callingBusy,
            duration: 3000,
            location: 'middle'
        });
    });

    api.addEventListener({
        name: 'setChatDetail'
    }, function (ret, err) {
        if (chatPage.conversationType === 'PRIVATE') {
            // console.log('user: ' + JSON.stringify(ret.value));
            var user = ret.value;
            chatPage.userID = user.Id;
            chatPage.userGUID = user.CustomerGuid;
        } else {
            // console.log('groupInfo: ' + JSON.stringify(ret.value));
            chatPage.groupInfo = ret.value;
        }
    });

    api.addEventListener({
        name: 'cleanMessage'
    }, function (ret, err) {
        chatPage.cleanMessage();
    });

    api.addEventListener({
        name: 'openChatPrifile'
    }, function (ret, err) {
        chatPage.chatProfile();
    });

    api.addEventListener({
        name: 'dialogRemarkSuccess'
    }, function (ret, err) {
        chatPage.$forceUpdate();
    });

    // 发送消息
    // api.addEventListener({
    //     name: 'sendMessageInChat'
    // }, function(ret, err) {
    //     console.log("[" + api.deviceName + "]" + '[sendMessageInChat] ' + JSON.stringify(ret.value));
    //     chatPage.sendMessages(ret.value.msg);
    // });

    var kv = api.require('snKVStorage');

    // 存储群聊的信息
    var chatDetailMap = {};
    var hasChatDetailMap = kv.has({
        key: 'ChatDetailMap'
    });
    if (hasChatDetailMap) {
        chatDetailMap = kv.getObject({
            key: 'ChatDetailMap'
        });
    }

    chatPage = new Vue({
        el: '#chatPage',
        filters: {
            transEmo: function (emoMsg) {
                return transEmo(emoMsg);
            },
            formatTime: function (value) {
                return moment.utc(value).local().format('MM-DD HH:mm:ss')
            },
            formatDuration: function (s) {
                var t;
                s = Math.floor(s);
                if (s > -1) {
                    var hour = Math.floor(s / 3600);
                    var min = Math.floor(s / 60) % 60;
                    var sec = s % 60;
                    if (hour < 10) {
                        t = '0' + hour + ":";
                    } else {
                        t = hour + ":";
                    }

                    if (min < 10) {
                        t += "0";
                    }
                    t += min + ":";
                    if (sec < 10) {
                        t += "0";
                    }
                    t += sec;
                }
                return t;
            },
            formatCallDurationText: function (text) {
                if (text.indexOf(CHAT_STATUS.HANG_UP_AFTER) > -1) {
                    var duration = text.substring(text.indexOf(' '));
                    return MSG.chat.callDuration + duration;
                }
            },
            formatInviteText: function (text) {
                var symbol = lan === 'zh' ? '、' : ',';
                var arr = text.split(',');
                var inviter = arr[0];
                var members = arr[1].split(' ');
                var membersText = members.join(symbol);
                return inviter + ' ' + MSG.chat.invite + ' ' + membersText + MSG.chat.joinGroup;
            },
            formatRemoveText: function (text) {
                var symbol = lan === 'zh' ? '、' : ',';
                var arr = text.split(',');
                var inviter = arr[0];
                var members = arr[1].split(' ');
                var membersText = '';
                if (members.length > 3) {
                    var tempArr = members.slice(0, 3);
                    membersText = tempArr.join(symbol) + '...';
                } else {
                    membersText = members.join(symbol);
                }
                return inviter + ' ' + MSG.chat.by + ' ' + membersText + MSG.chat.removeGroup;
            },
            formatChangeGroupName: function (text) {
                var arr = text.split(',');
                var username = arr[0];
                var newGroupName = arr[1];
                return username + MSG.chat.groupNameChange + newGroupName;
            }
        },
        watch: {
            inputValue: function (newVal, oldVal) {
                if (this.conversationType === 'GROUP' && newVal.indexOf('@') >= 0) {

                    // 增加字符
                    if (newVal.length > oldVal.length) {
                        var len = newVal.length;
                        var mentionSymbolIndex = newVal.lastIndexOf('@');
                        if (mentionSymbolIndex === len - 1) {
                            UIChatBox.closeKeyboard();
                            chatPage.openMentionedFrame();
                        }
                    } else {

                    }

                }
            }
        },
        mounted: function () {
            if (this.conversationType !== 'SYSTEM') {
                this.getChatHistory();//获取聊天记录
                this.getDraft();
                this.getUnreadMsgNumber();

                this.getUserDetail();

                if (this.conversationType === 'GROUP') {
                    this.checkInGroup();
                }

                this._initDom();
            } else {
                this.getAnnouncements();
            }
            // this._checkCalling();
        },
        created: function () {
            if (this.conversationType !== 'SYSTEM') {
                this.chatName = api.pageParam.userName;
                this.conversationType = api.pageParam.conversationType;
                this.chatPortrait = api.pageParam.userPortrait;

                if (this.conversationType === 'GROUP') {
                    var groupId = this.targetId;
                    if (chatDetailMap[groupId]) {
                        this.groupInfo = chatDetailMap[groupId];
                    }

                    // this._checkCalling();
                } else {
                    if (api.pageParam.product) {
                        this.sendProduct(api.pageParam.product);
                    }
                }
            } else {
                announcementUtil.clearLocalAnnouncement();
                api.sendEvent({
                    name: 'refreshAnnouncements'
                });
            }
        },
        data: {
            FIRST_PAGE_SIZE: FIRST_PAGE_SIZE,
            chatMessages: [],
            userID: '',
            userGUID: '',
            conversationType: api.pageParam.conversationType,
            targetId: api.pageParam.targetId, //对方融云Id
            chatName: '',//对方昵称
            chatPortrait: '', //对方头像
            sendUserId: localStorage.getItem('userId'), //己方id
            sendName: localStorage.getItem('storename'), //己方昵称
            sendPortrait: localStorage.getItem('thumbnail'),//己方头像
            firstLoad: true,
            lastMessageId: '',
            isPlay: false,
            playId: '',
            hasDraft: false,
            silence: api.pageParam.notificationStatus === 'DO_NOT_DISTURB',
            groupInfo: '',
            membersMap: {},    // 群成员
            imageShow: false,
            unreadTotal: 0,     // 所有未读的消息数量
            hasReadNumber: FIRST_PAGE_SIZE,      // 当前已读消息数量
            hasReadAll: false,    // 是否已经读完了所有的消息
            isRequesting: false,    // 是否在请求历史记录
            MSG: MSG,
            message: MSG.chat,
            callingInfo: null,
            inputValue: '',
            latestTime: null,
            timeCounter: 0,
            currentDocHeight: 0,
            isScrolling: false,
            announcementCondition: {
                page: 1,
                size: DEFAULT_PAGE_SIZE
            },
            callingTimeId: null
        },
        methods: {
            sendProduct: function (product) {
                rong.sendRichContentMessage({
                    conversationType: this.conversationType,
                    targetId: this.targetId,
                    title: product.title,
                    description: product.description,
                    imageUrl: product.imageUrl,
                    extra: JSON.stringify(product.extra)
                }, function (ret, err) {
                    console.warn("[" + api.deviceName + "]" + JSON.stringify(ret));
                    if (ret.status === 'progress') {

                    } else if (ret.status === 'prepare') {

                    } else if (ret.status === 'error') {
                        if (err.code === -3) {
                            api.toast({
                                msg: '参数错误',
                                duration: 2000,
                                location: 'middle'
                            });
                        }
                        console.log('error: ' + err.code);
                    }
                });
            },
            formatSize: function (value) {
                if (null == value || value === '') {
                    return "0 Bytes";
                }
                var unitArr = ["Bytes", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB"];
                var index = 0;
                var srcsize = parseFloat(value);
                index = Math.floor(Math.log(srcsize) / Math.log(1024));
                var size = srcsize / Math.pow(1024, index);
                size = size.toFixed(2);//保留的小数位数
                return size + unitArr[index];
            },
            getFileType: function (fileName) {
                var fileType;
                var ext;
                var arr;

                if (fileName) {
                    arr = fileName.split('.');
                    ext = arr[arr.length - 1].toLowerCase();
                }

                var videos = ['mp4', 'mpg', 'mov', 'wmv', 'm3u8'];
                var pics = ['jpg', 'jpeg', 'raw', 'png', 'bmp'];
                var audios = ['amr', 'wav', 'mp3', 'm4a'];
                var pdf = ['pdf'];
                var text = ['txt', 'doc', 'docx', 'xlsx', 'xls'];
                var links = ['com', 'cn', 'io', 'pro', 'net', 'html', 'org', 'info', 'xyz'];

                if (videos.indexOf(ext) !== -1) {
                    fileType = 'video';
                } else if (pics.indexOf(ext) !== -1) {
                    fileType = 'image';
                } else if (audios.indexOf(ext) !== -1) {
                    fileType = 'audios'
                } else if (pdf.indexOf(ext) !== -1) {
                    fileType = 'pdf';
                } else if (text.indexOf(ext) !== -1) {
                    fileType = 'text';
                } else if (links.indexOf(ext) !== -1) {
                    fileType = 'other';
                } else {
                    fileType = 'other';
                }

                return fileType;
            },
            openRichMessage: function (event, params) {
                var type = params.textType;
                var data = params.extraObj;
                switch (type) {
                    case 'moment':
                        openTabLayout('shareMoment', '', 'widget://html/users/moment-detail.html', {
                            prodId: data.momentId,
                            momentGuid: data.momentGuid,
                            userId: data.userId,
                            useServer: 'cn',
                            type: '',
                            from: 'chat',
                        });
                        break;
                    case 'product-showcase':
                        openTabLayout('tweebaaProductDetail', MSG.tProduct.detailTitle, 'widget://html/tproducts/tw-prod-detail.html', {
                            productId: data.productId,
                            index: data.index
                        });
                        break;
                    case 'product-tycoonplace':
                        openTabLayout('productDetail', '', 'widget://html/products/product-detail.html', {
                            prodId: data.prodId,
                            userInfo: data.userInfo,
                            countryCode: data.RegisterCountryCode,
                            tweebaaTag: data.tweebaaTag
                        });
                        break;
                    case 'evaluation':
                        openTabLayout('evaluationProduct', MSG.tProduct.detail, 'widget://html/discovery/evaluation-product.html', {
                            evaluationId: data.evaluationId,
                            evaluationData: data.evaluationData
                        });
                        break;
                    case 'tycoonplace':
                        openUserTycoonPlace(data.userId, data.storeName, data.AvatarUrl, 'chat');
                        break;
                }
            },
            getAnnouncements: function () {
                var that = this;
                apiNotify.get("/announcements", this.announcementCondition).done(function (rep) {
                    if (rep.code === 0) {
                        var list = rep.data.records;
                        var results = [];
                        $.map(list, function (item, index) {
                            item.titleObj = JSON.parse(item.title);
                            item.contentObj = JSON.parse(item.content);
                            results.unshift(item);
                        });
                        that.chatMessages = results;

                        that._showHtml();
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    console.error("[" + api.deviceName + "] getNotifyUnreads: " + JSON.stringify(err));
                });
            },
            _initDom: function () {
                var that = this;
                //调整字体大小
                var fontSize = localStorage.getItem('chatFontSize');
                if (fontSize) {
                    var style = '<style> #showChat .send, #showChat .received\{font-size: ' + getRightPxFromFontSize(fontSize) + 'px !important;\}</style>';
                    $('head').append(style);
                }

                var $doc = $(document);

                // 解决页面滚动过程中，突然停住不小心打开图片
                var t1 = 0;
                var t2 = 0;
                var timer = null; // 定时器

                $doc.scroll(function () {
                    that.isScrolling = true;
                    clearTimeout(timer);
                    timer = setTimeout(isScrollEnd, 500);
                    t1 = document.documentElement.scrollTop || document.body.scrollTop;
                    // console.warn('$doc.height()' + $doc.height() + ', that.hasReadAll: ' +  that.hasReadAll);
                    // console.warn("[" + api.deviceName + "] t1 : " + t1);
                    // console.warn("[" + api.deviceName + "] document.documentElement.scrollTop : " + document.documentElement.scrollTop);

                    if (that.isRequesting === false && that.hasReadAll === false && t1 <= OFFSET_REQURE_HISTORY) {
                        that.getChatHistory();
                        // console.log('[begin chat history] isRequesting: ' + that.isRequesting);
                        that.isRequesting = true;
                        setTimeout(function () {
                            that.isRequesting = false;
                            // console.log('[end chat history] isRequesting: ' + that.isRequesting);
                        }, REQUEST_TIME);
                    }
                });

                function isScrollEnd() {
                    t2 = document.documentElement.scrollTop || document.body.scrollTop;
                    // console.log('t2 ===== ' + t2);
                    if (t2 === t1) {
                        // console.log('滚动结束了');
                        that.isScrolling = false;
                    }
                }

                $doc.click(function () {
                    // console.log('Doc clicked...');
                    that.closeBoard();
                });

                // api.addEventListener({
                //     name:'tap'
                // }, function(ret, err){
                //     console.log('Doc clicked...');
                //     that.closeBoard();
                // });
            },
            /**
             * 获取聊天历史
             * 这个方法，猜测应该是ws返回数据，所以，这里的获取请求的方法，基本倾向于同步获取
             */
            getChatHistory: function (unreadTotal) {

                var that = this;
                loading('show');
                var count;
                if (unreadTotal) {
                    count = unreadTotal - this.hasReadNumber;
                } else {
                    count = that.firstLoad ? FIRST_PAGE_SIZE : HISTORY_PAGE_SIZE;
                }
                rong.getHistoryMessages({
                    conversationType: api.pageParam.conversationType,
                    targetId: api.pageParam.targetId,
                    oldestMessageId: that.lastMessageId || -1,
                    count: count,
                }, function (ret, err) {
                    loading('hide');

                    // console.log('+++++++++++++++++++++++++');
                    // console.log(JSON.stringify(ret.result));
                    // console.log('+++++++++++++++++++++++++');
                    //console.log(JSON.stringify(ret));
                    // that.chatMessages = that.chatMessages.concat(ret.result);


                    ret.result = ret.result || [];

                    var list = ret.result.reverse();

                    var len = ret.result.length;
                    if (len > 0) {
                        var item;
                        var lastMessageId = list[0].messageId;
                        var results = [];
                        for (var i = 0; i < len; i++) {
                            item = list[i];

                            if (item.objectName === 'RC:ImgMsg') {
                                that._imgLoad(item);
                            }

                            // 撤回消息
                            if (item.objectName === 'RC:RcNtf' && item.extra && JSON.parse(item.extra).sendPortrait) {
                                item.extraObj = JSON.parse(item.extra);
                                results.push(item);
                            } else if (item.content && item.content.extra && JSON.parse(item.content.extra).sendPortrait) {
                                item.content.extraObj = JSON.parse(item.content.extra);
                                if (item.extra) {
                                    try {
                                        item.extraObj = JSON.parse(item.extra);
                                    } catch (e) {

                                    }
                                } else {
                                    item.extraObj = {
                                        isVoiceRead: false
                                    }
                                }
                                if (item.content.extraObj && !item.content.extraObj.textType) {
                                    // 判断是否要插入时间
                                    if (i === 0) {
                                        that._checkTime(item, results, true);
                                    } else {
                                        that._checkTime(item, results);
                                    }

                                }
                                results.push(item);
                            }
                        }
                        that.chatMessages = results.concat(that.chatMessages);
                    }

                    // 是否所有的消息均已读完毕
                    if (that.firstLoad === true) {
                        // 清除未读消息状态
                        that.clearUnreadStatus();

                        if (len >= FIRST_PAGE_SIZE) {
                            that.hasReadAll = false;
                        } else {
                            that.hasReadAll = true;
                        }
                    } else {
                        if (!unreadTotal) {
                            if (len >= HISTORY_PAGE_SIZE) {
                                that.hasReadAll = false;
                            } else {
                                that.hasReadAll = true;
                            }
                        }

                        // 已读消息数量
                        that.hasReadNumber = that.hasReadNumber + count;
                    }
                    // console.log('hasReadNumber: ' + that.hasReadNumber);

                    setTimeout(function () {

                        // console.log('$(document).scrollTop(): ' + $(document).scrollTop());

                        if (that.firstLoad === true) {
                            that._showHtml();
                            that.firstLoad = false;
                            // console.log('firstLoad: ' + that.firstLoad);
                        } else if (that.firstLoad === false && len !== 0) {
                            var $doc = $(document);
                            var docHeight = $doc.height();

                            // 一次性阅读所有未读消息
                            if (unreadTotal) {
                                that.isScrolling = true;
                                that.isRequesting = true;
                                // console.log('[unread begin] isRequesting: ' + that.isRequesting);
                                api.pageUp({
                                    top: true
                                });
                                // $('html body').animate({
                                //     scrollTop: OFFSET_REQURE_HISTORY
                                // }, 300);
                                setTimeout(function () {
                                    $doc.scrollTop(1);
                                    // console.log('$doc.scrollTop(): ' + $doc.scrollTop());
                                    that.isRequesting = false;
                                    that.isScrolling = false;
                                    // console.log('[unread end] isRequesting: ' + that.isRequesting);
                                }, 1000);
                            } else {
                                var h = docHeight - that.currentDocHeight;
                                // console.log("[" + api.deviceName + "]" + ' docHeight: ' + docHeight);
                                // console.log("[" + api.deviceName + "]" + ' currentDocHeight: ' + that.currentDocHeight);
                                // console.log("[" + api.deviceName + "]" + ' h: ' + h);
                                $doc.scrollTop(h);
                            }
                            that.currentDocHeight = docHeight;
                        }

                        // 记录最后的一条消息
                        if (len !== 0) {
                            that.lastMessageId = lastMessageId;
                        }

                    }, 0);
                })
            },
            _imgLoad: function (item, callback) {
                item.content.renderPath = item.content.thumbPath;

                var img = new Image();
                img.src = item.content.imageUrl;
                if (img.complete) {
                    // console.log("[" + api.deviceName + "]" + '[complete] item.content.imageUrl: ' + item.content.imageUrl);
                    item.content.renderPath = item.content.imageUrl;
                } else {
                    img.onload = function () {
                        // console.log("[" + api.deviceName + "]" + '[onload] item.content.imageUrl: ' + item.content.imageUrl);
                        item.content.renderPath = item.content.imageUrl;
                        if (callback) {
                            callback();
                        }
                        img.onload = null;
                    };
                }
            },
            _showHtml: function () {
                var that = this;
                setTimeout(function () {
                    that.currentDocHeight = $(document).height();
                    // console.log('[_showHtml] this.currentDocHeight: ' + that.currentDocHeight);
                    window.scrollTo(0, 99999);
                    $('#chatPage').css({
                        opacity: 1
                    });
                }, 400);
            },
            toScrollBottom: function (time) {
                setTimeout(function () {
                    window.scrollTo(0, 99999);
                }, time || 100);
                // api.pageDown({
                //     bottom: true
                // });
            },
            _getMentionedParam: function (msg) {
                if (msg.indexOf('@') === -1) {
                    return null;
                }

                var that = this;
                var REG_MENTION_ALL = /(@all\s+)|(@all$)|(@所有人\s+)|(@所有人$)/gi;

                if (REG_MENTION_ALL.test(msg) === true) {
                    return {
                        type: 'all'
                    }
                }

                var REG_MENTION_PART = /@\S+/g;
                var mentionedMap = {};
                msg.replace(REG_MENTION_PART, function (word) {
                    // console.log(word);
                    var name = word.split('@')[1];
                    var item = that.membersMap[name];
                    if (item) {
                        mentionedMap[item.UserId] = item;
                    }
                });
                if ($.isEmptyObject(mentionedMap) === false) {
                    var userIdArray = [];
                    $.map(mentionedMap, function (item, key) {
                        userIdArray.push(item.UserId);
                    });
                    return {
                        type: 'part',
                        userIdList: userIdArray
                    }
                }

                return null;

            },
            setInputValue: function (value) {
                // console.log("[" + api.deviceName + "] setInputValue: " + value);
                this.inputValue = value;
            },
            inputMentionUser: function (user) {
                UIChatBox.value(function (ret) {
                    if (ret) {
                        var currentText = ret.msg;
                        UIChatBox.value({
                            msg: currentText + user.StoreNames + ' '
                        });
                        setTimeout(function () {
                            UIChatBox.popupKeyboard();
                        }, 100);
                    }
                });
            },
            inputMentionAll: function () {
                UIChatBox.value(function (ret) {
                    if (ret) {
                        var currentText = ret.msg;
                        UIChatBox.value({
                            msg: currentText + MSG.general.all + ' '
                        });
                        setTimeout(function () {
                            UIChatBox.popupKeyboard();
                        }, 100);
                    }
                });
            },
            openMentionedFrame: function () {
                api.openFrame({
                    name: 'setMentioned',
                    url: 'widget://html/chat/set-menthioned.html',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    pageParam: {
                        members: this.groupInfo.Members
                    },
                    bounces: false,
                    bgColor: 'rgba(0,0,0,0)',
                    fixedOn: 'ui_layout',
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 200
                    }
                });
            },

            _checkCalling: function () {
                var that = this;
                rong.getCallSession(function (ret) {
                    console.warn("[" + api.deviceName + "] _checkCalling: " + JSON.stringify(ret));
                    if (ret.status === false) {

                    } else {
                        that.callingInfo = ret.result;
                    }
                })
            },
            clearUnreadStatus: function () {
                var that = this;
                rong.clearMessagesUnreadStatus({
                    conversationType: this.conversationType,
                    targetId: this.targetId
                }, function (ret, err) {
                    // console.log('+++++++++++++++');
                    // console.warn(JSON.stringify(ret));
                    // console.log(JSON.stringify(err));
                    if (ret.status === 'success') {
                        // api.sendEvent({
                        //     name: 'conversationListReload'
                        // });
                    } else {
                        console.warn(JSON.stringify(ret));
                    }
                });
            },
            /**
             * 获取未读消息数量
             */
            getUnreadMsgNumber: function () {
                var that = this;
                rong.getUnreadCount({
                    conversationType: this.conversationType,
                    targetId: this.targetId
                }, function (ret, err) {
                    if (ret.status === 'success') {
                        that.unreadTotal = ret.result;
                        // console.log('that.unreadTotal: ' + that.unreadTotal);
                    } else {
                        console.error(JSON.stringify(ret));
                    }
                });
            },
            /**
             * 判断是否是群成员
             */
            checkInGroup: function () {
                var that = this;
                var url = getBaseUrl() + "api/im/v1/imgroup/" + this.targetId + '/' + localStorage.getItem('chatID');
                getAxois(url, "GET", {}).then(function (response) {
                    if (response.data.Code === 46004) {
                        alert(MSG.chat.notInGroup, function () {
                            closeChatPage();
                        });
                    }
                }).catch(function (error) {
                    console.error(JSON.stringify(error));
                });
            },
            /**
             * 获取聊天草稿
             */
            getDraft: function () {
                var that = this;
                rong.getTextMessageDraft({
                    conversationType: that.conversationType,
                    targetId: that.targetId
                }, function (ret, err) {
                    if (ret.result) {
                        UIChatBox.value({
                            msg: ret.result
                        });
                        that.hasDraft = true;
                    }

                })
            },
            getSendPortrait: function (msg) {
                var data = msg.content.extra;
                if (data) {
                    return JSON.parse(data).sendPortrait;
                }
            },
            getUserDetail: function () {
                var that = this;
                var url;
                if (this.conversationType === 'PRIVATE') {
                    var chatId = that.targetId.split('@')[0];
                    url = getBaseUrl() + "api/users/username/a?username=" + chatId;
                    getAxois(url, "GET", {}).then(function (response) {
                        //console.log(JSON.stringify(response.data));
                        that.userID = response.data.Id;
                        that.userGUID = response.data.CustomerGuid;

                        chatDetailMap[that.targetId] = response.data;
                        kv.setObject({
                            key: 'ChatDetailMap',
                            value: chatDetailMap
                        });
                    }).catch(function (error) {
                        console.error(JSON.stringify(error));
                    });
                } else {
                    url = getBaseUrl() + "api/im/v1/imgroup/" + that.targetId + "?currentpage=0&itemsperpage=100";
                    getAxois(url, "GET", {}).then(function (response) {
                        //console.log(JSON.stringify(response.data));
                        var groupInfo = response.data;
                        that.groupInfo = groupInfo;
                        that.chatName = response.data.Name;
                        that.chatPortrait = response.data.AvatarUrl || IMAGE_GROUP_AVATAR;

                        chatDetailMap[that.targetId] = groupInfo;
                        kv.setObject({
                            key: 'ChatDetailMap',
                            value: chatDetailMap
                        });

                        var members = groupInfo.Members;
                        $.map(members, function (item, index) {
                            if (!that.membersMap[item.StoreNames]) {
                                that.membersMap[item.StoreNames] = item;
                            }
                        });

                    }).catch(function (error) {
                        console.error(JSON.stringify(error));
                    });
                }
            },
            showAvatar: function (index) {
                var data = this.chatMessages[index].content.extra;
                if (data) {
                    var avatar = JSON.parse(data);
                    return avatar.sendPortrait
                } else {
                    return '../../image/portrait-placeholder.jpg'
                }
            },
            showName: function (index) {
                var data = this.chatMessages[index].content.extra;
                if (data) {
                    var avatar = JSON.parse(data);
                    return avatar.sendName
                }
            },
            scrollAllRead: function () {
                // console.log("[" + api.deviceName + "] scrollAllRead");
                this.getChatHistory(this.unreadTotal, true);
            },
            /**
             * 写入聊天内容
             * 将消息设置为已读
             * @param data
             */
            getChatMessage: function (data) {
                var that = this;
                var msg = data;
                if (typeof data === 'string') {
                    msg = JSON.parse(data);
                }
                msg.content.extraObj = JSON.parse(msg.content.extra);

                if (msg.content.extraObj && !msg.content.extraObj.textType) {
                    // 判断是否要插入时间
                    that._checkTime(msg, this.chatMessages);
                }

                if (msg.objectName === 'RC:ImgMsg') {
                    this._imgLoad(msg, function () {
                        that.toScrollBottom();
                    });
                }
                // if (msg.objectName === 'RC:ImgTextMsg') {
                //     if (msg.content.extraObj.textType === 'video') {
                //         this._imgLoad(msg.content.imageUrl, function () {
                //             that.toScrollBottom();
                //         });
                //     }
                // }
                if (msg.extra) {
                    try {
                        msg.extraObj = JSON.parse(msg.extra);
                    } catch (e) {

                    }
                } else {
                    msg.extraObj = {
                        isVoiceRead: false
                    }
                }

                if (msg.objectName !== 'RC:VcMsg') {
                    rong.setMessageReceivedStatus({
                        messageId: msg.messageId,
                        receivedStatus: 'READ'
                    }, function (ret, err) {
                        // console.log('==============');
                        // console.log(JSON.stringify(ret));
                        // console.log(JSON.stringify(err));
                    });
                }

                this.chatMessages.push(msg);

                this.toScrollBottom();
            },
            _checkTime: function (item, list, isForce) {
                var that = this;

                if (isForce === true) {
                    doIt();
                }

                if (!this.latestTime) {
                    doIt();
                } else {
                    // 大于1个小时
                    if (item.sentTime - this.latestTime >= ONE_HOUR_MINITIME) {
                        doIt();
                    } else if (this.timeCounter > TIME_ACROSS_NUM) {
                        doIt();
                    } else {
                        this.timeCounter++;
                    }
                }

                function doIt() {
                    that.latestTime = item.sentTime;
                    that.timeCounter = 0;
                    list.push({
                        objectName: 'TIME',
                        sentTime: item.sentTime
                    });
                }
            },
            /**
             * 将语音消息和语音通话设置为已读
             * @param msg
             */
            setVoiceRead: function (msg) {
                var extraObj = msg.content.extraObj || {};
                extraObj.isVoiceRead = true;

                rong.setMessageExtra({
                    messageId: msg.messageId,
                    value: JSON.stringify(extraObj)
                }, function (ret, err) {
                    // console.log('setVoiceRead: ' + JSON.stringify(ret));
                });
            },
            countMessage: function () {
                var msgC = Number(localStorage.getItem('messagesCount'));
                var newCount = msgC + 1;
                localStorage.setItem('messagesCount', newCount);  //记录聊天数量
                console.log("[" + api.deviceName + "] newCount: " + newCount);
                if (newCount >= 50) {
                    AddTivNew('MESSAGE');
                    localStorage.setItem('messagesCount', '0');
                }
            },
            sendMessages: function (msg, groupName, avatar, textType, isVoiceRead) {
                var that = this;
                if (msg === '' || msg === undefined) {
                    api.toast({
                        msg: MSG.chat.blankMessage,//'You can not send blank message'
                        duration: 2000,
                        location: 'middle'
                    });
                    return
                }
                if (that.hasDraft) {
                    rong.clearTextMessageDraft({
                        conversationType: that.conversationType,
                        targetId: that.targetId
                    }, function (ret, err) {
                        that.hasDraft = false;
                    })
                }
                if (api.pageParam.conversationType === 'GROUP') {
                    if (!groupName) {
                        groupName = api.pageParam.userName;
                    }
                    if (!avatar) {
                        avatar = api.pageParam.userPortrait || IMAGE_GROUP_AVATAR;
                    }
                }

                var mentionedInfo = this._getMentionedParam(msg);

                api.sendEvent({
                    name: 'sendMessagesEvent',
                    extra: {
                        type: 'text',
                        targetId: this.targetId,
                        conversationType: this.conversationType,
                        msg: msg,
                        sendUserId: this.sendUserId,
                        sendName: this.sendName,
                        sendPortrait: this.sendPortrait,
                        chatUserId: this.userID,
                        chatName: this.chatName,
                        chatPortrait: this.chatPortrait,
                        Source: systemType,
                        groupName: groupName,
                        avatar: avatar,
                        textType: textType,
                        isVoiceRead: isVoiceRead,
                        mentionedInfo: mentionedInfo
                    }
                });

                this.countMessage();
            },
            getPicture: function (type) {
                var that = this;
                var videos = ['mp4', 'mpg', 'mov', 'wmv', 'm3u8'];
                var pics = ['jpg', 'jpeg', 'raw', 'png', 'bmp'];
                if (type === 'library') {
                    UIAlbumBrowser.open({
                        max: 9,
                        isOpenPreview: true,
                        classify: true,
                        type: 'all',
                        styles: {
                            bg: '#FFFFFF',
                            cameraImg: 'widget://res/cameraImg.png',
                            mark: {
                                icon: '',
                                position: 'bottom_left',
                                size: 20
                            },
                            nav: {
                                bg: '#252525',
                                cancelColor: '#fff',
                                cancelSize: 16,
                                nextStepColor: '#fff',
                                nextStepSize: 16,
                                cancelText: MSG.general.cancel,
                                finishText: MSG.general.ok,
                            }
                        },
                    }, function (ret) {
                        setTimeout(function () {
                            console.warn("[UIAlbumBrowser.open] [" + api.deviceName + "]" + JSON.stringify(ret));

                            /*
                            // IOS
                            {
                                "eventType": "confirm",
                                "list": [
                                    {
                                    "mediaType": "video",
                                    "time": 1601442712394,
                                    "longitude": 0,
                                    "size": 2.167605955e-314,
                                    "duration": 11966.666666666666,
                                    "latitude": 0,
                                    "path": "B03F773B-838F-4E5E-9A61-E7370C53D189/L0/001",
                                    "thumbPath": "/var/mobile/Containers/Data/Application/ED4A0942-8514-43E7-A691-FEC25F65EEB7/Library/Caches/UZUIAlbumBrowser/1608711123601.png"
                                    }
                                ]
                            }

                            */

                            if (ret.eventType === 'nextStep' || ret.eventType === 'confirm') {
                                // UIAlbumBrowser.closePicker();
                                // that.closeBoard();
                                var medias = ret.list;
                                var len = medias.length;
                                var temp;
                                for (var i = 0; i < len; i++) {
                                    temp = medias[i];
                                    if (temp.mediaType) {
                                        temp.type = temp.mediaType;
                                    } else {
                                        if (videos.indexOf(temp.suffix.toLowerCase()) >= 0) {
                                            temp.type = 'video';
                                        } else {
                                            temp.type = 'image';
                                        }
                                    }

                                    (function (media) {
                                        if (api.systemType.toLowerCase() === 'ios') {
                                            if (media.type === 'image') {
                                                UIAlbumBrowser.transPath({
                                                    quality: 'highest',
                                                    scale: 1, //
                                                    path: media.path
                                                }, function (Ret, err) {
                                                    that.sendImage(Ret.path);
                                                });
                                            } else {
                                                UIAlbumBrowser.transVideoPath({
                                                    path: media.path
                                                }, function (Ret, err) {
                                                    console.warn("[UIAlbumBrowser.transVideoPath] [" + api.deviceName + "]" + JSON.stringify(Ret));
                                                    if (Ret.status) {
                                                        that.sendVideo(Ret.albumVideoPath);
                                                    }
                                                });
                                            }
                                        } else {
                                            if (media.type === 'image') {
                                                that.sendImage(media.path);
                                            } else {
                                                that.sendVideo(media.path);
                                            }
                                        }
                                    })(temp);
                                }
                            }
                        });
                    });
                } else {
                    // 拍照/摄像
                    actionSheet([
                        {
                            text: MSG.general.takePicture,
                            callback: function () {
                                api.getPicture({
                                    sourceType: 'camera',
                                    encodingType: 'jpg',
                                    mediaValue: 'pic',
                                    destinationType: 'url',
                                    allowEdit: false,
                                    quality: 80,
                                    saveToPhotoAlbum: false
                                }, function (ret, err) {
                                    console.warn("[" + api.deviceName + "]" + ret.data);
                                    if (ret) {
                                        that.closeBoard();
                                        that.sendImage(ret.data);
                                    }
                                });
                            }
                        },
                        {
                            text: MSG.general.takeVideo,
                            callback: function () {
                                api.getPicture({
                                    sourceType: 'camera',
                                    mediaValue: 'video',
                                    destinationType: 'url',
                                }, function (ret, err) {
                                    console.warn("[" + api.deviceName + "]" + ret.data);
                                    if (ret.data) {
                                        that.closeBoard();
                                        that.sendVideo(ret.data);
                                    }
                                });
                            }
                        }
                    ]);

                }
            },
            openImage: function (event, params) {

                if (this.isScrolling === true) {
                    // console.log('Image will not open !');
                    return;
                }
                var that = this;
                var thumb = params.thumb;
                var imageUrl = params.imageUrl;
                var msg = params.msg;

                this.imageShow = true;

                var UIPhotoViewer = api.require('UIPhotoViewer');
                UIPhotoViewer.open({
                    images: [imageUrl],
                    placeholderImg: thumb,
                    bgColor: '#000',
                    activeIndex: 0,
                    zoomEnabled: true,
                    gestureClose: true
                }, function (Ret, err) {
                    msg.content.thumbPath = imageUrl;
                    if (Ret.eventType === 'click') {
                        UIPhotoViewer.close();
                        chatPage.imageShow = false;
                    } else if (Ret.eventType === 'longPress') {
                        actionSheet([
                            {
                                text: MSG.general.repost,
                                callback: function () {
                                    that.repostImageToChats(imageUrl);
                                }
                            },
                            {
                                text: MSG.general.save,
                                callback: function () {
                                    // console.log("[" + api.deviceName + "]" + '[longPress] ' + imageUrl);

                                    // 从网络来的图片
                                    if (imageUrl.indexOf('http://') === 0) {
                                        api.download({
                                            url: imageUrl,
                                            report: true,
                                            cache: true,
                                            savePath: api.fsDir + "/" + Date.parse(new Date()) + ".jpg",
                                            allowResume: true
                                        }, function (ret, err) {
                                            // console.log("[" + api.deviceName + "]" + '[longPress] ' + JSON.stringify(ret));
                                            if (ret.state === 1) {
                                                var Url = ret.savePath;
                                                api.saveMediaToAlbum({
                                                    path: Url,
                                                    groupName: "Tweebaa"
                                                }, function (ret, err) {
                                                    if (ret && ret.status) {
                                                        api.toast({
                                                            msg: MSG.tips.saveImage,
                                                            duration: 2000,
                                                            location: 'middle'
                                                        });
                                                    }
                                                });
                                            }
                                        });
                                    } else {
                                        // 本地上传的图片
                                        api.saveMediaToAlbum({
                                            path: imageUrl,
                                            groupName: "Tweebaa"
                                        }, function (ret, err) {
                                            if (ret && ret.status) {
                                                api.toast({
                                                    msg: MSG.tips.saveImage,
                                                    duration: 2000,
                                                    location: 'middle'
                                                });
                                            }
                                        });

                                    }
                                }
                            }
                        ]);
                    }
                });
            },
            sendImage: function (url) {
                api.sendEvent({
                    name: 'sendMessagesEvent',
                    extra: {
                        type: 'img',
                        targetId: this.targetId,
                        conversationType: this.conversationType,
                        msg: url,
                        sendUserId: this.sendUserId,
                        sendName: this.sendName,
                        sendPortrait: this.sendPortrait,
                        chatUserId: this.userID,
                        chatName: this.chatName,
                        chatPortrait: this.chatPortrait,
                        Source: systemType
                    }
                });
                this.countMessage();
            },
            sendVideo: function (url) {
                var that = this;
                apiMedia.uploadVideo("/upload/videos", url).done(function (response) {
                    api.hideProgress();
                    var data = response.data[0];
                    var param = {
                        conversationType: that.conversationType,
                        targetId: that.targetId,
                        title: data.name.toLowerCase(),
                        description: data.duration + '',
                        imageUrl: data.thumbnailUrl,
                        extra: JSON.stringify({
                            textType: 'video',
                            sendUserId: that.sendUserId,
                            sendName: that.sendName,
                            sendPortrait: that.sendPortrait,
                            receiveUserId: that.userID,
                            receiveName: that.chatName,
                            receivePortrait: that.chatPortrait,
                            Source: systemType,
                            downloadUrl: data.downloadUrl,
                            duration: data.duration,
                        })
                    };
                    rong.sendRichContentMessage(param, function (ret, err) {
                        console.warn("[" + api.deviceName + "]" + JSON.stringify(ret));
                        if (ret.status === 'progress') {

                        } else if (ret.status === 'prepare') {
                            if (localStorage.getItem('openChatPage')) {
                                var message = JSON.stringify(ret.result.message);
                                api.sendEvent({
                                    name: 'showMessageInPage',
                                    extra: {
                                        message: message,
                                    }
                                });
                            }
                        } else if (ret.status === 'error') {
                            if (err.code === -3) {
                                api.toast({
                                    msg: '参数错误',
                                    duration: 2000,
                                    location: 'middle'
                                });
                            }
                            console.log('error: ' + err.code);
                        }
                    });
                });
            },
            sendVoice: function (ERT) {
                ERT = JSON.parse(ERT);

                if (ERT.duration > 0) {
                    var path = ERT.path;
                    var duration = ERT.duration > 60 ? 60 : ERT.duration;

                    api.sendEvent({
                        name: 'sendMessagesEvent',
                        extra: {
                            type: 'voice',
                            targetId: this.targetId,
                            conversationType: this.conversationType,
                            msg: path,
                            sendUserId: this.sendUserId,
                            sendName: this.sendName,
                            sendPortrait: this.sendPortrait,
                            chatUserId: this.userID,
                            chatName: this.chatName,
                            chatPortrait: this.chatPortrait,
                            Source: systemType,
                            duration: duration
                        }
                    });

                    this.countMessage();
                }
            },

            playVoice: function (event, params) {
                var msg = params.msg;
                var voicePath = params.voicePath;
                var msgId = params.msgId;
                var index = this.chatMessages.indexOf(msg);

                var that = this;

                api.stopPlay();
                if (that.isPlay && that.playId === msgId) {
                    api.stopPlay();
                    that.isPlay = false;
                } else {
                    that.setVoiceRead(msg);
                    that.isPlay = true;
                    that.playId = msgId;
                    api.startPlay({
                        path: voicePath
                    }, function (ret) {
                        if (ret) {
                            that.isPlay = false;
                            var nextMsg = that.chatMessages[index + 1];
                            if (nextMsg && nextMsg.objectName === "RC:VcMsg" && nextMsg.extraObj.isVoiceRead === false
                                && nextMsg.messageDirection === "RECEIVE") {
                                that.playVoice(null, {
                                    msg: nextMsg,
                                    voicePath: nextMsg.content.voicePath,
                                    msgId: nextMsg.messageId
                                });
                            }
                        }
                    });

                }
            },
            giveTweebucks: function () {
                var that = this;
                that.closeBoard();
                openTabLayout("giveTweebucks", MSG.tweebucks.giveTweebucks, 'widget://html/tweebucks/give-tweebucks.html', {
                    receiver: that.userID,
                    receiverGuid: that.userGUID,
                    name: api.pageParam.userName,
                    AvatarUrl: api.pageParam.userPortrait,
                    targetId: that.targetId
                });
            },
            tweebucksReceive: function (event, params) {
                var that = this;
                var DATA = params.description;
                openTabLayout("tweebucksPack", '', 'widget://html/tweebucks/tweebucks-pack.html', {
                    receiver: that.userID,
                    receiverGuid: that.userGUID,
                    name: api.pageParam.userName,
                    AvatarUrl: api.pageParam.userPortrait,
                    targetId: that.targetId,
                    tweebucksData: DATA
                });
            },
            playVideo: function (url) {
                playVideo(url, 'chat');
            },
            openFileDetail: function (event, params) {
                var msg = params.msg;
                var fileType = this.getFileType(msg.content.name);
                switch (fileType) {
                    case 'video':
                        playVideo(msg.content.mediaUrl, 'chat');
                        break;
                    case 'image':
                        this.openImage(null, {
                            thumb: msg.content.fileUrl,
                            imageUrl: msg.content.fileUrl,
                            msg: msg
                        });
                        break;
                    case 'audios':
                        openTabLayout('audioPlayer', '', 'widget://html/business/audio-player.html', {
                            url: msg.content.mediaUrl,
                            title: msg.content.name,
                            pic: '../../image/icon/audio.png',
                            page: 'chat'
                        });
                        break;
                    case 'pdf':
                        openTabLayout('pdfPlayer', msg.content.name, 'widget://html/business/pdfreader.html', {
                            url: msg.content.mediaUrl,
                            page: 'chat'
                        });
                        break;
                    case 'text':
                    default:
                        openTabLayout('otherFile', msg.content.name, 'widget://html/business/other-player.html', {
                            url: msg.content.mediaUrl,
                            page: 'chat'
                        });
                }
            },
            getFileName: function (path) {
                var pos = path.lastIndexOf('/');
                return path.substr(pos + 1);
            },
            sendFileMessage: function () {
                var that = this;

                UIChatBox.closeBoard();

                if (systemType === 'android') {
                    var getFile = api.require('getFile');
                    getFile.open(function (ret, err) {
                        that.closeBoard();
                        if (ret.status) {
                            console.log("[" + api.deviceName + "]" + JSON.stringify(ret));
                            var path = ret.path;
                            var fileName = that.getFileName(path);
                            var newPath = api.fsDir;
                            var destPath = api.fsDir + '/' + fileName;
                            console.log("[" + api.deviceName + "] destPath: " + destPath);
                            var fs = api.require('fs');
                            fs.copyTo({
                                oldPath: ret.path,
                                newPath: newPath
                            }, function (ret, err) {
                                if (ret.status) {
                                    console.log("[" + api.deviceName + "]" + JSON.stringify(ret));
                                    start(destPath);
                                } else {
                                    console.warn("[" + api.deviceName + "]" + JSON.stringify(err));
                                }
                            });
                        } else {
                            alert('选择文件不存在');
                        }
                    });
                } else {
                    // var $input = $('<input type="file" id="file" name="file">');
                    // $input.change(function (e) {
                    //     console.log(JSON.stringify(e));
                    //     var file = this.files[0];
                    //     console.log('files[0]: ' + JSON.stringify(file));
                    //     console.log('$input.val(): ' + $input.val());
                    //     // var reader = new FileReader();
                    //     // reader.readAsDataURL(file);
                    //     // reader.onloadend = function () {
                    //     //     console.log('reader.result: ' + reader.result);
                    //     //     start(reader.result);
                    //     // };
                    //     var path = getObjectURL(file);
                    //     // var path = $input.val();
                    //     console.log('path: ' + path);
                    //     UIAlbumBrowser.transPath({
                    //         quality: 'highest',
                    //         scale: 1, //
                    //         path: path
                    //     }, function (Ret, err) {
                    //         console.log('Ret: ' + JSON.stringify(Ret));
                    //         start(Ret.path);
                    //     });
                    // });
                    // $input.trigger('click');
                    //
                    // function getObjectURL(file) {
                    //     var url = null ;
                    //     if (window.createObjectURL !== undefined) { // basic
                    //         url = window.createObjectURL(file) ;
                    //     } else if (window.URL !== undefined) { // mozilla(firefox)
                    //         url = window.URL.createObjectURL(file) ;
                    //     } else if (window.webkitURL !== undefined) { // webkit or chrome
                    //         url = window.webkitURL.createObjectURL(file) ;
                    //     }
                    //     return url ;
                    // }

                    // var fileBrowser = api.require('fileBrowser');
                    // fileBrowser.open(function(ret) {
                    //     if (ret) {
                    //         alert(JSON.stringify(ret));
                    //     }
                    // });

                    var fileReader = api.require('fileReader');
                    fileReader.addEventListener({
                        target: 'select'
                    },function(ret) {
                        console.log("[" + api.deviceName + "] fileReader 监听: " + JSON.stringify(ret));
                        that.closeBoard();
                        $.map(ret.urls, function (path, index) {
                            start(path);
                        });
                    });
                    fileReader.open(function(ret) {
                        if (ret.status) {

                        }
                    });

                }

                function start(path) {
                    var fileName = that.getFileName(path);
                    var fileType = that.getFileType(fileName);
                    switch (fileType) {
                        case 'video':
                            that.sendVideo(path);
                            break;
                        case 'image':
                            that.sendImage(path);
                            break;
                        case 'audios':
                        case 'pdf':
                        case 'text':
                        default:
                            rong.sendFileMessage({
                                conversationType: that.conversationType,
                                targetId: that.targetId,
                                filePath: path,
                                extra: JSON.stringify({
                                    sendUserId: that.sendUserId,
                                    sendName: that.sendName,
                                    sendPortrait: that.sendPortrait,
                                    receiveUserId: that.userID,
                                    receiveName: that.chatName,
                                    receivePortrait: that.chatPortrait,
                                    Source: systemType
                                })
                            }, function (ret, err) {
                                console.warn("[" + api.deviceName + "]" + JSON.stringify(ret));
                                if (ret.status === 'progress') {
                                    api.showProgress({
                                        title: MSG.general.uploading,
                                        text: ret.result.progress + '%',
                                        modal: false
                                    });
                                } else if (ret.status === 'success') {
                                    api.hideProgress();
                                    if (localStorage.getItem('openChatPage')) {
                                        rong.getLatestMessages({
                                            conversationType: that.conversationType,
                                            targetId: that.targetId,
                                            count: 1
                                        }, function(ret, err) {
                                            console.warn("[" + api.deviceName + "]【openChatPage】" + JSON.stringify(ret));
                                            that.getChatMessage(ret.result[0]);
                                        });
                                    }
                                } else if (ret.status === 'error') {
                                    if (err.code === -3) {
                                        api.toast({
                                            msg: '参数错误',
                                            duration: 2000,
                                            location: 'middle'
                                        });
                                    }
                                    console.log('error: ' + err.code);
                                }

                            });
                    }
                }

            },
            vCall: function () {
                var that = this;

                that.closeBoard();
                if (that.conversationType === 'GROUP' && that.groupInfo) {
                    openTabLayout('callSelector', MSG.chat.selectMembers, 'widget://html/chat/call-selector.html', {
                        groupInfo: that.groupInfo,
                    });
                } else if (that.conversationType === 'PRIVATE') {
                    var extra = {
                        userInfo: {nickName: that.sendName},
                        sendUserId: that.sendUserId,
                        sendName: that.sendName,
                        sendPortrait: that.sendPortrait,
                        receiveUserId: that.userID,
                        receiveName: that.chatName,
                        receivePortrait: that.chatPortrait,
                        Source: systemType
                    };
                    // var msg = MSG.chat.startVoiceCall;
                    // that.sendMessages(msg);

                    // console.log("[startCall] [" + api.deviceName + "] 发起通话");

                    // 修改对方收到的通知内容，XXX邀请你进行语音通话

                    rong.sendCommandMessage({
                        conversationType: 'PRIVATE',
                        targetId: that.targetId,
                        name: 'vPrivateCall:begin',
                        data: JSON.stringify(extra)
                    }, function (ret, err) {
                        console.info("[" + api.deviceName + "][sendCommandMessage][vPrivateCall:begin]: " + JSON.stringify(ret));
                        if (ret.status === 'success') {
                            // rong.configurationParameter({
                            //     alertTitle: that.sendName + MSG.chat.toCall,
                            //     showNickname: false
                            // });
                            rong.startCall({
                                targetId: that.targetId,            //targetId: 对方用户id
                                mediaType: "audio",
                                conversationType: that.conversationType,
                                extra: JSON.stringify(extra),
                                userIdList: [that.targetId]
                            }, function (ret) {
                                var calledId = ret.callSession.callId;
                                console.log('startCall:' + JSON.stringify(ret));

                                // 还原推送的消息体内容
                                // rong.configurationParameter({
                                //     alertTitle: '',
                                //     showNickname: true
                                // });

                                that.callingTimeId = setTimeout(function () {
                                    api.sendEvent({
                                        name: 'openVCallPage',
                                        extra: {
                                            calledId: calledId,
                                            targetId: that.targetId,
                                            mediaType: 'audio',
                                            chatName: that.chatName,
                                            chatPortrait: that.chatPortrait,
                                            direction: 'send',
                                            extra: extra
                                        }
                                    });
                                }, 500);

                                if (api.systemType === 'ios') {
                                    // 接通
                                    rong.addCallSessionListener({
                                        target: 'didConnect'
                                    }, function (ret) {
                                        console.log('didConnect:' + JSON.stringify(ret) + 'callstart监听到已连接');
                                        // console.warn("[" + api.deviceName + "] [IOS] [didConnect] callstart监听到已连接: " + JSON.stringify(ret));
                                        api.sendEvent({
                                            name: 'vCallConnected',
                                        });
                                    });
                                    // 挂断
                                    rong.addCallSessionListener({
                                        target: 'remoteUserDidLeft'
                                    }, function (ret) {
                                        console.warn("[" + api.deviceName + "] [IOS] [remoteUserDidLeft] 挂断: " + JSON.stringify(ret));
                                        // console.log("已挂断:" + JSON.stringify(ret) + 'callstart监听到挂断');
                                        // 如果对方正在通话，那么提示用户通话中，且挂断
                                        if (ret.disConnectReason === 14) {
                                            api.sendEvent({
                                                name: 'callingIsBusy'
                                            });
                                        }
                                    });
                                }
                            });
                        } else if (ret.status === 'error') {
                            console.error(JSON.stringify(ret));
                        }
                    });

                }

            },
            videoCall: function () {
                var that = this;

                that.closeBoard();

                var extra = {
                    userInfo: {nickName: that.sendName},
                    sendUserId: this.sendUserId,
                    sendName: that.sendName,
                    sendPortrait: that.sendPortrait,
                    receiveUserId: that.userID,
                    receiveName: that.chatName,
                    receivePortrait: that.chatPortrait,
                    Source: systemType
                };
                // var msg = MSG.chat.startVoiceCall;
                // that.sendMessages(msg);

                // console.log("[startCall] [" + api.deviceName + "] 发起通话");
                rong.startCall({
                    targetId: that.targetId,            //targetId: 对方用户id
                    mediaType: "video",
                    conversationType: that.conversationType,
                    extra: JSON.stringify(extra),
                    userIdList: [that.targetId]
                }, function (ret) {
                    var calledId = ret.callSession.callId;
                    //console.log('startCall:' + JSON.stringify(ret));
                    if (api.systemType === 'ios') {
                        // 接通
                        // rong.addCallSessionListener({
                        //     target: 'didConnect'
                        // }, function(ret) {
                        //     console.log('didConnect:' + JSON.stringify(ret) +'callstart监听到已连接');
                        //     console.warn("[" + api.deviceName + "] [IOS] [didConnect] callstart监听到已连接: " + JSON.stringify(ret));
                        //     api.sendEvent({
                        //         name: 'videoCallConnected',
                        //     });
                        // });

                        rong.removeCallSessionListener({
                            target: 'remoteUserDidJoin'
                        });
                        console.log('aaa');
                        rong.addCallSessionListener({
                            target: 'remoteUserDidJoin'
                        }, function (ret) {

                            console.log("[remoteUserDidJoin] [" + api.deviceName + "] 对端用户加入了通话的事件:" + JSON.stringify(ret));

                            // 视频通话
                            if (ret.mediaType === 'video') {
                                api.sendEvent({
                                    name: 'videoCallConnected',
                                    extra: {
                                        userId: ret.userId
                                    }
                                });
                            }

                        });

                        // 挂断
                        rong.addCallSessionListener({
                            target: 'remoteUserDidLeft'
                        }, function (ret) {
                            console.warn("[" + api.deviceName + "] [IOS] [remoteUserDidLeft] 挂断: " + JSON.stringify(ret));
                            console.log("已挂断:" + JSON.stringify(ret) + 'callstart监听到挂断');
                        });
                    }

                    // openVideoCallPage(calledId, that.targetId, 'video', that.chatName, that.chatPortrait, 'send', extra);

                    api.sendEvent({
                        name: 'openVideoCallPage',
                        extra: {
                            calledId: calledId,
                            targetId: that.targetId,
                            mediaType: 'video',
                            chatName: that.chatName,
                            chatPortrait: that.chatPortrait,
                            direction: 'send',
                            extra: extra
                        }
                    });

                    // api.openFrame({
                    //     name: 'vCallPage',
                    //     url: 'widget://html/chat/vcall.html',
                    //     rect: {
                    //         x: 0,
                    //         y: 0,
                    //         w: 'auto',
                    //         h: 'auto'
                    //     },
                    //     pageParam: {
                    //         chatName: that.chatName,
                    //         portrait: that.chatPortrait,
                    //         calledId: calledId,
                    //         mediaType: type,
                    //         targetId: that.targetId,
                    //         direction: 'send',
                    //         extra: JSON.stringify(extra)
                    //     },
                    //     bounces: false,
                    //     bgColor: 'rgba(0,0,0,0.7)',
                    //     fixedOn: 'ui_layout',
                    //     animation:{
                    //         type: "movein",
                    //         subType: "from_top",
                    //         duration: 200
                    //     }
                    // });

                });


            },
            replyCall: function (msg, type) {
                this.setVoiceRead(msg);
                if (type === 'call') {
                    this.vCall();
                } else {
                    this.videoCall();
                }
            },
            openPlace: function (event, params) {

                if (this.isScrolling === true) {
                    console.log('Tycoon will not open !');
                    return;
                }

                var msg = params.msg;
                var data = JSON.parse(msg.content.extra);
                var userID;
                if (this.conversationType === "GROUP") {
                    var userName = msg.senderUserId.split('@')[0];
                    if (msg.senderUserId === localStorage.getItem('chatID')) {
                        userID = localStorage.getItem('userId');
                        openUserTycoonPlace(userID, data.sendName, data.sendPortrait);
                    } else {
                        loading('show');
                        var url = getBaseUrl() + "/api/users/username/a?username=" + userName;
                        //console.log(url);
                        getAxois(url, "GET", {}).then(function (response) {
                            //console.log(JSON.stringify(response.data));
                            openUserTycoonPlace(response.data.Id, response.data.StoreName, response.data.ThumbnailAvatarUrl);
                            loading('hide');
                        }).catch(function (error) {
                            loading('hide');
                            console.error(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                        });
                    }
                } else {
                    userID = data.sendUserId === localStorage.getItem('chatID') ? localStorage.getItem('userId') : data.sendUserId;
                    if (userID) {
                        openUserTycoonPlace(userID, data.sendName, data.sendPortrait);
                    }

                }
            },
            mentionSomeone: function (event, params) {
                var that = this;
                var userName = params.userName;
                UIChatBox.value(function (ret) {
                    if (ret) {
                        var currentText = ret.msg;
                        var value = '';
                        if (that.conversationType === 'PRIVATE') {
                            value = currentText + userName + ' ';
                        } else {
                            value = currentText + '@' + userName + ' ';
                        }
                        UIChatBox.value({
                            msg: value
                        });
                        setTimeout(function () {
                            UIChatBox.popupKeyboard();
                        }, 100);
                    }
                });
            },
            showListButton: function (event, params) {
                var index = params.index;
                var tar = event.target;
                var that = this;

                $(tar).closest('.msg-content').addClass('opacity-5');

                var data = that.chatMessages[index];
                var msgId = data.messageId;
                var content = data.content;
                var objName = data.objectName;
                var extraObj = data.content.extraObj;
                var direction = data.messageDirection;
                var text = data.content.text;
                var sentTime = data.sentTime;
                var nowTime = new Date().getTime();
                var fromNow = (nowTime - sentTime) / 1000;
                // console.log("msgId: " + msgId);
                // console.log("objName: " + objName);
                // console.log("now: " + new Date().getTime());
                var buttons = [];

                if (direction === 'SEND' && fromNow < RECALL_TIMEOUT) {
                    buttons.push({
                        text: MSG.chat.recall,
                        callback: function () {
                            that.recallMessage(msgId, index);
                        }
                    });
                }

                buttons.push({
                    text: MSG.chat.removeConversation,
                    callback: function () {
                        rong.deleteMessages({
                            messageIds: [msgId]
                        }, function (ret, err) {
                            that.chatMessages.splice(index, 1);
                        });
                    }
                });

                switch (objName) {
                    case 'RC:TxtMsg':
                        if (content && content.extraObj && content.extraObj.textType !== 'call' && content.extraObj.textType !== 'videoCall') {
                            buttons = [
                                {
                                    text: MSG.general.repost,
                                    callback: function () {
                                        openShareToChats({
                                            type: 'text',
                                            msg: text
                                        });
                                    }
                                },
                                {
                                    text: MSG.general.copy,
                                    callback: function () {
                                        var clipBoard = api.require('clipBoard');

                                        // 将发消息时，格式化的链接去除掉
                                        var value = removeLink(text);

                                        clipBoard.set({
                                            value: value
                                        }, function (ret, err) {
                                            if (ret) {
                                                api.toast({
                                                    msg: MSG.tips.copied,
                                                    duration: 2000,
                                                    location: 'middle'
                                                });
                                            }
                                        });
                                    }
                                },
                                {
                                    text: MSG.general.translate,
                                    callback: function () {
                                        data.extra = MSG.tips.translating;
                                        var url = getBaseUrl() + '/api/v2/translation';
                                        var paramStr = {
                                            "q": text,
                                            "LanguageCode": lan,
                                        };
                                        getAxois(url, "POST", paramStr).then(function (response) {
                                            data.extra = response.data.TranslatedText;
                                        }).catch(function (error) {
                                            console.error(JSON.stringify(error) + '聊天翻译错误');
                                        });
                                    }
                                }
                            ];
                            if (direction === 'SEND' && fromNow < RECALL_TIMEOUT) {
                                buttons.push({
                                    text: MSG.chat.recall,
                                    callback: function () {
                                        that.recallMessage(msgId, index);
                                    }
                                });
                            }
                            buttons.push({
                                text: MSG.chat.removeConversation,
                                callback: function () {
                                    rong.deleteMessages({
                                        messageIds: [msgId]
                                    }, function (ret, err) {
                                        that.chatMessages.splice(index, 1);
                                    });
                                }
                            });
                        }
                        break;
                    case 'RC:VcMsg':
                        buttons.unshift({
                            text: MSG.general.repost,
                            callback: function () {
                                openShareToChats({
                                    type: 'voice',
                                    path: data.content.voicePath,
                                    duration: data.content.duration
                                });
                            }
                        });
                        break;
                    case 'RC:ImgMsg':
                        var imageUrl = data.content.renderPath;
                        buttons.unshift({
                            text: MSG.general.repost,
                            callback: function () {
                                that.repostImageToChats(imageUrl);
                            }
                        });
                        break;
                    case 'RC:ImgTextMsg':
                        var textType = extraObj.textType;
                        if (textType !== 'tweebuck') {
                            buttons.unshift({
                                text: MSG.general.repost,
                                callback: function () {
                                    openShareToChats({
                                        type: 'imgText',
                                        title: content.title,
                                        description: content.description,
                                        imageUrl: content.imageUrl,
                                        currentTagetId: that.targetId,
                                        extra: extraObj
                                    });
                                }
                            });
                        }
                        break;
                    case 'RC:FileMsg':
                        buttons.unshift({
                            text: MSG.general.repost,
                            callback: function () {
                                openShareToChats({
                                    type: 'file',
                                    name: content.name,
                                    fileUrl: content.fileUrl,
                                    currentTagetId: that.targetId,
                                    extra: extraObj
                                });
                            }
                        });
                }

                actionSheet(buttons, function () {
                    $('#showChat').find('.msg-content').removeClass('opacity-5');
                });

            },
            repostImageToChats: function (imageUrl) {
                if (imageUrl.indexOf('http://') === 0) {
                    api.download({
                        url: imageUrl,
                        report: true,
                        cache: true,
                        savePath: api.fsDir + "/" + Date.parse(new Date()) + ".jpg",
                        allowResume: true
                    }, function (ret, err) {
                        console.log("[" + api.deviceName + "]" + '[longPress] ' + JSON.stringify(ret));
                        if (ret.state === 1) {
                            openShareToChats({
                                type: 'img',
                                renderPath: ret.savePath,
                            });
                        }
                    });
                } else {
                    // 本地上传的图片
                    openShareToChats({
                        type: 'img',
                        renderPath: imageUrl,
                    });
                }
            },
            recallMessage: function (id, index) {
                var that = this;

                var data = that.chatMessages[index];
                var extraObj = data.content.extraObj;
                extraObj.type = 'recall';

                rong.setMessageExtra({
                    messageId: id,
                    value: JSON.stringify(extraObj)
                }, function (ret, err) {
                    rong.recallMessage({
                        messageId: id
                    }, function (ret, err) {
                        if (ret.success) {
                            $('#chatId' + id).html("<div class='small text-center text-light-gray'>" + MSG.chat.recallSender + "</div>");
                        }
                    });
                });

            },
            keybackClose: function () {
                if (this.imageShow) {
                    var UIPhotoViewer = api.require('UIPhotoViewer');
                    UIPhotoViewer.close();
                    this.imageShow = false;
                } else {
                    closeChatPage();
                }
            },
            closePage: function () {
                localStorage.removeItem("openChatPage");
                api.setKeepScreenOn({
                    keepOn: false
                });
                var that = this;
                UIChatBox.value(function (ret, err) {
                    if (ret.msg) {
                        rong.saveTextMessageDraft({
                            conversationType: that.conversationType,
                            targetId: that.targetId,
                            content: ret.msg
                        }, function (ret, err) {

                        });
                    } else if (that.hasDraft) {
                        rong.clearTextMessageDraft({
                            conversationType: that.conversationType,
                            targetId: that.targetId
                        }, function (ret, err) {

                        });
                    } else {

                    }
                });

            },
            chatProfile: function () {
                var that = this;
                var username = api.pageParam.userName;
                var targetId = api.pageParam.targetId;
                var userPortrait = api.pageParam.userPortrait;
                var conversationType = api.pageParam.conversationType;
                var isTop = api.pageParam.isTop;
                var group = that.groupInfo ? that.groupInfo : null;
                // var pageTitle = conversationType ==='GROUP'? username + '('+that.groupInfo.Members.length+')':'';
                openTabLayout('chatProfile', MSG.general.set, 'widget://html/chat/chat-setting.html', {
                    targetId: targetId,
                    userId: that.userID,
                    userName: username,
                    userPortrait: userPortrait,
                    conversationType: conversationType,
                    isTop: isTop,
                    isSilence: that.silence,
                    groupInfo: group,
                });
            },
            cleanMessage: function () {
                this.chatMessages = [];
            },
            showMic: function () {
                $('.mic').show();
            },
            hideMic: function () {
                $('.mic').hide();
            },
            setMicTime: function (value) {
                if (value !== undefined) {
                    $('#Countdown').text(value);
                } else {
                    $('#Countdown').empty();
                }
            },
            closeBoard: function () {
                api.sendEvent({
                    name: 'closeChatBoxBoard'
                });
                // UIChatBox.closeBoard();
                // UIChatBox.closeKeyboard();
            }
        }
    });

    //清除系统提示
    api.cancelNotification({
        id: -1
    });
    api.setAppIconBadge({
        badge: 0
    });
};

function removeLink(text) {
    var reg = /<a href=['"]javascript:;['"] data-url=['"]\S+['"] onclick=['"]openBrowser\(this\)['"]>(\S+)<\/a>/gi;
    if (text) {
        return text.replace(reg, '$1');
    }
}


