var MSG;

apiready = function () {
    api.setWinAttr({
        bounces: false
    });

    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    }) || localStorage.getItem('access_token');

    var UIInput = api.require('UIInput');
    UIInput.open({
        rect: {
            x: 15 + 44,
            y: getRightPxFromFontSize(16),
            w: api.winWidth- 160,
            h: 44
        },
        styles: {
            bgColor: 'rgba(0,0,0,0)',
            size: 14,
            color: '#000',
            placeholder: {
                color: '#BDBDBD'
            }
        },
        autoFocus: true,
        maxRows: 1,
        placeholder: MSG.searchFriend.placeholder,
        keyboardType: 'search',
        fixedOn: api.frameName,
        fixed: false
    }, function(ret) {
        if (ret.eventType === 'search') {
            UIInput.value(function(Ret) {
                if (Ret) {
                    searchFriends.inputKeys = Ret.msg;
                    searchFriends.submitKey();
                    UIInput.closeKeyboard();
                }
            });
        }
        if (ret.eventType === 'change') {
            searchFriends.changeInput();
        }
    });

    api.addEventListener({
        name:'swiperight'
    }, function(ret, err){
        back();
    });

    backListener();

    var kv = api.require('snKVStorage');
    var hasSearchFriendsKeys = kv.has({
        key: 'searchFriendsRecords'
    });
    var SEARCH_RECORDS;
    if (hasSearchFriendsKeys === true) {
        SEARCH_RECORDS = kv.getArray({
            key: 'searchFriendsRecords'
        });
    }

    var searchFriends = new Vue({
        el: '#searchFriends',
        data: function () {
            var records = [];
            if (SEARCH_RECORDS) {
                records = SEARCH_RECORDS.slice(0, 10);
            }
            return {
                myID: +localStorage.getItem('userId'),
                inputKeys: '',
                keySelectList:[],
                listData:[],
                searchRecordsList: records,
                isRequesting: false,
                message: MSG
            }
        },
        methods:{
            resetKey: function() {
                this.inputKeys = '';
                this.keySelectList = [];
                this.listData = [];
                UIInput.value({
                    msg: '',
                });
            },
            clickHistory: function(key) {
                UIInput.value({
                    msg: key,
                });
                this.inputKeys = key;
                this.submitKey();
                UIInput.closeKeyboard();
            },
            clearHistory: function() {
                this.searchRecordsList = [];
                kv.setArray({
                    key: 'searchFriendsRecords',
                    value: []
                });
            },
            /**
             * 格式化搜索关键字
             * @param text
             * @param userId
             * @returns {*}
             */
            formatSearchResult: function(text, userId) {
                var reg = new RegExp(this.inputKeys, 'gi');
                var result = text.replace(reg, '<em class="text-blue">$&</em>');
                if (userRemarkService.has(userId) === true) {
                    result = result + ' (' + userRemarkService.get(userId) + ')'
                }
                return result;
            },
            changeInput:function(){
                var that = this;
                UIInput.value(function(Ret) {
                    if(Ret.msg.length>=1){
                        that.inputKeys = Ret.msg;
                        // that.getAutoList(Ret.msg);
                        that.searchUser(Ret.msg);
                    }else{
                        that.keySelectList = [];
                        that.listData = [];
                        that.inputKeys ='';
                    }
                });
            },
            inputKey:function (e) {
                this.inputKeys = e.target.value;
                this.listData = [];
                if(this.inputKeys){
                    this.getAutoList(this.inputKeys);
                }else{
                    this.keySelectList = [];
                }
            },
            getAutoList:function (q) {
                var that = this;
                var Q = q ||'';
                console.log('Q: ' + Q);
                if (this.isRequesting === true) {
                    return;
                }
                this.isRequesting = true;
                var paramStr = {
                    page: 1,
                    size: 10,
                    q: Q
                };
                setTimeout(function () {
                    apiUserCenter.get("/api/v1/users/autocomplete", paramStr).done(function (rep) {
                        loading('hide');
                        that.isRequesting = false;
                        if (rep.code === 0) {
                            that.keySelectList = rep.data;
                        } else {
                            api.toast({
                                msg: rep.message,
                                duration: 2000,
                                location: 'middle'
                            });
                        }
                    }).fail(function (err) {
                        loading('hide');
                        that.isRequesting = false;
                        api.toast({
                            msg:MSG.tips.systemError,
                            duration: 2000,
                            location: 'middle'
                        });
                    });
                }, 100);

                // var url = getBaseUrl() +'/api/users/autocomplete?q='+Q+'&currentpage=0&itemsperpage=7';
                // getAxois(url,"GET",{}).then(function (response) {
                //     that.keySelectList = response.data;
                // }).catch(function (error) {
                //     console.log(JSON.stringify(error));
                // });
            },
            selectKey:function(key){
                this.inputKeys = key;
                UIInput.value({
                    msg: key,
                });
                this.searchUser(key);
            },
            submitKey:function () {
                $('input').blur();
                if(!this.inputKeys){
                    return false;
                }
                this.searchUser();
            },
            _reduceSame: function(list) {
                var results = [];
                for (var i = 0, len = list.length; i < len; i++) {
                    if (results.indexOf(list[i]) < 0) {
                        results.push(list[i]);
                    }
                }
                return results;
            },
            followBtn: function (item) {
                var token = api.getPrefs({
                    sync: true,
                    key: 'accessToken'
                });
                if (token) {
                    if (item.followed === true) {
                        disFollow(item.userGuid, function () {
                            item.followed = false;
                        });
                    } else {
                        follow(item.userGuid, item.userName, function () {
                            item.followed = true;
                        });
                    }
                } else {
                    openLogin();
                }
            },
            searchUser:function (key) {
                var that = this;
                var Key = key || this.inputKeys;
                var paramStr = {
                    page: 1,
                    size: 10,
                    q: Key
                };
                var header = {};
                if (token) {
                    header.Authorization = 'Bearer ' + token;
                }
                apiUserCenter.get("/api/v1/users", paramStr, header).done(function (rep) {
                    loading('hide');
                    // console.log(JSON.stringify(rep));
                    if (rep.code === 0) {
                        that.keySelectList = [];

                        var results = rep.data;
                        $.map(results, function (item, index) {
                            item.Followed = item.followed;
                        });

                        that.listData = results;

                        // 记录搜索记录
                        var list = that.searchRecordsList;
                        list.unshift(that.inputKeys);
                        that.searchRecordsList = that._reduceSame(list);
                        kv.setArray({
                            key: 'searchFriendsRecords',
                            value: that.searchRecordsList
                        });
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    loading('hide');
                    api.toast({
                        msg:MSG.tips.systemError,
                        duration: 2000,
                        location: 'middle'
                    });
                });

                // var url = getBaseUrl() + "api/users?q="+ Key;
                // loading('show');
                // getAxois(url,"GET",{}).then(function (response) {
                //     loading('hide');
                //     //console.log(JSON.stringify(response.data));
                //     that.keySelectList = [];
                //     that.searchResult = response.data;
                //
                //     // 记录搜索记录
                //     var list = that.searchRecordsList;
                //     list.unshift(that.inputKeys);
                //     that.searchRecordsList = that._reduceSame(list);
                //     kv.setArray({
                //         key: 'searchFriendsRecords',
                //         value: that.searchRecordsList
                //     });
                //
                // }).catch(function (error) {
                //     console.log(JSON.stringify(error));
                // });
            },
            openTycoon: function(userId, storeName, avatarUrl) {
                openUserTycoonPlace(userId, storeName, avatarUrl);
            },
            close: function () {
                back();
            }
        }

    });

};
