
apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    $('[data-replace-text]').each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.chat[k]);
    });

    api.setWinAttr({
        slidBackEnabled:false,
        hScrollBarEnabled:false
    });

    api.setNavBarAttr({
        rightButtons: [{
            text: MSG.evaluation.submit,
            color:'#4578F3',
            fontSize:'15'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if(ret.type ==='right'){
            createGroup.createAGroup();
        }else{
            back();
        }
    });

    var createGroup = new Vue({
        el: '#createGroup',
        mounted: function () {
            if (api.pageParam.type !=="remove") {
                this.getFollowList();
            }

            // 创建群聊
            if (this.type === 'createFromOne') {

            }
        },

        /**
         * that.holdUsers.push(
         {
                "StoreNames":that.members[i].StoreNames,
                "Thumbnail":that.members[i].Thumbnail,
                "CustomerId":that.members[i].CustomerId,
                "UserId":that.members[i].UserId
            }
         )
         */
        data: {
            listData:'',
            name: api.pageParam.name || '',
            holdUsers:[
                {
                    "StoreNames": localStorage.getItem('storename'),
                    "Thumbnail": localStorage.getItem('thumbnail'),
                    "CustomerId": Number(localStorage.getItem('userId')),
                    "UserId": localStorage.getItem('chatID')
                }
            ],
            myID:localStorage.getItem('userId'),
            members:api.pageParam.members,
            removeUsers:[],
            type: api.pageParam.type,
            isDone:false,
            creatorId:api.pageParam.creatorId,
            myChatId : localStorage.getItem('chatID'),
            myName: localStorage.getItem('storename'),
            keySelectList: [],
            searchResult:[],
            inputKeys: '',
            message: MSG
        },
        watch:{
            holdUsers:function () {
                var color;

                if (this.type === 'add' && (this.holdUsers.length > this.members.length)) {
                    color = '#32cc54';
                    this.isDone = true;
                } else if ((this.type === 'create' || this.type === 'createFromOne')
                    &&  this.holdUsers.length > 2 && this.holdUsers.length < 100) {
                    color = '#32cc54';
                    this.isDone = true;
                } else {
                    color = '#6b6b6b';
                    this.isDone = false;
                }
                api.setNavBarAttr({
                    rightButtons: [{
                        text: MSG.general.done,
                        color: color,
                        fontSize: '14'
                    }]
                });
            },
            removeUsers:function () {
                var color;
                if(this.type === 'remove' && this.removeUsers.length !==0 && (this.members.length - this.removeUsers.length) > 2){
                    color = '#32cc54';
                    this.isDone = true;
                }else{
                    color = '#6b6b6b';
                    this.isDone = false;
                }
                api.setNavBarAttr({
                    rightButtons: [{
                        text: MSG.general.done,
                        color:color,
                        fontSize:'14'
                    }]
                });
            }
        },
        methods:{
            /**
             * 格式化搜索关键字
             * @param text
             * @returns {*}
             */
            formatSearchResult: function(text) {
                var reg = new RegExp(this.inputKeys, 'gi');
                return text.replace(reg, '<em class="text-blue">$&</em>');
            },

            getFollowList: function () {
                var that = this;
                var url = getBaseUrl() + "/api/users/"+ this.myID +"/followers" ;
                loading('show');

                getAxois(url,"GET",{}).then(function (response) {
                    loading('hide');

                    if (that.type === 'create') {
                        if ($.isArray(response.data) === true) {
                            that.listData = response.data.reverse();
                        }
                    } else if (that.type === 'add' || that.type === 'remove') {
                        that.holdUsers = [];
                        doSuccess();
                    } else if (that.type === 'createFromOne') {
                        doSuccess();
                    }

                    function doSuccess() {
                        var temp = response.data.reverse();
                        for(i=0;i< that.members.length;i++){
                            for(j=0;j<temp.length;j++){
                                if(that.members[i].CustomerId === temp[j].Id){
                                    temp.splice(j,1);
                                }
                            }
                            that.holdUsers.push(
                                {
                                    "StoreNames":that.members[i].StoreNames,
                                    "Thumbnail":that.members[i].Thumbnail,
                                    "CustomerId":that.members[i].CustomerId,
                                    "UserId":that.members[i].UserId
                                }
                            )
                        }
                        that.listData = temp;
                    }


                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error));
                });
            },
            getAutoList:function (q) {
                var that = this;
                var Q = q ||'';
                var url = getBaseUrl() +'/api/users/autocomplete?q='+Q+'&currentpage=0&itemsperpage=7';
                getAxois(url,"GET",{}).then(function (response) {
                    that.keySelectList = response.data;
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            inputKey:function (e) {
                this.inputKeys = e.target.value;
                this.searchResult = [];
                if(this.inputKeys !==''){
                    this.getAutoList(this.inputKeys);
                }else{
                    this.keySelectList = [];
                }
            },
            selectKey:function(key){
                this.inputKeys = key;
                this.searchUser(key);
            },
            submitKey:function () {
                $('input').blur();
                if(!this.inputKeys){
                    return false;
                }
                this.searchUser();
            },
            searchUser:function (key) {
                var that = this;
                var Key = key || this.inputKeys;
                var url = getBaseUrl() + "api/users?q="+ Key;
                that.keySelectList = [];
                loading('show');
                getAxois(url,"GET",{}).then(function (response) {
                    //console.log(JSON.stringify(response.data));
                    loading('hide');
                    that.searchResult = response.data;
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            createAGroup:function () {
                if(!this.isDone){
                    return false;
                }
                var that = this;
                var groupId = api.pageParam.groupId;

                // 创建群聊
                if (this.type === 'create' || this.type === 'createFromOne') {
                    var groupName;

                    closeChatPage();

                    var members = [];
                    $.map(this.holdUsers, function (item, index) {
                        members.push({
                            userName: item.StoreNames,
                            avatar: item.Thumbnail,
                            CustomerId: item.CustomerId,
                            userId: item.UserId
                        });
                    });

                    if (that.name) {
                        groupName = that.name;
                    } else {
                        var nameArr = [];
                        $.map(this.holdUsers, function (item, index) {
                            nameArr.push(item.StoreNames);
                        });
                        var symbol = lan === 'zh' ? '、' : ',';
                        nameArr = nameArr.slice(0, 5);
                        groupName = nameArr.join(symbol);
                    }

                    var groupData = {
                        "CreatorId": localStorage.getItem('chatID'),
                        "Members": members,
                        "Name": groupName
                    };
                    loading('show');
                    //console.log(JSON.stringify(groupData));
                    var url = getBaseUrl() + "/api/im/v1/imgroup";
                    getAxois(url,"POST",groupData).then(function (response) {
                        loading('hide');
                        //console.log(JSON.stringify(response));
                        if(response.data.Code === 0){
                            showTiV(false);

                            openChatPage({
                                pageTitle: MSG.chat.groupLabel + '(' + that.holdUsers.length + ')',
                                targetId: response.data.Data.GroupId,
                                userName: groupName,
                                userPortrait: 'https://tweebaafiles.oss-cn-beijing.aliyuncs.com/tweebaa/group-avatar.jpg',
                                conversationType: 'GROUP',
                                isTop: false,
                                notificationStatus: 'NOTIFY'
                            });

                            setTimeout(function () {
                                api.sendEvent({
                                    name: 'groupChatCreate',
                                    extra: {
                                        msg: groupName
                                    }
                                });
                                api.closeWin({
                                    name: 'chatProfile'
                                });
                                setTimeout(function () {
                                    api.closeWin({
                                        name: 'setGroup'
                                    });
                                }, 100);
                            }, 400);

                        }else if(response.data.Code === 45024){
                            loading('hide');
                            api.toast({
                                msg: MSG.chat.membersFull,
                                duration: 3000,
                                location: 'middle'
                            });
                            setTimeout(function () {
                                back();
                            }, 3000);
                        }

                    }).catch(function (error) {
                        console.log(JSON.stringify(error));
                    });
                    return;
                }

                // 添加成员
                if (that.type === 'add') {
                    var addMembers = [];
                    var userNames = [];
                    var tempMembers = that.holdUsers.slice(that.members.length);

                    for (var l = 0; l < tempMembers.length; l++) {
                        addMembers.push(tempMembers[l].UserId);
                        userNames.push(tempMembers[l].StoreNames);
                        // if (tempMembers[l].UserId.indexOf('tw') === 0) {
                        //
                        // }
                    }

                    var pram = {
                        "GroupId": groupId,
                        "UserIds": addMembers,
                    };
                    loading('show');

                    var Url = getBaseUrl() + "/api/im/v1/imgroupuser";
                    getAxois(Url,"POST",pram).then(function (response) {
                        //console.log(JSON.stringify(response.data));

                        if(response.data.Code === 0){
                            var msg = [
                                that.myName,
                                userNames.join(' ')
                            ].join(',');

                            api.sendEvent({
                                name: 'groupChatInvite',
                                extra: {
                                    msg: msg
                                }
                            });

                            api.sendEvent({
                                name: 'changeGroupMembers',
                                extra: {
                                    members: that.holdUsers
                                }
                            });

                            api.sendEvent({
                                name: 'updateChatTitle'
                            });

                            setTimeout(function () {
                                loading('hide');
                                back();
                            },500);
                        }else if(response.data.Code === 45024){
                            loading('hide');
                            api.toast({
                                msg: MSG.chat.membersFull,
                                duration: 3000,
                                location: 'middle'
                            });
                            // setTimeout(function () {
                            //     back();
                            // }, 3000);
                        }

                    }).catch(function (error) {
                        loading('hide');
                        api.toast({
                            msg: MSG.tips.systemError,
                            duration: 2000,
                            location: 'middle'
                        });
                        console.log(JSON.stringify(error));
                    });
                } else if (that.type === 'remove') {     // 移除成员
                    // console.log(JSON.stringify(that.removeUsers));
                    confirmBox(MSG.chat.wantRemoveMembers, MSG.general.cancel, MSG.general.ok,'error');
                    $('.dialog-box').find('button').on('click',function (e) {
                        var index = $(this).attr('id');
                        //console.log(index);
                        $('.dialog-box').remove();
                        if (index === 'btn-2') {
                            loading('show');

                            var members = that.members;
                            var userNames = [];
                            var removeMap = {};
                            $.map(that.removeUsers, function (chatId, index) {
                                var item;
                                for (var i = 0, len = members.length; i < len; i++) {
                                    item = members[i];
                                    if (item.UserId === chatId) {
                                        removeMap[item.UserId] = item;
                                        userNames.push(item.StoreNames);
                                        break;
                                    }
                                }
                            });

                            var msg = [
                                that.myName,
                                userNames.join(' ')
                            ].join(',');

                            api.sendEvent({
                                name: 'groupChatRemove',
                                extra: {
                                    msg: msg
                                }
                            });

                            setTimeout(function () {
                                var URL = getBaseUrl() + "/api/im/v1/imgroupuser";
                                var params = {
                                    "GroupId": groupId,
                                    "UserIds": that.removeUsers
                                };
                                getAxois(URL,"DELETE",params).then(function (response) {
                                    // console.log(JSON.stringify(response.data));

                                    var currentUsers = [];
                                    $.map(members, function (item, index) {
                                        if (!removeMap[item.UserId]) {
                                            currentUsers.push(item);
                                        }
                                    });
                                    api.sendEvent({
                                        name: 'changeGroupMembers',
                                        extra: {
                                            members: currentUsers
                                        }
                                    });

                                    setTimeout(function () {
                                        loading('hide');
                                        back();
                                    },500)

                                }).catch(function (error) {
                                    loading('hide');
                                    console.log(JSON.stringify(error));
                                });
                            });

                        }
                    });

                }

            }
        }

    });

};
