apiready = function () {

    var rong = api.require('rongCloud2');

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/' + lan + '.json'
    }));

    $('[data-replace-text]').each(function () {
        var k = $(this).data('replace-text');
        $(this).text(MSG.chat[k]);
    });

    api.setWinAttr({
        slidBackEnabled: false,
        hScrollBarEnabled: false
    });

    api.setNavBarAttr({
        rightButtons: [{
            text: MSG.evaluation.submit,
            color: '#4578F3',
            fontSize: '15'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function (ret, err) {
        if (ret.type === 'right') {
            if (setShare.isDone === true) {
                setShare.submit();
            }
        } else {
            back();
        }
    });

    var setShare = new Vue({
        el: '#setShare',
        mounted: function () {

        },
        created: function() {
            this.getFollowList();
            this.getConversationList();
        },
        data: {
            listData: '',
            holdUsers: [],
            myID: +localStorage.getItem('userId'),
            sendName: localStorage.getItem('storename'), //己方昵称
            sendPortrait: localStorage.getItem('thumbnail'),//己方头像
            myChatId: localStorage.getItem('chatID'),
            myName: localStorage.getItem('storename'),
            isDone: false,
            keySelectList: [],
            searchResult: [],
            inputKeys: '',
            conversationData: [],
            message: MSG
        },
        watch: {
            holdUsers: function () {
                var color;

                if (this.holdUsers.length > 0) {
                    color = '#4578F3';
                    this.isDone = true;
                } else {
                    this.isDone = false;
                    color = '#6b6b6b';
                }
                api.setNavBarAttr({
                    rightButtons: [{
                        text: MSG.general.done,
                        color: color,
                        fontSize: '14'
                    }]
                });
            },
        },
        methods: {
            showUserId: function(index, conversationType) {
                var that = this;
                var data = this.conversationData[index].latestMessage.extra;
                if (data) {
                    var extraObj = JSON.parse(data);
                    if (conversationType === 'GROUP') {
                        return '';
                    } else {
                        if (that.conversationData[index].senderUserId === this.myChatId) {
                            return extraObj.receiveUserId;
                        } else {
                            return extraObj.sendUserId;
                        }
                    }
                }
            },
            showAvatar: function(index, conversationType) {
                var that = this;
                var data = this.conversationData[index].latestMessage.extra;
                if(data){
                    var avatar = JSON.parse(data);
                    if (conversationType === 'GROUP') {
                        return avatar.receivePortrait;
                    }else{
                        return that.conversationData[index].senderUserId === this.myChatId ? avatar.receivePortrait : avatar.sendPortrait;
                    }
                }
            },
            showName: function (index, conversationType) {
                var that = this;
                var data = this.conversationData[index].latestMessage.extra;
                if (data) {
                    var extraObj = JSON.parse(data);
                    if (conversationType === 'GROUP') {
                        return  extraObj.receiveName;
                    } else {
                        if (that.conversationData[index].senderUserId === this.myChatId) {
                            return userRemarkService.get(extraObj.receiveUserId, extraObj.receiveName);
                        } else {
                            return userRemarkService.get(extraObj.sendUserId, extraObj.sendName);
                        }
                    }
                }
            },
            getConversationList:function () {
                var that = this;

                rong.getConversationList(function(ret, err) {
                    // console.log("会话列表:" + ret.status);
                    // console.log("[" + api.deviceName + "]" + "会话列表:" + ret.status);
                    // console.log("会话列表:" +JSON.stringify(ret));
                    loading('hide');
                    if(ret.status ==='success'){
                        var list = ret.result;
                        var len = list.length;

                        that.conversationLen = len;

                        // console.warn("[" + api.deviceName + "]" + JSON.stringify(ret.result));

                        var results = [];
                        var item;
                        for (var i = 0; i < len; i++) {
                            item = list[i];

                            item.selected = false;

                            if (item.sentStatus === 'SENDING') {
                                continue;
                            }

                            if (item.objectName === 'RC:RcNtf') {
                                item.extraObj = {};
                                $.extend(item.latestMessage, {
                                    type: '',
                                    receiveName: '',
                                    receivePortrait: '',
                                    sendName: '',
                                    sendPortrait: ''
                                });
                                (function (item) {
                                    rong.getLatestMessages({
                                        conversationType: item.conversationType,
                                        targetId: item.targetId,
                                        count: 10
                                    }, function(ret, err) {
                                        if (ret.status === 'success') {
                                            var firstItem = ret.result[0];
                                            var extra = firstItem.extra;
                                            if (extra) {
                                                $.extend(item.latestMessage, ret.result[0], JSON.parse(firstItem.extra));
                                            } else {
                                                // 遍历
                                                var innerItem;
                                                for (var j = 0, len = ret.result.length; j < len; j++) {
                                                    innerItem = ret.result[j];
                                                    if (innerItem.content && innerItem.content.extra) {
                                                        $.extend(item, innerItem);
                                                        item.latestMessage = innerItem.content;
                                                        item.extraObj = JSON.parse(item.latestMessage.extra);
                                                        break;
                                                    }
                                                }
                                            }
                                        }
                                        // api.alert({ msg: JSON.stringify(ret.result) });
                                    })
                                })(item);
                                results.push(item);
                            } else if (item.latestMessage.extra) {
                                try {
                                    item.extraObj = JSON.parse(item.latestMessage.extra);
                                    results.push(item);
                                } catch (e) {
                                    console.error(item.latestMessage.extra);
                                }
                            }

                        }
                        that.conversationData = results;

                        // setTimeout(function () {
                        //     that.notifyGlobalUnread();
                        // }, 1000);
                        // that.openChatPage(0);
                    }
                });

            },
            /**
             * 格式化搜索关键字
             * @param text
             * @returns {*}
             */
            formatSearchResult: function (text) {
                var reg = new RegExp(this.inputKeys, 'gi');
                return text.replace(reg, '<em class="text-blue">$&</em>');
            },

            getFollowList: function () {
                var that = this;
                var url = getBaseUrl() + "/api/users/" + this.myID + "/followers";
                loading('show');

                getAxois(url, "GET", {}).then(function (response) {
                    loading('hide');
                    that.listData = response.data.reverse();
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error));
                });
            },
            getAutoList: function (q) {
                var that = this;
                var Q = q || '';
                var url = getBaseUrl() + '/api/users/autocomplete?q=' + Q + '&currentpage=0&itemsperpage=7';
                getAxois(url, "GET", {}).then(function (response) {
                    that.keySelectList = response.data;
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            inputKey: function (e) {
                this.inputKeys = e.target.value;
                this.searchResult = [];
                if (this.inputKeys !== '') {
                    this.getAutoList(this.inputKeys);
                } else {
                    this.keySelectList = [];
                }
            },
            selectKey: function (key) {
                this.inputKeys = key;
                this.searchUser(key);
            },
            submitKey: function () {
                $('input').blur();
                if (!this.inputKeys) {
                    return false;
                }
                this.searchUser();
            },
            searchUser: function (key) {
                var that = this;
                var Key = key || this.inputKeys;
                var url = getBaseUrl() + "api/users?q=" + Key;
                that.keySelectList = [];
                loading('show');
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(response.data));
                    loading('hide');
                    that.searchResult = response.data;
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            doSuccess: function() {
                api.sendEvent({
                    name: 'conversationListReload',
                });
                setTimeout(function () {
                    back();
                }, 500);
            },
            submit: function () {
                var that = this;
                var type = api.pageParam.type;
                var pageExtra = api.pageParam.extra;
                var currentTagetId = api.pageParam.currentTagetId;

                switch(type) {
                    case 'text':
                        var msg = api.pageParam.msg;
                        $.map(this.holdUsers, function (item, index) {
                            api.sendEvent({
                                name: 'sendMessagesEvent',
                                extra: {
                                    type: 'text',
                                    targetId: item.targetId,
                                    conversationType: item.conversationType,
                                    msg: msg,
                                    sendUserId: that.myID,
                                    sendName: that.sendName,
                                    sendPortrait: that.sendPortrait,
                                    chatUserId: item.chatUserId,
                                    chatName: item.chatName,
                                    chatPortrait: item.chatPortrait,
                                    Source: api.systemType,
                                }
                            });
                            setTimeout(function () {
                                that.doSuccess();
                            }, 200);
                        });
                        break;
                    case 'img':
                        var renderPath = api.pageParam.renderPath;
                        $.map(this.holdUsers, function (item, index) {
                            api.sendEvent({
                                name: 'sendMessagesEvent',
                                extra: {
                                    type: 'img',
                                    targetId: item.targetId,
                                    conversationType: item.conversationType,
                                    msg: renderPath,
                                    sendUserId: that.myID,
                                    sendName: that.sendName,
                                    sendPortrait: that.sendPortrait,
                                    chatUserId: item.chatUserId,
                                    chatName: item.chatName,
                                    chatPortrait: item.chatPortrait,
                                    Source: api.systemType
                                }
                            });
                            setTimeout(function () {
                                that.doSuccess();
                            }, 200);
                        });
                        break;
                    case 'voice':
                        var path = api.pageParam.path;
                        var duration = api.pageParam.duration;
                        $.map(this.holdUsers, function (item, index) {
                            api.sendEvent({
                                name: 'sendMessagesEvent',
                                extra: {
                                    type: 'voice',
                                    targetId: item.targetId,
                                    conversationType: item.conversationType,
                                    msg: path,
                                    sendUserId: that.myID,
                                    sendName: that.sendName,
                                    sendPortrait: that.sendPortrait,
                                    chatUserId: item.chatUserId,
                                    chatName: item.chatName,
                                    chatPortrait: item.chatPortrait,
                                    Source: api.systemType,
                                    duration: duration
                                }
                            });
                            setTimeout(function () {
                                that.doSuccess();
                            }, 200);
                        });
                        break;
                    case 'file':
                        var name = api.pageParam.name;
                        var fileUrl = api.pageParam.fileUrl;
                        api.download({
                            url: fileUrl,
                            report: true,
                            cache: true,
                            savePath: api.fsDir + "/" + name,
                            allowResume: true
                        }, function (ret, err) {
                            console.log("[" + api.deviceName + "]" + '[download] ' + JSON.stringify(ret));
                            if (ret.state === 1) {
                                var Url = ret.savePath;
                                $.map(that.holdUsers, function (item, index) {
                                    var extra = $.extend({}, pageExtra, {
                                        sendUserId: that.myID,
                                        sendName: that.sendName,
                                        sendPortrait: that.sendPortrait,
                                        receiveName: item.chatName,
                                        receivePortrait: item.chatPortrait,
                                        chatUserId: item.chatUserId,
                                        chatName: item.chatName,
                                        chatPortrait: item.chatPortrait,
                                    });
                                    (function (item) {
                                        rong.sendFileMessage({
                                            conversationType: item.conversationType,
                                            targetId: item.targetId,
                                            filePath: Url,
                                            extra: JSON.stringify(extra)
                                        }, function (ret, err) {
                                            // console.log("照片发出:" +JSON.stringify(ret));
                                            if (ret.status === 'success') {
                                                if (localStorage.getItem('openChatPage') && item.targetId === currentTagetId) {
                                                    rong.getLatestMessages({
                                                        conversationType: item.conversationType,
                                                        targetId: item.targetId,
                                                        count: 1
                                                    }, function(ret, err) {
                                                        console.warn("[" + api.deviceName + "]【openChatPage】" + JSON.stringify(ret));
                                                        api.sendEvent({
                                                            name: 'showMessageInPage',
                                                            extra: {
                                                                message: JSON.stringify(ret.result[0])
                                                            }
                                                        });
                                                    });
                                                }
                                                that.doSuccess();
                                            } else if (ret.status === 'error') {
                                                if (err.code === -3) {
                                                    api.toast({
                                                        msg: '参数错误',
                                                        duration: 2000,
                                                        location: 'middle'
                                                    });
                                                }
                                                console.log('error: ' + err.code);
                                            }
                                        });
                                    })(item);
                                });
                            }
                        });
                        break;
                    case 'imgText':
                    default:
                        var title = api.pageParam.title;
                        var description = api.pageParam.description;
                        var imageUrl = api.pageParam.imageUrl;
                        $.map(this.holdUsers, function (item, index) {
                            var extra = $.extend({}, pageExtra, {
                                sendUserId: that.myID,
                                sendName: that.sendName,
                                sendPortrait: that.sendPortrait,
                                receiveName: item.chatName,
                                receivePortrait: item.chatPortrait,
                                chatUserId: item.chatUserId,
                                chatName: item.chatName,
                                chatPortrait: item.chatPortrait,
                            });
                            (function (item) {
                                rong.sendRichContentMessage({
                                    conversationType: item.conversationType,
                                    targetId: item.targetId,
                                    title: title,
                                    description: description,
                                    imageUrl: imageUrl,
                                    extra: JSON.stringify(extra)
                                }, function (ret, err) {
                                    // console.log("照片发出:" +JSON.stringify(ret));
                                    if (ret.status === 'success') {
                                        if (localStorage.getItem('openChatPage') && item.targetId === currentTagetId) {
                                            rong.getLatestMessages({
                                                conversationType: item.conversationType,
                                                targetId: item.targetId,
                                                count: 1
                                            }, function(ret, err) {
                                                console.warn("[" + api.deviceName + "]【openChatPage】" + JSON.stringify(ret));
                                                api.sendEvent({
                                                    name: 'showMessageInPage',
                                                    extra: {
                                                        message: JSON.stringify(ret.result[0])
                                                    }
                                                });
                                            });
                                        }
                                        that.doSuccess();
                                    }
                                });
                            })(item);
                        });
                }

            }
        }

    });

};
