
function fnOpen(conversationType) {

    var systemType = api.systemType;

    var isRecording = false;

    function popKeyboardHeight(panelHeight) {
        panelHeight = panelHeight || 0;
        api.sendEvent({
            name: 'setChatWrapperRect',
            extra: {
                panelHeight: panelHeight
            }
        });
    }
    function resetKeyboardHeight() {
        api.sendEvent({
            name: 'setChatWrapperRect',
            extra: {
                panelHeight: 0
            }
        });
    }

    api.addEventListener({
        name: 'closeChatBoxBoard'
    }, function(ret, err) {
        // console.log("[" + api.deviceName + "]" + '[closeChatBoxBoard] ' + JSON.stringify(ret));
        UIChatBox.closeBoard();
        UIChatBox.closeKeyboard();
        resetKeyboardHeight();
    });

   // console.log(api.pageParam.conversationType);
    var btn;
    if(api.pageParam.conversationType === 'PRIVATE'){
        btn = [
            // 相册
            {
                title: MSG.general.album, //'Album'
                normalImg: 'widget://image/chat/album.png',
                activeImg: 'widget://image/chat/album.png'
            },
            // 相机
            {
                title: MSG.general.camera, //'Camera'
                normalImg: 'widget://image/chat/camera.png',
                activeImg: 'widget://image/chat/camera.png',
            },
            // 语音通话
            {
                title: MSG.general.voiceCall, //'语音'
                normalImg: 'widget://image/chat/call.png',
                activeImg: 'widget://image/chat/call.png'
            },
            // 视频
            {
                title: MSG.general.videoCall,
                normalImg: 'widget://image/chat/video.png',
                activeImg: 'widget://image/chat/video.png'
            },
            // // 赠送T豆
            // {
            //     title: MSG.general.gift, //'tweebucks'
            //     normalImg: 'widget://image/chat/tweebucks.png',
            //     activeImg: 'widget://image/chat/tweebucks.png'
            // },
            // 发送文件
            {
                title: MSG.general.file, //文件
                normalImg: 'widget://image/chat/file.png',
                activeImg: 'widget://image/chat/file.png'
            }
        ];
        var appleCheck = api.getGlobalData({
            key: 'appleCheck'
        });
        if(!appleCheck){
            btn.splice( 4,0,          // 赠送T豆
                {
                    title: MSG.general.gift, //'tweebucks'
                    normalImg: 'widget://image/chat/tweebucks.png',
                    activeImg: 'widget://image/chat/tweebucks.png'
                })
        }
    }else{
        btn = [
            // 相册
            {
                title: MSG.general.album, //'Album'
                normalImg: 'widget://image/chat/album.png',
                activeImg: 'widget://image/chat/album.png'
            },
            // 相机
            {
                title: MSG.general.camera, //'Camera'
                normalImg: 'widget://image/chat/camera.png',
                activeImg: 'widget://image/chat/camera.png',
            },
            // 语音通话
            {
                title: MSG.general.voiceCall, //'语音'
                normalImg: 'widget://image/chat/call.png',
                activeImg: 'widget://image/chat/call.png'
            },
            {
                title: MSG.general.file, //文件
                normalImg: 'widget://image/chat/file.png',
                activeImg: 'widget://image/chat/file.png'
            }
        ];
    }
    UIChatBox.open({
        placeholder: '',
        autoFocus: false,
        maxRows:2,
        emotionPath: 'widget://image/emotion',
        texts: {
            recordBtn: {
                normalTitle: MSG.chat.holdtoTalk, //'Hold to talk'
                activeTitle: MSG.chat.releasetoSend  //'Release to send'
            },
            sendBtn: {
                title: MSG.chat.send //send
            }
        },
        recordType: 'pressRecord',
        styles: {
            topDivider: {
                width: 1,
                color: '#fff'
            },
            inputBar: {
                borderColor: '#fff',
                bgColor: '#fff',
                placeholderColor: '',
                textSize: 16,
                textColor: '#000',
                textMarginLeft: 8
            },
            inputBox: {
                borderColor: '#F2F2F2',
                bgColor: '#F2F2F2',
                boardBgColor: '#fff',
                borderCorner: 16,
                topMargin: systemType === 'ios' ? 8 : 6
            },
            extrasBtn: {
                normalImg: 'widget://image/add1.png'
            },
            speechBtn: {
                normalImg: 'widget://image/voice1.png',
                activeImg:'widget://image/key1.png'
            },
            emotionBtn: {
                normalImg: 'widget://image/face1.png'
            },
            indicator: {
                target: 'extrasPanel',
                color: '#c4c4c4',
                activeColor: '#9e9e9e'
            },
            sendBtn: {
                titleColor: '#FFF',
                bg: '#4578F3',
                activeBg: '#346EF0',
                titleSize: 13
            },
            recordBtn:{
                normalBg: '#fff',
                activeBg: '#CCC',
            },
            recordPanelBtn:{                     //JSON对象；录音面板样式
                normalImg: 'widget://image/recordingicon.png',        //（可选项）字符串类型；按钮常态的图片
                activeImg: 'widget://image/recordingicon2.png',        //（可选项）字符串类型；按钮按下时的图片
                width:150,           //（可选项）数字类型；按钮的宽度，默认：100
                height:150           //（可选项）数字类型；按钮的高度，默认：100
            },
        },
        extras: {
            titleSize: 12,
            titleColor: '#a3a3a3',
            btns: btn
        }
    }, function (ret, err) {
        if (ret) {
            // console.log("[" + api.deviceName + "]" + JSON.stringify(ret));
            var eventType = ret.eventType;

            if (eventType === 'show') {
                api.sendEvent({
                    name: 'initChatWrapper',
                    extra: {
                        inputBarHeight: ret.inputBarHeight
                    }
                });
            }

            // 监听录音
            initRecord();

            if (eventType === 'clickExtras') {
                if (conversationType === 'PRIVATE') {
                    switch(ret.index){
                        case 0:
                            startPicture();
                            break;
                        case 1:
                            startPhoto();
                            break;
                        case 2:
                            if (isRecording === true) {
                                return;
                            }
                            startVCall();
                            break;
                        case 3:
                            if (isRecording === true) {
                                return;
                            }
                            startVideoCall();
                            break;
                        case 4:
                            startTweeBuck();
                            break;
                        case 5:
                            startFile();
                    }
                } else {
                    switch(ret.index){
                        case 0:
                            startPicture();
                            break;
                        case 1:
                            startPhoto();
                            break;
                        case 2:
                            if (isRecording === true) {
                                return;
                            }
                            startVCall();
                            break;
                        case 3:
                            startFile();
                            break;
                    }
                }
            }
            if (ret.eventType === 'send') {
                var msg = $.trim(ret.msg);
                if (msg === '') {
                    alert(MSG.chat.emptyMsg);
                    UIChatBox.closeKeyboard();
                    return;
                }

                chatPage.sendMessages(msg);
            }
        } else {
           // alert(JSON.stringify(err));
        }

        // 相册
        function startPicture() {
            // console.log("[" + api.deviceName + "] checkPermission('photos'): " + checkPermission('photos'));
            if(!checkPermission('photos')){
                if (systemType === 'android') {
                    requestPermission("photos");
                }else{
                    api.requestPermission({
                        list: ["photos"],
                        code: 1
                    }, function (ret, err) {
                        if (ret.list[0].granted) {
                            api.execScript({
                                frameName: 'chat',
                                script: "chatPage.getPicture('library')"
                            });
                        }
                    });
                }
            } else {
                api.execScript({
                    frameName: 'chat',
                    script: "chatPage.getPicture('library')"
                });
            }
        }

        // 相机
        function startPhoto() {
            if (!checkPermission('camera')) {
                if (systemType === 'android') {
                    requestPermission("camera");
                }else{
                    api.requestPermission({
                        list: ["camera"],
                        code: 1
                    }, function (ret, err) {
                        api.execScript({
                            frameName: 'chat',
                            script: "chatPage.getPicture('camera')"
                        });
                    });
                }
            } else {
                api.execScript({
                    frameName: 'chat',
                    script: "chatPage.getPicture('camera')"
                });
            }
        }

        // 发送文件
        function startFile() {
            api.execScript({
                frameName: 'chat',
                script: "chatPage.sendFileMessage()"
            });
        }

        // 语音通话
        function startVCall() {
            // 使用麦克风的权限，在vcall.html里进行  来不及，打开页面后在申请权限会导致接通失败没有声音
            if (!checkPermission('microphone')) {
                if (systemType === 'android') {
                    requestPermission("microphone");
                }else{
                    api.requestPermission({
                        list: ["microphone"],
                        code: 1
                    }, function (ret, err) {
                        if (ret.list[0].granted) {
                            api.execScript({
                                frameName: 'chat',
                                script: "chatPage.vCall('audio')"
                            });
                        }
                    });
                }
            } else {
                api.execScript({
                    frameName: 'chat',
                    script: "chatPage.vCall('audio')"
                });
            }
        }

        // 视频通话
        function startVideoCall() {
            // 相机&麦克
            if (!checkPermission('camera') && !checkPermission('microphone')) {
                requestPermission("camera");
                requestPermission("microphone");
                return;
            } else if (!checkPermission('camera') && checkPermission('microphone')) {
                requestPermission("camera");
                return;
            } else if (checkPermission('camera') && !checkPermission('microphone')) {
                requestPermission("microphone");
                return;
            }
            chatPage.videoCall();
        }

        // 赠送T豆
        function startTweeBuck() {
            api.execScript({
                frameName: 'chat',
                script: "chatPage.giveTweebucks()"
            });
        }

    });

    UIChatBox.addEventListener({
        target: "inputBar",
        name: "change"
    }, function(ret, err){
        // console.log("[" + api.deviceName + "]" + JSON.stringify(ret));
        // inputBarHeight = ret.inputBarHeight;
        // api.sendEvent({
        //     name: 'initChatWrapper',
        //     extra: {
        //         inputBarHeight: inputBarHeight
        //     }
        // });
    });

    UIChatBox.addEventListener({
        target: "inputBar",
        name: "move"
    }, function(ret, err){
        // console.log("[" + api.deviceName + "]" + JSON.stringify(ret));
        if (ret.panelHeight !== 0) {
            popKeyboardHeight(ret.panelHeight);
        } else {
            resetKeyboardHeight()
        }
    });

    UIChatBox.addEventListener({
        target: "inputBar",
        name: "showRecord"
    }, function(ret, err){
        // console.log("[" + api.deviceName + "]" + JSON.stringify(ret));

    });

    if (api.pageParam.conversationType === 'GROUP') {
        UIChatBox.addEventListener({
            target: "inputBar",
            name: "valueChanged"
        }, function(ret, err){
            // console.log(JSON.stringify(ret));
            var value = ret.value;
            chatPage.setInputValue(value);
        });
    }

    function initRecord() {
        var time = 61;
        var vt;
        var sj1;

        function setTime() {

            vt = setTimeout(function () {
                time--;
                if(time > 0){
                    setTime();
                    // console.log(time);
                    setMicTime(time);
                }else{
                    clearTimeout(vt);
                    setMicTime('');
                    hideMic();

                    time = 61;
                    api.stopRecord(function (ret, err) {
                        if(ret){
                            api.execScript({
                                frameName: 'chat',
                                script: "chatPage.sendVoice('" + JSON.stringify(ret) + "')"
                            });
                            // chatPage.sendVoice(ret);
                        }
                    });
                }

            },1000);
        }

        function showMic() {
            api.execScript({
                frameName: 'chat',
                script: "chatPage.showMic()"
            });
        }

        function hideMic() {
            api.execScript({
                frameName: 'chat',
                script: "chatPage.hideMic()"
            });
        }

        function setMicTime(value) {
            api.execScript({
                frameName: 'chat',
                script: "chatPage.setMicTime(" + value + ")"
            });
        }


        // 监听语音输入
        // 按下录音按钮
        UIChatBox.addEventListener({
            target: 'recordBtn',
            name: 'press'
        }, function (ret, err) {

            if (!checkPermission('microphone')) {
                if (systemType === 'android') {
                    requestPermission("microphone");
                }else{
                    api.requestPermission({
                        list: ["microphone"],
                        code: 1
                    }, function (ret, err) {
                        if (ret.list[0].granted) {
                            start();
                        }
                    });
                }
            } else {
                start();
            }

            function start() {
                isRecording = true;
                clearTimeout(vt);
                time = 61;
                setTime();
                sj1 = new Date().getTime();
                showMic();
                if (ret) {
                    //console.log("录音");
                    var savePath = 'fs://lysd_' + (+new Date()) + '.amr';
                    api.startRecord({
                        path: savePath
                    });
                }
            }
        });

        // 按下录音按钮后，从按钮移出并松开按钮
        UIChatBox.addEventListener({
            target: 'recordBtn',
            name: 'move_out_cancel'
        }, function (ret, err) {
            isRecording = false;
            stopRecord();
            api.toast({
                msg: MSG.chat.sendCanceled,
                duration: 2000,
                location: 'middle'
            });
            hideMic();
        });

        // 松开录音按钮
        UIChatBox.addEventListener({
            target: 'recordBtn',
            name: 'press_cancel'
        }, function (ret, err) {
            isRecording = false;
            hideMic();
            var sj2 = new Date().getTime() - sj1;
            if (sj2 <= 1000) {
                stopRecord();
                api.toast({
                    msg:  MSG.chat.recodShort,//'语音时间较短，请重新录音'
                    duration: 3000,
                    location: 'middle'
                });
            } else if (sj2 > 1000) {
                //console.log(time);
                if(time < 61){

                    api.stopRecord(function (ret, err) {
                        if(ret){
                            api.execScript({
                                frameName: 'chat',
                                script: "chatPage.sendVoice('" + JSON.stringify(ret) + "')"
                            });
                        }
                    });
                }
                clearTimeout(vt);
                setMicTime('');
                time = 61;
            }
        });

        //终止录音
        function stopRecord() {
            clearTimeout(vt);
            setMicTime('');
            time = 61;
            api.stopRecord(function (ret, err) {

            });
        }

    }

}


