
apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    api.setNavBarAttr({
        rightButtons: [{
            text:MSG.general.next,
            color:"#93b1fb",
            fontSize:14
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if(ret.type ==='right'){
            if(addFreeProd.currentStep === 1){
                if(addFreeProd.picked !==''){
                    addFreeProd.currentStep = 2;
                    addFreeProd.pickedProduct = addFreeProd.productsData[addFreeProd.picked];
                    api.setNavBarAttr({
                        rightButtons: [{
                            text:MSG.general.submit,
                            color:"#4578F3",
                            fontSize:14
                        }]
                    });
                }
            }else{
                addFreeProd.submitFunction();
            }
        }else{
            back();
        }
    });


    api.addEventListener({
        name: 'selectedProd'
    }, function (ret, err) {
        console.log(JSON.stringify(ret.value));
        if(ret.value.type ==='share'){
            addFreeProd.shareProd = ret.value.prod;
        }else if(ret.value.type ==='time'){
            addFreeProd.timeProd = ret.value.prod;
        }
    });


    var today = moment().format('YYYY-MM-DDTHH:mm');
    var day1 = moment().add(1, 'days').format('YYYY-MM-DDTHH:mm');
    var addFreeProd = new Vue({
        el: '#addFreeProd',
        mounted: function() {
            this.getProducts();
        },
        data: {
            currentStep:1,
            myID: localStorage.getItem('userId'),
            productsData:'',
            picked:'',
            pickedProduct:'',
            SelectedFreePeriod:'',
            SelectedFreeQuantity:'',
            freeConditions:'',
            SelectedConditions:[],
            freeSaleDays:'',
            freeSaleQuantityLimit: 1,
            displayHours:'0000',
            inputDay:'00',
            inputHours:'00',
            conditions:'',
            shareProd:'',
            shareProdCount:1,
            timeProd:'',
            message:MSG
        },
        watch:{
            picked:function () {
                if(this.picked !== ''){
                    api.setNavBarAttr({
                        rightButtons: [{
                            text:MSG.general.next,
                            color:"#4578F3",
                            fontSize:14
                        }]
                    });
                }
            },
            freeSaleQuantityLimit:function () {
                if(!this.freeSaleQuantityLimit  || this.freeSaleQuantityLimit < 1 ){
                    this.freeSaleQuantityLimit = 0;
                }else{
                    this.freeSaleQuantityLimit = parseInt(this.freeSaleQuantityLimit);
                }
            },
            shareProdCount:function () {
                if(!this.shareProdCount  || this.shareProdCount < 1 ){
                    this.shareProdCount = 0;
                }else{
                    this.shareProdCount = parseInt(this.shareProdCount);
                }
            },
            freeConditions:function () {
                if(this.freeConditions  === 'all'){
                    this.SelectedConditions = ['follow','commentPost','buy','add','share','time'];
                }
            },
            inputDay:function () {

                if(parseInt(this.inputDay) > 416){
                    this.inputDay = 416;
                }else{
                    this.inputDay = this.inputDay ? parseInt(this.inputDay) : 0;
                }
                this.showHours();
            },
            inputHours:function () {

                if( parseInt(this.inputDay) < 416 && parseInt(this.inputHours) > 24){
                    this.inputHours = 24;
                }else if( parseInt(this.inputDay) === 416 && parseInt(this.inputHours) > 15){
                    this.inputHours = 15;
                }else{
                    this.inputHours = this.inputHours ? parseInt(this.inputHours) : 0;
                }

                this.showHours();
            },
            SelectedConditions:function () {
                if(this.SelectedConditions.length < 6){
                    this.freeConditions  = 'select'
                }

                var Conditions;
                if(this.SelectedConditions.indexOf('follow') !== -1){
                    Conditions = "1";
                }else{
                    Conditions = "0";
                }

                if(this.SelectedConditions.indexOf('commentPost') !== -1){
                    Conditions = Conditions + "1";
                }else{
                    Conditions = Conditions + "0";
                }

                if(this.SelectedConditions.indexOf('buy') !== -1){
                    Conditions = Conditions + "1";
                }else{
                    Conditions = Conditions + "0";
                }

                if(this.SelectedConditions.indexOf('add') !== -1){
                    Conditions = Conditions + "1";
                }else{
                    Conditions = Conditions + "0";
                }

                if(this.SelectedConditions.indexOf('share') !== -1){
                    Conditions = Conditions + "1";
                }else{
                    Conditions = Conditions + "0";
                }

                if(this.SelectedConditions.indexOf('time') !== -1){
                    Conditions = Conditions + "1";
                }else{
                    Conditions = Conditions + "0";
                }
                this.conditions = Conditions;
                //console.log(this.conditions);
            }
        },
        methods:{
            showHours:function (){
                var displayHours = parseInt(this.inputDay) * 24 + parseInt(this.inputHours);

                this.displayHours = padStart(4,displayHours);

                this.freeSaleDays = displayHours;

                function padStart(n,str){
                    str = String(str);
                    return Array(str.length >= n ? 0 : n - str.length + 1).join('0') + str;
                }


            },
            openProductFrame:function (type){
                api.openFrame({
                    name: 'selectProd',
                    url: 'select-myproducts.html',
                    bgColor:'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation:{
                        type:"movein",
                        subType:"from_bottom",
                        duration:300
                    },
                    pageParam: {
                        type: type
                    }
                });
            },
            openWarn: function(key, $event) {
                // alert(MSG.suggestion[key]);
                $event && $event.stopPropagation();
                dialog({
                    title: MSG.tips.title,
                    content: MSG.freeProduct[key],
                    primaryText: MSG.tips.gotit,
                    asideText: '',
                    onClose: "show",
                    textAlign: 'left',
                    onWarning: function() {
                    },
                    onPrimary: function () {

                    }
                });
            },
            getProducts:function(){
                var that = this;
                var url = getBaseUrl() + "/api/v3/users/products?LanguageCode="+lan;
                var paramStr = {
                    "ownerId": this.myID,
                    "currentpage": 0,
                    "itemsperpage": 999,
                    "LanguageCode":lan,
                    "self":true,
                    "businessType" : 0,
                    "productType" : 2
                };
                loading('show');
                getAxois(url, "POST", paramStr).then(function (response) {
                    //console.log(JSON.stringify(response.data.Data));
                    loading('hide');
                    that.productsData = response.data.Data;
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },

            submitFunction:function () {
                var that = this;

                if(!this.SelectedFreePeriod){
                    api.toast({
                        msg: MSG.freeProduct.freePeriodEmpty,
                        duration: 2000,
                        location: 'middle'
                    });
                    return;
                }

                if(!this.SelectedFreeQuantity){
                    api.toast({
                        msg: MSG.freeProduct.freePeriodEmpty,
                        duration: 2000,
                        location: 'middle'
                    });
                    return;
                }

                if(this.SelectedFreePeriod ==='limitedDays' && !this.freeSaleDays){
                    api.toast({
                        msg: MSG.freeProduct.freeSaleDaysEmpty,
                        duration: 2000,
                        location: 'middle'
                    });
                    return;
                }

                if(this.SelectedFreeQuantity ==='maxQuantity' && !this.freeSaleQuantityLimit){
                    api.toast({
                        msg: MSG.freeProduct.freeSaleQuantityEmpty,
                        duration: 2000,
                        location: 'middle'
                    });
                    return;
                }

                if(this.SelectedConditions.length === 0){
                    api.toast({
                        msg: MSG.freeProduct.selectOneConditions,
                        duration: 2000,
                        location: 'middle'
                    });
                    return;
                }
                var viewCount,viewCountProd,viewTimeProd;

                if(this.SelectedConditions.includes('share')){
                    if(this.shareProdCount < 1){
                        api.toast({
                            msg: MSG.freeProduct.shareProdCountEmpty,
                            duration: 2000,
                            location: 'middle'
                        });
                        return;
                    }else{
                        viewCount = parseInt(this.shareProdCount);
                    }

                    if(!this.shareProd){
                        api.toast({
                            msg: MSG.freeProduct.shareProdEmpty,
                            duration: 2000,
                            location: 'middle'
                        });
                        return;
                    }else{
                        viewCountProd = this.shareProd.Id;
                    }
                }

                if(this.SelectedConditions.includes('time')){

                    if(!this.timeProd){
                        api.toast({
                            msg: MSG.freeProduct.timeProdEmpty,
                            duration: 2000,
                            location: 'middle'
                        });
                        return;
                    }else{
                        viewTimeProd = this.timeProd.Id;
                    }
                }

                var params = {
                    "freeSaleCondition": this.conditions,
                    "freeSaleDays": this.SelectedFreePeriod === 'limitedDays'? this.freeSaleDays : -1,
                    "freeSaleQuantityLimit":  this.SelectedFreeQuantity === 'maxQuantity'?  this.freeSaleQuantityLimit : -1,
                    "prodId": this.pickedProduct.Id,
                    "viewCountLimit": viewCount,
                    "viewCountProdId": viewCountProd,
                    "viewTimeProdId": viewTimeProd,
                    "viewTimeSecondLimit": viewTimeProd ? 30 :''
                };
                console.log(JSON.stringify(params));
                 // console.log(JSON.stringify(this.pickedProduct));
                //return;
                loading('show');
                apiFree.post("/v1/product/free", params).done(function (rep) {
                    console.log(JSON.stringify(rep));
                    that.isRequesting = false;
                    loading('hide');
                    if (rep.code === 0) {
                        api.toast({
                            msg: MSG.tips.success,
                            duration: 2000,
                            location: 'middle'
                        });
                        api.sendEvent({
                            name: 'productListReload',
                        });
                        setTimeout(function () {
                            back();
                        },2000);
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            },

        }

    });
};
