/**
 * @file 选择法币折算T豆
 * @author jinguangguo
 * @date 27/08/2020 2:05 PM
 */

function CurrencySelector(input, callback) {
    this.$input = $(input);

    this.currentCurrency = 'Tweebucks';  // USD, CNY
    this.callback = callback;

    var $selector = $(
        '<div class="currency-selector small text-light-gray">\n' +
        '    <span class="text unit">' + MSG.tweebucks.tweebuck + '</span> <i class="xx-small pl-1">▼</i>\n' +
        '</div>'
    );

    this.$selector = $selector;

    var $tip = $(
        '<div class="selector-tip x-small">\n' +
        '    ≈\n' +
        '    <span class="text">--</span>\n' +
        '    <span class="unit pl-2 pr-2">' + (lan === 'zh' ? MSG.tweebucks.currencyCNY : MSG.tweebucks.currencyUSD) + '</span>\n' +
        '</div>'
    );

    this.$tip = $tip;

    this.$input.after($selector);
    this.$input.after($tip);

    this.bind();

    var value = $.trim(this.$input.val());
    if (value !== '') {
        this.setValue(value);
    }

}

CurrencySelector.prototype.bind = function () {
    var that = this;

    this.$input.on('input',function () {
        var value = $.trim($(this).val());
        that.setValue(value);
    });

    this.$selector.on('click', function () {
        var value = that.$input.val();

        actionSheet([
            {
                text: MSG.tweebucks.tweebuck,
                callback: function () {
                    that.currentCurrency = 'Tweebucks';

                    that.$selector.find('.unit').text(MSG.tweebucks.tweebuck);

                    if (lan === 'zh') {
                        that.$tip.find('.unit').text(MSG.tweebucks.currencyCNY);
                    } else {
                        that.$tip.find('.unit').text(MSG.tweebucks.currencyUSD);
                    }

                    that.setValue(value);
                }
            },
            {
                text: MSG.tweebucks.currencyCNY,
                callback: function () {
                    that.currentCurrency = 'CNY';

                    that.$selector.find('.unit').text(MSG.tweebucks.currencyCNY);
                    that.$tip.find('.unit').text(MSG.tweebucks.tweebuck);

                    that.setValue(value);
                }
            },
            {
                text: MSG.tweebucks.currencyUSD,
                callback: function () {
                    that.currentCurrency = 'USD';

                    that.$selector.find('.unit').text(MSG.tweebucks.currencyUSD);
                    that.$tip.find('.unit').text(MSG.tweebucks.tweebuck);

                    that.setValue(value);
                }
            }
        ]);

    });
};

CurrencySelector.prototype.setValue = function(value) {
    var $text = this.$tip.find('.text');
    var tweebuckValue;
    if (value !== '') {
        value = parseFloat(value);

        if(this.currentCurrency === 'USD'){
            tweebuckValue = value * 10;
            $text.text(tweebuckValue.toFixed(2));
        }else if(this.currentCurrency === 'CNY'){
            tweebuckValue = value / getExchangeCNY();
            $text.text(tweebuckValue.toFixed(2));
        }else if(this.currentCurrency === 'Tweebucks'){
            tweebuckValue = value;
            // 根据当前语言呈现对应法币
            if (lan === 'zh') {
                $text.text((value * getExchangeCNY()).toFixed(2));
            } else if (lan === 'en') {
                $text.text((value / 10).toFixed(2));
            }
        }

        this.callback(tweebuckValue);
    } else {
        $text.text('-');
        this.callback('');
    }
};
