
apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    setTimeout(function () {
        autosize(document.querySelectorAll('textarea'));
    });

    api.setWinAttr({
        bounces: false,
    });

    var postBtn = MSG.general.save;
    api.setNavBarAttr({
        rightButtons: [{
            text: postBtn,
            color:'#4578F3',
            fontSize:'15'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if (ret.type === 'right') {
            if (enabletoTweebaa.isRequesting === false) {
                enabletoTweebaa.submit();
            }
        } else {
            back();
        }
    });

    api.addEventListener({
        name:'calculate2Result'
    }, function(ret, err){
        //console.log(JSON.stringify(ret.value));
        enabletoTweebaa.retailPrice= ret.value.price;
        enabletoTweebaa.profit= ret.value.profit;
    });

    var enabletoTweebaa = new Vue({
        el: '#enabletoTweebaa',
        computed: {
            eqPriceValue: function () {
                if (this.retailPrice && $.isNumeric(this.retailPrice) === true) {
                    return getExchangeText(this.retailPrice);
                } else {
                    return '~';
                }
            }
        },
        mounted: function () {
            this.getReason();
        },
        created: function() {

        },
        data: {
            isRequesting: false,
            product: {
                productGuid: api.pageParam.productGuid,
                price: api.pageParam.price,
                productType: api.pageParam.productType,
                productName: api.pageParam.productName,
                productThumbnailUrl: api.pageParam.productThumbnailUrl
            },
            retailPrice: api.pageParam.price,
            profit:0,
            InviteCode:'',
            comment:'',
            commission:0,
            manufacturers:false,
            reason:'',
            otherWebsite:"",
            message:MSG
        },
        filters: {
            fixed2:function (value) {
                return Number(value).toFixed(2);
            },
        },
        methods:{
            openCalculator:function () {
                openTabLayout('calculator2','','calculator2.html',{
                    price:parseFloat(this.retailPrice),
                    profit:this.profit,
                    productType:api.pageParam.productType
                })
            },
            getReason:function(){
                var that = this;
                var url = getBaseUrl() + "api/v2/product/advisory-reasons?ProductGuid=" + this.product.productGuid;
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(response.data.Data));
                    if(response.data){
                        that.InviteCode = response.data.Data.InviteCode;
                        that.profit = response.data.Data.TargetTweebuckProfit;
                        that.comment = response.data.Data.Comment;
                        that.retailPrice = response.data.Data.TweebuckPrice;
                        that.commission = response.data.Data.CommissionForInviter;
                        that.manufacturers = response.data.Data.IsManufacturers;
                        that.otherWebsite = response.data.Data.DescInOtherWebsite;
                        if(lan==="en"){
                            that.reason = response.data.Data.En.AdvisoryReason;
                        }else {
                            that.reason = response.data.Data.Cn.AdvisoryReason;
                        }
                    }

                }).catch(function (error) {
                    // console.log(JSON.stringify(error) + '#######################');
                    loading('hide');
                });
            },
            submit: function () {
                api.closeWin({
                    name: 'selectMyProduct'
                });
                if(!this.profit || parseFloat(this.profit) <= 0){

                    api.toast({
                        msg: MSG.tips.incomeGreaterZero,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }
                var url = getBaseUrl() + "/api/v2/product/to/tweebaa";
                var paramStr = {
                    "ActorId":localStorage.getItem('userId'),
                    "ActorGuid": localStorage.getItem('userGuid'),
                    "ProductGuid": this.product.productGuid,
                    "TweebuckPrice" : parseFloat(this.retailPrice),
                    "TargetTweebuckProfit": parseFloat(this.profit),
                    "Comment": this.comment,
                    "IsManufacturers" : this.manufacturers,
                    "DescInOtherWebsite" :this.otherWebsite,
                    "InviteCode" : this.InviteCode.toLowerCase(),
                    "CommissionForInviter" :  Number(this.commission),
                    "En":{
                        "AdvisoryReason" : lan==="en"?this.reason:'',
                    },
                    "Cn":{
                        "AdvisoryReason" : lan==="zh"?this.reason:'',
                    }

                };
                //console.log(url);
                //console.log(JSON.stringify(paramStr));
                loading('show');
                getAxois(url, "POST", paramStr).then(function (response) {
                    //console.log(JSON.stringify(response.data));
                    loading('hide');
                    if(response.data.Success){
                        api.sendEvent({
                            name: 'productListReload',
                        });
                        api.sendEvent({
                            name: 'workplaceReload',
                            extra: {
                                type: 'product'
                            }
                        });
                        alert(MSG.tips.enabletoTweebaaSuccess, function () {
                            back();
                        });
                    }
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '#######################');
                    loading('hide');
                });
            },
            showTip: function (key) {

            }
        }
    });
};

