var page = 1;
apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/' + lan + '.json'
    }));

    api.setNavBarAttr({
        rightButtons: [{
            iconPath: 'widget://image/add-icon.jpg'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function (ret, err) {
        if (ret.type === 'right') {
            myPresaleProductsList.addPresale();
        } else {
            back();
        }
    });


    //上拉加载
    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 300
        }
    }, function (ret, err) {
        if (!myPresaleProductsList.hasLoadedAll && !myPresaleProductsList.bottomLoading && !myPresaleProductsList.isLoading) {
            if (myPresaleProductsList.currentType === 0 || myPresaleProductsList.currentType === 2) {
                page++;
                myPresaleProductsList.getPresaleApplyList();
            } else {
                myPresaleProductsList.prodFilter.page++;
                myPresaleProductsList.getPresaleProducts();
            }
        }
    });

    api.setRefreshHeaderInfo({
        loadingImg: 'widget://image/refresh-logo.png',
        bgColor: '#fff',
        textColor: '#000',
        textDown: MSG.tips.pullDownRefresh,
        textLoading: MSG.tips.refreshing,
        showTime: false,
        textUp: MSG.tips.releaseRefresh
    }, function (ret, err) {
        api.refreshHeaderLoadDone();
        myPresaleProductsList.refresh();
    });

    api.addEventListener({
        name: 'myPresaleProductsList'
    }, function (ret, err) {
        myPresaleProductsList.refresh();
    });

    var taskService = new TaskService(TASK_CODE.GROUP_ADD_SHOWCASE);

    api.addEventListener({
        name: 'taskReload'
    }, function (ret, err) {
        taskService.refresh();
    });

    var kv = api.require('snKVStorage');
    var USERINFO;
    var hasUserInfo = kv.has({
        key: 'userInfo'
    });
    if (hasUserInfo) {
        USERINFO = kv.getObject({
            key: 'userInfo'
        });
    }

    var myPresaleProductsList = new Vue({
        el: '#myPresaleProductsList',
        mounted: function () {
            this.getPresaleApplyList(page);// 预售申请列表
            this.getUserDetails();
        },
        data: {
            myID: localStorage.getItem('userId'),
            userInfo: USERINFO,
            presaleList: [],

            bottomLoading: false,
            isLoading: false,
            hasLoadedAll: false,

            currentPresale: null,
            productsData: [],
            currentType: 0,
            prodFilter: {
                page: 0,
                displayFilter: '',
                categoryId: '',
                orderBy: '',   // 可选项。 其值只有两个固定选项“NAME” 和 “TWEEBUCK_PRICE” 或者为空
                desc: true,//可选项。 默认值是true降序。
                q: ''//可选项。 对产品名称的模糊查询
            },
            message: MSG
        },
        filters: {
            StatusCode: function (value) {
                var result;
                switch (value) {
                    case -1:
                        result = MSG.products.REJECTED;
                        break;
                    case 0:
                        result = MSG.products.SUBMITTED;
                        break;
                    case 1:
                        result = MSG.products.VOTING;
                        break;
                    case 2:
                        result = MSG.products.APPROVED;
                        break;
                }
                return result;
            }
        },
        methods: {
            getUserDetails: function () {
                var that = this;
                var userId = localStorage.getItem('userId');
                var url = getBaseUrl() + "/api/users/" + userId + "?viewerId=" + this.myID;
                loading('show');
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(response.data));
                    var data = response.data;
                    that.userInfo = data;
                    kv.setObject({
                        key: 'userInfo',
                        value: data
                    });
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            getCompletedRate: function (presale) {
                var value = presale.PreSaleInfo.PreSaleEndQuantity / presale.PreSaleInfo.PreSaleTargetQuantity * 100;
                return value.toFixed(2) + '%';
            },
            changeType: function (type) {
                this.currentType = type;
                this.refresh();
            },
            getStatusKey: function (value) {
                var result;
                switch (value) {
                    // 待审核
                    case 0:
                        result = 'Pending';
                        break;
                    // 审核通过
                    case 1:
                        result = 'Approved';
                        break;
                    // 审核拒绝
                    case 2:
                        result = 'Rejected';
                        break;
                    case 99:
                        result = 'None'
                }
                return result;
            },
            getLangKey: function () {
                return lan === 'zh' ? 'zh_CN' : 'en_US';
            },
            refresh: function () {
                loading('show');
                this.hasLoadedAll = false;
                page = 1;
                this.prodFilter.page = 0;
                // 待审核&审核拒绝
                if (this.currentType === 0 || this.currentType === 2) {
                    myPresaleProductsList.getPresaleApplyList();
                } else {
                    myPresaleProductsList.getPresaleProducts();
                }
            },
            _initListData: function (list) {
                if (list.length > 0) {
                    var currency = lan === 'zh' ? '￥' : '$';
                    var item;
                    for (var i = 0, len = list.length; i < len; i++) {
                        item = list[i];
                        // 价格
                        item.TweebuckPriceText = getExchangeText(item.TweebuckPrice);
                    }
                }
                if (page === 0) {
                    this.productsData = list;
                } else {
                    this.productsData = this.productsData.concat(list);
                }
            },
            getPresaleProducts: function () {
                var that = this;
                if (that.isLoading) {
                    return false;
                }
                var url = getBaseUrl() + "/api/v3/users/products?LanguageCode=" + lan;
                var paramStr = {
                    "ownerId": this.myID,
                    "currentpage": that.prodFilter.page,
                    "itemsperpage": DEFAULT_PAGE_SIZE,
                    "LanguageCode": lan,
                    "ProductToTweebaaDetailRequired": true,
                    "self": that.onlySelf,
                    "businessType": 1,  // 1 只取预售产品 0 只取非预售产品 不填混合返回
                    "categoryId": that.prodFilter.categoryId,
                    "orderBy": that.prodFilter.orderBy,
                    "desc": that.prodFilter.desc,
                    "q": that.prodFilter.q
                };
                if (this.currentType === 'doing') {
                    paramStr.presaleStatusCode = "Approved";
                } else if (this.currentType === 'over') {
                    paramStr.presaleStatusCode = "Completed";
                }
                if (this.prodFilter.page === 0) {
                    that.isLoading = true;
                    loading('show');
                } else {
                    that.bottomLoading = true;
                }
                getAxois(url, "POST", paramStr).then(function (response) {
                    that.isLoading = false;
                    that.bottomLoading = false;
                    loading('hide');
                    var list = response.data.Data;
                    if (that.prodFilter.page === 0) {
                        if (list.length !== 0) {
                            that.presaleList = list;
                        } else {
                            that.presaleList = [];
                            that.hasLoadedAll = true;
                        }
                    } else {
                        if (list.length !== 0) {
                            that.presaleList = that.presaleList.concat(list);
                        } else {
                            that.hasLoadedAll = true;
                        }
                    }
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            getPresaleApplyList: function () {
                var that = this;
                if (that.isLoading) {
                    return false;
                }

                var param = {
                    categoryId: '',
                    currentpage: page,
                    itemsperpage: DEFAULT_PAGE_SIZE,
                    orderBy: '',
                    desc: true,
                    q: '',
                    status: this.currentType
                };

                if (page === 1) {
                    loading('show');
                    that.isLoading = true;
                } else {
                    that.bottomLoading = true;
                }
                apiPresale.get('/presales', param).done(function (response) {
                    that.bottomLoading = false;
                    that.isLoading = false;
                    loading('hide');
                    if (response.code === 0) {
                        var list = response.data.list;
                        if (page === 1) {
                            if (list.length !== 0) {
                                that.presaleList = list;
                            } else {
                                that.presaleList = [];
                                that.hasLoadedAll = true;
                            }
                        } else {
                            if (list.length !== 0) {
                                that.presaleList = that.presaleList.concat(list);
                            } else {
                                that.hasLoadedAll = true;
                            }
                        }
                    } else {
                        api.toast({
                            msg: response.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            openMenu: function (presale, $event) {
                $event.stopPropagation();
                var that = this;
                this.currentPresale = presale;
                actionSheet([
                    {
                        color: 'red',
                        text: MSG.general.delete,
                        callback: function () {
                            that.remove();
                        }
                    },
                    {
                        text: MSG.suggestion.reApply,
                        callback: function () {
                            that.edit();
                        }
                    }
                ]);
            },
            edit: function () {
                openTabLayout('presaleProduct', MSG.mine.myPresale, 'widget://html/products/add-presale.html', {
                    isEdit: true,
                    presale: this.currentPresale
                });
            },
            remove: function () {
                var that = this;
                confirm(MSG.tips.wantDelete, [
                    {
                        text: MSG.general.ok,
                        callback: function () {
                            loading('show');
                            apiPresale.post('/presales/' + that.currentPresale.id + '/actions/cancel').done(function (rep) {
                                loading('hide');
                                if (rep.code === 0) {
                                    api.toast({
                                        msg: MSG.general.success,
                                        duration: 2000,
                                        location: 'middle'
                                    });
                                    that.refresh();
                                } else {
                                    api.toast({
                                        msg: MSG.tips.systemError,
                                        duration: 2000,
                                        location: 'middle'
                                    });
                                }
                            });
                        }
                    },
                    {
                        text: MSG.general.cancel,
                        callback: function () {

                        }
                    }
                ]);
            },
            openDetail: function (presale) {
                openTabLayout('presaleDetail', this.message.suggestion.presaleDetail, 'widget://html/products/presale-detail.html', {
                    product: presale
                });
            },
            openProdDetail: function (prodId, productSource) {
                var tweebaaTag = productSource === 1 ? 'tweebaa-tag' : '';
                var param = {
                    prodId: prodId,
                    userInfo: JSON.stringify(this.userInfo),
                    countryCode: 'CN',
                    tweebaaTag: tweebaaTag
                };
                openTabLayout('productDetail', '', 'widget://html/products/product-detail.html', param);
            },
            addPresale: function () {
                taskService.check(function () {
                    openTabLayout("addPresale", MSG.tProduct.presale, 'widget://html/products/add-presale.html');
                });
            }
        }

    });

};
