
var page = 0;
apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    api.setNavBarAttr({
        rightButtons: [{
            iconPath:'widget://image/add-icon.jpg'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if(ret.type ==='right'){
            //myProductsList.addProduct();
            myProductsList.openAddMenu();
        }else{
            back();
        }
    });


    //上拉加载
    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 300
        }
    }, function (ret, err) {
        if(myProductsList.productsLoad === true && !myProductsList.bottomLoading && !myProductsList.isLoading){
            page++;
            myProductsList.getProducts(page, true);
        }
    });

    api.setRefreshHeaderInfo({
        loadingImg:'widget://image/refresh-logo.png',
        bgColor: '#fff',
        textColor: '#000',
        textDown: MSG.tips.pullDownRefresh,
        textLoading: MSG.tips.refreshing,
        showTime: false,
        textUp:  MSG.tips.releaseRefresh
    }, function (ret, err) {
        api.refreshHeaderLoadDone();
        myProductsList.refreshProduct();
    });

    api.addEventListener({
        name: 'productListReload'
    }, function (ret, err) {
        location.reload();
    });

    var taskService = new TaskService(TASK_CODE.GROUP_ADD_SHOWCASE);

    api.addEventListener({
        name: 'taskReload'
    }, function(ret, err){
        taskService.refresh();
    });


    api.addEventListener({
        name: 'selectedProdCategory',
    }, function (ret, err) {
        myProductsList.prodFilter.categoryId = ret.value.category.id;
        myProductsList.prodFilter.displayFilter = ret.value.category[lan];
        page = 0;
        myProductsList.useFilter = true;
        myProductsList.getProducts(0);
    });


    // 我的产品
    var kv = api.require('snKVStorage');
    var MY_RPODUCT_DATA = [];
    var hasMyProductData = kv.has({
        key: 'myProductData'
    });

    if(hasMyProductData){
        MY_RPODUCT_DATA = kv.getArray({
            key: 'myProductData'
        });
    }

    var appleCheck = api.getGlobalData({
        key: 'appleCheck'
    });

    var myProductsList = new Vue({
        el: '#myProductsList',
        mounted: function () {
            this.getProducts(0);
        },
        created: function() {

        },
        data: {
            appleCheck: appleCheck,
            myID: localStorage.getItem('userId'),
            userInfo: '',
            productsData: MY_RPODUCT_DATA || [],
            defaultCurrency: '',
            lastGuid:'',
            currentProductId:'',
            currentProductGUID:'',
            currentProductPrice:'',
            currentProductCurrency:'',
            currentIndex:'',
            currentProductType:'',
            currentProductSource:'',
            currentProductName:'',
            currentProductBusinessType:'',
            currentProductToTweebaaApproved:false,
            currentProductActive:true,
            currentProductFreeOffer:null,
            currentProductThumbnailUrl: '',
            currentProductIsTop: false,
            bottomLoading:false,
            isLoading:false,
            prodPicWidth:$('#testPordPic').width(),
            productsLoad: true,
            hasFinishShowcaseTask: false,
            searchBox:false,
            useFilter:false,
            onlySelf:false,
            prodFilter:{
                displayFilter:'',
                categoryId:'',
                orderBy:'',   // 可选项。 其值只有两个固定选项“NAME” 和 “TWEEBUCK_PRICE” 或者为空
                desc:true,//可选项。 默认值是true降序。
                q: ''//可选项。 对产品名称的模糊查询
            },
            message:MSG
        },
        filters: {
            /**
             * @return {string}
             */
            productStatusCode:function (value) {
                return MSG.products[value.toUpperCase()];
            },
            formatTime:function (value) {
                return moment.utc(value).local().format('YYYY-MM-DD HH:mm');
            },
        },
        methods: {
            /**
             * 刷新产品列表
             */
            refreshProduct: function() {
                loading('show');
                page = 0;
                this.productsLoad = true;
                this.onlySelf = false;
                this.prodFilter.categoryId = '';
                this.prodFilter.displayFilter = '';
                this.prodFilter.orderBy = '';
                this.prodFilter.desc = true;
                this.prodFilter.q = '';
                this.searchBox = false;
                this.useFilter = false;
                this.getProducts(page);
            },
            _initListData: function(list) {
                if (list.length > 0) {
                    var currency = lan === 'zh' ? '￥' : '$';
                    var item;
                    for (var i = 0, len = list.length; i < len; i++) {
                        item = list[i];
                        // 价格
                        item.TweebuckPriceText = getExchangeText(item.TweebuckPrice);
                    }
                }
                if (page === 0) {
                    this.productsData = list;
                } else {
                    this.productsData = this.productsData.concat(list);
                }
            },

            /**
             * 个人产品分类排序查询
             */
            openCategoryPage:function(){
                openTabLayout('categoryPage', MSG.products.category, 'widget://html/frame/select-category.html', {
                    fromPage: 'tycoonProd'
                });
            },
            openProdSearch:function(){
                this.searchBox = true;
                this.useFilter = true;
            },
            searchProduct:function(){
                $('#searchBox').blur();
                pPages = 0;
                this.getProducts(0);
            },
            openAddMenu: function (){
                var that = this;
                var mnPopups = api.require('MNPopups');
                mnPopups.open({
                    rect: {
                        w: 180,
                        h: 100
                    },
                    position: {
                        x: api.winWidth - getRightPxFromFontSize(26),
                        y: getRightPxFromFontSize(68)
                    },
                    styles: {
                        mask: 'rgba(0,0,0,0.2)',
                        bg: '#fff',
                        corner: 8,
                        cell: {
                            bg: {
                                normal: '#fff',
                                highlight: ''
                            },
                            h: 44,
                            title: {
                                marginL: 20,
                                color: '#000',
                                size: 14,
                                textAlign: 'left'
                            },
                            icon: {
                                marginL: 140,
                                w: 20,
                                h: 20,
                                corner: 0
                            },
                            separateLine: {
                                width: 0.5,
                                marginLR: 10,
                                bg: '#DADADA',
                                hideLastSeparateLine: true
                            }
                        },
                        pointer: {
                            size: 0,
                            xPercent: 90,
                            yPercent: 0,
                            orientation: 'downward'
                        }
                    },
                    datas: [
                        {
                            icon: 'widget://image/placeholder.png',
                            title: MSG.products.addProduct
                        },
                        {
                            icon: 'widget://image/placeholder.png',
                            title:  MSG.products.addToFree
                        }
                    ],
                    animation: true,
                    animationDuration: 100
                }, function(ret) {
                    if (ret) {
                        if (ret.index === 0) {  //添加产品
                            that.addProduct();
                        } else if (ret.index === 1) {   // 添加免费
                            that.addFree();
                        }
                    }
                });
            },
            openSortMenu:function(){
                var that = this;
                var T = this.$refs.prodFilterBar.offsetTop;
                var mnPopups = api.require('MNPopups');
                mnPopups.open({
                    rect: {
                        w: 180,
                        h: 238
                    },
                    position: {
                        x: api.winWidth - getRightPxFromFontSize(26),
                        y: T+ 60
                    },
                    styles: {
                        mask: 'rgba(0,0,0,0.2)',
                        bg: '#fff',
                        corner: 8,
                        cell: {
                            bg: {
                                normal: '#fff',
                                highlight: ''
                            },
                            h: 44,
                            title: {
                                marginL: 20,
                                color: '#000',
                                size: 14,
                                textAlign: 'left'
                            },
                            icon: {
                                marginL: 140,
                                w: 20,
                                h: 20,
                                corner: 0
                            },
                            separateLine: {
                                width: 0.5,
                                marginLR: 10,
                                bg: '#DADADA',
                                hideLastSeparateLine: true
                            }
                        },
                        pointer: {
                            size: 0,
                            xPercent: 90,
                            yPercent: 0,
                            orientation: 'downward'
                        }
                    },
                    datas: [
                        {
                            icon: 'widget://image/placeholder.png',
                            title: MSG.tProduct.default
                        },
                        {
                            icon: 'widget://image/ranking-up.png',
                            title:  MSG.tProduct.lowToHigh
                        },
                        {
                            icon: 'widget://image/ranking-down.png',
                            title:  MSG.tProduct.highToLow
                        },
                        {
                            icon:  'widget://image/ranking-up.png',
                            title:  MSG.tProduct.byName
                        },
                        {
                            icon: 'widget://image/ranking-down.png',
                            title:  MSG.tProduct.byNameR
                        }
                    ],
                    animation: true,
                    animationDuration: 100
                }, function(ret) {
                    if (ret) {
                        if (ret.index === 0) {  //默认
                            that.refreshProduct();
                        } else if (ret.index === 1) {   // 价格由低到高
                            that.prodFilter.orderBy = 'TWEEBUCK_PRICE';
                            that.useFilter = true;
                            that.prodFilter.desc = false;
                            that.prodFilter.displayFilter = MSG.tProduct.lowToHigh;
                            pPages = 0;
                            that.getProducts(0);
                        } else if (ret.index === 2) {   // 价格由高到低
                            that.prodFilter.orderBy = 'TWEEBUCK_PRICE';
                            that.useFilter = true;
                            that.prodFilter.desc = true;
                            that.prodFilter.displayFilter = MSG.tProduct.highToLow;
                            pPages = 0;
                            that.getProducts(0);
                        } else if (ret.index === 3) {   // 名字正序
                            that.prodFilter.orderBy = 'NAME';
                            that.useFilter = true;
                            that.prodFilter.desc = false;
                            that.prodFilter.displayFilter = MSG.tProduct.byName;
                            pPages = 0;
                            that.getProducts(0);
                        } else if (ret.index === 4) {   // 名字倒序
                            that.prodFilter.orderBy = 'NAME';
                            that.useFilter = true;
                            that.prodFilter.desc = true;
                            that.prodFilter.displayFilter = MSG.tProduct.byNameR;
                            pPages = 0;
                            that.getProducts(0);
                        }
                    }
                });
            },
            getProducts: function (page) {
                var that = this;
                if(that.isLoading){
                    return false;
                }
                if(page===0){
                    loading('show');
                }else{
                    that.bottomLoading = true;
                }
                var url = getBaseUrl() + "/api/v3/users/products?LanguageCode="+lan;
                var paramStr = {
                    "ownerId": this.myID,
                    "currentpage": page || 0,
                    "itemsperpage": 10,
                    "LanguageCode":lan,
                    "ProductToTweebaaDetailRequired":true,
                    "self":that.onlySelf,
                    // "businessType" : 0, // 1 只取预售产品 0 只取非预售产品 不填混合返回
                    "categoryId":that.prodFilter.categoryId,
                    "orderBy":that.prodFilter.orderBy,
                    "desc":that.prodFilter.desc,
                    "q":that.prodFilter.q
                };

                that.isLoading = true;
                getAxois(url, "POST", paramStr).then(function (response) {
                    //console.log(JSON.stringify(response.data.Data));
                    that.bottomLoading = false;
                    that.isLoading = false;
                    loading('hide');
                    var list = response.data.Data;
                    if(page===0){
                        if (response.data.Data.length !== 0) {
                            that.userInfo = response.data.Data[0].Owner;
                            that.productsData = response.data.Data;
                            that._initListData(list);
                            kv.setArray({
                                key: 'myProductData',
                                value: that.productsData
                            });
                        } else {
                            that.productsLoad = false;
                        }
                    }else{
                        if (response.data.Data.length !== 0) {
                            that._initListData(list);
                        } else {
                            that.productsLoad = false;
                        }
                    }
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            tweebaaTag:function (value) {
                return value === 1 ?'tweebaa-tag':''
            },
            progressColor:function(index){
                if(!this.productsData[index].BusinessType && this.productsData[index].BusinessType !== 1){
                    return
                }
                var end = moment(this.productsData[index].PreSaleInfo.PreSaleStopUtc).local();
                var now = moment();
                var endDate = end.diff(now, 'hours');
                var endMinute = end.diff(now, 'minutes');
                if(endDate>=0 && endDate < 24 && endMinute >0 ){
                    return 'bk-red'
                }else if(endMinute <= 0 ){
                    return 'bk-green'
                }
            },
            openDetail: function (prodId,productSource) {
                var tweebaaTag  = productSource === 1 ?'tweebaa-tag':'';
                var userInfo = {
                    "UserName": localStorage.getItem('userName'),
                    "Id": localStorage.getItem('userId'),
                    "CustomerGuid": localStorage.getItem('userGuid'),
                    "StoreName": localStorage.getItem('storename'),
                };
                var param = {
                    prodId: prodId,
                    userInfo:JSON.stringify(userInfo),
                    // countryCode:this.userInfo.RegisterCountryCode,
                    tweebaaTag:tweebaaTag
                };
                openTabLayout('productDetail','','widget://html/products/product-detail.html',param);
            },
            openProductMenu:function(index){
                var that = this;
                this.currentProductId = this.productsData[index].Id;
                this.currentProductGUID = this.productsData[index].ProductGuid;
                this.currentProductPrice = this.productsData[index].TweebuckPrice;
                this.currentProductSource = this.productsData[index].ProductSource;
                this.currentProductType = this.productsData[index].ProductType;
                this.currentProductCurrency = this.productsData[index].CurrencyCode;
                this.currentProductName = this.productsData[index].Name;
                this.currentProductBusinessType = this.productsData[index].BusinessType;
                // this.currentProductThumbnailUrl = this.productsData[index].FeaturedPicture.ThumbnailUrl || that.productsData[index].FeaturedPicture.PictureUrl;
                // this.currentProductFreeOffer = this.productsData[index].FreeOffer;
                this.currentProductActive = this.productsData[index].Active;
                this.currentProductToTweebaaApproved = this.productsData[index].ProductSource!==1 && !!(this.productsData[index].LatestProductToTweebaa && this.productsData[index].LatestProductToTweebaa.LatestProductToTweebaaStatusCode === "Approved");
                this.currentIndex = index;
                this.currentProductIsTop = this.productsData[index].isTop;
                var buttons = [];
                if(this.currentProductIsTop){
                    buttons.push({
                        text: MSG.chat.removeStickyTop,
                        callback: function () {
                            that.productStickyTop('DELETE');
                        }
                    });
                }else{
                    buttons.push({
                        text: MSG.chat.stickyTop,
                        callback: function () {
                            that.productStickyTop('POST');
                        }
                    });
                }
                if (!this.currentProductToTweebaaApproved) {
                    buttons.push({
                        color: 'red',
                        text: MSG.general.delete,
                        callback: function () {
                            that.deleteProduct();
                        }
                    });
                }
                if (this.currentProductBusinessType === 2) {
                    buttons.push({
                        color: 'red',
                        text: MSG.products.cancelFree,
                        callback: function () {
                            that.cancelFreeProduct();
                        }
                    });
                }
                if (this.currentProductSource !== 1 && !this.currentProductToTweebaaApproved) {
                    buttons.push({
                        text: MSG.general.edit,
                        callback: function () {
                            that.productEdit();
                        }
                    });
                    if (this.currentProductActive) {
                        buttons.push({
                            text: MSG.general.discontinue,
                            callback: function () {
                                that.switchActive('discontinue');
                            }
                        });
                    }else{
                        buttons.push({
                            text: MSG.general.launch,
                            callback: function () {
                                that.switchActive();
                            }
                        });
                    }
                }

                actionSheet(buttons);
            },
            cancelFreeProduct:function(){
                var that = this;
                $('#productMenu').removeClass('show');
                confirmBox(that.message.products.wantCancelFree, MSG.general.cancel,  MSG.general.ok,'error');
                $('.dialog-box').find('button').on('click',function (e) {
                    $('.dialog-box').remove();

                    var index = $(this).attr('id');
                    if (index === 'btn-2') {
                        var url = "/v1/product/free/cancel/" + that.currentProductId;
                        loading('show');
                        apiFree.edit(url , {}).done(function (rep) {
                            //console.log(JSON.stringify(rep));
                            that.isRequesting = false;
                            loading('hide');
                            if (rep.code === 0) {
                                api.toast({
                                    msg: MSG.tips.success,
                                    duration: 2000,
                                    location: 'middle'
                                });
                                that.productsData[that.currentIndex].BusinessType = 0;
                            } else {
                                api.toast({
                                    msg: rep.message,
                                    duration: 2000,
                                    location: 'middle'
                                });
                            }
                        });
                    }
                });
            },
            productStickyTop:function(method){
                var that = this;
                var url = getBaseUrl() + "api/v3/user/topproduct";
                var paramStr = {
                    "ProductId":that.currentProductId  ,
                    "ProductGuid":that.currentProductGUID
                };
                getAxois(url,method,paramStr).then(function (response) {
                    //console.log(JSON.stringify(response));
                    api.toast({
                        msg: MSG.general.success,
                        duration: 2000,
                        location: 'middle'
                    });
                    that.getProducts(0);
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            deleteProduct: function () {
                var that = this;
                confirm(MSG.tips.wantDelete, [
                    {
                        text: MSG.general.ok,
                        callback: function () {
                            var userid = localStorage.getItem('userId');
                            var url,paramStr;
                            if(that.currentProductSource ===1){
                                url = getBaseUrl() + "api/v2/tweebaa-product/to/tycoon?ProductId=" + that.currentProductId + "&UserId=" + userid;
                                paramStr = {};
                            }else{
                                url = getBaseUrl() + "api/v2/products?ActorId=" + userid + "&ProductId=" + that.currentProductId;
                                paramStr = {"userId": userid, "productId": that.currentProductId};
                            }
                            loading('show');
                            getAxois(url,"DELETE",paramStr).then(function (response) {
                                loading('hide');
                                api.toast({
                                    msg: MSG.general.success,
                                    duration: 2000,
                                    location: 'middle'
                                });
                                that.productsData.splice(that.currentIndex, 1);
                                api.sendEvent({
                                    name: 'indexProductListReload',
                                });

                                if(that.currentProductSource ===1){
                                    //删除扣减Tiv
                                    var TZ = Intl.DateTimeFormat().resolvedOptions().timeZone;
                                    var LT = moment().format('YYYY-MM-DDThh:mm:ss');
                                    api.sendEvent({
                                        name: 'delTiV',
                                        extra: {
                                            type: 'showcase',
                                            obj:{
                                                "tz":TZ,
                                                "tl":LT,
                                                "PrG": that.currentProductGUID,
                                                "OI" : localStorage.getItem('userId'),
                                                "OG" : localStorage.getItem('userGuid')
                                            }
                                        }
                                    });
                                }

                            }).catch(function (error) {
                                console.log(JSON.stringify(error));
                            });

                        }
                    },
                    {
                        text: MSG.general.cancel,
                        callback: function () {

                        }
                    }
                ]);
            },
            switchActive:function(type){
                var that = this;
                if(type === 'discontinue'){
                    confirmBox(that.message.products.wantDiscontinue, MSG.general.cancel,  MSG.general.ok,'error');
                    $('.dialog-box').find('button').on('click',function (e) {
                        $('.dialog-box').remove();
                        var index = $(this).attr('id');
                        if (index === 'btn-2') {
                            that.setActive();

                        }
                    });
                }else{
                    that.setActive();
                }

            },
            setActive:function(){
                var that = this;
                var userid = localStorage.getItem('userId');
                var url = getBaseUrl() + "api/v2/product/activate-deactivate?userId=" + userid +"&ProductId=" + that.currentProductId;
                $('#productMenu').removeClass('show');
                getAxois(url,"PUT",{}).then(function (response) {
                    that.getProducts(0);
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            enableToTweeba:function(){
                var that = this;
                openTabLayout('enabletoTweeba', MSG.products.enabletoTweeba, '../products/enable-tweebaa.html',{
                    productGuid: that.currentProductGUID,
                    price: that.currentProductPrice,
                    productType: that.currentProductType,
                    productName: that.currentProductName,
                    productThumbnailUrl: that.currentProductThumbnailUrl
                });
            },
            productEdit:function () {
                var that = this;
                var url = that.currentProductType ===1?"widget://html/products/form-physical.html":"widget://html/products/form-digital-new.html";
                openTabLayout('editProduct',that.message.products.editProd,url,{
                    productId: that.currentProductId
                });
            },
            latestProductToTweebaaStatus:function (index) {
                var that = this;
                api.openFrame({
                    name: 'latestProductToTweebaaStatuspage',
                    url: 'latest-status.html',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    pageParam: {
                        data: that.productsData[index].LatestProductToTweebaa
                    },
                    bounces:false,
                    bgColor:'rgba(0,0,0,0.7)',
                    fixedOn:'ui_layout',
                    animation:{
                        type:"none",
                    }
                });
            },
            addProduct: function () {
                taskService.check(function () {
                    openTabLayout('prepareAdd', MSG.mine.selectProductType, 'widget://html/products/prepare-add.html');
                });
            },
            addFree: function () {
                taskService.check(function () {
                    openTabLayout('addFree', MSG.products.addToFree, 'widget://html/products/add-free.html');
                });
            }
        }

    });

};
