
var page = 1;
apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    api.setNavBarAttr({
        rightButtons: [{
            iconPath:'widget://image/add-icon.jpg'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if(ret.type ==='right'){
            mySuggestProductsList.addSuggest();
        }else{
            back();
        }
    });


    //上拉加载
    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 300
        }
    }, function (ret, err) {
        if(!mySuggestProductsList.hasLoadedAll && !mySuggestProductsList.bottomLoading && !mySuggestProductsList.isLoading){
            page++;
            mySuggestProductsList.getSuggestProducts(page);
        }
    });

    api.setRefreshHeaderInfo({
        loadingImg:'widget://image/refresh-logo.png',
        bgColor: '#fff',
        textColor: '#000',
        textDown: MSG.tips.pullDownRefresh,
        textLoading: MSG.tips.refreshing,
        showTime: false,
        textUp:  MSG.tips.releaseRefresh
    }, function(ret, err) {
        api.refreshHeaderLoadDone();
        mySuggestProductsList.refresh();
    });

    api.addEventListener({
        name: 'mySuggestProductsListReload'
    }, function (ret, err) {
        mySuggestProductsList.refresh();
    });

    var taskService = new TaskService(TASK_CODE.GROUP_ADD_SHOWCASE);

    api.addEventListener({
        name: 'taskReload'
    }, function(ret, err){
        taskService.refresh();
    });

    var kv = api.require('snKVStorage');
    var USERINFO;
    var hasUserInfo = kv.has({
        key: 'userInfo'
    });
    if (hasUserInfo) {
        USERINFO = kv.getObject({
            key: 'userInfo'
        });
    }

    var mySuggestProductsList = new Vue({
        el: '#mySuggestProductsList',
        mounted: function () {
            this.getSuggestProducts(page);
        },
        data: {
            myID: localStorage.getItem('userId'),
            userInfo: USERINFO,

            evaluationList: [],
            bottomLoading:false,
            isLoading:false,
            hasLoadedAll: false,
            currentEvaluation: null,
            message:MSG
        },
        filters: {
            StatusCode:function (value) {
                var result;
                switch (value) {
                    case -1:
                        result = MSG.products.REJECTED;
                        break;
                    case 0:
                        result = MSG.products.SUBMITTED;
                        break;
                    case 1:
                        result = MSG.products.VOTING;
                        break;
                    case 2:
                        result = MSG.products.APPROVED;
                        break;
                }
                return result;
            }
        },
        methods: {
            getStatusKey: function(value) {
                var result;
                switch (value) {
                    case -1:
                        result = 'Rejected';
                        break;
                    case 0:
                        result = 'Submitted';
                        break;
                    case 1:
                        result = 'Voting';
                        break;
                    case 2:
                        result = 'Approved';
                        break;
                    case 99:
                        result = 'None'
                }
                return result;
            },
            getLangKey: function() {
                return lan === 'zh' ? 'zh_CN' : 'en_US';
            },
            refresh: function() {
                loading('show');
                this.hasLoadedAll = false;
                page = 1;
                mySuggestProductsList.getSuggestProducts(page);
            },
            _doList: function(list) {
                $.map(list, function (item, index) {
                    if (item.status === -1 || item.status === 0 || item.status === 99) {
                        item.isMoreOk = true;
                    } else {
                        item.isMoreOk = false;
                    }
                });
                return list;
            },
            getSuggestProducts: function(page) {
                var that = this;
                if(that.isLoading){
                    return false;
                }

                var param = {
                    userId: this.myID,
                    categoryId: '',
                    currentpage: page,
                    itemsperpage: 20,
                    orderBy: '',
                    desc: true,
                    q: ''
                };

                if (page === 1) {
                    loading('show');
                } else {
                    that.bottomLoading = true;
                }
                that.isLoading = true;
                apiSuggest.get('/api-product/suggest/list/mine', param).done(function (response) {
                    // $('#placeHolderLoad').remove();
                    // console.log(JSON.stringify(response.data.Data));
                    that.bottomLoading = false;
                    that.isLoading = false;
                    loading('hide');
                    if (response.code === 0) {
                        if (page === 1) {
                            if (response.data.list.length !== 0) {
                                var list = that._doList(response.data.list);
                                that.evaluationList = list;
                            } else {
                                that.hasLoadedAll = true;
                            }
                        } else {
                            if (response.data.list.length !== 0) {
                                var list = that._doList(response.data.list);
                                that.evaluationList = that.evaluationList.concat(list);
                            } else {
                                that.hasLoadedAll = true;
                            }
                        }
                    } else {
                        api.toast({
                            msg: MSG.tips.systemError,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            openDetail: function (prodId, productSource) {
                var tweebaaTag  = productSource === 1 ?'tweebaa-tag':'';
                var param = {
                    prodId: prodId,
                    userInfo: JSON.stringify(this.userInfo),
                    countryCode: this.userInfo.RegisterCountryCode,
                    tweebaaTag: tweebaaTag
                };
                openTabLayout('productDetail','','widget://html/products/product-detail.html',param);
            },
            openMenu:function(evaluation, $event){
                $event.stopPropagation();
                var that = this;
                this.currentEvaluation = evaluation;

                // actionSheet([
                //     {
                //         color: 'red',
                //         text: MSG.general.delete,
                //         callback: function () {
                //             that.remove();
                //         }
                //     },
                //     {
                //         text: MSG.suggestion.reApply,
                //         callback: function () {
                //             that.edit();
                //         }
                //     }
                // ]);
                // return;

                var buttons = [];
                if (evaluation.status === -1 || evaluation.status === 99 || evaluation.status === 0) {
                    buttons = [
                        {
                            color: 'red',
                            text: MSG.general.delete,
                            callback: function () {
                                that.remove();
                            }
                        },
                        {
                            text: MSG.suggestion.reApply,
                            callback: function () {
                                that.edit();
                            }
                        }
                    ];
                }
                // else if (evaluation.status === 0) {
                //     buttons = [
                //         {
                //             color: 'red',
                //             text: MSG.general.delete,
                //             callback: function () {
                //                 that.remove();
                //             }
                //         }
                //     ];
                // }

                actionSheet(buttons);
            },
            edit: function() {
                openTabLayout('suggestProduct', MSG.tProduct.suggestProduct, 'widget://html/products/suggest-product.html', {
                    isEdit: true,
                    type: this.currentEvaluation.type,
                    suggestId: this.currentEvaluation.id
                });
            },
            remove: function () {
                var that = this;
                confirmBox(MSG.tips.wantDelete, MSG.general.cancel, MSG.general.ok,'error');
                $('.dialog-box').find('button').on('click',function (e) {
                    $('.dialog-box').remove();
                    var index = $(this).attr('id');
                    if (index === 'btn-2') {
                        loading('show');
                        apiSuggest.remove('/api-product/suggest/' + that.currentEvaluation.id).done(function (rep) {
                            loading('hide');
                            if (rep.code === 0) {
                                api.toast({
                                    msg: MSG.general.success,
                                    duration: 2000,
                                    location: 'middle'
                                });
                                that.refresh();
                            } else {
                                api.toast({
                                    msg: MSG.tips.systemError,
                                    duration: 2000,
                                    location: 'middle'
                                });
                            }
                        });
                    }

                    //     getAxois(url,"DELETE",paramStr).then(function (response) {
                    //         //console.log(JSON.stringify(response));
                    //         //$('#'+that.currentProductGUID).remove();
                    //         that.getProducts(0);
                    //     }).catch(function (error) {
                    //         console.log(JSON.stringify(error));
                    //         messages($.i18n.prop('systemError'), 'error', 'top', 3);
                    //     });
                    // }
                });

            },
            openEvaluationDetail: function (index) {
                var title = this.message.tProduct.detail;
                var id = this.evaluationList[index].id;
                openTabLayout('evaluationDetail', title, 'widget://html/discovery/evaluation-product.html', {
                    evaluationId: id,
                    evaluationData: this.evaluationList[index]
                });
            },
            addSuggest: function () {
                taskService.check(function () {
                    openTabLayout("prepareSuggest", MSG.products.addProductMethod, 'widget://html/products/prepare-suggest.html');
                });
            }
        }

    });

};
