
apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    backListener();

    api.addEventListener({
        name: 'swiperight'
    }, function (ret, err) {
        back();
    });

    api.setWinAttr({
        bounces: false,
    });

    api.addEventListener({
        name: 'reloadOrderDetail'
    }, function(ret, err) {
        orderDetail.getOrderDetail();
    });

    api.addEventListener({
        name: 'dialogRemarkSuccess'
    }, function (ret, err) {
        orderDetail.$forceUpdate();
    });

    var orderDetail = new Vue({
        el: '#orderDetail',
        mounted: function () {

        },
        created: function() {
            this.getProductAssess();
            this.getOrderDetail();
        },
        data: {
            productType: 1,
            isLoading: true,
            isOwner: false,
            myId: localStorage.getItem('userId'),
            repData: {},
            AddressInfo:[],
            listData:[],
            orderNumber:'',
            orderDate:'',
            orderTime: '',
            OrderStatus:'',
            PaymentStatus:'',
            Buyer:[],
            userInfo:[],
            Total:'',
            CurrencyCode:'',
            orderId: api.pageParam.orderId,
            message: MSG,
            picUrls: [],
            assessData: null
        },
        filters: {
            filterSubString: filterSubString,
            fixed2:function (value) {
                return Number(value).toFixed(2);
            },
            filterOrderStatus: filterOrderStatus,
            setText: filterPayStatus,
            filterShippingStatus: filterShippingStatus
        },
        methods:{
            openDetail: function (prodId,productSource) {
                var tweebaaTag  = productSource === 1 ?'tweebaa-tag':'';
                var param = {
                    prodId: prodId,
                    userInfo:JSON.stringify(this.userInfo),
                    countryCode:this.userInfo.RegisterCountryCode,
                    tweebaaTag:tweebaaTag
                };
               // console.log(param);
                openTabLayout('productDetail','','widget://html/products/product-detail.html',param);
            },
            getOrderDetail:function () {
                var that= this;
                var url = getBaseUrl() + 'api/v3/orderdetail?OrderId=' + that.orderId;
                this.isLoading = true;
                getAxois(url, "GET", '').then(function (response) {
                    that.isLoading = false;
                    that.repData = response.data;
                    that.AddressInfo = response.data.ShippingAddress;
                    that.orderNumber= response.data.CustomOrderNumber;
                    that.orderDate= moment.utc(response.data.CreatedOnUtc).local().format('YYYY-MM-DD');
                    that.orderTime= moment.utc(response.data.CreatedOnUtc).local().format('HH:mm:ss');
                    that.Buyer= response.data.Buyer;
                    that.listData= response.data.Items;
                    that.productType = that.listData[0].Product.ProductType;
                    that.Total= response.data.TweebuckTotal;
                    that.CurrencyCode= response.data.CurrencyCode;
                    that.userInfo = response.data.Items[0].Owner;
                    that.OrderStatus= response.data.OrderStatus;
                    that.PaymentStatus= response.data.PaymentStatus;

                    // 判断是否产品的所有者
                    if (that.listData[0].Owner.Id === +that.myId) {
                        that.isOwner = true;
                    }

                    // 判断是否有申诉，如果有，把退款原因提取出来
                    if (that.repData.AppealInfo && that.repData.AppealInfo.AppealComment) {
                        var comment = that.repData.AppealInfo.AppealComment;
                        var indexDivide = comment.indexOf(']');
                        that.repData.AppealInfo.Reasons = comment.substring(1, indexDivide);
                        that.repData.AppealInfo.Desc = comment.substring(indexDivide + 1);
                        that._initPics();
                    }

                    //console.log(JSON.stringify(response));
                }).catch(function (error) {
                    that.isLoading = false;
                    console.log(JSON.stringify(error) + ' review API 报错');
                });
            },
            checkShippingStatus:function(){
                var param = {
                    shippingInfo: this.repData.ShippingInfo,
                    addressInfo: this.AddressInfo
                };
                openTabLayout('tracking','','widget://html/business/show-tracking.html',param);
            },
            chatToUser: function () {
                var userinfo = this.Buyer;
                var userId = userinfo.UserName + '@new';
                openChatPage({
                    targetId: userId,
                    userId: userinfo.Id,
                    userName: userinfo.Name,
                    userPortrait: userinfo.ThumbnailAvatarUrl,
                    conversationType: 'PRIVATE',
                    isTop: false
                });
            },
            openPlace:function(user){
                openUserTycoonPlace(user.Id,user.Name,user.ThumbnailAvatarUrl);
            },
            chatToOwner: function (owner) {
                openChatPage({
                    targetId: owner.UserName + '@new',
                    userId: owner.Id,
                    userName: owner.Name,
                    userPortrait: owner.ThumbnailAvatarUrl,
                    conversationType: 'PRIVATE',
                    isTop: false
                });
            },
            _doSuccess: function() {
                api.toast({
                    msg: this.message.tips.success,
                    duration: 2000,
                    location: 'middle'
                });
                this.getOrderDetail();
                api.sendEvent({
                    name: 'reloadOrderList'
                });
            },
            /**
             * 直接取消订单
             * @param orderId
             * @param buyerUserName
             */
            cancelOrderDirectly: function(orderId, buyerUserName) {
                var that = this;
                // 二次确认
                confirmBox(this.message.payment.tipCancel, this.message.general.cancel, this.message.general.ok);
                $('.dialog-box').find('button').on('click',function (e) {
                    var index = $(this).attr('id');
                    $('.dialog-box').remove();
                    if (index === 'btn-2') {
                        loading('show');
                        var ProdAdminId = localStorage.getItem('userId');
                        var ProdAdminGuid = localStorage.getItem('userGuid');
                        var url = getBaseUrl() + "api/v1/appeal/owner";
                        getAxois(url, "POST", {
                            OrderId: orderId,
                            ProdAdminId: ProdAdminId,
                            ProdAdminGuid: ProdAdminGuid,
                            ProdAdminReplyCode: 'OwnerCancel'
                        }).then(function (response) {
                            loading('hide');
                            if(response.data.Code === 0){
                                that._doSuccess();

                                // 通知买家订单已经取消
                                postNotify(buyerUserName, MSG_TYPE_ORDER, {
                                    Type: 'orderCancelledByOwner',
                                    AvatarUrl: localStorage.getItem('thumbnail'),
                                    StoreName: localStorage.getItem('storename'),
                                    OrderId: api.pageParam.orderId,
                                    UserId: localStorage.getItem('userId'),
                                });
                            } else {
                                api.toast({
                                    msg: response.data.ExceptionMessage,
                                    duration: 2000,
                                    location: 'middle'
                                });
                            }
                        }).catch(function (error) {
                            loading('hide');
                            console.log(JSON.stringify(error));
                        });
                    }
                });
            },
            /**
             * 确认修改地址，继续订单
             * @param orderId
             * @param appealId
             */
            confirmUpdateAddress: function (orderId, appealId) {
                var that = this;
                // 二次确认
                confirmBox(this.message.payment.tipReject, this.message.general.cancel, this.message.general.ok);
                $('.dialog-box').find('button').on('click',function (e) {
                    var index = $(this).attr('id');
                    $('.dialog-box').remove();
                    if (index === 'btn-2') {
                        loading('show');
                        var ProdAdminId = localStorage.getItem('userId');
                        var ProdAdminGuid = localStorage.getItem('userGuid');
                        var url = getBaseUrl() + "api/v1/appeal/owner";
                        getAxois(url, "POST", {
                            OrderId: orderId,
                            AppealId: appealId,
                            ProdAdminId: ProdAdminId,
                            ProdAdminGuid: ProdAdminGuid,
                            ProdAdminReplyCode: 'OwnerResume',
                            ProdAdminComment: '不许申诉！'
                        }).then(function (response) {
                            loading('hide');
                            if(response.data.Code === 0){
                                that._doSuccess();
                            } else {
                                api.toast({
                                    msg: response.data.ExceptionMessage,
                                    duration: 2000,
                                    location: 'middle'
                                });
                            }
                        }).catch(function (error) {
                            loading('hide');
                            console.log(JSON.stringify(error));
                        });
                    }
                });
            },
            /**
             * 确认退货退款，取消订单
             * @param orderId
             * @param appealId
             */
            confirmCancelOrder: function (orderId, appealId) {
                var that = this;
                // 二次确认
                confirmBox(this.message.payment.tipRefund, this.message.general.cancel, this.message.general.ok);
                $('.dialog-box').find('button').on('click',function (e) {
                    var index = $(this).attr('id');
                    $('.dialog-box').remove();
                    if (index === 'btn-2') {
                        loading('show');
                        var ProdAdminId = localStorage.getItem('userId');
                        var ProdAdminGuid = localStorage.getItem('userGuid');
                        var url = getBaseUrl() + "api/v1/appeal/owner";
                        getAxois(url, "POST", {
                            OrderId: orderId,
                            AppealId: appealId,
                            ProdAdminId: ProdAdminId,
                            ProdAdminGuid: ProdAdminGuid,
                            ProdAdminReplyCode: 'ConfirmCancel'
                        }).then(function (response) {
                            loading('hide');
                            if(response.data.Code === 0){
                                that._doSuccess();
                            } else {
                                api.toast({
                                    msg: response.data.ExceptionMessage,
                                    duration: 2000,
                                    location: 'middle'
                                });
                            }
                        }).catch(function (error) {
                            loading('hide');
                            console.log(JSON.stringify(error));
                        });
                    }
                });
            },
            /**
             * 输入物流单号
             * @param orderId
             * @param shippingInfo
             * @param buyerUserName
             */
            openTracking: function(orderId, shippingInfo, buyerUserName) {
                var userId = localStorage.getItem('userId');
                openTabLayout('orderEnterTracking', this.message.payment.tracking, 'widget://html/products/order-enter-tracking.html', {
                    userId: userId,
                    orderId: orderId,
                    orderStatus: this.OrderStatus,
                    shippingInfo: shippingInfo,
                    userName: buyerUserName
                });
            },
            /**
             * 查看物流单号
             * @param orderId
             * @param shippingInfo
             */
            openViewTracking: function(orderId, shippingInfo) {
                openTabLayout('orderReadTracking', this.message.payment.viewTracking, 'widget://html/products/order-read-tracking.html', {
                    orderId: orderId,
                    shippingInfo: shippingInfo
                });
            },
            /**
             * 查看修改地址
             * @param comment
             */
            openViewAddress: function (comment) {
                openTabLayout('orderViewAddress', this.message.payment.viewAddress, 'widget://html/products/order-view-address.html', {
                    comment: comment
                });
            },
            openRefundView: function (AppealInfo) {
                openTabLayout('orderViewRefund', this.message.payment.appealLabel, 'widget://html/products/order-view-refund.html', {
                    listData: this.listData,
                    AppealInfo: AppealInfo
                });
            },
            copyNumber:function (Number,type) {
                var that = this;
                if(type === 'address'){
                    Number = that.AddressInfo.Country.Name + ' ' + that.AddressInfo.City +' ' + that.AddressInfo.Address1 + ' ' +that.AddressInfo.PostalCode;
                }
                var clipBoard = api.require('clipBoard');
                clipBoard.set({
                    value: Number
                }, function (ret, err) {
                    if (ret) {
                        var content;
                        if(type === 'orderNum'){
                            content = that.message.payment.orderNumberCopied
                        }else if(type === 'trackingNum'){
                            content = that.message.payment.trackingNumberCopied
                        }else {
                            content = that.message.tips.copied
                        }
                        api.toast({
                            msg: content,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            },
            _initPics: function() {
                var appealPictures = this.repData.AppealInfo.AppealPictures;
                if (appealPictures) {
                    var picUrls= [];
                    for (var i = 0, len = appealPictures.length; i < len; i++) {
                        picUrls.push(appealPictures[i].DownloadUrl);
                    }
                    this.picUrls = picUrls;
                }
            },
            showImages:function(event, Index){
                var that = this;
                var UIPhotoViewer = api.require('UIPhotoViewer');
                UIPhotoViewer.open({
                    images: this.picUrls,
                    placeholderImg: 'widget://image/lost_images.jpg',
                    bgColor: '#000',
                    activeIndex:Index,
                    zoomEnabled:true,
                    gestureClose:true
                }, function(Ret, err) {
                    if (Ret.eventType === 'click' ) {
                        UIPhotoViewer.close();
                    } else if(Ret.eventType === 'longPress'){
                        api.actionSheet({
                            cancelTitle: that.message.general.cancel,
                            buttons: [that.message.general.save]
                        }, function(ret, err) {
                            var index = ret.buttonIndex;
                            if(index === 1){
                                api.download({
                                    url: that.picUrls[Ret.index],
                                    report: true,
                                    cache: true,
                                    allowResume: true
                                }, function (ret, err) {
                                    if (ret.state === 1) {
                                        var Url= ret.savePath;
                                        api.saveMediaToAlbum({
                                            path: Url,
                                            groupName:"Tweebaa"
                                        }, function(ret, err) {
                                            if (ret && ret.status) {
                                                alert(that.message.tips.saved);
                                            }
                                        });

                                    }
                                });
                            }

                        });

                    }
                });
            },
            getProductAssess: function() {
                apiAssess.get('/v1/api/evaluate/get/' + api.pageParam.prodId).done(function (rep) {
                    if (rep.code === 0) {
                        this.assessData = rep.data;
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }.bind(this));
            },
            goAssessList: function () {
                openTabLayout('product-assess-list', MSG.assess.title, 'widget://html/products/product-assess-list.html', {
                    prodId: api.pageParam.prodId,
                    average: this.assessData.average,
                    totalCount: this.assessData.totalCount
                });
            },
        }
    });


};
