var page = 0;
apiready = function () {
    backListener();

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 0
        }
    }, function (ret, err) {
        loading('show');
        page++;
        orderList.getOrderList(page);
    });

    api.addEventListener({
        name: 'reloadOrderList'
    }, function (ret, err) {
        page = 0;
        orderList.getOrderList(page);
    });

    api.addEventListener({
        name: 'swiperight'
    }, function (ret, err) {
        back();
    });

    api.setRefreshHeaderInfo({
        loadingImg:'widget://image/refresh-logo.png',
        bgColor: '#fff',
        textColor: '#000',
        textDown: MSG.tips.pullDownRefresh,
        textLoading: MSG.tips.refreshing,
        showTime: false,
        textUp:  MSG.tips.releaseRefresh
    }, function (ret, err) {
        //结束下拉刷新状态
        api.refreshHeaderLoadDone();
        page = 0;
        // orderList.orderData = [];
        $('#placeHolderLoad').show();
        orderList.getOrderList(page);
    });

    api.addEventListener({
        name: 'dialogRemarkSuccess'
    }, function (ret, err) {
        orderList.$forceUpdate();
    });

    var orderList = new Vue({
        el: '#orderList',
        mounted: function () {
            this.getOrderList(null,0);
        },
        data: {
            currentType:'all',
            loadingBottom: false,
            orderData: [],
            loading:true,
            message:MSG
        },
        filters: {
            filterTime: filterTime,
            fixed2:function (value) {
                return Number(value).toFixed(2);
            },
            filterOrderStatus: filterOrderStatus,
            filterShippingStatus: filterShippingStatus,
            setStatus:function (value) {
                switch (value) {
                    case "Pending":
                        return MSG.payment.unpaid;
                    case "Paid":
                        return MSG.payment.Paid;
                }
            }
        },
        methods:{
            changeType:function(type){
                this.currentType = type;
                this.orderData = [];
                page = 0;
                this.getOrderList();
            },
            getOrderList: function (page, event) {
                var that = this;
                var userId = localStorage.getItem('userId');
                if(event){
                    page = 0;
                    var tar = event.target;
                    that.orderData = [];
                    $('.product-tag').removeClass('current-tag');
                    $(tar).addClass('current-tag');
                }
                var currentPage = page || 0;
                var url = getBaseUrl() + "api/v3/sellerorders?SellerId="+userId+"&currentpage="+currentPage+
                    "&itemsperpage=24&orderStatus="+this.currentType;
                if (currentPage === 0) {
                    $('#placeHolderLoad').show();
                }
                that.loading = true;
                loading('show');
               //console.log(url);
                getAxois(url,"GET",{}).then(function (response) {
                    $('#placeHolderLoad').hide();
                    loading('hide');
                    that.loading = false;
                    if (currentPage === 0) {
                        that.orderData = response.data;
                    } else {
                        that.orderData = that.orderData.concat(response.data);
                    }
                    // that.orderData = that.orderData.concat(response.data);
                    //console.log(JSON.stringify(response));
                    // setTimeout(function () {
                    //     //changePriceType();
                    //     setOrder();
                    // });
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error));
                    //messages($.i18n.prop('systemError'), 'error', 'top', 3);
                });
            },
            copyNumber:function (Number) {
                var that = this;
                var clipBoard = api.require('clipBoard');
                clipBoard.set({
                    value: Number
                }, function (ret, err) {
                    if (ret) {
                        api.toast({
                            msg: that.message.payment.orderNumberCopied,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            },
            openOrderDetail:function (orderId, prodId) {
                openTabLayout("orderDetail",this.message.payment.orderDetail,'widget://html/products/order-detail.html',{
                    orderId: orderId,
                    prodId: prodId
                });
            },
            deleteOrder:function(orderId,orderGuid){
                confirmBox(MSG.tips.wantDelete, MSG.general.cancel, MSG.general.ok,'error'); //'Do you want delete this moment?'
                $('.dialog-box').find('button').on('click',function (e) {
                    var index = $(this).attr('id');
                    $('.dialog-box').remove();
                    if (index === 'btn-2') {
                        loading('show');
                        var url = getBaseUrl() + "api/orders/" + orderId + "/cancel";
                        getAxois(url,"DELETE",{}).then(function (response) {
                            loading('hide');
                            $('li#'+orderGuid).fadeOut();
                        }).catch(function (error) {
                            loading('hide');
                            console.log(JSON.stringify(error));
                            //messages($.i18n.prop('systemError'), 'error', 'top', 3);
                        });
                    }
                });
            },
        }
    });

};

// function setOrder() {
//     $('.order-list').each(function () {
//         var status = $(this).find('.order-status-text');
//         var statusText;
//         switch (status.text()) {
//             case "Pending":
//                 statusText = $.i18n.prop('unpaid');
//                 break;
//             case "Paid":
//                 statusText = $.i18n.prop('Paid');
//                 break;
//         }
//         status.text(statusText);
//     })
// }
