var prodId;

apiready = function () {

    backListener();

    api.addEventListener({
        name:'swiperight'
    }, function(ret, err){
        back();
    });

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 500            //设置距离底部多少距离时触发，默认值为0，数字类型
        }
    }, function (ret, err) {
        if (assessList.assessData
                && assessList.list.length < assessList.assessData.totalCount
                && assessList.isLoading === false) {
            assessList.condition.currPage++;
            assessList.getList();
        }
    });

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    prodId = api.pageParam.prodId;

    var assessList = new Vue({
        el: '#assessList',
        filters: {
            formatTime:function (value) {
                return moment.utc(value).local().format('YYYY-MM-DD HH:mm');
            },
            fixed1:function (value) {
                return Number(value).toFixed(1);
            },
            fixed2:function (value) {
                return Number(value).toFixed(2);
            },
        },
        created: function () {
            this.getScore();
            this.getCount();
            this.getList();
        },
        data: {
            average: api.pageParam.average,
            totalCount: api.pageParam.totalCount,
            isLoading: false,
            assessData: {
                totalCount: 0
            },
            list: [],
            condition: {
                productId: prodId,
                currPage: 1,
                pageSize: DEFAULT_PAGE_SIZE,
                type: -1,    // 类型 -1:全部 0:好评 1:中/差评 2:有图/视频
                orderBy: 1,     // 1:点赞数 2:时间
            },
            scoreData: {
                '1': {
                    "score": 1,
                    "num": 0,
                    "percentage": '0'
                },
                '2': {
                    "score": 2,
                    "num": 0,
                    "percentage": '0'
                },
                '3': {
                    "score": 3,
                    "num": 0,
                    "percentage": '0'
                },
                '4': {
                    "score": 4,
                    "num": 0,
                    "percentage": '0'
                },
                '5': {
                    "score": 5,
                    "num": 0,
                    "percentage": '0'
                }
            },
            countData: {
                "totalCount": '-',
                "highScoreCount": '-',
                "middleScoreCount": '-',
                "mediaCount": '-'
            },
            message: MSG
        },
        methods: {
            changeTag: function(value) {
                if (value === this.condition.type) {
                    return;
                }
                this.condition.currPage = 1;
                this.condition.type = value;
                this.getList();
            },
            openSort: function() {
                var that = this;
                var selected;
                actionSheet([
                    {
                        text: MSG.assess.sortDefault,
                        callback: function() {
                            selected = 1;
                            if (that.condition.orderBy !== selected) {
                                that.condition.currPage = 1;
                                that.condition.orderBy = 1;
                                that.getList();
                            }
                        }
                    },
                    {
                        text: MSG.assess.time,
                        callback: function() {
                            selected = 2;
                            if (that.condition.orderBy !== selected) {
                                that.condition.currPage = 1;
                                that.condition.orderBy = 2;
                                that.getList();
                            }
                        }
                    }
                ])
            },
            getScore: function () {
                var that = this;
                apiAssess.get('/v1/api/evaluate/getScore', {
                    productId: prodId
                }).done(function (rep) {
                    if (rep.code === 0) {
                        var list = rep.data.list;
                        $.map(list, function (item, index) {
                            that.scoreData[item.score + ''] = item;
                        });
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }.bind(this));
            },
            getCount: function () {
                apiAssess.get('/v1/api/evaluate/getCount', {
                    productId: prodId
                }).done(function (rep) {
                    if (rep.code === 0) {
                        this.countData = rep.data;
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }.bind(this));
            },
            _formatList: function(list) {
                $.map(list, function (item, index) {
                    item.isTranslate = false;
                    item.commentText = item.comment;
                });
                return list;
            },
            getList: function () {
                var that = this;
                loading('show');
                this.isLoading = true;
                apiAssess.get('/v1/api/evaluate/list', this.condition).done(function (rep) {
                    that.isLoading = false;
                    loading('hide');
                    if (rep.code === 0) {
                        var data = rep.data;

                        if (this.condition.currPage === 1) {
                            this.list = this._formatList(data.list);
                        } else {
                            this.list = this.list.concat(this._formatList(data.list));
                        }

                        this.assessData = data;
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }.bind(this));
            },
            toTranslate(item) {
                if (item.isTranslate === false) {
                    loading('show');
                    item.isTranslate = true;
                    translate(item.comment, function (result) {
                        loading('hide');
                        item.commentText = result;
                    });
                } else {
                    item.isTranslate = false;
                    item.commentText = item.comment;
                }
            },
            toLikeAssess: function(assess) {
                var param = {
                    "evaluateId": assess.evaluateId,
                    "productId": prodId,
                    "userId": this.myID
                };
                loading('show');
                apiAssess.post('/v1/api/evaluate/like', param).done(function (rep) {
                    loading('hide');
                    if (rep.code === 0) {
                        assess.likeNum++;
                        api.toast({
                            msg: MSG.general.success,
                            duration: 2000,
                            location: 'middle'
                        });
                    } else {
                        loading('hide');
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            },
            playPicture: function(innerIndex, pictures) {
                var pics = [];
                $.map(pictures, function (item, index) {
                    pics.push(item.DownloadUrl);
                });
                var UIPhotoViewer = api.require('UIPhotoViewer');
                UIPhotoViewer.open({
                    images: pics,
                    placeholderImg: 'widget://image/lost_images.jpg',
                    bgColor: '#000',
                    activeIndex: innerIndex,
                    zoomEnabled: true,
                    gestureClose: true
                }, function(Ret, err) {
                    if (Ret.eventType === 'click' ) {
                        UIPhotoViewer.close();
                    }
                });
            },
            playVideo: function(url) {
                playVideo(url);
            },
        }
    });

};
