
var productURL;
apiready = function () {
    api.setWinAttr({
        bounces: false,
        slidBackEnabled:false
    });
    api.addEventListener({
        name: 'keyback'
    }, function(ret, err) {
        backToAdd();
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        //console.log(JSON.stringify(ret));
        if(ret.type ==='right'){
            deleteUpload();
        }else{
            backToAdd();
        }
    });

    if(api.pageParam.url){
        productURL = api.pageParam.url.DownloadUrl;
        $('#progress').css('width','100%');
        $('#saveBtn').removeClass('opacity-5 no-touch');
        api.setNavBarAttr({
            rightButtons: [{
                text: $.i18n.prop('cancel'),
                color:'#d11212',
                fontSize:'16',
                fontWeight:'bold'
            }]
        });
    }
};
var message = {
    "zh":{
        "uploadTips":"数据正在上传，请勿关闭此窗口。 "
    },
    "en":{
        "uploadTips":"Data is uploading，please do not close this page."
    }
};

function saveUpload() {
    api.execScript({
        name: 'addProduct',
        script: 'Btns.enterSimple("'+ productURL +'");'
    });
    back();
}

//添加产品和小样
$("#getProduct").on('change', function () {

    var fileName = $(this).val();
    if (fileName == "") {
        return false;
    }
    // var objUrl = showVideo(this.files[0]);
    //showDisplay('prod',fileName,objUrl);
    if(this.files[0].size > 82837504){
        alert($.i18n.prop('fileTooLarge'));
        return
    }
    uploadProduct();
});

//删除产品和小样
function deleteUpload() {
    confirmBox($.i18n.prop('wantDelete'), $.i18n.prop('cancel'), $.i18n.prop('sure'),'error');
    $('.dialog-box').find('button').on('click',function (e) {
        $('.dialog-box').remove();
        var index = $(this).attr('id');
        if (index === 'btn-2') {
            productURL = null;
            $('#progress').css('width',0);
            $('#uploadTips').addClass('invisible');
            $('#saveBtn').addClass('opacity-5 no-touch');
            api.setNavBarAttr({
                rightButtons: [{
                    text: '',
                    color:'#d11212',
                    fontSize:'16',
                    fontWeight:'bold'
                }]
            });
        }
    });

}

function uploadProduct() {
    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });
    var formData = new FormData();
    var productFile = $('#getProduct').get(0).files[0];
    if(productFile){
        formData.append('file', productFile, 'TWEEBAA-ORIGIN-'+ productFile.name);
    }

    var url = 'https://media.tweebaa.';
    if (localStorage.getItem('server') === 'cn') {
        url = url + 'cn';
    } else {
        url = url + 'com';
    }
    url = url + '/api/v1/uploader/products/' + localStorage.getItem('userGuid');
    $('#uploadTips').text(message[lan].uploadTips).removeClass('invisible');
    axios.post(url, formData, {
        headers: {
            "apikey":token,
            'Content-Type':'application/x-www-form-urlencoded;charset=utf-8'
        },
        onUploadProgress: function (e){

            var completeProgress = ((e.loaded / e.total * 100) | 0);
            $('#progress').css('width',completeProgress+'%');

            if(completeProgress === 100){
                loading('show');
            }
        }
    }).then(function(res){
        loading('hide');
        $('#uploadTips').addClass('invisible');
        $('#saveBtn').removeClass('opacity-5 no-touch');
        productURL = res.data.Files[0].DownloadUrl;
        //console.log(productURL);
        api.setNavBarAttr({
            rightButtons: [{
                text: $.i18n.prop('cancel'),
                color:'#d11212',
                fontSize:'16',
                fontWeight:'bold'
            }]
        });
    }).catch(function(error){
        console.log(JSON.stringify(error));
    });

}

function backToAdd() {
    api.execScript({
        name: 'addProduct',
        script: 'Btns.enterSimple("'+ productURL +'");'
    });
    setTimeout(function () {
        back();
    })

}
