apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    api.setTabLayoutAttr({
        bounces: false
    });
    api.setWinAttr({
        bounces: false
    });
    backListener();
    var kv = api.require('snKVStorage');
    var hasCache = kv.has({
        key: 'userProdDetail'
    });
    var USERPORDDETAIL = {};
    var cacheProductData;
    if(hasCache){
        USERPORDDETAIL = kv.getObject({
            key: 'userProdDetail',
        });
        cacheProductData = USERPORDDETAIL['userpd' + api.pageParam.id];
    }

    // 监听添加收货地址
    api.addEventListener({
        name: 'reloadAddressList'
    }, function(ret, err) {
        buynow.getAddressList();
    });

    // 监听选择收货地址
    api.addEventListener({
        name: 'changeShippingAddress'
    }, function (ret, err) {
        buynow.selectedAddress = ret.value.address
    });

    var buynow = new Vue({
        el: '#buynow',
        mounted: function () {
            if (api.pageParam.toTweebaaId) {
                this.getSeller();
            }
            this.getProductDetail(api.pageParam.id);
            this.getAddressList();
            this.getTweebucks();
            this._initCache();
        },
        created: function() {

        },
        data: {
            isRequesting: false,
            productData: cacheProductData ? cacheProductData : '',
            seller: api.pageParam.seller,   // 如果有值，说明是从个人空间里面进来的
            product: {
                id: api.pageParam.id,
                toTweebaaId: api.pageParam.toTweebaaId,
                price: api.pageParam.price,
                type: api.pageParam.type,
                name: api.pageParam.name,
                thumbnailUrl: api.pageParam.thumbnailUrl
            },
            myID: localStorage.getItem('userId'),
            totalTweebucks:0,
            buyQuantity:1,
            addressData:[],
            selectedAddress: null,
            needPayTweebucks:0,
            needPayTweebucksText: 0,    // 对标法币
            totalOfProducts:0,
            Address:'',
            retailPrice: api.pageParam.price,
            relatedList: [],
            sellerList: [], // 卖家列表
            picked: -1,
            message:MSG
        },
        watch:{
            buyQuantity:function () {
                this._doTotal(this.productData);
            },
        },
        filters: {
            formatTime:function (value) {
                return moment.utc(value).local().format('YYYY-MM-DD HH:mm');
            },
            fixed2:function (value) {
                return Number(value).toFixed(2);
            },
            deliveryDate:function (value) {
                if(value){
                    return moment.utc(value).local().format('YYYY-MM');
                }else{
                    return MSG.tips.notSure;
                }
            }
        },
        methods:{
            _initCache: function() {
                var that = this;
                if (cacheProductData) {
                    that._doTotal(cacheProductData);
                }
            },
            _doTotal: function(productData) {
                this.totalOfProducts = (this.buyQuantity * productData.TweebuckPrice ).toFixed(2);
                if (productData.ShippingFee) {
                    this.needPayTweebucks = (this.buyQuantity * (productData.TweebuckPrice +  productData.ShippingFee)).toFixed(2);
                } else {
                    this.needPayTweebucks = (this.buyQuantity * productData.TweebuckPrice).toFixed(2);

                }
                this.needPayTweebucksText = getExchangeText(this.needPayTweebucks);
            },
            selectSeller: function(index) {
                this.picked = index;
            },
            ctrlQuantity:function (type) {
                if(type ==='add' && this.productData.ProductType !==2){
                    this.buyQuantity ++;
                }else{
                    if(this.buyQuantity >= 2){
                        this.buyQuantity --;
                    }
                }
            },
            getProductDetail: function (prodId) {
                var that = this;
                var url = getBaseUrl() + "api/users/" + that.myID + "/products/" + prodId + "?ProductToTweebaaDetailRequired=true&needProductType=true&LanguageCode="+lan;
                loading('show');
                getAxois(url, "GET", {}).then(function (response) {
                    var newRep = response.data;
                    loading('hide');
                    that.productData = newRep;
                    var datas = {};
                    if(hasCache){
                        datas = kv.getObject({
                            key: 'userProdDetail',
                        });
                    }
                    datas['userpd'+prodId] = that.productData;
                    var USERPORDDETAILS = kv.setObject({
                        key: 'userProdDetail',
                        value:datas
                    });

                    cacheProductData = newRep;
                    that._doTotal(cacheProductData);
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            getAddressList:function(){
                var that = this;
                var userId =  localStorage.getItem('userId');
                var url = getBaseUrl() + "api/users/"+ userId +"/addresses";
                getAxois(url,"GET",{}).then(function (response) {
                    //console.log(JSON.stringify(response.data));
                    if(response.data.length>0){
                        that.addressData = response.data;
                        for(i=0; i<that.addressData.length;i++){
                            if(that.addressData[i].IsPrimaryShipping){
                                that.selectedAddress = that.addressData[i];
                            }
                        }
                        // 如果没有默认地址，选择第一个地址作为默认地址
                        if ($.isEmptyObject(that.selectedAddress) === true) {
                            that.selectedAddress = that.addressData[0];
                        }
                    }
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            getTweebucks:function () {
                var that = this;
                var url = getBaseUrl() + "api/tweebucks/v1/balance?UserId=" + this.myID;
                getAxois(url,"GET",{}).then(function (response) {
                    //console.log(JSON.stringify(response));
                    that.totalTweebucks = response.data.Data.CompletedSubtotal;
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            /**
             * 购买成功的回调
             * @private
             */
            _doBuySuccess: function(orderId) {
                var that = this;
                confirm(that.message.tProduct.orderOk, [
                    {
                        text: that.message.tProduct.reviewOrder,
                        callback: function () {
                            openTabLayout('purchasesList', that.message.tProduct.purchases, 'widget://html/business/purchases-list.html');
                        }
                    },
                    {
                        text: that.message.tProduct.continueShopping,
                        callback: function () {
                            back();
                        }
                    }
                ]);

                // 发送购买成功的通知
                // 1. 发送给代理
                var userNameOfProxy = this.relatedList[that.picked].UserName;
                postNotify(userNameOfProxy, MSG_TYPE_ORDER, {
                    Type: 'orderProxyed',
                    AvatarUrl: localStorage.getItem('thumbnail'),
                    StoreName: localStorage.getItem('storename'),
                    UserId: localStorage.getItem('userId'),
                    OrderId: orderId,
                    ProductPrice: this.productData.TweebuckPrice,
                    ProductName: this.productData.Name,
                    ProductThumbnailUrl: this.productData.Pictures[0].ThumbnailUrl || this.productData.Pictures[0].PictureUrl
                });
                // 2. 发送给Owner
                var userNamOfOwner = that.productData.Owner.UserName;
                postNotify(userNamOfOwner, MSG_TYPE_ORDER, {
                    Type: 'orderSelled',
                    AvatarUrl: localStorage.getItem('thumbnail'),
                    StoreName: localStorage.getItem('storename'),
                    UserId: localStorage.getItem('userId'),
                    OrderId: orderId,
                    ProductPrice: this.productData.TweebuckPrice,
                    ProductName: this.productData.Name,
                    ProductThumbnailUrl: this.productData.Pictures[0].ThumbnailUrl || this.productData.Pictures[0].PictureUrl
                });
            },
            buyNow:function(){
                var that = this;
                if(this.needPayTweebucks > this.totalTweebucks){
                    confirm(that.message.tProduct.rewardBalance, [
                        {
                            text: that.message.tProduct.toRecharge,
                            callback: function () {
                                openTabLayout('tweebuck', MSG.tweebucks.buyTweebuck, 'widget://html/tweebucks/buy-tweebucks.html');
                            }
                        },
                        {
                            text: that.message.tProduct.cancel,
                            callback: function () {

                            }
                        }
                    ]);
                    return false;
                }
                // 从产品库进入
                if (!this.seller) {
                    if(that.relatedList.length === 0 || !that.relatedList[that.picked].UserId){
                        api.toast({
                            msg: that.message.tProduct.noSeller,
                            duration: 2000,
                            location: 'middle'
                        });
                        return false;
                    }
                }

                // 如果是实体产品，需要判断是否有收货地址
                if (this.productData.ProductType === 1 && !this.selectedAddress) {
                    api.toast({
                        msg: this.message.tProduct.emptyAddAdress,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }

                // 二次确认
                confirmBox(this.message.tProduct.confirmBuy, MSG.general.cancel, MSG.general.ok);
                $('.dialog-box').find('button').on('click',function (e) {
                    var index = $(this).attr('id');
                    //console.log(index);
                    $('.dialog-box').remove();
                    if (index === 'btn-2') {
                        var paramStr = {
                            "AddressId": that.selectedAddress ? that.selectedAddress.Id : '',
                            "BuyerId": that.myID,
                            "Guid": localStorage.getItem('userGuid'),
                            "ProductId": that.product.id,
                            "Quantity": that.buyQuantity
                        };

                        if (!that.seller) {
                            paramStr.SellerId = that.relatedList[that.picked].UserId;
                        } else {
                            paramStr.SellerId = that.seller.Id;
                        }
                        loading('show');
                        var url = getBaseUrl() + "api/tweebucks/v1/order";
                        getAxois(url, "POST", paramStr).then(function (response) {
                            //console.log(JSON.stringify(response));
                            loading('hide');
                            if(response.data.Code === 0){
                                // location.reload();
                                that._doBuySuccess(response.data.Data.Orderid);
                            }else if(response.data.Code === 50002){
                                messages("T豆冻结", 'error', 'top', 3);
                            }
                        }).catch(function (error) {
                            loading('hide');
                            console.log(JSON.stringify(error));
                        });

                    }
                });

                // var paramStr = {
                //     "AddressId": that.selectedAddress ? that.selectedAddress.Id : '',
                //     "BuyerId": that.myID,
                //     "Guid": localStorage.getItem('userGuid'),
                //     "ProductId": that.product.id,
                //     "Quantity": that.buyQuantity
                // };
                //
                // if (!this.seller) {
                //     paramStr.SellerId = that.relatedList[that.picked].UserId;
                // } else {
                //     paramStr.SellerId = this.seller.Id;
                // }
                //
                // //console.log(JSON.stringify(paramStr));
                // loading('show');
                // var url = getBaseUrl() + "api/tweebucks/v1/order";
                // getAxois(url, "POST", paramStr).then(function (response) {
                //     //console.log(JSON.stringify(response));
                //     loading('hide');
                //     if(response.data.Code === 0){
                //         // location.reload();
                //         that._doBuySuccess();
                //     }else if(response.data.Code === 50002){
                //         messages("T豆冻结", 'error', 'top', 3);
                //     }
                // }).catch(function (error) {
                //     loading('hide');
                //     console.log(JSON.stringify(error));
                // });
            },
            selectAddressBtn:function(){
                if(this.addressData.length !==0){
                    openTabLayout('addressList','','widget://html/business/address-list.html',{
                        selectedAddress:true
                    });
                }else{
                    openTabLayout('addAddress','','widget://html/business/add-address.html', {
                        addressData: {}
                    });
                }

            },
            getSeller:function(){
                var that = this;
                var url = getBaseUrl() + 'api/v2/tweebaa-product/tycoon/list?ProductToTweebaaID=' + api.pageParam.toTweebaaId;
                getAxois(url,"GET",{}).then(function (response) {

                    var list = response.data;
                    if(list.length >0 ){
                        that.relatedList = list.reverse();

                        // 取前三个
                        that.sellerList = that.relatedList.slice(0, 3);

                    }else if(that.productData.Owner.Id !==1){
                        that.relatedList = [{
                            "UserId":that.productData.Owner.Id,
                            "UserName":that.productData.Owner.UserName,
                            "UserPicLink":that.productData.Owner.AvatarUrl,
                            "UserPicThumnilLink":that.productData.Owner.ThumbnailAvatarUrl,
                            "StoreName":that.productData.Owner.StoreName,
                        }]
                    }else{
                        that.relatedList = [];
                    }

                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error));
                });
            },
            viewProd:function () {
                var that = this;
                openTabLayout('tweebaaProductDetail', MSG.tProduct.detail, 'widget://html/tproducts/tw-prod-detail.html',{
                    productId: that.product.id,
                    index: api.pageParam.index
                });
            },
            openSellerPlace: function(index) {
                var id = this.relatedList[index].UserId;
                var StoreName = this.relatedList[index].StoreName;
                var AvatarUrl = this.relatedList[index].UserPicThumnilLink;

                openUserTycoonPlace(id,StoreName,AvatarUrl);
            },
            seeMore: function () {
                var len = this.sellerList.length;
                this.sellerList = this.relatedList.slice(0, len + 5);
            }
        }
    });
};
