
apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    backListener();

    api.addEventListener({
        name:'swiperight'
    }, function(ret, err){
        back();
    });



    var UIInput = api.require('UIInput');
    UIInput.open({
        rect: {
            x: 15+44,
            y: getRightPxFromFontSize(16),
            w: api.winWidth - 160,
            h: 44
        },
        styles: {
            bgColor: 'rgba(0,0,0,0)',
            size: 14,
            color: '#000',
            placeholder: {
                color: '#BDBDBD'
            }
        },
        autoFocus: true,
        maxRows: 1,
        placeholder: MSG.searchProduct.placeholder,
        keyboardType: 'search',
        fixedOn: api.frameName,
        fixed: false
    }, function(ret) {
        if (ret.eventType === 'search') {
            UIInput.value(function(Ret) {
                if (Ret) {
                    // console.log(111);
                    productSearch.inputKeys = Ret.msg;
                    productSearch.submit();
                }
            });
        }
        if (ret.eventType === 'change') {
            UIInput.value(function(Ret) {
                if (Ret.msg.length >= 1) {
                    productSearch.inputKeys = Ret.msg;
                } else {
                    productSearch.inputKeys = '';
                }
            });
        }
    });

    var HOT_CATEORY = [
        {
            "id": 1019,
            "zh": "数字产品",
            "en": "Digital Products",
            "u": "",
            "o": 1019,
            "pi": 0,
            "c": []
        },
        {
            "id": 1015,
            "zh": "家居用品",
            "en": "Household Products",
            "u": "",
            "o": 1015,
            "pi": 0,
            "c": []
        },
        {
            "id": 1011,
            "zh": "运动户外",
            "en": "Outdoors",
            "u": "",
            "o": 1011,
            "pi": 0,
            "c": []
        },
        {
            "id": 1003,
            "zh": "健康理疗",
            "en": "Health",
            "u": "",
            "o": 1003,
            "pi": 0,
            "c": []
        }
    ];

    var kv = api.require('snKVStorage');
    var hasSearchFriendsKeys = kv.has({
        key: 'searchProductRecords'
    });
    var SEARCH_RECORDS;
    if (hasSearchFriendsKeys === true) {
        SEARCH_RECORDS = kv.getArray({
            key: 'searchProductRecords'
        });
    }

    var productSearch = new Vue({
        el: '#productSearch',
        data: function () {
            var records = [];
            if (SEARCH_RECORDS) {
                records = SEARCH_RECORDS.slice(0, 10);
            }
            return {
                inputKeys: '',
                searchResult: [],
                searchRecordsList: records,
                popularCategory: HOT_CATEORY,
                message: MSG
            }
        },
        methods:{
            resetKey: function() {
                this.inputKeys = '';
                this.keySelectList = [];
                this.searchResult = [];
                UIInput.value({
                    msg: '',
                });
            },
            clickHistory: function(key) {
                UIInput.value({
                    msg: key,
                });
                this.inputKeys = key;
                this.submit();
            },
            clearHistory: function() {
                this.searchRecordsList = [];
                kv.setArray({
                    key: 'searchProductRecords',
                    value: []
                });
            },
            _reduceSame: function(list) {
                var results = [];
                for (var i = 0, len = list.length; i < len; i++) {
                    if (results.indexOf(list[i]) < 0) {
                        results.push(list[i]);
                    }
                }
                return results;
            },
            submit: function () {
                var that = this;
                var key = this.inputKeys;

                // openTabLayout('tproductsRrsult', MSG.searchProduct.title, 'widget://html/tproducts/tw-prod-result.html', {
                //     Q: key
                // });

                api.sendEvent({
                    name: 'changeProductSearchKey',
                    extra: {
                        key: key
                    }
                });

                // 记录搜索记录
                var list = that.searchRecordsList;
                list.unshift(that.inputKeys);
                that.searchRecordsList = that._reduceSame(list);
                kv.setArray({
                    key: 'searchProductRecords',
                    value: that.searchRecordsList
                });

                setTimeout(function () {
                    back();
                }, 200);
            },
            clickCategory: function (category) {
                // openTabLayout('tproductsRrsult', MSG.searchProduct.title, 'widget://html/tproducts/tw-prod-result.html', {
                //     category: category
                // });

                api.sendEvent({
                    name: 'tProductsChangeCategory',
                    extra: {
                        category: category
                    }
                });

                // api.execScript({
                //     frameName: 'products',
                //     script: "tproductsList.changeCategory("+ JSON.stringify(category) + ")"
                // });

                setTimeout(function () {
                    back();
                }, 200);
            },
            close: function () {
                back();
            }
        }
    });

};
