var specialProducts;
apiready = function () {
    var pages =0;
    var pullDownRefresh = lan === 'zh' ? '下拉刷新' : 'Pull down to refresh';
    var refreshing = lan === 'zh' ? '刷新中...' : 'Refreshing...';
    var releaseRefresh = lan === 'zh' ? '放开开始刷新' : 'Release refresh';
    api.setRefreshHeaderInfo({
        loadingImg:'widget://image/refresh-logo.png',
        bgColor: '#fff',
        textColor: '#000',
        textDown: pullDownRefresh,
        textLoading: refreshing,
        showTime: false,
        textUp: releaseRefresh
    }, function (ret, err) {
        pages = 0;
        specialProducts.productsData = [];
        specialProducts.getProducts(0);
    });

    backListener();

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 500            //设置距离底部多少距离时触发，默认值为0，数字类型
        }
    }, function (ret, err) {
        if(!specialProducts.bottomLoading && specialProducts.totalItems > specialProducts.productsData.length){
            pages++;
            specialProducts.getProducts();
        }

    });



    specialProducts = new Vue({
        el: '#specialProducts',
        mounted: function () {
            this.getProducts();
            this.setTitle();
        },
        data: {
            productsData: [],
            productType:api.pageParam.type,
            bottomLoading:false,
            totalItems:'',
            categoryId: '',
            Q:'',
            noProduct:false,
            message: {
                "zh": {
                    "maxSellReward": "最大销售奖励",
                    "added": "已添加",
                    "noAdded": "添加",
                    "loading": "正在加载。。。。",
                    "search": "搜索产品",
                    "tweebaaProducts": "推易吧产品库",
                    "productOwner": "推荐人",
                    "noProduct": "没找到商品~",
                    "presale": "预售产品",
                    "freeoffers": "限免产品",
                },
                "en": {
                    "maxSellReward": "Maximum Rewards",
                    "added": "Add",
                    "noAdded": "Add to products",
                    "loading": "Loading...",
                    "search": "Search products",
                    "tweebaaProducts": "Tweebaa Products",
                    "productOwner": "OWNER",
                    "noProduct": "Can not found product",
                    "presale": "Presale products",
                    "freeoffers": "Free offers",
                }
            }
        },
        filters: {
            fixed2:function (value) {
                var v = value || 0;
                return Number(v).toFixed(2);
            },
        },
        methods:{
            setTitle:function(){
                var that = this;
                api.setTabLayoutAttr({
                    title: that.message[lan][api.pageParam.type]
                });
            },
            getProducts:function () {
                var that = this;
                if(pages===0){
                    loading('show');
                }else{
                    that.bottomLoading = true
                }
                var q = that.Q ||'';
                var userId = localStorage.getItem('userId');
                var url = getBaseUrl()+ "api/v3/tweebaa/products/"+this.productType+"?currentpage="+ pages +"&itemsperpage=24&q="+ q +"&LanguageCode="+ lan +"&ProductToTweebaaStatus=Approved&viewerId="+userId ;
                api.refreshHeaderLoadDone();
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(response.data.Data[0]));
                    loading('hide');
                    if(pages ===0 ){
                        that.productsData =[];
                    }
                    that.bottomLoading = false;
                    that.totalItems = response.data.TotalCount;
                    if(that.totalItems === 0 && pages ===0 ){
                        that.noProduct = true;
                    }
                    $('#placeHolderLoad').hide();
                    if (response.data.Data.length !== 0) {
                        that.productsData = that.productsData.concat(response.data.Data);
                    }

                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error));
                });
            },
            openSearch:function () {
                openTabLayout('activityDetail',this.message[lan]["search"],'widget://html/tproducts/products-search.html');
            },
            openProdDetail:function (proId) {
                openTabLayout('tweebaaProductDetail','','widget://html/tproducts/tw-prod-detail.html',{productId:proId});
            },
            openCategory:function () {
                openWindows('categoryList','widget://html/products/category-list.html');
            }
        }
    });

};

