var tproductsList;
apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    var taskService = new TaskService(TASK_CODE.GROUP_ADD_SHOWCASE);

    api.addEventListener({
        name: 'taskReload'
    }, function (ret, err) {
        taskService.refresh();
    });

    var pages = 0;
    var exchangeValue;

    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });

    api.addEventListener({
        name: 'dialogRemarkSuccess'
    }, function (ret, err) {
        tproductsList.$forceUpdate();
    });

    /**
     * 初始化汇率
     */
    function initRates() {

        var EXPIRE_TIME = 12;  // 超时时间，单位小时
        var exChangeCNY;
        var exChangeCAD;

        //删除Key
        // api.removePrefs({
        //     key: 'userName'
        // });

        var exChangeCNYFromStorage = api.getPrefs({
            sync: true,
            key: 'exChangeCNY'
        });

        // 1. 是否存储
        // 存储过
        if (exChangeCNYFromStorage) {
            // 2. 检查有效性
            var storageExchangeTime = api.getPrefs({
                sync: true,
                key: 'storageExchangeTime'
            });
            var timeDiff = moment().diff(storageExchangeTime, 'hour');
            //失效
            if (timeDiff >= EXPIRE_TIME) {
                fetchRate();
            } else {        // 没有失效
                if (lan === 'zh') {
                    exchangeValue = +exChangeCNYFromStorage;
                } else {
                    exchangeValue = 0.1;
                }
            }
        } else {    // 尚未存储过
            fetchRate();
        }

        function fetchRate() {
            //获取汇率信息
            getAxois(getBaseUrl() + "api/tweebucks/v1/rates", "GET", {}).then(function (response) {
                exChangeCNY = response.data.CNY / 10;
                exChangeCAD = response.data.CAD / 10;
                if (lan === 'zh') {
                    exchangeValue = exChangeCNY;
                } else {
                    exchangeValue = 0.1;
                }
                tproductsList._initListData(tproductsList.productsData);
                api.sendEvent({
                    name: 'exChangeRefresh',
                    extra: {
                        exChangeCNY: exChangeCNY,
                        exChangeCAD: exChangeCAD
                    }
                });
                api.setPrefs({
                    key: 'exChangeCNY',
                    value: exChangeCNY
                });
                api.setPrefs({
                    key: 'exChangeCAD',
                    value: exChangeCAD
                });
                //记录时间
                api.setPrefs({
                    key: 'storageExchangeTime',
                    value: moment().format()
                });
            });
        }
    }
    if (token) {
        initRates();
    }

    api.setRefreshHeaderInfo({
        loadingImg:'widget://image/refresh-logo.png',
        bgColor: '#fff',
        textColor: '#000',
        textDown: MSG.tips.pullDownRefresh,
        textLoading: MSG.tips.refreshing,
        showTime: false,
        textUp:  MSG.tips.releaseRefresh
    }, function (ret, err) {
        api.refreshHeaderLoadDone();
        if (tproductsList.currentType === 'products') {
            tproductsList.refreshProduct();
        } else {
            tproductsList.refreshEvaluation();
        }
    });

    // 用户添加/编辑/删除自己的产品时，需要刷新
    api.addEventListener({
        name: 'indexProductListReload'
    }, function(ret, err){
        // pages = 0;
        // tproductsList.getProducts();
        location.reload();
    });

    api.addEventListener({
        name: 'refreshEvaluationVoted'
    }, function(ret, err){
        var evaluationId = ret.value.evaluationId;
        var evaluation = tproductsList.getEvaluationById(evaluationId);
        if (evaluation) {
            evaluation.voted = true;
            evaluation.currentVotes++;
        }
    });

    api.addEventListener({
        name: 'changeProductSearchKey'
    }, function(ret, err){
        tproductsList.productFilter.key = ret.value.key;
        tproductsList.refreshProduct();
    });

    api.addEventListener({
        name: 'changeEvaluationSearchKey'
    }, function(ret, err){
        tproductsList.evaluationFilter.key = ret.value.key;
        tproductsList.refreshEvaluation();
    });

    api.addEventListener({
        name: 'tProductsChangeCategory'
    }, function(ret, err){
        tproductsList.changeCategory(ret.value.category);
    });

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 500            //设置距离底部多少距离时触发，默认值为0，数字类型
        }
    }, function (ret, err) {
        if (tproductsList.currentType === 'products') {
            if(!tproductsList.bottomLoading && tproductsList.totalItems > tproductsList.productsData.length){
                pages++;
                tproductsList.getProducts();
            }
        } else {
            if(!tproductsList.evaluationData.bottomLoading && tproductsList.totalEvaluation > tproductsList.evaluationList.length){
                tproductsList.evaluationData.page++;
                tproductsList.getEvaluationList();
            }
        }
    });

    api.addEventListener({
        name: guideService.GUIDE_SHOWROOM.key
    }, function(ret, err){
        if (guideService.check(guideService.GUIDE_SHOWROOM.key) === false) {
            api.pageUp({
                top: true
            });
            guideService.openGuidePage(guideService.GUIDE_SHOWROOM.key);
        }
    });

    var kv = api.require('snKVStorage');
    //大众评审
    var EVALUATION_LIST_MAP = {
        '25': {
            Id: 25
        },
        '20': {
            Id: 20
        },
        '19': {
            Id: 19
        },
        '38': {
            Id: 38
        },
        '42': {
            Id: 42
        }
    };
    // 评审列表
    var hasEvaluationList = kv.has({
        key: 'evaluationList'
    });
    var EVALUATION_LIST;
    if (hasEvaluationList === true) {
        EVALUATION_LIST = kv.getArray({
            key: 'evaluationList'
        });
    }

    // 产品列表
    var hasProductList = kv.has({
        key: 'productList'
    });
    var PRODUCT_LIST;
    if (hasProductList === true) {
        PRODUCT_LIST = kv.getArray({
            key: 'productList'
        });
    }

    var ROLE_PRODUCT_KEY = 'ROLE_PRODUCT';

    var imgIndex =1;

    tproductsList = new Vue({
        el: '#tproductsList',
        mounted: function () {
            var that = this;
            $('.place-holder-load').show();
            this.getProducts();
            this._initScroll();

            var version = api.appVersion.toString();
            var m = Math.random();
            getAxois("https://tweebaafiles-com.oss-accelerate.aliyuncs.com/check.json?"+m, "GET", {}).then(function (response) {
                if(api.systemType ==='ios'){
                    that.appleCheck = !!((response.data.version === version && response.data.check) || localStorage.getItem('userId') == "1808307");
                }
            })
        },
        data: {
            appleCheck: false,
            categories:[],
            Timer:0,
            role: localStorage.getItem(ROLE_PRODUCT_KEY) ? localStorage.getItem(ROLE_PRODUCT_KEY) : 'sell',
            productsData: [],
            banners: [
                {
                    en: '../../image/banners/product1-en.jpg',
                    es: '../../image/banners/product1-en.jpg',
                    zh: '../../image/banners/product1-zh.jpg'
                },
                {
                    en: '../../image/banners/product2-en.jpg',
                    es: '../../image/banners/product2-en.jpg',
                    zh: '../../image/banners/product2-zh.jpg'
                },
                {
                    en: '../../image/banners/product3-en.jpg',
                    es: '../../image/banners/product3-en.jpg',
                    zh: '../../image/banners/product3-zh.jpg'
                }
            ],
            tipsImg: '../../image/banners/product1-'+ lan +'.jpg',
            height: '',
            bottomLoading:false,
            totalItems:'',
            totalEvaluation: 0,
            scrollLeft:0,
            isRequesting: false,
            productFilter: {
                CategoryId: '',
                currentCategory: '',
                sortBy: '',
                key: ''
            },
            evaluationFilter: {
                CategoryId: '',
                currentCategory: '',
                sortBy: '',
                key: ''
            },
            isScrolling: false,
            currentType: 'products',    // 产品/大众评审
            evaluationList: EVALUATION_LIST || [],
            evaluationData: {
                page: 1,
                pageSize: 20,
                bottomLoading: false,
                haveData: true,
                isLoading: false,
            },
            lang: lan,
            message:MSG,

        },
        filters: {
            fixed2:function (value) {
                var v = value || 0;
                return Number(v).toFixed(2);
            },
            sortByFormat:function (value) {
                var d = MSG.tProduct.default;
                var l = MSG.tProduct.lowToHigh;
                var h = MSG.tProduct.highToLow;
                switch (value) {
                    case "default":
                        return d;
                    case "lowToHigh":
                        return l;
                    case "highToLow":
                        return h;
                }
            }
        },
        methods:{

            getEvaluationById: function(evaluationId) {
                var item;
                for (var i = 0, len = this.evaluationList.length; i < len; i++) {
                    item = this.evaluationList[i];
                    if (item.id === evaluationId) {
                        return item;
                    }
                }
                return null;
            },
            getLangKey: function() {
                return lan === 'zh' ? 'zh_CN' : 'en_US';
            },
            /**
             * 分类：产品，评审
             * @param type
             */
            switchType: function(type) {
                this.currentType = type;
                if (type === 'products' || type === 'presale') {
                    this.refreshProduct();
                } else{
                    this.refreshEvaluation();
                }
            },
            refreshProduct: function(type) {
                loading('show');
                pages = 0;
                this.getProducts(type);
            },
            refreshEvaluation: function() {
                loading('show');
                this.evaluationData.page = 1;
                this.getEvaluationList();
            },
            _initSwipper: function() {
                var IMG_WIDTH = 712;
                var IMG_HEIGHT = 220;
                var screenWidth = api.winWidth;

                var containerHeight = screenWidth * IMG_HEIGHT / IMG_WIDTH;
                // console.log('containerHeight: ' + containerHeight);
                $('#productListBanner').height(containerHeight);

                new Swiper ('#productListBanner', {
                    direction: 'horizontal',
                    autoplay: {
                        delay: 5000,
                        stopOnLastSlide: false,
                        disableOnInteraction: false,
                    },
                    loop: true,
                    initialSlide: 0,
                    pagination: {
                        el: '.swiper-pagination',
                    }
                });

            },
            _initScroll: function() {
                var that = this;

                var t1 = 0;
                var t2 = 0;
                var timer = null; // 定时器

                // var $returnTop = $("#returnTop");
                var clienHeight = api.screenHeight;

                //当点击跳转链接后，回到页面顶部位置
                // $returnTop.click(function(){
                //     //$('body,html').animate({scrollTop:0},1000);
                //     if ($('html').scrollTop()) {
                //         $('html').animate({ scrollTop: 0 }, 'normal');
                //         return false;
                //     }
                //     $('body').animate({ scrollTop: 0 }, 'normal');
                //     return false;
                // });

                // scroll监听
                $(document).scroll(function() {
                    that.isScrolling = true;
                    clearTimeout(timer);
                    timer = setTimeout(isScrollEnd, 500);
                    t1 = document.documentElement.scrollTop || document.body.scrollTop;
                    // console.log('t1 ===== ' + t1);

                    // if (t1 > clienHeight) {
                    //     $returnTop.fadeIn(800);
                    // } else {
                    //     $returnTop.fadeOut(800);
                    // }

                });

                function isScrollEnd() {
                    t2 = document.documentElement.scrollTop || document.body.scrollTop;
                    // console.log('t2 ===== ' + t2);
                    if(t2 === t1){
                        // console.log('滚动结束了');
                        that.isScrolling = false;
                    }
                }

            },
            changeRole:function(type){
                this.role = type;
                localStorage.setItem(ROLE_PRODUCT_KEY, type);
            },
            getCategories:function(){
                var that = this;
                var url = getBaseUrl()+ "api/tweebaa/products/categories?LanguageCode=" + lan ;
                getAxois(url, "GET", {}).then(function (response) {
                    // console.log(JSON.stringify(response.data.Data[0]));
                    that.categories = response.data.Data;
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            changeSortBy: function(method, type){
                var that = this;

                this.currentType = type;

                if (type === 'products') {
                    if( method !== that.productFilter.sortBy){
                        that.productFilter.sortBy = method;
                        this.refreshProduct();
                    }
                } else {
                    if( method !== that.evaluationFilter.sortBy){
                        that.evaluationFilter.sortBy = method;
                        this.refreshEvaluation();
                    }
                }

            },
            closeKey: function(type) {
                if (type === 'products') {
                    this.productFilter.key = '';
                    this.refreshProduct();
                } else {
                    this.evaluationFilter.key = '';
                    this.refreshEvaluation();
                }
            },
            closeSortBy: function(type) {
                if (type === 'products') {
                    this.productFilter.sortBy = '';
                    this.refreshProduct();
                } else {
                    this.evaluationFilter.sortBy = '';
                    this.refreshEvaluation();
                }
            },
            closeCategory: function(type) {
                if (type === 'products') {
                    this.productFilter.CategoryId = '';
                    this.productFilter.currentCategory = '';
                    this.refreshProduct();
                } else {
                    this.evaluationFilter.CategoryId = '';
                    this.evaluationFilter.currentCategory = '';
                    this.refreshEvaluation();
                }
            },
            getTimer:function(){
                var that = this;
                that.Timer ++;
                if(that.Timer === 4 ){
                    that.changeBannerAuto();
                }
                setTimeout(function () {
                    that.getTimer();
                },1000)
            },
            changeBannerAuto:function(){
                var that = this;
                that.Timer =0;
                if(imgIndex < 3){
                    imgIndex ++
                }else{
                    imgIndex = 1;
                }
                that.tipsImg = '../../image/banners/product'+ imgIndex +'-'+ lan +'.jpg'
            },
            openCategoryPage:function(){
                openTabLayout('categoryPage', this.message.tProduct.all, 'widget://html/frame/select-category.html');
            },
            changeCategory:function(category){
                var lang = lan === "es" ? "en" : lan;
                if (this.currentType === 'products') {
                    this.productFilter.CategoryId = category.id;
                    this.productFilter.currentCategory = category[lang];
                    this.refreshProduct();
                } else {
                    this.evaluationFilter.CategoryId = category.id;
                    this.evaluationFilter.currentCategory = category[lang];
                    this.refreshEvaluation();
                }
            },
            _initListData: function(list) {
                if (exchangeValue && list.length > 0) {
                    var currency = lan === 'zh' ? '￥' : '$';
                    var item;
                    for (var i = 0, len = list.length; i < len; i++) {
                        item = list[i];
                        // 最大销售奖励
                        if (item.LatestProductToTweebaa) {
                            var value = item.LatestProductToTweebaa.MaxAvailableTweebuckProfit;
                            item.LatestProductToTweebaa.MaxAvailableTweebuckProfitText = '≈' + currency + (value * exchangeValue).toFixed(2);
                        }
                        // 价格
                        item.TweebuckPriceText = '≈' + currency + (item.TweebuckPrice * exchangeValue).toFixed(2);

                    }
                }
                if (pages === 0) {
                    this.productsData = list;
                } else {
                    this.productsData = this.productsData.concat(list);
                }
                kv.setArray({
                    key: 'productList',
                    value: this.productsData
                });
            },
            getProducts:function (type) {
                var that = this;
                var orderBy;
                var desc;
                switch (this.productFilter.sortBy) {
                    case "default":
                        orderBy = '';
                        desc = '';
                        break;
                    case "lowToHigh":
                        orderBy = 'TWEEBUCK_PRICE';
                        desc = false;
                        break;
                    case "highToLow":
                        orderBy = 'TWEEBUCK_PRICE';
                        desc = true;
                        break;
                    default:
                        orderBy = '';
                        desc = '';
                }

                if(pages === 0){
                    loading('show');
                }else{
                    that.bottomLoading = true;
                }
                var userId = localStorage.getItem('userId');

                var params = {
                    currentpage: pages,
                    itemsperpage: 24,
                    LanguageCode: lan ==="es"?"en":lan,
                    ProductToTweebaaStatus: 'Approved',
                    viewerId: userId,
                    categoryLevel: 1,
                    categoryId: this.productFilter.CategoryId,
                    orderBy: orderBy,
                    desc: desc,
                    q: this.productFilter.key
                };
                if(this.currentType ==='presale'){
                    params.businessType = 1;
                    params.presaleStatusCode ='Approved';
                }else{
                    params.businessType = '';
                }
                // var paramStr = "currentpage=" + pages + "&itemsperpage=24&q=&LanguageCode=" + lan
                //     + "&ProductToTweebaaStatus=Approved&viewerId=" + userId
                //     + "&categoryLevel=1&categoryId=" + this.productFilter.CategoryId
                //     + "&orderBy=" + orderBy + "&desc=" + desc;
                var url = getBaseUrl()+ "api/v6/tweebaa/products?"+ $.param(params);

                this.isRequesting = true;
                   // console.log(url);
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(response));
                    $('.place-holder-load').hide();
                    that.isRequesting = false;
                    loading('hide');
                    that.bottomLoading = false;
                    // that.totalItems = response.data.TotalCount;
                    that.totalItems = response.data.Data.TotalCount;
                    // var list = response.data.Data;
                    var list = response.data.Data.ProdList;
                    if (pages === 0) {
                        that._initListData(list);
                    } else {
                        if (list.length !== 0) {
                            that._initListData(list);
                        }
                    }
                }).catch(function (error) {
                    console.error(JSON.stringify(error));
                });
            },
            progressColor:function(index){
                if(!this.productsData[index].BusinessType && this.productsData[index].BusinessType !== 1){
                    return
                }
                var end = moment(this.productsData[index].PreSaleInfo.PreSaleStopUtc).local();
                var now = moment();
                var endDate = end.diff(now, 'hours');
                var endMinute = end.diff(now, 'minutes');
                if(endDate>=0 && endDate < 24 && endMinute >0 ){
                    return 'bk-red'
                }else if(endMinute <= 0 ){
                    return 'bk-green'
                }
            },
            displayPresaleDate:function(index){
                if(!this.productsData[index].BusinessType && this.productsData[index].BusinessType !== 1){
                    return
                }
                var end = moment(this.productsData[index].PreSaleInfo.PreSaleStopUtc).local();
                var now = moment();
                var endDate = end.diff(now, 'days');
                var endHour = end.diff(now, 'hours');
                var endMinute = end.diff(now, 'minutes');
                var D = MSG.tProduct.day;
                var H = MSG.tProduct.hr;
                var M = MSG.tProduct.min;
                var Left = MSG.tProduct.left;
                if(endDate > 1 && endDate <= 5){
                    if(lan === 'zh'){
                        return '<span>'+ Left + endDate + D +'</span>'
                    }else{
                        return '<span>'+ endDate + ' ' + D + ' ' + Left +'</span>'
                    }

                }else if(endDate === 0 && endHour > 0 && endHour < 24){
                    if(lan === 'zh'){
                        return '<span class="text-red">'+ Left + endHour + H +'</span>'
                    }else{
                        return '<span class="text-red">'+ endHour + ' ' + H + ' ' + Left +'</span>'
                    }
                }
                else if(endDate === 0 && endHour === 0 && endMinute > 0){
                    if(lan === 'zh'){
                        return '<span class="text-red">'+ Left + endMinute + M +'</span>'
                    }else{
                        return '<span class="text-red">'+ endMinute + ' ' + M + ' ' + Left +'</span>'
                    }
                }
                else if(endMinute <= 0){
                    return '<span>'+ MSG.tProduct.presaleEnd +'</span>'
                }
            },
            openProdDetail:function (proId,index) {
                if (this.isScrolling === true) {
                    // console.log('Product Detail will not open !');
                    return;
                }
                if (token) {
                    openTabLayout('tweebaaProductDetail', this.message.tProduct.detailTitle, 'widget://html/tproducts/tw-prod-detail.html',{
                        productId: proId,
                        index: index
                    });
                } else {
                    openLogin();
                }
            },
            openCategory:function () {
                openTabLayout('categoryList','','widget://html/products/category-list.html');
            },
            openSearch: function(type) {
                var name, url;
                if (type === 'products') {
                    name = 'searchProduct';
                    url = 'widget://html/tproducts/products-search.html';
                } else {
                    name = 'searchEvaluation';
                    url = 'widget://html/tproducts/evaluation-search.html';
                }
                api.openWin({
                    name: name,
                    url: url,
                    bounces: true,
                    scrollToTop:true,
                    rect: {
                        x: 0,
                        y: 0,
                        w: api.screenWidth,
                        h: 'auto'
                    },
                    slidBackEnabled: false,
                    allowEdit: true,
                    bgColor: '#fff',
                    animation:{
                        type: "movein",
                        subType: "from_left",
                    }
                });
            },
            openTips:function () {
                openTabLayout("faqDetail",'','widget://html/access/faq-detail.html',{
                    id:16002
                })
            },
            buyNow:function(index){
                var param = {
                    id: this.productsData[index].Id,
                    toTweebaaId: this.productsData[index].LatestProductToTweebaa.ProductToTweebaaId,
                    price: this.productsData[index].TweebuckPrice,
                    shippingFee: this.productsData[index].shippingFee,
                    type:this.productsData[index].ProductType,
                    name: this.productsData[index].Name,
                    thumbnailUrl:this.productsData[index].FeaturedPicture.ThumbnailUrl || this.productsData[index].FeaturedPicture.PictureUrl,
                    index: index
                };
                openTabLayout("buyNow",this.message.tProduct.yourOrder,'widget://html/tproducts/buynow.html',param)
            },
            openCreateMenu:function(){
                $('.select-create, #Mask').toggleClass('show');
                var that = this;
                actionSheet([
                    {
                        text: MSG.tProduct.fromMyProduct,
                        callback: function () {
                            that.fromMyProduct();
                        }
                    },
                    {
                        text: MSG.tProduct.suggestNewProduct,
                        callback: function () {
                            that.suggestNewProduct();
                        }
                    }
                ])
            },

            add: function() {
                this.addSuggest();
                // if (this.currentType === 'products') {
                //     this.createProduct();
                // } else {
                //     this.addSuggest();
                // }
            },
            addSuggest: function() {
                if (token) {
                    if (this.currentType === 'products' || this.currentType === 'evaluation') {
                        taskService.check(function () {
                            openTabLayout("prepareSuggest", MSG.products.addSuggest, 'widget://html/products/prepare-suggest.html')
                        });
                    } else {
                        taskService.check(function () {
                            openTabLayout("addPresale", MSG.tProduct.presale, 'widget://html/products/add-presale.html');
                        });
                    }
                } else {
                    openLogin();
                }
            },
            createProduct:function(){
                openTabLayout('prepareAdd', MSG.tProduct.selectProductType, 'widget://html/products/prepare-add.html');
            },
            fromMyProduct:function(){
                openTabLayout("selectMyProduct",this.message.tProduct.selectProduct,'widget://html/tproducts/select-product.html')
            },
            suggestNewProduct:function(){
                openTabLayout("suggestProduct",this.message.tProduct.suggestProduct,'widget://html/products/suggest-product.html')
            },
            scrollNav:function (type) {
                var el = $('.tweebaa-pro-nav');
                var po = type ==='right' ? el.width():0;
                el.scrollLeft(po);
            },
            changeType: function(type) {
                this.currentType = type;
            },
            toggleTypeMenu:function(){

            },
            hideTypeMenu: function() {

            },
            getEvaluationName: function(nameObj) {
                var lang = this.getLangKey();
                if (lan === 'zh') {
                    if (nameObj['zh_CN']) {
                        return nameObj['zh_CN'];
                    } else {
                        return nameObj['en_US'];
                    }
                } else {
                    if (nameObj['en_US']) {
                        return nameObj['en_US'];
                    } else {
                        return nameObj['zh_CN'];
                    }
                }
            },
            // 评审相关方法
            addEvaluation:function () {
                openTabLayout('suggestProduct', this.message.tProduct.suggestProduct, 'widget://html/products/suggest-product.html');
            },
            _getNewListByMap: function(listMap, baseList) {
                var resultsTop = [];
                var resultsBottom = [];
                var item;
                for (var i = 0, len = baseList.length; i < len; i++) {
                    item = baseList[i];
                    if (listMap[item.Id]) {
                        resultsTop.push(item);
                    } else {
                        resultsBottom.push(item);
                    }
                }
                return resultsTop.concat(resultsBottom);
            },
            getEvaluationList: function () {
                var that = this;

                if (this.evaluationData.isLoading) {
                    return false;
                }

                var orderBy;
                var desc;
                switch (this.evaluationFilter.sortBy) {
                    case "default":
                        orderBy = '';
                        desc = true;
                        break;
                    case "lowToHigh":
                        orderBy = 'TWEEBUCK_PRICE';
                        desc = false;
                        break;
                    case "highToLow":
                        orderBy = 'TWEEBUCK_PRICE';
                        desc = true;
                        break;
                    default:
                        orderBy = '';
                        desc = true;
                }

                var param = {
                    currentpage: this.evaluationData.page,
                    itemsperpage: this.evaluationData.pageSize,
                    categoryId: this.evaluationFilter.CategoryId,
                    orderBy: orderBy,
                    desc: desc,
                    q: this.evaluationFilter.key
                };

                if (this.evaluationData.page === 1) {
                    loading('show');
                } else {
                    this.evaluationData.bottomLoading = true;
                }

                apiSuggest.get("/api-product/suggest/list/all", param).done(function (rep) {
                    loading('hide');
                    that.isLoading = false;

                    if (rep.code === 0) {
                        that.totalEvaluation = +rep.data.total;

                        var list = rep.data.list;

                        if (that.evaluationData.page === 1) {
                            that.evaluationData.isLoading = false;
                            if (list.length === 0) {
                                that.evaluationList = [];
                                that.evaluationData.haveData = false;
                            } else {
                                loading('hide');
                                // that.evaluationList = that._getNewListByMap(EVALUATION_LIST_MAP, list);
                                that.evaluationList = list;
                                kv.setArray({
                                    key: 'evaluationList',
                                    value: that.evaluationList
                                });
                            }
                        } else {
                            if (list.length === 0) {
                                that.evaluationData.haveData = false;
                            } else {
                                that.evaluationData.isLoading = false;
                                that.evaluationData.bottomLoading = false;
                                that.evaluationList = that.evaluationList.concat(list);
                            }
                        }

                        setTimeout(function () {
                            if (that.currentType === 'evaluation') {
                                if (guideService.check(guideService.GUIDE_EVALUATION.key) === false) {
                                    guideService.openGuidePage(guideService.GUIDE_EVALUATION.key);
                                }
                            }
                        });

                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (err) {
                    console.error(JSON.stringify(err));
                });
            },
            openEvaluationProduct: function (index) {
                var title = this.message.tProduct.detail;
                var id = this.evaluationList[index].id;
                openTabLayout('evaluationProduct', title, 'widget://html/discovery/evaluation-product.html', {
                    evaluationId: id,
                    evaluationData: this.evaluationList[index]
                });
            },
            openEvaluationVote: function ($event, index) {
                $event.stopPropagation();
                var title = this.message.tProduct.evaluation;
                var id = this.evaluationList[index].id;
                openTabLayout('evaluationDetail', title, 'widget://html/discovery/evaluation-detail.html', {
                    evaluationId: id,
                    evaluationData: this.evaluationList[index],
                    index: index
                });
            },
            openTycoon: function($event, Owner) {
                $event.stopPropagation();
                openUserTycoonPlace(Owner.Id, Owner.StoreName, Owner.ThumbnailAvatarUrl, 'tproducts-list');
            },
            openTycoonOfEvaluation: function ($event, userId, username, avatarUrl) {
                $event.stopPropagation();
                openUserTycoonPlace(userId, username, avatarUrl, 'tproducts-list');
            }
        }
    });


};

$('.to-top-btn i').on('click',function () {
    api.pageUp({
        top:true
    });
});

function toAdded(index) {
    tproductsList.productsData[index].AddedToTycoonPlace = true;
}

function refreshPage() {
    location.reload();
}
