var tProductDetail;
apiready = function () {
    //进入页面统计点
    var td = api.require('talkingData');
    td.onPageStart({pageName:'推吧产品详情'});
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    api.setNavBarAttr({
        rightButtons: [{
            iconPath: 'widget://image/share0.png',
            color: '#a1a1a1',
            fontSize: '18'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        //console.log(JSON.stringify(ret));
        if(ret.type ==='right'){
            tProductDetail.preShare();
        }else{
            back('推吧产品详情');
        }
    });

    var prodId = api.pageParam.productId;
    //console.log('prodId: ' + prodId);

    // $('.addShopping-bar').height((api.safeArea.bottom + 40) + 'px');
    var kv = api.require('snKVStorage');
    var hasCache = kv.has({
        key: 'TweebaaProdDetail'
    });
    var TWPORDDETAIL = {};
    var cacheProductData;
    if(hasCache){
        TWPORDDETAIL = kv.getObject({
            key: 'TweebaaProdDetail',
        });
        cacheProductData = TWPORDDETAIL['twpd' + prodId];
        // console.log(JSON.stringify(cacheProductData);
    }

    // 1. hasCache = null; cacheProductData = null;
    // hasCache = null;
    // cacheProductData = null;
    // 2. hasCache != null; cacheProductData = null;
    // cacheProductData = null;
    // 3. hasCache != null; cacheProductData != null;

    api.setWinAttr({
        bounces: false,
        slidBackEnabled:false,
        allowEdit: false
    });

    var taskService = new TaskService(TASK_CODE.GROUP_PERSON_PROFILE);

    var appleCheck = api.getGlobalData({
        key: 'appleCheck'
    });

    tProductDetail = new Vue({
        el: '#tProductDetail',
        data: function () {
            return {
                appleCheck: appleCheck,
                productData: cacheProductData ? cacheProductData : '',
                switchImg: true,
                isTranslate:false,
                shortDescriptionText:'',
                fullDescriptionText:'',
                imageShow:false,
                userId:localStorage.getItem('userId'),
                pics:[],
                now: null,
                endTime: null,
                countDownTimeId: null,
                leftTime: '',
                relatedCurrentList: [],
                assessData: null,
                presaleStatus:'',
                shipToCountries:'',
                completedConditions:'',
                conditions:"",
                message:MSG,
            };
        },
        filters: {
            fixed1:function (value) {
                return Number(value).toFixed(1);
            },
            fixed2:function (value) {
                var v = value || 0;
                return Number(v).toFixed(2);
            },
            formatTime: function (value) {
                if(value){
                    return moment.utc(value).local().format('YYYY-MM-DD HH:mm');
                }else{
                    return MSG.general.unlimited;
                }
            },
            deliveryDate:function (value) {
                if(value){
                    return moment.utc(value).local().format('YYYY-MM');
                }else{
                    return MSG.tips.notSure;
                }
            },
            presaleDate:function (value) {
                return moment.utc(value).local().format('MM-DD');
            },
            presaleTime:function (value) {
                return moment.utc(value).local().format('HH:mm');
            },
            formatAddTime: function (value) {
                var m1 = moment.utc();
                var m2 = moment.utc(value);
                var du = moment.duration(m1 - m2, 'ms'),
                    years = du.get('years'),
                    months = du.get('months'),
                    days = du.get('days'),
                    hours = du.get('hours'),
                    mins = du.get('minutes'),
                    ss = du.get('seconds');
                if (years > 0) {
                    return MSG.tips.yearAgo;
                } else {
                    if (months >= 3) {
                        return MSG.tips.monthsAgo3;
                    } else if (months >= 2 && months < 3) {
                        return MSG.tips.monthsAgo2;
                    } else if (months >= 1 && months < 2) {
                        return MSG.tips.monthAgo;
                    } else {
                        if (days >= 3) {
                            return MSG.tips.daysAgo3;
                        } else if (days >= 2 && days < 3) {
                            return MSG.tips.daysAgo2;
                        } else if (days >= 1 && days < 2) {
                            return MSG.tips.dayAgo;
                        } else {
                            if (hours > 0) {
                                return MSG.tips.hrsAgo;
                            } else {
                                return MSG.tips.minAgo;
                            }
                        }
                    }
                }
            }
        },
        watch: {
            now: function(newVal, oldVal) {
                if (newVal && this.endTime) {
                    var m1 = newVal;
                    var m2 = this.endTime;

                    var DIFF = m2.diff(m1, 'seconds');

                    var du = moment.duration(DIFF, 'seconds'),
                        day = m2.diff(m1, 'days'),
                        hours = prefixInteger(du.get('hours'),2),
                        mins = prefixInteger(du.get('minutes'),2),
                        ss = prefixInteger(du.get('seconds'),2);
                    if (day<=0 && hours<=0 && mins<=0 && ss<=0) {
                        this.productData.BusinessType = 0;
                        window.clearInterval(this.countDownTimeId);
                        //this.getProductDetail(this.prodId);
                    }else {
                        var span = '<span class="p-2 bk-white text-red" style="border-radius: 2px">';
                        this.leftTime = span + day + '</span>' +
                            '<span class="p-2"> ' + MSG.freeProduct.day +'</span>' + span + hours + '</span>:' + span + mins + '</span>:'+ span + ss +'</span>';
                    }
                }
                function prefixInteger(num, n) {
                    return (Array(n).join('0') + num).slice(-n);
                }
            }
        },
        mounted: function () {
            this.getProductDetail(prodId);
            this.getProductAssess();
            this._initCache();
            //this.sendTime(); 产品库无需计算时间
        },
        methods:{
            playPicture: function(innerIndex, pictures) {
                var pics = [];
                $.map(pictures, function (item, index) {
                    pics.push(item.DownloadUrl);
                });
                var UIPhotoViewer = api.require('UIPhotoViewer');
                UIPhotoViewer.open({
                    images: pics,
                    placeholderImg: 'widget://image/lost_images.jpg',
                    bgColor: '#000',
                    activeIndex: innerIndex,
                    zoomEnabled: true,
                    gestureClose: true
                }, function(Ret, err) {
                    if (Ret.eventType === 'click' ) {
                        UIPhotoViewer.close();
                    }
                });
            },
            playVideo: function(url) {
                playVideo(url);
            },
            toTranslate: function(item) {
                if (item.isTranslate === false) {
                    loading('show');
                    item.isTranslate = true;
                    translate(item.comment, function (result) {
                        loading('hide');
                        item.commentText = result;
                    });
                } else {
                    item.isTranslate = false;
                    item.commentText = item.comment;
                }
            },
            _formatList: function(list) {
                $.map(list, function (item, index) {
                    item.isTranslate = false;
                    item.commentText = item.comment;
                });
                return list;
            },
            getProductAssess: function() {
                apiAssess.get('/v1/api/evaluate/get/' + prodId).done(function (rep) {
                    if (rep.code === 0) {
                        var assessData = rep.data;
                        assessData.list = this._formatList(assessData.list);
                        this.assessData = assessData;
                    } else {
                        api.toast({
                            msg: rep.responseJSON.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }.bind(this));
            },
            toLikeAssess: function(assess) {
                var param = {
                    "evaluateId": assess.evaluateId,
                    "productId": prodId,
                    "userId": this.myID
                };
                loading('show');
                apiAssess.post('/v1/api/evaluate/like', param).done(function (rep) {
                    loading('hide');
                    if (rep.code === 0) {
                        assess.likeNum++;
                        api.toast({
                            msg: MSG.general.success,
                            duration: 2000,
                            location: 'middle'
                        });
                    } else {
                        loading('hide');
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            },
            goAssessList: function () {
                openTabLayout('product-assess-list', MSG.assess.title, 'widget://html/products/product-assess-list.html', {
                    prodId: prodId,
                    average: this.assessData.average,
                    totalCount: this.assessData.totalCount
                });
            },
            _initCache: function() {
                var that = this;

                // 如果缓存有数据，那么直接绑定scroll事件
                if (cacheProductData) {

                    // 初始化轮播
                    setTimeout(function () {
                        initialize();
                    }, 0);

                    // 如果是限时免费产品，那么启动倒计时
                    if (cacheProductData.BusinessType === 2 && cacheProductData.FreeSaleInfo.FreeSaleStopUtc) {
                        that.endTime = moment.utc(cacheProductData.FreeSaleInfo.FreeSaleStopUtc);
                        that._doRemainingTime();
                    }
                    // 最近添加
                    // if (cacheProductData.LatestProductToTweebaa) {
                    //     this.getRelatedPosts(cacheProductData.LatestProductToTweebaa.ProductToTweebaaId, function () {
                    //         setTimeout(function () {
                    //             that._initScroll();
                    //         }, 0);
                    //     });
                    // } else {
                    //     setTimeout(function () {
                    //         that._initScroll();
                    //     }, 0);
                    // }

                    setTimeout(function () {
                        that._initScroll();
                    }, 0);
                }
            },
            _initScroll: function() {
                var that = this;

                var t1 = 0;
                var timer = null; // 定时器

                var $returnTop = $("#returnTop");
                var clienHeight = api.screenHeight;

                //当点击跳转链接后，回到页面顶部位置
                $returnTop.click(function(){
                    //$('body,html').animate({scrollTop:0},1000);
                    if ($('html').scrollTop()) {
                        $('html').animate({ scrollTop: 0 }, 'normal');
                        return false;
                    }
                    $('body').animate({ scrollTop: 0 }, 'normal');
                    return false;
                });

                // scroll监听
                $(document).scroll(function() {
                    clearTimeout(timer);
                    t1 = document.documentElement.scrollTop || document.body.scrollTop;
                    // console.log('t1 ===== ' + t1);

                    if (t1 > clienHeight) {
                        $returnTop.fadeIn(800);
                    } else {
                        $returnTop.fadeOut(800);
                    }

                });

            },
            /**
             * 展示更多相关   里面是关注列表？
             */
            // toggleShowMoreRalated: function() {
            //     openTabLayout("sellerList", this.message.tProduct.relatedLabel, "widget://html/tproducts/seller-list.html", {
            //         sellerList: relatedList
            //     });
            // },
            // 针对有截止时间的活动，需要计算剩余时间
            _doRemainingTime: function() {
                var that = this;
                var nowDate = moment().utc();
                if (nowDate >= this.endTime) {
                    return;
                }
                this.now = moment().utc();

                //定时更新当前时间
                this.countDownTimeId = window.setInterval(function() {
                    that.now = moment.utc();
                },1000);
            },
            /**
             * 关联最近添加的推主列表
             */
            getRelatedPosts: function (productToTweebaaId, callback) {
                var that = this;
                var url = getBaseUrl() + 'api/v2/tweebaa-product/tycoon/list?ProductToTweebaaID=' + productToTweebaaId;
                getAxois(url,"GET",{}).then(function (response) {
                    var list = response.data;
                    this.relatedList = list.reverse();
                    that.relatedCurrentList = list.slice(0, 3);
                    callback();
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error));
                });
            },
            openSellerPlace:function(id,StoreName,AvatarUrl){
                openUserTycoonPlace(id,StoreName,AvatarUrl);
            },
            getProductDetail: function (prodId) {
                var that = this;
                var userId = localStorage.getItem('userId') || '';
                // var url = getBaseUrl() + "api/users/"+ userId +"/products/" + prodId+'?needfreeOffer=true&needProductType=true&productToTweebaaDetailRequired=true&productToTweebaaLogRequired=true&LanguageCode='+lan;
                //console.log(url);
                var url = getBaseUrl() + "api/v6/product?viewerId="+ userId + "&productId=" + prodId +"&LanguageCode=" + lan ;

                getAxois(url,"GET",{}).then(function (response) {
                     //console.log(JSON.stringify(response));
                    var newRep = response.data.Data;

                    that.productData = newRep;

                    // 判断预售状态
                    var info = that.productData.PreSaleInfo;
                    if(info){
                        var startTime = moment(info.PreSaleStartUtc ).local().format('YYYY-MM-DD HH:mm:ss');
                        var endTime = moment(info.PreSaleStopUtc ).local().format('YYYY-MM-DD HH:mm:ss');
                        var now = moment().format('YYYY-MM-DD HH:mm:ss');
                        if(moment(now).isBefore(endTime, 'second') && moment(now).isAfter(startTime, 'second')){
                            that.presaleStatus = 'doing'
                        }
                        else if(moment(now).isAfter(endTime, 'second') && info.PreSaleEndQuantity >= info.PreSaleTargetQuantity ){
                            that.presaleStatus = 'pass'
                        }else if(moment(now).isAfter(endTime, 'second') && info.PreSaleEndQuantity < info.PreSaleTargetQuantity ){
                            that.presaleStatus =  'fail'
                        }

                        //输出发货国家
                        for(l = 0; l < callingCode.length; l++){
                            if(info.CountryList.indexOf(callingCode[l].code) !== -1){
                                that.shipToCountries = that.shipToCountries + " " + callingCode[l][lan];
                            }
                        }

                    }

                    var Pics = that.productData.Pictures;
                    for (i = 0; i < Pics.length; i++) {
                        that.pics.push(Pics[i].PictureUrl);
                    }

                    var datas = {};
                    if(hasCache){
                        datas = kv.getObject({
                            key: 'TweebaaProdDetail',
                        });
                    }
                    datas['twpd' + prodId] = response.data.Data;
                    kv.setObject({
                        key: 'TweebaaProdDetail',
                        value: datas
                    });

                    if (!cacheProductData) {
                        cacheProductData = newRep;
                        that._initCache();
                    } else {
                        // 最新数据 !== 缓存数据
                        if (isObjectValueEqual(newRep, cacheProductData) === false) {
                            cacheProductData = newRep;
                            that._initCache();
                        }
                    }


                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error));
                });
            },
            switchImgVideo:function (type) {
                this.switchImg = type === 'img';
                setTimeout(function () {
                    initialize();
                }, 0);
            },
            openPicture:function(index){
                var that = this;
                // console.log(index);
                var UIPhotoViewer = api.require('UIPhotoViewer');
                UIPhotoViewer.open({
                    images: that.pics,
                    placeholderImg: 'widget://image/lost_images.jpg',
                    bgColor: '#000',
                    activeIndex:index,
                    zoomEnabled:true,
                    gestureClose:true
                }, function(Ret, err) {
                    if (Ret.eventType === 'click' ) {
                        UIPhotoViewer.close();
                    }
                });
            },
            preShare: function() {
                var that = this;
                actionSheet([
                    {
                        text: MSG.general.shareto,
                        callback: function () {
                            that.openShareBar();
                        }
                    },
                    {
                        text: MSG.general.repostChat,
                        callback: function () {
                            that.toRepostChatPage();
                        }
                    }
                ]);
            },
            toRepostChatPage: function() {
                var title = MSG.tProduct.shareTitle;
                var content = this.productData.Name.replace(REG_SHARE_FILTER," ");
                if (content && content.length > 50) {
                    content = content.slice(0,50) + '...';
                }
                var thumbnail = this.productData.Pictures && this.productData.Pictures[0]
                    && (this.productData.Pictures[0].ThumbnailUrl || this.productData.Pictures[0].PictureUrl);
                openShareToChats({
                    title: title,
                    description: content,
                    imageUrl: thumbnail,
                    extra: {
                        textType: 'product-showcase',
                        productId: api.pageParam.productId,
                        index: api.pageParam.index,
                        userId: this.productData.Owner.Id,
                        userPortrait: this.productData.Owner.ThumbnailAvatarUrl,
                        storeName: this.productData.Owner.StoreName
                    }
                });
            },
            openShareBar:function(){
                var title = MSG.tProduct.shareTitle;
                var content   = this.productData.Name.replace(REG_SHARE_FILTER," ");
                if(content && content.length>50){
                    content = content.slice(0,50) + '...';
                }
                var ShareUrl = shareH5Host + '/html/porduct.html?prodid=' + this.productData.Id
                    + '&userid=' + this.productData.Owner.Id
                    + "&shareid="+localStorage.getItem('userName')
                    + '&page=tpd';
                new OpenShareBox(ShareUrl,title,content,this.productData.Owner.UserName,this.productData.ProductGuid,'prod',this.productData.Owner.ThumbnailAvatarUrl,this.productData.ProductGuid);
            },
            showTranslation:function(){
                var that = this;
                if(that.fullDescriptionText){
                    that.isTranslate = true;
                    return;
                }
                var content = that.productData.FullDescription.replace(/<[^>]+>/g,"").replace(/&nbsp;/ig, "");

                loading('show');
                var url = getBaseUrl() + '/api/v2/translation';
                var paramStr1 = {
                    "q": content,
                    "LanguageCode": lan,
                };
                getAxois(url, "POST", paramStr1).then(function (response) {
                    that.fullDescriptionText = response.data.TranslatedText;
                    loading('hide');
                    that.isTranslate = true;
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@!@!@!@!@!@!@!@');
                });
            },
            originalText:function(){
                this.isTranslate = false;
            },
            chatToUser: function () {
                var chatID = localStorage.getItem('chatID');
                if (chatID) {
                    var userinfo = this.productData.Owner;
                    var userId = userinfo.UserName + '@new';
                    //console.log(JSON.stringify(userinfo));
                    openChatPage({
                        targetId: userId,
                        userId: userinfo.Id,
                        userName: userinfo.StoreName,
                        userPortrait: userinfo.ThumbnailAvatarUrl,
                        conversationType: 'PRIVATE',
                        isTop: false
                    });
                } else {
                    openLogin();
                }
            },
            addToMyProducts:function () {
                var that = this;
                //console.log(JSON.stringify(that.productData));
                taskService.check(function () {
                    var userId = localStorage.getItem('userId');
                    openTabLayout("addShowcase", that.message.tProduct.addtoMyStore, "widget://html/tproducts/add-showcase.html", {
                        toTweebaaId: that.productData.LatestProductToTweebaa.ProductToTweebaaId,
                        userId: userId,
                        index: api.pageParam.index,
                        id: that.productData.Id,
                        productGuid: that.productData.ProductGuid,
                        price: that.productData.TweebuckPrice,
                        shippingFee: that.productData.ShippingFee,
                        type: that.productData.ProductType,
                        name: that.productData.Name,
                        thumbnailUrl: that.productData.Pictures && that.productData.Pictures[0]
                            && (that.productData.Pictures[0].ThumbnailUrl || that.productData.Pictures[0].PictureUrl)
                    });
                });
            },
            toTycoonplace:function(){
                var that = this;
                if(that.productData.ProdInviter){
                    openUserTycoonPlace(that.productData.ProdInviter.Id,that.productData.ProdInviter.StoreName,that.productData.ProdInviter.ThumbnailAvatarUrl);
                }else{
                    openUserTycoonPlace(that.productData.Owner.Id,that.productData.Owner.StoreName,that.productData.Owner.ThumbnailAvatarUrl);
                }
            },
            alreadyMyProducts:function(){
                api.toast({
                    msg: MSG.tProduct.addedMyStore,
                    duration: 2000,
                    location: 'middle'
                });
            },
            showTivProfit:function(){
                openTabLayout("tweebaaProfitTips",'','widget://html/access/tips.html',{
                    key:'tips',
                    text:'tweebaaProfitTips'
                })
            },
            closePage:function () {
                api.closeWin();
            },
            /**
             * 立即购买
             * 始终可以购买，不分数字产品和实体产品
             */
            buyNow:function(){
                var that = this;
                if(this.appleCheck){ //only for check
                    var paypal = api.require('paypal');

                    paypal.pay({
                        currency: 'USD',
                        price: this.productData.TweebuckPrice,
                        description: this.productData.Name + ' '+ MSG.general.quantity +':' + 1 + ' ID:' + that.productData.Id ,
                        mode: 'production'
                    }, function(ret) {
                        that.loading = false;
                        if (ret.state === 'success') {
                            that._doBuySuccess(that.productData.Id);
                        }else{
                            alert(MSG.payment.paymentError);
                        }
                    });

                    return;
                }

                var param = {
                    id: this.productData.Id,
                    toTweebaaId: this.productData.LatestProductToTweebaa.ProductToTweebaaId,
                    price: this.productData.TweebuckPrice,
                    shippingFee: this.productData.ShippingFee,
                    type: this.productData.ProductType,
                    name: this.productData.Name,
                    thumbnailUrl: this.productData.Pictures && this.productData.Pictures[0]
                        && (this.productData.Pictures[0].ThumbnailUrl || this.productData.Pictures[0].PictureUrl)
                };
                openTabLayout("buynow", this.message.tProduct.yourOrder, 'widget://html/tproducts/buynow.html', param);
            },
        }
    });

};
//初始化图片显示
function initialize() {
    var mySwiper = new Swiper ('#proDetailPhoto', {
        direction: 'horizontal',
        loop: false,
        initialSlide :0 ,
        pagination: {
            el: '.swiper-pagination',
            type: 'fraction'
        }
    });

    var winWidth = api.winWidth;
    $('#proDetailPhoto').height(winWidth - 30);
    $('.videoDisplay').height(winWidth - 36);
    var service = $('#serviceTag');
    if(service){
        var text = '<span class="pl-4 pt-2">'+ MSG.general.contactUs +'</span>';
        var template = '<span class="text-blue" onclick="window.location.href=\'mailto:service@tweebaa.com\'" style="vertical-align:middle;">' +
            '<img src="../../image/logo.png" style="width: 30px; height: 30px;vertical-align:middle;" alt="">' +
            text+
            '</span>';
        service.html(template);
    }
}

// 深度比对两个对象是否相等
function isObjectValueEqual(a, b) {
    var aProps = Object.getOwnPropertyNames(a);
    var bProps = Object.getOwnPropertyNames(b);
    if (aProps.length != bProps.length) {
        return false;
    }
    for (var i = 0; i < aProps.length; i++) {
        var propName = aProps[i];

        var propA = a[propName];
        var propB = b[propName];
        if ((typeof (propA) === 'object')) {
            if (this.isObjectValueEqual(propA, propB)) {
                return true
            } else {
                return false
            }
        } else if (propA !== propB) {
            return false
        } else { }
    }
    return true
}

//更改按钮状态
function changeBtnStatus() {
    tProductDetail.productData.AddedToTycoonPlace = true
}
