var tproductsRrsult;
apiready = function () {

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    var pages =0;

    api.setRefreshHeaderInfo({
        loadingImg:'widget://image/refresh-logo.png',
        bgColor: '#fff',
        textColor: '#000',
        textDown: MSG.tips.pullDownRefresh,
        textLoading: MSG.tips.refreshing,
        showTime: false,
        textUp:  MSG.tips.releaseRefresh
    }, function (ret, err) {
        pages = 0;
        tproductsRrsult.productsData = [];
        tproductsRrsult.getProducts(0);
    });

    backListener();

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 500            //设置距离底部多少距离时触发，默认值为0，数字类型
        }
    }, function (ret, err) {
        if(!tproductsRrsult.bottomLoading && tproductsRrsult.totalItems > tproductsRrsult.productsData.length){
            pages++;
            tproductsRrsult.getProducts();
        }
    });

    // 更换搜索词
    api.addEventListener({
        name: 'changeProductSearchKey'
    }, function(ret, err){
        tproductsRrsult.productFilter.key = ret.value.key;
        tproductsRrsult.refreshProduct();
    });

    var ROLE_PRODUCT_KEY = 'ROLE_PRODUCT';

    tproductsRrsult = new Vue({
        el: '#tproductsRrsult',
        mounted: function () {
            var lang = lan ==="es"?"en":lan;
            if (api.pageParam.category) {
                this.productFilter.CategoryId = api.pageParam.category.id;
                this.productFilter.currentCategory = api.pageParam.category[lang];
            }
            if (api.pageParam.Q) {
                this.productFilter.key = api.pageParam.Q;
            }

            this.getProducts();

            this._initScroll();

            // 点击页面，隐藏排序菜单
            var that = this;
            $(document).click(function () {
                that.hideSortBy();
            });
        },
        data: {
            productsData: [],
            bottomLoading:false,
            totalItems:'',
            role: localStorage.getItem(ROLE_PRODUCT_KEY) ? localStorage.getItem(ROLE_PRODUCT_KEY) : 'sell',
            noProduct:false,
            isScrolling: false,
            productFilter: {
                key: '',
                CategoryId: '',
                currentCategory: '',
                sortByMenu: false,
                sortBy: '',
            },
            message: MSG
        },
        filters: {
            fixed2:function (value) {
                var v = value || 0;
                return Number(v).toFixed(2);
            },
        },
        methods:{
            _initScroll: function() {
                var that = this;

                var t1 = 0;
                var t2 = 0;
                var timer = null; // 定时器

                var $returnTop = $("#returnTop");
                var clienHeight = api.screenHeight;

                //当点击跳转链接后，回到页面顶部位置
                $returnTop.click(function(){
                    //$('body,html').animate({scrollTop:0},1000);
                    if ($('html').scrollTop()) {
                        $('html').animate({ scrollTop: 0 }, 'normal');
                        return false;
                    }
                    $('body').animate({ scrollTop: 0 }, 'normal');
                    return false;
                });

                // scroll监听
                $(document).scroll(function() {
                    that.isScrolling = true;
                    clearTimeout(timer);
                    timer = setTimeout(isScrollEnd, 500);
                    t1 = document.documentElement.scrollTop || document.body.scrollTop;
                    // console.log('t1 ===== ' + t1);

                    if (t1 > clienHeight) {
                        $returnTop.fadeIn(800);
                    } else {
                        $returnTop.fadeOut(800);
                    }

                });

                function isScrollEnd() {
                    t2 = document.documentElement.scrollTop || document.body.scrollTop;
                    // console.log('t2 ===== ' + t2);
                    if(t2 === t1){
                        // console.log('滚动结束了');
                        that.isScrolling = false;
                    }
                }

            },
            refreshProduct: function() {
                loading('show');
                pages = 0;
                this.getProducts();
            },
            closeProductKey: function() {
                this.productFilter.key = '';
                this.refreshProduct();
            },
            closeProductSortBy: function() {
                this.productFilter.sortBy = '';
                this.refreshProduct();
            },
            closeProductCategory: function() {
                this.productFilter.CategoryId = '';
                this.productFilter.currentCategory = '';
                this.refreshProduct();
            },
            changeRole:function(type){
                this.role = type;
                localStorage.setItem(ROLE_PRODUCT_KEY, type);
            },
            openCategoryPage:function(){
                openTabLayout('categoryPage', this.message.tProduct.all, 'widget://html/frame/select-category.html', {
                    fromPage: 'twProdResult'
                });
            },
            openSortBy:function($event){
                $event.stopPropagation();
                this.productFilter.sortByMenu = !this.productFilter.sortByMenu;
            },
            hideSortBy: function() {
                this.productFilter.sortByMenu = false;
            },
            changeProductSortBy:function($event,type){
                var that = this;
                that.productFilter.sortByMenu = false;
                $event.stopPropagation();
                if( type !== that.productFilter.sortBy){
                    that.productFilter.sortBy = type;
                    this.refreshProduct();
                }
            },
            changeCategory:function(category){
                var lang = lan ==="es"?"en":lan;
                this.productFilter.CategoryId = category.id;
                this.productFilter.currentCategory = category[lang];
                this.refreshProduct();
            },
            _initListData: function(list) {
                if (list.length > 0) {
                    var currency = lan === 'zh' ? '￥' : '$';
                    var item;
                    for (var i = 0, len = list.length; i < len; i++) {
                        item = list[i];
                        // 最大销售奖励
                        if (item.LatestProductToTweebaa) {
                            var value = item.LatestProductToTweebaa.MaxAvailableTweebuckProfit;
                            item.LatestProductToTweebaa.MaxAvailableTweebuckProfitText = getExchangeText(value);
                        }
                        // 价格
                        item.TweebuckPriceText = getExchangeText(item.TweebuckPrice);
                    }
                }
            },
            getProducts:function () {
                var that = this;
                var orderBy;
                var desc;
                switch (this.productFilter.sortBy) {
                    case "default":
                        orderBy = '';
                        desc = '';
                        break;
                    case "lowToHigh":
                        orderBy = 'TWEEBUCK_PRICE';
                        desc = false;
                        break;
                    case "highToLow":
                        orderBy = 'TWEEBUCK_PRICE';
                        desc = true;
                        break;
                    default:
                        orderBy = '';
                        desc = '';
                }

                if(pages===0){
                    loading('show');
                }else{
                    that.bottomLoading = true
                }
                var userId = localStorage.getItem('userId');

                var params = {
                    currentpage: pages,
                    itemsperpage: 24,
                    LanguageCode: lan ==="es"?"en":lan,
                    ProductToTweebaaStatus: 'Approved',
                    viewerId: userId,
                    q: this.productFilter.key,
                    categoryLevel: 1,
                    categoryId: that.productFilter.CategoryId,
                    orderBy: orderBy,
                    desc: desc
                };

                // var url = getBaseUrl()+ "api/v6/tweebaa/products/?currentpage="+ pages +"&itemsperpage=24&q="+ q +"&LanguageCode="+ lan +"&ProductToTweebaaStatus=Approved&viewerId="+userId +"&categoryLevel=3&categoryId="+ that.categoryId ;
                var url = getBaseUrl()+ "api/v6/tweebaa/products?" + $.param(params);

                api.refreshHeaderLoadDone();
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(response));
                    loading('hide');
                    if(pages ===0 ){
                        that.productsData =[];
                    }
                    that.bottomLoading = false;
                    that.totalItems = response.data.Data.TotalCount;
                    // var list = response.data.Data;
                    var list = response.data.Data.ProdList;
                    if(that.totalItems === 0 && pages ===0 ){
                        that.noProduct = true;
                    }
                    $('#placeHolderLoad').hide();
                    if (list.length !== 0) {
                        that._initListData(list);
                        that.productsData = that.productsData.concat(list);
                    }

                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error));
                });
            },
            buyNow:function(index){
                var param = {
                    id: this.productsData[index].Id,
                    toTweebaaId: this.productsData[index].LatestProductToTweebaa.ProductToTweebaaId,
                    price: this.productsData[index].TweebuckPrice,
                    shippingFee: this.productsData[index].shippingFee,
                    type:this.productsData[index].ProductType,
                    name: this.productsData[index].Name,
                    thumbnailUrl:this.productsData[index].FeaturedPicture.ThumbnailUrl || this.productsData[index].FeaturedPicture.PictureUrl
                };
                openTabLayout("buyNow",this.message.tProduct.yourOrder,'widget://html/tproducts/buynow.html',param)
            },
            openSearch:function () {
                api.openWin({
                    name: 'searchProduct',
                    url: 'widget://html/tproducts/products-search.html',
                    bounces: true,
                    scrollToTop:true,
                    rect: {
                        x: 0,
                        y: 0,
                        w: api.screenWidth,
                        h: 'auto'
                    },
                    slidBackEnabled:false,
                    allowEdit:true,
                    bgColor: '#fff',
                    animation:{
                        type:"movein",
                        subType:"from_left",
                    },
                });

            },
            openProdDetail:function (proId) {
                if (this.isScrolling === true) {
                    return;
                }
                openTabLayout('tweebaaProductDetail','','widget://html/tproducts/tw-prod-detail.html',{productId:proId});
            },
            openCategory:function () {
                openTabLayout('categoryList','','widget://html/products/category-list.html');
            }
        }
    });

};

