/*
 * Tweebaa JavaScript Library
 * Copyright (c) 2018 tweebaa.com
 */

var ua = navigator.userAgent.toLowerCase();
if (ua.indexOf('android') >= 0) {
    $('html').css({
        fontSize: REM_ANDROID_FONTSIZE + '%'
    });
}

function getRightPxFromFontSize(pxValue) {
    if (api.systemType === 'ios') {
        return pxValue;
    } else {
        return pxValue * REM_ANDROID_FONTSIZE / REM_BASE_FONTSIZE;
    }
}

//Base 64 encode function:
var Base64 = {
    _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=", encode: function (e) {
        var t = "";
        var n, r, i, s, o, u, a;
        var f = 0;
        e = Base64._utf8_encode(e);
        while (f < e.length) {
            n = e.charCodeAt(f++);
            r = e.charCodeAt(f++);
            i = e.charCodeAt(f++);
            s = n >> 2;
            o = (n & 3) << 4 | r >> 4;
            u = (r & 15) << 2 | i >> 6;
            a = i & 63;
            if (isNaN(r)) {
                u = a = 64
            } else if (isNaN(i)) {
                a = 64
            }
            t = t + this._keyStr.charAt(s) + this._keyStr.charAt(o) + this._keyStr.charAt(u) + this._keyStr.charAt(a)
        }
        return t
    }, decode: function (e) {
        var t = "";
        var n, r, i;
        var s, o, u, a;
        var f = 0;
        e = e.replace(/[^A-Za-z0-9+/=]/g, "");
        while (f < e.length) {
            s = this._keyStr.indexOf(e.charAt(f++));
            o = this._keyStr.indexOf(e.charAt(f++));
            u = this._keyStr.indexOf(e.charAt(f++));
            a = this._keyStr.indexOf(e.charAt(f++));
            n = s << 2 | o >> 4;
            r = (o & 15) << 4 | u >> 2;
            i = (u & 3) << 6 | a;
            t = t + String.fromCharCode(n);
            if (u != 64) {
                t = t + String.fromCharCode(r)
            }
            if (a != 64) {
                t = t + String.fromCharCode(i)
            }
        }
        t = Base64._utf8_decode(t);
        return t
    }, _utf8_encode: function (e) {
        e = e.replace(/rn/g, "n");
        var t = "";
        for (var n = 0; n < e.length; n++) {
            var r = e.charCodeAt(n);
            if (r < 128) {
                t += String.fromCharCode(r)
            } else if (r > 127 && r < 2048) {
                t += String.fromCharCode(r >> 6 | 192);
                t += String.fromCharCode(r & 63 | 128)
            } else {
                t += String.fromCharCode(r >> 12 | 224);
                t += String.fromCharCode(r >> 6 & 63 | 128);
                t += String.fromCharCode(r & 63 | 128)
            }
        }
        return t
    }, _utf8_decode: function (e) {
        var t = "";
        var n = 0;
        var r = c1 = c2 = 0;
        while (n < e.length) {
            r = e.charCodeAt(n);
            if (r < 128) {
                t += String.fromCharCode(r);
                n++
            } else if (r > 191 && r < 224) {
                c2 = e.charCodeAt(n + 1);
                t += String.fromCharCode((r & 31) << 6 | c2 & 63);
                n += 2
            } else {
                c2 = e.charCodeAt(n + 1);
                c3 = e.charCodeAt(n + 2);
                t += String.fromCharCode((r & 15) << 12 | (c2 & 63) << 6 | c3 & 63);
                n += 3
            }
        }
        return t
    }
};


function postApi(url, method, paramStr, token, contentTypeStr,node) {
    var defer = $.Deferred();
    var dataParam;
    var param = JSON.stringify(paramStr);
    var head;
    if (token === null) {
        head = {"Authorization": "Bearer "};
    } else if (node === 'node') {
        head = {"apikey": token};
    } else {
        head = {"Authorization": "Bearer " + token};
    }
    if (contentTypeStr === null) {
        contentTypeStr = "application/x-www-form-urlencoded; charset=UTF-8";
        dataParam = paramStr;
    } else {
        contentTypeStr = "application/json; charset=utf-8";
        dataParam = param;
    }
    $.ajax({
        contentType: contentTypeStr,
        method: method,
        url: url,
        async: true,
        data: dataParam,
        dataType: 'json',
        headers: head
    }).done(function (data) {
        defer.resolve(data);
    }).fail(function (err) {
        defer.resolve(err);
    });
    return defer;
}

function getAxois(url,method,perms) {
    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    }) || localStorage.getItem('access_token') || '';
    return  axios({
        method:method,
        url:url,
        data:perms,
        headers:{
            "Authorization":"Bearer " + token
        }
    })
}

function getNodeAxois(url,method,perms) {
    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    }) || localStorage.getItem('access_token') || '';

    return  axios({
        method:method,
        url:url,
        data:perms,
        headers:{
            "apikey":token
        }
    })
}
function kc() {
    var d = moment(new Date()).utc().format('YYYYMMDDTHH');
    var strK = selectedCallingCode + phoneNumber.trim() + Code+d;
    return md5(strK);
}
//获取当前用户使用API
function getBaseUrl() {
    // return 'http://njuser2.tweebaa.cn/'; //网关地址
    // return 'http://api-dev.tycoonplace.com/';
    // return "https://api.tweebaa.cn/";
    if (SERVER_HOSTS.dev === false) {
        return SERVER_HOSTS.BASE.PROD;
    } else {
        return SERVER_HOSTS.BASE.TEST;
    }
    // if (server === 'CN') {
    //     return "https://api.tweebaa.cn/"
    // } else  {
    //     return "https://api.tycoonplace.com/"    //https://api.tycoonplace.com/ 生产环境    http://api-dev.tycoonplace.com/ 开发环境
    // }
}

//获取当前用户使用API Sever 标识
function getApi() {
    return 'cn';
    // var api = getBaseUrl();
    // if (api === 'https://api.tweebaa.cn/') {
    //     return 'cn';
    // } else {
    //     return 'com';
    // }
}
// //获取nodeJs API
function getNodeApiUrl() {
    return "https://tweebaa.cn/api/v1/";
}
//获取NodeJs uas Api
function getUASApi() {
    return 'https://tweebaa.cn/api/v1/uas/';
}
function success(meg) {
    //弹出成功提示
    $('.success').text(meg).addClass('show-down');
    setTimeout(function () {
        $('.success').text('').removeClass('show-down');
    }, 2000);
}

function messages(msg, type, location, time, square, close) {
    // $('.msg').remove();
    // var t = time * 1000 || 2000;
    // var s = square || '';
    // var c = close || '';
    // var template = '<div class="msg ' + location + ' ' + type + ' ' + s + ' ' + c + '">' + msg + '</div>';
    // $('body').append(template);
    // setTimeout(function () {
    //     $('.msg').remove();
    // }, t);

    api.toast({
        msg: msg,
        duration: 2000,
        location: 'middle'
    });
}

function saving(visible) {
    if (visible === 'show') {
        $('.save-btn').addClass('active');
    }else{
        $('.save-btn').removeClass('active');
    }
}
//loading
function loading(visible) {
    $('.ploading').remove();

    if (visible === 'show') {
        var template = '<div class="ploading">\n' +
            '  <div class="sk-circle">\n' +
            '    <div class="sk-circle1 sk-child"></div>\n' +
            '    <div class="sk-circle2 sk-child"></div>\n' +
            '    <div class="sk-circle3 sk-child"></div>\n' +
            '    <div class="sk-circle4 sk-child"></div>\n' +
            '    <div class="sk-circle5 sk-child"></div>\n' +
            '    <div class="sk-circle6 sk-child"></div>\n' +
            '    <div class="sk-circle7 sk-child"></div>\n' +
            '    <div class="sk-circle8 sk-child"></div>\n' +
            '    <div class="sk-circle9 sk-child"></div>\n' +
            '    <div class="sk-circle10 sk-child"></div>\n' +
            '    <div class="sk-circle11 sk-child"></div>\n' +
            '    <div class="sk-circle12 sk-child"></div>\n' +
            '  </div>\n' +
            '</div>';

        $('body').append(template);
        setTimeout(function () {
            $('.ploading').remove();
        }, 530000)
    }else{
        $('.ploading').remove();
    }

}

/**
 * 获取字符长度，一个中文代表两个英文长度
 * @param str
 * @returns {number}
 */
function jmz(str) {
    var realLength = 0, len = str.length, charCode = -1;
    for (var i = 0; i < len; i++) {
        charCode = str.charCodeAt(i);
        if (charCode >= 0 && charCode <= 128) realLength += 1;
        else realLength += 2;
    }
    return realLength;
}

//input 提示 及光标位置
$('.form-ctrl,input').on('focus', function () {
    $(this).attr('placeholder', '').prev('label').removeClass('invisible');
    $(this).selectionEnd = $(this).val().length;
});

//对话框
function confirmBox(title, btn1, btn2, type) {
    var template = '<div class="ui-dialog dialog-box show ">\n' +
        '    <div class="ui-dialog-cnt">\n' +
        '        <div class="ui-dialog-bd">\n' +
        '            <p>'+ title +'</p>\n' +
        '        </div>\n' +
        '        <div class="ui-dialog-ft">\n' +
        '            <button type="button" data-role="button" id="btn-1">'+ btn1 +'</button>\n' +
        '            <button type="button" style="color: #4578F3;" data-role="button" id="btn-2">'+ btn2 +'</button>\n' +
        '        </div>\n' +
        '    </div>\n' +
        '</div>';
    $('body').append(template);
}

/**
 * 确认框
 */
function confirm(msg, listOrCallback) {
    // var buttons = [];
    // for (var i = 0, len = list.length; i < len; i++) {
    //     buttons.push(list[i].text);
    // }

    if (typeof listOrCallback === 'function') {
        api.removeEventListener({
            name: 'confirmCallbackMain'
        });
        api.addEventListener({
            name: 'confirmCallbackMain'
        }, function() {
            listOrCallback();
        });
        api.openFrame({
            name: 'dialog-confirm',
            url: 'widget://html/dialog/dialog-confirm.html',
            rect: {
                x: 0,
                y: 0,
                w: 'auto',
                h: 'auto'
            },
            pageParam: {
                type: 'main',
                msg: msg,
            },
            bounces: false,
            bgColor:'rgba(0,0,0,0)',
            fixedOn: 'ui_layout'
        });
    } else {
        var buttons = [];
        for (var i = 0, len = listOrCallback.length; i < len; i++) {
            buttons.push(listOrCallback[i].text);
        }
        $.map(listOrCallback, function(item, index) {
            api.removeEventListener({
                name: 'confirmCallbackAside' + index
            });
            api.addEventListener({
                name: 'confirmCallbackAside' + index
            }, function() {
                if (item.callback && $.isFunction(item.callback) === true) {
                    item.callback();
                }
            });
        });
        api.openFrame({
            name: 'dialog-confirm',
            url: 'widget://html/dialog/dialog-confirm.html',
            rect: {
                x: 0,
                y: 0,
                w: 'auto',
                h: 'auto'
            },
            pageParam: {
                type: 'aside',
                msg: msg,
                buttons: buttons
            },
            bounces: false,
            bgColor:'rgba(0,0,0,0)',
            fixedOn: 'ui_layout'
        });
    }

}

function openShareToChats(params) {
    openTabLayout('set-share', MSG.general.repostChat, 'widget://html/chat/set-share.html', params);
}

//弹出分享菜单
function OpenShareBox(ShareUrl,name,content,username,postId,type,thumbnail,postGuid){
    api.openFrame({
        name: 'shareVideo',
        url: 'widget://html/dialog/share.html',
        rect: {
            x: 0,
            y: 0,
            w: 'auto',
            h: 'auto'
        },
        bounces: false,
        bgColor: 'rgba(0,0,0,0)',
        fixedOn: 'ui_window',
        pageParam: {
            ShareUrl: ShareUrl,
            name: name,
            content: content,
            username: username,
            postId: postId,
            type: type,
            thumbnail: thumbnail,
            postGuid: postGuid
        }
    });
}
function ClosePopUpBox(type) {
    $('#shareBox').remove();
    if(type==='postDetail' || type=== 'replay'){
        var UIChatBox = api.require('UIChatBox');
        UIChatBox.show();
    }
}

function deleteMoment(postGuid,postId){
    ClosePopUpBox();
    confirmBox(MSG.tips.wantDelete, MSG.general.cancel, MSG.general.ok,'error');
    $('.dialog-box').find('button').on('click',function (e) {
        var index = $(this).attr('id');
        //console.log(index);
        $('.dialog-box').remove();
        if (index === 'btn-2') {
            loading('show');
            var userid = localStorage.getItem('userId');
            var token = api.getPrefs({
                sync: true,
                key: 'accessToken'
            });
            var url = getBaseUrl() + "api/users/" + userid + "/moments/" + postId;
            var method = "DELETE";

            $.when(postApi(url, method, null, token, null)).done(function (data) {
                console.log(JSON.stringify(data));
                loading('hide');
                if(data.status === 200){
                    $('li#'+postGuid).remove();
                    api.sendEvent({
                        name: 'reloadHome',
                    });
                }
            });
        }
    });
}

/**
 * 反馈
 * @param pageParam
 * pageParam.target: MOMENT、PRODUCT、USER、VOICS_ACTIVITY
 * pageParam.targetId:
 * pageParam.comment
 * pageParam.reeason
 */
function openReportPage(pageParam) {
    ClosePopUpBox();
    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });
    if (token) {
        api.openFrame({
            name: 'Report',
            url: 'widget://html/access/report.html',
            rect: {
                x: 0,
                y: 0,
                w: 'auto',
                h: 'auto'
            },
            bounces: false,
            bgColor: 'rgba(0,0,0,0.7)',
            animation:{
                type: "movein",
                subType: "from_bottom",
                duration: 200
            },
            pageParam: pageParam
        });
    } else {
        openLogin();
    }
}

//检测权限
function checkPermission(type) {
    //type 有 photos|camera|microphone|phone|location|storage

    var resultList = api.hasPermission({
        list: [type]
    });

    return resultList[0].granted;
}

function requestPermission(type) {
    var tips = 'permission-'+type;
    confirm(MSG.tips[tips], function () {
        api.requestPermission({
            list: [type],
            code: 1
        }, function (ret, err) {
            if (!ret.list[0].granted) {
                checkPermission(type)
            }
        });
    });
}

//隐藏没有使用的右侧按钮
if ($('header li:last-child').children().length === 0) {
    $('header li:last-child').css('opacity', 0);
}

//下载二维码
// function downloadQRCode () {
//     loading('show');
//     var img = $('#qrcode img')[0];
//     var canvas = document.createElement('canvas');
//     canvas.width = 256;
//     canvas.height = 256;
//     canvas.getContext('2d').drawImage(img, 0, 0);
//     var dataURL = canvas.toDataURL('image/jpeg');
//     var sendUrl = dataURL.split(",")[1];
//
//     var picJson = {
//         'PictureBinaryBase64': sendUrl,
//         'FileName': 'picture.jpg',
//         'SeoFileName': 'picture.jpg',
//         'MediaType': 'Picture',
//         'DisplayOrder' :0
//     };
//
//     var url = getBaseUrl() + "api/v2/upload/pictures?resizeRequired=true";
//     var paramStr = [picJson];
//     // console.log(JSON.stringify(paramStr));
//     imgUploading = true;
//     getAxois(url,"POST",paramStr).then(function (response) {
//          // console.log(JSON.stringify(response));
//         var imgURL = response.data.Data[0].PictureUrl;
//         api.download({
//             url: imgURL,
//             report: true,
//             cache: true,
//             allowResume: true
//         }, function (ret, err) {
//             // console.log(JSON.stringify(ret));
//             // console.log(JSON.stringify(err));
//             if (ret.state === 1) {
//                 var Url= ret.savePath;
//                 loading('hide');
//                 api.saveMediaToAlbum({
//                     path: Url,
//                     groupName:"Tweebaa"
//                 }, function(ret, err) {
//                     if (ret && ret.status) {
//                         $('#qrCodeBox').hide();
//                         api.toast({
//                             msg: $.i18n.prop('QRcodeDownload'),
//                             duration: 2000,
//                             location: 'middle'
//                         });
//                     }
//                 });
//
//             }
//         });
//     }).catch(function (error) {
//         loading('hide');
//         console.log(JSON.stringify(error) + '@!@!@!@!@!@!@!@');
//     });
//
//
// }

//打开浏览器
function openBrowser(This,Url,title) {
    var url = Url || $(This).attr('data-url');
    //console.log(url);
    // openWindows('browser','../users/browser.html',{
    //     url: url,
    //     title:title
    // });
    var Title = title ||'';

    api.openTabLayout({
        name: 'browser',
        url: '../users/browser.html',
        title: Title,
        shadow:'#f0f0f0',
        hideNavigationBar:false,
        navigationBar: {
            height: getRightPxFromFontSize(48),
            background: '#fff',
            color: '#000',
            leftButtons:  [ {
                iconPath: 'widget://image/back2.png'
            }],
        },
        bounces: true,
        scrollToTop:true,
        slidBackEnabled:true,
        allowEdit:true,
        pageParam:{
            url: url
        }
    });
}
//打开购物车
function openShoppingCart(page) {
    //localStorage.setItem('openFrame', 'shoppingCart');
    openWindows('shoppingCart','../business/shopping.html',{
        fromPage: page
    });
}
//打开扫码器扫码
function openScaner(invite) {
    if(checkPermission('camera')){
        var module = api.require('easyQRCodeScan');
        var resultCallback = function(ret, err) {
            var msg = ret.msg;
            api.startPlay({
                path: 'widget://image/beep.mp3'
            });
            if(invite){
                var code;
                if(msg.split("invitecode=")[1]){
                    code = msg.split("invitecode=")[1];
                }else{
                    code = msg.split("&shareid=")[1];
                }
                api.sendEvent({
                    name: 'scanInviteCode',
                    extra: {
                        inviteCode: code
                    }
                });
            }else {
                if(msg.indexOf("http://")!==-1 || msg.indexOf("https://")!==-1){
                    if(msg.indexOf("invitecode=")!==-1 ){
                        $('#inviteCode').val(msg.split("invitecode=")[1]);
                    }else if(msg.indexOf("https://tweebaa.com/space/html/space.html")!==-1){
                        // var id = msg.split("&shareid=")[1];
                        var id = getUrlParam(msg,'userId');
                        var name = getUrlParam(msg,'storeName');
                        openUserTycoonPlace(id,name);
                    }else{
                        openTabLayout('browser','','../users/browser.html',{
                            url: msg
                        })
                    }
                }
            }

        };
        module.qrScan(resultCallback);
    }else{
        requestPermission('camera')
    }

}

function getUrlParam(url,parameter){
    var urlparameter = '';
    if(url.indexOf(parameter) > -1){
        urlparameter = getUrlVars(url)[parameter];
    }
    return urlparameter;
}
function getUrlVars(url) {
    var vars = {};
    var parts = url.replace(/[?&]+([^=&]+)=([^&]*)/gi, function(m,key,value) {
        vars[key] = value;
    });
    return vars;
}

//打开登录窗
function openLogin() {
    var title = MSG.loginRegister.login;
    openTabLayout('login', title, 'widget://html/access/login.html');
}

function openSignup() {
    var singUp = MSG.loginRegister.singUp;
    openTabLayout('signup', singUp, 'widget://html/access/signup.html');
}

//打开用户空间
function openUserTycoonPlace(Id,StoreName,AvatarUrl,FromPage) {
    openTabLayout('tycoonplace' + Id,'','widget://html/users/tycoonplace.html',{
        userId:Id,
        storeName:StoreName,
        AvatarUrl:AvatarUrl,
        FromPage:FromPage
    },true);
}

//播放视频
function playVideo(url,page,thumb) {
    openTabLayout('single-video', '', 'widget://html/videos/single-video-container.html',
        {
            url: url,
            page: page,
            thumb:thumb
        }, true)
   /* api.openFrame({
        name: 'single-video',
        url: 'widget://html/videos/single-video.html',
        pageParam: {
            url: url,
            page: page
        },
        rect: {
            x: 0,
            y: 0,
            w: 'auto',
            h: 'auto'
        },
        bounces: false,
        bgColor: 'rgba(0,0,0,0)',
        fixedOn: 'ui_layout'
    });*/
   /* var h = api.winHeight;
    // var direction ='portrait_up';
    var obj = api.require('playModule');
    if(api.systemType === 'ios' && page ==='home' ){
        h = api.winHeight - api.safeArea.bottom;
    }else{
        h = 'auto'
    }
    obj.play({
        rect:
            {   x: 0,
                y: 0,
                w: api.winWidth,
                h: h
            },
        title: '',
        url: url,
        defaultBtn: true,
        enableFull : false,
        fullscreenMode:'LANDSCAPE',
        isTopView : true,
        isLive:false,
        isShowLock:false,
        isFullBtn:true,
        isAutoPlay:true,
        isBackBtn:true,
        isLoop:true,
        scalingMode:2,
        enableFullAutoClose:false,
        isSmallShowMore:true,
        isSmallImmerse:true,
        isLongShowBackBtn:true,
    }, function(ret, err) {
        obj.addEventListener({
            name: 'backBtn'
        }, function(ret, err) {
            obj.stop(function(ret, err) {
                api.setScreenOrientation({
                    orientation: 'portrait_up'
                });
                setTimeout(function () {
                    obj.cleanPlayers(function(ret, err) {

                    });
                },800)
            });
        });

        obj.addEventListener({
            name: 'moreClick'
        }, function(ret, err) {

            actionSheet([
                {
                    text: MSG.general.download,
                    callback: function () {
                        if(url.indexOf("/playlist.m3u8") !== -1 ){
                            console.log(url);
                            api.download({
                                url: url.split('/playlist.m3u8')[0],
                                cache: true,
                                savePath:"fs://videos/"+ Date.parse(new Date()) +".mp4",
                                allowResume: true
                            }, function(ret, err) {
                                if (ret.state === 1) {

                                    api.saveMediaToAlbum({
                                        path: ret.savePath,
                                        groupName:"Tweebaa"
                                    }, function(ret, err) {
                                        if (ret && ret.status) {
                                            alert(MSG.tips.saved);
                                        }
                                    });
                                } else {
                                    //console.log(JSON.stringify(err))
                                }
                            });
                        }else{

                            api.saveMediaToAlbum({
                                path: url,
                                groupName:"Tweebaa"
                            }, function(ret, err) {
                                if (ret && ret.status) {
                                    alert(MSG.tips.saved);
                                }
                            });
                        }


                    }
                }
            ]);
        });
    });*/
}


//打开新win窗口
function openWindows(name,url,param) {
    api.openWin({
        name: name,
        url: url,
        bounces: true,
        scrollToTop:true,
        rect: {
            x: 0,
            y: 0,
            w: api.screenWidth,
            h: 'auto'
        },
        slidBackEnabled:false,
        allowEdit:true,
        bgColor: '#fff',
        animation:{
            type:"movein",
            subType:"from_right",
        },
        pageParam: param
    });
}

function openTabLayout(name,title,url,pageParam,hideNav) {
    hideNav = hideNav || false;
    api.openTabLayout({
        name: name,
        url: url,
        title: title,
        fontSize: getRightPxFromFontSize(16),
        shadow:'#f0f0f0',
        hideNavigationBar:hideNav,
        navigationBar: {
            height: getRightPxFromFontSize(48),
            background: '#fff',
            color: '#000',
            leftButtons:  [{
                iconPath: 'widget://image/back2.png'
            }],
        },
        bounces: true,
        scrollToTop:true,
        slidBackEnabled:true,
        allowEdit:true,
        pageParam:pageParam
    });
}


//翻译post
// function translatePost(text,index,that) {
//     var url = getBaseUrl() + '/api/v2/translation';
//     var paramStr = {
//         "q": text,
//         "LanguageCode": lan,
//     };
//     getAxois(url, "POST", paramStr).then(function (response) {
//         that.momentsData[index].Store = response.data.TranslatedText;
//         loading('hide');
//     }).catch(function (error) {
//         loading('hide');
//     });
// }
// function translateTitle(title,index,that) {
//     var url = getBaseUrl() + '/api/v2/translation';
//     var paramStr = {
//         "q": title,
//         "LanguageCode": lan,
//     };
//     getAxois(url, "POST", paramStr).then(function (response) {
//         loading('hide');
//         that.momentsData[index].FeaturedPicture = response.data.TranslatedText;
//     }).catch(function (error) {
//         loading('hide');
//     });
// }

function translate(text, callback) {
    var url = getBaseUrl() + '/api/v2/translation';
    var paramStr = {
        "q": text,
        "LanguageCode": lan,
    };
    loading('show');
    getAxois(url, "POST", paramStr).then(function (response) {
        loading('hide');
        var result = response.data.TranslatedText;
        callback(result);
    });
}

/**
 * 点赞
 * @param momentId
 * @param callback
 */
var like = disLike = function(momentId, callback) {
    apiMoment.edit('/api/v1/likes', {
        source: 'MOMENT',
        sourceId: momentId
    }).done(function (rep) {
        loading('hide');
        if (rep.code === 0) {
            showTiV(true);
            if ($.isFunction(callback) === true) {
                callback();
            }
        } else {
            api.toast({
                msg: rep.message,
                duration: 2000,
                location: 'middle'
            });
        }
    }).fail(function (e) {
        console.log(e.message);
    });
};

function favorite(momentId, callback) {
    apiMoment.edit('/api/v1/favorites', {
        source: 'MOMENT',
        sourceId: momentId
    }).done(function (rep) {
        loading('hide');
        if (rep.code === 0) {
            api.toast({
                msg: MSG.moment.favored,
                duration: 2000,
                location: 'middle'
            });
            if ($.isFunction(callback) === true) {
                callback();
            }
        } else {
            api.toast({
                msg: rep.message,
                duration: 2000,
                location: 'middle'
            });
        }
    }).fail(function (e) {
        console.log(e.message);
    });
}

function disFavorite(momentId, callback) {
    apiMoment.edit('/api/v1/favorites', {
        source: 'MOMENT',
        sourceId: momentId
    }).done(function (rep) {
        loading('hide');
        if (rep.code === 0) {
            api.toast({
                msg: MSG.moment.unfavored,
                duration: 2000,
                location: 'middle'
            });
            if ($.isFunction(callback) === true) {
                callback();
            }
        } else {
            api.toast({
                msg: rep.message,
                duration: 2000,
                location: 'middle'
            });
        }
    }).fail(function (e) {
        console.log(e.message);
    });
}

/**
 * 关注
 * @param userGuid
 * @param userName
 * @param callback
 */
function follow(userGuid, userName, callback) {
    loading('show');
    var myGuid = localStorage.getItem('userGuid');
    var url = getBaseUrl() + "api/user/"+ myGuid +"/follow/"+ userGuid;
    getAxois(url, "PUT", {}).then(function (response) {
        loading('hide');
        if (response.statusText === "OK") {
            api.execScript({
                frameName: 'mine',
                script: 'workPlace.getMyDetails();'
            });
            if (response.data.Data.TaskId) {
                apiTask.fetchTaskStatus(response.data.Data.TaskId, true);
            } else {
                api.toast({
                    msg: MSG.general.success,
                    duration: 2000,
                    location: 'middle'
                });
            }
            // 发送通知
            if (userName) {
                postNotify(userName, MSG_TYPE_FOLLOW, {
                    AvatarUrl: localStorage.getItem('thumbnail'),
                    StoreName: localStorage.getItem('storename'),
                    UserId: localStorage.getItem('userId'),
                });
            }
            if ($.isFunction(callback) === true) {
                callback();
            }
        }
    }).catch(function (error) {
        loading('hide');
        console.log(JSON.stringify(error));
    });
}

/**
 * 取消关注
 * @param userGuid
 * @param callback
 */
function disFollow(userGuid, callback) {
    loading('show');
    var myGuid = localStorage.getItem('userGuid');
    var url = getBaseUrl() + "api/user/" + myGuid + "/follow/" + userGuid;
    getAxois(url, "PUT", {}).then(function (response) {
        loading('hide');
        if (response.statusText === "OK") {
            api.execScript({
                frameName: 'mine',
                script: 'workPlace.getMyDetails();'
            });
            api.toast({
                msg: MSG.general.success,
                duration: 2000,
                location: 'middle'
            });
            if ($.isFunction(callback) === true) {
                callback();
            }
        }
    }).catch(function (error) {
        loading('hide');
        console.log(JSON.stringify(error));
    });
}

//平均时间格式化
function formatSeconds(value) {
    var secondTime = parseInt(value);
    var minuteTime = 0;
    if(secondTime > 60) {
        minuteTime = parseInt(secondTime / 60);
        secondTime = parseInt(secondTime % 60);
    }
    var result = " " + parseInt(secondTime) +' '+ MSG.general.second;

    if(minuteTime > 0) {
        result = " " + parseInt(minuteTime) +' '+ MSG.general.minute + result;
    }
    return result;
}

//列表汇率转换
function setExPirce(page,id) {
    if(!page){
        $('#productsList').find('li').each(function () {
            var that = this;
            exChange(that);
        });
    }else{
        $('#productsList').find('li#'+id).nextAll().each(function () {
            var that = this;
            exChange(that);
        });
    }
}
function exChange(that) {
    var currencyCode = $(that).attr('data-currency-code');
    var price = Number($(that).find('.price').text());
    var url = getBaseUrl() + "/api/exchange/get-rate?from="+ currencyCode +"&to="+ localStorage.getItem('primaryCurrencyCode');
    //console.log(JSON.stringify(url));
    getAxois(url, "GET", {}).then(function (response) {
        //console.log(JSON.stringify(response) + '!!!!');
        $(that).find('.exprice').html((price * response.data).toFixed(2));
    }).catch(function (error) {
        console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
    });
}

function getExchangeText(price) {
    if ($.isNumeric(price) === true) {
        price = +price;
        var exchange = 0.1;
        var currency = '$';
        var lan = window.lan;
        if (lan === 'zh') {
            exchange = +api.getPrefs({
                sync: true,
                key: 'exChangeCNY'
            });
            currency = '￥';
        } else {
            exchange = 0.1;
            currency = '$';
        }
        return '≈' + currency + (price * exchange).toFixed(2);
    } else {
        return price;
    }
}

function getExchangeCNY() {
    return +api.getPrefs({
        sync: true,
        key: 'exChangeCNY'
    });
}

function getExchangeCAD() {
    return +api.getPrefs({
        sync: true,
        key: 'exChangeCAD'
    });
}

function getExchangeValue() {
    var exchange;
    if (lan === 'zh') {
        exchange = +api.getPrefs({
            sync: true,
            key: 'exChangeCNY'
        });
    } else {
        exchange = 0.1;
    }
    return exchange;
}

/**
 * 这里的loading高度，类似于手机的竖屏照片，横屏放置的高度
 */
function getPhoneLoadingHeight() {
    var winWidth = api.winWidth;
    var winHeight = api.winHeight;
    return winWidth * (winWidth / winHeight);
}

function back(page) {
    if(page){
        var td = api.require('talkingData');
        td.onPageEnd({pageName:page});
    }
    api.closeWin();
}

function backListener(page) {

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if(page){
            var td = api.require('talkingData');
            td.onPageEnd({pageName:page});
        }
        api.closeWin();
    });

    // api.addEventListener({
    //     name: 'keyback'
    // }, function(ret, err) {
    //     back();
    // });

    // api.addEventListener({
    //     name:'swiperight'
    // }, function(ret, err){
    //     back();
    // });

}

function openVCallPage(calledId, targetId, type, chatName, chatPortrait, direction, extra) {
    api.openWin({
        name: 'vCallPage',
        url: 'widget://html/chat/vcall.html',
        bounces: false,
        scrollToTop:true,
        rect: {
            x: 0,
            y: 0,
            w: api.screenWidth,
            h: 'auto'
        },
        slidBackEnabled:false,
        allowEdit:true,
        bgColor: 'rgba(0,0,0,0.7)',
        pageParam: {
            chatName: chatName,
            portrait: chatPortrait,
            calledId: calledId,
            mediaType: type,
            targetId: targetId,
            direction: direction,
            extra: extra ? JSON.stringify(extra) : ''
        },
        animation:{
            type: "movein",
            subType: "from_top",
            duration: 200
        }
    });
}

function closeVCallPage() {
    api.closeWin({
        name: 'vCallPage'
    });
    api.closeFrame({
        name: 'vCallPage'
    });
}

function openVideoCallPage(calledId, targetId, type, chatName, chatPortrait, direction, extra) {
    api.openWin({
        name: 'videoCallPage',
        url: 'widget://html/chat/videoCall.html',
        rect: {
            x: 0,
            y: 0,
            w: 'auto',
            h: 'auto'
        },
        pageParam: {
            chatName: chatName,
            portrait: chatPortrait,
            calledId: calledId,
            mediaType: type,
            targetId: targetId,
            direction: direction,
            extra: extra ? JSON.stringify(extra) : ''
        },
        bounces: false,
        bgColor: '#fff',
        fixedOn: 'ui_layout',
        animation:{
            type: "movein",
            subType: "from_top",
            duration: 200
        }
    });
}

function openGroupVCallPage(calledId, targetId, type, chatName, chatPortrait, direction, callerUserId, membersInfo, membersGroup) {
    api.openWin({
        name: 'groupVCallPage',
        url: 'widget://html/chat/group-call.html',
        bounces: false,
        scrollToTop: true,
        rect: {
            x: 0,
            y: 0,
            w: api.screenWidth,
            h: 'auto'
        },
        slidBackEnabled: false,
        allowEdit: true,
        bgColor: 'rgba(0,0,0,0.7)',
        pageParam: {
            chatName: chatName,
            portrait: chatPortrait,
            calledId: calledId,
            mediaType: type,
            targetId: targetId,
            direction: direction,
            callerUserId: callerUserId,
            membersInfo: membersInfo,
            membersGroup: membersGroup
        },
        animation: {
            type: "movein",
            subType: "from_top",
            duration: 200
        }
    });
}
/**
 * 输出日志，快捷方法
 * @param textOrObj
 * @param type
 */
function log(textOrObj, type) {
    if ($.isArray(textOrObj) === true || $.isPlainObject(textOrObj) === true) {
        textOrObj = JSON.stringify(textOrObj);
    }
    switch (type) {
        case 'info':
            console.info(textOrObj);
            break;
        case 'warn':
            console.warn(textOrObj);
            break;
        case 'error':
            console.error(textOrObj);
            break;
        default:
            console.log(textOrObj);
            break;
    }
}

/**
 * 单位：rem
 * @returns {number}
 */
function getSafeHeight() {
    var FIX_HEIGHT = 0;
    var h = 0;
    if (api.safeArea.bottom) {
        h =  FIX_HEIGHT + api.safeArea.bottom;
    }
    return h / 10;
}

function changeTweelogPortrait(pageParam){
    if (api.systemType === 'ios') {
        openTabLayout('photchangePortraitoTweelog', MSG.profile.changeAvatar, 'widget://html/tweelog/modules/changeAvatar/change-portrait.html', pageParam);
    } else {
        openWindows('photchangePortraitoTweeLog', 'widget://html/tweelog/modules/changeAvatar/change-portrait-android.html', pageParam);
    }
}

function openChangePortrait(pageParam) {
    if (api.systemType === 'ios') {
        if (!pageParam) {
            openTabLayout('photchangePortraitoWall', MSG.profile.changeAvatar, 'widget://html/users/change-portrait.html');
        } else {
            openTabLayout('photchangePortraitoWall', MSG.profile.changeAvatar, 'widget://html/users/change-portrait.html', pageParam);
        }
    } else {
        if (!pageParam) {
            openWindows('photchangePortraitoWall', 'widget://html/users/change-portrait-android.html');
        } else {
            openWindows('photchangePortraitoWall', 'widget://html/users/change-portrait-android.html', pageParam);
        }
    }
}

/**
 * 所有的下拉菜单，均使用这个方法
 * @param list
 * @param onClickCallback
 */
function actionSheet(list, onClickCallback) {
    var buttons = [];
    for (var i = 0, len = list.length; i < len; i++) {
        buttons.push(list[i].text);
    }

    var params = {
        cancelTitle: MSG.general.cancel,
        buttons: buttons,
        style: {
            fontNormalColor: '#000',
            fontPressColor: '#000',
        }
    };

    if (list[0] && list[0].color === 'red') {
        params.destructiveTitle = list[0].text;
        buttons.shift();
    }
    if (api.systemType === 'android') {
        api.actionSheet(params, function(ret, err) {
            var index = ret.buttonIndex;
            var item;
            for (var j = 0, lenJ = list.length; j < lenJ; j++) {
                item = list[j];
                if (index === (j + 1)) {
                    if (item.callback) {
                        item.callback();
                    }
                }
            }

            if (onClickCallback && $.isFunction(onClickCallback) === true) {
                onClickCallback();
            }
        });
    } else {
        $.map(list, function (item, index) {
            api.removeEventListener({
                name: 'actionSheetCallback' + index
            });
            api.addEventListener({
                name: 'actionSheetCallback' + index
            }, function() {
                item.callback();
                if (onClickCallback && $.isFunction(onClickCallback) === true) {
                    onClickCallback();
                }
            });
        });
        api.removeEventListener({
            name: 'actionSheetCallbackCancel'
        });
        api.addEventListener({
            name: 'actionSheetCallbackCancel'
        }, function() {
            if (onClickCallback && $.isFunction(onClickCallback) === true) {
                onClickCallback();
            }
        });
        // console.log(111);
        api.openFrame({
            name: 'dialog-actionsheet',
            url: 'widget://html/dialog/dialog-actionsheet.html',
            rect: {
                x: 0,
                y: 0,
                w: 'auto',
                h: 'auto'
            },
            pageParam: {
                list: list
            },
            bounces: false,
            bgColor:'rgba(0,0,0,0)',
            fixedOn: 'ui_layout'
        });
    }

}

/*
dialog({
    title: 'Add Profile Image',
    content: '这里是内容',
    primaryText: 'Continue',
    onPrimary: function() {
        console.log('primary...');
    },
    asideText: 'Remind Me Later',
    onAside: function () {
        console.log('asdie...');
    },
    onClose: function () {
        console.log('close...');
    }
});
 */
function dialog(config) {
    api.openFrame({
        name: 'dialog',
        url: 'widget://html/dialog/dialog.html',
        rect: {
            x: 0,
            y: 0,
            w: 'auto',
            h: 'auto'
        },
        pageParam: {
            title: config.title,
            content: config.content,
            primaryText: config.primaryText,
            asideText: config.asideText,
            showClose: config.onClose ? true : false,
            textAlign: config.textAlign || 'center'
        },
        bounces: false,
        bgColor:'rgba(0,0,0,0)',
        fixedOn: 'ui_layout'
    });

    api.removeEventListener({
        name: 'dialogPrimary'
    });
    api.addEventListener({
        name: 'dialogPrimary'
    }, function() {
        var callback = config.onPrimary;
        if ($.isFunction(callback) === true) {
            callback();
        }
    });

    api.removeEventListener({
        name: 'dialogAside'
    });
    api.addEventListener({
        name: 'dialogAside'
    }, function() {
        var callback = config.onAside;
        if ($.isFunction(callback) === true) {
            callback();
        }
    });

    if (config.onClose && $.isFunction(config.onClose) === true) {
        api.removeEventListener({
            name: 'dialogClose'
        });
        api.addEventListener({
            name: 'dialogClose'
        }, function() {
            config.onClose();
        });
    }

}

/*
 confirmTiV({
    value: 2,
    content: 'Nickname Setting',
    onWarning: function() {
    },
    onPrimary: function () {
        console.log(111);
    },
    onAside: function () {
        console.log(222);
    }
 });
 * @param config
 */
function confirmTiV(config) {
    api.openFrame({
        name: 'dialogTiV',
        url: 'widget://html/dialog/dialog-tiv.html',
        rect: {
            x: 0,
            y: 0,
            w: 'auto',
            h: 'auto'
        },
        pageParam: {
            value: config.value,
            content: config.content
        },
        bounces: false,
        bgColor:'rgba(0,0,0,0)',
        fixedOn: 'ui_layout'
    });

    api.removeEventListener({
        name: 'dialogTiVPrimary'
    });
    api.addEventListener({
        name: 'dialogTiVPrimary'
    }, function() {
        var callback = config.onPrimary;
        if ($.isFunction(callback) === true) {
            callback();
        }
    });

    api.removeEventListener({
        name: 'dialogTiVAside'
    });
    api.addEventListener({
        name: 'dialogTiVAside'
    }, function() {
        var callback = config.onAside;
        if ($.isFunction(callback) === true) {
            callback();
        }
    });

    api.removeEventListener({
        name: 'dialogTiVWarning'
    });
    api.addEventListener({
        name: 'dialogTiVWarning'
    }, function() {
        var callback = config.onWarning;
        if ($.isFunction(callback) === true) {
            callback();
        }
    });

}

/**
 * 展示ws消息接收模式下的tiv奖励弹窗
 * @param stayPage 弹出奖励弹窗之后，是否停留在本页面
 * @param timeout 如果没有收到消息，在指定时间内，回退当前页面，在stayPage=false的情况下使用
 */
function showTiV(stayPage, timeout) {
    var timeId;

    console.log("[" + api.deviceName + "] " + 'showTiV...');

    api.removeEventListener({
        name: 'showTiV'
    });
    api.addEventListener({
        name: 'showTiV'
    }, function(ret) {
        clearTimeout(timeId);
        var notify = ret.value.notify;
        confirmTiV({
            value: notify.amount,
            onWarning: function() {
                console.log('onWarning');
            },
            onPrimary: function () {
                if (stayPage === false) {
                    api.closeWin();
                }
            },
            onAside: function () {
                openTabLayout('tiv', MSG.mine.myTIV, "widget://html/business/tiv-statement.html");
            }
        });
    });

    // 计时两秒，如果没有收到消息，就直接退出页面
    if (stayPage === false) {
        timeId = setTimeout(function () {
            api.closeWin();
        }, timeout || 2000);
    }
}


//新增加tiv 接口

function AddTIV(url,obj,content,stayPage) {

    stayPage = stayPage || false;
    var URL = getBaseUrl() + "api/v3/tiv/" + url;
    getAxois(URL,"POST",obj).then(function (response) {
        var obj = response.data;
        // console.log(JSON.stringify(response) + "!!!");
        loading('hide');
        if (obj.Code === 0) {
            if (url === "viewtycoonplace" || url === "post" || url === "voteproduct" || url === 'comment') {
                confirmTiV({
                    value: response.data.Data.Tiv,
                    content: content,
                    onWarning: function () {
                    },
                    onPrimary: function () {
                        if (!stayPage) {
                            back();
                        }
                    },
                    onAside: function () {
                        openTabLayout('tiv', MSG.mine.myTIV, "widget://html/business/tiv-statement.html");
                    }
                });
            } else {
                if (!stayPage) {
                    back();
                }
            }
        } else if(obj.Code === 999999) {
            // 不是一个高质量的评论
            // console.log(JSON.stringify(obj));
            if (!stayPage) {
                back();
            }
        } else {
            if (!stayPage) {
                back();
            }
        }
    })
    // .catch(function (error) {
    //     loading('hide');
    //     console.log(JSON.stringify(error) + "!@@@@@");
    //     if(!stayPage){
    //         console.log(stayPage);
    //         back();
    //     }
    //
    // });

}

function AddTivNew(type, config) {
    var param = {
        type: type
    };
    if (config && config.visitedCustomerId) {
        param.visitedCustomerId = config.visitedCustomerId;
    }
    if (config && config.postOwnerId) {
        param.postOwnerId = config.postOwnerId;
    }
    apiTiv.post("/api/v1/tiv", param).done(function (rep) {
        if (rep.code === 0) {
            var value = rep.data.amount;
            if (parseFloat(value) > 0) {
                confirmTiV({
                    value: rep.data.amount,
                    onWarning: function() {
                        console.log('onWarning');
                    },
                    onPrimary: function () {

                    },
                    onAside: function () {
                        openTabLayout('tiv', MSG.mine.myTIV, "widget://html/business/tiv-statement.html");
                    }
                });
            }
        } else {
            api.toast({
                msg: rep.message,
                duration: 2000,
                location: 'middle'
            });
        }
    }).fail(function (err) {
        console.error("[" + api.deviceName + "] AddTivNew: " + JSON.stringify(err));
    });
}

function alert(msg, callback) {
    api.removeEventListener({
        name: 'alertCallback'
    });
    api.addEventListener({
        name: 'alertCallback'
    }, function() {
        if ($.isFunction(callback) === true) {
            callback();
        }
    });
    api.openFrame({
        name: 'dialog-alert',
        url: 'widget://html/dialog/dialog-alert.html',
        rect: {
            x: 0,
            y: 0,
            w: 'auto',
            h: 'auto'
        },
        pageParam: {
            msg: msg
        },
        bounces: false,
        bgColor:'rgba(0,0,0,0)',
        fixedOn: 'ui_layout'
    });
}

// 客服沟通
function chatToService() {
    openChatPage({
        targetId: 'tw1580766923@new',
        userName: '客服/Customer service',
        userPortrait: 'https://tweebaafiles.oss-accelerate.aliyuncs.com/tweebaa/customer-avatar.jpg',
        conversationType: 'PRIVATE',
        isTop: false,
        notificationStatus: 'NOTIFY'
    });
}

function openChatPage(param, animation) {
    var a = {
        type: "movein",
        subType: "from_right",
    };
    if (animation === 'fast') {
        a = {
            type: 'none',
            duration: 0
        }
    }
    api.openWin({
        name: 'chatWrapperPage',
        url: 'widget://html/chat/chat-wrapper.html',
        bounces: false,
        scrollToTop: false,
        rect: {
            x: 0,
            y: 0,
            w: api.screenWidth,
            h: 'auto'
        },
        slidBackEnabled: false,
        allowEdit: true,
        bgColor: '#fff',
        softInputMode: 'resize',
        vScrollBarEnabled: true,
        animation: a,
        pageParam: param
    });
}

function closeChatPage(callback) {

    localStorage.removeItem("openChatPage");

    api.sendEvent({
        name: 'conversationListReload',
    });

    api.setKeepScreenOn({
        keepOn: false
    });

    api.execScript({
        frameName: 'chat',
        script: "chatPage.closePage()"
    });

    setTimeout(function () {
        api.closeWin({
            name: 'chatWrapperPage'
        });

        if ($.isFunction(callback) === true) {
            callback();
        }
    }, 100);

}

function restartChatPage(pageParam) {
    closeChatPage(function () {
        openChatPage(pageParam);
    });
}

function transEmo(emoMsg) {
    var emoPath, transMsg;
    var reg = /\[(.*?)\]/gm;
    transMsg = emoMsg.replace(reg, function (match) {
        for (var i = 0, len = EMO_DATA.length; i < len; i++) {
            if (EMO_DATA[i].text === match) {
                emoPath = '../../image/emotion/' + EMO_DATA[i].name + '.png';
                return "<img width='20' height='20' src='" + emoPath + "' />"
            }
        }
        return match;
    });
    return transMsg;
}

/**
 * 根据categoryIds，来获得对应的类别名字列表
 * @param list
 * @param lang
 * @returns {*}
 */
function getCategoryNameByIds(list, lang) {
    if (!category) {
        return;
    }
    var result = {};
    $.map(category, function (item) {
        result[item.i] = item[lang];

        if (item.c) {
            $.map(item.c, function (item2) {
                result[item2.i] = item2[lang];

                if (item2.c) {
                    $.map(item2.c, function (item3) {
                        result[item3.i] = item3[lang];
                    });
                }
            });
        }
    });

    var categoryNames = [];
    $.map(list, function (categoryId) {
        if (result[categoryId]) {
            categoryNames.push(result[categoryId]);
        }
    });
    return categoryNames;
}

//美洽客服
function MQCustomerSerivce(PreSendText) {
    var kv = api.require('snKVStorage');
    var USERINFO = kv.getObject({
        key: 'userInfo'
    });
    var TIV = kv.getDouble({
        key: 'tiv'
    });
    var Tweebuck = kv.getDouble({
        key: 'tweebuck'
    });

    var mq = api.require('meiQia');

    var scheduleParam = {
        agentGroup: "b8807679a355812a286a938315c13646",
        scheduleRule: "none"
    };

    var clientIdParam = {
        id: localStorage.getItem('MQCliednId'),
    };
    var infoParam = {
        ID:USERINFO.Id,
        AppVersion:api.appVersion,
        UserName:USERINFO.UserName,
        tel: USERINFO.CountryCallingCode + " " + USERINFO.PhoneNumber,
        tiv:TIV,
        tweebuck:Tweebuck,
        name: USERINFO.StoreName,
        phoneModel:api.deviceModel,
        avatar: USERINFO.ThumbnailAvatarUrl,
    };
    var titleColor = {
        color: "#000"
    };
    mq.setScheduledAgentOrAgentGroup(scheduleParam);

    mq.setClientInfo(infoParam);

    mq.setLoginCustomizedId(clientIdParam);

    mq.setTitleColor(titleColor);
    setTimeout(function () {
        mq.show({showAvatar:true,enableCamera:false,updateClientInfo:true});
        mq.setLoginCustomizedId(function(ret,err){

        });

    },200);
    if(PreSendText){
        mq.setPreSendTextMessage({
            message:PreSendText
        });
    }
}


var ApiService = function (baseUrl) {
    this.baseUrl = baseUrl;
};

ApiService.prototype = {
    get: function (url, param, headers) {
        var defer = $.Deferred();

        var token = api.getPrefs({
            sync: true,
            key: 'accessToken'
        }) || localStorage.getItem('access_token') || '';
        var currentHeader = {
            'Content-Type': 'application/json;charset=utf-8',
            lang: lan === 'zh' ? 'zh_CN' : 'en_US'
        };
        if (token && token) {
            currentHeader.userId = localStorage.getItem('userId');
            currentHeader.userName = localStorage.getItem('userName');
            currentHeader.userGuid = localStorage.getItem('userGuid');
            currentHeader.token = 'Bearer ' + token;
        }
        if (headers) {
            $.extend(currentHeader, headers);
        }
        if (api.systemType === 'android') {
            $.ajax({
                contentType: "application/json; charset=utf-8",
                method: 'GET',
                url: this.baseUrl + url,
                async: true,
                data: param,
                dataType: 'json',
                headers: currentHeader
            }).done(function (data) {
                // console.log("[" + api.deviceName + "]: " + JSON.stringify(data));
                defer.resolve(data);
            }).fail(function (err) {
                console.error("[" + api.deviceName + "]: " + JSON.stringify(err));
                // console.error(JSON.stringify(err));
                defer.resolve(err);
            });
        } else {
            api.ajax({
                url: this.baseUrl + url,
                method: 'GET',
                headers: currentHeader,
                data: {
                    body: param
                }
            }, function(response, err) {
                // console.log("[" + api.deviceName + "] [ApiService] [GET] : " + JSON.stringify(response));
                defer.resolve(response);
                if (err) {
                    console.error("[" + api.deviceName + "] [ApiService] [GET] : " + JSON.stringify(err));
                }
            });
        }

        return defer;
    },
    post: function (url, param, headers) {
        var defer = $.Deferred();
        // console.log(JSON.stringify(param));
        var token = api.getPrefs({
            sync: true,
            key: 'accessToken'
        }) || localStorage.getItem('access_token') || '';
        var currentHeader = {
            'Content-Type': 'application/json;charset=utf-8',
            lang: lan === 'zh' ? 'zh_CN' : 'en_US'
        };
        if (token && token !== 'null') {
            currentHeader.userId = localStorage.getItem('userId');
            currentHeader.userName = localStorage.getItem('userName');
            currentHeader.userGuid = localStorage.getItem('userGuid');
            currentHeader.token = 'Bearer ' + token;
        }
        if (headers) {
            $.extend(currentHeader, headers);
        }

        if (api.systemType === 'android') {
            $.ajax({
                contentType: "application/json; charset=utf-8",
                method: 'POST',
                url: this.baseUrl + url,
                async: true,
                data: JSON.stringify(param),
                dataType: 'json',
                headers: currentHeader
            }).done(function (data) {
                defer.resolve(data);
            }).fail(function (err) {
                console.error("[" + api.deviceName + "]" + JSON.stringify(err));
                defer.resolve(err);
            });
        } else {
            api.ajax({
                url: this.baseUrl + url,
                method: 'POST',
                headers: currentHeader,
                data: {
                    body: JSON.stringify(param)
                }
            }, function(response, err) {
                // console.log("[" + api.deviceName + "] [ApiService] [POST] : " + JSON.stringify(response));
                defer.resolve(response);
                if (err) {
                    console.error("[" + api.deviceName + "] [ApiService] [POST] : " + JSON.stringify(err));
                }
            });
        }

        return defer;
    },
    remove: function (url, headers) {
        var defer = $.Deferred();
        var token = api.getPrefs({
            sync: true,
            key: 'accessToken'
        }) || localStorage.getItem('access_token') || '';
        var currentHeader = {
            'Content-Type': 'application/json;charset=utf-8',
            lang: lan === 'zh' ? 'zh_CN' : 'en_US',
            userId: localStorage.getItem('userId')
        };
        if (token && token !== 'null') {
            currentHeader.userId = localStorage.getItem('userId');
            currentHeader.userName = localStorage.getItem('userName');
            currentHeader.userGuid = localStorage.getItem('userGuid');
            currentHeader.token = 'Bearer ' + token;
        }
        if (headers) {
            $.extend(currentHeader, headers);
        }
        if (api.systemType === 'android') {
            $.ajax({
                method: 'DELETE',
                url: this.baseUrl + url,
                async: true,
                dataType: 'json',
                headers: currentHeader
            }).done(function (data) {
                // console.log("[" + api.deviceName + "]: " + JSON.stringify(data));
                defer.resolve(data);
            }).fail(function (err) {
                console.error("[" + api.deviceName + "]: " + JSON.stringify(err));
                // console.error(JSON.stringify(err));
                defer.resolve(err);
            });
        } else {
            api.ajax({
                url: this.baseUrl + url,
                method: 'DELETE',
                headers: currentHeader,
            }, function(response, err) {
                defer.resolve(response);
                if (err) {
                    console.error("[" + api.deviceName + "] [ApiService] [DELETE] : " + JSON.stringify(err));
                }
            });
        }
        return defer;
    },
    edit: function (url, param, headers) {
        var defer = $.Deferred();
        var token = api.getPrefs({
            sync: true,
            key: 'accessToken'
        }) || localStorage.getItem('access_token') || '';
        var currentHeader = {
            'Content-Type': 'application/json;charset=utf-8',
            lang: lan === 'zh' ? 'zh_CN' : 'en_US',
            userId: localStorage.getItem('userId'),
            userName: localStorage.getItem('userName'),
        };
        if (token) {
            currentHeader.token = 'Bearer ' + token;
        }
        if (headers) {
            $.extend(currentHeader, headers);
        }
        if (api.systemType === 'android') {
            $.ajax({
                contentType: "application/json; charset=utf-8",
                method: 'PUT',
                url: this.baseUrl + url,
                async: true,
                data: JSON.stringify(param),
                dataType: 'json',
                headers: currentHeader
            }).done(function (data) {
                // console.log("[" + api.deviceName + "]: " + JSON.stringify(data));
                defer.resolve(data);
            }).fail(function (err) {
                console.error("[" + api.deviceName + "]: " + JSON.stringify(err));
                // console.error(JSON.stringify(err));
                defer.resolve(err);
            });
        } else {
            api.ajax({
                url: this.baseUrl + url,
                method: 'PUT',
                headers: currentHeader,
                data: {
                    body: JSON.stringify(param)
                }
            }, function(response, err) {
                defer.resolve(response);
                if (err) {
                    console.error("[" + api.deviceName + "] [ApiService] [PUT] : " + JSON.stringify(err));
                }
            });
        }
        return defer;
    }
};

var currentHostKey = '';
if (SERVER_HOSTS.dev === true) {
    if (localStorage.getItem('server') === 'cn') {
        currentHostKey = 'TEST';
    } else {
        currentHostKey = 'TEST_COM';
    }
} else {
    currentHostKey = 'PROD';
}
var apiUserCenter = new ApiService(SERVER_HOSTS.USER_CENTER[currentHostKey]);
var apiSuggest = new ApiService(SERVER_HOSTS.SUGGEST[currentHostKey]);
var apiNotify = new ApiService(SERVER_HOSTS.NOTIFICATION[currentHostKey]);
var apiTiv = new ApiService(SERVER_HOSTS.TIV[currentHostKey]);
var apiAssess = new ApiService(SERVER_HOSTS.ASSESS[currentHostKey]);
var apiTracking = new ApiService(SERVER_HOSTS.TRACKING[currentHostKey]);
var apiPresale = new ApiService(SERVER_HOSTS.PRESALE[currentHostKey]);
var apiMoment = new ApiService(SERVER_HOSTS.MOMENT[currentHostKey]);
var apiFree = new ApiService(SERVER_HOSTS.FREE[currentHostKey]);
var apiTask = new ApiService(SERVER_HOSTS.TASK[currentHostKey]);
var apiTweelog = new ApiService(SERVER_HOSTS.TWEELOG[currentHostKey]);
var apiRecommend = new ApiService(SERVER_HOSTS.RECOMMEND[currentHostKey]);
var shareH5Host = SERVER_HOSTS.SHARE_H5[currentHostKey];
// var apiUserCenter = new ApiService(SERVER_HOSTS.dev === false ? SERVER_HOSTS.USER_CENTER.PROD : SERVER_HOSTS.USER_CENTER.TEST);
// var apiSuggest = new ApiService(SERVER_HOSTS.dev === false ? SERVER_HOSTS.SUGGEST.PROD : SERVER_HOSTS.SUGGEST.TEST);
// var apiNotify = new ApiService(SERVER_HOSTS.dev === false ? SERVER_HOSTS.NOTIFICATION.PROD : SERVER_HOSTS.NOTIFICATION.TEST);
// var apiTiv = new ApiService(SERVER_HOSTS.dev === false ? SERVER_HOSTS.TIV.PROD : SERVER_HOSTS.TIV.TEST);
// var apiAssess = new ApiService(SERVER_HOSTS.dev === false ? SERVER_HOSTS.ASSESS.PROD : SERVER_HOSTS.ASSESS.TEST);
// var apiTracking = new ApiService(SERVER_HOSTS.dev === false ? SERVER_HOSTS.TRACKING.PROD : SERVER_HOSTS.TRACKING.TEST);
// var apiPresale = new ApiService(SERVER_HOSTS.dev === false ? SERVER_HOSTS.PRESALE.PROD : SERVER_HOSTS.PRESALE.TEST);
// var apiMoment = new ApiService(SERVER_HOSTS.dev === false ? SERVER_HOSTS.MOMENT.PROD : SERVER_HOSTS.MOMENT.TEST);
// var apiFree = new ApiService(SERVER_HOSTS.dev === false ? SERVER_HOSTS.FREE.PROD : SERVER_HOSTS.FREE.TEST);

function postNotify(username, type, content) {
    apiNotify.post('/notification', {
        type: type,
        username: username,
        content: JSON.stringify(content)
    });
}

var TASK_CODE = {
    // 完善个人信息
    GROUP_PERSON_PROFILE: 1,
    // 添加产品到空间
    GROUP_ADD_SHOWCASE: 2,
    // 创建数字产品
    GROUP_CREATE_DIGITAL: 3,

    // 每日签到
    SIGN: 5,
    // 设置头像
    SETTING_PORTRAIT: 1,
    // 设置昵称
    CHANGE_NAME: 2,
    // 设置背景
    CHANGE_BG: 3,
    // 关注5个新推友
    FOLLOW: 4,
    // 创建数字产品
    CREATE_DIGITAL: 5
};

// var apiTask = new ApiService(SERVER_HOSTS.dev === false ? SERVER_HOSTS.TASK.PROD : SERVER_HOSTS.TASK.TEST);

apiTask.FETCH_TASK_TOTAL_TIMES = 10; // 轮训3次获取异步任务完成状态
apiTask.FETCH_TASK_LOOP_TIME = 1000;    // 毫秒，每1秒获取一次状态
apiTask.fetchTaskCount = 0;         // 当前获取次数
apiTask.fetchTaskStatus = function(taskId, stayPage, callback) {
    console.log('[fetchTaskStatus]: get TaskId: ' + new Date());
    setTimeout(function () {
        console.log('[fetchTaskStatus]: begin loop: ' + new Date());
        apiTask.loopTaskStatus(taskId, stayPage, callback);
    }, 1000);
};
apiTask.loopTaskStatus = function(taskId, stayPage, callback) {
    var that = this;
    stayPage = stayPage || false;
    this.fetchTaskCount++;
    var url = "/api-task/usertask/status";
    var param = {
        traceId: taskId,
        lang: lan === "zh" ? "zh_CN" : "en_US"
    };
    //console.info('[loopTaskStatus][param] : ' + JSON.stringify(param));
    this.post(url, param).done(function (rep) {

        api.sendEvent({
            name: 'taskReload'
        });

        api.sendEvent({
            name: 'workplaceReload',
            extra: {
                type: 'task'
            }
        });
        api.execScript({
            frameName: 'mine',
            script: 'workPlace.getTaskList();'
        });
        console.warn('[loopTaskStatus]' + new Date() + ': ' + JSON.stringify(rep));
        if (rep.code === 0) {

            var tasks = rep.tasks;
            var data = tasks[0];

            if (!data) {
                restart();
                // api.toast({
                //     msg: MSG.general.success,
                //     duration: 2000,
                //     location: 'middle'
                // });
                // if (stayPage === false) {
                //     setTimeout(function () {
                //         api.closeWin();
                //     }, 2000);
                // }
                return;
            }

            // 已完成
            if (data.status === 2) {
                console.log('【loopTaskStatus】：已完成');
                confirmTiV({
                    value: data.reward,
                    content: data.name,
                    onWarning: function() {
                        console.log('onWarning');
                    },
                    onPrimary: function () {
                        if (stayPage === false) {
                            api.closeWin();
                        } else {
                            if (callback) {
                                callback();
                            }
                        }
                    },
                    onAside: function () {
                        openTabLayout('tiv', MSG.mine.myTIV, "widget://html/business/tiv-statement.html");
                    }
                });
                that.fetchTaskCount = 0;
            } else if (data.status === 0) {
                restart();
            } else if (data.status === 1) {
                // 进行中
                if (stayPage === false) {
                    doSuccess();
                } else {
                    if (!callback) {
                        api.toast({
                            msg: MSG.general.success,
                            duration: 2000,
                            location: 'middle'
                        });
                    } else {
                        callback();
                    }
                }
            } else if (data.status === 3) {
                // 进行中
                if (stayPage === false) {
                    doSuccess();
                } else {
                    loading('hide');
                    if (!callback) {
                        api.toast({
                            msg: MSG.general.success,
                            duration: 2000,
                            location: 'middle'
                        });
                    } else {
                        callback();
                    }
                }
            }

            function restart() {
                console.log('【loopTaskStatus】：未完成');
                // 进行中，再次触发请求
                setTimeout(function () {
                    if (that.fetchTaskCount < that.FETCH_TASK_TOTAL_TIMES) {
                        that.loopTaskStatus(taskId);
                    } else {
                        if (stayPage === false) {
                            doSuccess();
                        } else {
                            api.toast({
                                msg: MSG.general.success,
                                duration: 2000,
                                location: 'middle'
                            });
                        }
                    }
                }, that.FETCH_TASK_LOOP_TIME);
            }
        } else {
            api.toast({
                msg: MSG.tips.systemError,
                duration: 2000,
                location: 'middle'
            });
        }

        function doSuccess() {
            api.toast({
                msg: MSG.general.success,
                duration: 2000,
                location: 'middle'
            });
            setTimeout(function () {
                api.closeWin();
            }, 2000);
        }

    });
};
apiTask.loopTaskList = function (taskCode, currentStatus, callback) {
    var that = this;
    var url = "/api-task/usertask/main";
    var lang = (lan === "zh" ? "zh_CN" : "en_US");
    var param = {
        "lang": lang,
        "userId": localStorage.getItem('userId')
    };
    console.info("[" + api.deviceName + "] loopTaskList begin : " + taskCode);
    this.fetchTaskCount++;
    apiTask.get(url, param).done(function (rep) {
        if (rep.code === 0) {
            var list = rep.tasks;
            // that.tasksList = list;
            var newList = [].concat(list.novices).concat(list.dailys);
            var changedStatus = getStatusByCode(newList, taskCode);
            // 如果状态没有发生改变，继续轮训
            console.log('changedStatus: ' + changedStatus);
            if (currentStatus === changedStatus) {
                console.info("[" + api.deviceName + "] loopTaskList loop : " + that.fetchTaskCount);
                // 进行中，再次触发请求
                setTimeout(function () {
                    if (that.fetchTaskCount <= that.FETCH_TASK_TOTAL_TIMES) {
                        that.loopTaskList(taskCode, currentStatus, callback);
                    }
                }, that.FETCH_TASK_LOOP_TIME);
            } else {
                console.info("[" + api.deviceName + "] loopTaskList Success : " + taskCode);
                that.fetchTaskCount = 0;
                callback && callback(changedStatus);
            }
        } else {
            console.error({ msg: JSON.stringify(rep) });
        }
    });

    function getStatusByCode(list, taskCode) {
        var item;
        for (var i = 0, len = list.length; i < len; i++) {
            item = list[i];
            if (item.id === taskCode) {
                return item.status;
            }
        }
    }
};

var TaskService = function (taskCode, initOnLoaded, onCloseCallback) {
    this.taskCode = taskCode;
    this.hasFinished = false;
    this.initOnLoaded = initOnLoaded;
    this.novicesStatusMap = {};
    this.onCloseCallback = onCloseCallback;
    this.init();
};
TaskService.prototype.init = function () {
    var that = this;
    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    }) || localStorage.getItem('access_token') || '';
    if (token) {
        apiTask.get('/api-task/usertask/main', {
            userId: localStorage.getItem('userId'),
            lang: lan === 'zh' ? 'zh_CN' : 'en_US'
        }).done(function (rep) {
            if (rep.code === 0) {
                var list = rep.tasks.novices;
                var item;
                for (var i = 0, len = list.length; i < len; i++) {
                    item = list[i];
                    that.novicesStatusMap[item.id] = item.status;
                    if (item.id === that.taskCode) {
                        if (item.status === 2) {
                            that.hasFinished = true;
                        } else {
                            that.hasFinished = false;
                            if (that.initOnLoaded === true) {
                                that._showDialog();
                            }
                        }
                        break;
                    }
                }
            } else {
                console.error(JSON.stringify(rep));
            }
        });
    }
};
TaskService.prototype.check = function (successCallback) {
    if (this.hasFinished === true) {
        successCallback && successCallback();
    } else {
        this._showDialog();
    }
};
TaskService.prototype._showDialog = function() {
    var that = this;
    if (this.taskCode === TASK_CODE.GROUP_PERSON_PROFILE) {
        dialog({
            title: MSG.novice.dialogFunctionTitle,
            content: MSG.novice.dialogFuntionDesc1,
            primaryText: MSG.novice.btnText,
            onPrimary: function() {
                openTabLayout('novice', '', 'widget://html/frame/novice.html', {
                    id: TASK_CODE.GROUP_PERSON_PROFILE
                });
            },
            onClose: function () {
                console.log('on close ...');
                if (that.onCloseCallback) {
                    that.onCloseCallback();
                }
            }
        });
    } else if (this.taskCode === TASK_CODE.GROUP_ADD_SHOWCASE) {
        dialog({
            title: MSG.novice.dialogFunctionTitle,
            content: MSG.novice.dialogFuntionDesc2,
            primaryText: MSG.novice.btnText,
            onPrimary: function() {
                var partId = TASK_CODE.GROUP_ADD_SHOWCASE;
                if (that.novicesStatusMap[TASK_CODE.GROUP_PERSON_PROFILE] !== 2) {
                    partId = TASK_CODE.GROUP_PERSON_PROFILE;
                }
                openTabLayout('novice', '', 'widget://html/frame/novice.html', {
                    id: partId
                });
            },
            onClose: function () {
                console.log('on close ...');
                if (that.onCloseCallback) {
                    that.onCloseCallback();
                }
            }
        });
    } else if (this.taskCode === TASK_CODE.GROUP_CREATE_DIGITAL) {
        dialog({
            title: MSG.novice.dialogFunctionTitle,
            content: MSG.novice.dialogFuntionDesc2,
            primaryText: MSG.novice.btnText,
            onPrimary: function() {
                var partId = TASK_CODE.GROUP_CREATE_DIGITAL;
                if (that.novicesStatusMap[TASK_CODE.GROUP_ADD_SHOWCASE] !== 2) {
                    partId = TASK_CODE.GROUP_ADD_SHOWCASE;
                }
                if (that.novicesStatusMap[TASK_CODE.GROUP_PERSON_PROFILE] !== 2) {
                    partId = TASK_CODE.GROUP_PERSON_PROFILE;
                }
                openTabLayout('novice', '', 'widget://html/frame/novice.html', {
                    id: partId
                });
            },
            onClose: function () {
                console.log('on close ...');
                if (that.onCloseCallback) {
                    that.onCloseCallback();
                }
            }
        });
    }
};
TaskService.prototype.refresh = function () {
    this.init();
};

var mediaHost;
if (SERVER_HOSTS.dev === false) {
    if (localStorage.getItem('server') === 'cn') {
        mediaHost = SERVER_HOSTS.MEDIA_UPLOAD.PROD_CN;
    } else {
        mediaHost = SERVER_HOSTS.MEDIA_UPLOAD.PROD_COM;
    }
} else {
    mediaHost = SERVER_HOSTS.MEDIA_UPLOAD.TEST;
}
var apiMedia = new ApiService(mediaHost);

apiMedia.upload = function (url, filepath, headers) {
    var defer = $.Deferred();
    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    }) || localStorage.getItem('access_token') || '';
    var currentHeader = {
        // 'Content-Type': 'multipart/form-data',
        lang: lan === 'zh' ? 'zh_CN' : 'en_US',
        userId: localStorage.getItem('userId'),
        userName: localStorage.getItem('userName'),
        token: 'Bearer ' + token
    };
    if (headers) {
        $.extend(currentHeader, headers);
    }
    api.ajax({
        url: this.baseUrl + url,
        method: 'POST',
        headers: currentHeader,
        data: {
            files: {
                files: filepath
            }
        },
        timeout: 90,
        dataType: 'json',
        returnAll: true,
        report: true
    }, function(response, err) {
        console.warn("[" + api.deviceName + "] [ApiService] [UPLOAD] : " + JSON.stringify(response));
        console.warn('[UPload] Progress : ' + response.progress);

        if (err) {
            console.error("[" + api.deviceName + "] [ApiService] [UPLOAD] : " + JSON.stringify(err));
        }
        if (response.progress === 100 && response.status === 1) {
            console.log("[" + api.deviceName + "]" + "文件上传完成");
            defer.resolve(response.body);
        } else if (response.progress === 100 && response.status === 2) {
            console.error("[" + api.deviceName + "] [ApiService] [UPLOAD] : " + JSON.stringify(response.body));
            alert(JSON.stringify(response.body));
        }
    });

    // $.ajax({
    //     "url": this.baseUrl + "/upload/images",
    //     "method": "POST",
    //     "timeout": 0,
    //     "processData": false,
    //     "mimeType": "multipart/form-data",
    //     "contentType": false,
    //     "data": formdata,
    //     "dataType": 'json'
    // }).done(function (data) {
    //     // console.log("[" + api.deviceName + "]: " + JSON.stringify(data));
    //     defer.resolve(data);
    // }).fail(function (err) {
    //     console.error("[" + api.deviceName + "]: " + JSON.stringify(err));
    //     // console.error(JSON.stringify(err));
    //     defer.resolve(err);
    // });

    return defer;
};

apiMedia.uploadVideo = function (url, filepath) {
    console.log('111111: filepath: ' + filepath);
    var defer = $.Deferred();
    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    }) || localStorage.getItem('access_token') || '';
    var currentHeader = {
        // 'Content-Type': 'multipart/form-data',
        lang: lan === 'zh' ? 'zh_CN' : 'en_US',
        userId: localStorage.getItem('userId'),
        userName: localStorage.getItem('userName'),
        token: 'Bearer ' + token
    };
    api.ajax({
        url: this.baseUrl + url,
        method: 'POST',
        headers: currentHeader,
        data: {
            files: {
                files: filepath
            }
        },
        timeout: 120,
        dataType: 'json',
        returnAll: true,
        report: true
    }, function(response, err) {
        console.log("[" + api.deviceName + "] [ApiService] [UPLOAD] : " + JSON.stringify(response));
        // console.log('[UPload] Progress : ' + response.progress);
        if (err) {
            console.error("[" + api.deviceName + "] [ApiService] [UPLOAD] : " + JSON.stringify(err));
        }
        if (response.progress < 100) {
            api.showProgress({
                title: MSG.general.uploading,
                text: response.progress + '%',
                modal: false
            });
            // } else if (response.progress === 100 && response.status === 0) {
            //     api.showProgress({
            //         title: MSG.general.zipVideo,
            //         text: MSG.general.waiting,
            //         modal: false
            //     });
        } else if (response.progress === 100 && response.status === 1) {
            defer.resolve(response.body);
        } else if (response.progress === 100 && response.status === 2) {
            console.error("[" + api.deviceName + "] [ApiService] [UPLOAD] : " + response.body.message);
            alert(response.body.msg);
        }
    });

    return defer;
};

var guideService = {
    GUIDE_APP_BOOT: {
        key: 'GUIDE_APP_BOOT',
        page: 'widget://html/guide/guide-app.html'
    },
    GUIDE_VERSION: {
        key: 'GUIDE_VERSION',
        page: 'widget://html/guide/guide-version.html'
    },
    GUIDE_HOME: {
        key: 'GUIDE_HOME',
        page: 'widget://html/guide/guide-home.html'
    },
    GUIDE_SHOWROOM: {
        key: 'GUIDE_SHOWROOM',
        page: 'widget://html/guide/guide-showroom.html'
    },
    GUIDE_EVALUATION: {
        key: 'GUIDE_EVALUATION',
        page: 'widget://html/guide/guide-evaluation.html'
    },
    GUIDE_CHAT: {
        key: 'GUIDE_CHAT',
        page: 'widget://html/guide/guide-chat.html'
    },
    GUIDE_MINE: {
        key: 'GUIDE_MINE',
        page: 'widget://html/guide/guide-mine.html'
    },
    GUIDE_TYCOON_MINE: {
        key1: 'GUIDE_TYCOON_MINE',
        key2: 'GUIDE_TYCOON_PRODUCT',
        key3: 'GUIDE_TYCOON_PHOTO',
    },
    GUIDE_TYCOON_VIEW: {
        key: 'GUIDE_TYCOON_VIEW',
        page: 'widget://html/guide/guide-tycoon.html'
    },
    check: function (key) {
        // return false;
        var hasShow = api.getPrefs({
            key: key,
            sync: true
        });
        if (!hasShow) {
            return false;
        } else {
            return true;
        }
    },
    openGuidePage: function(key, pageParam) {
        api.openFrame({
            name: key,
            url: guideService[key].page,
            rect: {
                x: 0,
                y: 0,
                w: 'auto',
                h: 'auto'
            },
            bounces: false,
            bgColor: 'rgba(0, 0, 0, 0)',
            fixedOn: 'ui_layout',
            animation:{
                type: "fade",
            },
            pageParam: pageParam
        });
    },
    closeGuidePage: function(key) {
        api.setPrefs({
            key: key,
            value: 1
        });
        setTimeout(function () {
            api.closeFrame({
                name: key
            });
        }, 200);
    },
    /**
     * 主页面引导
     * @param config
     * mode
     * left, right, top, bottom
     * width,
     * height,
     * content
     * textAlign
     * inPage
     */
    setGuide: function(config) {
        var safeBottom;
        if (config.addSafe === false) {
            safeBottom = 0;
        } else {
            safeBottom = api.safeArea.bottom || 0;
        }
        var $body = $('body');
        var mode = config.mode;
        var $dom;
        switch (mode) {
            case 'leftTop':
                $dom = $('<div class="ui-guide left-top">\n' +
                    '        <div class="guide-circle">\n' +
                    '            <div class="circle-box"></div>' +
                    '            <div class="guide-line">\n' +
                    '                <div class="guide-content">\n' +
                    '                    <div class="content-text">' + config.content + '</div>\n' +
                    '                </div>\n' +
                    '            </div>\n' +
                    '        </div>\n' +
                    '    </div>');
                $dom.css({
                    left: config.left,
                    top: config.top,
                });
                $dom.find('.guide-circle').css({
                    width: config.width,
                    height: config.height
                });
                $dom.find('.guide-content').css({
                    top: config.top + config.height / 2 + 44
                });
                break;
            case 'top':
                $dom = $('<div class="ui-guide top">\n' +
                    '        <div class="guide-circle">\n' +
                    '            <div class="circle-box"></div>' +
                    '            <div class="guide-line">\n' +
                    '                <div class="guide-content">\n' +
                    '                    <div class="content-text">' + config.content + '</div>\n' +
                    '                </div>\n' +
                    '            </div>\n' +
                    '        </div>\n' +
                    '    </div>');
                $dom.css({
                    left: config.left,
                    top: config.top,
                });
                $dom.find('.guide-circle').css({
                    width: config.width,
                    height: config.height
                });
                $dom.find('.guide-content').css({
                    top: config.top + config.height + 46
                });
                break;
            case 'rightTop':
                $dom = $('<div class="ui-guide right-top">\n' +
                    '        <div class="guide-circle">\n' +
                    '            <div class="circle-box"></div>' +
                    '            <div class="guide-line">\n' +
                    '                <div class="guide-content">\n' +
                    '                    <div class="content-text">' + config.content + '</div>\n' +
                    '                </div>\n' +
                    '            </div>\n' +
                    '        </div>\n' +
                    '    </div>');
                $dom.css({
                    right: config.right,
                    top: config.top,
                });
                $dom.find('.guide-circle').css({
                    width: config.width,
                    height: config.height
                });
                $dom.find('.guide-content').css({
                    top: config.top + config.height / 2 + 44
                });
                break;
            case 'rightBottom':
                $dom = $('<div class="ui-guide right-bottom">\n' +
                    '        <div class="guide-circle">\n' +
                    '            <div class="circle-box"></div>' +
                    '            <div class="guide-line">\n' +
                    '                <div class="guide-content">\n' +
                    '                    <div class="content-text">' + config.content + '</div>\n' +
                    '                </div>\n' +
                    '            </div>\n' +
                    '        </div>\n' +
                    '    </div>');
                $dom.css({
                    right: config.right,
                    bottom: config.bottom + safeBottom,
                });
                $dom.find('.guide-circle').css({
                    width: config.width,
                    height: config.height
                });
                $dom.find('.guide-content').css({
                    bottom: config.bottom + config.height / 2 + 44 + safeBottom
                });
                break;
        }
        if (config.textAlign && config.textAlign === 'left') {
            $dom.find('.guide-content').css({
                left: '-10%'
            });
        }
        if (config.textAlign && config.textAlign === 'right') {
            $dom.find('.guide-content').css({
                left: 'auto',
                right: '-10%'
            });
        }
        if (config.borderRadius && config.borderRadius === 'none') {
            $dom.find('.guide-circle').css({
                borderRadius: 6
            });
            $dom.find('.circle-box').css({
                borderRadius: 6
            });
        }
        if (config.container) {
            config.container.html($dom);
        } else {
            $body.html($dom);
        }
        function toRem(pxValue) {
            return pxValue / 10 + 'rem';
        }
    },
    hideGuide: function (key) {
        api.setPrefs({
            key: key,
            value: 1
        });
    },
    reset: function (key) {
        if (key) {
            api.removePrefs({
                key: key,
            });
            return;
        }
        api.removePrefs({
            key: guideService.GUIDE_HOME.key,
        });
        api.removePrefs({
            key: guideService.GUIDE_SHOWROOM.key,
        });
        api.removePrefs({
            key: guideService.GUIDE_EVALUATION.key,
        });
        api.removePrefs({
            key: guideService.GUIDE_CHAT.key,
        });
        api.removePrefs({
            key: guideService.GUIDE_TYCOON_VIEW.key,
        });
        api.removePrefs({
            key: guideService.GUIDE_TYCOON_MINE.key1,
        });
        api.removePrefs({
            key: guideService.GUIDE_TYCOON_MINE.key2,
        });
        api.removePrefs({
            key: guideService.GUIDE_TYCOON_MINE.key3,
        });
        api.removePrefs({
            key: guideService.GUIDE_VERSION.key,
        });
        api.removePrefs({
            key: guideService.GUIDE_MINE.key,
        });
    }
};

// 用户备注昵称服务
var userRemarkService = {
    storageKey: 'userRemarkMap',
    userMap: {
        // '1918156': {
        //     "UpdatedUtc": "2021-01-08T02:50:51.4610511",
        //     "IdNoted": 1918520,  //被备注推主Id
        //     "GuidNoted": "290d7085-9e78-4202-b3ab-1dca6207dec8", //被备注推主Guid
        //     "Sname": "tw1609991576000",  //Store Name  店名
        //     "Note": "测试 0 test",
        //     "Uname": "tw1609991576000" //User Name  用户名
        // },
        // '1871544': {
        //     "UpdatedUtc": "2021-01-08T02:50:51.4610511",
        //     "IdNoted": 1918520,  //被备注推主Id
        //     "GuidNoted": "290d7085-9e78-4202-b3ab-1dca6207dec8", //被备注推主Guid
        //     "Sname": "tw1609991576000",  //Store Name  店名
        //     "Note": "测试 1 test",
        //     "Uname": "tw1609991576000" //User Name  用户名
        // }
    },
    init: function () {
        this.fetchData();
    },
    has: function(userId) {
        var userMap = {};
        var kv = api.require('snKVStorage');
        var hasRemarkData = kv.has({
            key: this.storageKey,
        });
        if (hasRemarkData) {
            userMap = kv.getObject({
                key: this.storageKey,
            });
        }
        if (userMap[userId]) {
            return true;
        } else {
            return false;
        }
    },
    getStorageMap: function() {
        var userMap = {};
        var kv = api.require('snKVStorage');
        var hasRemarkData = kv.has({
            key: this.storageKey,
        });
        if (hasRemarkData) {
            userMap = kv.getObject({
                key: this.storageKey,
            });
        }
        return userMap;
    },
    get: function(userId, storeName) {
        // if (!userId) {
        //     console.log('The userId is null');
        // }
        var userMap = this.getStorageMap();
        if (userMap[userId]) {
            return userMap[userId].Note;
        } else {
            return storeName;
        }
    },
    set: function (userId, name, callback) {
        var that = this;
        loading('show');
        getAxois(getBaseUrl() + "api/v1/tycoonnote", "PUT", {
            TycoonId: localStorage.getItem('userId'),
            Note: name,
            IdNoted: userId
        }).then(function (response) {
            loading('hide');
            if (response.data.Code === 0) {
                // api.toast({
                //     msg: MSG.general.success,
                //     duration: 2000,
                //     location: 'middle'
                // });
                var userMap = that.getStorageMap();
                userMap[userId] = {
                    Note: name
                };
                var kv = api.require('snKVStorage');
                kv.setObject({
                    key: that.storageKey,
                    value: userMap
                });
                if ($.isFunction(callback) === true) {
                    callback();
                }
            } else {
                api.toast({
                    msg: MSG.tips.systemError,
                    duration: 2000,
                    location: 'middle'
                });
            }
        });
    },
    fetchData: function () {
        var that = this;
        var params = {
            TycoonId: localStorage.getItem('userId'),
            TycoonGuid: localStorage.getItem('userGuid'),
            Note: '',
            Pg: 0,
            Nu: 100
        };
        getAxois(getBaseUrl() + "api/v1/tycoonnotesls", "POST", params).then(function (response) {
            if (response.status === 200) {
                var data = response.data;
                var map = {};
                $.map(data, function (item) {
                    map[item.IdNoted] = item;
                });
                var kv = api.require('snKVStorage');
                kv.setObject({
                    key: that.storageKey,
                    value: map
                });
            } else {
                console.error('tycoonnotesls');
                api.toast({
                    msg: MSG.tips.systemError,
                    duration: 2000,
                    location: 'middle'
                });
            }
        });
    },
    open: function (pageParam, callback) {
        api.openFrame({
            name: 'dialog-remark',
            url: 'widget://html/dialog/dialog-remark.html',
            rect: {
                x: 0,
                y: 0,
                w: 'auto',
                h: 'auto'
            },
            pageParam: pageParam,
            bounces: false,
            bgColor:'rgba(0,0,0,0)',
            fixedOn: 'ui_layout'
        });
        api.removeEventListener({
            name: 'dialogRemarkSuccess'
        });
        api.addEventListener({
            name: 'dialogRemarkSuccess'
        }, function(ret, err) {
            if (callback && $.isFunction(callback) === true) {
                callback(ret.value.name);
            }
        });
    }
};

// 数字产品下载
function downloadProdManager(url,prodName,prodId,xName,pic,fileType,needOpen) {
    var t;
    var downloadManager = api.require('downloadManager');
    downloadManager.enqueue({
        url: url,
        savePath: 'fs://downloadPord'+ Date.parse(new Date()) +'.' + xName,
        cache: true,
        allowResume: true,
        title: prodName + "##" + prodId,
        iconPath:pic,
        networkTypes: 'all'
    }, function(ret, err) {
        if (ret) {
            api.showProgress({
                title: MSG.general.downloading,
                text: '0 KB',
                modal: false
            });
            t = setTimeout(function () {

                getDownloadStatus(ret.id);
            }, 2000);
        }
    });

    function getDownloadStatus(id) {
        downloadManager.query({
            ids:[id]
        }, function(ret, err) {
            var status = ret.data[0].status;
            if (status === 1) {
                api.showProgress({
                    title: MSG.general.downloading,
                    text:  Math.round(ret.data[0].finishSize / 1024) + ' KB',
                    modal: false
                });
                getDownloadStatus(id);
            }else if(status === 3){
                console.log(JSON.stringify(ret));
                api.hideProgress();
                clearTimeout(t);
                // if(fileType === 'audios'){
                //     openTabLayout('audioPlayer','', 'widget://html/business/audio-player.html',{
                //         url:ret.data[0].savePath,
                //         title:prodName,
                //         pic:that.repData.Items[0].Product.FeaturedPicture.ThumbnailUrl,
                //         prodId:prodId
                //     });
                // }else if(fileType ==='image'){
                //     openTabLayout('imgPlayer','', 'widget://html/business/image-player.html',{
                //         url:ret.data[0].savePath,
                //         prodId:prodId
                //     });
                // }

                if(needOpen){

                    openDigitalProd(ret.data[0].savePath,fileType,prodName,prodId,pic);
                }


            }
        });
    }
}
function openDigitalProd(url,type,prodName,prodId,pic,xName) {

    var pageName,pageUrl;
    switch (type) {
        case 'audios':
            pageName = 'audioPlayer';
            pageUrl = 'widget://html/business/audio-player.html';
            break;
        case 'image':
            pageName = 'imgPlayer';
            pageUrl = 'widget://html/business/image-player.html';
            break;
        case 'video':
            pageName = 'videoPlayer';
            pageUrl = 'widget://html/business/video-player.html';
            break;
        case 'pdf':
            pageName = 'pdfPlayer';
            pageUrl = 'widget://html/business/pdfreader.html';
            break;
        case 'other':
            pageName = 'otherFile';
            pageUrl = 'widget://html/business/other-player.html';
            break;
    }

    openTabLayout(pageName,'', pageUrl,{
        url:url,
        title:prodName,
        pic:pic,
        prodId:prodId,
        xName:xName
    });
}

/*
* Rate 评分
* @param { Object } options 参数
* @param { Number } options.rate 评分
* @param { Function } options.callback 点击评分后回调函数  @return { Number } rate
* @param { DOM } options.dom 评分组件容器
* @param { Boolean } isModify 是否允许修改评分
*
* 例子
*
new Rate({
    dom: document.querySelector('body'),
    rate: 1.1,
    callback: function(rate){ console.log(rate) },
});
*
* */

function Rate(options){
    this.root = options.dom;
    var rate = Number(options.rate);
    if (rate > 5){
        rate = 5;
    }
    if (rate < 0){
        rate = 0;
    }
    this.rate = rate || 0;
    this.callback = options.callback || function(){};
    this.isModify = options.isModify || false;
    this.init();
}

Rate.prototype = {
    constructor: Rate,
    init: function(){
        this.root.innerHTML = this.createDom();
        if (this.isModify){
            this.bindEvent();
        }
    },
    bindEvent: function(){
        $(this.root).find('li').each(function(index, target){
            $(target).click(function(){
                this.rate = index + 1;
                this.callback(this.rate);
                this.resetRate();
            }.bind(this));
        }.bind(this));
    },
    resetRate: function(){
        $(this.root).find('img').each(function(index, target){
            var p = 'start-empty.png';
            var inx = index;
            if (this.rate > inx){
                if ((this.rate - inx) >= 1){
                    p = 'start.png';
                }else {
                    p = 'start-half.png';
                }
            }
            target.src = '../../image/common/' + p;
        }.bind(this));
    },
    createDom: function (){
        var html = '';
        for(var i = 0, len = 5; i < len; i++){
            var p = 'start-empty.png';
            var inx = i;
            if (this.rate > inx){
                if ((this.rate - inx) >= 1){
                    p = 'start.png';
                }else {
                    p = 'start-half.png';
                }
            }
            var src = '../../image/common/' + p;
            html += '<li class="start"><img src=' + src + '></li>'
        }
        return '<ul class="star-list">' + html + '</ul>';
    },
};

function renderStars(value) {
    var html = '';
    for(var i = 0, len = 5; i < len; i++){
        var p = 'start-empty.png';
        var inx = i;
        if (value > inx){
            if ((value - inx) >= 1){
                p = 'start.png';
            }else {
                p = 'start-half.png';
            }
        }
        var src = '../../image/common/' + p;
        html += '<li class="start"><img src=' + src + '></li>'
    }
    return '<ul class="star-list">' + html + '</ul>';
}

var announcementUtil = {
    saveLocalAnnouncement: function(announcement) {
        announcement.hasRead = false;
        var kv = api.require('snKVStorage');
        var announcementsMap = {};
        var hasAnnouncementsMap = kv.has({
            key: 'announcementsMap'
        });
        if (hasAnnouncementsMap) {
            announcementsMap = kv.getObject({
                key: 'announcementsMap'
            });
        }
        announcementsMap[announcement.id] = announcement;
        kv.setObject({
            key: 'announcementsMap',
            value: announcementsMap
        });
    },
    clearLocalAnnouncement: function() {
        var kv = api.require('snKVStorage');
        kv.removeKey({
            key: 'announcementsMap'
        });
    },
    getUnreadAnnouncementsNumber: function() {
        var kv = api.require('snKVStorage');
        var announcementsMap = {};
        var hasAnnouncementsMap = kv.has({
            key: 'announcementsMap'
        });
        var result = 0;
        if (hasAnnouncementsMap) {
            announcementsMap = kv.getObject({
                key: 'announcementsMap'
            });
            $.map(announcementsMap, function (item) {
                if (item.hasRead === false) {
                    result++;
                }
            });
            console.log('result: ' + result);
        }
        return result;
    }
};

function buildnStyles(w, h, data){
    var back = {
        type : 'button',// 按钮类型:button,text,music(带动画的音乐按钮),autoText(跑马灯)
        x: 30,
        y: 60,
        w: 40,
        h: 40,
        pic : 'widget://image/back2.png',//按钮图片路径;音乐按钮背景图（支持路径fs:// widget:// 类型：png gif ）
        pic1 : 'widget://image/gif1.gif',//音乐按钮中间logo图片路径（支持路径fs:// widget:// 类型：png gif ）
        isRadius : false,//是否进行圆形图片按钮处理;音乐按钮是否开启动画，默认:false
        lineColor : '',//设置描边颜色,默认无
        text : '分享',//文本内容
        textSize : 12, //字体大小
        textColor : '',//字体颜色
        gravity : 0,// 文字位置 0:center 1 : left 2 :right (水平)
        vertical : 0,// 文字位置 0:top 1 : middle 2 :bottom (垂直)
        name : 'back',
    }

    var share = {
        type : 'button',// 按钮类型:button,text,music(带动画的音乐按钮),autoText(跑马灯)
        x: w - 60,
        y: h - 260,
        w: 40,
        h: 40,
        pic : 'widget://image/share0.png',//按钮图片路径;音乐按钮背景图（支持路径fs:// widget:// 类型：png gif ）
        pic1 : 'widget://image/gif1.gif',//音乐按钮中间logo图片路径（支持路径fs:// widget:// 类型：png gif ）
        isRadius : false,//是否进行圆形图片按钮处理;音乐按钮是否开启动画，默认:false
        lineColor : '',//设置描边颜色,默认无
        text : '分享',//文本内容
        textSize : 12, //字体大小
        textColor : '',//字体颜色
        gravity : 0,// 文字位置 0:center 1 : left 2 :right (水平)
        vertical : 0,// 文字位置 0:top 1 : middle 2 :bottom (垂直)
        name : 'share',
    }

    var like = {
        type : 'text',// 按钮类型:button,text,music(带动画的音乐按钮),autoText(跑马灯)
        x: w - 60,
        y: h - 320,
        w: 40,
        h: 40,
        pic : 'widget://image/gif1.gif',//按钮图片路径;音乐按钮背景图（支持路径fs:// widget:// 类型：png gif ）
        pic1 : 'widget://image/gif1.gif',//音乐按钮中间logo图片路径（支持路径fs:// widget:// 类型：png gif ）
        isRadius : false,//是否进行圆形图片按钮处理;音乐按钮是否开启动画，默认:false
        lineColor : '',//设置描边颜色,默认无
        text : '点赞',//文本内容
        textSize : 12, //字体大小
        textColor : '',//字体颜色
        gravity : 0,// 文字位置 0:center 1 : left 2 :right (水平)
        vertical : 0,// 文字位置 0:top 1 : middle 2 :bottom (垂直)
        name : 'like',
    }
    var avatar = {
        type: 'button',
        x: w - 65,
        y: h - 400,
        w: 50,
        h: 50,
        pic : data.userInfo.thumbnail,//按钮图片路径;音乐按钮背景图（支持路径fs:// widget:// 类型：png gif ）
        pic1 : 'widget://image/gif1.gif',//音乐按钮中间logo图片路径（支持路径fs:// widget:// 类型：png gif ）
        isRadius : true,//是否进行圆形图片按钮处理;音乐按钮是否开启动画，默认:false
        lineColor : '',//设置描边颜色,默认无
        text : '头像',//文本内容
        textSize : 12, //字体大小
        textColor : '',//字体颜色
        gravity : 0,// 文字位置 0:center 1 : left 2 :right (水平)
        vertical : 0,// 文字位置 0:top 1 : middle 2 :bottom (垂直)
        name : 'avatar',
    };
    return [share, like, avatar, back];
}

function buiidStyles(w, h) {

    //code  0 返回  1 右滑 2 单击  3 双击  4滑到最后一个视频返回5 播放记录放回index滚动到播放记录索引 6播放 7 暂停 8 缓冲返回 9 网络错误 10播放完成 11长按事件
    //按钮类型:music(带动画的音乐按钮),comment(评论),share(分享),like(红心点赞),avatar(头像),focus(关注),title(标题),desc(简介),musicName(音乐滚动字幕),component自定义组件 支持gif,
    //xywh 控件 位置 大小
    //pic 图片 音乐封面 图标图片 按钮背景图片等
    //pic1 评论输入框 pic1 图标 pic2 发送图标
    //component 自定义控件  radius 圆角值 backgroundColor 背景色 border 边框 borderColor边框颜色 scroll 是否随视频滚动
    //alignment 文字对齐0:居中 1上左对齐 2上中对齐 3上右对齐 4上两端对齐 5下左对齐 6下中对齐 7下右对齐 8下两端对齐 9居中两端对齐
    //textSize:14  文字大小 textColor:'#C0FF3E' 文字颜色 alpha 背景透明度
    //hidden 是否隐藏  processColor 进度条颜色(需要进度条添加)
    //code:16//控件标识  同时作为点击事件返回码 0-15占用 不能使用 组件 code值不能重复 rect 图片位置(相对父组件component位置)
    //  红包     音乐   分销    评论     点赞   头像     关注    视频简介 用户名    音乐名      自定义组件
    var music, share, comment, like, avatar, focus, title, userName, musicName, component, compon;
    music = {
        type: 'music',
        x: w - 65,
        y: h - 120,
        w: 80,
        h: 80,
        pic: 'widget://image/icon_music_cover.png',
        code: 16,
        hidden: false
    }; //旋转音乐
    share = {
        type: 'share',
        x: w - 60,
        y: h - 260,
        w: 40,
        h: 40,
        pic: '',
        code: 17,
        hidden: false,
        num: {
            hidden: true,
            textColor: '#C0FF3E',
            textSize: 12,
            x: w - 60,
            y: h - 160,
            w: 40,
            h: 40
        }
    }; //分享
    comment = {
        type: 'comment',
        x: w - 60,
        y: h - 260,
        w: 40,
        h: 40,
        pic: '',
        code: 18,
        hidden: false,
        num: {
            hidden: false,
            textColor: '#C0FF3E',
            textSize: 12,
            x: w - 60,
            y: h - 220,
            w: 40,
            h: 40
        }
    }; //评论
    like = {
        type: 'like',
        x: w - 60,
        y: h - 320,
        w: 40,
        h: 40,
        pic: 'widget://image/video-like.png',
        pic1: 'widget://image/video-like-1.png',
        code: 19,
        hidden: false,
        num: {
            hidden: false,
            textColor: '#FFFFFF',
            textSize: 12,
            x: w - 60,
            y: h - 280,
            w: 40,
            h: 40
        }
    }; //红心点赞
    avatar = {
        type: 'avatar',
        x: w - 65,
        y: h - 400,
        w: 50,
        h: 50,
        pic: '',
        radius: 25,
        border: 2,
        borderColor: '#E066FF',
        code: 20,
        hidden: false
    }; //头像
    userName = {
        type: 'userName',
        x: 10,
        y: h - 200,
        w: 150,
        h: 40,
        textSize: 16,
        textColor: '#FFFFFF',
        code: 21,
        hidden: false
    }; //视频简介
    title = {
        type: 'title',
        x: 10,
        y: h - 160,
        w: w - 120,
        h: 80,
        code: 22,
        textSize: 14,
        textColor: '#FFFFFF',
        hidden: false
    }; //用户名
    musicName = {
        type: 'musicName',
        x: 20,
        y: h - 80,
        w: w - 130,
        h: 30,
        textSize: 16,
        textColor: '#FFFFFF',
        code: 23,
        hidden: false
    }; //头像
    focus = {
        type: 'focus',
        x: w - 55,
        y: h - 365,
        w: 30,
        h: 30,
        pic: '',
        code: 25,
        hidden: false
    }; //关注
    component = {
        type: 'component',
        x: 10,
        y: h - 45,
        w: w - 20,
        h: 40,
        radius: 10,
        backgroundColor: '#000000',
        alpha: 0.1,
        border: 0,
        borderColor: '#01000000',
        code: 27,
        hidden: false,
        animation:0,
        pics:[{path:'widget://image/pan.png',x:10,y:10,w:20,h:20,code:271}],
        texts:[{x:0,y:0,w:120,h:40,text:'说点什么',textSize:14,textColor:'#C0FF3E',alignment:0,code:272}]
    }; //自定义控件 评论输入框
    compon = {
        type: 'component',
        x:20,
        y:h-300,
        w:140,
        h:70,
        radius:5,
        backgroundColor:'#000000',
        alpha:0.5,
        border:0,
        borderColor:'#E066FF',
        code:26,
        hidden:false,
        animation:0,
        pics:[{path:'widget://image/product.jpg',x:0,y:0,w:70,h:70,code:261},{path:'widget://image/icon_close.png',x:125,y:0,w:15,h:15,code:262}],
        texts:[{x:80,y:40,w:60,h:20,text:'商品',textSize:12,textColor:'#FFFFFF',alignment:0,code:263}]
    };//商品
    var styles = [avatar, focus, like, share];
    return styles;
}

function videoLikeFunction(vid, guid, isLike, likeNum){
    var userId = localStorage.getItem('userId');
    var url =  getBaseUrl() + 'api/users/'+ userId +'/like?&momentId='+ vid ;
    api.sendEvent({
        name: 'resetPost',
        extra: {
            type: "like",
            index: vid,
            liked:isLike,
            likedCount: likeNum,
            from: 'video'
        }
    });
    var TZ = Intl.DateTimeFormat().resolvedOptions().timeZone;
    var LT = moment().format('YYYY-MM-DDThh:mm:ss');
    var obj = {
        "tz":TZ,
        "tl":LT,
        "PostId" : vid,
        "PostGuid": guid,
        "OI" : localStorage.getItem('userId'),
        "OG":localStorage.getItem('userGuid')
    };
    api.sendEvent({
        name: 'likeAPI',
        extra: {
            url: url,
            obj: obj
        }
    });
}

function getTagById(tagId) {
    var result;
    for (var i = 0, len = POST_TAGS.length; i < len; i++) {
        var item = POST_TAGS[i];
        if (item.Id === +tagId) {
            result = item;
            break;
        }
    }
    return result;
}

function getScript(url){
    const promise = new Promise(function(resolve, reject) {
        var script = document.createElement('script');
        var head = document.querySelector('head');
        script.onload = function() {
            resolve();
        };
        script.onerror = function(err) {
            reject(err);
        };
        script.src = url;
        head.appendChild(script);
    });
    return promise;
}

function isEmail(email) {
    var regEmail = /^\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+$/;
    return regEmail.test(email);
}

function getTweeLogType(){
    const promise = new Promise(function(resolve, reject) {
        apiTweelog.get('/api/v1/tweelog/tweelog_type').then(function (res) {
            if (!Number(res.code)){
                localStorage.setItem('tweelogType', JSON.stringify(res.data));
                resolve(res.data);
            }else {
                api.toast({
                    msg: res.message,
                    duration: 2000,
                    location: 'middle'
                });
            }
        })
    });
    return promise;
}
