apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    api.setNavBarAttr({
        rightButtons: [{
            text: '',
            color:'#3eb2c6',
            fontSize:'12',
            iconPath:'widget://image/me-help.png',
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if(ret.type ==='right'){
            buyTweebucks.openCustomer();
        }else{
            back();
        }
    });

    api.setWinAttr({
        bounces: false
    });
    var buyTweebucks = new Vue({
        el: '#buyTweebucks',
        mounted: function () {
            var that = this;
            loading('show');
            getAxois(getBaseUrl() + "api/tweebucks/v1/rates", "GET", {}).then(function (response) {
                loading('hide');
                //console.log(JSON.stringify(response) + 'CAD');
                that.exChangeCAD = (response.data.CAD/10).toFixed(3);
                that.exChangeCNY = (response.data.CNY/10).toFixed(3);
            });
            if(this.payOrderId){
                this.total = (Number(this.quantity) * this.exChange).toFixed(2);
            }

        },
        filters: {
            formatCurrencyCode:function (value) {
                return MSG.tweebucks['currency'+value];
            }
        },
        watch:{
            paymentMethod:function () {
                var that = this;
                switch (this.paymentMethod) {
                    case 'payPalUSD':
                        that.currencyCode = 'USD';
                        that.exChange = 0.1;
                        break;
                    // case 'payPalCAD':
                    //     that.currencyCode = 'CAD';
                    //     that.exChange = that.exChangeCAD;
                    //     break;
                    case 'aliPay':
                        that.currencyCode = 'CNY';
                        that.exChange = that.exChangeCNY;
                        break;
                    case 'wechat':
                        that.currencyCode = 'CNY';
                        that.exChange = that.exChangeCNY;
                        break;
                }
                this.total = (this.quantity * that.exChange).toFixed(2);
            },
            quantity:function () {
                this.total = (Number(this.quantity) * this.exChange).toFixed(2);
            }
        },
        data: {
            currencyCode:'USD',
            currency: '',
            orderId: '',
            quantity:api.pageParam.quantity || 100,
            total:api.pageParam.total || 10.00,
            payOrderId:api.pageParam.OrderId,
            payCreatedAtUtc:api.pageParam.CreatedAtUtc,
            exChange:0.1,
            loading:false,
            exChangeCNY: getExchangeCNY(),
            exChangeCAD: getExchangeCAD(),
            paymentMethod:'payPalUSD',
            userId:localStorage.getItem('userId'),
            userGuid:localStorage.getItem('userGuid'),
            messages:MSG.tweebucks
        },
        methods:{

            buyTweebucks:function () {
                var that = this;
                if(that.loading){
                    return false;
                }
                that.loading = true;

                if(that.payOrderId){
                    switch (that.paymentMethod) {
                        case 'aliPay':
                            that.alipay(that.payOrderId,that.payCreatedAtUtc,'CNY');
                            break;
                        case'wechat':
                            that.wechatpay(that.payOrderId,that.payCreatedAtUtc,'CNY');
                            break;
                        // case'payPalCAD':
                        //     this.currency = 'CAD';
                        //     this.orderId = that.payOrderId;
                        //     that.payPal(that.payOrderId,that.payCreatedAtUtc,'CAD');
                        //     break;
                        case'payPalUSD':
                            this.currency = 'USD';
                            this.orderId = that.payOrderId;
                            that.payPal(that.payOrderId,that.payCreatedAtUtc,'USD');
                            break;
                    }

                }else{
                    if(!this.quantity || Number(this.quantity)< 100){
                        api.toast({
                            msg: MSG.tweebucks.quantityLessThan + 100,
                            duration: 2000,
                            location: 'middle'
                        });
                        that.loading = false;
                        return false;
                    }
                    var url = getBaseUrl() + "api/tweebucks/v1";
                    var param = {
                        "Tweebuck":this.quantity,
                        "BuyerId":this.userId,
                        "BuyerGuid":this.userGuid,
                        "CurrencyCode":this.currencyCode,
                        "SubTotal": this.total,
                        "Tax": 0,
                        "Total": this.total
                    };
                    loading('show');
                    getAxois(url,"POST",param).then(function (response) {
                        //console.log(JSON.stringify(response));
                        var OrderId = response.data.Data.OrderId;
                        var CreatedAtUtc = response.data.Data.CreatedAtUtc;
                        switch (that.paymentMethod) {
                            case 'aliPay':
                                that.alipay(OrderId,CreatedAtUtc);
                                break;
                            case'wechat':
                                that.wechatpay(OrderId,CreatedAtUtc);
                                break;
                            case'payPalCAD':
                                that.currency = 'CAD';
                                that.orderId = OrderId;
                                that.payPal(OrderId,CreatedAtUtc,'CAD');
                                break;
                            case'payPalUSD':
                                that.currency = 'USD';
                                that.orderId = OrderId;
                                that.payPal(OrderId,CreatedAtUtc,'USD');
                                break;
                        }
                    }).catch(function (error) {
                        console.log(JSON.stringify(error));
                    });
                }

            },
            switchPaymentMethod:function(){
                var that = this;
                actionSheet([
                    {
                        text: MSG.tweebucks.payPalUSD,
                        callback: function () {
                            that.currencyCode = 'USD';
                            that.paymentMethod = 'payPalUSD'
                        }
                    },
                    // {
                    //     text: MSG.tweebucks.payPalCAD,
                    //     callback: function () {
                    //         that.currencyCode = 'CAD';
                    //         that.paymentMethod = 'payPalCAD'
                    //     }
                    // },
                    {
                        text: MSG.tweebucks.alipay,
                        callback: function () {
                            that.currencyCode = 'CNY';
                            that.paymentMethod = 'aliPay'
                        }
                    },
                    {
                        text: MSG.tweebucks.weChatPay,
                        callback: function () {
                            that.currencyCode = 'CNY';
                            that.paymentMethod = 'wechat'
                        }
                    }
                ])
            },
            payPal:function(OrderId,CreatedAtUtc,currency){
                this.loading = false;
                loading('hide');
                openTabLayout('paypal', MSG.payment.selectPayMethod, 'widget://html/tweebucks/paypal.html', {
                    amount: this.quantity,
                    order: {
                        id:OrderId,
                        quantity:this.quantity,
                        currency: currency,
                        price: this.total,
                        description: MSG.tweebucks.buyTweebuck + ' '+ MSG.general.quantity +':' + this.quantity + ' ID:' + OrderId ,
                        mode: 'production',
                    }
                });
            //    document.querySelector('#paypal-button-container').click();
/*                loading('hide');
                var paypal = api.require('paypal');
                var that = this;
                paypal.pay({
                    currency: currency,
                    price: that.total,
                    description: MSG.tweebucks.buyTweebuck + ' '+ MSG.general.quantity +':' + that.quantity + ' ID:' + OrderId ,
                    mode: 'production'
                }, function(ret) {
                    that.loading = false;
                    if (ret.state === 'success') {
                        that.payResult(true,CreatedAtUtc,OrderId,'paypal',ret);
                    }else{
                        that.payResult(false,CreatedAtUtc,OrderId,'paypal');
                    }
                });*/
            },
            wechatpay:function(OrderId,CreatedAtUtc){

                if( this.total < (this.exChangeCNY * this.quantity * 0.1 - 1)){
                    alert('SB');
                    return false;
                }
                loading("show");
                var that = this;
                var Param = {
                    "OrderID": OrderId,
                    "Amount" : that.total,
                    "CurrencyCode" : "CNY",
                    "buyerId": that.userId,
                    "TradeType": "APP",
                    "Orders" : [
                        {"orderId" : OrderId}
                    ]
                };
                var Url = getBaseUrl() + "api/v3/pay/wxtweebuck?lang=" + lan;
                getAxois(Url,"POST",Param).then(function (response) {
                    //console.log(JSON.stringify(response)+"@!@!@!@");
                    loading('hide');
                    var data = response.data.wxpay;
                    var wxPay = api.require('wxPayPlus');
                    wxPay.payOrder({
                        apiKey: data.appid,
                        orderId: data.prepay_id,
                        mchId: data.mch_id,
                        nonceStr: data.nonce_str,
                        timeStamp: data.timestamp,
                        sign: data.sign
                    }, function(ret, err) {
                        that.loading = false;
                        if (ret.status) {
                            that.payResult(true,CreatedAtUtc,OrderId,'wechatpay',ret);
                        } else {
                            that.payResult(false,CreatedAtUtc,OrderId,'wechatpay',ret);
                        }
                    });
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                    that.loading = false;
                    loading('hide');
                });
            },
            alipay:function(OrderId,CreatedAtUtc){

                // if( this.total < (this.exChangeCNY * this.quantity * 0.1 - 1)){
                //     alert('SB');
                //     return false;
                // }
                loading("show");
                var that = this;
                var Param = {
                    "Amount" : that.total,
                    "CurrencyCode" : "CNY",
                    "buyerId": that.userId,
                    "Orders" : [
                        {"orderId" : OrderId}
                    ]
                };
                var Url = "https://api.tweebaa.cn/api/tweebuck/payments/alipay?mode=prod";
                // var Url = getBaseUrl() + "api/tweebuck/payments/alipay?mode=dev";
                getAxois(Url,"PUT",Param).then(function (response) {
                    // console.log(JSON.stringify(response)+"@!@!@!@");
                    that.loading = false;
                    loading('hide');
                    if(response.data.response){
                        var aliPayPlus = api.require('aliPayPlus');
                        aliPayPlus.payOrder({
                            orderInfo:response.data.response,
                        }, function(ret, err) {
                            if(ret.code == "9000"){
                                that.payResult(true,CreatedAtUtc,OrderId,'alipay',ret);
                            }else{
                                that.payResult(false,CreatedAtUtc,OrderId,'alipay',ret);
                            }

                        });
                    }
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                    loading('hide');
                    that.loading = false;
                });
            },
            payResult:function (paymentStatus,paymentTime,OrderId,PaymentMethod,data) {
                var that = this;
                if(paymentStatus){
                    var paramStr = {
                        "Amount" : that.total,
                        "CurrencyCode" : that.currencyCode,
                        "PaymentMethod":PaymentMethod,
                        "Orders" : [
                            {"orderId" : OrderId}
                        ],
                        "Data":data
                    };
                    // var URL = getBaseUrl() + "api/tweebuck/orders/verify?buyerId="+ that.userId +"&mode=dev";
                    var URL = getBaseUrl() + "api/tweebuck/orders/verify?buyerId="+ that.userId +"&mode=prod";
                    getAxois(URL, "PUT", paramStr).then(function (response) {
                        // console.log(JSON.stringify(response) + ' payment API ');
                        loading('hide');
                        that.loading=false;
                        api.sendEvent({
                            name: 'workplaceReload',
                            extra: {
                                type: 'tweebuck',
                            }
                        });
                        api.sendEvent({
                            name: 'tweebucksReload'
                        });
                        api.sendEvent({
                            name: 'marketReload'
                        });
                        if(that.payOrderId){
                            api.sendEvent({
                                name: 'marketReload'
                            });
                        }
                        openTabLayout('tweebucksBuyRusult',"", 'widget://html/tweebucks/tweebucks-pay-result.html',{
                            currencyCode:that.currencyCode,
                            total:that.total,
                            paymentStatus:paymentStatus,
                            paymentTime:paymentTime,
                            quantity:that.quantity,
                            paymentMethod:that.paymentMethod
                        });

                    }).catch(function (error) {
                        loading('hide');
                        that.loading=false;
                        console.log(JSON.stringify(error) + ' payment API 报错');
                    });
                }else{
                    openTabLayout('tweebucksBuyRusult',"", 'widget://html/tweebucks/tweebucks-pay-result.html',{
                        currencyCode:that.currencyCode,
                        total:that.total,
                        paymentStatus:paymentStatus,
                        paymentTime:paymentTime,
                        quantity:that.quantity,
                        paymentMethod:that.paymentMethod
                    });
                }
            },
            openCustomer:function(){
                MQCustomerSerivce();
            },
            inputNumber:function (num) {
                if(this.appleCheck){
                    return;
                }
                if(!api.pageParam.OrderId){
                    var Q = this.quantity.toString();
                    if(Q.indexOf(".") !== -1 && num ==='.'){
                        return;
                    }
                    if(Q.indexOf("0") === 0 && Q.indexOf(".") !== 1 && num ===0){
                        return;
                    }
                    if(Q.indexOf("0") === 0 && Q.indexOf(".") !== 1 && num !==0 && num !=='.'){
                        Q = Q +".";
                    }
                    if(Q.indexOf(".") !== -1 && Q.charAt(Q.length - 3) ==='.'){
                        return;
                    }
                    this.quantity = Q + num;
                }

            },
            deleteNumber:function () {
                if(this.appleCheck){
                    return;
                }
                if(!api.pageParam.OrderId){
                    var Q = this.quantity.toString();
                    this.quantity = Q.substring(0,Q.length -1);
                }

            }

        }
    });
};
