var giftTweebucks;
apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    api.setWinAttr({
        bounces: false
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        back();
    });

    giftTweebucks = new Vue({
        el: '#giftTweebucks',
        mounted: function () {
            this.getTweebucks();
        },
        data: {
            pageType:"prepare",
            quantity:'',
            AvatarUrl:api.pageParam.AvatarUrl,
            Name:api.pageParam.name,
            ToId:api.pageParam.receiver,
            ToGuid:api.pageParam.receiverGuid,
            allTweebucks:'--',
            userId: localStorage.getItem('userId'),
            userGuid: localStorage.getItem('userGuid'),
            message:MSG
        },
        watch: {
            quantity: function (value) {
                if(value && value.length > 18){
                    this.quantity = value.substring(0, 18);
                }else{
                    this.quantity = value
                }
            }
        },
        methods:{
            getTweebucks:function () {
                var that = this;
                var url = getBaseUrl() + "api/tweebucks/v1/balance?UserId=" + this.userId;
                getAxois(url,"GET",{}).then(function (response) {
                    //console.log(JSON.stringify(response));
                    that.allTweebucks = response.data.Data.CompletedSubtotal;
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },

            giftTweebuck:function () {
                var that = this;

                if(that.allTweebucks<10){
                    api.toast({
                        msg: that.message.tweebucks.noEnoughBalance,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }
                if(Number(that.quantity)<= 0){

                    return false;
                }
                if(Number(that.quantity) > that.allTweebucks){
                    api.toast({
                        msg: that.message.tweebucks.YourBalanceNotEnough,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }
                loading('show');
                var url = getBaseUrl() + "api/tweebucks/v1/give";
                var param = {
                    "ToId":that.ToId,
                    "ToGuid":that.ToGuid,
                    "Tweebuck":Number(that.quantity).toFixed(2),
                    "FromId":that.userId,
                    "FromGuid":that.userGuid
                };
                //console.log(JSON.stringify(param));
                //return;
                getAxois(url,"POST",param).then(function (response) {
                    loading('hide');
                    //console.log(JSON.stringify(response));
                    if(response.data.Code ===0){
                        var msg = JSON.stringify(response.data.Data);
                        //that.allTweebucks = that.allTweebucks - Number(that.quantity);
                        that.pageType  = 'done';
                        api.setNavBarAttr({
                            rightButtons: [{
                                text: that.message.general.done,
                                color:'#4578F3',
                                fontSize:'15'
                            }]
                        });
                        api.sendEvent({
                            name: 'workplaceReload',
                            extra: {
                                type: 'tweebuck',
                            }
                        });

                        api.sendEvent({
                            name: 'sendMessagesEvent',
                            extra: {
                                type: 'imgText',
                                targetId: api.pageParam.targetId,
                                conversationType: 'PRIVATE',
                                msg: msg,
                                sendUserId: localStorage.getItem('userId'), //己方id
                                sendName: localStorage.getItem('storename'),
                                sendPortrait: localStorage.getItem('thumbnail'),
                                chatName: that.Name,
                                chatPortrait: that.AvatarUrl,
                                Source: 'undefined',
                                groupName: 'undefined',
                                avatar: 'undefined',
                                duration: that.quantity,
                                textType: 'tweebuck'
                            }
                        });

                    }else if(response.data.Code === 50002){
                        messages("T豆冻结", 'error', 'top', 3);
                    }else {
                        messages(MSG.tips.systemError, 'error', 'top', 3);
                    }
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error));
                });
            },
        }
    });
};

function inputNumber(num) {
    // console.log(giftTweebucks.quantity.indexOf("0"));
    if(giftTweebucks.quantity.indexOf(".") !== -1 && num ==='.'){
        return;
    }
    if(giftTweebucks.quantity.indexOf("0") === 0 && giftTweebucks.quantity.indexOf(".") !== 1 && num ===0){
        return;
    }
    if(giftTweebucks.quantity.indexOf("0") === 0 && giftTweebucks.quantity.indexOf(".") !== 1 && num !==0 && num !=='.'){
        giftTweebucks.quantity = giftTweebucks.quantity +".";
    }
    if(giftTweebucks.quantity.indexOf(".") !== -1 && giftTweebucks.quantity.charAt(giftTweebucks.quantity.length - 3) ==='.'){
        return;
    }
    giftTweebucks.quantity += num;
}
function deleteNumber() {
    giftTweebucks.quantity = giftTweebucks.quantity.substring(0,giftTweebucks.quantity.length -1);
    // console.log(giftTweebucks.quantity.toString().substring(0,giftTweebucks.quantity.length))
}
