apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    api.setWinAttr({
        bounces: false
    });

    api.setNavBarAttr({
        rightButtons: [{
            text: '',
            color:'#3eb2c6',
            fontSize:'12',
            iconPath:'widget://image/me-help.png',
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if(ret.type ==='right'){
            sellTweebucks.openCustomer();
        }else{
            back();
        }
    });

    api.addEventListener({
        name: 'reloadSellTweebucks'
    }, function(ret, err) {
        sellTweebucks.getAccount();
    });

    var sellTweebucks = new Vue({
        el: '#sellTweebucks',
        mounted: function () {
            this.getAccount();
        },
        created: function() {
            if (api.pageParam.tweebucks) {
                this.allTweebucks = +api.pageParam.tweebucks;
            } else {
                this.getTweebucks();
            }
        },
        data: {
            quantity: '',
            allTweebucks: '',
            userId: localStorage.getItem('userId'),
            userGuid: localStorage.getItem('userGuid'),
            accountId:'',
            withdrawAccount:'',
            accountNum:'',
            exChangeCNY: getExchangeCNY(),
            exChangeCAD: getExchangeCAD(),
            loading:false,
            minQuantity:50,
            serviceFee:"5%",
            currentCurrency:'USD',
            message:MSG.tweebucks
        },
        filters: {
            formatName:function (value) {
                var that = this;
                switch (value) {
                    case "alipay":
                        return MSG.tweebucks.alipay;
                    case "paypal":
                        return "PayPal";
                    case "":
                        return MSG.tweebucks.account;
                }
            },
            hiddenText:function (value) {
                return value.length > 7 ? value.substr(0, 3) + new Array(value.length - 5).join('*') + value.substr(-3) : value
            },
            formatCurrencyCode:function (value) {
                return MSG.tweebucks['currency'+value];
            }
        },
        watch:{
            // quantity:function () {
            //     this.quantity = this.quantity.replace(/[\r\n*&^%$#@!(),:;+P'"<>?]/g,"");
            // }
        },
        computed:{
            approximate:function () {
                var quantity = Number(this.quantity);
                if(this.currentCurrency ==="USD"){
                    return (quantity * 0.1).toFixed(2);
                }else if(this.currentCurrency ==="CAD"){
                    return (quantity * this.exChangeCAD).toFixed(2);
                }else if(this.currentCurrency ==="CNY"){
                    return (quantity * this.exChangeCNY).toFixed(2);
                }else{
                    return '--';
                }
            }
        },
        methods:{
            getTweebucks:function () {
                var that = this;
                var url = getBaseUrl() + "api/tweebucks/v1/balance?UserId=" + this.userId;
                getAxois(url,"GET",{}).then(function (response) {
                    that.allTweebucks = response.data.Data.CompletedSubtotal;
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            sellTweebuck:function () {
                var that = this;
                if(this.loading){
                    return false;
                }
                if(!that.withdrawAccount){
                    api.toast({
                        msg: that.message.noWithdrawAccount,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }
                if(Number(that.quantity)< that.minQuantity){
                    api.toast({
                        msg: that.message.quantityLessThan + " "+that.minQuantity,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }
                if(Number(that.quantity) > that.allTweebucks){
                    api.toast({
                        msg: that.message.YourBalanceNotEnough,
                        duration: 2000,
                        location: 'middle'
                    });
                    return false;
                }
                var url = getBaseUrl() + "api/tweebucks/v1/seller/order";
                var param = {
                    "AccountId":that.accountId,
                    "Tweebuck":Number(that.quantity),
                    "SellerId":that.userId,
                    "SellerGuid":that.userGuid
                };
                loading('show');
                getAxois(url,"POST",param).then(function (response) {
                    //console.log(JSON.stringify(response));
                    that.loading = false;
                    loading('hide');
                    if(response.data.Code === 0 ){
                        that.allTweebucks = (that.allTweebucks - Number(that.quantity)).toFixed(2);
                        api.sendEvent({
                            name: 'workplaceReload',
                            extra: {
                                type: 'tweebuck',
                            }
                        });
                        api.sendEvent({
                            name: 'tweebucksReload'
                        });
                        openTabLayout("sellSuccess",that.message.alreadySubmit,'widget://html/tweebucks/tweebucks-sell-success.html',{
                            quantity:that.quantity,
                            accountNum:that.accountNum,
                            withdrawAccount:that.withdrawAccount
                        });

                    }else if(response.data.Code === 81003 ){
                        api.toast({
                            msg: that.message.yourBalanceNotEnough,
                            duration: 2000,
                            location: 'middle'
                        });
                    }else if(response.data.Code === 50002){
                        messages("T豆冻结", 'error', 'top', 3);
                    }else if(response.data.Code === 81002){
                        api.toast({
                            msg: that.message.unit,
                            duration: 2000,
                            location: 'middle'
                        });
                    }else {
                        api.toast({
                            msg: response.data.ExceptionMessage,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                    that.loading = false;
                    loading('hide');
                });
            },
            sellAll:function(){
                this.quantity = this.allTweebucks
            },
            openChangeCurrency:function(){
                var that = this;
                actionSheet([
                    {
                        text: MSG.tweebucks.currencyCNY,
                        callback: function () {
                            that.currentCurrency = 'CNY';
                        }
                    },
                    {
                        text: MSG.tweebucks.currencyUSD,
                        callback: function () {
                            that.currentCurrency = 'USD';
                        }
                    },
                    {
                        text: MSG.tweebucks.currencyCAD,
                        callback: function () {
                            that.currentCurrency = 'CAD';
                        }
                    }
                ])
            },
            market:function(){
                openTabLayout("tweebucksMarket",this.message.tweebuckMarket,'widget://html/tweebucks/tweebucks-market.html');
            },
            getAccount:function(){
                var that = this;
                var url = getBaseUrl() + "api/v2/users/payment-accounts?UserId=" + this.userId;
                loading("show");
                getAxois(url,"GET",{}).then(function (response) {
                    loading("hide");
                    if(response.data.length>0){
                        console.log(JSON.stringify(response.data));
                        that.accountId = response.data[0].PaymentAccountId;
                        that.withdrawAccount = response.data[0].AccountType;
                        that.minQuantity = that.withdrawAccount ==="paypal" ? 50 : 10;
                        that.quantity = that.minQuantity;
                        that.accountNum = response.data[0].AccountNumber;
                        localStorage.setItem("withdrawAccount","true");
                    } else {
                        that.resetAccount();
                    }
                }).catch(function (error) {
                    loading("hide");
                    console.log(JSON.stringify(error));
                });
            },
            openCustomer:function(){
                MQCustomerSerivce();
            },
            setAccount:function(){
                openTabLayout('withdrawAccount',this.message.addAccount, 'widget://html/tweebucks/withdraw-account.html');
            },
            resetAccount: function () {
                var that = this;
                that.withdrawAccount = '';
                that.minQuantity = 50;
                that.quantity = that.minQuantity;
                that.accountNum = '';
            },
            showServiceFee:function(){
                 dialog({
                     title: MSG.tweebucks.rule,
                     content:  MSG.tweebucks.sellTweebucksFeeTips,
                     primaryText:MSG.tweebucks.gotit,
                     asideText: '',
                     onClose: "show",
                     onWarning: function() {
                     },
                     onPrimary: function () {
                         api.closeFrame();
                     }
                 });
            },
            inputNumber:function (num) {

                var Q = this.quantity.toString();
                if(Q.indexOf(".") !== -1 && num ==='.'){
                    return;
                }
                if(Q.indexOf("0") === 0 && Q.indexOf(".") !== 1 && num ===0){
                    return;
                }
                if(Q.indexOf("0") === 0 && Q.indexOf(".") !== 1 && num !==0 && num !=='.'){
                    Q = Q +".";
                }
                if(Q.indexOf(".") !== -1 && Q.charAt(Q.length - 3) ==='.'){
                    return;
                }
                this.quantity = Q + num;
            },
            deleteNumber:function () {
                var Q = this.quantity.toString();
                this.quantity = Q.substring(0,Q.length -1);
            }
        }
    });
};
