
apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    // api.setWinAttr({
    //     bounces: false
    // });

    api.setNavBarAttr({
        rightButtons: [{
            text: '',
            color:'#3eb2c6',
            fontSize:'12',
            iconPath:'widget://image/me-help.png',
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function(ret, err) {
        if(ret.type ==='right'){
            tweebuck.openfaq();
        }else{
            back();
        }
    });

    api.addEventListener({
        name:'tweebucksReload'
    }, function(ret, err){
        location.reload();
    });

    $('.buy-tweebuck-btn').height((api.safeArea.bottom + 50) + 'px');

    var tweebuck = new Vue({
        el: '#tweebuck',
        mounted: function () {
            var that = this;
            this.getTweebucks();
            this.getTweebucksRecords();
            this.getTivSum();
            //this.getAddress();获取TWEE 地址
            getAxois(getBaseUrl() + "api/tweebucks/v1/rates", "GET", {}).then(function (response) {
                //console.log(JSON.stringify(response) + 'CAD');
                that.exChangeCAD = (response.data.CAD/10).toFixed(3);
                that.exChangeCNY = (response.data.CNY/10).toFixed(3);
                api.sendEvent({
                    name: 'workplaceReload',
                    extra: {
                        type: 'tweebuck',
                    }
                });
            });
            this.getLockedTweeUsers();
        },
        data: {
            totalCoin: '--',
            isLoading: false,
            listData:'',
            recordDate:moment().format('YYYY-MM'),
            userId:localStorage.getItem('userId'),
            exChangeCNY: getExchangeCNY(),
            exChangeCAD: getExchangeCAD(),
            fromDate:moment().subtract(7, 'days').format('YYYY-MM-DD'),
            toDate:moment().utc().format('YYYY-MM-DD'),
            TweeAddress:'',
            canCollectTweebucks:0,
            collectedTweebucks:0,
            collectPage:false,
            lockedBtnShow:false,
            tivRewardTotal: '-',
            productTotal: '-',
            currentCurrency: lan === 'zh' ? 'CNY' : 'USD',
            message:MSG.tweebucks
        },
        filters: {
            formatTime:function (value) {
                return moment.utc(value).local().format('MM-DD HH:mm');
            },
            fixed2:function (value) {
                return Number(value).toFixed(2);
            },
            fixed4: function (value) {
                if ($.isNumeric(value) === true) {
                    return Number(value).toFixed(4);
                } else {
                    return value;
                }
            },
            formatCurrency:function (value) {
                return MSG.tweebucks['currency'+value];
            }
        },
        computed:{
            approximate:function () {
                if (this.totalCoin === '--') {
                    return '--';
                }
                if(this.currentCurrency ==="USD"){
                    return (this.totalCoin * 0.1).toFixed(2);
                }else if(this.currentCurrency ==="CAD"){
                    return (this.totalCoin * this.exChangeCAD).toFixed(2);
                }else if(this.currentCurrency ==="CNY"){
                    return (this.totalCoin * this.exChangeCNY).toFixed(2);
                }else{
                    return '--';
                }
            }
        },
        methods:{
            getTweebucks:function () {
                var that = this;
                var url = getBaseUrl() + "api/tweebucks/v1/balance?UserId=" + this.userId;
                getAxois(url,"GET",{}).then(function (response) {
                    //console.log(JSON.stringify(response));
                    that.totalCoin = response.data.Data.CompletedSubtotal;
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            getLockedTweeUsers:function(){
                var that = this;
                var url = "https://tweebaafiles.oss-accelerate.aliyuncs.com/lockedusers.json?" + Date.parse(new Date());
                getAxois(url,"GET",{}).then(function (response) {
                    if(response.data.users.indexOf(that.userId) !==-1){
                        that.lockedBtnShow = true;
                    }
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            getTweebucksRecords:function(){
                var that = this;
                loading('show');
                this.isLoading = true;
                var url = getBaseUrl() + "api/tweebuck-logs?UserId="+ that.userId +"&StartedAtUtc="+ moment(that.fromDate).utc().format('YYYY-MM-DDT00:00:01.000') +
                    "&EndedAtUtc="+ moment(that.toDate).format('YYYY-MM-DDT23:59:00.000') +"&currentpage=0&itemsperpage=1000&LanguageCode="+lan;
                getAxois(url,"GET",{}).then(function (response) {
                    //console.log(JSON.stringify(response));
                    loading('hide');
                    that.isLoading = false;
                    that.listData = response.data.Data;
                }).catch(function (error) {
                    loading('hide');
                    that.isLoading = false;
                    console.log(JSON.stringify(error));
                });
            },
            getTivSum:function(){
                var that = this;
                var url = getBaseUrl() + "api/v1/tiv2tweebucksum?UserId="+ this.userId;
                getAxois(url,"GET",{}).then(function (response) {
                    //console.log(JSON.stringify(response));
                    loading('hide');
                    that.canCollectTweebucks = response.data.Data.TweebuckPending;
                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error));
                });
            },
            openChangeCurrency:function(){
                var that = this;
                actionSheet([
                    {
                        text: MSG.tweebucks.currencyCNY,
                        callback: function () {
                            that.currentCurrency = 'CNY';
                        }
                    },
                    {
                        text: MSG.tweebucks.currencyUSD,
                        callback: function () {
                            that.currentCurrency = 'USD';
                        }
                    },
                    {
                        text: MSG.tweebucks.currencyCAD,
                        callback: function () {
                            that.currentCurrency = 'CAD';
                        }
                    }
                ])
            },
            toPage:function(page){
                var that = this;
                switch (page) {
                    case 'sell':
                        openTabLayout("sellTweebucks",that.message.sellTweebuck,'widget://html/tweebucks/sell-tweebucks.html',{
                            tweebucks:that.totalCoin,
                            exChangeCNY:that.exChangeCNY,
                        });
                        return;
                    case 'topUp':
                        openTabLayout("buyTweebucks",that.message.buy,'widget://html/tweebucks/buy-tweebucks.html');
                        return;
                    case 'market':
                        openTabLayout("tweebucksMarket",that.message.tweebuckMarket,'widget://html/tweebucks/tweebucks-market.html');
                        return;
                    case 'transactions':
                        openTabLayout("tweebucksMarket",that.message.transactions,'widget://html/tweebucks/tweebucks-transactions.html');
                        return;
                }
            },

            lockedTwee:function(){
                var that = this;
                openTabLayout("lockedTwee",that.message.lockedTwee,'widget://html/tweebucks/locked-twee.html',{
                    userId:that.userId
                });
            },

            openfaq:function () {
                openTabLayout('addDigital', MSG.mine.faq, 'widget://html/access/faq-new.html', {
                    type: 'community',
                    index: 4
                });
            }
        }
    });
};
