apiready = function () {

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/' + lan + '.json'
    }));

    var typeList = [];
    try {
        typeList = JSON.parse(localStorage.getItem('tweelogType'));
    } catch (err) {
        typeList = [];
    }

    api.addEventListener({
        name: 'navitembtn'
    }, function (ret, err) {
        if (ret.type === 'right') {

        } else {
            api.sendEvent({
                name: 'tweelogReloadList'
            });
            api.sendEvent({
                name: 'reloadMyTweelog'
            });
            setTimeout(function () {
                back();
            }, 200)
        }
    });

    var kv = api.require('snKVStorage');

    var tweelogId = api.pageParam.tweelogId;

    new Vue({
        el: '#app',
        components: {},
        data() {
            return {
                message: MSG,
                tweelogType: {},
                tweeLogData: {
                    moments: [],
                    products: [],
                    members: []
                },
                tagResults: []
            }
        },
        mounted: function () {
            api.addEventListener({
                name: 'tweelogSelectMembersFinish'
            }, function () {
                this.fetchMembers();
            }.bind(this));
            api.addEventListener({
                name: 'changeTweeLogSocials'
            }, function (ret, err) {
                this.tweeLogData.socials = ret.value.list;
                loading('show');
                apiTweelog.post("/api/v1/tweelog/social", {
                    tweelogId: tweelogId,
                    socials: ret.value.list
                }).done(function (rep) {
                    loading('hide');
                    console.log('socials');
                    if (rep.code !== 0) {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            }.bind(this));

            api.addEventListener({
                name: 'tweelogChangeContact'
            }, function (ret, err) {
                this.tweeLogData.email = ret.value.email;
                this.tweeLogData.faxNumber = ret.value.faxNumber;
                this.tweeLogData.phoneNumber = ret.value.phoneNumber;
                loading('show');
                apiTweelog.post("/api/v1/tweelog/contact", {
                    tweelogId: tweelogId,
                    email: ret.value.email,
                    faxNumber: ret.value.faxNumber,
                    phoneNumber: ret.value.phoneNumber
                }).done(function (rep) {
                    loading('hide');
                    console.log('contact');
                    if (rep.code !== 0) {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            }.bind(this));
            api.addEventListener({
                name: 'tweelogSelectLocation'
            }, function (ret, err) {
                this.tweeLogData.location = ret.value.location;
                this.setLocal();
            }.bind(this));

            // 编辑联系人
            api.addEventListener({
                name: 'tweelogSelectConcats'
            }, function (ret, err) {
                this.tweeLogData.members = ret.value.members
                var results = [];
                $.map(ret.value.members, function (item) {
                    if (item.contactMember === true) {
                        results.push(item.userId);
                    }
                });
                loading('show');
                apiTweelog.post("/api/v1/tweelog/members/contracts", {
                    tweelogId: tweelogId,
                    contactMembers: results
                }).done(function (rep) {
                    loading('hide');
                    console.log('contactMembers');
                    if (rep.code !== 0) {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            }.bind(this));
            api.addEventListener({
                name: 'tweelogInputStory'
            }, function (ret, err) {
                this.tweeLogData.story = ret.value.content
                loading('show');
                apiTweelog.post("/api/v1/tweelog/story", {
                    tweelogId: tweelogId,
                    text: ret.value.content
                }).done(function (rep) {
                    loading('hide');
                    console.log('story');
                    if (rep.code !== 0) {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            }.bind(this));
            api.addEventListener({
                name: 'tweelogSelectMoment'
            }, function (ret, err) {
                this.tweeLogData.moments = ret.value.list
                var resultMoments = [];
                $.map(ret.value.list, function (item, index) {
                    resultMoments.push({
                        displayOrder: index,
                        id: item.blogPostId
                    })
                });
                loading('show');
                apiTweelog.post("/api/v1/tweelog/moments", {
                    tweelogId: tweelogId,
                    moments: resultMoments
                }).done(function (rep) {
                    loading('hide');
                    console.log('moments');
                    if (rep.code !== 0) {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            }.bind(this));
            api.addEventListener({
                name: 'tweelogSelectProduct'
            }, function (ret, err) {
                this.tweeLogData.products = ret.value.list
                var resultProducts = [];
                $.map(ret.value.list, function (item, index) {
                    resultProducts.push({
                        displayOrder: index,
                        id: item.Id || item.id
                    })
                });
                loading('show');
                apiTweelog.post("/api/v1/tweelog/products", {
                    tweelogId: tweelogId,
                    products: resultProducts
                }).done(function (rep) {
                    loading('hide');
                    console.log('products');
                    if (rep.code !== 0) {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            }.bind(this));
            api.addEventListener({
                name: 'changeTweeLogDescription'
            }, function (ret, err) {
                this.tweeLogData.description = ret.value.description
                loading('show');
                apiTweelog.post("/api/v1/tweelog/slogan", {
                    tweelogId: tweelogId,
                    text: ret.value.description
                }).done(function (rep) {
                    loading('hide');
                    console.log('slogan');
                    if (rep.code !== 0) {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            }.bind(this));
            api.addEventListener({
                name: 'changeTweeLogIntroduction'
            }, function (ret, err) {
                this.tweeLogData.introduction = ret.value.introduction
                loading('show');
                apiTweelog.post("/api/v1/tweelog/introduction", {
                    tweelogId: tweelogId,
                    text: ret.value.introduction
                }).done(function (rep) {
                    loading('hide');
                    console.log('introduction');
                    if (rep.code !== 0) {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            }.bind(this));
            api.addEventListener({
                name: 'changeTweeLogName'
            }, function (ret, err) {
                this.tweeLogData.name = ret.value.name
                loading('show');
                apiTweelog.post("/api/v1/tweelog/name", {
                    tweelogId: tweelogId,
                    text: ret.value.name
                }).done(function (rep) {
                    loading('hide');
                });
            }.bind(this));
            api.addEventListener({
                name: 'selectTweeLogType'
            }, function (ret, err) {
                this.tweeLogData.tweelogType = ret.value.type.code;
                this.tweelogType = ret.value.type;
                loading('show');
                apiTweelog.post("/api/v1/tweelog/tweelog_type", {
                    tweelogId: tweelogId,
                    text: ret.value.type.code
                }).done(function (rep) {
                    loading('hide');
                });
            }.bind(this));
            api.addEventListener({
                name: 'tweelogtags'
            }, function (ret, err) {
                this.tweeLogData.tags = ret.value.tags;
                this.setTagsText();
            }.bind(this))
            api.addEventListener({
                name: 'select-tweelog-avatar'
            }, function (ret, err) {
                this.tweeLogData.avatarUrl = ret.value.data.thumbnail;
                this.setLocal();
            }.bind(this))
            api.addEventListener({
                name: 'tweelogSelectMembers'
            }, function (ret, err) {
                this.tweeLogData.members = ret.value.members;
                this.setLocal();
            }.bind(this))
        },
        created: function () {
            this.fetchData();
        },
        methods: {
            sloveType: function (typeList) {
                typeList.forEach(function (item) {
                    if (item.code === this.tweeLogData.tweelogType) {
                        this.tweelogType = item;
                    }
                }.bind(this));
            },
            fetchData: function () {
                var that = this;
                loading('show');
                apiTweelog.get("/api/v1/tweelog/" + tweelogId + "/basic/detail", {}).done(function (rep) {
                    loading('hide');
                    // console.log(JSON.stringify(rep));
                    var data = rep.data;
                    data.story = '';
                    data.members = [];
                    data.moments = [];
                    data.products = [];
                    data.tagsText = '';
                    that.tweeLogData = data;
                    if (!typeList || !typeList.length) {
                        getTweeLogType().then(function (list) {
                            typeList = list;
                            this.sloveType(typeList)
                        }.bind(this));
                    } else {
                        this.sloveType(typeList)
                    }
                    that.fetchMembers();
                    that.fetchSocials();
                    that.fetchStory();
                    that.fetchMoments();
                    that.fetchProducts();
                    that.setTagsText();
                }.bind(this));
            },
            fetchMembers: function () {
                var that = this;
                var promise = new Promise(function (resolve, reject) {
                    apiTweelog.get("/api/v1/tweelog/members", {
                        tweelogId: tweelogId,
                        page: 1,
                        size: TWEELOG_PAGE_SIZE
                    }).then(function (rep) {
                        if (!Number(rep.code)) {
                            that.tweeLogData.members = rep.data.list;
                            resolve();
                        } else {
                            api.toast({
                                msg: rep.message,
                                duration: 2000,
                                location: 'middle'
                            });
                        }
                    }.bind(this));
                }.bind(this));
                return promise;

            },
            fetchSocials: function () {
                var that = this;
                apiTweelog.get("/api/v1/tweelog/" + tweelogId + "/socials", {}).done(function (rep) {
                    that.tweeLogData.socials = rep.data;
                });
            },
            fetchStory: function () {
                var that = this;
                apiTweelog.get("/api/v1/tweelog/" + tweelogId + "/story", {}).done(function (rep) {
                    that.tweeLogData.story = rep.data.content;
                });
            },
            fetchMoments: function () {
                var that = this;
                apiTweelog.get("/api/v1/tweelog/" + tweelogId + "/moments", {}).done(function (rep) {
                    that.tweeLogData.moments = rep.data;
                });
            },
            fetchProducts: function () {
                var that = this;
                apiTweelog.get("/api/v1/tweelog/" + tweelogId + "/products", {}).done(function (rep) {
                    that.tweeLogData.products = rep.data;
                });
            },
            changeSocials: function () {
                api.openFrame({
                    name: 'changeTweeLogSocials',
                    url: 'widget://html/tweelog/frame/change-socials.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        tweeLogData: this.tweeLogData
                    }
                });
            },
            changeContact: function () {
                api.openFrame({
                    name: 'changeTweeLogContact',
                    url: 'widget://html/tweelog/frame/change-contact.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        tweeLogData: this.tweeLogData
                    }
                });
            },
            selectLocation: function () {
                api.openFrame({
                    name: 'location',
                    url: 'widget://html/tweelog/modules/step2/location-page.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        type: ''
                    }
                });
            },
            selectConcetMembers: function () {
                api.openFrame({
                    name: 'tweelogSelectConcats',
                    url: 'widget://html/tweelog/modules/step2/selectConcatMembers.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        members: this.tweeLogData.members
                    }
                });
            },
            selectStory: function () {
                api.openFrame({
                    name: 'step3Story',
                    url: 'widget://html/tweelog/modules/step3/story-page.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        tweeLogData: this.tweeLogData
                    }
                });
            },
            selectProduct: function () {
                api.openFrame({
                    name: 'step3Product',
                    url: 'widget://html/tweelog/modules/step3/product-page.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        products: this.tweeLogData.products
                    }
                });
            },
            selectMoment: function () {
                api.openFrame({
                    name: 'step3Moment',
                    url: 'widget://html/tweelog/modules/step3/moment-page.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        moments: this.tweeLogData.moments
                    }
                });
            },
            formatContractMembers(members) {
                var len = members.length;
                if (len === 0) {
                    return;
                }
                var results = [];
                $.map(members, function (item) {
                    if (item.contactMember === true) {
                        results.push(item.storeName);
                    }
                });
                results = results.slice(0, 2);
                if (len > 2) {
                    return results.join(',') + '...';
                } else {
                    return results.join(',');
                }
            },
            formatText(text) {
                if (text) {
                    if (text.length > 40) {
                        return text.substring(0, 40) + '...';
                    } else {
                        return text;
                    }
                }
            },
            changeDescription: function () {
                api.openFrame({
                    name: 'changeTweeLogDescription',
                    url: 'widget://html/tweelog/frame/change-description.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        tweeLogData: this.tweeLogData
                    }
                });
            },
            changeIntroduction: function () {
                api.openFrame({
                    name: 'changeTweeLogIntroduction',
                    url: 'widget://html/tweelog/frame/change-introduction.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        tweeLogData: this.tweeLogData
                    }
                });
            },
            changeName: function () {
                api.openFrame({
                    name: 'changeTweeLogName',
                    url: 'widget://html/tweelog/frame/change-name.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        tweeLogData: this.tweeLogData
                    }
                });
            },
            changeAvatar() {
                changeTweelogPortrait();
            },
            changeMembers() {
                if (this.tweeLogData.members) {
                    api.openFrame({
                        name: 'tweelogSelectMembers',
                        url: 'widget://html/tweelog/modules/step1/selectMembers.html',
                        bgColor: 'rgba(0, 0, 0, 0.4)',
                        rect: {
                            x: 0,
                            y: 0,
                            w: 'auto',
                            h: 'auto'
                        },
                        animation: {
                            type: "movein",
                            subType: "from_bottom",
                            duration: 300
                        },
                        pageParam: {
                            members: this.tweeLogData.members,
                            tweelogId: tweelogId,
                            groupId: this.tweeLogData.groupId,
                            tweeLogData: this.tweeLogData
                        }
                    });
                }
            },
            changeTags() {
                api.openFrame({
                    name: 'tweeLogTags',
                    url: 'widget://html/tweelog/modules/step1/tweelog-tags.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        tweelogId: tweelogId,
                        tags: this.tagResults,
                        tagsData: this.tweeLogData.tags
                    }
                });
            },
            goType() {
                api.openFrame({
                    name: 'selectTweeLogType',
                    url: 'widget://html/tweelog/modules/step1/selectType.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        type: this.tweelogType
                    }
                });
            },
            setTagsText() {
                var tags = this.tweeLogData.tags;
                if (tags.length > 0) {
                    var results = [];
                    $.map(tags, function (item) {
                        results.push(item.tagName || item);
                    });
                    this.tagResults = results;
                    var len = tags.length;
                    if (len <= 2) {
                        this.tweeLogData.tagsText = results.join(',');
                    } else {
                        this.tweeLogData.tagsText = results.slice(0, 2).join(',') + '...';
                    }
                }
            },
            setLocal() {
                kv.setObject({
                    key: 'tweeLogData',
                    value: this.tweeLogData
                });
            }
        }
    })

};
