apiready = function () {

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/' + lan + '.json'
    }));

    backListener();

    var kv = api.require('snKVStorage');

    var TWEE_LOG_DATA;
    var hasTweeLogData = kv.has({
        key: 'tweeLogData'
    });
    if (hasTweeLogData) {
        TWEE_LOG_DATA = kv.getObject({
            key: 'tweeLogData'
        });
    }

    new Vue({
        el: '#app',
        components: {},
        data() {
            return {
                message: MSG,
                tweeLogData: TWEE_LOG_DATA,
                tagResults: []
            }
        },
        mounted: function () {
            api.addEventListener({
                name: 'changeTweeLogSocials'
            }, function(ret, err){
                this.tweeLogData.socials = ret.value.list;
                this.setLocal();
            }.bind(this));
            api.addEventListener({
                name: 'tweelogChangeContact'
            }, function(ret, err){
                this.tweeLogData.email = ret.value.email;
                this.tweeLogData.faxNumber = ret.value.faxNumber;
                this.tweeLogData.phoneNumber = ret.value.phoneNumber;
                this.setLocal();
            }.bind(this));
            api.addEventListener({
                name: 'tweelogSelectLocation'
            }, function(ret, err){
                this.tweeLogData.location = ret.value.location;
                this.setLocal();
            }.bind(this));
            api.addEventListener({
                name: 'tweelogSelectConcats'
            }, function (ret, err) {
                this.tweeLogData.contactMembers = ret.value.members
                this.setLocal();
            }.bind(this));
            api.addEventListener({
                name: 'tweelogInputStory'
            }, function(ret, err){
                this.tweeLogData.story = ret.value.content
                this.setLocal();
            }.bind(this));
            api.addEventListener({
                name: 'tweelogSelectMoment'
            }, function (ret, err) {
                this.tweeLogData.moments = ret.value.list
                this.setLocal();
            }.bind(this));
            api.addEventListener({
                name: 'tweelogSelectProduct'
            }, function (ret, err) {
                this.tweeLogData.products = ret.value.list
                this.setLocal();
            }.bind(this));
            api.addEventListener({
                name: 'tweelogSelectProduct'
            }, function (ret, err) {
                this.tweeLogData.products = ret.value.list
                this.setLocal();
            }.bind(this));
            api.addEventListener({
                name: 'changeTweeLogIntroduction'
            }, function (ret, err) {
                this.tweeLogData.description = ret.value.description
                this.setLocal();
            }.bind(this));
            api.addEventListener({
                name: 'changeTweeLogIntroduction'
            }, function (ret, err) {
                this.tweeLogData.introduction = ret.value.introduction
                this.setLocal();
            }.bind(this));
            api.addEventListener({
                name: 'changeTweeLogName'
            }, function (ret, err) {
                this.tweeLogData.name = ret.value.name
                this.setLocal();
            }.bind(this));
            api.addEventListener({
                name: 'selectTweeLogType'
            }, function (ret, err) {
                this.tweeLogData.tweelogType = ret.value.type.value;
                this.setLocal();
            }.bind(this));
            api.addEventListener({
                name: 'tweelogtags'
            }, function (ret, err) {
                this.tweeLogData.tags = ret.value.tags;
                this.setTagsText();
                this.setLocal();
            }.bind(this))
            api.addEventListener({
                name: 'select-tweelog-avatar'
            }, function (ret, err) {
                this.tweeLogData.avatarUrl = ret.value.data.thumbnail;
                this.setLocal();
            }.bind(this))
            api.addEventListener({
                name: 'tweelogSelectMembers'
            }, function (ret, err) {
                this.tweeLogData.members = ret.value.members;
                this.setLocal();
            }.bind(this))
        },
        created: function () {
            this.setTagsText();
        },
        methods: {
            changeSocials: function () {
                api.openFrame({
                    name: 'changeTweeLogSocials',
                    url: 'widget://html/tweelog/frame/change-socials.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        tweeLogData: this.tweeLogData
                    }
                });
            },
            changeContact: function () {
                api.openFrame({
                    name: 'changeTweeLogContact',
                    url: 'widget://html/tweelog/frame/change-contact.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        tweeLogData: this.tweeLogData
                    }
                });
            },
            selectLocation: function () {
                api.openFrame({
                    name: 'location',
                    url: 'widget://html/tweelog/modules/step2/location-page.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        type: ''
                    }
                });
            },
            selectConcetMembers: function () {
                api.openFrame({
                    name: 'tweelogSelectConcats',
                    url: 'widget://html/tweelog/modules/step2/selectConcatMembers.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        members: this.tweeLogData.contactMembers
                    }
                });
            },
            selectStory: function () {
                api.openFrame({
                    name: 'step3Story',
                    url: 'widget://html/tweelog/modules/step3/story-page.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        tweeLogData: this.tweeLogData
                    }
                });
            },
            selectProduct: function () {
                api.openFrame({
                    name: 'step3Product',
                    url: 'widget://html/tweelog/modules/step3/product-page.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        products: this.tweeLogData.products
                    }
                });
            },
            selectMoment: function () {
                api.openFrame({
                    name: 'step3Moment',
                    url: 'widget://html/tweelog/modules/step3/moment-page.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        moments: this.tweeLogData.moments
                    }
                });
            },
            formatText(text) {
                if (text) {
                    if (text.length > 40) {
                        return text.substring(0, 40) + '...';
                    } else {
                        return text;
                    }
                }
            },
            changeDescription: function () {
                api.openFrame({
                    name: 'changeTweeLogDescription',
                    url: 'widget://html/tweelog/frame/change-description.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        tweeLogData: this.tweeLogData
                    }
                });
            },
            changeIntroduction: function () {
                api.openFrame({
                    name: 'changeTweeLogIntroduction',
                    url: 'widget://html/tweelog/frame/change-introduction.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        tweeLogData: this.tweeLogData
                    }
                });
            },
            changeName: function () {
                api.openFrame({
                    name: 'changeTweeLogName',
                    url: 'widget://html/tweelog/frame/change-name.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        tweeLogData: this.tweeLogData
                    }
                });
            },
            changeAvatar() {
                changeTweelogPortrait();
            },
            changeMembers() {
                const list = this.tweeLogData.members.length ? this.tweeLogData.members : [
                    {
                        avatarUrl: localStorage.getItem('thumbnail'),
                        userId: +localStorage.getItem('userId'),
                        userGuid: localStorage.getItem('userGuid'),
                        nickname: localStorage.getItem('storename'),
                        tweebaaId: localStorage.getItem('userName'),
                        role: 'CREATOR',
                        title: this.message.tweeLog.memberCreator
                    }
                ]
                api.openFrame({
                    name: 'tweelogSelectMembers',
                    url: 'widget://html/tweelog/modules/step1/selectMembers.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        members: list
                    }
                });
            },
            changeTags() {
                api.openFrame({
                    name: 'tweeLogTags',
                    url: 'widget://html/tweelog/modules/step1/tweelog-tags.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        tags: this.tagResults
                    }
                });
            },
            goType() {
                api.openFrame({
                    name: 'selectTweeLogType',
                    url: 'widget://html/tweelog/modules/step1/selectType.html',
                    bgColor: 'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation: {
                        type: "movein",
                        subType: "from_bottom",
                        duration: 300
                    },
                    pageParam: {
                        type: this.tweeLogData.tweelogType
                    }
                });
            },
            setTagsText() {
                var tags = this.tweeLogData.tags;
                if (tags.length > 0) {
                    var results = [];
                    $.map(tags, function (item) {
                        results.push(item.tagName || item);
                    });
                    this.tagResults = results;
                    var len = tags.length;
                    if (len <= 2) {
                        this.tweeLogData.tagsText = results.join(',');
                    } else {
                        this.tweeLogData.tagsText = results.slice(0, 2).join(',') + '...';
                    }
                }
            },
            setLocal() {
                kv.setObject({
                    key: 'tweeLogData',
                    value: this.tweeLogData
                });
            }
        }
    })

};
