apiready = function () {
    var Pages = 1;
    var tweelogTypeList = [];
    var tweeLogTypeMap = {};
    try{
        tweelogTypeList = JSON.parse(localStorage.getItem('tweelogType'));
        tweelogTypeList.forEach(function(item){
            tweeLogTypeMap[item.code] = item.value;
        })
    }catch (err){
    }
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/' + lan + '.json'
    }));
    api.setNavBarAttr({
        rightButtons: [{
            iconPath:'widget://image/add-icon.jpg'
        }]
    });

    new Vue({
        el: '#app',
        data() {
            return {
                message: MSG,
                getDataFirst: false,
                tabClick: false,
                tweeLogTypeMap: tweeLogTypeMap,
                tipShow: {},
                params: {
                    page: Pages,
                    size: 10,
                    category: api.pageParam.category || 'created'
                },
                pendingCount: 0,
                appliedCount: 0,
                createdCount: 0,
                joinedCount: 0,
                list: [],
                paddingList: [],
                totalPage: 0,
                isLoading:false,
                collabEnabled: true,
                personalEnabled: true,
            }
        },
        mounted() {
            this.$el.style.display = 'block';
            if (!Object.keys(this.tweeLogTypeMap).length){
                apiTweelog.get('/api/v1/tweelog/tweelog_type').then(function (res) {
                    if (!Number(res.code)){
                        tweelogTypeList = res.data;
                        tweelogTypeList.forEach(function(item){
                            tweeLogTypeMap[item.code] = item.value;
                        })
                        this.tweeLogTypeMap = tweeLogTypeMap;
                    }else {
                        api.toast({
                            msg: res.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                })
            }
        },
        created() {
            var that = this;
            //上拉加载
            api.addEventListener({
                name: 'scrolltobottom',
                extra: {
                    threshold: 100
                }
            }, function (ret, err) {
                if (!this.isLoading) {
                    Pages++;
                    that.params.page = Pages;
                    that.getList();
                }
            });
            api.addEventListener({
                name: 'navitembtn'
            }, function (ret, err) {
                if (ret.type === 'right') {
                    if (!this.collabEnabled && !this.collabEnabled){
                        api.toast({
                            msg: MSG.tweeLog.createLimit,
                            duration: 2000,
                            location: 'middle'
                        });
                        return;
                    }
                   this.createTweeLog();
                }else {
                    back();
                }
            }.bind(this));

            api.addEventListener({
                name: 'tweeLogUpdate'
            }, function(){
                this.getList();
            }.bind(this));

            api.addEventListener({
                name: 'reloadMyTweelog'
            }, function(ret, err){
                this.getDataFirst = true;
                this.getList();
            }.bind(this));

            api.addEventListener({
                name: 'reloadMyTweelog'
            }, function(ret, err){
                this.getDataFirst = true;
                this.getList();
            }.bind(this));

            this.getDataFirst = true;
            this.getList();
            apiTweelog.get('/api/v1/tweelog/limit').then(function (res) {
                if (!Number(res.code)){
                    this.collabEnabled = res.data.collabEnabled;
                    this.personalEnabled = res.data.personalEnabled;
                }else {
                    api.toast({
                        msg: res.message,
                        duration: 2000,
                        location: 'middle'
                    });
                }
            }.bind(this));
        },
        computed: {
        },
        filters: {
            filterTag: function(tags){
                return tags.map(function(item){
                    return item.tagName;
                }).join(' | ');
            },
        },
        methods: {
            processApply: function(item){
                if (item.applyStatus === 'PENDING'){
                    api.openFrame({
                        name: 'processApply',
                        url: 'widget://html/tweelog/modules/processApply/processApply.html',
                        bgColor:'rgba(0, 0, 0, 0.4)',
                        rect: {
                            x: 0,
                            y: 0,
                            w: 'auto',
                            h: 'auto'
                        },
                        animation:{
                            type:"movein",
                            subType:"from_bottom",
                            duration:300
                        },
                        pageParam: {
                            data: item
                        }
                    });
                }
            },
            openDetail: function(index) {
                openTabLayout('tweeLogDetail', '', 'widget://html/tweelog/tweeLog-detail.html', {
                    tweelogInfo: this.list[index]
                }, true);
            },
            operate: function(item){
                var buttons = [];
                if (this.params.category === 'created'){
                    buttons.push({
                        color: '#282A2B',
                        text: MSG.tweeLog.edit,
                        callback: function () {
                            openTabLayout('detailTweelog', MSG.tweeLog.edit, 'widget://html/tweelog/editTweeLog.html', {
                                tweelogId: item.tweelogId
                            });
                        }.bind(this)
                    })
                    buttons.push({
                        color: '#282A2B',
                        text: MSG.tweeLog.delete,
                        callback: function () {
                            this.delete(item);
                        }.bind(this)
                    })
                }else {
                    if (this.params.category === 'joined'){
                        buttons.push({
                            color: '#282A2B',
                            text: MSG.tweeLog.quit,
                            callback: function () {
                                this.quit(item);
                            }.bind(this)
                        })
                    }
                    if (item.enableChanges){
                        buttons.push({
                            color: '#282A2B',
                            text: MSG.tweeLog.edit,
                            callback: function () {

                            }.bind(this)
                        })
                    }
                }
                actionSheet(buttons);
            },
            quit: function(){

            },
            delete: function(item){
                var buttons = [
                    {
                        color: 'red',
                        text: MSG.tweeLog.deleteConfirm,
                        callback: function () {
                            apiTweelog.post('/api/v1/tweelog/'+ item.tweelogId +'/close').then(function(res){
                                if (!Number(res.code)){
                                    this.getList();
                                    api.sendEvent({
                                        name: 'tweelogReloadList'
                                    });
                                }
                            }.bind(this));
                        }.bind(this)
                    }
                ];
                actionSheet(buttons);
            },
            showTip: function(tweeLog){
                var index = this.list.findIndex(function(item){
                    return item.tweelogId === tweeLog.tweelogId;
                })
                this.$set(this.list, index, Object.assign({}, tweeLog, {tipShow: true}));
                document.body.addEventListener('touchstart',this.docClick, false)
            },
            docClick: function(e){
                e.stopPropagation();
                this.list = this.list.map(function(item){
                    return Object.assign({}, item, {tipShow: false});
                })
                document.body.removeEventListener('touchstart', this.docClick);
            },
            roleCls: function(category){
                return category + '-color';
            },
            switchCategory: function(category){
                if (!this.tabClick){
                    this.tabClick = true;
                    this.getDataFirst = true;
                    this.params = {
                        page: Pages,
                        size: DEFAULT_PAGE_SIZE,
                        category: category
                    };
                    this.getList();
                }
            },
            createTweeLog: function(){
                openTabLayout('createTweeLog', MSG.tweeLog.createTweelog, 'widget://html/tweelog/createTweeLog.html', {
                    collabEnabled: this.collabEnabled,
                    personalEnabled: this.personalEnabled,
                });
            },
            getList: function(){
                loading('show');
                var that = this;
                that.isLoading = true;
                apiTweelog.get('/api/v1/tweelog/me', this.params).then(function (res) {
                    that.isLoading = false;
                    this.tabClick = false;
                    loading('hide');
                    if (!Number(res.code)){
                        var data = res.data;
                        this.appliedCount = data.appliedCount;
                        this.createdCount = data.createdCount;
                        this.joinedCount = data.joinedCount;
                        this.pendingCount = data.pendingCount;
                        this.getDataFirst = false;
                        var LIST = [];
                        if (this.params.category === 'pending'){
                            LIST = data.pendingApplies.list;
                            this.totalPage = data.pendingApplies.totalPage;
                        }else {
                            LIST = data.tweelogs.list;
                            this.totalPage = data.tweelogs.totalPage;
                        }
                        if (Pages === 1) {
                            if (LIST.length !== 0) {
                                this.list = LIST;
                            } else {
                                this.list = [];
                            }
                        } else {
                            if (LIST.length !== 0) {
                                this.list = this.list.concat(LIST);
                            }
                        }
                    }else {
                        api.toast({
                            msg: res.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }.bind(this));
            }
        }
    })

}
