window.showcaseService = {
    fileLen: 0,         // 选择了几个文件
    uploadedCount: 0,   // 已经上传的文件计数
    list: [],           // 选择文件的结果
    onSuccessCallback: null,    // 选择并上传完毕之后的成功回调函数
    setUploadedCallback: function(callbacck) {
        this.onSuccessCallback = callbacck;
    },
    open: function () {
        var that = this;
        var systemType = api.systemType;
        actionSheet([
            {
                text: MSG.general.takePicture,
                callback: function () {
                    if (!checkPermission('camera')) {
                        if (systemType === 'android') {
                            requestPermission("camera");
                        } else {
                            api.requestPermission({
                                list: ["camera"],
                                code: 1
                            }, function (ret, err) {
                                if (ret.list[0].granted) {
                                    that.getPicture('camera');
                                }
                            });
                        }

                    } else {
                        that.getPicture('camera');
                    }
                }
            },
            {
                text: MSG.general.library,
                callback: function () {
                    if (!checkPermission('photos')) {
                        if (systemType === 'android') {
                            requestPermission("photos");
                        } else {
                            api.requestPermission({
                                list: ["photos"],
                                code: 1
                            }, function (ret, err) {
                                if (ret.list[0].granted) {
                                    that.getPicture('photos');
                                }
                            });
                        }

                    } else {
                        that.getPicture('photos');
                    }
                }
            }
        ]);
    },
    getPicture: function (type) {
        var UIAlbumBrowser = api.require('UIAlbumBrowser');
        var that = this;
        var videos = ['mp4', 'mpg', 'mov', 'wmv', 'm3u8'];
        var pics = ['jpg', 'jpeg', 'raw', 'png', 'bmp'];
        if (type === 'photos') {
            UIAlbumBrowser.open({
                max: 9,
                isOpenPreview: true,
                classify: true,
                type: 'all',
                styles: {
                    bg: '#FFFFFF',
                    cameraImg: 'widget://res/cameraImg.png',
                    mark: {
                        icon: '',
                        position: 'bottom_left',
                        size: 20
                    },
                    nav: {
                        bg: '#252525',
                        cancelColor: '#fff',
                        cancelSize: 16,
                        nextStepColor: '#fff',
                        nextStepSize: 16,
                        cancelText: MSG.general.cancel,
                        finishText: MSG.general.ok,
                    }
                },
            }, function (ret) {
                setTimeout(function () {
                    console.warn("[UIAlbumBrowser.open] [" + api.deviceName + "]" + JSON.stringify(ret));
                    if (ret.eventType === 'nextStep' || ret.eventType === 'confirm') {
                        // UIAlbumBrowser.closePicker();
                        // that.closeBoard();
                        var medias = ret.list;
                        var len = medias.length;
                        that.fileLen = len;
                        var temp;
                        for (var i = 0; i < len; i++) {
                            temp = medias[i];
                            if (temp.mediaType) {
                                temp.type = temp.mediaType;
                            } else {
                                if (videos.indexOf(temp.suffix.toLowerCase()) >= 0) {
                                    temp.type = 'video';
                                } else {
                                    temp.type = 'image';
                                }
                            }

                            (function (media, index) {
                                if (api.systemType.toLowerCase() === 'ios') {
                                    if (media.type === 'image') {
                                        UIAlbumBrowser.transPath({
                                            quality: 'highest',
                                            scale: 1, //
                                            path: media.path
                                        }, function (Ret, err) {
                                            that.sendImage(Ret.path, index);
                                        });
                                    } else {
                                        UIAlbumBrowser.transVideoPath({
                                            path: media.path
                                        }, function (Ret, err) {
                                            console.warn("[UIAlbumBrowser.transVideoPath] [" + api.deviceName + "]" + JSON.stringify(Ret));
                                            if (Ret.status) {
                                                that.sendVideo(Ret.albumVideoPath, index);
                                            }
                                        });
                                    }
                                } else {
                                    if (media.type === 'image') {
                                        that.sendImage(media.path, index);
                                    } else {
                                        that.sendVideo(media.path, index);
                                    }
                                }
                            })(temp, i);
                        }
                    }
                });
            });
        } else {
            // 拍照/摄像
            actionSheet([
                {
                    text: MSG.general.takePicture,
                    callback: function () {
                        api.getPicture({
                            sourceType: 'camera',
                            encodingType: 'jpg',
                            mediaValue: 'pic',
                            destinationType: 'url',
                            allowEdit: false,
                            quality: 80,
                            saveToPhotoAlbum: false
                        }, function (ret, err) {
                            console.warn("[" + api.deviceName + "]" + ret.data);
                            if (ret) {
                                that.closeBoard();
                                that.sendImage(ret.data);
                            }
                        });
                    }
                },
                {
                    text: MSG.general.takeVideo,
                    callback: function () {
                        api.getPicture({
                            sourceType: 'camera',
                            mediaValue: 'video',
                            destinationType: 'url',
                        }, function (ret, err) {
                            console.warn("[" + api.deviceName + "]" + ret.data);
                            if (ret.data) {
                                that.closeBoard();
                                that.sendVideo(ret.data);
                            }
                        });
                    }
                }
            ]);

        }
    },
    sendVideo: function(path, index) {
        var that = this;
        apiMedia.uploadVideo("/upload/videos", path).done(function (response) {
            api.hideProgress();
            var data = response.data[0];
            that.list[index] = {
                mediaType: 'Video',
                fileName: data.name,
                thumbnailUrl: data.thumbnailUrl,
                mediaFileUrl: data.downloadUrl,
                durationSeconds: Math.ceil(data.duration),
                fileSize: data.size
            };
            that.uploadedCount++;
            if (that.uploadedCount === that.fileLen) {
                that.onSuccessCallback(that.list);
                that.reset();
            }
        });
    },
    sendImage(path, index) {
        loading('show');
        var that = this;
        var savePath = api.fsDir;
        var specialStr = path.substring(path.lastIndexOf('/') + 1).split(".")[0];
        var imageFilter = api.require('imageFilter');
        var pattern = new RegExp("[`/~@#$^&=|{}':;, \\[\\]<>￥…‘；：”“。，、？+]");
        var picName = "";
        for (var i = 0; i < specialStr.length; i++) {
            picName += specialStr.substr(i, 1).replace(pattern, '');
        }
        imageFilter.getAttr({
            path: path
        }, function (ret, err) {
            if (ret.status) {
                var originWidth = ret.width;
                var originHeight = ret.height;
                var maxWidth = 1080, maxHeight = 2400;
                var targetWidth = originWidth, targetHeight = originHeight;
                if (originWidth > maxWidth || originHeight > maxHeight) {
                    if (originWidth / originHeight > maxWidth / maxHeight) {
                        targetWidth = maxWidth;
                        targetHeight = Math.round(maxWidth * (originHeight / originWidth));
                    } else {
                        targetHeight = maxHeight;
                        targetWidth = Math.round(maxHeight * (originWidth / originHeight));
                    }
                }
                var S = 1;
                var Q = 1;
                imageFilter.compress({
                    img: path,
                    quality: Q,
                    scale: S,
                    size: {
                        w: targetWidth,
                        h: targetHeight
                    },
                    save: {
                        album: false,
                        imgPath: savePath + '/tweebaaCache/',
                        imgName: picName + '.jpg',
                    }
                }, function (ret, err) {
                    if (ret.status) {
                        var imgPath = savePath + '/tweebaaCache/' + picName + '.jpg';
                        that.uploadImagesNew(imgPath, picName + '.jpg', index);
                        loading('hide');
                    } else {
                        alert(JSON.stringify(err));
                    }
                });

            } else {
                //alert( JSON.stringify( err ) );
            }

        });
    },
    uploadImagesNew(filepath, filename, index) {
        var that = this;
        apiMedia.upload("/upload/images", filepath).done(function (response) {
            console.log("[" + api.deviceName + "]" + JSON.stringify(response));
            var data = response.data[0];
            that.list[index] = {
                mediaType: 'Picture',
                fileName: filename,
                thumbnailUrl: data.thumbnail,
                mediaFileUrl: data.raw
            };
            that.uploadedCount++;
            if (that.uploadedCount === that.fileLen) {
                that.onSuccessCallback(that.list);
                that.reset();
            }
        });
    },
    reset: function () {
        this.fileLen = 0;
        this.uploadedCount = 0;
        this.list = [];
    }
};
