apiready = function () {

    api.setWinAttr({
        bounces: false
    });

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    var momentListHtml = api.readFile({
        sync: true,
        path: 'widget://html/fragment/moment.html'
    });
    $('#momentBox').html(momentListHtml);

    api.addEventListener({
        name: 'changeTweeLogShowcases'
    }, function(ret, err){
        tweeLogDetail.media = ret.value.list;
    });
    api.addEventListener({
        name: 'myScore'
    }, function(ret, err){
        tweeLogDetail.getTweelogDetail();
    });
    api.addEventListener({
        name: 'applyContent'
    }, function(ret, err){
        tweeLogDetail.applyContent = ret.value.content;
        tweeLogDetail.sendApply();
    });
    var tweelogInfo = api.pageParam.tweelogInfo;
    var tweelogId = tweelogInfo.tweelogId;
    var TYPE = tweelogInfo.type;

    var appleCheck = api.getGlobalData({
        key: 'appleCheck'
    });


    var tweeLogDetail = new Vue({
        el: '#tweeLogDetail',
        mixins: [
            FRAGMENT_MOMENT
        ],
        mounted: function () {
            var that = this;
            this.getTweelogDetail();
            this.getStory();
            this.getSocial();
            this.getMedia();
            this.openPPFrame(); //打开底部瞬间和产品的浮动窗口
            this.getIsEditor();
            this.setScore();
        },
        data: {
            appleCheck: appleCheck,
            myId:localStorage.getItem('userId'),
            myName:localStorage.getItem('storename'),
            myThumbnail:localStorage.getItem('thumbnail'),
            isEditor:false,  //= true 可以编辑背景和视频
            isApplyJoin:true, //= true 可以申请加入
            detail:tweelogInfo,
            TYPE:'',
            tweelogType:'',
            backgroundUrl:'',
            media:'',
            pics:[],
            totalScore:'',
            score:'',
            longitude:"",
            latitude:"",
            socialMedia:'',
            showAccount:'',
            members:'',
            ourStory:"",
            applyContent:""
        },
        filters:{
            displayType:function (value) {
                if (value) {
                    var text = value.toLowerCase();
                    return MSG.tweeLog['type-'+text]
                }
            }
        },
        methods: {
            setScore: function () {
                if(TYPE === "COLLAB"){
                    this.getMembers();
                    new Rate({
                        dom: this.$refs.rate,
                        rate: +this.detail.totalScore,
                    });
                }
                new Rate({
                    dom: this.$refs.totalrate,
                    rate: +this.detail.totalScore,
                });
            },
            preShare: function () {
                var that = this;
                actionSheet([
                    {
                        text: MSG.general.shareto,
                        callback: function () {
                            that.openShareBar();
                        }
                    },
                    {
                        text: MSG.general.repostChat,
                        callback: function () {
                            that.toRepostChatPage();
                        }
                    }
                ]);
            },
            /**
             * 打开分享
             * @override
             */
            openShareBar:function(){
                var thumbnail = this.detail.avatarUrl;
                var content = this.detail.name.replace(REG_SHARE_FILTER," ");
                var title = this.detail.owner.storeName + MSG.tweeLog.shareTitle;

                var ShareUrl = shareH5Host + '/html/tweelog.html?tweelogid=' + tweelogId
                    + '&name=' + this.detail.name
                    + '&userid=' + this.detail.owner.userId
                    + "&shareid=" + localStorage.getItem('userName')
                    + '&page=td';
                // console.log(ShareUrl);
                // console.log(JSON.stringify(this.userInfo));

                new OpenShareBox(ShareUrl, title, content, this.detail.owner.userName, '', 'prod', thumbnail, this.detail.owner.userId);
            },
            toRepostChatPage: function () {
                var userId = this.myID;
                var name = this.detail.owner.storeName + MSG.tweeLog.shareTitle;
                var Content = this.detail.name;
                var userThumbnail = this.detail.owner.avatarUrl;
                var thumbnail = this.detail.avatarUrl;
                openShareToChats({
                    title: name,
                    description: Content,
                    imageUrl: thumbnail,
                    extra: {
                        textType: 'tweeLog',
                        tweelogId: tweelogId,
                        tweelogInfo: JSON.stringify(this.detail),
                        userId: userId,
                        AvatarUrl: thumbnail,
                        userPortrait: userThumbnail,
                        storeName: this.myName,
                    }
                });
            },
            changeShowcases: function() {
                api.openFrame({
                    name: 'changeTweeLogShowcases',
                    url: 'widget://html/tweelog/frame/change-showcase.html',
                    bgColor:'rgba(0, 0, 0, 0.4)',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    animation:{
                        type:"movein",
                        subType:"from_bottom",
                        duration:300
                    },
                    pageParam: {
                        tweelogdata: $.extend({}, this.detail, {
                            showcases: this.media
                        })
                    }
                });
            },
            getTweelogDetail:function(){
                var that = this;
                loading('show');
                apiTweelog.get("/api/v1/tweelog/"+ tweelogId +"/basic/detail", {}).done(function (rep) {
                    //console.log(JSON.stringify(rep));
                    if(rep.code === 0){
                        that.detail = rep.data;
                        that.TYPE = rep.data.type;
                        that.tweelogType = rep.data.tweelogType;
                        that.backgroundUrl = rep.data.backgroundUrl;
                        that.longitude = rep.data.longitude;
                        that.latitude = rep.data.latitude;
                        that.totalScore = rep.data.totalScore;
                        that.score = rep.data.score;
                        that.setScore();
                        loading('hide');

                        //如果没有存地址信息则通过经纬度取
                        if(!rep.data.address){
                            that.showAddress();
                        }
                    }

                });
            },
            getIsEditor:function(){
                var that = this;
                if(that.myId == that.detail.owner.userId){
                    that.isEditor = true
                }else{
                    apiTweelog.get("/api/v1/tweelog/"+ tweelogId +"/user/property", {}).done(function (rep) {
                        console.log(JSON.stringify(rep));
                        that.isEditor = rep.data.editor;
                        that.isApplyJoin = rep.data.applyJoin;  //todo 判断是否可以点申请按钮
                    });
                }
            },
            changeBg: function () {
                var that = this;
                var type;
                actionSheet([
                    {
                        text: MSG.general.takePicture,
                        callback: function () {
                            type = 'camera';
                            start();
                        }
                    },
                    {
                        text: MSG.general.library,
                        callback: function () {
                            type = 'library';
                            start();
                        }
                    }
                ]);

                function start() {

                    api.getPicture({
                        sourceType: type,
                        encodingType: 'jpg',
                        mediaValue: 'pic',
                        destinationType: 'url',
                        allowEdit: false,
                        quality: 70,
                        targetWidth: 640,
                        saveToPhotoAlbum: false
                    }, function (ret, err) {

                        if (ret) {
                            loading('show');

                            setTimeout(function () {
                                // console.log("[" + api.deviceName + "]" + JSON.stringify(ret));
                                apiMedia.upload("/upload/images", ret.data).done(function (response) {
                                    console.log(JSON.stringify(response));

                                    var data = response.data[0];
                                    var imgURL = data.raw;

                                    var params = {
                                        "tweelogId": tweelogId,
                                        "backgroundUrl":imgURL
                                    };

                                    apiTweelog.post("/api/v1/tweelog/background", params).done(function (rep) {
                                        loading('hide');
                                        if(rep.code ===0){
                                           that.backgroundUrl = imgURL
                                        }
                                    });

                                });
                            }, 200);

                        } else {
                            loading('hide');
                            console.log(JSON.stringify(err));
                        }
                    });
                }

            },
            getMedia :function(){
                var that = this;
                apiTweelog.get("/api/v1/tweelog/"+ tweelogId +"/media", {}).done(function (rep) {
                    that.pics = [];
                    that.media = rep.data;
                    for(var i=0;i<that.media.length;i++){
                        if(that.media[i].mediaType ==='PICTURE'){
                            that.pics.push(that.media[i].mediaFileUrl)
                        }
                    }
                });
            },
            getStory :function(){
                var that = this;
                apiTweelog.get("/api/v1/tweelog/"+ tweelogId +"/story", {}).done(function (rep) {
                    that.ourStory = rep.data.content;
                });
            },
            getSocial :function(){
                var that = this;
                apiTweelog.get("/api/v1/tweelog/"+ tweelogId +"/socials", {}).done(function (rep) {
                    that.socialMedia = rep.data;
                });
            },
            getMembers:function(){
                var that = this;
                var params = {
                    "page": 1,
                    "size": 6,
                    "tweelogId": tweelogId,
                };
                apiTweelog.get("/api/v1/tweelog/members", params).done(function (rep) {
                    that.members = rep.data.list;
                });
            },
            openMemberList:function(){
                openTabLayout("location",MSG.tweeLog.allMembers,"widget://html/tweelog/frame/member-list.html",{
                    tweelogId:tweelogId,
                    isEditor:this.isEditor,
                    members:this.members,
                })
            },
            toPlace:function(userInfo){
                openUserTycoonPlace(userInfo.userId, userInfo.storeName,userInfo.avatarUrl);
            },
            showAddress: function () {
                var that = this;
                var lon = this.longitude;
                var lat = this.latitude;
                var map = api.require('bMap');
                if(api.systemType === 'ios'){
                    map.initMapSDK(function(ret) {
                        if (ret.status) {
                            getName();
                        }
                    });
                }else{
                    getName();
                }
                function getName() {
                    map.getNameFromCoords({
                        lon: lon,
                        lat: lat
                    }, function(ret, err) {
                        if (ret.status) {
                            that.detail.address = ret.address
                        }
                    });
                }
            },
            showMediaAccount:function (index) {
                this.showAccount = index;
            },
            changeList:function (type) {
                this.listBtn = type;
            },
            openPPFrame:function () {
                api.openFrame({
                    name: 'postPord',
                    url: 'frame/post-product.html',
                    bgColor:'rgba(0, 0, 0, 0)',
                    rect: {
                        x: 0,
                        y: api.winHeight - 80,
                        w: 'auto',
                        h: 'auto'
                    },
                    pageParam: {
                        tweelogId: tweelogId
                    }
                });
            },
            openMedia:function (type,url,thumb) {
                var that = this;
                if(type === 'VIDEO' ){
                    playVideo(url,'',thumb);
                }else{
                    var Index = that.pics.indexOf(url);
                    var UIPhotoViewer = api.require('UIPhotoViewer');
                    UIPhotoViewer.open({
                        images: that.pics,
                        placeholderImg: 'widget://image/lost_images.jpg',
                        bgColor: '#000',
                        activeIndex: Index,
                        zoomEnabled: true,
                        gestureClose: true
                    }, function (Ret, err) {
                        if (Ret.eventType === 'click') {
                            UIPhotoViewer.close();
                        }
                    });
                }
            },
            favorite:function () {
                var that = this;
                var params = {
                    "tweelogId": tweelogId,
                };
                loading('show');
                apiTweelog.post("/api/v1/tweelog/favorites", params).done(function (rep) {
                    loading('hide');
                    if(rep.code ===0){
                        var text;
                        if(that.detail.favorite){
                            that.detail.favoriteCount --;
                            that.detail.favorite = false;
                            text = MSG.moment.unfavored;
                        }else{
                            that.detail.favoriteCount ++;
                            that.detail.favorite = true;
                            text = MSG.moment.favored;
                        }
                        api.toast({
                            msg: text,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            },
            showStar:function(totalScore){
                if(totalScore){
                    return parseInt(totalScore);
                }else{
                    return 0;
                }
            },
            toEdit: function() {
                openTabLayout('createTweeLog', MSG.tweeLog.edit, 'widget://html/tweelog/editTweeLog.html', {
                    tweelogId: tweelogId
                });
            },
            toChat:function () {
                var chatID = localStorage.getItem('chatID');
                if (chatID) {
                    if(this.TYPE === 'PERSONAL'){
                        this.chatToUser(this.detail.owner);
                    }else{
                        openTabLayout('groupContact', MSG.tweeLog.concatMember, 'widget://html/tweelog/frame/group-contact.html', {
                            tweelogId: tweelogId
                        });
                    }
                } else {
                    openLogin();
                }

            },
            chatToUser: function (userinfo) {
                var that = this;
                restartChatPage({
                    targetId: userinfo.userName + '@new',
                    userName: userinfo.storeName,
                    userPortrait: that.avatarUrl,
                    conversationType: 'PRIVATE',
                    isTop: false
                });
            },
            copyInfo:function (info) {
                var clipBoard = api.require('clipBoard');
                clipBoard.set({
                    value: info
                }, function (ret, err) {
                    if (ret) {
                        api.toast({
                            msg: MSG.tips.copied,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            },
            openLink:function (link) {
                openBrowser('',link,'')
            },
            openLocation:function () {
                openTabLayout("location",MSG.tweeLog.locationTitle,"widget://html/tweelog/frame/show-location.html",{
                    lon:this.detail.longitude,
                    lat:this.detail.latitude,
                    address:this.detail.address,
                })
            },
            openMarkFrame:function () {
                api.openFrame({
                    name: 'markFrame',
                    url: 'mark-page.html',
                    bgColor:'rgba(0, 0, 0, 0)',
                    rect: {
                        x: 0,
                        y: api.winHeight-400,
                        w: 'auto',
                        h: 400
                    },
                    pageParam: {
                        scoreId: this.detail.score.scoreId,
                        myScore: this.detail.score.myScore,
                        tweelogId:tweelogId
                    }
                });
            },
            applyBtn:function () {
                openTabLayout("apply",MSG.tweeLog.applyJoin,"widget://html/tweelog/frame/apply-join.html")
            },
            sendApply:function () {
                var that = this;
                if(that.applyContent){
                    var params = {
                        "tweelogId": tweelogId,
                        "reason": that.applyContent
                    };
                    loading('show');
                    apiTweelog.post("/api/v1/tweelog/members/applies", params).done(function (rep) {
                        loading('hide');
                        console.log(JSON.stringify(rep));
                        if(rep.code ===0){
                            api.toast({
                                msg: MSG.tips.applicationSent,
                                duration: 2000,
                                location: 'middle'
                            });
                            that.getIsEditor();
                        }
                    });
                }
            }
        }

    });

};