apiready = function () {
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    backListener();

    var downloadManager = api.require('downloadManager');
    var downloadManagerPage = new Vue({
        el: '#downloadManagerPage',
        created: function () {
            this.getDownloadList();
        },
        filters: {
            showTitle: function (value) {
                return value.split('##')[0]
            },
            formatSize:function (value) {
                return (value / 1048576).toFixed(2)
            }
        },
        data: {
            videos:['mp4','mpg','mov','wmv','m3u8'],
            pics: ['jpg','jpeg','raw','png','bmp'],
            audios:['amr','wav','mp3','m4a'],
            text :['txt','doc','docx','xlsx','xls','pdf'],
            currentType:'allList',
            allList:[],
            imgList:[],
            videoList:[],
            audioList:[],
            textList:[],
            otherList:[],
            showList:[],
            searchTitle:'',
            message:MSG
        },
        methods: {
            changeType:function(type){
                this.currentType = type;
                this.showList = this[type];
            },
            searchForm:function(){
                var that = this;
                that.showList = [];
                var D = this[this.currentType];
                for(var i= 0; i<D.length;i++){
                    if(D[i].title.indexOf(that.searchTitle) !== -1){
                        that.showList.push(D[i]);
                    }
                }
            },
            getDownloadList:function () {
                var that = this;
                downloadManager.query({
                }, function(ret, err) {
                    if (ret) {
                        console.log(JSON.stringify(ret));
                        if(!ret.data){
                            that.allList = [];
                        }else{
                            that.allList = ret.data;
                            that.showList = that.allList;
                            for(var i =0; i < that.allList.length;i++){
                                var url = that.allList[i].savePath;
                                var key = url.lastIndexOf(".");
                                var xName = (url.substr(key+1)).toLowerCase();

                                if (that.videos.indexOf(xName) !== -1) {
                                    that.videoList.push(that.allList[i])
                                } else if (that.pics.indexOf(xName) !== -1) {
                                    that.imgList.push(that.allList[i])
                                } else if (that.audios.indexOf(xName) !== -1) {
                                    that.audioList.push(that.allList[i])
                                } else if (that.text.indexOf(xName) !== -1) {
                                    that.textList.push(that.allList[i])
                                }else {
                                    that.otherList.push(that.allList[i])
                                }

                            }

                        }
                    }
                });
            },
            openDownloadFile:function(index){
                var that = this;
                var url = this.showList[index].savePath;
                //console.log(url);
                var fileType;
                var prod = this.showList[index].title;
                var prodName = prod.split('##')[0];
                var prodId = prod.split('##')[1];
                var pic = this.showList[index].iconPath;

                var key = url.lastIndexOf(".");
                var xName = (url.substr(key+1)).toLowerCase();

                if (that.videos.indexOf(xName) !== -1) {
                    fileType = 'video'
                } else if (that.pics.indexOf(xName) !== -1) {
                    fileType = 'image'
                } else if (that.audios.indexOf(xName) !== -1) {
                    fileType = 'audios'
                } else if (that.text.indexOf(xName) !== -1) {
                    fileType= 'text';
                }else {
                    fileType = 'other'
                }

                if(fileType ==='video' || fileType ==='image' || fileType ==='audios'){
                    openDigitalProd(url,fileType,prodName,prodId,pic);
                }else if(fileType ==='text'){
                    if(xName === 'pdf'){
                        url = this.showList[index].url;
                        openDigitalProd(url,'pdf',prodName,prodId,pic);
                    }else{
                        openDigitalProd(url,'other',prodName,prodId,pic,xName);
                    }
                }else{
                    api.openApp({
                        iosUrl: url,
                        androidPkg: 'android.intent.action.VIEW',
                        mimeType: 'text/html',
                        uri: url
                    });
                }
            },
            delFile:function(index){
                var that = this;
                api.actionSheet({

                    cancelTitle: MSG.general.cancel,
                    destructiveTitle: MSG.payment.deleteDownloadFile,
                }, function(ret, err) {

                    if(ret.buttonIndex == 1){
                        downloadManager.remove({
                            ids: [
                                that.showList[index].id
                            ]
                        }, function(ret, err) {
                            if (ret) {
                                that.getDownloadList();
                            }
                        });
                    }
                });

            },
            saveToAlbum:function(index){
                var that = this;
                loading('show');
                api.saveMediaToAlbum({
                    path: that.showList[index].savePath
                }, function(ret, err) {
                    loading('hide');
                    if (ret && ret.status) {
                        alert(MSG.tips.saved);
                    }
                });
            },
            showMoreBtn:function (index) {
                var that = this;
                var menu = [
                    {
                        text: MSG.payment.openFile,
                        callback: function () {
                            that.openDownloadFile(index);
                        }
                    },
                    {
                        text: MSG.payment.deleteDownload,
                        callback: function () {
                            that.delFile(index);
                        }
                    }
                ];
                if(that.showList[index].mimeType.indexOf("image") !== -1 || that.showList[index].mimeType.indexOf("video") !== -1){
                    menu.unshift({
                        text: MSG.general.saveToAlbum,
                        callback: function () {
                            that.saveToAlbum(index);
                        }
                    })
                }
                actionSheet(menu);
            }
        }
    });
};
