apiready = function () {
    backListener();

    var username = localStorage.getItem('userName');
    var db = api.require('db');
    var ret = db.openDatabaseSync({
        name: username
    });

    var appleCheck = api.getGlobalData({
        key: 'appleCheck'
    });

    var favoriteList = new Vue({
        el: '#favoriteList',
        mounted: function () {
            this.getFavoriteList();
        },
        data: {
            appleCheck: appleCheck,
            favoriteList: [],
            noFavorite:''
        },
        methods: {
            getFavoriteList:function () {
                var showFavorite = db.selectSqlSync({
                    name: localStorage.getItem('userName'),
                    sql: 'SELECT * FROM favorite'
                });
                if(showFavorite.status){
                    var d = showFavorite.data;
                    var len = d.length;
                    if(len!==0){
                        for(i = 0; i<len; i++){
                            d[i].userInfo = (JSON.parse(d[i].userInfo));
                        }
                        console.log(JSON.stringify(d));
                        this.favoriteList = d;
                    }else{
                        this.noFavorite = $.i18n.prop('noFavorite');
                    }

                }else{
                    var createTable = db.executeSqlSync({
                        name: username,
                        sql: "CREATE TABLE favorite(prodId INT PRIMARY KEY,userId INT,prodImg text,prodName text,userInfo text);"
                    });
                    console.log(JSON.stringify(createTable) +'db 创建数据表')
                }
            },
            removeFavorite:function (prodId,event) {
                var tar  = event.target;
                $(tar).closest('li').remove();
                var cleanKey = db.selectSqlSync({
                    name: username,
                    sql: 'DELETE FROM favorite WHERE prodId ='+prodId
                });
            },
            openDetail: function (prodId,userInfo) {
                api.openWin({
                    name: 'productDetail',
                    url: 'widget://html/products/product-detail.html',
                    bounces: false,
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    bgColor: '#fff',
                    animation: {
                        type: "movein",
                        subType: "from_right",
                    },
                    pageParam: {
                        prodId: prodId,
                        userInfo:JSON.stringify(userInfo),
                        countryCode:userInfo.RegisterCountryCode
                    }
                });
            }
        }
    })
};
