apiready = function () {
    var page = 0;
    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/' + lan + '.json'
    }));

    var type = api.pageParam.type;
    var UserId = api.pageParam.userId;
    var unread = api.pageParam.unread;

    backListener();

    var title;
    if(type === 'follow'){
        // 关注
        title = MSG.mine.following;
    }else{
        // 粉丝
        title = MSG.mine.follower;
    }
    api.setTabLayoutAttr({
        title: title
    });

    api.addEventListener({
        name: 'swiperight'
    }, function (ret, err) {
        back();
    });

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 300
        }
    }, function (ret, err) {
        if (!followedList.isLoading) {
            page++;
            followedList.getFollowList();
        }
    });

    // 在级联打开粉丝列表的情况下使用
    api.addEventListener({
        name: 'refreshFollowList'
    }, function (ret, err) {
        loading('show');
        type = ret.value.type;
        userId = ret.value.userId;
        followedList.condition.page = 1;
        followedList.getFollowList();
    });

    api.addEventListener({
        name: 'dialogRemarkSuccess'
    }, function (ret, err) {
        followedList.$forceUpdate();
    });

    var followedList = new Vue({
        el: '#followList',
        mounted: function () {
            var that = this;
            that.getFollowList();
        },
        data: function () {
            return {
                isLoading: true,
                from: api.pageParam.from,   // 来自页面，'conversation'
                listData: [],
                title: MSG.general[type],
                myID: +localStorage.getItem('userId'),
                noFollow: '',
                message: MSG,
            }
        },
        methods: {
            getFollowList: function () {
                var that = this;
                var userId = UserId || this.myID;
                if (this.searchInput !== '') {

                    loading('show');
                    that.isLoading = true;
                    var t = type === 'follow' ? 'followees' : 'followers';
                    var url = getBaseUrl() + "/api/users/" + userId + "/" + t + "?viewerId=" + this.myID + "&Pg=" + page + "&Nu=24";
                    getAxois(url, "GET", {}).then(function (response) {
                        var list;
                        that.isLoading = false;
                        loading('hide');
                        if (response.data.length !== 0 && page === 0) {
                            list = response.data;
                            if (type === 'follower') {
                                $.map(list, function (item, index) {
                                    if (unread > 0) {
                                        item.read = false;
                                        unread--;
                                    } else {
                                        item.read = true;
                                    }
                                });
                            }
                            that.listData = list;

                            // setTimeout(function () {
                            //     that.listData = response.data.reverse();
                            //     if(!UserId){
                            //         FollowList[type] = response.data;
                            //         kv.setObject({
                            //             key: 'FollowList',
                            //             value:FollowList
                            //         });
                            //     }
                            // });
                        } else if (response.data.length !== 0 && page !== 0) {
                            list = response.data;
                            if (type === 'follower') {
                                $.map(list, function (item, index) {
                                    if (unread > 0) {
                                        item.read = false;
                                        unread--;
                                    } else {
                                        item.read = true;
                                    }
                                });
                            }
                            that.listData = that.listData.concat(list);
                        } else if (response.data.length === 0 && page === 0) {
                            that.noFollow = type === 'follow' ? MSG.tips.noFollowing : MSG.tips.noFollower;
                        }

                    }).catch(function (error) {
                        console.log(JSON.stringify(error));
                    });
                }
            },
            followBtn: function (item) {
                var token = api.getPrefs({
                    sync: true,
                    key: 'accessToken'
                });
                if (token) {
                    if (item.Followed === true) {
                        disFollow(item.CustomerGuid, function () {
                            item.Followed = false;
                        });
                    } else {
                        follow(item.CustomerGuid, item.UserName, function () {
                            item.Followed = true;
                        });
                    }
                } else {
                    openLogin();
                }
            },
            openTycoonPlace: function (index) {
                openUserTycoonPlace(this.listData[index].Id, this.listData[index].StoreName, this.listData[index].AvatarUrl, 'searchUsers')
            },
            openChatPage: function (index) {
                var user = this.listData[index];

                var chatId = user.UserName + '@new';
                var userName = user.StoreName;
                var userAvatar = user.AvatarUrl;
                var userId = user.Id;

                chatTo(chatId, userId, userName, userAvatar, 'PRIVATE', false);

                //进入聊天页面
                function chatTo(targetId, userId, username, userPortrait, conversationType, isTop) {
                    openChatPage({
                        targetId: targetId,
                        userId: userId,
                        userName: username,
                        userPortrait: userPortrait,
                        conversationType: conversationType,
                        isTop: isTop
                    });
                }
            },
            setRemark: function(data) {
                var that = this;
                userRemarkService.open({
                    userId: data.Id,
                    avatarUrl: data.ThumbnailAvatarUrl,
                }, function (name) {
                    data.StoreName = name;
                });
            },
        }

    });

};
