var mPages = 0;
var homePage;
apiready = function () {
    var momentListHtml = api.readFile({
        sync: true,
        path: 'widget://html/fragment/moment.html'
    });
    $('#momentBox').html(momentListHtml);

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/' + lan + '.json'
    }));

    var token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });
    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 500            //设置距离底部多少距离时触发，默认值为0，数字类型
        }
    }, function (ret, err) {
        if (!homePage.bottomLoading && !homePage.isLoading) {
            mPages++;
            homePage.getAllMoments();
        }

    });

    var kv = api.require('snKVStorage');

    api.addEventListener({
        name: 'resetPost',
    }, function (ret, err) {
        switch (ret.value.type) {
            case 'remove':
                var postGuid = ret.value.postGuid;
                homePage.removeByGuid(postGuid);
                break;
            case 'like':
                if (ret.value.from === 'home') {
                    homePage.momentsData[ret.value.index].Liked = ret.value.liked;
                    homePage.momentsData[ret.value.index].LikedCount = ret.value.likedCount;
                }
                if (ret.value.from === 'video') {
                    var list = homePage.momentsData;
                    for (var i = 0, len = list.length; i < len; i++) {
                        if (list[i].Id == ret.value.index) {
                            list[i].Liked = ret.value.liked;
                            list[i].LikedCount = ret.value.likedCount;
                        }
                    }
                }
                break;
            case 'comments':
                if (ret.value.from === 'home' && ret.value.commentCount === 'add') {
                    homePage.momentsData[ret.value.index] && homePage.momentsData[ret.value.index].commentCount++;
                } else if (ret.value.from === 'home' && ret.value.commentCount === 'minus') {
                    homePage.momentsData[ret.value.index] && homePage.momentsData[ret.value.index].commentCount--;
                }
                break;
        }
    });

    //下拉刷新
    api.setRefreshHeaderInfo({
        loadingImg: 'widget://image/refresh-logo.png',
        bgColor: '#fff',
        textColor: '#000',
        textDown: MSG.tips.pullDownRefresh,
        textLoading: MSG.tips.refreshing,
        showTime: false,
        textUp: MSG.tips.releaseRefresh
    }, function (ret, err) {
        api.refreshHeaderLoadDone();
        homePage.refreshMoment();
    });

    api.addEventListener({
        name: 'reloadHome',
    }, function (ret, err) {
        //mPages = 0;
        // homePage.getAllMoments();
        //$("body").scrollTop(0);
        api.pageUp({
            top: true
        });
        homePage.token = api.getPrefs({
            sync: true,
            key: 'accessToken'
        });
        homePage.refreshMoment();
        //location.reload();
    });

    api.addEventListener({
        name: 'guideHomeFollow'
    }, function (ret, err) {
        api.pageUp({
            top: true
        });
        setTimeout(function () {
            api.openFrame({
                name: 'guideHomeFollow',
                url: 'widget://html/guide/guide-home-follow.html',
                rect: {
                    x: 0,
                    y: 0,
                    w: 'auto',
                    h: 'auto'
                },
                bounces: false,
                bgColor: 'rgba(0, 0, 0, 0)',
                fixedOn: 'ui_layout',
                animation: {
                    type: "fade",
                }
            });
        }, 400);
    });

    api.addEventListener({
        name: 'dialogRemarkSuccess'
    }, function (ret, err) {
        homePage.$forceUpdate();
    });

    // 重叠的数组映射
    // key是瞬间列表的guid
    var overlapMap = {
        // 'xxxx-yyyy-zzzz': [
        //     {}, // moment1
        //     {}, // moment2
        //     ...
        // ]
    };

    var postDataHome = {};
    var hasPostData = kv.has({
        key: 'postDataHome'
    });
    if (hasPostData) {
        postDataHome = kv.getObject({
            key: 'postDataHome'
        });
    }

    homePage = new Vue({
        el: '#home',
        mixins: [
            FRAGMENT_MOMENT
        ],
        mounted: function () {
        },
        created: function () {
            var that = this;
            this.setCachePostData();

            this.getAllMoments(0);
            // this.initResearch();

            var version = api.appVersion.toString();

            var m = Math.random();
            getAxois("https://tweebaafiles-com.oss-accelerate.aliyuncs.com/check.json?"+m, "GET", {}).then(function (response) {
                if(api.systemType ==='ios'){
                    that.appleCheck = !!((response.data.version === version && response.data.check) || localStorage.getItem('userId') == "1808307");
                }
            })
        },
        data: function () {
            var winWidth = api.winWidth - 20;
            var w66 = winWidth * 2 / 3;
            return {
                appleCheck: false,
                page: 'home',
                type: 'WORLD',   // 推荐=RECOMMEND 世界=WORLD 关注=FOCUS
                defaultTags: POST_TAGS,
                randomData: [],
                myUsername: localStorage.getItem('userName'),
                momentMap: {},
                condition: {
                    pageNum: 0,
                    pageSize: DEFAULT_PAGE_SIZE * 2,
                    sort: '',
                    tagId: '',
                    type: ''
                },
                momentsData: [],
                myID: +localStorage.getItem('userId'),
                currentTag: 'WORLD',
                bannerLink: [],
                bottomLoading: false,
                isLoading: false,
                token: token,
                scrollTop: 0,
                showResearchTip: false,
                showResearch: false,    // 是否展示调查对话框
                message: MSG,
                selectedTag: ''
            };
        },
        filters: {},
        methods: {
            selectTag: function (tagId) {
                this.selectedTag = tagId;
                var token = api.getPrefs({
                    sync: true,
                    key: 'accessToken'
                });
                if (tagId) {
                    if (token) {
                        apiMoment.post('/api/v1/logs', {
                            customerId: this.myID,
                            tags: [{
                                id: tagId + ''
                            }]
                        }).done(function (rep) {
                            if (rep.code === 0) {
                                console.log('收集Tag... ' + tagId);
                            }
                        });
                    } else {
                        apiMoment.post('/api/v1/logs/device', {
                            deviceId: api.deviceId,
                            tags: [{
                                id: tagId + ''
                            }]
                        }).done(function (rep) {
                            if (rep.code === 0) {
                                console.log('收集Tag... ' + tagId);
                            }
                        });
                    }
                }
                this.refreshMoment();
            },
            removeByGuid: function (momentGuid) {
                var item;
                for (var i = 0, len = this.momentsData.length; i < len; i++) {
                    item = this.momentsData[i];
                    if (item.momentGuid === momentGuid) {
                        this.momentsData.splice(i, 1);
                        break;
                    }
                }
            },
            refreshMoment: function () {
                mPages = 0;
                overlapMap = {};
                this.condition.pageNum = 0;
                this.condition.sort = '';
                this.getAllMoments();
                api.pageUp({
                    top: true
                });
            },
            height: function (event) {
                var aa = event.target;
                // console.log(aa);
            },
            setCachePostData: function () {
                var cachePostData = postDataHome[this.type];
                if (cachePostData) {
                    this.momentsData = cachePostData;
                } else {
                    this.momentsData = [];
                    $('#placeHolderLoad').show();
                }
            },
            /**
             * 切换世界、推荐、关注
             * @param type
             */
            switchTage: function (type) {
                var that = this;
                this.selectedTag = '';
                if (!that.token && type === 'FOCUS') {
                    openLogin();
                } else {
                    // if (type === 'WORLD') {
                    //     this.selectedTag = 4096;  //当切换到'世界'时第一个标签是'推易吧'
                    // }
                    this.type = type;
                    this.setCachePostData();
                    this.currentTag = type;
                    this.refreshMoment();
                }
            },
            searchFocus: function () {
                //openWindows('searchUsers','widget://html/chat/search-friend.html');
                api.openWin({
                    name: 'searchUsers',
                    url: 'widget://html/chat/search-friend.html',
                    bounces: true,
                    scrollToTop: true,
                    rect: {
                        x: 0,
                        y: 0,
                        w: api.screenWidth,
                        h: 'auto'
                    },
                    slidBackEnabled: false,
                    allowEdit: true,
                    bgColor: '#fff',
                    animation: {
                        type: "movein",
                        subType: "from_left",
                        duration: 100
                    },
                });
            },
            morePost: function (index, moment) {
                moment.sameNumber = 0;
                var list = overlapMap[moment.momentGuid];

                var arrPrefix = this.momentsData.slice(0, index + 1);
                var arrSuffix = this.momentsData.slice(index + 1);
                var newList = arrPrefix.concat(list).concat(arrSuffix);
                this.momentsData = newList;
                this._initSwipper();

                delete overlapMap[moment.momentGuid];
            },
            _doOverlap: function (list) {
                var results = [];
                var tempItem;
                var item;
                for (var i = 0, len = list.length; i < len; i++) {
                    item = list[i];
                    item.sameNumber = 0;
                    if (i === 0) {
                        tempItem = item;
                        results.push(item);
                        continue;
                    }
                    // 重叠发生
                    if (item.owner.id === tempItem.owner.id) {
                        // 维护字典
                        if (!overlapMap[tempItem.momentGuid]) {
                            overlapMap[tempItem.momentGuid] = [];
                        }
                        overlapMap[tempItem.momentGuid].push(item);
                        tempItem.sameNumber++;
                    } else {
                        // 重叠结束
                        tempItem = item;
                        results.push(item);
                    }

                }

                return results;
            },
            getAllMoments: function () {

                var currentType = this.type;

                var that = this;
                if (that.isLoading) {
                    return false;
                }
                if (mPages === 0) {
                    loading('show');
                } else {
                    that.bottomLoading = true
                }
                that.isLoading = true;
                var viewerId = localStorage.getItem('userId') || '';
                // var url;
                // if (localStorage.getItem('server') === 'com') {
                //     url = "http://us.tweebaa.com:26678/api/v3/moments";
                // } else {
                //     url = getBaseUrl() + "/api/v3/moments";
                // }
                // url = "https://api.tweebaa.cn/api/v3/moments";
                // url = getBaseUrl() + "/api/v3/moments";
                var Token = localStorage.getItem('access_token');
                // var paramStr = {
                //     "currentpage": mPages,
                //     "itemsperpage": 16,
                //     "ShowOnHomePage": true,
                //     "ShowFollowee": this.type === "FOCUS",
                //     "viewerId": viewerId,
                //     "IsFeatured": this.type === "RECOMMEND" ? true : null,
                //     "TagId": this.type !== "FOCUS" ? that.selectedTag : ''
                // };

                var param = $.extend({}, this.condition);

                var url;
                if (Token) {
                    url = '/api/v1/blog_posts/moments';
                } else {
                    url = '/api/v1/blog_posts/moments/anonymous';
                    param.deviceId = api.deviceId;
                }

                param.tagId = this.type !== "FOCUS" ? that.selectedTag : '';
                param.type = this.type;

                if(currentType === 'RECOMMEND'){
                    url = '/suggestions';

                    apiRecommend.get(url, param).done(function (rep) {
                        //console.log(JSON.stringify(rep));
                        that.bottomLoading = false;
                        that.isLoading = false;
                        loading('hide');
                        $('#placeHolderLoad').hide();
                        if (rep.code === 0) {
                            var list = rep.data.list;
                            that._initMomentsData(list);

                            var newList = that._doOverlap(list);
                            if (mPages === 0) {
                                that.momentsData = newList;
                                that._initSwipper();
                                postDataHome[currentType] = newList;
                            } else {
                                if (newList.length !== 0) {
                                    that.momentsData = that.momentsData.concat(newList);
                                    that._initSwipper();
                                }
                            }
                            // that.condition.sort = rep.data.sort.join(',');
                            // that.condition.pageNum = rep.data.pageNum;
                        } else {
                            api.toast({
                                msg: rep.message,
                                duration: 2000,
                                location: 'middle'
                            });
                            that.isLoading = false;
                        }
                    });

                }else{
                    // console.log(JSON.stringify(paramStr));
                    apiMoment.get(url, param).done(function (rep) {
                        // console.log(JSON.stringify(rep));
                        that.bottomLoading = false;
                        that.isLoading = false;
                        loading('hide');
                        $('#placeHolderLoad').hide();
                        if (rep.code === 0) {
                            var list = rep.data.blogPosts;
                            that._initMomentsData(list);
                            var newList = list;
                            if (that.type === 'WORLD' || that.type === 'RECOMMEND') {
                                newList = that._doOverlap(list);
                            }
                            if (mPages === 0) {
                                that.momentsData = newList;
                                that._initSwipper();
                                postDataHome[currentType] = newList;
                                kv.setArray({
                                    key: 'postDataHome',
                                    value: postDataHome
                                });
                            } else {
                                if (newList.length !== 0) {
                                    that.momentsData = that.momentsData.concat(newList);
                                    that._initSwipper();
                                }
                            }
                            that.condition.sort = rep.data.sort.join(',');
                            that.condition.pageNum = rep.data.pageNum;
                        } else {
                            api.toast({
                                msg: rep.message,
                                duration: 2000,
                                location: 'middle'
                            });
                            that.isLoading = false;
                        }
                    });
                }



            },
            createProduct: function () {
                if (this.token) {
                    var name = this.message.home.selectProductType;
                    openTabLayout('prepareAdd', name, 'widget://html/products/prepare-add.html');
                } else {
                    openLogin();
                }
            },
            createPost: function () {
                if (this.token) {
                    openTabLayout('addMoment', '', 'widget://html/users/add-moment.html');
                } else {
                    openLogin();
                }
            },
            toggleMore: function (moment, index) {
                var that = this;

                this.currentMoment.index = index;
                this.currentMoment.detail = moment;
                this.currentMoment.ownerId = moment.owner.id;

                // 自己的帖子
                if (moment.owner.id === this.myID) {
                    actionSheet([
                        {
                            text: MSG.general.edit,
                            callback: function () {
                                that.editThisMoment();
                            }
                        },
                        {
                            text: MSG.general.delete,
                            callback: function () {
                                that.deleteThisMoment();
                            }
                        }
                    ]);
                    return;
                }

                var buttons = [
                    {
                        text: MSG.general.messages,
                        callback: function () {
                            that.chatToUser();
                        }
                    },
                    {
                        text: MSG.home.enterTycoon,
                        callback: function () {
                            that.enterTycoon();
                        }
                    },
                    {
                        text: MSG.general.report,
                        callback: function () {
                            that.report();
                        }
                    },
                    {
                        text: MSG.general.dislike,
                        callback: function () {
                            that.dislike();
                        }
                    },
                ];

                if (this.token) {
                    if (moment.followed === false) {
                        buttons.unshift({
                            text: MSG.home.follow,
                            callback: function () {
                                follow(that.currentMoment.detail.owner.userGuid, that.currentMoment.detail.owner.userName, function () {
                                    moment.followed = true;
                                });
                            }
                        });
                    } else {
                        buttons.unshift({
                            text: MSG.home.unfollow,
                            callback: function () {
                                disFollow(that.currentMoment.detail.owner.userGuid, function () {
                                    moment.followed = false;
                                });
                            }
                        });
                    }
                } else {
                    buttons.unshift({
                        text: MSG.home.follow,
                        callback: function () {
                            openLogin();
                        }
                    });
                }

                actionSheet(buttons);
            },
            hideMore: function () {
                $('.select-post').removeClass('show');
            },
            _getUserDetails: function () {
                var that = this;
                var url = getBaseUrl() + "/api/users/" + api.pageParam.userId + "?viewerId=" + this.myID;
                loading('show');
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(response.data));
                    that.userInfo = response.data;
                    that.getmonents(0);
                    that.getPhotoWall(response.data.CustomerGuid);
                    that.photoHeight = $('#photoWidth').width();
                    that.bigAvatarUrl = response.data.AvatarUrl;
                    that.avatarUrl = response.data.AvatarUrl;
                    that.storeName = response.data.StoreName;
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            /**
             * 互动
             */
            chatToUser: function () {
                var that = this;
                var chatID = localStorage.getItem('chatID');
                var userInfo = that.currentMoment.detail.owner;
                if (chatID) {
                    openChatPage({
                        targetId: userInfo.userName + '@new',
                        userId: userInfo.id,
                        userName: userInfo.storeName,
                        userPortrait: userInfo.thumbnailAvatarUrl,
                        conversationType: 'PRIVATE',
                        isTop: false
                    });
                } else {
                    openLogin();
                }
            },
            /**
             * 进入空间
             */
            enterTycoon: function () {
                this.openTycoonPlace(this.currentMoment.index);
            },
            /**
             * 不喜欢
             */
            dislike: function () {
                var that = this;
                ClosePopUpBox();
                var token = api.getPrefs({
                    sync: true,
                    key: 'accessToken'
                });
                if (token) {
                    loading('show');
                    apiMoment.post('/api/v1/dislikes', {
                        source: 'MOMENT',
                        sourceId: this.currentMoment.detail.blogPostId
                    }).done(function (rep) {
                        loading('hide');
                        if (rep.code === 0) {
                            that.removeByGuid(that.currentMoment.detail.momentGuid);
                        } else {
                            api.toast({
                                msg: rep.message,
                                duration: 2000,
                                location: 'middle'
                            });
                        }
                    }).fail(function (e) {
                        console.log(e.message);
                    });
                } else {
                    openLogin();
                }
            },
            /**
             * 反馈
             */
            report: function () {
                openReportPage({
                    target: 'MOMENT',
                    targetId: this.currentMoment.detail.blogPostId
                });
            },
            editThisMoment: function () {
                openTabLayout('addMoment', '', 'widget://html/users/add-moment.html', {
                    postId: this.currentMoment.detail.blogPostId,
                    postGuid: this.currentMoment.detail.momentGuid
                });
            },
            deleteThisMoment: function () {
                var that = this;
                this.hideMore();
                confirm(MSG.tips.wantDelete, [
                    {
                        text: MSG.general.ok,
                        callback: function () {
                            loading('show');
                            apiMoment.post('/api/v1/blog_posts/' + that.currentMoment.detail.momentGuid + '/delete').done(function (rep) {
                                loading('hide');
                                if (rep.code === 0) {
                                    // 是否删除的是折叠项
                                    var overlapList = overlapMap[that.currentMoment.detail.momentGuid];
                                    // 删除当前缓存
                                    delete overlapMap[that.currentMoment.detail.momentGuid];

                                    if (overlapList) {
                                        var firstMoment = overlapList.shift();
                                        // 缓存项依旧>0，设置新的缓存
                                        if (overlapList.length > 0) {
                                            overlapMap[firstMoment.momentGuid] = overlapList;
                                            firstMoment.sameNumber = overlapList.length;
                                        } else {
                                            firstMoment.sameNumber = 0;
                                        }
                                        that.momentsData.splice(that.currentMoment.index, 1);
                                        that.momentsData.splice(that.currentMoment.index, 0, firstMoment);
                                        that._initSwipper();
                                    } else {
                                        that.momentsData.splice(that.currentMoment.index, 1);
                                    }

                                    api.toast({
                                        msg: MSG.general.success,
                                        duration: 2000,
                                        location: 'middle'
                                    });
                                    kv.setArray({
                                        key: 'postData',
                                        value: that.momentsData
                                    });
                                } else {
                                    api.toast({
                                        msg: rep.message,
                                        duration: 2000,
                                        location: 'middle'
                                    });
                                }
                            }).fail(function (e) {
                                console.log(e.message);
                            });

                        }
                    },
                    {
                        text: MSG.general.cancel,
                        callback: function () {

                        }
                    }
                ]);
            },
            initResearch: function () {
                if (!this.token) {
                    return;
                }
                var userId = localStorage.getItem('userId');
                // var hasShownResearch = localStorage.getItem(userId + '_hasShownResearch');
                // if(!hasShownResearch){
                var researchFirst = localStorage.getItem(userId + '_researchFirst');
                if (!researchFirst) {
                    this.showResearch = true;
                } else {
                    this.showResearch = false;
                }
                this.showResearchTip = true;
                // }
            },
            openResearchTip: function () {
                this.showResearch = true;
            },
            openResearch: function () {
                var that = this;
                var userId = localStorage.getItem('userId');
                var title = lan === 'zh' ? '推易吧用户行为调研' : 'Tweebaa User Behavior Survey';
                var link = lan === 'zh' ? 'https://wj.qq.com/s2/6591368/dfe1' : 'https://forms.gle/ov8aVto1D9gjANJy9';
                openBrowser(null, link, title);
                setTimeout(function () {
                    // localStorage.setItem(userId + '_hasShownResearch', true);
                    localStorage.setItem(userId + '_researchFirst', true);
                    that.showResearch = false;
                    // that.showResearchTip = false;
                }, 2000);
            },
            closeResearch: function () {
                var userId = localStorage.getItem('userId');
                this.showResearch = false;
                localStorage.setItem(userId + '_researchFirst', true);
            },
            closeResearchTip: function ($event) {
                $event.stopPropagation();
                this.showResearchTip = false;
            }
        }
    });

    $('#Mask').on('click', function () {
        $('.create-menu,#Mask').addClass('d-none');
        $(this).html('').removeClass('black');
        $('#home').css({'height': 'auto', "overflow": "scroll"});
    });
};

// function tycoonplacePoint(){
//     var text = lan==='zh'?"&#8619 推主空间中内容更精彩":"&#8619 More exciting content in Tycoonplace";
//     var p = "<p class='text-white text-b lg-text p-5' style='position: relative;z-index: 10;margin-left: 5rem; margin-top: 1rem'>"+text+"</p>";
//     $('.tycoon-avatar').css({'z-index':10,"position":"relative"});
//     $('#Mask').addClass('black').removeClass('d-none').append(p);
//     $('#home').css({'height':'100%',"overflow":"hidden"});
//     api.setPrefs({
//         key: 'firstIn',
//         value: 'firstIn'
//     });
// }

$('.save-image-btn').on('click', function () {
    loading('show');
    api.download({
        url: $('#downloadImage').val(),
        report: true,
        cache: true,
        allowResume: true
    }, function (ret, err) {
        if (ret.state === 1) {
            var Url = ret.savePath;
            loading('hide');
            api.saveMediaToAlbum({
                path: Url,
                groupName: "Tweebaa"
            }, function (ret, err) {
                if (ret && ret.status) {
                    api.toast({
                        msg: MSG.tips.saved,
                        duration: 2000,
                        location: 'middle'
                    });
                }
            });

        }
    });
});

function closeImg() {
    if (homePage.imageShow) {
        var UIPhotoViewer = api.require('UIPhotoViewer');
        UIPhotoViewer.close();
        homePage.imageShow = false;
    } else {
        api.toLauncher();
    }
}

function refreshPage() {
    location.reload();
}
