
apiready = function () {
    //进入页面统计点
    var td = api.require('talkingData');
    td.onPageStart({pageName: '瞬间详情'});

    var momentListHtml = api.readFile({
        sync: true,
        path: 'widget://html/fragment/moment.html'
    });
    $('#momentBox').html(momentListHtml);

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/' + lan + '.json'
    }));

    var momentId = api.pageParam.momentId || api.pageParam.prodId;
    var momentGuid = api.pageParam.momentGuid;
    var userId = api.pageParam.userId;
    var type = api.pageParam.type;
    var useServer = api.pageParam.useServer === 'cn' ? 'CN' : 'COM';
    var isView = api.pageParam.isView;

    api.setNavBarAttr({
        rightButtons: [{
            iconPath: 'widget://image/share0.png',
            color: '#a1a1a1',
            fontSize: '18'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function (ret, err) {
        if (ret.type === 'right') {
            sharePost.shareAndRepost(0);
        } else {
            sharePost.setAnalyticsInfo();
        }
    });

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 800
        }
    }, function (ret, err) {
        if (sharePost.currentTag === 'comments' && sharePost.bottomLoadingComment === false
                && sharePost.comments.length < sharePost.totalComment) {
            sharePost.conditionComment.page++;
            sharePost.getComments();
        } else if (sharePost.currentTag === 'like' && sharePost.bottomLoadingLike === false
                && sharePost.likeList.length < sharePost.totalLike) {
            sharePost.conditionLike.page++;
            sharePost.getLikeList();
        }
    });

    api.addEventListener({
        name: 'reloadComments'
    }, function (ret, err) {
        sharePost.getComments();
        if (ret.value) {
            sharePost.momentsData[0].commentCount++;
        } else {
            sharePost.momentsData[0].commentCount--;
        }
    });

    api.addEventListener({
        name: 'reloadMomentDetail',
    }, function (ret, err) {
        sharePost.getMomentDetail(momentId);
    });

    api.setRefreshHeaderInfo({
        loadingImg: 'widget://image/refresh-logo.png',
        bgColor: '#fff',
        textColor: '#000',
        textDown: MSG.tips.pullDownRefresh,
        textLoading: MSG.tips.refreshing,
        showTime: false,
        textUp: MSG.tips.releaseRefresh
    }, function (ret, err) {
        loading('show');
        sharePost._init();
    });

    var taskService = new TaskService(TASK_CODE.GROUP_PERSON_PROFILE);

    // 用户需要先完成任务，再评论
    taskService._showDialog = function () {
        dialog({
            title: MSG.novice.dialogFunctionTitle,
            content: MSG.novice.dialogFuntionDesc1,
            primaryText: MSG.novice.btnText,
            onPrimary: function () {
                openTabLayout('novice', '', 'widget://html/frame/novice.html', {
                    id: TASK_CODE.GROUP_PERSON_PROFILE
                });
            },
            onClose: function () {
                console.log('on close ...');
            },
            asideText: MSG.novice.optText,
            onAside: function () {
                // console.log('asdie...');
                sharePost.sendComment();
            }
        });
    };

    var time = 0;

    function setTime() {
        // console.log(time);
        setTimeout(function () {
            time++;
            setTime();
        }, 1000)
    }

    setTime();

    var appleCheck = api.getGlobalData({
        key: 'appleCheck'
    });

    var sharePost = new Vue({
        el: '#sharePost',
        mixins: [
            FRAGMENT_MOMENT
        ],
        mounted: function () {
            this._init();

            // 给底部操作添加safeArea
            var safeBottom = api.safeArea.bottom;
            $('.ui-actionsheet').find('button:last-child').css({
                paddingBottom: safeBottom + 'px'
            });
        },
        created: function () {
            if (type === 'comments') {
                this.currentTag = 'comments';
            } else if (type === 'like') {
                this.currentTag = 'like';
            } else if (type === 'reward') {
                this.currentTag = 'reward';
            }
        },
        data: function () {
            var momentsData = [];
            if (api.pageParam.detailData) {
                momentsData = [api.pageParam.detailData];
            }
            return {
                appleCheck: appleCheck,
                page: 'momentDetail',
                userInfo: '',
                // momentsData: USERPOSTDETAIL['userpost'+momentId] ? USERPOSTDETAIL['userpost'+momentId]:[],
                momentsData: momentsData,
                myUsername: localStorage.getItem('userName'),
                myID: +localStorage.getItem('userId') || '',
                useServer: useServer,
                //viewTime:0,
                //viewDuration:0,
                rewardCount: 0,
                totalReward: '-',
                linkTitle: '',
                comments: '',
                noComment: false,
                images: [],
                currentTag: 'comments',
                message: MSG,
                likeList: [],    // 点赞人员列表
                rewardList: [], // 打赏人员列表
                safearea: api.safeArea.bottom,
                rePostData: null,
                isRequesting: false,
                conditionComment: {
                    page: 1,
                    size: DEFAULT_PAGE_SIZE,
                    postId: momentId
                },
                conditionLike: {
                    page: 1,
                    size: DEFAULT_PAGE_SIZE,
                    source: 'MOMENT',
                    sourceId: momentId
                },
                bottomLoadingComment: false,
                bottomLoadingLike: false,
                totalComment: 0,
                totalLikes: 0,
                targetCommentId: null,
                targetName: '',
                targetUserId: '',
                currentComment: null,
                currentUserInfo: null
            }
        },
        filters: {
            formatTime: function (value) {
                return moment.utc(value).local().format('YYYY-MM-DD HH:mm');
            }
        },
        methods: {
            _init: function () {
                this.getMomentDetail(momentId);
                this.getUserDetails();
                // this.getViewTime();

                this.getComments();
                this.getLikeList();

                this.getReward();
            },
            reset: function() {
                this.targetCommentId = null;
                this.currentComment = null;
                this.currentUserInfo = null;
            },
            followBtn: function (item) {
                event.stopPropagation();
                var token = api.getPrefs({
                    sync: true,
                    key: 'accessToken'
                });
                if (token) {
                    if (item.followed === false) {
                        follow(item.userInfo.userGuid, item.userInfo.userName, function () {
                            item.followed = true;
                        });
                    } else {
                        disFollow(item.userInfo.userGuid, function () {
                            item.followed = false;
                        });
                    }
                } else {
                    openLogin();
                }
            },
            changeTag: function (TagType) {
                var that = this;
                if (this.currentTag === 'like' && TagType === 'like') {
                    var token = api.getPrefs({
                        sync: true,
                        key: 'accessToken'
                    });
                    if (token) {
                        if (that.momentsData[0].liked) {
                            disLike(momentId, function () {
                                that.momentsData[0].liked = false;
                                that.momentsData[0].likedCount--;
                                var likeList = that.likeList;
                                for (var l = 0; l < likeList.length; l++) {
                                    if (likeList[l].userInfo.customerId === that.myID) {
                                        likeList.splice(l, 1);
                                    }
                                }
                            });
                        } else {
                            like(momentId, function () {
                                that.momentsData[0].liked = true;
                                that.momentsData[0].likedCount++;
                                var likeUser = {
                                    "avatarUrl": localStorage.getItem('thumbnail'),
                                    "storeName": localStorage.getItem('storename'),
                                    "customerId": that.myID,
                                    "userName": localStorage.getItem('userName'),
                                    "userGuid": localStorage.getItem('userGuid')
                                };
                                that.likeList.unshift({
                                    followed: true,
                                    userInfo: likeUser
                                });
                            });
                        }
                    } else {
                        openLogin();
                    }
                }
                this.currentTag = TagType;
            },
            getUserDetails: function () {
                var that = this;
                var url = getBaseUrl() + "/api/users/" + userId + "?viewerId=" + this.myID;
                getAxois(url, "GET", {}).then(function (response) {
                    that.userInfo = response.data;
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            // getViewTime:function(){
            //     var that = this;
            //     var url = getBaseUrl() + "api/data-analytics/get-basic-data/moment/"+momentId;
            //     getAxois(url, "GET", {}).then(function (response) {
            //         if(response.data.Success){
            //             that.viewTime = response.data.DataAnalytics.ViewCount;
            //             that.viewDuration = formatSeconds(Math.round(response.data.DataAnalytics.StayTimeSeconds));
            //         }
            //     }).catch(function (error) {
            //     });
            // },

            /**
             * 初始化底部发布评论输入框
             */
            initCommentInput: function (from, type, postId, sideUserName) {
                var that = this;
                var UIChatBox = api.require('UIChatBox');
                UIChatBox.open({
                    placeholder: MSG.moment.commentPlaceholder,
                    maxRows: 2,
                    autoFocus: false,
                    isClose: false,
                    emotionPath: 'widget://res/img/emotion',
                    texts: {
                        sendBtn: {
                            title: MSG.general.send,
                        }
                    },
                    styles: {
                        topDivider: {
                            width: 1,
                            color: '#fff'
                        },
                        inputBar: {
                            borderColor: '#F2F2F2',
                            bgColor: '#F2F2F2',
                            textSize: 16,
                        },
                        inputBox: {
                            borderColor: '#fff',
                            bgColor: '#fff',
                            boardBgColor: '#eee',
                            topMargin: api.systemType === 'ios' ? 8 : 6
                        },
                        sendBtn: {
                            titleColor: '#FFF',
                            bg: '#4578F3',
                            activeBg: '#346EF0',
                            titleSize: 13
                        }
                    },
                }, function (ret, err) {
                    if (ret) {
                        if (ret.eventType === 'show' && localStorage.getItem("saveCommentDraft")) {
                            UIChatBox.value({
                                msg: localStorage.getItem("saveCommentDraft")
                            });
                        }
                        if (ret.eventType === 'send') {
                            localStorage.removeItem("saveCommentDraft");
                            var token = api.getPrefs({
                                sync: true,
                                key: 'accessToken'
                            });
                            if (token) {
                                taskService.check(function () {
                                    that.sendComment(ret.msg);
                                });
                            } else {
                                openLogin();
                            }
                        }
                    }
                    // if (isView === true) {
                    //     var UIChatBox = api.require('UIChatBox');
                    //     UIChatBox.closeKeyboard();
                    // }
                });
            },
            /**
             * 评论瞬间内容
             * @param msg
             */
            sendComment: function (msg) {
                var that = this;

                var UIChatBox = api.require('UIChatBox');
                UIChatBox.closeKeyboard();

                msg = $.trim(msg);
                if (!msg) {
                    api.toast({
                        msg: MSG.moment.saySomething,
                        duration: 2000,
                        location: 'middle'
                    });
                    return;
                }

                // 防止同一个评论连续提交两次
                if (this.isRequesting === true) {
                    return;
                }

                var param = {
                    postId: momentId,
                    targetCommentId: this.targetCommentId,
                    text: msg
                };
                this.isRequesting = true;
                loading('show');
                apiMoment.post('/api/v1/comments', param).done(function (rep) {
                    loading('hide');
                    that.isRequesting = false;
                    if (rep.code === 0) {

                        // FIXME
                        api.sendEvent({
                            name: 'reloadComments',
                            extra: {
                                add: 'add',
                            }
                        });

                        showTiV(true);

                        // 发送通知
                        // 1. 发给推主
                        var myUserName = localStorage.getItem('userName');
                        if (myUserName !== that.userInfo.UserName) {
                            postNotify(that.userInfo.UserName, MSG_TYPE_COMMENT, {
                                Type: 'comment',
                                AvatarUrl: localStorage.getItem('thumbnail'),
                                StoreName: localStorage.getItem('storename'),
                                UserId: localStorage.getItem('userId'),
                                PostId: momentId,
                                PostGuid: momentGuid,
                            });
                        }
                        // 2. 如果有回复的话，发给回复的人通知
                        if (that.currentUserInfo) {
                            if (myUserName !== that.currentUserInfo.userName) {
                                postNotify(that.currentUserInfo.userName, MSG_TYPE_COMMENT, {
                                    Type: 'reply',
                                    AvatarUrl: localStorage.getItem('thumbnail'),
                                    StoreName: localStorage.getItem('storename'),
                                    UserId: localStorage.getItem('userId'),
                                    PostId: momentId,
                                    PostGuid: momentGuid,
                                });
                            }
                        }

                        that.reset();

                        // 通知首页评论个数增加
                        if (api.pageParam.postIndex !== null) {
                            api.sendEvent({
                                name: 'resetPost',
                                extra: {
                                    type: "comments",
                                    index: api.pageParam.postIndex,
                                    commentCount: 'add',
                                    from: api.pageParam.from,
                                    postId: momentId
                                }
                            });
                        }
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (e) {
                    console.log(e.message);
                });

            },
            getMomentDetail: function (momentId) {
                var that = this;
                api.refreshHeaderLoadDone();
                apiMoment.get('/api/v1/blog_posts/detail/' + momentId).done(function (rep) {

                    if (rep.code === 0) {

                        var result = rep.data;

                        that.getLikeList();

                        var list = [result];
                        that._initMomentsData(list);

                        that.momentsData = list;

                        that._initSwipper();

                        setTimeout(function () {
                            loading('hide');
                            if (type && document.body.scrollHeight > (api.winHeight + 100)) {
                                var h = that.$refs.userComments.offsetTop;
                                window.scroll(0, h);
                            }
                        }, 300);

                        // 初始化输入框
                        that.initCommentInput();

                        if (result.ShowOnHomePage === false) {
                            api.setNavBarAttr({
                                rightButtons: [{
                                    iconPath: '',
                                    color: '#a1a1a1',
                                    fontSize: '15'
                                }]
                            });
                        }

                        //写入转发信息
                        if (that.rePostData) {
                            that.momentsData[0].rePost = that.rePostData;
                        }
                    } else if (rep.code === 410) {
                        api.toast({
                            msg: MSG.tips.deletedPost,
                            duration: 2000,
                            location: 'middle'
                        });
                        setTimeout(function () {
                            back();
                        }, 2000);
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            getReward: function () {
                var that = this;
                var url = getBaseUrl() + "api/v2/blogposttipping/list?PostId=" + momentId + "&ViewerId=" + that.myID + "&currentpage=0&itemsperpage=100";
                getAxois(url, "GET", {}).then(function (response) {
                    if (response.data.Code === 0) {
                        that.rewardList = response.data.Data.TipList;
                        that.totalReward = response.data.Data.TipTotalAmount || '-';
                        that.rewardCount = response.data.Data.TipCount;
                    }
                    //console.log(JSON.stringify(response));
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            getComments: function () {
                var that = this;
                if (this.conditionComment.page === 1) {
                    loading('show');
                } else {
                    this.bottomLoadingComment = true;
                }
                apiMoment.get('/api/v1/comments', this.conditionComment).done(function (rep) {
                    loading('hide');
                    that.bottomLoadingComment = false;
                    if (rep.code === 0) {

                        var comments = rep.data.records;
                        // 将子评论倒序
                        for (var i = 0, len = comments.length; i < len; i++) {
                            var item = comments[i];
                            item.store = null;
                            item.showMoreSubs = false;   // 是否显示所有子评论
                            if (item.subComments && item.subComments.total > 0) {
                                var subComments = item.subComments.records.slice(0);
                                item.subCommentsNew = subComments;
                                for (var j = 0, lenJ = item.subCommentsNew.length; j < lenJ; j++) {
                                    var itemInner = item.subCommentsNew[j];
                                    itemInner.store = null;
                                    var comment = itemInner.comment;
                                    var arrs = comment.split('  ');
                                    if (arrs.length > 1) {
                                        itemInner.targetName = arrs[0];
                                        itemInner.originName = itemInner.userInfo.storeName;
                                        itemInner.comment = arrs[1];
                                    } else {
                                        itemInner.originName = itemInner.userInfo.storeName;
                                    }
                                }
                                item.subCommentsNewText = item.subCommentsNew.slice(0, 3);
                            }
                        }

                        if (that.conditionComment.page === 1) {
                            that.comments = comments;
                        } else {
                            that.comments = that.comments.concat(comments);
                        }

                        that.totalComment = rep.data.total;
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (e) {
                    console.log(e.message);
                });
            },
            getLikeList: function () {
                var that = this;
                if (this.conditionLike.page === 1) {

                } else {
                    this.bottomLoadingLike = true;
                }
                apiMoment.get('/api/v1/likes', this.conditionLike).done(function (rep) {
                    loading('hide');
                    that.bottomLoadingLike = false;
                    if (rep.code === 0) {
                        var likeList = rep.data.records;
                        if (that.conditionLike.page === 1) {
                            that.likeList = likeList;
                        } else {
                            that.likeList = that.likeList.concat(likeList);
                        }
                        that.totalLike = rep.data.total;
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (e) {
                    console.log(e.message);
                });
            },
            openReplyMenu: function ($event, targetCommentId, comment, userInfo) {
                $event.stopPropagation();

                var UIChatBox = api.require('UIChatBox');
                UIChatBox.hide();

                var that = this;
                this.targetCommentId = targetCommentId;
                this.currentComment = comment;
                this.currentUserInfo = userInfo;

                var buttons = [
                    {
                        text: MSG.moment.reply + ' ' + userInfo.storeName,
                        callback: function () {
                            that.reply();
                        }
                    },
                    {
                        text: MSG.general.translate,
                        callback: function () {
                            that.commentTranslation();
                        }
                    },
                    {
                        text: MSG.general.copy,
                        callback: function () {
                            that.commentCopy();
                        }
                    }
                ];

                if (userInfo.customerId === this.myID || this.userInfo.Id === this.myID) {
                    buttons.push({
                        text: MSG.general.delete,
                        callback: function () {
                            that.deleteComment();
                        }
                    });
                }

                actionSheet(buttons, function () {
                    UIChatBox.show();
                });
            },
            closeReplyMenu: function () {
                var UIChatBox = api.require('UIChatBox');
                UIChatBox.show();
            },
            reply: function () {
                var that = this;
                var UIChatBox = api.require('UIChatBox');
                UIChatBox.show();
                setTimeout(function () {
                    var UIChatBox = api.require('UIChatBox');
                    UIChatBox.insertValue({
                        index: 0,
                        msg: that.currentUserInfo.storeName + '  '
                    });
                    UIChatBox.popupKeyboard();
                }, 200);
            },
            seeAll: function ($event, item) {
                $event.stopPropagation();
                loading('show');
                apiMoment.get('/api/v1/comments/' + item.id + '/sub_comments', {
                    page: 1,
                    size: item.subComments.total,
                }).done(function (rep) {
                    loading('hide');
                    if (rep.code === 0) {
                        var subComments = rep.data.records;
                        var subCommentsNew = subComments;
                        for (var j = 0, lenJ = subCommentsNew.length; j < lenJ; j++) {
                            var itemInner = subCommentsNew[j];
                            var comment = itemInner.comment;
                            var arrs = comment.split('  ');
                            if (arrs.length > 1) {
                                itemInner.targetName = arrs[0];
                                itemInner.originName = itemInner.userInfo.storeName;
                                itemInner.comment = arrs[1];
                            } else {
                                itemInner.originName = itemInner.userInfo.storeName;
                            }
                        }
                        item.subCommentsNewText = subCommentsNew;
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (e) {
                    console.log(e.message);
                });
            },
            hideShareRepost: function () {
                $('.select-repost').removeClass('show');
                var UIChatBox = api.require('UIChatBox');
                UIChatBox.show();
            },
            hideInputRepost: function () {
                $('.input-repost').removeClass('show');
                $("html,body").css({
                    "position": "static",   //去除相对于窗口的定位
                });
                $(window).scrollTop(this.scrollTop);     //恢复浏览器原来的滚动距离
                var UIChatBox = api.require('UIChatBox');
                UIChatBox.show();
            },
            inputRepost: function ($event) {
                $event && $event.stopPropagation();
                $('.input-repost').addClass('show');
                $('.select-repost').removeClass('show');
                this.scrollTop = $(window).scrollTop();
                $("html,body").css({
                    "position": "fixed",
                    "top": -this.scrollTop
                });
                var UIChatBox = api.require('UIChatBox');
                UIChatBox.hide();
            },
            /**
             * 打开分享
             * @override
             */
            openShareBar: function ($event) {
                $event && $event.stopPropagation();
                $('.select-repost').removeClass('show');
                var that = this;
                var ShareUrl = shareH5Host + '/html/post.html?postid=' + this.momentsData[0].blogPostId + "&shareid=" + localStorage.getItem('userName');
                var postGuid = this.momentsData[0].momentGuid;
                var username = this.userInfo.UserName;
                var thumbnail = this.userInfo.ThumbnailAvatarUrl;
                // var title = this.momentsData[0].Title? this.momentsData[0].Title.replace(REG_SHARE_FILTER," ") : name;

                var name = this.userInfo.StoreName.replace(REG_SHARE_FILTER, " ");
                var Content;
                if (!this.currentMoment.detail.rePost) {
                    name = name.replace(/&nbsp;/g, " ");
                    Content = this.momentsData[0].content ? this.momentsData[0].content.replace(REG_SHARE_FILTER, " ") : "推易吧";
                    if (Content && Content.length > 40) {
                        Content = Content.slice(0, 40) + '...';
                    }
                } else {
                    name = '@' + name + MSG.moment.shareRepostTitle;
                    Content = MSG.moment.shareRepostContent;
                }

                if (localStorage.getItem('userGuid')) {
                    setTimeout(function () {
                        AddTivNew('share_post_outside', {
                            postOwnerId: that.momentsData[0].owner.id
                        });
                    }, 2000);
                }
                new OpenShareBox(ShareUrl, name, Content, username, momentId, 'postDetail', thumbnail, postGuid);
                var UIChatBox = api.require('UIChatBox');
                UIChatBox.hide();
            },
            commentCopy: function () {
                var that = this;

                var UIChatBox = api.require('UIChatBox');
                UIChatBox.show();

                var clipBoard = api.require('clipBoard');
                clipBoard.set({
                    value: this.currentComment.comment
                }, function (ret, err) {
                    if (ret) {
                        api.toast({
                            msg: that.message.tips.copied,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                });
            },
            commentTranslation: function () {
                var that = this;

                var UIChatBox = api.require('UIChatBox');
                UIChatBox.show();

                var url = getBaseUrl() + '/api/v2/translation';
                var paramStr = {
                    "q": this.currentComment.comment,
                    "LanguageCode": lan,
                };
                loading('show');
                getAxois(url, "POST", paramStr).then(function (response) {
                    that.currentComment.store = response.data.TranslatedText;
                    that.reset();
                    loading('hide');
                }).catch(function (error) {
                    loading('hide');
                });
            },
            commentOriginalText: function ($event, comment) {
                $event.stopPropagation();
                comment.store = null;
            },
            deleteComment: function () {
                var that = this;
                loading('show');
                apiMoment.remove('/api/v1/comments/' + this.targetCommentId).done(function (rep) {
                    loading('hide');
                    if (rep.code === 0) {
                        api.toast({
                            msg: MSG.general.success,
                            duration: 2000,
                            location: 'middle'
                        });
                        $('[id=' + that.currentComment.id + ']').remove();
                        var UIChatBox = api.require('UIChatBox');
                        UIChatBox.show();
                        api.sendEvent({
                            name: 'resetPost',
                            extra: {
                                type: "comments",
                                index: api.pageParam.postIndex,
                                commentCount: 'minus',
                                from: api.pageParam.from
                            }
                        });
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (e) {
                    console.log(e.message);
                });
            },
            setAnalyticsInfo: function () {
                td.onEvent({
                    eventId: '退出点击',
                    eventLabel: '点击瞬间详情退出'
                });

                //写入草稿信息
                var UIChatBox = api.require('UIChatBox');
                UIChatBox.value(function (ret, err) {
                    if (ret.msg) {
                        localStorage.setItem("saveCommentDraft", ret.msg);
                    } else if (!ret.msg && localStorage.getItem("saveCommentDraft")) {
                        localStorage.removeItem("saveCommentDraft");
                    }
                });

                if (time > 5) {
                    api.sendEvent({
                        name: 'analytics',
                        extra: {
                            AnalyticsItemTypeId: 1,
                            AnalyticsActionTypeId: 1,
                            PostId: momentId,
                            CountryCode: localStorage.getItem('countryCode'),
                            StaySeconds: time
                        }
                    });
                }
                setTimeout(function () {
                    back();
                }, 200);

                td.onPageEnd({pageName: '瞬间详情'});
            },
            toggleMore: function () {
                var that = this;
                actionSheet([
                    {
                        text: MSG.general.edit,
                        callback: function () {
                            that.editThisMoment();
                        }
                    },
                    {
                        text: MSG.general.delete,
                        callback: function () {
                            that.deleteThisMoment();
                        }
                    }
                ])
            },
            deleteThisMoment: function () {
                var that = this;
                this.hideMore();
                confirm(MSG.tips.wantDelete, [
                    {
                        text: MSG.general.ok,
                        callback: function () {
                            loading('show');
                            apiMoment.post('/api/v1/blog_posts/' + that.currentMoment.detail.momentGuid + '/delete').done(function (rep) {
                                loading('hide');
                                if (rep.code === 0) {
                                    api.toast({
                                        msg: MSG.general.success,
                                        duration: 2000,
                                        location: 'middle'
                                    });
                                    api.sendEvent({
                                        name: 'resetPost',
                                        extra: {
                                            type: 'remove',
                                            postGuid: that.momentsData[0].momentGuid
                                        }
                                    });
                                    api.sendEvent({
                                        name: 'reloadMyPost'
                                    });
                                    setTimeout(function () {
                                        back();
                                    }, 2000);
                                } else {
                                    api.toast({
                                        msg: rep.message,
                                        duration: 2000,
                                        location: 'middle'
                                    });
                                }
                            }).fail(function (e) {
                                console.log(e.message);
                            });

                        }
                    },
                    {
                        text: MSG.general.cancel,
                        callback: function () {

                        }
                    }
                ]);
            },
            editThisMoment: function () {
                openTabLayout('addMoment', '', 'widget://html/users/add-moment.html', {
                    postId: this.momentsData[0].blogPostId,
                    postGuid: this.momentsData[0].momentGuid
                });
            },
            openPlace: function ($event, id, name, avatarUrl) {
                $event && $event.stopPropagation();
                openUserTycoonPlace(id, name, avatarUrl);
            }
        }
    });
};

function formatLink(text) {
    if (text) {
        var textR = text.replace(REG_LINK, "<a href='javascript:;' data-url='$1$2' onclick='openBrowser(this)'>$1$2</a>");
        $('.moment-content').html(textR);
    }
    $('.comment-text').each(function () {
        var t = $(this).text().replace(REG_LINK, "<a href='javascript:;' data-url='$1$2' onclick='openBrowser(this)'>$1$2</a>");
        $(this).html(t);
    })
}
