
var Pages = 1;
var TPage = 1;
var tweelogTypeList = [];
var tweeLogTypeMap = {};
try{
    tweelogTypeList = JSON.parse(localStorage.getItem('tweelogType'));
    tweelogTypeList.forEach(function(item){
        tweeLogTypeMap[item.code] = item.value;
    })
}catch (err){
}
apiready = function () {
    var momentListHtml = api.readFile({
        sync: true,
        path: 'widget://html/fragment/moment.html'
    });
    $('#momentBox').html(momentListHtml);

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/'+ lan +'.json'
    }));

    backListener();

    var kv = api.require('snKVStorage');
    var hasmyFavoriteData = kv.has({
        key: 'myFavoriteData'
    });
    var myFavoriteData = kv.getArray({
        key: 'myFavoriteData'
    });
   // console.log(JSON.stringify(myFavoriteData));
    api.addEventListener({
        name: 'keyback'
    }, function(ret, err) {
        if(myFavoriteList.imageShow){
            var UIPhotoViewer = api.require('UIPhotoViewer');
            UIPhotoViewer.close();
            myFavoriteList.imageShow = false;
        }else{
            back();
        }
    });

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 100
        }
    }, function (ret, err) {
        if(myFavoriteList.currentTag ==='moment'){
            if ( myFavoriteList.momentsLoad && !myFavoriteList.bottomLoading && !myFavoriteList.isLoading) {
                Pages++;
                myFavoriteList.getFavoriteMoments();
            }
        }else if(myFavoriteList.currentTag ==='tweelog'){
            if ( !myFavoriteList.isTweeLogLoading) {
                TPage++;
                myFavoriteList.getFavoriteTweeLogs();
            }
        }

    });

    api.addEventListener({
        name: 'reloadMyPost',
    }, function (ret, err) {
        Pages = 0;
        myFavoriteList.momentsData = [];
        myFavoriteList.getFavoriteMoments();
        $("body").scrollTop(0);
    });

    api.setRefreshHeaderInfo({
        loadingImg:'widget://image/refresh-logo.png',
        bgColor: '#fff',
        textColor: '#000',
        textDown: MSG.tips.pullDownRefresh,
        textLoading: MSG.tips.refreshing,
        showTime: false,
        textUp:  MSG.tips.releaseRefresh
    }, function(ret, err) {
        api.refreshHeaderLoadDone();
        myFavoriteList.refreshMoment();
    });

    var appleCheck = api.getGlobalData({
        key: 'appleCheck'
    });

    var myFavoriteList = new Vue({
        el: '#myFavoriteList',
        mixins: [
            FRAGMENT_MOMENT
        ],
        mounted: function () {
            var that = this;
            this.getFavoriteMoments();
            this.getFavoriteTweeLogs();
            //写入字体大小
            var fontSize = localStorage.getItem('chatFontSize');
            if (fontSize) {
                var style = '<style> .moment-content, .translation-text\{font-size: ' + getRightPxFromFontSize(fontSize) + 'px !important; line-height: 1.3 !important;\}</style>';
                $('head').append(style);
            }
            if (!Object.keys(this.tweeLogTypeMap).length){
                apiTweelog.get('/api/v1/tweelog/tweelog_type').then(function (res) {
                    if (!Number(res.code)){
                        tweelogTypeList = res.data;
                        tweelogTypeList.forEach(function(item){
                            tweeLogTypeMap[item.code] = item.value;
                        });
                        that.tweeLogTypeMap = tweeLogTypeMap;
                    }else {
                        api.toast({
                            msg: res.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                })
            }
        },
        data: {
            appleCheck: appleCheck,
            currentTag:"moment",
            page: 'myFavoriteList',
            tweeLogTypeMap: tweeLogTypeMap,
            myID: localStorage.getItem('userId'),
            momentsData: hasmyFavoriteData ? myFavoriteData : [],
            tweeLogList:'',
            Pages: Pages,
            currentMoment: {    // 当前操作的瞬间
                index: null,
                detail: null
            },
            bottomLoading: false,
            isLoading: false,
            isTweeLogLoading: false,
            momentsLoad: true,
            message:MSG
        },
        filters: {
            formatTime:function (value) {
                return moment.utc(value).local().format('YYYY-MM-DD HH:mm');
            },
            filters:{
                defultAvatar:function (val) {
                    if(val){
                        return val
                    }else{
                        return '../../image/no-image.png'
                    }
                }
            },
        },
        methods: {
            changeTag:function(type){
                this.currentTag = type;
            },
            /**
             * 刷新瞬间列表
             */
            refreshMoment: function() {
                loading('show');
                Pages = 0;
                this.momentsLoad = true;
                this.getFavoriteMoments();
            },
            getFavoriteTweeLogs:function(){
                var that = this;
                if(that.isTweeLogLoading){
                    return false;
                }
                var params = {
                    "page": TPage,
                    "size": DEFAULT_PAGE_SIZE,
                };
                apiTweelog.get("/api/v1/tweelog/favorites", params).done(function (rep) {
                    //console.log(JSON.stringify(rep));
                    that.isTweeLogLoading = false;
                    var list = rep.data.list;
                    if (rep.code === 0) {
                        if (TPage === 1) {
                            if (list.length !== 0) {
                                that.tweeLogList = list;
                            }
                        } else {
                            if (list.length !== 0) {
                                that.tweeLogList = that.tweeLogList.concat(list);
                            }
                        }
                    }

                });
            },
            showStar:function(totalScore){
                if(totalScore){
                    return parseInt(totalScore);
                }else{
                    return 0;
                }
            },
            toPlace:function(userInfo){
                openUserTycoonPlace(userInfo.userId, userInfo.storeName,userInfo.avatarUrl);
            },
            toDetail:function (index) {
                openTabLayout('tweeLogDetail', '', 'widget://html/tweelog/tweeLog-detail.html',{
                    tweelogInfo:this.tweeLogList[index]
                },true);
            },
            getFavoriteMoments: function(){
                var that = this;
                if(that.isLoading){
                    return false;
                }
                if (Pages === 1) {

                } else {
                    that.bottomLoading = true
                }
                var param = {
                    page: Pages,
                    size: DEFAULT_PAGE_SIZE
                };
                that.isLoading = true;
                apiMoment.get('/api/v1/favorites', param).done(function (rep) {
                    loading('hide');
                    if (rep.code === 0) {
                        loading('hide');
                        that.bottomLoading = false;
                        that.isLoading = false;
                        var list = rep.data.records;
                        for(l = 0; l < list.length; l++){
                            if(!list[l].blogPostId){
                                list.splice(l, 1);
                                l--;
                            }
                        }
                        that._initMomentsData(list);
                        if (Pages === 1) {
                            if (list.length !== 0) {
                                that.momentsData = list;
                                that._initSwipper();
                                kv.setArray({
                                    key: 'myFavoriteData',
                                    value: that.momentsData
                                });
                            } else {
                                that.momentsLoad = false;
                            }
                        } else {
                            if (list.length !== 0) {
                                that.momentsData = that.momentsData.concat(list);
                                that._initSwipper();
                            } else {
                                that.momentsLoad = false;
                            }
                        }
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (e) {
                    console.log(e.message);
                });
            },
            toggleMore: function (moment, index) {
                var that = this;
                this.currentMoment.index = index;
                this.currentMoment.detail = moment;

                if (moment.favorited === true) {
                    actionSheet([
                        {
                            text: MSG.moment.unfavored,
                            callback: function () {
                                disFavorite(moment.blogPostId, function () {
                                    moment.favorited = false;
                                    moment.favoritedCount--;
                                });
                            }
                        }
                    ]);
                } else {
                    actionSheet([
                        {
                            text: MSG.moment.favorite,
                            callback: function () {
                                favorite(moment.blogPostId, function () {
                                    moment.favorited = true;
                                    moment.favoritedCount++;
                                });
                            }
                        }
                    ]);
                }
            },
        }
    });

};
