var Pages = 0;
apiready = function () {
    var momentListHtml = api.readFile({
        sync: true,
        path: 'widget://html/fragment/moment.html'
    });
    $('#momentBox').html(momentListHtml);

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/' + lan + '.json'
    }));

    // backListener();
    api.setNavBarAttr({
        rightButtons: [{
            iconPath: 'widget://image/add-icon.jpg'
        }]
    });

    api.addEventListener({
        name: 'navitembtn'
    }, function (ret, err) {
        if (ret.type === 'right') {
            myPostList.createPost();
        } else {
            back();
        }
    });

    var kv = api.require('snKVStorage');
    var hasMyPostData = kv.has({
        key: 'myPostData'
    });
    var MYPOSTDATA = kv.getArray({
        key: 'myPostData'
    });

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 300
        }
    }, function (ret, err) {
        if (myPostList.momentsLoad && !myPostList.bottomLoading && !myPostList.isLoading) {
            Pages++;
            myPostList.getMoments();
        }

    });

    api.addEventListener({
        name: 'reloadMyPost',
    }, function (ret, err) {
        myPostList.refreshMoment();
        $("body").scrollTop(0);
    });

    api.setRefreshHeaderInfo({
        loadingImg: 'widget://image/refresh-logo.png',
        bgColor: '#fff',
        textColor: '#000',
        textDown: MSG.tips.pullDownRefresh,
        textLoading: MSG.tips.refreshing,
        showTime: false,
        textUp: MSG.tips.releaseRefresh
    }, function (ret, err) {
        api.refreshHeaderLoadDone();
        myPostList.refreshMoment();
    });

    var taskService = new TaskService(TASK_CODE.GROUP_PERSON_PROFILE);

    api.addEventListener({
        name: 'taskReload'
    }, function (ret, err) {
        taskService.refresh();
    });

    var appleCheck = api.getGlobalData({
        key: 'appleCheck'
    });

    var myPostList = new Vue({
        el: '#myPostList',
        mixins: [
            FRAGMENT_MOMENT
        ],
        mounted: function () {
            this.getMoments();
            //写入字体大小
            var fontSize = localStorage.getItem('chatFontSize');
            if (fontSize) {
                var style = '<style> .moment-content, .translation-text\{font-size: ' + getRightPxFromFontSize(fontSize) + 'px !important; line-height: 1.3 !important;\}</style>';
                $('head').append(style);
            }
        },
        data: {
            appleCheck: appleCheck,
            page: 'myPostList',
            myID: localStorage.getItem('userId'),
            momentsData: hasMyPostData ? MYPOSTDATA : [],
            Pages: Pages,
            currentMoment: {    // 当前操作的瞬间
                index: null,
                detail: null
            },
            bottomLoading: false,
            isLoading: false,
            momentsLoad: true,
            condition: {
                pageSize: DEFAULT_PAGE_SIZE,
                sort: null
            },
            message: MSG
        },
        filters: {
            formatTime: function (value) {
                return moment.utc(value).local().format('YYYY-MM-DD HH:mm');
            }
        },
        methods: {
            /**
             * 刷新瞬间列表
             */
            refreshMoment: function () {
                loading('show');
                Pages = 0;
                this.momentsLoad = true;
                this.condition.sort = null;
                this.getMoments();
            },
            getMoments: function () {
                var that = this;
                if (that.isLoading) {
                    return false;
                }
                var url = getBaseUrl() + "/api/v3/moments";
                var paramStr = {
                    "ownerId": this.myID,
                    "currentpage": Pages,
                    "itemsperpage": 10,
                    "viewerId": this.myID
                };
                if (Pages === 0) {

                } else {
                    that.bottomLoading = true
                }
                that.isLoading = true;
                apiMoment.get('/api/v1/blog_posts/browse/moment/me', this.condition).done(function (rep) {
                    // getAxois(url, "POST", paramStr).then(function (response) {
                    loading('hide');
                    that.bottomLoading = false;
                    that.isLoading = false;

                    if (rep.code === 0) {
                        var list = rep.data.blogPosts;
                        that._initMomentsData(list);
                        if (Pages === 0) {
                            if (list.length !== 0) {
                                that.momentsData = list;
                                that._initSwipper();
                                kv.setArray({
                                    key: 'myPostData',
                                    value: that.momentsData
                                });
                            } else {
                                that.momentsLoad = false;
                            }
                        } else {
                            if (list.length !== 0) {
                                that.momentsData = that.momentsData.concat(list);
                                that._initSwipper();
                            } else {
                                that.momentsLoad = false;
                            }
                        }
                        that.condition.sort = rep.data.sort.join(',');
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }


                }).fail(function (error) {
                    console.log(JSON.stringify(error) + '#######################');
                });
            },
            toggleMore: function (moment, index) {
                var that = this;
                this.currentMoment.index = index;
                this.currentMoment.detail = moment;

                actionSheet([
                    {
                        color: 'red',
                        text: MSG.general.delete,
                        callback: function () {
                            that.deleteThisMoment();
                        }
                    },
                    {
                        text: MSG.general.edit,
                        callback: function () {
                            that.editThisMoment();
                        }
                    },
                    {
                        text: moment.top === 0 ? MSG.chat.stickyTop : MSG.chat.removeStickyTop,
                        callback: function () {
                            that.stickyTop(moment.top);
                        }
                    }
                ]);
            },
            deleteThisMoment: function () {
                var that = this;
                confirm(MSG.tips.wantDelete, [
                    {
                        text: MSG.general.ok,
                        callback: function () {
                            loading('show');
                            apiMoment.post('/api/v1/blog_posts/' + that.currentMoment.detail.momentGuid + '/delete').done(function (rep) {
                                loading('hide');
                                if (rep.code === 0) {
                                    that.momentsData.splice(that.currentMoment.index, 1);
                                    api.toast({
                                        msg: MSG.general.success,
                                        duration: 2000,
                                        location: 'middle'
                                    });
                                    kv.setArray({
                                        key: 'myPostData',
                                        value: that.momentsData
                                    });
                                    api.sendEvent({
                                        name: 'resetPost',
                                        extra: {
                                            type: 'remove',
                                            postGuid: that.currentMoment.detail.momentGuid
                                        }
                                    });
                                } else {
                                    api.toast({
                                        msg: rep.message,
                                        duration: 2000,
                                        location: 'middle'
                                    });
                                }
                            }).fail(function (e) {
                                console.log(e.message);
                            });

                        }
                    },
                    {
                        text: MSG.general.cancel,
                        callback: function () {

                        }
                    }
                ]);
            },
            stickyTop: function (isTop) {
                var that = this;
                loading('show');
                var url;
                if (isTop === 0) {
                    url = '/api/v1/blog_posts/' + this.currentMoment.detail.momentGuid + '/placed_top';
                } else {
                    url = '/api/v1/blog_posts/' + this.currentMoment.detail.momentGuid + '/placed_top/cancel';
                }
                apiMoment.post(url).done(function (rep) {
                    loading('hide');
                    if (rep.code === 0) {
                        that.refreshMoment();
                        api.toast({
                            msg: MSG.general.success,
                            duration: 2000,
                            location: 'middle'
                        });
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (e) {
                    console.log(e.message);
                });
            },
            editThisMoment: function () {
                openTabLayout('addMoment', '', 'widget://html/users/add-moment.html', {
                    postId: this.currentMoment.detail.blogPostId,
                    postGuid: this.currentMoment.detail.momentGuid
                });
            },
            createPost: function () {
                taskService.check(function () {
                    openTabLayout('addMoment', '', 'widget://html/users/add-moment.html');
                });
            },
        }
    });

};
