var mPages = 0;
var pPages = 0;
var sPages = 0;

var PAGE_SIZE = 10;

var token;
apiready = function () {
    //进入页面统计点
    var td = api.require('talkingData');
    td.onPageStart({pageName: '个人空间'});

    var momentListHtml = api.readFile({
        sync: true,
        path: 'widget://html/fragment/moment.html'
    });
    $('#momentBox').html(momentListHtml);

    //读取文字信息
    MSG = JSON.parse(api.readFile({
        sync: true,
        path: 'widget://res/i18n/' + lan + '.json'
    }));

    token = api.getPrefs({
        sync: true,
        key: 'accessToken'
    });
    api.setWinAttr({
        slidBackEnabled: false,
        bounces: false
    });

    api.addEventListener({
        name: 'scrolltobottom',
        extra: {
            threshold: 300
        }
    }, function (ret, err) {
        if (tycoonplace.listBtn === 'post' && tycoonplace.momentsLoad && !tycoonplace.bottomLoading && !tycoonplace.isLoading) {
            mPages++;
            tycoonplace.getMoments(mPages);
        } else if (tycoonplace.listBtn === 'product' && tycoonplace.productsLoad && !tycoonplace.bottomLoading && !tycoonplace.isLoading) {
            pPages++;
            tycoonplace.getProducts(pPages);
        } else if (tycoonplace.listBtn === 'suggest' && tycoonplace.suggestLoad && !tycoonplace.bottomLoading && !tycoonplace.isLoading) {
            sPages++;
            tycoonplace.getSuggests(sPages);
        }
    });

    var kv = api.require('snKVStorage');

    // 我的瞬间
    var MYPOSTDATA = [];
    var hasMyPostData = kv.has({
        key: 'myPostData'
    });
    if (hasMyPostData) {
        MYPOSTDATA = kv.getArray({
            key: 'myPostData'
        });
    }

    // 我的产品
    var MY_RPODUCT_DATA = [];
    var hasMyProductData = kv.has({
        key: 'myProductData'
    });

    if (hasMyProductData) {
        MY_RPODUCT_DATA = kv.getArray({
            key: 'myProductData'
        });
    }

    // 我的建议
    var MY_SUGGEST_DATA = [];
    var hasMySuggestData = kv.has({
        key: 'mySuggestData'
    });

    if (hasMySuggestData) {
        MY_SUGGEST_DATA = kv.getArray({
            key: 'mySuggestData'
        });
    }

    // 缓存当前用户
    var USERINFO;
    var hasUserInfo = kv.has({
        key: 'userInfo'
    });
    if (hasUserInfo) {
        USERINFO = kv.getObject({
            key: 'userInfo'
        });
    }

    //同步详情页和列表页数据
    api.addEventListener({
        name: 'resetPost',
    }, function (ret, err) {
        switch (ret.value.type) {
            case 'remove':
                $('li#' + ret.value.postGuid).remove();
                break;
            case 'like':
                if (ret.value.from === 'tycoon') {
                    tycoonplace.momentsData[ret.value.index].Liked = ret.value.liked;
                    tycoonplace.momentsData[ret.value.index].LikedCount = ret.value.likedCount;
                }
                break;
            case 'comments':
                if (ret.value.from === 'tycoon' && ret.value.commentCount === 'add') {
                    tycoonplace.momentsData[ret.value.index].commentCount++;
                } else if (ret.value.from === 'tycoon' && ret.value.commentCount === 'minus') {
                    tycoonplace.momentsData[ret.value.index].commentCount--;
                }
                break;
        }
    });

    // 更改背景图&头像
    api.addEventListener({
        name: 'myProfileReload'
    }, function (ret, err) {
        tycoonplace.getUserDetails();
    });

    api.addEventListener({
        name: 'workplaceReload'
    }, function (ret, err) {
        if (ret.value.type === 'moment') {
            tycoonplace.refreshMoment();
        } else if (ret.value.type === 'product') {
            tycoonplace.refreshProduct();
        } else if (ret.value.type === 'photoWall') {
            tycoonplace.getPhotoWall();
        } else if (ret.value.type === 'suggest') {
            tycoonplace.refreshSuggest();
        }
    });

    // api.addEventListener({
    //     name: 'swiperight'
    // }, function (ret, err) {
    //     back('个人空间');
    // });

    api.addEventListener({
        name: 'dialogRemarkSuccess'
    }, function (ret, err) {
        tycoonplace.$forceUpdate();
    });

    var taskServiceOfProfile = new TaskService(TASK_CODE.GROUP_PERSON_PROFILE);
    var taskServiceOfProduct = new TaskService(TASK_CODE.GROUP_ADD_SHOWCASE);

    api.addEventListener({
        name: 'taskReload'
    }, function (ret, err) {
        taskServiceOfProfile.refresh();
        taskServiceOfProduct.refresh();
    });

    var time = 0;

    function setTime() {
        // console.log(time);
        setTimeout(function () {
            time++;
            setTime();
        }, 1000)
    }

    setTime();
    var userId = localStorage.getItem('userId');

    var appleCheck = api.getGlobalData({
        key: 'appleCheck'
    });

    var tycoonplace = new Vue({
        el: '#tycoonplace',
        mixins: [
            FRAGMENT_MOMENT
        ],
        mounted: function () {
            this.getUserDetails();
            this.getViewTime();
            this.getTiv();

            //写入字体大小
            var fontSize = localStorage.getItem('chatFontSize');
            if (fontSize) {
                var style = '<style> .moment-content, .translation-text\{font-size: ' + getRightPxFromFontSize(fontSize) + 'px !important; line-height: 1.3 !important;\}</style>';
                $('head').append(style);
            }

            // 顶部Tabs样式
            $('.ui-tabs').removeClass('zh en es').addClass(lan);

        },
        data: {
            appleCheck: appleCheck,
            page: 'tycoonplaceEdit',
            userInfo: USERINFO || {
                FollowersCount: '-',
                FollowingCount: '-',
                MomentCount: '-',
                ProductCount: '-'
            },
            storeName: userRemarkService.get(userId, localStorage.getItem('storeName')),
            avatarUrl: localStorage.getItem('chatPortrait'),
            myID: localStorage.getItem('userId'),
            bigAvatarUrl: '',
            listBtn: 'post',    // product, suggest, post, photo
            momentsTotal: '-',
            momentsData: [],
            productsData: MY_RPODUCT_DATA || [],
            evaluationList: MY_SUGGEST_DATA || [],
            currentEvaluation: null,
            productsLoad: true,
            momentsLoad: true,
            suggestLoad: true,
            photoWall: [],
            photoCount: '-',
            photoPics: [],
            photoHeight: '',
            viewTime: '-',
            viewDuration: 0,
            defaultCurrency: localStorage.getItem('primaryCurrencyCode'),
            bottomLoading: false,
            isLoading: true,
            imageShow: false,
            rewardPage: null,
            Tweebucks: [0.68, 1.88, 2.22, 6.68, 9.99, 18.88],
            ifInputReward: false,
            inputReward: '',
            rewardTweebucks: null,
            scrollTop: 0,
            TiV: '',
            pPages: pPages,
            condition: {
                pageSize: PAGE_SIZE,
                sort: null
            },
            currentMoment: {    // 当前操作的瞬间
                index: null,
                detail: null
            },
            currentProductId: '',
            currentProductGUID: '',
            currentProductPrice: '',
            currentProductCurrency: '',
            currentIndex: '',
            currentProductType: '',
            currentProductSource: '',
            currentProductName: '',
            currentProductToTweebaaApproved: false,
            currentProductActive: true,
            currentProductFreeOffer: null,
            currentProductThumbnailUrl: '',
            isNavTop: false,
            navOffset: 0,
            tweeLogList:'',
            message: MSG
        },
        filters: {
            formatTime: function (value) {
                return moment.utc(value).local().format('YYYY-MM-DD HH:mm');
            },
            ifNull: function (value) {
                if (!value) {
                    return 0;
                } else {
                    return value;
                }
            },
            StatusCode: function (value) {
                if (value) {
                    return MSG.products[value.toUpperCase()];
                } else {
                    return MSG.products.SUBMITTED;
                }
            },
            productStatusCode: function (value) {
                if (value) {
                    return MSG.products[value.toUpperCase()];
                }
            },
            toThousand: function (value) {
                if (value || value === 0) {
                    var N = Number(value);
                    if (N > 1000) {
                        return Math.round(N / 100) / 10 + "K";
                    } else {
                        return value;
                    }
                } else {
                    return '--'
                }
            }
        },
        methods: {
            _initDom: function () {
                var that = this;
                var $win = $(window);
                var $header = $('.ui-header');
                var heightHeader = $header.height();
                var $icon = $header.find('.icon-tweebaa');
                var $tycoonNav = $('#tycoonNav');
                var heightNav = $tycoonNav.height() + 5;
                var $tycoonList = $('.tycoonList');
                var offsetTop = $tycoonNav.offset().top;
                var h = offsetTop - $header.height();
                var contentHeight = api.winHeight - 40 - 30;
                $tycoonList.css({
                    minHeight: contentHeight
                });

                this.navOffset = h;

                // console.log('$win: ' + $win.height());
                // console.log('winHeight:' + api.winHeight);
                // console.log('heightHeader: ' + heightHeader);
                // console.log('heightNav: ' + heightNav);

                $win.scroll(function () {
                    var top = $win.scrollTop();
                    // console.log('top: ' + top);
                    if (top >= h) {
                        that.isNavTop = true;
                        $icon.css({"background": "none", "color": "#4d4d4d"});
                        $header.removeClass('header-transparent');
                        $tycoonNav.addClass('fixed');
                        $tycoonList.css({
                            marginTop: heightNav
                        });
                    } else {
                        that.isNavTop = false;
                        $icon.css({"background": "rgba(57, 57, 57, 0.4)", "color": "#fff"});
                        $header.addClass('header-transparent');
                        $tycoonNav.removeClass('fixed');
                        $tycoonList.css({
                            marginTop: 0
                        });
                    }

                    if (top >= 100) {
                        $header.find('.icon-camera').hide();
                    } else {
                        $header.find('.icon-camera').show();
                    }
                });

            },
            startGuide: function () {
                var that = this;
                var winWidth = api.winWidth;

                var $body = $('body');
                var $guideBox = $('<div class="ui-guide-box"></div>');
                $body.append($guideBox).css({
                    overflow: 'hidden'
                });

                var $tycoonNav = $('.tycoonNav');
                var h = $tycoonNav.height();

                var count = 1;
                var LAST = 6;

                next();

                $guideBox.click(function () {
                    start();
                });

                function start() {
                    count++;
                    next();
                }

                function next() {
                    if (count > LAST) {
                        $guideBox.remove();
                        $body.css({
                            overflow: 'auto'
                        });
                        guideService.hideGuide(guideService.GUIDE_TYCOON_MINE.key1);
                        return;
                    }
                    switch (count) {
                        case 1:
                            guideService.setGuide({
                                mode: 'rightTop',
                                right: 55,
                                top: 3,
                                width: 34,
                                height: 34,
                                content: MSG.guide.tycoon1,
                                textAlign: 'right',
                                container: $guideBox
                            });
                            break;
                        case 2:
                            guideService.setGuide({
                                mode: 'leftTop',
                                left: 0,
                                top: $tycoonNav.offset().top,
                                width: winWidth / 3,
                                height: h,
                                content: MSG.guide.tycoon2,
                                container: $guideBox
                            });
                            break;
                        case 3:
                            if (that.momentsData.length > 0) {
                                guideService.setGuide({
                                    mode: 'rightTop',
                                    right: 0,
                                    top: $('.postsList .header-more').eq(0).offset().top + 2,
                                    width: 34,
                                    height: 34,
                                    content: MSG.guide.tycoon3,
                                    container: $guideBox
                                });
                            } else {
                                start();
                            }
                            break;
                        case 4:
                            guideService.setGuide({
                                mode: 'rightBottom',
                                right: 3,
                                bottom: 16,
                                width: 60,
                                height: 60,
                                content: MSG.guide.tycoon4,
                                textAlign: 'right',
                                container: $guideBox,
                                addSafe: false
                            });
                            break;
                        case 5:
                            guideService.setGuide({
                                mode: 'top',
                                left: winWidth / 3,
                                top: $tycoonNav.offset().top,
                                width: winWidth / 3,
                                height: h,
                                content: MSG.guide.tycoon5,
                                container: $guideBox
                            });
                            break;
                        case 6:
                            guideService.setGuide({
                                mode: 'rightTop',
                                right: 0,
                                top: $tycoonNav.offset().top,
                                width: winWidth / 3,
                                height: h,
                                content: MSG.guide.tycoon6,
                                container: $guideBox
                            });
                            break;
                    }
                }
            },
            startGuideProduct: function () {
                var that = this;
                var winWidth = api.winWidth;

                var $body = $('body');
                var $guideBox = $('<div class="ui-guide-box"></div>');
                $body.append($guideBox).css({
                    overflow: 'hidden'
                });

                var count = 1;
                var LAST = 1;

                next();

                $guideBox.click(function () {
                    start();
                });

                function start() {
                    count++;
                    next();
                }

                function next() {
                    if (count > LAST) {
                        $guideBox.remove();
                        $body.css({
                            overflow: 'auto'
                        });
                        guideService.hideGuide(guideService.GUIDE_TYCOON_MINE.key2);
                        return;
                    }
                    switch (count) {
                        case 1:
                            guideService.setGuide({
                                mode: 'rightBottom',
                                right: 3,
                                bottom: 16,
                                width: 60,
                                height: 60,
                                content: MSG.guide.tycoonP2,
                                textAlign: 'right',
                                container: $guideBox,
                                addSafe: false
                            });
                            break;
                    }
                }
            },
            startGuidePhoto: function () {

                var $body = $('body');
                var $guideBox = $('<div class="ui-guide-box"></div>');
                $body.append($guideBox).css({
                    overflow: 'hidden'
                });

                var count = 1;
                var LAST = 1;

                next();

                $guideBox.click(function () {
                    start();
                });

                function start() {
                    count++;
                    next();
                }

                function next() {
                    if (count > LAST) {
                        $guideBox.remove();
                        $body.css({
                            overflow: 'auto'
                        });
                        guideService.hideGuide(guideService.GUIDE_TYCOON_MINE.key3);
                        return;
                    }
                    switch (count) {
                        case 1:
                            guideService.setGuide({
                                mode: 'rightBottom',
                                right: 3,
                                bottom: 16,
                                width: 60,
                                height: 60,
                                content: MSG.guide.tycoonA1,
                                textAlign: 'right',
                                container: $guideBox,
                                addSafe: false
                            });
                            break;
                    }
                }
            },

            /**
             * 刷新瞬间列表
             */
            refreshMoment: function () {
                loading('show');
                mPages = 0;
                this.condition.sort = null;
                this.momentsLoad = true;
                this.getMoments(mPages);
            },
            /**
             * 刷新产品列表
             */
            refreshProduct: function () {
                loading('show');
                pPages = 0;
                this.productsLoad = true;
                this.getProducts(pPages);
            },
            /**
             * 刷新建议列表
             */
            refreshSuggest: function () {
                loading('show');
                sPages = 0;
                this.suggestLoad = true;
                this.getSuggests(sPages);
            },
            openMyProfile: function () {
                openTabLayout('myProfile', this.message.setting.editProfile, '../users/my-profile.html');
            },
            /**
             * 更改头像
             */
            openChangePortrait: function ($event) {
                $event.stopPropagation();
                openChangePortrait();
            },
            /**
             * 更改背景
             */
            changeBg: function () {
                var that = this;
                var type;
                actionSheet([
                    {
                        text: MSG.general.takePicture,
                        callback: function () {
                            type = 'camera';
                            start();
                        }
                    },
                    {
                        text: MSG.general.library,
                        callback: function () {
                            type = 'library';
                            start();
                        }
                    }
                ]);

                function start() {

                    api.getPicture({
                        sourceType: type,
                        encodingType: 'jpg',
                        mediaValue: 'pic',
                        destinationType: 'url',
                        allowEdit: false,
                        quality: 70,
                        targetWidth: 640,
                        saveToPhotoAlbum: false
                    }, function (ret, err) {

                        if (ret) {
                            loading('show');

                            setTimeout(function () {
                                // console.log("[" + api.deviceName + "]" + JSON.stringify(ret));

                                apiMedia.upload("/upload/images", ret.data).done(function (response) {
                                    //console.log("[" + api.deviceName + "]" + JSON.stringify(response));

                                    var data = response.data[0];
                                    var imgURL = data.raw;

                                    // console.log("[" + api.deviceName + "]" + JSON.stringify(response));

                                    // 调用存储接口
                                    apiUserCenter.post("/api/v1/uas/background", {
                                        backgroundUrl: imgURL,
                                    }).done(function (rep) {
                                        // console.log(JSON.stringify(rep));

                                        if (rep.code === 0) {
                                            loading('hide');

                                            localStorage.setItem('myCoverCache', imgURL);

                                            that.getUserDetails();

                                            api.sendEvent({
                                                name: 'workplaceReload',
                                                extra: {
                                                    type: 'info',
                                                }
                                            });

                                            if (rep.data) {
                                                apiTask.fetchTaskStatus(rep.data, true);
                                            } else {
                                                api.toast({
                                                    msg: MSG.tips.backgroundChanged,
                                                    duration: 2000,
                                                    location: 'middle'
                                                });
                                            }
                                        } else {
                                            api.toast({
                                                msg: rep.message,
                                                duration: 2000,
                                                location: 'middle'
                                            });
                                        }
                                    }).fail(function (err) {
                                        loading('hide');
                                        api.toast({
                                            msg: MSG.tips.systemError,
                                            duration: 2000,
                                            location: 'middle'
                                        });
                                    });

                                });
                            }, 200);


                            // var myId = localStorage.getItem('userId');
                            // var url = getBaseUrl() + "api/users/"+ myId +"/background";
                            // var param = {
                            //     "FileName":localStorage.getItem('userName')+myId+'background.jpg',
                            //     "DownloadBinaryBase64": ret.base64Data.split(',')[1]
                            // };
                            //
                            // loading('show');
                            // getAxois(url,"POST",param).then(function (response) {
                            //     localStorage.setItem('myCover',response.data.DownloadUrl);
                            //     api.imageCache({
                            //         url: response.data.DownloadUrl
                            //     }, function(ret, err) {
                            //         loading('hide');
                            //
                            //         var url = ret.url;
                            //         localStorage.setItem('myCoverCache',url);
                            //
                            //         that.getUserDetails();
                            //
                            //         api.sendEvent({
                            //             name: 'workplaceReload',
                            //             extra: {
                            //                 type: 'info',
                            //             }
                            //         });
                            //
                            //         if (response.data.TaskId) {
                            //             apiTask.fetchTaskStatus(response.data.TaskId, true);
                            //         } else {
                            //             api.toast({
                            //                 msg: MSG.tips.backgroundChanged,
                            //                 duration: 2000,
                            //                 location: 'middle'
                            //             });
                            //         }
                            //
                            //     });
                            //
                            // }).catch(function (error) {
                            //     loading('hide');
                            //     console.log(JSON.stringify(error));
                            // });
                        } else {
                            loading('hide');
                            console.log(JSON.stringify(err));
                        }
                    });
                }

            },
            getUserDetails: function () {
                var that = this;
                var url = getBaseUrl() + "/api/users/" + userId + "?viewerId=" + this.myID;
                loading('show');
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(response.data));
                    var data = response.data;
                    that.userInfo = data;
                    that.getMoments(0);
                    that.getPhotoWall();
                    that.photoHeight = $('#photoWidth').width();
                    that.bigAvatarUrl = data.AvatarUrl;
                    that.avatarUrl = data.AvatarUrl;
                    that.storeName = data.StoreName;

                    that._initDom();

                    if (guideService.check(guideService.GUIDE_TYCOON_MINE.key1) === false) {
                        that.startGuide();
                    }

                    kv.setObject({
                        key: 'userInfo',
                        value: data
                    });
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            getTiv: function () {
                var that = this;
                var url = getBaseUrl() + "api/v2/tiv?UserId=" + userId;
                getAxois(url, "GET", {}).then(function (response) {
                    that.TiV = response.data.Data.CompletedTiv.toFixed(2);
                }).catch(function (error) {
                    console.log(JSON.stringify(error));
                });
            },
            getViewTime: function () {
                var that = this;
                var url = getBaseUrl() + "api/dashboard/v1/ty/" + userId;
                getAxois(url, "GET", {}).then(function (response) {
                    //console.log(JSON.stringify(that.tag));
                    if (response.data.Code === 0) {
                        that.viewTime = response.data.Data.Views;
                    }

                    api.sendEvent({
                        name: 'workplaceReload',
                        extra: {
                            type: 'view'
                        }
                    });
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');

                });

            },
            resetNav: function () {
                var $win = $(window);
                if (this.isNavTop === true) {
                    $win.scrollTop(this.navOffset + 1);
                }
            },
            changeList: function (event, list) {
                var that = this;
                if (this.listBtn !== list) {
                    this.resetNav();
                    this.listBtn = list;
                    switch (list) {
                        case 'product':
                            this.refreshProduct();
                            setTimeout(function () {
                                if (guideService.check(guideService.GUIDE_TYCOON_MINE.key2) === false) {
                                    that.startGuideProduct();
                                }
                            }, 1000);
                            break;
                        case 'suggest':
                            this.refreshSuggest();
                            break;
                        case 'post':
                            this.refreshMoment();
                            break;
                        case 'photo':
                            setTimeout(function () {
                                if (guideService.check(guideService.GUIDE_TYCOON_MINE.key3) === false) {
                                    that.startGuidePhoto();
                                }
                            }, 1000);
                            td.onEvent({
                                eventId: '点击空间相册',
                                eventLabel: '点击个人空间相册'
                            });
                            break;
                    }
                }
            },
            addProduct: function () {
                taskServiceOfProduct.check(function () {
                    openTabLayout('prepareAdd', MSG.products.addProductMethod, 'widget://html/products/prepare-add.html');
                });
            },
            openProductMenu: function (index) {
                var that = this;
                this.currentProductId = this.productsData[index].Id;
                this.currentProductGUID = this.productsData[index].ProductGuid;
                this.currentProductPrice = this.productsData[index].TweebuckPrice;
                this.currentProductSource = this.productsData[index].ProductSource;
                this.currentProductType = this.productsData[index].ProductType;
                this.currentProductCurrency = this.productsData[index].CurrencyCode;
                this.currentProductName = this.productsData[index].Name;
                this.currentProductThumbnailUrl = this.productsData[index].FeaturedPicture.ThumbnailUrl || that.productsData[index].FeaturedPicture.PictureUrl;
                this.currentProductFreeOffer = this.productsData[index].FreeOffer;
                this.currentProductActive = this.productsData[index].Active;
                this.currentProductToTweebaaApproved = this.productsData[index].ProductSource !== 1 && !!(this.productsData[index].LatestProductToTweebaa && this.productsData[index].LatestProductToTweebaa.LatestProductToTweebaaStatusCode === "Approved");
                this.currentIndex = index;

                var buttons = [];
                if (!this.currentProductToTweebaaApproved) {
                    buttons.push({
                        color: 'red',
                        text: MSG.general.delete,
                        callback: function () {
                            that.deleteProduct();
                        }
                    });
                }
                if (this.currentProductSource !== 1 && !this.currentProductToTweebaaApproved) {
                    buttons.push({
                        text: MSG.general.edit,
                        callback: function () {
                            that.productEdit();
                        }
                    });
                }

                actionSheet(buttons);

            },
            deleteProduct: function () {
                var that = this;
                confirm(MSG.tips.wantDelete, [
                    {
                        text: MSG.general.ok,
                        callback: function () {
                            var userid = localStorage.getItem('userId');
                            var url, paramStr;
                            if (that.currentProductSource === 1) {
                                url = getBaseUrl() + "api/v2/tweebaa-product/to/tycoon?ProductId=" + that.currentProductId + "&UserId=" + userid;
                                paramStr = {};
                            } else {
                                url = getBaseUrl() + "api/v2/products?ActorId=" + userid + "&ProductId=" + that.currentProductId;
                                paramStr = {"userId": userid, "productId": that.currentProductId};
                            }
                            loading('show');
                            getAxois(url, "DELETE", paramStr).then(function (response) {
                                loading('hide');
                                if (response.data.Success) {
                                    api.toast({
                                        msg: that.message.tips.success,
                                        duration: 2000,
                                        location: 'middle'
                                    });
                                    // $('#' + that.currentProductGUID).remove();
                                    that.productsData.splice(that.currentIndex, 1);
                                    api.sendEvent({
                                        name: 'indexProductListReload',
                                    });


                                    if (that.currentProductSource === 1) {
                                        //删除扣减Tiv
                                        var TZ = Intl.DateTimeFormat().resolvedOptions().timeZone;
                                        var LT = moment().format('YYYY-MM-DDThh:mm:ss');
                                        api.sendEvent({
                                            name: 'delTiV',
                                            extra: {
                                                type: 'showcase',
                                                obj: {
                                                    "tz": TZ,
                                                    "tl": LT,
                                                    "PrG": that.currentProductGUID,
                                                    "OI": localStorage.getItem('userId'),
                                                    "OG": localStorage.getItem('userGuid')
                                                }
                                            }
                                        });
                                    }
                                }
                            }).catch(function (error) {
                                console.log(JSON.stringify(error));
                                messages(that.message.tips.systemError, 'error', 'top', 3);
                            });
                        }
                    },
                    {
                        text: MSG.general.cancel,
                        callback: function () {

                        }
                    }
                ]);
            },
            enableToTweeba: function () {
                var that = this;
                openTabLayout('enabletoTweeba', that.message.products.enabletoTweeba, '../products/enable-tweebaa.html', {
                    productGuid: that.currentProductGUID,
                    price: that.currentProductPrice,
                    productType: that.currentProductType,
                    productName: that.currentProductName,
                    productThumbnailUrl: that.currentProductThumbnailUrl
                });
            },

            productEdit: function () {
                var that = this;
                var url;
                if (that.currentProductType === 1) {
                    url = "../products/form-physical.html";
                } else if (that.currentProductType === 2) {
                    url = "../products/form-digital-new.html";
                }
                openTabLayout('editProduct', this.message.tycoonplace.editProduct, url, {
                    productId: that.currentProductId,
                });
            },
            _initListData: function (list) {
                if (list.length > 0) {
                    var currency = lan === 'zh' ? '￥' : '$';
                    var item;
                    for (var i = 0, len = list.length; i < len; i++) {
                        item = list[i];
                        // 价格
                        item.TweebuckPriceText = getExchangeText(item.TweebuckPrice);
                    }
                }
            },
            getProducts: function (pPages) {
                var that = this;
                if (that.isLoading) {
                    return false;
                }

                if (pPages !== 0) {
                    that.bottomLoading = true;
                } else {

                }
                var url = getBaseUrl() + "/api/v3/users/products?LanguageCode=" + lan;
                var paramStr = {
                    "ownerId": userId,
                    "currentpage": pPages || 0,
                    "itemsperpage": PAGE_SIZE,
                    "LanguageCode": lan,
                    "ProductToTweebaaDetailRequired": true,
                    "self": false,
                    "categoryId": '',
                    "orderBy": '',
                    "desc": '',
                    "q": ''
                };
                that.isLoading = true;
                getAxois(url, "POST", paramStr).then(function (response) {
                    //console.log(JSON.stringify(response.data.Data));
                    // $('#placeHolderLoad1').remove();
                    that.bottomLoading = false;
                    that.isLoading = false;
                    var list;
                    if (pPages === 0) {
                        loading('hide');
                        list = response.data.Data;
                        that._initListData(list);
                        that.productsData = list;
                        if (response.data.Data.length === 0) {
                            that.productsLoad = false;
                        }
                        kv.setArray({
                            key: 'myProductData',
                            value: that.productsData
                        });
                    } else {
                        if (response.data.Data.length !== 0) {
                            list = response.data.Data;
                            that._initListData(list);
                            that.productsData = that.productsData.concat(list);
                        } else {
                            that.productsLoad = false;
                        }
                    }
                }).catch(function (error) {
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            progressColor:function(index){
                if(!this.productsData[index].BusinessType && this.productsData[index].BusinessType !== 1){
                    return
                }
                var end = moment(this.productsData[index].PreSaleInfo.PreSaleStopUtc).local();
                var now = moment();
                var endDate = end.diff(now, 'hours');
                var endMinute = end.diff(now, 'minutes');
                if(endDate>=0 && endDate < 24 && endMinute >0 ){
                    return 'bk-red'
                }else if(endMinute <= 0 ){
                    return 'bk-green'
                }
            },
            getSuggests: function (page) {
                var that = this;
                if (that.isLoading) {
                    return false;
                }
                var url = getBaseUrl() + "/api/suggest-products?ApplicantId=" + this.myID
                    + "&currentpage=" + page
                    + "&itemsperpage=" + PAGE_SIZE + "&viewerId=" + this.myID;

                if (page === 0) {
                    loading('show');
                } else {
                    that.bottomLoading = true;
                }
                that.isLoading = true;
                getAxois(url, "GET", {}).then(function (response) {
                    // $('#placeHolderLoad').remove();
                    // console.log(JSON.stringify(response.data.Data));
                    that.bottomLoading = false;
                    that.isLoading = false;
                    loading('hide');

                    if (page === 0) {
                        if (response.data.Data.length !== 0) {
                            that.evaluationList = response.data.Data;
                            kv.setArray({
                                key: 'mySuggestData',
                                value: that.evaluationList
                            });
                        } else {
                            that.suggestLoad = false;
                        }
                    } else {
                        if (response.data.Data.length !== 0) {
                            that.evaluationList = that.evaluationList.concat(response.data.Data);
                        } else {
                            that.suggestLoad = false;
                        }
                    }

                }).catch(function (error) {
                    loading('hide');
                    console.log(JSON.stringify(error) + '@@@@@@@@@@@@@@@@');
                });
            },
            addSuggest: function () {
                openTabLayout('suggestProduct', MSG.products.suggestProduct, 'widget://html/products/suggest-product.html');
            },
            openEvaluationDetail: function (index) {
                var title = this.message.tycoonplace.evaluation;
                var id = this.evaluationList[index].Id;
                openTabLayout('evaluationDetail', title, 'widget://html/discovery/evaluation-detail.html', {
                    evaluationId: id,
                    index: index
                });
            },
            openSuggestMenu: function (evaluation) {
                var that = this;
                this.currentEvaluation = evaluation;

                actionSheet([
                    {
                        color: 'red',
                        text: MSG.tycoonplace.cancelSuggest,
                        callback: function () {
                            that.removeSuggest();
                        }
                    }
                ]);
            },
            removeSuggest: function () {
                var that = this;
                confirmBox(MSG.tips.wantDelete, MSG.general.cancel, MSG.general.ok, 'error');
                $('.dialog-box').find('button').on('click', function (e) {
                    $('.dialog-box').remove();
                    // TODO
                    //     getAxois(url,"DELETE",paramStr).then(function (response) {
                    //         //console.log(JSON.stringify(response));
                    //         //$('#'+that.currentProductGUID).remove();
                    //         that.getProducts(0);
                    //     }).catch(function (error) {
                    //         console.log(JSON.stringify(error));
                    //         messages($.i18n.prop('systemError'), 'error', 'top', 3);
                    //     });
                    // }
                });

            },
            add: function () {
                var type = this.listBtn;
                switch (type) {
                    case 'post':
                        this.createPost();
                        break;
                    case 'product':
                        this.addProduct();
                        break;
                    case 'suggest':
                        this.addSuggest();
                        break;
                    case 'photo':
                        this.openPhotoWall();
                        break;
                }
            },
            createPost: function () {
                taskServiceOfProfile.check(function () {
                    openTabLayout('addMoment', '', 'widget://html/users/add-moment.html');
                });
            },
            getTycoonTweeLogs:function(){
                var that = this;
                var params = {
                    "page": 1,
                    "size": 20,
                };
                apiTweelog.get("/api/v1/tweelog/"+ api.pageParam.userId +"/space", params).done(function (rep) {
                    if (rep.code === 0) {
                        that.tweeLogList = rep.data.list;
                    }

                });
            },
            showStar:function(totalScore){
                if(totalScore){
                    return parseInt(totalScore);
                }else{
                    return 0;
                }
            },
            toDetail:function (index) {
                openTabLayout('tweeLogDetail', '', 'widget://html/tweelog/tweeLog-detail.html',{
                    tweelogInfo:this.tweeLogList[index]
                },true);
            },
            getMoments: function (mPages) {
                var that = this;
                if (mPages !== 0 && that.isLoading) {
                    return false;
                }
                if (mPages !== 0) {
                    that.bottomLoading = true;
                }
                loading('show');
                that.isLoading = true;
                apiMoment.get('/api/v1/blog_posts/browse/moment/me', this.condition).done(function (rep) {
                    // getAxois(url, "POST", paramStr).then(function (response) {
                    //console.log(JSON.stringify(response));
                    that.bottomLoading = false;
                    that.isLoading = false;
                    loading('hide');
                    if (rep.code === 0) {
                        var list = rep.data.blogPosts;
                        if (mPages === 0) {
                            if (list.length !== 0) {
                                that._initMomentsData(list);
                                that.momentsData = list;
                                that._initSwipper();
                                kv.setArray({
                                    key: 'myPostData',
                                    value: that.momentsData
                                });
                            } else {
                                that.momentsLoad = false;
                            }
                        } else {
                            if (list.length !== 0) {
                                that._initMomentsData(list);
                                that.momentsData = that.momentsData.concat(list);
                                that._initSwipper();
                            } else {
                                that.momentsLoad = false;
                            }
                        }
                        that.momentsTotal = rep.data.total;
                        that.condition.sort = rep.data.sort.join(',');
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (e) {
                    console.log(e.message);
                });
            },
            toggleMore: function (moment, index) {
                var that = this;
                this.currentMoment.index = index;
                this.currentMoment.detail = moment;
                actionSheet([
                    {
                        color: 'red',
                        text: MSG.general.delete,
                        callback: function () {
                            that.deleteThisMoment();
                        }
                    },
                    {
                        text: MSG.general.edit,
                        callback: function () {
                            that.editThisMoment();
                        }
                    },
                    {
                        text: moment.top === 0 ? MSG.chat.stickyTop : MSG.chat.removeStickyTop,
                        callback: function () {
                            that.stickyTop(moment.top);
                        }
                    }
                ]);
            },
            deleteThisMoment: function () {
                var that = this;
                this.hideMore();

                confirm(MSG.tips.wantDelete, [
                    {
                        text: MSG.general.ok,
                        callback: function () {
                            loading('show');
                            apiMoment.post('/api/v1/blog_posts/' + that.currentMoment.detail.momentGuid + '/delete').done(function (rep) {
                                loading('hide');
                                if (rep.code === 0) {
                                    that.momentsData.splice(that.currentMoment.index, 1);
                                    api.toast({
                                        msg: MSG.general.success,
                                        duration: 2000,
                                        location: 'middle'
                                    });
                                    kv.setArray({
                                        key: 'myPostData',
                                        value: that.momentsData
                                    });
                                    api.sendEvent({
                                        name: 'resetPost',
                                        extra: {
                                            type: 'remove',
                                            postGuid: that.currentMoment.detail.momentGuid
                                        }
                                    });
                                } else {
                                    api.toast({
                                        msg: rep.message,
                                        duration: 2000,
                                        location: 'middle'
                                    });
                                }
                            }).fail(function (e) {
                                console.log(e.message);
                            });

                        }
                    },
                    {
                        text: MSG.general.cancel,
                        callback: function () {

                        }
                    }
                ]);
            },
            stickyTop: function (isTop) {
                var that = this;
                loading('show');
                var url;
                if (isTop === 0) {
                    url = '/api/v1/blog_posts/' + this.currentMoment.detail.momentGuid + '/placed_top';
                } else {
                    url = '/api/v1/blog_posts/' + this.currentMoment.detail.momentGuid + '/placed_top/cancel';
                }
                apiMoment.post(url).done(function (rep) {
                    loading('hide');
                    if (rep.code === 0) {
                        that.refreshMoment();
                        api.toast({
                            msg: MSG.general.success,
                            duration: 2000,
                            location: 'middle'
                        });
                    } else {
                        api.toast({
                            msg: rep.message,
                            duration: 2000,
                            location: 'middle'
                        });
                    }
                }).fail(function (e) {
                    console.log(e.message);
                });
            },
            editThisMoment: function () {
                openTabLayout('addMoment', '', 'widget://html/users/add-moment.html', {
                    postId: this.currentMoment.detail.blogPostId,
                    postGuid: this.currentMoment.detail.momentGuid
                });
            },
            getPhotoWall: function () {
                var that = this;
                var userGuid = localStorage.getItem('userGuid');
                var url = getBaseUrl() + "/api/v2/users/album?OwnerGuid=" + userGuid;
                getAxois(url, "GET", {}).then(function (response) {
                    var list = response.data.Photos;
                    that.photoWall = list;
                    that.photoCount = list.length;
                    for (var i = 0, len = list.length; i < len; i++) {
                        that.photoPics.push(list[i].PictureUrl);
                    }
                }).catch(function (error) {
                    loading('hide');
                });
            },
            preShare: function () {
                var that = this;
                actionSheet([
                    {
                        text: MSG.general.shareto,
                        callback: function () {
                            that.openShareBarSpace();
                        }
                    },
                    {
                        text: MSG.general.repostChat,
                        callback: function () {
                            that.toRepostChatPage();
                        }
                    }
                ]);
            },
            toRepostChatPage: function () {
                var userId = this.myID;
                var name = MSG.tips.shareTycoonplaceTips;
                var Content = MSG.tips.shareTycoonplaceTips2;
                var thumbnail = this.userInfo.ThumbnailAvatarUrl;
                openShareToChats({
                    title: name,
                    description: Content,
                    imageUrl: thumbnail,
                    extra: {
                        textType: 'tycoonplace',
                        userId: userId,
                        AvatarUrl: thumbnail,
                        userPortrait: thumbnail,
                        storeName: this.storeName,
                    }
                });
            },
            /**
             * 分享个人空间
             */
            openShareBarSpace: function () {
                var userId = this.myID;
                var userName = localStorage.getItem('userName') || '';
                var ShareUrl = shareH5Host + '/html/space.html?userId=' + userId + "&storeName=" + this.storeName + "&shareid=" + userName;
                var name = MSG.tips.shareTycoonplaceTips;
                var Content = MSG.tips.shareTycoonplaceTips2;
                var thumbnail = this.userInfo.ThumbnailAvatarUrl;
                new OpenShareBox(ShareUrl, name, Content, userName, '', 'activity', thumbnail, userId);
            },
            openPortrait: function () {
                var UIPhotoViewer = api.require('UIPhotoViewer');
                var that = this;
                tycoonplace.imageShow = true;
                UIPhotoViewer.open({
                    images: [that.bigAvatarUrl],
                    bgColor: '#000',
                    zoomEnabled: true,
                    gestureClose: true
                }, function (ret, err) {
                    if (ret.eventType === 'click') {
                        UIPhotoViewer.close();
                        tycoonplace.imageShow = false;
                    } else if (ret.eventType === 'longPress') {
                        actionSheet([
                            {
                                text: MSG.general.save,
                                callback: function () {
                                    loading('show');
                                    api.download({
                                        url: that.bigAvatarUrl,
                                        report: true,
                                        cache: true,
                                        allowResume: true
                                    }, function (ret, err) {
                                        if (ret.state === 1) {
                                            var Url = ret.savePath;
                                            loading('hide');
                                            api.saveMediaToAlbum({
                                                path: Url,
                                                groupName: "Tweebaa"
                                            }, function (ret, err) {
                                                if (ret && ret.status) {
                                                    alert(MSG.tips.saved);

                                                }
                                            });

                                        }
                                    });
                                }
                            }
                        ]);
                    }
                });

            },
            openDetail: function (prodId, productSource) {
                var tweebaaTag = productSource === 1 ? 'tweebaa-tag' : '';
                var param = {
                    prodId: prodId,
                    userInfo: JSON.stringify(this.userInfo),
                    countryCode: this.userInfo.RegisterCountryCode,
                    tweebaaTag: tweebaaTag
                };
                openTabLayout('productDetail', '', 'widget://html/products/product-detail.html', param);
            },
            toFollowList: function (type, userId) {
                var param = {
                    type: type,
                    userId: userId
                };
                openTabLayout('followList', MSG.general[type], 'widget://html/users/follow-list.html', param);
                api.sendEvent({
                    name: 'refreshFollowList',
                    extra: param
                });
            },
            reportBtn: function () {
                openReportPage({
                    target: 'USER',
                    targetId: this.userInfo.Id
                });
            },
            buyNow: function (index) {
                var param = {
                    id: this.productsData[index].Id,
                    seller: this.userInfo,
                    toTweebaaId: null,
                    price: this.productsData[index].TweebuckPrice,
                    shippingFee: this.productsData[index].shippingFee,
                    type: this.productsData[index].ProductType,
                    name: this.productsData[index].Name,
                    thumbnailUrl: this.productsData[index].FeaturedPicture.ThumbnailUrl || this.productsData[index].FeaturedPicture.PictureUrl
                };
                openTabLayout("buyNow", this.message.tycoonplace.yourOrder, 'widget://html/tproducts/buynow.html', param);
            },
            openPhotoWall: function () {
                openTabLayout('photoWall', MSG.profile.photoWall, 'photo-wall.html');
            },
            latestProductToTweebaaStatus: function (index, $event) {
                $event.stopPropagation();
                var that = this;
                api.openFrame({
                    name: 'latestProductToTweebaaStatuspage',
                    url: '../products/latest-status.html',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    pageParam: {
                        data: that.productsData[index].LatestProductToTweebaa
                    },
                    bounces: false,
                    bgColor: 'rgba(0,0,0,0.7)',
                    fixedOn: 'ui_layout',
                    animation: {
                        type: "none",
                    }
                });
            },
            showPhotos: function ($event, Index) {
                var that = this;
                this.imageShow = true;

                var UIPhotoViewer = api.require('UIPhotoViewer');
                UIPhotoViewer.open({
                    images: this.photoPics,
                    placeholderImg: 'widget://image/lost_images.jpg',
                    bgColor: '#000',
                    activeIndex: Index,
                    zoomEnabled: true,
                    gestureClose: true
                }, function (Ret, err) {
                    if (Ret.eventType === 'click') {
                        UIPhotoViewer.close();
                        that.imageShow = false;
                    } else if (Ret.eventType === 'longPress') {
                        actionSheet([
                            {
                                text: MSG.general.save,
                                callback: function () {
                                    api.download({
                                        url: picUrls[Ret.index],
                                        report: true,
                                        cache: true,
                                        allowResume: true
                                    }, function (ret, err) {
                                        if (ret.state === 1) {
                                            var Url = ret.savePath;
                                            api.saveMediaToAlbum({
                                                path: Url,
                                                groupName: "Tweebaa"
                                            }, function (ret, err) {
                                                if (ret && ret.status) {
                                                    alert(MSG.tips.saved);
                                                }
                                            });

                                        }
                                    });
                                }
                            }
                        ]);
                    }
                });
            },
        }

    });

};

$('.save-image-btn').on('click', function () {
    loading('show');
    api.download({
        url: $('#downloadImage').val(),
        report: true,
        cache: true,
        allowResume: true
    }, function (ret, err) {
        if (ret.state === 1) {
            var Url = ret.savePath;
            loading('hide');
            api.saveMediaToAlbum({
                path: Url,
                groupName: "Tweebaa"
            }, function (ret, err) {
                if (ret && ret.status) {
                    api.toast({
                        msg: MSG.tips.saved,
                        duration: 2000,
                        location: 'middle'
                    });
                }
            });

        }
    });
});

$('#actionBox').on('click', function (e) {
    var tar = e.target.id;
    if (tar === 'shareBox') {
        CloseActionBox();
    }
});

function CloseActionBox() {
    $('#actionBox').removeClass('show');
}
